/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var me=["require","exports","vs/base/common/uri","vs/base/common/event","vs/platform/instantiation/common/instantiation","vs/workbench/api/common/extHost.protocol","vs/base/common/lifecycle","vs/workbench/api/common/extHostTypes","vs/base/common/strings","vs/base/common/path","vs/base/common/network","vs/base/common/platform","vs/platform/log/common/log","vs/workbench/api/common/extHostRpcService","vs/base/common/errors","vs/base/common/types","vs/base/common/async","vs/workbench/api/common/extHostTypeConverters","vs/base/common/arrays","vs/nls","vs/nls!vs/workbench/services/extensions/node/extensionHostProcess","vs/base/common/cancellation","vs/base/common/buffer","vs/base/common/map","vs/base/common/resources","vs/base/common/objects","vs/platform/extensions/common/extensions","vs/workbench/api/common/extHostInitDataService","vs/base/node/pfs","vs/base/common/extpath","vs/base/common/glob","vs/workbench/services/search/common/search","vs/base/common/uuid","vs/workbench/api/common/extHostTerminalService","vs/workbench/services/extensions/common/extensions","vs/workbench/api/common/extHostWorkspace","vs/workbench/api/common/extHostConfiguration","vs/base/common/process","child_process","vs/workbench/api/common/extHostExtensionService","vs/editor/common/core/range","vs/platform/files/common/files","vs/workbench/api/common/extHostDocumentsAndEditors","vs/base/common/stopwatch","vs/editor/common/core/position","vs/platform/workspace/common/workspace","vs/workbench/api/common/extHostEditorTabs","vs/workbench/api/common/extHostTunnelService","vs/workbench/api/common/extHostCommands","vs/workbench/api/common/extHostDebugService","vs/base/common/assert","vs/base/common/decorators","vs/base/common/iterator","vs/base/common/json","vs/base/common/severity","vs/base/common/marshalling","fs","vs/base/common/errorMessage","vs/platform/registry/common/platform","vs/workbench/api/common/extHostFileSystemInfo","vs/workbench/api/common/extHostUriTransformerService","vs/workbench/api/common/extHostApiDeprecationService","vs/workbench/api/common/extHostOutput","vs/workbench/api/common/extHostWebview","vs/workbench/services/search/common/searchExtTypes","vs/workbench/api/common/extHostTask","vs/base/common/performance","vs/workbench/api/common/extHostSearch","vs/base/common/collections","vs/base/common/functional","vs/base/common/idGenerator","vs/base/common/linkedList","vs/base/common/numbers","vs/base/common/hash","vs/base/common/normalization","vs/base/common/labels","vs/editor/common/modes/languageSelector","vs/platform/instantiation/common/extensions","vs/editor/common/modes","vs/platform/instantiation/common/serviceCollection","vs/platform/configuration/common/configurationRegistry","vs/platform/remote/common/remoteHosts","vs/workbench/api/common/cache","vs/workbench/api/common/shared/webview","vs/workbench/contrib/notebook/common/notebookCommon","vs/workbench/api/common/exHostSecretState","vs/workbench/api/common/extHostFileSystemConsumer","vs/workbench/api/common/extHostStorage","vs/workbench/api/common/extHostStoragePaths","vs/workbench/services/search/node/ripgrepSearchUtils","vs/base/common/codicons","vs/base/common/stream","vs/base/common/uint","vs/base/common/filters","vs/base/common/htmlContent","vs/base/common/comparers","vs/base/common/fuzzyScorer","vs/base/common/mime","vs/base/common/uriIpc","string_decoder","os","vs/base/node/extpath","vs/base/parts/ipc/common/ipc","vs/base/parts/ipc/common/ipc.net","vs/editor/common/core/characterClassifier","vs/editor/common/model","vs/editor/common/model/wordHelper","vs/editor/common/services/semanticTokensDto","vs/editor/common/viewModel/prefixSumComputer","vs/base/node/processes","vs/platform/instantiation/common/descriptors","vs/platform/contextkey/common/contextkey","vs/platform/log/node/spdlogLog","vs/platform/markers/common/markers","vs/platform/progress/common/progress","vs/platform/configuration/common/configuration","vs/platform/remote/common/remoteAuthorityResolver","vs/workbench/api/common/extHostTelemetry","vs/workbench/api/common/extHostTestingPrivateApi","vs/workbench/api/common/extHostDocumentData","vs/workbench/contrib/debug/common/abstractDebugAdapter","net","vs/workbench/contrib/testing/common/testCollection","vs/workbench/api/common/extHostNotebookEditor","vs/workbench/api/common/extHostTextEditor","vs/workbench/services/extensions/common/proxyIdentifier","vs/workbench/api/common/extHostDecorations","vs/workbench/api/common/extHostWindow","vs/workbench/services/search/common/textSearchManager","vs/workbench/services/search/node/textSearchManager","vs/workbench/services/search/node/ripgrepTextSearchEngine","vs/base/parts/ipc/node/ipc.net","vs/base/common/jsonFormatter","vs/base/common/jsonEdit","vs/base/common/lazy","vs/base/common/processes","vs/base/common/iconLabels","vs/base/node/decoder","vs/editor/common/controller/wordCharacterClassifier","vs/editor/common/core/selection","vs/editor/common/model/textModelSearch","vs/editor/common/modes/languageConfiguration","vs/editor/common/modes/linkComputer","vs/editor/common/modes/tokenizationRegistry","vs/editor/common/model/mirrorTextModel","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/node/processes","vs/nls!vs/editor/common/config/editorOptions","vs/editor/common/config/editorOptions","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/externalTerminal/node/externalTerminalService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/markers/common/markers","vs/nls!vs/platform/workspaces/common/workspaces","vs/nls!vs/workbench/api/common/extHostDiagnostics","vs/nls!vs/workbench/api/common/extHostExtensionService","vs/nls!vs/workbench/api/common/extHostProgress","vs/nls!vs/workbench/api/common/extHostStatusBar","vs/nls!vs/workbench/api/common/extHostTerminalService","vs/nls!vs/workbench/api/common/extHostTreeViews","vs/nls!vs/workbench/api/common/extHostWorkspace","vs/nls!vs/workbench/api/node/extHostDebugService","vs/nls!vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/nls!vs/workbench/contrib/debug/node/debugAdapter","vs/nls!vs/workbench/contrib/search/common/queryBuilder","vs/nls!vs/workbench/contrib/tasks/common/taskService","vs/nls!vs/workbench/services/configurationResolver/common/variableResolver","vs/platform/editor/common/editor","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/graph","vs/editor/common/services/modelService","vs/editor/common/modes/languageFeatureRegistry","vs/platform/environment/common/environment","vs/platform/extensionManagement/common/extensionManagement","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/externalTerminal/common/externalTerminal","vs/platform/externalTerminal/node/externalTerminalService","vs/platform/instantiation/common/instantiationService","vs/platform/notification/common/notification","vs/platform/opener/common/opener","vs/platform/product/common/product","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurationModels","vs/platform/remote/common/tunnel","vs/platform/sign/node/signService","vs/platform/terminal/common/terminalDataBuffering","vs/platform/workspaces/common/workspaces","vs/workbench/api/common/extHostMemento","vs/workbench/api/common/extHostNotebookDocuments","vs/workbench/api/common/extHostSecrets","vs/workbench/api/common/extHostNotebookConcatDocument","vs/workbench/api/common/extHostTheming","vs/workbench/api/common/extHostWebviewMessaging","vs/workbench/api/common/extHostCodeInsets","vs/workbench/contrib/debug/common/debugUtils","vs/workbench/contrib/debug/node/debugAdapter","vs/workbench/contrib/debug/node/terminals","vs/workbench/contrib/tasks/common/taskService","vs/workbench/contrib/terminal/common/environmentVariableShared","vs/workbench/services/configurationResolver/common/variableResolver","vs/workbench/services/editor/common/editorGroupsService","vs/workbench/services/editor/common/editorService","vs/workbench/api/common/extHostDocumentSaveParticipant","vs/workbench/api/common/extHostFileSystemEventService","vs/workbench/api/common/extHostNotebookDocument","vs/workbench/api/common/extHostProgress","vs/workbench/api/common/extHostTreeViews","vs/workbench/contrib/testing/common/ownedTestCollection","vs/workbench/services/environment/common/environmentService","vs/workbench/services/extensions/common/extensionDescriptionRegistry","vs/workbench/services/extensions/common/extensionHostProtocol","vs/workbench/api/common/extHostExtensionActivator","vs/workbench/api/node/extHostLogService","vs/workbench/services/extensions/common/lazyPromise","vs/workbench/api/common/extHostAuthentication","vs/workbench/api/common/extHostBulkEdits","vs/workbench/api/common/extHostClipboard","vs/workbench/api/common/extHostApiCommands","vs/workbench/api/common/extHostComments","vs/workbench/api/common/extHostDiagnostics","vs/workbench/api/common/extHostDialogs","vs/workbench/api/common/extHostDocumentContentProviders","vs/workbench/api/common/extHostDocuments","vs/workbench/api/common/extHostFileSystem","vs/workbench/api/common/extHostLabelService","vs/workbench/api/common/extHostLanguageFeatures","vs/workbench/api/common/extHostLanguages","vs/workbench/api/common/extHostMessageService","vs/workbench/api/common/extHostNotebook","vs/workbench/api/common/extHostNotebookEditors","vs/workbench/api/common/extHostNotebookKernels","vs/workbench/api/common/extHostNotebookRenderers","vs/workbench/api/common/extHostQuickOpen","vs/workbench/api/common/extHostSCM","vs/workbench/api/common/extHostStatusBar","vs/workbench/api/common/extHostTesting","vs/workbench/api/common/extHostTextEditors","vs/workbench/api/common/extHostTimeline","vs/workbench/api/common/extHostUriOpener","vs/workbench/api/common/extHostUrls","vs/workbench/api/common/extHostCustomEditors","vs/workbench/api/common/extHostWebviewPanels","vs/workbench/api/common/extHostWebviewView","vs/workbench/api/node/extHostDownloadService","vs/workbench/api/node/extHostOutputService","vs/workbench/api/node/extHostTerminalService","vs/workbench/api/node/extHostTunnelService","vs/workbench/services/extensions/common/rpcProtocol","vs/workbench/services/remote/common/remoteAgentService","vs/workbench/services/path/common/pathService","vs/workbench/contrib/search/common/queryBuilder","vs/workbench/api/common/shared/workspaceContains","vs/workbench/api/common/extHostRequireInterceptor","vs/workbench/api/node/extHostDebugService","vs/workbench/api/node/extHostTask","vs/workbench/services/extensions/common/extensionHostMain","vs/workbench/services/search/common/fileSearchManager","vs/workbench/api/common/extHost.api.impl","vs/workbench/api/common/extHost.common.services","vs/workbench/services/textfile/common/encoding","vs/workbench/services/extensions/node/proxyResolver","http","vs/workbench/services/search/node/ripgrepFileSearch","vscode-ripgrep","vs/workbench/services/search/node/fileSearch","vs/workbench/services/search/node/ripgrepSearchProvider","vs/workbench/services/search/node/textSearchAdapter","vs/workbench/services/search/node/rawSearchService","vs/workbench/api/node/extHostSearch","vs/workbench/api/node/extHostCLIServer","vs/workbench/api/node/extHostExtensionService","vs/workbench/api/node/extHost.node.services","vs/workbench/services/extensions/node/extensionHostProcessSetup","util","vs/base/common/marked/marked","https","tls","vscode-proxy-agent","events","vscode-regexpp","graceful-fs","crypto","zlib","minimist","vs/workbench/services/extensions/node/extensionHostProcess"],ge=function(X){for(var e=[],p=0,R=X.length;p<R;p++)e[p]=me[X[p]];return e};define(me[50],ge([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ok=void 0;function p(R,C){if(!R)throw new Error(C?`Assertion failed (${C})`:"Assertion Failed")}e.ok=p}),define(me[68],ge([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SetMap=e.diffMaps=e.diffSets=e.fromMap=e.groupBy=e.forEach=e.values=void 0;const p=Object.prototype.hasOwnProperty;function R(r){const I=[];for(let l in r)p.call(r,l)&&I.push(r[l]);return I}e.values=R;function C(r,I){for(let l in r)if(p.call(r,l)&&I({key:l,value:r[l]},function(){delete r[l]})===!1)return}e.forEach=C;function y(r,I){const l=Object.create(null);for(const f of r){const c=I(f);let u=l[c];u||(u=l[c]=[]),u.push(f)}return l}e.groupBy=y;function A(r){const I=Object.create(null);return r&&r.forEach((l,f)=>{I[f]=l}),I}e.fromMap=A;function P(r,I){const l=[],f=[];for(let c of r)I.has(c)||l.push(c);for(let c of I)r.has(c)||f.push(c);return{removed:l,added:f}}e.diffSets=P;function E(r,I){const l=[],f=[];for(let[c,u]of r)I.has(c)||l.push(u);for(let[c,u]of I)r.has(c)||f.push(u);return{removed:l,added:f}}e.diffMaps=E;class k{constructor(){this.map=new Map}add(I,l){let f=this.map.get(I);f||(f=new Set,this.map.set(I,f)),f.add(l)}delete(I,l){const f=this.map.get(I);!f||(f.delete(l),f.size===0&&this.map.delete(I))}forEach(I,l){const f=this.map.get(I);!f||f.forEach(l)}}e.SetMap=k}),define(me[51],ge([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=e.createDecorator=void 0;function p(A){return(P,E,k)=>{let r=null,I=null;if(typeof k.value=="function"?(r="value",I=k.value):typeof k.get=="function"&&(r="get",I=k.get),!I)throw new Error("not supported");k[r]=A(I,E)}}e.createDecorator=p;function R(A,P,E){let k=null,r=null;if(typeof E.value=="function"?(k="value",r=E.value,r.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof E.get=="function"&&(k="get",r=E.get),!r)throw new Error("not supported");const I=`$memoize$${P}`;E[k]=function(...l){return this.hasOwnProperty(I)||Object.defineProperty(this,I,{configurable:!1,enumerable:!1,writable:!1,value:r.apply(this,l)}),this[I]}}e.memoize=R;function C(A,P,E){return p((k,r)=>{const I=`$debounce$${r}`,l=`$debounce$result$${r}`;return function(...f){this[l]||(this[l]=E?E():void 0),clearTimeout(this[I]),P&&(this[l]=P(this[l],...f),f=[this[l]]),this[I]=setTimeout(()=>{k.apply(this,f),this[l]=E?E():void 0},A)}})}e.debounce=C;function y(A,P,E){return p((k,r)=>{const I=`$throttle$timer$${r}`,l=`$throttle$result$${r}`,f=`$throttle$lastRun$${r}`,c=`$throttle$pending$${r}`;return function(...u){if(this[l]||(this[l]=E?E():void 0),(this[f]===null||this[f]===void 0)&&(this[f]=-Number.MAX_VALUE),P&&(this[l]=P(this[l],...u)),this[c])return;const S=this[f]+A;S<=Date.now()?(this[f]=Date.now(),k.apply(this,[this[l]]),this[l]=E?E():void 0):(this[c]=!0,this[I]=setTimeout(()=>{this[c]=!1,this[f]=Date.now(),k.apply(this,[this[l]]),this[l]=E?E():void 0},S-Date.now()))}})}e.throttle=y}),define(me[14],ge([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createErrorWithActions=e.isErrorWithActions=e.ExpectedError=e.NotSupportedError=e.NotImplementedError=e.getErrorMessage=e.disposed=e.readonly=e.illegalState=e.illegalArgument=e.canceled=e.CancellationError=e.isPromiseCanceledError=e.transformErrorForSerialization=e.onUnexpectedExternalError=e.onUnexpectedError=e.setUnexpectedErrorHandler=e.errorHandler=e.ErrorHandler=void 0;class p{constructor(){this.listeners=[],this.unexpectedErrorHandler=function(t){setTimeout(()=>{throw t.stack?new Error(t.message+`

`+t.stack):t},0)}}addListener(t){return this.listeners.push(t),()=>{this._removeListener(t)}}emit(t){this.listeners.forEach(i=>{i(t)})}_removeListener(t){this.listeners.splice(this.listeners.indexOf(t),1)}setUnexpectedErrorHandler(t){this.unexpectedErrorHandler=t}getUnexpectedErrorHandler(){return this.unexpectedErrorHandler}onUnexpectedError(t){this.unexpectedErrorHandler(t),this.emit(t)}onUnexpectedExternalError(t){this.unexpectedErrorHandler(t)}}e.ErrorHandler=p,e.errorHandler=new p;function R(g){e.errorHandler.setUnexpectedErrorHandler(g)}e.setUnexpectedErrorHandler=R;function C(g){E(g)||e.errorHandler.onUnexpectedError(g)}e.onUnexpectedError=C;function y(g){E(g)||e.errorHandler.onUnexpectedExternalError(g)}e.onUnexpectedExternalError=y;function A(g){if(g instanceof Error){let{name:t,message:i}=g;const s=g.stacktrace||g.stack;return{$isError:!0,name:t,message:i,stack:s}}return g}e.transformErrorForSerialization=A;const P="Canceled";function E(g){return g instanceof Error&&g.name===P&&g.message===P}e.isPromiseCanceledError=E;class k extends Error{constructor(){super(P);this.name=this.message}}e.CancellationError=k;function r(){const g=new Error(P);return g.name=g.message,g}e.canceled=r;function I(g){return g?new Error(`Illegal argument: ${g}`):new Error("Illegal argument")}e.illegalArgument=I;function l(g){return g?new Error(`Illegal state: ${g}`):new Error("Illegal state")}e.illegalState=l;function f(g){return g?new Error(`readonly property '${g} cannot be changed'`):new Error("readonly property cannot be changed")}e.readonly=f;function c(g){const t=new Error(`${g} has been disposed`);return t.name="DISPOSED",t}e.disposed=c;function u(g){return g?g.message?g.message:g.stack?g.stack.split(`
`)[0]:String(g):"Error"}e.getErrorMessage=u;class S extends Error{constructor(t){super("NotImplemented");t&&(this.message=t)}}e.NotImplementedError=S;class w extends Error{constructor(t){super("NotSupported");t&&(this.message=t)}}e.NotSupportedError=w;class b extends Error{constructor(){super(...arguments);this.isExpected=!0}}e.ExpectedError=b;function d(g){const t=g;return t instanceof Error&&Array.isArray(t.actions)}e.isErrorWithActions=d;function h(g,t=Object.create(null)){const i=new Error(g);return t.actions&&(i.actions=t.actions),i}e.createErrorWithActions=h}),define(me[18],ge([0,1,14]),function(X,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.maxIndex=e.minIndex=e.mapFind=e.getRandomElement=e.asArray=e.mapArrayOrNot=e.pushToEnd=e.pushToStart=e.shuffle=e.arrayInsert=e.remove=e.insert=e.index=e.range=e.flatten=e.commonPrefixLength=e.firstOrDefault=e.lastIndex=e.uniqueFilter=e.distinctES6=e.distinct=e.isNonEmptyArray=e.isFalsyOrEmpty=e.move=e.coalesceInPlace=e.coalesce=e.topAsync=e.top=e.delta=e.sortedDiff=e.groupBy=e.quickSelect=e.findFirstInSorted=e.binarySearch=e.equals=e.tail2=e.tail=void 0;function R(j,O=0){return j[j.length-(1+O)]}e.tail=R;function C(j){if(j.length===0)throw new Error("Invalid tail call");return[j.slice(0,j.length-1),j[j.length-1]]}e.tail2=C;function y(j,O,F=(B,$)=>B===$){if(j===O)return!0;if(!j||!O||j.length!==O.length)return!1;for(let B=0,$=j.length;B<$;B++)if(!F(j[B],O[B]))return!1;return!0}e.equals=y;function A(j,O,F){let B=0,$=j.length-1;for(;B<=$;){const Y=(B+$)/2|0,le=F(j[Y],O);if(le<0)B=Y+1;else if(le>0)$=Y-1;else return Y}return-(B+1)}e.binarySearch=A;function P(j,O){let F=0,B=j.length;if(B===0)return 0;for(;F<B;){const $=Math.floor((F+B)/2);O(j[$])?B=$:F=$+1}return F}e.findFirstInSorted=P;function E(j,O,F){if(j=j|0,j>=O.length)throw new TypeError("invalid index");let B=O[Math.floor(O.length*Math.random())],$=[],Y=[],le=[];for(let be of O){const Le=F(be,B);Le<0?$.push(be):Le>0?Y.push(be):le.push(be)}return j<$.length?E(j,$,F):j<$.length+le.length?le[0]:E(j-($.length+le.length),Y,F)}e.quickSelect=E;function k(j,O){const F=[];let B;for(const $ of j.slice(0).sort(O))!B||O(B[0],$)!==0?(B=[$],F.push(B)):B.push($);return F}e.groupBy=k;function r(j,O,F){const B=[];function $(be,Le,Ie){if(Le===0&&Ie.length===0)return;const Ue=B[B.length-1];Ue&&Ue.start+Ue.deleteCount===be?(Ue.deleteCount+=Le,Ue.toInsert.push(...Ie)):B.push({start:be,deleteCount:Le,toInsert:Ie})}let Y=0,le=0;for(;;){if(Y===j.length){$(Y,0,O.slice(le));break}if(le===O.length){$(Y,j.length-Y,[]);break}const be=j[Y],Le=O[le],Ie=F(be,Le);Ie===0?(Y+=1,le+=1):Ie<0?($(Y,1,[]),Y+=1):Ie>0&&($(Y,0,[Le]),le+=1)}return B}e.sortedDiff=r;function I(j,O,F){const B=r(j,O,F),$=[],Y=[];for(const le of B)$.push(...j.slice(le.start,le.start+le.deleteCount)),Y.push(...le.toInsert);return{removed:$,added:Y}}e.delta=I;function l(j,O,F){if(F===0)return[];const B=j.slice(0,F).sort(O);return c(j,O,B,F,j.length),B}e.top=l;function f(j,O,F,B,$){return F===0?Promise.resolve([]):new Promise((Y,le)=>{(async()=>{const be=j.length,Le=j.slice(0,F).sort(O);for(let Ie=F,Ue=Math.min(F+B,be);Ie<be;Ie=Ue,Ue=Math.min(Ue+B,be)){if(Ie>F&&await new Promise(Qe=>setTimeout(Qe)),$&&$.isCancellationRequested)throw p.canceled();c(j,O,Le,Ie,Ue)}return Le})().then(Y,le)})}e.topAsync=f;function c(j,O,F,B,$){for(const Y=F.length;B<$;B++){const le=j[B];if(O(le,F[Y-1])<0){F.pop();const be=P(F,Le=>O(le,Le)<0);F.splice(be,0,le)}}}function u(j){return j.filter(O=>!!O)}e.coalesce=u;function S(j){let O=0;for(let F=0;F<j.length;F++)j[F]&&(j[O]=j[F],O+=1);j.length=O}e.coalesceInPlace=S;function w(j,O,F){j.splice(F,0,j.splice(O,1)[0])}e.move=w;function b(j){return!Array.isArray(j)||j.length===0}e.isFalsyOrEmpty=b;function d(j){return Array.isArray(j)&&j.length>0}e.isNonEmptyArray=d;function h(j,O){if(!O)return j.filter((B,$)=>j.indexOf(B)===$);const F=Object.create(null);return j.filter(B=>{const $=O(B);return F[$]?!1:(F[$]=!0,!0)})}e.distinct=h;function g(j){const O=new Set;return j.filter(F=>O.has(F)?!1:(O.add(F),!0))}e.distinctES6=g;function t(j){const O=Object.create(null);return F=>{const B=j(F);return O[B]?!1:(O[B]=!0,!0)}}e.uniqueFilter=t;function i(j,O){for(let F=j.length-1;F>=0;F--){const B=j[F];if(O(B))return F}return-1}e.lastIndex=i;function s(j,O){return j.length>0?j[0]:O}e.firstOrDefault=s;function n(j,O,F=(B,$)=>B===$){let B=0;for(let $=0,Y=Math.min(j.length,O.length);$<Y&&F(j[$],O[$]);$++)B++;return B}e.commonPrefixLength=n;function o(j){return[].concat(...j)}e.flatten=o;function v(j,O){let F=typeof O=="number"?j:0;typeof O=="number"?F=j:(F=0,O=j);const B=[];if(F<=O)for(let $=F;$<O;$++)B.push($);else for(let $=F;$>O;$--)B.push($);return B}e.range=v;function m(j,O,F){return j.reduce((B,$)=>(B[O($)]=F?F($):$,B),Object.create(null))}e.index=m;function _(j,O){return j.push(O),()=>D(j,O)}e.insert=_;function D(j,O){const F=j.indexOf(O);if(F>-1)return j.splice(F,1),O}e.remove=D;function a(j,O,F){const B=j.slice(0,O),$=j.slice(O);return B.concat(F,$)}e.arrayInsert=a;function T(j,O){let F;if(typeof O=="number"){let B=O;F=()=>{const $=Math.sin(B++)*179426549;return $-Math.floor($)}}else F=Math.random;for(let B=j.length-1;B>0;B-=1){const $=Math.floor(F()*(B+1)),Y=j[B];j[B]=j[$],j[$]=Y}}e.shuffle=T;function L(j,O){const F=j.indexOf(O);F>-1&&(j.splice(F,1),j.unshift(O))}e.pushToStart=L;function U(j,O){const F=j.indexOf(O);F>-1&&(j.splice(F,1),j.push(O))}e.pushToEnd=U;function G(j,O){return Array.isArray(j)?j.map(O):O(j)}e.mapArrayOrNot=G;function ee(j){return Array.isArray(j)?j:[j]}e.asArray=ee;function z(j){return j[Math.floor(Math.random()*j.length)]}e.getRandomElement=z;function N(j,O){for(const F of j){const B=O(F);if(B!==void 0)return B}}e.mapFind=N;function W(j,O){let F=Number.MAX_SAFE_INTEGER,B=0;return j.forEach(($,Y)=>{const le=O($);le<F&&(F=le,B=Y)}),B}e.minIndex=W;function M(j,O){let F=Number.MIN_SAFE_INTEGER,B=0;return j.forEach(($,Y)=>{const le=O($);le>F&&(F=le,B=Y)}),B}e.maxIndex=M}),define(me[69],ge([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.once=void 0;function p(R){const C=this;let y=!1,A;return function(){return y||(y=!0,A=R.apply(C,arguments)),A}}e.once=p}),define(me[70],ge([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.defaultGenerator=e.IdGenerator=void 0;class p{constructor(C){this._prefix=C,this._lastId=0}nextId(){return this._prefix+ ++this._lastId}}e.IdGenerator=p,e.defaultGenerator=new p("id#")}),define(me[52],ge([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var p;(function(R){function C(g){return g&&typeof g=="object"&&typeof g[Symbol.iterator]=="function"}R.is=C;const y=Object.freeze([]);function A(){return y}R.empty=A;function*P(g){yield g}R.single=P;function E(g){return g||y}R.from=E;function k(g){return!g||g[Symbol.iterator]().next().done===!0}R.isEmpty=k;function r(g){return g[Symbol.iterator]().next().value}R.first=r;function I(g,t){for(const i of g)if(t(i))return!0;return!1}R.some=I;function l(g,t){for(const i of g)if(t(i))return i}R.find=l;function*f(g,t){for(const i of g)t(i)&&(yield i)}R.filter=f;function*c(g,t){let i=0;for(const s of g)yield t(s,i++)}R.map=c;function*u(...g){for(const t of g)for(const i of t)yield i}R.concat=u;function*S(g){for(const t of g)for(const i of t)yield i}R.concatNested=S;function w(g,t,i){let s=i;for(const n of g)s=t(s,n);return s}R.reduce=w;function*b(g,t,i=g.length){for(t<0&&(t+=g.length),i<0?i+=g.length:i>g.length&&(i=g.length);t<i;t++)yield g[t]}R.slice=b;function d(g,t=Number.POSITIVE_INFINITY){const i=[];if(t===0)return[i,g];const s=g[Symbol.iterator]();for(let n=0;n<t;n++){const o=s.next();if(o.done)return[i,R.empty()];i.push(o.value)}return[i,{[Symbol.iterator](){return s}}]}R.consume=d;function h(g,t,i=(s,n)=>s===n){const s=g[Symbol.iterator](),n=t[Symbol.iterator]();for(;;){const o=s.next(),v=n.next();if(o.done!==v.done)return!1;if(o.done)return!0;if(!i(o.value,v.value))return!1}}R.equals=h})(p=e.Iterable||(e.Iterable={}))}),define(me[53],ge([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var p;(function(t){t[t.None=0]="None",t[t.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=2]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",t[t.InvalidUnicode=4]="InvalidUnicode",t[t.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",t[t.InvalidCharacter=6]="InvalidCharacter"})(p=e.ScanError||(e.ScanError={}));var R;(function(t){t[t.OpenBraceToken=1]="OpenBraceToken",t[t.CloseBraceToken=2]="CloseBraceToken",t[t.OpenBracketToken=3]="OpenBracketToken",t[t.CloseBracketToken=4]="CloseBracketToken",t[t.CommaToken=5]="CommaToken",t[t.ColonToken=6]="ColonToken",t[t.NullKeyword=7]="NullKeyword",t[t.TrueKeyword=8]="TrueKeyword",t[t.FalseKeyword=9]="FalseKeyword",t[t.StringLiteral=10]="StringLiteral",t[t.NumericLiteral=11]="NumericLiteral",t[t.LineCommentTrivia=12]="LineCommentTrivia",t[t.BlockCommentTrivia=13]="BlockCommentTrivia",t[t.LineBreakTrivia=14]="LineBreakTrivia",t[t.Trivia=15]="Trivia",t[t.Unknown=16]="Unknown",t[t.EOF=17]="EOF"})(R=e.SyntaxKind||(e.SyntaxKind={}));var C;(function(t){t[t.InvalidSymbol=1]="InvalidSymbol",t[t.InvalidNumberFormat=2]="InvalidNumberFormat",t[t.PropertyNameExpected=3]="PropertyNameExpected",t[t.ValueExpected=4]="ValueExpected",t[t.ColonExpected=5]="ColonExpected",t[t.CommaExpected=6]="CommaExpected",t[t.CloseBraceExpected=7]="CloseBraceExpected",t[t.CloseBracketExpected=8]="CloseBracketExpected",t[t.EndOfFileExpected=9]="EndOfFileExpected",t[t.InvalidCommentToken=10]="InvalidCommentToken",t[t.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=12]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",t[t.InvalidUnicode=14]="InvalidUnicode",t[t.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",t[t.InvalidCharacter=16]="InvalidCharacter"})(C=e.ParseErrorCode||(e.ParseErrorCode={}));var y;(function(t){t.DEFAULT={allowTrailingComma:!0}})(y=e.ParseOptions||(e.ParseOptions={}));function A(t,i=!1){let s=0,n=t.length,o="",v=0,m=16,_=0;function D(z){let N=0,W=0;for(;N<z;){const M=t.charCodeAt(s);if(M>=48&&M<=57)W=W*16+M-48;else if(M>=65&&M<=70)W=W*16+M-65+10;else if(M>=97&&M<=102)W=W*16+M-97+10;else break;s++,N++}return N<z&&(W=-1),W}function a(z){s=z,o="",v=0,m=16,_=0}function T(){const z=s;if(t.charCodeAt(s)===48)s++;else for(s++;s<t.length&&k(t.charCodeAt(s));)s++;if(s<t.length&&t.charCodeAt(s)===46)if(s++,s<t.length&&k(t.charCodeAt(s)))for(s++;s<t.length&&k(t.charCodeAt(s));)s++;else return _=3,t.substring(z,s);let N=s;if(s<t.length&&(t.charCodeAt(s)===69||t.charCodeAt(s)===101))if(s++,(s<t.length&&t.charCodeAt(s)===43||t.charCodeAt(s)===45)&&s++,s<t.length&&k(t.charCodeAt(s))){for(s++;s<t.length&&k(t.charCodeAt(s));)s++;N=s}else _=3;return t.substring(z,N)}function L(){let z="",N=s;for(;;){if(s>=n){z+=t.substring(N,s),_=2;break}const W=t.charCodeAt(s);if(W===34){z+=t.substring(N,s),s++;break}if(W===92){if(z+=t.substring(N,s),s++,s>=n){_=2;break}switch(t.charCodeAt(s++)){case 34:z+='"';break;case 92:z+="\\";break;case 47:z+="/";break;case 98:z+="\b";break;case 102:z+="\f";break;case 110:z+=`
`;break;case 114:z+="\r";break;case 116:z+="	";break;case 117:const j=D(4);j>=0?z+=String.fromCharCode(j):_=4;break;default:_=5}N=s;continue}if(W>=0&&W<=31)if(E(W)){z+=t.substring(N,s),_=2;break}else _=6;s++}return z}function U(){if(o="",_=0,v=s,s>=n)return v=n,m=17;let z=t.charCodeAt(s);if(P(z)){do s++,o+=String.fromCharCode(z),z=t.charCodeAt(s);while(P(z));return m=15}if(E(z))return s++,o+=String.fromCharCode(z),z===13&&t.charCodeAt(s)===10&&(s++,o+=`
`),m=14;switch(z){case 123:return s++,m=1;case 125:return s++,m=2;case 91:return s++,m=3;case 93:return s++,m=4;case 58:return s++,m=6;case 44:return s++,m=5;case 34:return s++,o=L(),m=10;case 47:const N=s-1;if(t.charCodeAt(s+1)===47){for(s+=2;s<n&&!E(t.charCodeAt(s));)s++;return o=t.substring(N,s),m=12}if(t.charCodeAt(s+1)===42){s+=2;const W=n-1;let M=!1;for(;s<W;){if(t.charCodeAt(s)===42&&t.charCodeAt(s+1)===47){s+=2,M=!0;break}s++}return M||(s++,_=1),o=t.substring(N,s),m=13}return o+=String.fromCharCode(z),s++,m=16;case 45:if(o+=String.fromCharCode(z),s++,s===n||!k(t.charCodeAt(s)))return m=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return o+=T(),m=11;default:for(;s<n&&G(z);)s++,z=t.charCodeAt(s);if(v!==s){switch(o=t.substring(v,s),o){case"true":return m=8;case"false":return m=9;case"null":return m=7}return m=16}return o+=String.fromCharCode(z),s++,m=16}}function G(z){if(P(z)||E(z))return!1;switch(z){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function ee(){let z;do z=U();while(z>=12&&z<=15);return z}return{setPosition:a,getPosition:()=>s,scan:i?ee:U,getToken:()=>m,getTokenValue:()=>o,getTokenOffset:()=>v,getTokenLength:()=>s-v,getTokenError:()=>_}}e.createScanner=A;function P(t){return t===32||t===9||t===11||t===12||t===160||t===5760||t>=8192&&t<=8203||t===8239||t===8287||t===12288||t===65279}function E(t){return t===10||t===13||t===8232||t===8233}function k(t){return t>=48&&t<=57}var r;(function(t){t[t.nullCharacter=0]="nullCharacter",t[t.maxAsciiCharacter=127]="maxAsciiCharacter",t[t.lineFeed=10]="lineFeed",t[t.carriageReturn=13]="carriageReturn",t[t.lineSeparator=8232]="lineSeparator",t[t.paragraphSeparator=8233]="paragraphSeparator",t[t.nextLine=133]="nextLine",t[t.space=32]="space",t[t.nonBreakingSpace=160]="nonBreakingSpace",t[t.enQuad=8192]="enQuad",t[t.emQuad=8193]="emQuad",t[t.enSpace=8194]="enSpace",t[t.emSpace=8195]="emSpace",t[t.threePerEmSpace=8196]="threePerEmSpace",t[t.fourPerEmSpace=8197]="fourPerEmSpace",t[t.sixPerEmSpace=8198]="sixPerEmSpace",t[t.figureSpace=8199]="figureSpace",t[t.punctuationSpace=8200]="punctuationSpace",t[t.thinSpace=8201]="thinSpace",t[t.hairSpace=8202]="hairSpace",t[t.zeroWidthSpace=8203]="zeroWidthSpace",t[t.narrowNoBreakSpace=8239]="narrowNoBreakSpace",t[t.ideographicSpace=12288]="ideographicSpace",t[t.mathematicalSpace=8287]="mathematicalSpace",t[t.ogham=5760]="ogham",t[t._=95]="_",t[t.$=36]="$",t[t._0=48]="_0",t[t._1=49]="_1",t[t._2=50]="_2",t[t._3=51]="_3",t[t._4=52]="_4",t[t._5=53]="_5",t[t._6=54]="_6",t[t._7=55]="_7",t[t._8=56]="_8",t[t._9=57]="_9",t[t.a=97]="a",t[t.b=98]="b",t[t.c=99]="c",t[t.d=100]="d",t[t.e=101]="e",t[t.f=102]="f",t[t.g=103]="g",t[t.h=104]="h",t[t.i=105]="i",t[t.j=106]="j",t[t.k=107]="k",t[t.l=108]="l",t[t.m=109]="m",t[t.n=110]="n",t[t.o=111]="o",t[t.p=112]="p",t[t.q=113]="q",t[t.r=114]="r",t[t.s=115]="s",t[t.t=116]="t",t[t.u=117]="u",t[t.v=118]="v",t[t.w=119]="w",t[t.x=120]="x",t[t.y=121]="y",t[t.z=122]="z",t[t.A=65]="A",t[t.B=66]="B",t[t.C=67]="C",t[t.D=68]="D",t[t.E=69]="E",t[t.F=70]="F",t[t.G=71]="G",t[t.H=72]="H",t[t.I=73]="I",t[t.J=74]="J",t[t.K=75]="K",t[t.L=76]="L",t[t.M=77]="M",t[t.N=78]="N",t[t.O=79]="O",t[t.P=80]="P",t[t.Q=81]="Q",t[t.R=82]="R",t[t.S=83]="S",t[t.T=84]="T",t[t.U=85]="U",t[t.V=86]="V",t[t.W=87]="W",t[t.X=88]="X",t[t.Y=89]="Y",t[t.Z=90]="Z",t[t.ampersand=38]="ampersand",t[t.asterisk=42]="asterisk",t[t.at=64]="at",t[t.backslash=92]="backslash",t[t.bar=124]="bar",t[t.caret=94]="caret",t[t.closeBrace=125]="closeBrace",t[t.closeBracket=93]="closeBracket",t[t.closeParen=41]="closeParen",t[t.colon=58]="colon",t[t.comma=44]="comma",t[t.dot=46]="dot",t[t.doubleQuote=34]="doubleQuote",t[t.equals=61]="equals",t[t.exclamation=33]="exclamation",t[t.greaterThan=62]="greaterThan",t[t.lessThan=60]="lessThan",t[t.minus=45]="minus",t[t.openBrace=123]="openBrace",t[t.openBracket=91]="openBracket",t[t.openParen=40]="openParen",t[t.percent=37]="percent",t[t.plus=43]="plus",t[t.question=63]="question",t[t.semicolon=59]="semicolon",t[t.singleQuote=39]="singleQuote",t[t.slash=47]="slash",t[t.tilde=126]="tilde",t[t.backspace=8]="backspace",t[t.formFeed=12]="formFeed",t[t.byteOrderMark=65279]="byteOrderMark",t[t.tab=9]="tab",t[t.verticalTab=11]="verticalTab"})(r||(r={}));function I(t,i){const s=[],n=new Object;let o;const v={value:{},offset:0,length:0,type:"object",parent:void 0};let m=!1;function _(D,a,T,L){v.value=D,v.offset=a,v.length=T,v.type=L,v.colonOffset=void 0,o=v}try{d(t,{onObjectBegin:(D,a)=>{if(i<=D)throw n;o=void 0,m=i>D,s.push("")},onObjectProperty:(D,a,T)=>{if(i<a||(_(D,a,T,"property"),s[s.length-1]=D,i<=a+T))throw n},onObjectEnd:(D,a)=>{if(i<=D)throw n;o=void 0,s.pop()},onArrayBegin:(D,a)=>{if(i<=D)throw n;o=void 0,s.push(0)},onArrayEnd:(D,a)=>{if(i<=D)throw n;o=void 0,s.pop()},onLiteralValue:(D,a,T)=>{if(i<a||(_(D,a,T,g(D)),i<=a+T))throw n},onSeparator:(D,a,T)=>{if(i<=a)throw n;if(D===":"&&o&&o.type==="property")o.colonOffset=a,m=!1,o=void 0;else if(D===","){const L=s[s.length-1];typeof L=="number"?s[s.length-1]=L+1:(m=!0,s[s.length-1]=""),o=void 0}}})}catch(D){if(D!==n)throw D}return{path:s,previousNode:o,isAtPropertyKey:m,matches:D=>{let a=0;for(let T=0;a<D.length&&T<s.length;T++)if(D[a]===s[T]||D[a]==="*")a++;else if(D[a]!=="**")return!1;return a===D.length}}}e.getLocation=I;function l(t,i=[],s=y.DEFAULT){let n=null,o=[];const v=[];function m(D){Array.isArray(o)?o.push(D):n!==null&&(o[n]=D)}return d(t,{onObjectBegin:()=>{const D={};m(D),v.push(o),o=D,n=null},onObjectProperty:D=>{n=D},onObjectEnd:()=>{o=v.pop()},onArrayBegin:()=>{const D=[];m(D),v.push(o),o=D,n=null},onArrayEnd:()=>{o=v.pop()},onLiteralValue:m,onError:(D,a,T)=>{i.push({error:D,offset:a,length:T})}},s),o[0]}e.parse=l;function f(t,i=[],s=y.DEFAULT){let n={type:"array",offset:-1,length:-1,children:[],parent:void 0};function o(D){n.type==="property"&&(n.length=D-n.offset,n=n.parent)}function v(D){return n.children.push(D),D}d(t,{onObjectBegin:D=>{n=v({type:"object",offset:D,length:-1,parent:n,children:[]})},onObjectProperty:(D,a,T)=>{n=v({type:"property",offset:a,length:-1,parent:n,children:[]}),n.children.push({type:"string",value:D,offset:a,length:T,parent:n})},onObjectEnd:(D,a)=>{n.length=D+a-n.offset,n=n.parent,o(D+a)},onArrayBegin:(D,a)=>{n=v({type:"array",offset:D,length:-1,parent:n,children:[]})},onArrayEnd:(D,a)=>{n.length=D+a-n.offset,n=n.parent,o(D+a)},onLiteralValue:(D,a,T)=>{v({type:g(D),offset:a,length:T,parent:n,value:D}),o(a+T)},onSeparator:(D,a,T)=>{n.type==="property"&&(D===":"?n.colonOffset=a:D===","&&o(a))},onError:(D,a,T)=>{i.push({error:D,offset:a,length:T})}},s);const _=n.children[0];return _&&delete _.parent,_}e.parseTree=f;function c(t,i){if(!t)return;let s=t;for(let n of i)if(typeof n=="string"){if(s.type!=="object"||!Array.isArray(s.children))return;let o=!1;for(const v of s.children)if(Array.isArray(v.children)&&v.children[0].value===n){s=v.children[1],o=!0;break}if(!o)return}else{const o=n;if(s.type!=="array"||o<0||!Array.isArray(s.children)||o>=s.children.length)return;s=s.children[o]}return s}e.findNodeAtLocation=c;function u(t){if(!t.parent||!t.parent.children)return[];const i=u(t.parent);if(t.parent.type==="property"){const s=t.parent.children[0].value;i.push(s)}else if(t.parent.type==="array"){const s=t.parent.children.indexOf(t);s!==-1&&i.push(s)}return i}e.getNodePath=u;function S(t){switch(t.type){case"array":return t.children.map(S);case"object":const i=Object.create(null);for(let s of t.children){const n=s.children[1];n&&(i[s.children[0].value]=S(n))}return i;case"null":case"string":case"number":case"boolean":return t.value;default:return}}e.getNodeValue=S;function w(t,i,s=!1){return i>=t.offset&&i<t.offset+t.length||s&&i===t.offset+t.length}e.contains=w;function b(t,i,s=!1){if(w(t,i,s)){const n=t.children;if(Array.isArray(n))for(let o=0;o<n.length&&n[o].offset<=i;o++){const v=b(n[o],i,s);if(v)return v}return t}}e.findNodeAtOffset=b;function d(t,i,s=y.DEFAULT){const n=A(t,!1);function o(le){return le?()=>le(n.getTokenOffset(),n.getTokenLength()):()=>!0}function v(le){return le?be=>le(be,n.getTokenOffset(),n.getTokenLength()):()=>!0}const m=o(i.onObjectBegin),_=v(i.onObjectProperty),D=o(i.onObjectEnd),a=o(i.onArrayBegin),T=o(i.onArrayEnd),L=v(i.onLiteralValue),U=v(i.onSeparator),G=o(i.onComment),ee=v(i.onError),z=s&&s.disallowComments,N=s&&s.allowTrailingComma;function W(){for(;;){const le=n.scan();switch(n.getTokenError()){case 4:M(14);break;case 5:M(15);break;case 3:M(13);break;case 1:z||M(11);break;case 2:M(12);break;case 6:M(16);break}switch(le){case 12:case 13:z?M(10):G();break;case 16:M(1);break;case 15:case 14:break;default:return le}}}function M(le,be=[],Le=[]){if(ee(le),be.length+Le.length>0){let Ie=n.getToken();for(;Ie!==17;){if(be.indexOf(Ie)!==-1){W();break}else if(Le.indexOf(Ie)!==-1)break;Ie=W()}}}function j(le){const be=n.getTokenValue();return le?L(be):_(be),W(),!0}function O(){switch(n.getToken()){case 11:let le=0;try{le=JSON.parse(n.getTokenValue()),typeof le!="number"&&(M(2),le=0)}catch(be){M(2)}L(le);break;case 7:L(null);break;case 8:L(!0);break;case 9:L(!1);break;default:return!1}return W(),!0}function F(){return n.getToken()!==10?(M(3,[],[2,5]),!1):(j(!1),n.getToken()===6?(U(":"),W(),Y()||M(4,[],[2,5])):M(5,[],[2,5]),!0)}function B(){m(),W();let le=!1;for(;n.getToken()!==2&&n.getToken()!==17;){if(n.getToken()===5){if(le||M(4,[],[]),U(","),W(),n.getToken()===2&&N)break}else le&&M(6,[],[]);F()||M(4,[],[2,5]),le=!0}return D(),n.getToken()!==2?M(7,[2],[]):W(),!0}function $(){a(),W();let le=!1;for(;n.getToken()!==4&&n.getToken()!==17;){if(n.getToken()===5){if(le||M(4,[],[]),U(","),W(),n.getToken()===4&&N)break}else le&&M(6,[],[]);Y()||M(4,[],[4,5]),le=!0}return T(),n.getToken()!==4?M(8,[4],[]):W(),!0}function Y(){switch(n.getToken()){case 3:return $();case 1:return B();case 10:return j(!0);default:return O()}}return W(),n.getToken()===17?s.allowEmptyContent?!0:(M(4,[],[]),!1):Y()?(n.getToken()!==17&&M(9,[],[]),!0):(M(4,[],[]),!1)}e.visit=d;function h(t,i){let s=A(t),n=[],o,v=0,m;do switch(m=s.getPosition(),o=s.scan(),o){case 12:case 13:case 17:v!==m&&n.push(t.substring(v,m)),i!==void 0&&n.push(s.getTokenValue().replace(/[^\r\n]/g,i)),v=s.getPosition();break}while(o!==17);return n.join("")}e.stripComments=h;function g(t){switch(typeof t){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(t){if(Array.isArray(t))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=g}),define(me[132],ge([0,1,53]),function(X,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEOL=e.getEOL=e.format=void 0;function R(E,k,r){let I,l,f,c,u;if(k){for(c=k.offset,u=c+k.length,f=c;f>0&&!P(E,f-1);)f--;let v=u;for(;v<E.length&&!P(E,v);)v++;l=E.substring(f,v),I=y(l,r)}else l=E,I=0,f=0,c=0,u=E.length;const S=A(r,E);let w=!1,b=0,d;r.insertSpaces?d=C(" ",r.tabSize||4):d="	";const h=p.createScanner(l,!1);let g=!1;function t(){return S+C(d,I+b)}function i(){let v=h.scan();for(w=!1;v===15||v===14;)w=w||v===14,v=h.scan();return g=v===16||h.getTokenError()!==0,v}const s=[];function n(v,m,_){!g&&m<u&&_>c&&E.substring(m,_)!==v&&s.push({offset:m,length:_-m,content:v})}let o=i();if(o!==17){const v=h.getTokenOffset()+f,m=C(d,I);n(m,f,v)}for(;o!==17;){let v=h.getTokenOffset()+h.getTokenLength()+f,m=i(),_="";for(;!w&&(m===12||m===13);){const a=h.getTokenOffset()+f;n(" ",v,a),v=h.getTokenOffset()+h.getTokenLength()+f,_=m===12?t():"",m=i()}if(m===2)o!==1&&(b--,_=t());else if(m===4)o!==3&&(b--,_=t());else{switch(o){case 3:case 1:b++,_=t();break;case 5:case 12:_=t();break;case 13:w?_=t():_=" ";break;case 6:_=" ";break;case 10:if(m===6){_="";break}case 7:case 8:case 9:case 11:case 2:case 4:m===12||m===13?_=" ":m!==5&&m!==17&&(g=!0);break;case 16:g=!0;break}w&&(m===12||m===13)&&(_=t())}const D=h.getTokenOffset()+f;n(_,v,D),o=m}return s}e.format=R;function C(E,k){let r="";for(let I=0;I<k;I++)r+=E;return r}function y(E,k){let r=0,I=0;const l=k.tabSize||4;for(;r<E.length;){const f=E.charAt(r);if(f===" ")I++;else if(f==="	")I+=l;else break;r++}return Math.floor(I/l)}function A(E,k){for(let r=0;r<k.length;r++){const I=k.charAt(r);if(I==="\r")return r+1<k.length&&k.charAt(r+1)===`
`?`\r
`:"\r";if(I===`
`)return`
`}return E&&E.eol||`
`}e.getEOL=A;function P(E,k){return`\r
`.indexOf(E.charAt(k))!==-1}e.isEOL=P}),define(me[133],ge([0,1,53,132]),function(X,e,p,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.applyEdits=e.applyEdit=e.withFormatting=e.setProperty=e.removeProperty=void 0;function C(k,r,I){return y(k,r,void 0,I)}e.removeProperty=C;function y(k,r,I,l,f){const c=r.slice(),u=[],S=p.parseTree(k,u);let w,b;for(;c.length>0&&(b=c.pop(),w=p.findNodeAtLocation(S,c),w===void 0&&I!==void 0);)typeof b=="string"?I={[b]:I}:I=[I];if(w)if(w.type==="object"&&typeof b=="string"&&Array.isArray(w.children)){const d=p.findNodeAtLocation(w,[b]);if(d!==void 0)if(I===void 0){if(!d.parent)throw new Error("Malformed AST");const h=w.children.indexOf(d.parent);let g,t=d.parent.offset+d.parent.length;if(h>0){const i=w.children[h-1];g=i.offset+i.length}else g=w.offset+1,w.children.length>1&&(t=w.children[1].offset);return A(k,{offset:g,length:t-g,content:""},l)}else return A(k,{offset:d.offset,length:d.length,content:JSON.stringify(I)},l);else{if(I===void 0)return[];const h=`${JSON.stringify(b)}: ${JSON.stringify(I)}`,g=f?f(w.children.map(i=>i.children[0].value)):w.children.length;let t;if(g>0){const i=w.children[g-1];t={offset:i.offset+i.length,length:0,content:","+h}}else w.children.length===0?t={offset:w.offset+1,length:0,content:h}:t={offset:w.offset+1,length:0,content:h+","};return A(k,t,l)}}else if(w.type==="array"&&typeof b=="number"&&Array.isArray(w.children))if(I!==void 0){const d=`${JSON.stringify(I)}`;let h;if(w.children.length===0||b===0)h={offset:w.offset+1,length:0,content:w.children.length===0?d:d+","};else{const g=b===-1||b>w.children.length?w.children.length:b,t=w.children[g-1];h={offset:t.offset+t.length,length:0,content:","+d}}return A(k,h,l)}else{const d=b,h=w.children[d];let g;if(w.children.length===1)g={offset:w.offset+1,length:w.length-2,content:""};else if(w.children.length-1===d){const t=w.children[d-1],i=t.offset+t.length,s=w.offset+w.length;g={offset:i,length:s-2-i,content:""}}else g={offset:h.offset,length:w.children[d+1].offset-h.offset,content:""};return A(k,g,l)}else throw new Error(`Can not add ${typeof b!="number"?"index":"property"} to parent of type ${w.type}`);else{if(I===void 0)throw new Error("Can not delete in empty document");return A(k,{offset:S?S.offset:0,length:S?S.length:0,content:JSON.stringify(I)},l)}}e.setProperty=y;function A(k,r,I){let l=P(k,r),f=r.offset,c=r.offset+r.content.length;if(r.length===0||r.content.length===0){for(;f>0&&!R.isEOL(l,f-1);)f--;for(;c<l.length&&!R.isEOL(l,c);)c++}const u=R.format(l,{offset:f,length:c-f},I);for(let w=u.length-1;w>=0;w--){const b=u[w];l=P(l,b),f=Math.min(f,b.offset),c=Math.max(c,b.offset+b.length),c+=b.content.length-b.length}const S=k.length-(l.length-c)-f;return[{offset:f,length:S,content:l.substring(f,c)}]}e.withFormatting=A;function P(k,r){return k.substring(0,r.offset)+r.content+k.substring(r.offset+r.length)}e.applyEdit=P;function E(k,r){let I=r.slice(0).sort((f,c)=>{const u=f.offset-c.offset;return u===0?f.length-c.length:u}),l=k.length;for(let f=I.length-1;f>=0;f--){let c=I[f];if(c.offset+c.length<=l)k=P(k,c);else throw new Error("Overlapping edit");l=c.offset}return k}e.applyEdits=E}),define(me[134],ge([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Lazy=void 0;class p{constructor(C){this.executor=C,this._didRun=!1}hasValue(){return this._didRun}getValue(){if(!this._didRun)try{this._value=this.executor()}catch(C){this._error=C}finally{this._didRun=!0}if(this._error)throw this._error;return this._value}get rawValue(){return this._value}map(C){return new p(()=>C(this.getValue()))}}e.Lazy=p}),define(me[6],ge([0,1,69,52]),function(X,e,p,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ImmortalReference=e.AsyncReferenceCollection=e.ReferenceCollection=e.MutableDisposable=e.Disposable=e.DisposableStore=e.toDisposable=e.combinedDisposable=e.dispose=e.isDisposable=e.MultiDisposeError=e.trackDisposable=e.setDisposableTracker=void 0;const C=!1;let y=null;function A(h){y=h}if(e.setDisposableTracker=A,C){const h="__is_disposable_tracked__";y=new class{trackDisposable(g){const t=new Error("Potentially leaked disposable").stack;setTimeout(()=>{g[h]||console.log(t)},3e3)}markTracked(g){if(g&&g!==u.None)try{g[h]=!0}catch(t){}}}}function P(h){!y||y.markTracked(h)}function E(h){return y&&y.trackDisposable(h),h}e.trackDisposable=E;class k extends Error{constructor(g){super(`Encountered errors while disposing of store. Errors: [${g.join(", ")}]`);this.errors=g}}e.MultiDisposeError=k;function r(h){return typeof h.dispose=="function"&&h.dispose.length===0}e.isDisposable=r;function I(h){if(R.Iterable.is(h)){let g=[];for(const t of h)if(t){P(t);try{t.dispose()}catch(i){g.push(i)}}if(g.length===1)throw g[0];if(g.length>1)throw new k(g);return Array.isArray(h)?[]:h}else if(h)return P(h),h.dispose(),h}e.dispose=I;function l(...h){return h.forEach(P),f(()=>I(h))}e.combinedDisposable=l;function f(h){const g=E({dispose:()=>{P(g),h()}});return g}e.toDisposable=f;class c{constructor(){this._toDispose=new Set,this._isDisposed=!1}dispose(){this._isDisposed||(P(this),this._isDisposed=!0,this.clear())}clear(){try{I(this._toDispose.values())}finally{this._toDispose.clear()}}add(g){if(!g)return g;if(g===this)throw new Error("Cannot register a disposable on itself!");return P(g),this._isDisposed?c.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this._toDispose.add(g),g}}e.DisposableStore=c,c.DISABLE_DISPOSED_WARNING=!1;class u{constructor(){this._store=new c,E(this)}dispose(){P(this),this._store.dispose()}_register(g){if(g===this)throw new Error("Cannot register a disposable on itself!");return this._store.add(g)}}e.Disposable=u,u.None=Object.freeze({dispose(){}});class S{constructor(){this._isDisposed=!1,E(this)}get value(){return this._isDisposed?void 0:this._value}set value(g){var t;this._isDisposed||g===this._value||((t=this._value)===null||t===void 0||t.dispose(),g&&P(g),this._value=g)}clear(){this.value=void 0}dispose(){var g;this._isDisposed=!0,P(this),(g=this._value)===null||g===void 0||g.dispose(),this._value=void 0}}e.MutableDisposable=S;class w{constructor(){this.references=new Map}acquire(g,...t){let i=this.references.get(g);i||(i={counter:0,object:this.createReferencedObject(g,...t)},this.references.set(g,i));const{object:s}=i,n=p.once(()=>{--i.counter==0&&(this.destroyReferencedObject(g,i.object),this.references.delete(g))});return i.counter++,{object:s,dispose:n}}}e.ReferenceCollection=w;class b{constructor(g){this.referenceCollection=g}async acquire(g,...t){const i=this.referenceCollection.acquire(g,...t);try{return{object:await i.object,dispose:()=>i.dispose()}}catch(s){throw i.dispose(),s}}}e.AsyncReferenceCollection=b;class d{constructor(g){this.object=g}dispose(){}}e.ImmortalReference=d}),define(me[71],ge([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinkedList=void 0;class p{constructor(y){this.element=y,this.next=p.Undefined,this.prev=p.Undefined}}p.Undefined=new p(void 0);class R{constructor(){this._first=p.Undefined,this._last=p.Undefined,this._size=0}get size(){return this._size}isEmpty(){return this._first===p.Undefined}clear(){let y=this._first;for(;y!==p.Undefined;){const A=y.next;y.prev=p.Undefined,y.next=p.Undefined,y=A}this._first=p.Undefined,this._last=p.Undefined,this._size=0}unshift(y){return this._insert(y,!1)}push(y){return this._insert(y,!0)}_insert(y,A){const P=new p(y);if(this._first===p.Undefined)this._first=P,this._last=P;else if(A){const k=this._last;this._last=P,P.prev=k,k.next=P}else{const k=this._first;this._first=P,P.next=k,k.prev=P}this._size+=1;let E=!1;return()=>{E||(E=!0,this._remove(P))}}shift(){if(this._first!==p.Undefined){const y=this._first.element;return this._remove(this._first),y}}pop(){if(this._last!==p.Undefined){const y=this._last.element;return this._remove(this._last),y}}_remove(y){if(y.prev!==p.Undefined&&y.next!==p.Undefined){const A=y.prev;A.next=y.next,y.next.prev=A}else y.prev===p.Undefined&&y.next===p.Undefined?(this._first=p.Undefined,this._last=p.Undefined):y.next===p.Undefined?(this._last=this._last.prev,this._last.next=p.Undefined):y.prev===p.Undefined&&(this._first=this._first.next,this._first.prev=p.Undefined);this._size-=1}*[Symbol.iterator](){let y=this._first;for(;y!==p.Undefined;)yield y.element,y=y.next}}e.LinkedList=R}),function(X,e){typeof exports=="object"&&typeof module!="undefined"?module.exports=e():typeof define=="function"&&define.amd?define("vs/base/common/marked/marked",e):(X=typeof globalThis!="undefined"?globalThis:X||self,X.marked=e())}(this,function(){"use strict";function X(ke,ye){for(var Ae=0;Ae<ye.length;Ae++){var oe=ye[Ae];oe.enumerable=oe.enumerable||!1,oe.configurable=!0,"value"in oe&&(oe.writable=!0),Object.defineProperty(ke,oe.key,oe)}}function e(ke,ye,Ae){return ye&&X(ke.prototype,ye),Ae&&X(ke,Ae),ke}function p(ke,ye){if(!!ke){if(typeof ke=="string")return R(ke,ye);var Ae=Object.prototype.toString.call(ke).slice(8,-1);if(Ae==="Object"&&ke.constructor&&(Ae=ke.constructor.name),Ae==="Map"||Ae==="Set")return Array.from(ke);if(Ae==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(Ae))return R(ke,ye)}}function R(ke,ye){(ye==null||ye>ke.length)&&(ye=ke.length);for(var Ae=0,oe=new Array(ye);Ae<ye;Ae++)oe[Ae]=ke[Ae];return oe}function C(ke,ye){var Ae;if(typeof Symbol=="undefined"||ke[Symbol.iterator]==null){if(Array.isArray(ke)||(Ae=p(ke))||ye&&ke&&typeof ke.length=="number"){Ae&&(ke=Ae);var oe=0;return function(){return oe>=ke.length?{done:!0}:{done:!1,value:ke[oe++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}return Ae=ke[Symbol.iterator](),Ae.next.bind(Ae)}function y(ke){var ye={exports:{}};return ke(ye,ye.exports),ye.exports}var A=y(function(ke){function ye(){return{baseUrl:null,breaks:!1,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}function Ae(oe){ke.exports.defaults=oe}ke.exports={defaults:ye(),getDefaults:ye,changeDefaults:Ae}}),P=/[&<>"']/,E=/[&<>"']/g,k=/[<>"']|&(?!#?\w+;)/,r=/[<>"']|&(?!#?\w+;)/g,I={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},l=function(ye){return I[ye]};function f(ke,ye){if(ye){if(P.test(ke))return ke.replace(E,l)}else if(k.test(ke))return ke.replace(r,l);return ke}var c=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function u(ke){return ke.replace(c,function(ye,Ae){return Ae=Ae.toLowerCase(),Ae==="colon"?":":Ae.charAt(0)==="#"?Ae.charAt(1)==="x"?String.fromCharCode(parseInt(Ae.substring(2),16)):String.fromCharCode(+Ae.substring(1)):""})}var S=/(^|[^\[])\^/g;function w(ke,ye){ke=ke.source||ke,ye=ye||"";var Ae={replace:function(ue,fe){return fe=fe.source||fe,fe=fe.replace(S,"$1"),ke=ke.replace(ue,fe),Ae},getRegex:function(){return new RegExp(ke,ye)}};return Ae}var b=/[^\w:]/g,d=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function h(ke,ye,Ae){if(ke){var oe;try{oe=decodeURIComponent(u(Ae)).replace(b,"").toLowerCase()}catch(ue){return null}if(oe.indexOf("javascript:")===0||oe.indexOf("vbscript:")===0||oe.indexOf("data:")===0)return null}ye&&!d.test(Ae)&&(Ae=n(ye,Ae));try{Ae=encodeURI(Ae).replace(/%25/g,"%")}catch(ue){return null}return Ae}var g={},t=/^[^:]+:\/*[^/]*$/,i=/^([^:]+:)[\s\S]*$/,s=/^([^:]+:\/*[^/]*)[\s\S]*$/;function n(ke,ye){g[" "+ke]||(t.test(ke)?g[" "+ke]=ke+"/":g[" "+ke]=_(ke,"/",!0)),ke=g[" "+ke];var Ae=ke.indexOf(":")===-1;return ye.substring(0,2)==="//"?Ae?ye:ke.replace(i,"$1")+ye:ye.charAt(0)==="/"?Ae?ye:ke.replace(s,"$1")+ye:ke+ye}var o={exec:function(){}};function v(ke){for(var ye=1,Ae,oe;ye<arguments.length;ye++){Ae=arguments[ye];for(oe in Ae)Object.prototype.hasOwnProperty.call(Ae,oe)&&(ke[oe]=Ae[oe])}return ke}function m(ke,ye){var Ae=ke.replace(/\|/g,function(fe,we,q){for(var pe=!1,Se=we;--Se>=0&&q[Se]==="\\";)pe=!pe;return pe?"|":" |"}),oe=Ae.split(/ \|/),ue=0;if(oe.length>ye)oe.splice(ye);else for(;oe.length<ye;)oe.push("");for(;ue<oe.length;ue++)oe[ue]=oe[ue].trim().replace(/\\\|/g,"|");return oe}function _(ke,ye,Ae){var oe=ke.length;if(oe===0)return"";for(var ue=0;ue<oe;){var fe=ke.charAt(oe-ue-1);if(fe===ye&&!Ae)ue++;else if(fe!==ye&&Ae)ue++;else break}return ke.substr(0,oe-ue)}function D(ke,ye){if(ke.indexOf(ye[1])===-1)return-1;for(var Ae=ke.length,oe=0,ue=0;ue<Ae;ue++)if(ke[ue]==="\\")ue++;else if(ke[ue]===ye[0])oe++;else if(ke[ue]===ye[1]&&(oe--,oe<0))return ue;return-1}function a(ke){ke&&ke.sanitize&&!ke.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function T(ke,ye){if(ye<1)return"";for(var Ae="";ye>1;)ye&1&&(Ae+=ke),ye>>=1,ke+=ke;return Ae+ke}var L={escape:f,unescape:u,edit:w,cleanUrl:h,resolveUrl:n,noopTest:o,merge:v,splitCells:m,rtrim:_,findClosingBracket:D,checkSanitizeDeprecation:a,repeatString:T},U=A.defaults,G=L.rtrim,ee=L.splitCells,z=L.escape,N=L.findClosingBracket;function W(ke,ye,Ae){var oe=ye.href,ue=ye.title?z(ye.title):null,fe=ke[1].replace(/\\([\[\]])/g,"$1");return ke[0].charAt(0)!=="!"?{type:"link",raw:Ae,href:oe,title:ue,text:fe}:{type:"image",raw:Ae,href:oe,title:ue,text:z(fe)}}function M(ke,ye){var Ae=ke.match(/^(\s+)(?:```)/);if(Ae===null)return ye;var oe=Ae[1];return ye.split(`
`).map(function(ue){var fe=ue.match(/^\s+/);if(fe===null)return ue;var we=fe[0];return we.length>=oe.length?ue.slice(oe.length):ue}).join(`
`)}var j=function(){function ke(Ae){this.options=Ae||U}var ye=ke.prototype;return ye.space=function(oe){var ue=this.rules.block.newline.exec(oe);if(ue)return ue[0].length>1?{type:"space",raw:ue[0]}:{raw:`
`}},ye.code=function(oe){var ue=this.rules.block.code.exec(oe);if(ue){var fe=ue[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:ue[0],codeBlockStyle:"indented",text:this.options.pedantic?fe:G(fe,`
`)}}},ye.fences=function(oe){var ue=this.rules.block.fences.exec(oe);if(ue){var fe=ue[0],we=M(fe,ue[3]||"");return{type:"code",raw:fe,lang:ue[2]?ue[2].trim():ue[2],text:we}}},ye.heading=function(oe){var ue=this.rules.block.heading.exec(oe);if(ue){var fe=ue[2].trim();if(/#$/.test(fe)){var we=G(fe,"#");(this.options.pedantic||!we||/ $/.test(we))&&(fe=we.trim())}return{type:"heading",raw:ue[0],depth:ue[1].length,text:fe}}},ye.nptable=function(oe){var ue=this.rules.block.nptable.exec(oe);if(ue){var fe={type:"table",header:ee(ue[1].replace(/^ *| *\| *$/g,"")),align:ue[2].replace(/^ *|\| *$/g,"").split(/ *\| */),cells:ue[3]?ue[3].replace(/\n$/,"").split(`
`):[],raw:ue[0]};if(fe.header.length===fe.align.length){var we=fe.align.length,q;for(q=0;q<we;q++)/^ *-+: *$/.test(fe.align[q])?fe.align[q]="right":/^ *:-+: *$/.test(fe.align[q])?fe.align[q]="center":/^ *:-+ *$/.test(fe.align[q])?fe.align[q]="left":fe.align[q]=null;for(we=fe.cells.length,q=0;q<we;q++)fe.cells[q]=ee(fe.cells[q],fe.header.length);return fe}}},ye.hr=function(oe){var ue=this.rules.block.hr.exec(oe);if(ue)return{type:"hr",raw:ue[0]}},ye.blockquote=function(oe){var ue=this.rules.block.blockquote.exec(oe);if(ue){var fe=ue[0].replace(/^ *> ?/gm,"");return{type:"blockquote",raw:ue[0],text:fe}}},ye.list=function(oe){var ue=this.rules.block.list.exec(oe);if(ue){var fe=ue[0],we=ue[2],q=we.length>1,pe={type:"list",raw:fe,ordered:q,start:q?+we.slice(0,-1):"",loose:!1,items:[]},Se=ue[0].match(this.rules.block.item),Te=!1,Oe,je,qe,Ze,nt,ct,Ee,Ce,ce=Se.length;qe=this.rules.block.listItemStart.exec(Se[0]);for(var Q=0;Q<ce;Q++){if(Oe=Se[Q],fe=Oe,Q!==ce-1){if(Ze=this.rules.block.listItemStart.exec(Se[Q+1]),this.options.pedantic?Ze[1].length>qe[1].length:Ze[1].length>qe[0].length||Ze[1].length>3){Se.splice(Q,2,Se[Q]+`
`+Se[Q+1]),Q--,ce--;continue}else(!this.options.pedantic||this.options.smartLists?Ze[2][Ze[2].length-1]!==we[we.length-1]:q===(Ze[2].length===1))&&(nt=Se.slice(Q+1).join(`
`),pe.raw=pe.raw.substring(0,pe.raw.length-nt.length),Q=ce-1);qe=Ze}je=Oe.length,Oe=Oe.replace(/^ *([*+-]|\d+[.)]) ?/,""),~Oe.indexOf(`
 `)&&(je-=Oe.length,Oe=this.options.pedantic?Oe.replace(/^ {1,4}/gm,""):Oe.replace(new RegExp("^ {1,"+je+"}","gm"),"")),ct=Te||/\n\n(?!\s*$)/.test(Oe),Q!==ce-1&&(Te=Oe.charAt(Oe.length-1)===`
`,ct||(ct=Te)),ct&&(pe.loose=!0),this.options.gfm&&(Ee=/^\[[ xX]\] /.test(Oe),Ce=void 0,Ee&&(Ce=Oe[1]!==" ",Oe=Oe.replace(/^\[[ xX]\] +/,""))),pe.items.push({type:"list_item",raw:fe,task:Ee,checked:Ce,loose:ct,text:Oe})}return pe}},ye.html=function(oe){var ue=this.rules.block.html.exec(oe);if(ue)return{type:this.options.sanitize?"paragraph":"html",raw:ue[0],pre:!this.options.sanitizer&&(ue[1]==="pre"||ue[1]==="script"||ue[1]==="style"),text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(ue[0]):z(ue[0]):ue[0]}},ye.def=function(oe){var ue=this.rules.block.def.exec(oe);if(ue){ue[3]&&(ue[3]=ue[3].substring(1,ue[3].length-1));var fe=ue[1].toLowerCase().replace(/\s+/g," ");return{tag:fe,raw:ue[0],href:ue[2],title:ue[3]}}},ye.table=function(oe){var ue=this.rules.block.table.exec(oe);if(ue){var fe={type:"table",header:ee(ue[1].replace(/^ *| *\| *$/g,"")),align:ue[2].replace(/^ *|\| *$/g,"").split(/ *\| */),cells:ue[3]?ue[3].replace(/\n$/,"").split(`
`):[]};if(fe.header.length===fe.align.length){fe.raw=ue[0];var we=fe.align.length,q;for(q=0;q<we;q++)/^ *-+: *$/.test(fe.align[q])?fe.align[q]="right":/^ *:-+: *$/.test(fe.align[q])?fe.align[q]="center":/^ *:-+ *$/.test(fe.align[q])?fe.align[q]="left":fe.align[q]=null;for(we=fe.cells.length,q=0;q<we;q++)fe.cells[q]=ee(fe.cells[q].replace(/^ *\| *| *\| *$/g,""),fe.header.length);return fe}}},ye.lheading=function(oe){var ue=this.rules.block.lheading.exec(oe);if(ue)return{type:"heading",raw:ue[0],depth:ue[2].charAt(0)==="="?1:2,text:ue[1]}},ye.paragraph=function(oe){var ue=this.rules.block.paragraph.exec(oe);if(ue)return{type:"paragraph",raw:ue[0],text:ue[1].charAt(ue[1].length-1)===`
`?ue[1].slice(0,-1):ue[1]}},ye.text=function(oe){var ue=this.rules.block.text.exec(oe);if(ue)return{type:"text",raw:ue[0],text:ue[0]}},ye.escape=function(oe){var ue=this.rules.inline.escape.exec(oe);if(ue)return{type:"escape",raw:ue[0],text:z(ue[1])}},ye.tag=function(oe,ue,fe){var we=this.rules.inline.tag.exec(oe);if(we)return!ue&&/^<a /i.test(we[0])?ue=!0:ue&&/^<\/a>/i.test(we[0])&&(ue=!1),!fe&&/^<(pre|code|kbd|script)(\s|>)/i.test(we[0])?fe=!0:fe&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(we[0])&&(fe=!1),{type:this.options.sanitize?"text":"html",raw:we[0],inLink:ue,inRawBlock:fe,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(we[0]):z(we[0]):we[0]}},ye.link=function(oe){var ue=this.rules.inline.link.exec(oe);if(ue){var fe=ue[2].trim();if(!this.options.pedantic&&/^</.test(fe)){if(!/>$/.test(fe))return;var we=G(fe.slice(0,-1),"\\");if((fe.length-we.length)%2==0)return}else{var q=N(ue[2],"()");if(q>-1){var pe=ue[0].indexOf("!")===0?5:4,Se=pe+ue[1].length+q;ue[2]=ue[2].substring(0,q),ue[0]=ue[0].substring(0,Se).trim(),ue[3]=""}}var Te=ue[2],Oe="";if(this.options.pedantic){var je=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(Te);je&&(Te=je[1],Oe=je[3])}else Oe=ue[3]?ue[3].slice(1,-1):"";return Te=Te.trim(),/^</.test(Te)&&(this.options.pedantic&&!/>$/.test(fe)?Te=Te.slice(1):Te=Te.slice(1,-1)),W(ue,{href:Te&&Te.replace(this.rules.inline._escapes,"$1"),title:Oe&&Oe.replace(this.rules.inline._escapes,"$1")},ue[0])}},ye.reflink=function(oe,ue){var fe;if((fe=this.rules.inline.reflink.exec(oe))||(fe=this.rules.inline.nolink.exec(oe))){var we=(fe[2]||fe[1]).replace(/\s+/g," ");if(we=ue[we.toLowerCase()],!we||!we.href){var q=fe[0].charAt(0);return{type:"text",raw:q,text:q}}return W(fe,we,fe[0])}},ye.emStrong=function(oe,ue,fe){fe===void 0&&(fe="");var we=this.rules.inline.emStrong.lDelim.exec(oe);if(!!we&&!(we[3]&&fe.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u08A0-\u08B4\u08B6-\u08C7\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u170C\u170E-\u1711\u1720-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4B\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2C2E\u2C30-\u2C5E\u2C60-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\u9FFC\uA000-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7BF\uA7C2-\uA7CA\uA7F5-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEC0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82C[\uDC00-\uDD1E\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDD\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF34\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var q=we[1]||we[2]||"";if(!q||q&&(fe===""||this.rules.inline.punctuation.exec(fe))){var pe=we[0].length-1,Se,Te,Oe=pe,je=0,qe=we[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(qe.lastIndex=0,ue=ue.slice(-1*oe.length+pe);(we=qe.exec(ue))!=null;)if(Se=we[1]||we[2]||we[3]||we[4]||we[5]||we[6],!!Se){if(Te=Se.length,we[3]||we[4]){Oe+=Te;continue}else if((we[5]||we[6])&&pe%3&&!((pe+Te)%3)){je+=Te;continue}if(Oe-=Te,!(Oe>0)){if(Oe+je-Te<=0&&!ue.slice(qe.lastIndex).match(qe)&&(Te=Math.min(Te,Te+Oe+je)),Math.min(pe,Te)%2)return{type:"em",raw:oe.slice(0,pe+we.index+Te+1),text:oe.slice(1,pe+we.index+Te)};if(Math.min(pe,Te)%2==0)return{type:"strong",raw:oe.slice(0,pe+we.index+Te+1),text:oe.slice(2,pe+we.index+Te-1)}}}}}},ye.codespan=function(oe){var ue=this.rules.inline.code.exec(oe);if(ue){var fe=ue[2].replace(/\n/g," "),we=/[^ ]/.test(fe),q=/^ /.test(fe)&&/ $/.test(fe);return we&&q&&(fe=fe.substring(1,fe.length-1)),fe=z(fe,!0),{type:"codespan",raw:ue[0],text:fe}}},ye.br=function(oe){var ue=this.rules.inline.br.exec(oe);if(ue)return{type:"br",raw:ue[0]}},ye.del=function(oe){var ue=this.rules.inline.del.exec(oe);if(ue)return{type:"del",raw:ue[0],text:ue[2]}},ye.autolink=function(oe,ue){var fe=this.rules.inline.autolink.exec(oe);if(fe){var we,q;return fe[2]==="@"?(we=z(this.options.mangle?ue(fe[1]):fe[1]),q="mailto:"+we):(we=z(fe[1]),q=we),{type:"link",raw:fe[0],text:we,href:q,tokens:[{type:"text",raw:we,text:we}]}}},ye.url=function(oe,ue){var fe;if(fe=this.rules.inline.url.exec(oe)){var we,q;if(fe[2]==="@")we=z(this.options.mangle?ue(fe[0]):fe[0]),q="mailto:"+we;else{var pe;do pe=fe[0],fe[0]=this.rules.inline._backpedal.exec(fe[0])[0];while(pe!==fe[0]);we=z(fe[0]),fe[1]==="www."?q="http://"+we:q=we}return{type:"link",raw:fe[0],text:we,href:q,tokens:[{type:"text",raw:we,text:we}]}}},ye.inlineText=function(oe,ue,fe){var we=this.rules.inline.text.exec(oe);if(we){var q;return ue?q=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(we[0]):z(we[0]):we[0]:q=z(this.options.smartypants?fe(we[0]):we[0]),{type:"text",raw:we[0],text:q}}},ke}(),O=L.noopTest,F=L.edit,B=L.merge,$={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?:\n+|$)|$)/,hr:/^ {0,3}((?:- *){3,}|(?:_ *){3,}|(?:\* *){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3})(bull) [\s\S]+?(?:hr|def|\n{2,}(?! )(?! {0,3}bull )\n*|\s*$)/,html:"^ {0,3}(?:<(script|pre|style)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:\\n{2,}|$)|<(?!script|pre|style)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:\\n{2,}|$)|</(?!script|pre|style)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:\\n{2,}|$))",def:/^ {0,3}\[(label)\]: *\n? *<?([^\s>]+)>?(?:(?: +\n? *| *\n *)(title))? *(?:\n+|$)/,nptable:O,table:O,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html| +\n)[^\n]+)*)/,text:/^[^\n]+/};$._label=/(?!\s*\])(?:\\[\[\]]|[^\[\]])+/,$._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,$.def=F($.def).replace("label",$._label).replace("title",$._title).getRegex(),$.bullet=/(?:[*+-]|\d{1,9}[.)])/,$.item=/^( *)(bull) ?[^\n]*(?:\n(?! *bull ?)[^\n]*)*/,$.item=F($.item,"gm").replace(/bull/g,$.bullet).getRegex(),$.listItemStart=F(/^( *)(bull)/).replace("bull",$.bullet).getRegex(),$.list=F($.list).replace(/bull/g,$.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+$.def.source+")").getRegex(),$._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",$._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,$.html=F($.html,"i").replace("comment",$._comment).replace("tag",$._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),$.paragraph=F($._paragraph).replace("hr",$.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|!--)").replace("tag",$._tag).getRegex(),$.blockquote=F($.blockquote).replace("paragraph",$.paragraph).getRegex(),$.normal=B({},$),$.gfm=B({},$.normal,{nptable:"^ *([^|\\n ].*\\|.*)\\n {0,3}([-:]+ *\\|[-| :]*)(?:\\n((?:(?!\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)",table:"^ *\\|(.+)\\n {0,3}\\|?( *[-:]+[-| :]*)(?:\\n *((?:(?!\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),$.gfm.nptable=F($.gfm.nptable).replace("hr",$.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|!--)").replace("tag",$._tag).getRegex(),$.gfm.table=F($.gfm.table).replace("hr",$.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|!--)").replace("tag",$._tag).getRegex(),$.pedantic=B({},$.normal,{html:F(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",$._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:O,paragraph:F($.normal._paragraph).replace("hr",$.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",$.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var Y={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:O,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(?!\s*\])((?:\\[\[\]]?|[^\[\]\\])+)\]/,nolink:/^!?\[(?!\s*\])((?:\[[^\[\]]*\]|\\[\[\]]|[^\[\]])*)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/\_\_[^_]*?\*[^_]*?\_\_|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/\*\*[^*]*?\_[^*]*?\*\*|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:O,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};Y._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",Y.punctuation=F(Y.punctuation).replace(/punctuation/g,Y._punctuation).getRegex(),Y.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,Y.escapedEmSt=/\\\*|\\_/g,Y._comment=F($._comment).replace("(?:-->|$)","-->").getRegex(),Y.emStrong.lDelim=F(Y.emStrong.lDelim).replace(/punct/g,Y._punctuation).getRegex(),Y.emStrong.rDelimAst=F(Y.emStrong.rDelimAst,"g").replace(/punct/g,Y._punctuation).getRegex(),Y.emStrong.rDelimUnd=F(Y.emStrong.rDelimUnd,"g").replace(/punct/g,Y._punctuation).getRegex(),Y._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,Y._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,Y._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,Y.autolink=F(Y.autolink).replace("scheme",Y._scheme).replace("email",Y._email).getRegex(),Y._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,Y.tag=F(Y.tag).replace("comment",Y._comment).replace("attribute",Y._attribute).getRegex(),Y._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,Y._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,Y._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,Y.link=F(Y.link).replace("label",Y._label).replace("href",Y._href).replace("title",Y._title).getRegex(),Y.reflink=F(Y.reflink).replace("label",Y._label).getRegex(),Y.reflinkSearch=F(Y.reflinkSearch,"g").replace("reflink",Y.reflink).replace("nolink",Y.nolink).getRegex(),Y.normal=B({},Y),Y.pedantic=B({},Y.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:F(/^!?\[(label)\]\((.*?)\)/).replace("label",Y._label).getRegex(),reflink:F(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",Y._label).getRegex()}),Y.gfm=B({},Y.normal,{escape:F(Y.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@))|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@))/}),Y.gfm.url=F(Y.gfm.url,"i").replace("email",Y.gfm._extended_email).getRegex(),Y.breaks=B({},Y.gfm,{br:F(Y.br).replace("{2,}","*").getRegex(),text:F(Y.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});var le={block:$,inline:Y},be=A.defaults,Le=le.block,Ie=le.inline,Ue=L.repeatString;function Qe(ke){return ke.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function ze(ke){var ye="",Ae,oe,ue=ke.length;for(Ae=0;Ae<ue;Ae++)oe=ke.charCodeAt(Ae),Math.random()>.5&&(oe="x"+oe.toString(16)),ye+="&#"+oe+";";return ye}var Ge=function(){function ke(Ae){this.tokens=[],this.tokens.links=Object.create(null),this.options=Ae||be,this.options.tokenizer=this.options.tokenizer||new j,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options;var oe={block:Le.normal,inline:Ie.normal};this.options.pedantic?(oe.block=Le.pedantic,oe.inline=Ie.pedantic):this.options.gfm&&(oe.block=Le.gfm,this.options.breaks?oe.inline=Ie.breaks:oe.inline=Ie.gfm),this.tokenizer.rules=oe}ke.lex=function(oe,ue){var fe=new ke(ue);return fe.lex(oe)},ke.lexInline=function(oe,ue){var fe=new ke(ue);return fe.inlineTokens(oe)};var ye=ke.prototype;return ye.lex=function(oe){return oe=oe.replace(/\r\n|\r/g,`
`).replace(/\t/g,"    "),this.blockTokens(oe,this.tokens,!0),this.inline(this.tokens),this.tokens},ye.blockTokens=function(oe,ue,fe){ue===void 0&&(ue=[]),fe===void 0&&(fe=!0),this.options.pedantic&&(oe=oe.replace(/^ +$/gm,""));for(var we,q,pe,Se;oe;){if(we=this.tokenizer.space(oe)){oe=oe.substring(we.raw.length),we.type&&ue.push(we);continue}if(we=this.tokenizer.code(oe)){oe=oe.substring(we.raw.length),Se=ue[ue.length-1],Se&&Se.type==="paragraph"?(Se.raw+=`
`+we.raw,Se.text+=`
`+we.text):ue.push(we);continue}if(we=this.tokenizer.fences(oe)){oe=oe.substring(we.raw.length),ue.push(we);continue}if(we=this.tokenizer.heading(oe)){oe=oe.substring(we.raw.length),ue.push(we);continue}if(we=this.tokenizer.nptable(oe)){oe=oe.substring(we.raw.length),ue.push(we);continue}if(we=this.tokenizer.hr(oe)){oe=oe.substring(we.raw.length),ue.push(we);continue}if(we=this.tokenizer.blockquote(oe)){oe=oe.substring(we.raw.length),we.tokens=this.blockTokens(we.text,[],fe),ue.push(we);continue}if(we=this.tokenizer.list(oe)){for(oe=oe.substring(we.raw.length),pe=we.items.length,q=0;q<pe;q++)we.items[q].tokens=this.blockTokens(we.items[q].text,[],!1);ue.push(we);continue}if(we=this.tokenizer.html(oe)){oe=oe.substring(we.raw.length),ue.push(we);continue}if(fe&&(we=this.tokenizer.def(oe))){oe=oe.substring(we.raw.length),this.tokens.links[we.tag]||(this.tokens.links[we.tag]={href:we.href,title:we.title});continue}if(we=this.tokenizer.table(oe)){oe=oe.substring(we.raw.length),ue.push(we);continue}if(we=this.tokenizer.lheading(oe)){oe=oe.substring(we.raw.length),ue.push(we);continue}if(fe&&(we=this.tokenizer.paragraph(oe))){oe=oe.substring(we.raw.length),ue.push(we);continue}if(we=this.tokenizer.text(oe)){oe=oe.substring(we.raw.length),Se=ue[ue.length-1],Se&&Se.type==="text"?(Se.raw+=`
`+we.raw,Se.text+=`
`+we.text):ue.push(we);continue}if(oe){var Te="Infinite loop on byte: "+oe.charCodeAt(0);if(this.options.silent){console.error(Te);break}else throw new Error(Te)}}return ue},ye.inline=function(oe){var ue,fe,we,q,pe,Se,Te=oe.length;for(ue=0;ue<Te;ue++)switch(Se=oe[ue],Se.type){case"paragraph":case"text":case"heading":{Se.tokens=[],this.inlineTokens(Se.text,Se.tokens);break}case"table":{for(Se.tokens={header:[],cells:[]},q=Se.header.length,fe=0;fe<q;fe++)Se.tokens.header[fe]=[],this.inlineTokens(Se.header[fe],Se.tokens.header[fe]);for(q=Se.cells.length,fe=0;fe<q;fe++)for(pe=Se.cells[fe],Se.tokens.cells[fe]=[],we=0;we<pe.length;we++)Se.tokens.cells[fe][we]=[],this.inlineTokens(pe[we],Se.tokens.cells[fe][we]);break}case"blockquote":{this.inline(Se.tokens);break}case"list":{for(q=Se.items.length,fe=0;fe<q;fe++)this.inline(Se.items[fe].tokens);break}}return oe},ye.inlineTokens=function(oe,ue,fe,we){ue===void 0&&(ue=[]),fe===void 0&&(fe=!1),we===void 0&&(we=!1);var q,pe,Se=oe,Te,Oe,je;if(this.tokens.links){var qe=Object.keys(this.tokens.links);if(qe.length>0)for(;(Te=this.tokenizer.rules.inline.reflinkSearch.exec(Se))!=null;)qe.includes(Te[0].slice(Te[0].lastIndexOf("[")+1,-1))&&(Se=Se.slice(0,Te.index)+"["+Ue("a",Te[0].length-2)+"]"+Se.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(Te=this.tokenizer.rules.inline.blockSkip.exec(Se))!=null;)Se=Se.slice(0,Te.index)+"["+Ue("a",Te[0].length-2)+"]"+Se.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(Te=this.tokenizer.rules.inline.escapedEmSt.exec(Se))!=null;)Se=Se.slice(0,Te.index)+"++"+Se.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;oe;){if(Oe||(je=""),Oe=!1,q=this.tokenizer.escape(oe)){oe=oe.substring(q.raw.length),ue.push(q);continue}if(q=this.tokenizer.tag(oe,fe,we)){oe=oe.substring(q.raw.length),fe=q.inLink,we=q.inRawBlock;var Ze=ue[ue.length-1];Ze&&q.type==="text"&&Ze.type==="text"?(Ze.raw+=q.raw,Ze.text+=q.text):ue.push(q);continue}if(q=this.tokenizer.link(oe)){oe=oe.substring(q.raw.length),q.type==="link"&&(q.tokens=this.inlineTokens(q.text,[],!0,we)),ue.push(q);continue}if(q=this.tokenizer.reflink(oe,this.tokens.links)){oe=oe.substring(q.raw.length);var nt=ue[ue.length-1];q.type==="link"?(q.tokens=this.inlineTokens(q.text,[],!0,we),ue.push(q)):nt&&q.type==="text"&&nt.type==="text"?(nt.raw+=q.raw,nt.text+=q.text):ue.push(q);continue}if(q=this.tokenizer.emStrong(oe,Se,je)){oe=oe.substring(q.raw.length),q.tokens=this.inlineTokens(q.text,[],fe,we),ue.push(q);continue}if(q=this.tokenizer.codespan(oe)){oe=oe.substring(q.raw.length),ue.push(q);continue}if(q=this.tokenizer.br(oe)){oe=oe.substring(q.raw.length),ue.push(q);continue}if(q=this.tokenizer.del(oe)){oe=oe.substring(q.raw.length),q.tokens=this.inlineTokens(q.text,[],fe,we),ue.push(q);continue}if(q=this.tokenizer.autolink(oe,ze)){oe=oe.substring(q.raw.length),ue.push(q);continue}if(!fe&&(q=this.tokenizer.url(oe,ze))){oe=oe.substring(q.raw.length),ue.push(q);continue}if(q=this.tokenizer.inlineText(oe,we,Qe)){oe=oe.substring(q.raw.length),q.raw.slice(-1)!=="_"&&(je=q.raw.slice(-1)),Oe=!0,pe=ue[ue.length-1],pe&&pe.type==="text"?(pe.raw+=q.raw,pe.text+=q.text):ue.push(q);continue}if(oe){var ct="Infinite loop on byte: "+oe.charCodeAt(0);if(this.options.silent){console.error(ct);break}else throw new Error(ct)}}return ue},e(ke,null,[{key:"rules",get:function(){return{block:Le,inline:Ie}}}]),ke}(),V=A.defaults,Z=L.cleanUrl,ne=L.escape,se=function(){function ke(Ae){this.options=Ae||V}var ye=ke.prototype;return ye.code=function(oe,ue,fe){var we=(ue||"").match(/\S*/)[0];if(this.options.highlight){var q=this.options.highlight(oe,we);q!=null&&q!==oe&&(fe=!0,oe=q)}return oe=oe.replace(/\n$/,"")+`
`,we?'<pre><code class="'+this.options.langPrefix+ne(we,!0)+'">'+(fe?oe:ne(oe,!0))+`</code></pre>
`:"<pre><code>"+(fe?oe:ne(oe,!0))+`</code></pre>
`},ye.blockquote=function(oe){return`<blockquote>
`+oe+`</blockquote>
`},ye.html=function(oe){return oe},ye.heading=function(oe,ue,fe,we){return this.options.headerIds?"<h"+ue+' id="'+this.options.headerPrefix+we.slug(fe)+'">'+oe+"</h"+ue+`>
`:"<h"+ue+">"+oe+"</h"+ue+`>
`},ye.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},ye.list=function(oe,ue,fe){var we=ue?"ol":"ul",q=ue&&fe!==1?' start="'+fe+'"':"";return"<"+we+q+`>
`+oe+"</"+we+`>
`},ye.listitem=function(oe){return"<li>"+oe+`</li>
`},ye.checkbox=function(oe){return"<input "+(oe?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},ye.paragraph=function(oe){return"<p>"+oe+`</p>
`},ye.table=function(oe,ue){return ue&&(ue="<tbody>"+ue+"</tbody>"),`<table>
<thead>
`+oe+`</thead>
`+ue+`</table>
`},ye.tablerow=function(oe){return`<tr>
`+oe+`</tr>
`},ye.tablecell=function(oe,ue){var fe=ue.header?"th":"td",we=ue.align?"<"+fe+' align="'+ue.align+'">':"<"+fe+">";return we+oe+"</"+fe+`>
`},ye.strong=function(oe){return"<strong>"+oe+"</strong>"},ye.em=function(oe){return"<em>"+oe+"</em>"},ye.codespan=function(oe){return"<code>"+oe+"</code>"},ye.br=function(){return this.options.xhtml?"<br/>":"<br>"},ye.del=function(oe){return"<del>"+oe+"</del>"},ye.link=function(oe,ue,fe){if(oe=Z(this.options.sanitize,this.options.baseUrl,oe),oe===null)return fe;var we='<a href="'+ne(oe)+'"';return ue&&(we+=' title="'+ue+'"'),we+=">"+fe+"</a>",we},ye.image=function(oe,ue,fe){if(oe=Z(this.options.sanitize,this.options.baseUrl,oe),oe===null)return fe;var we='<img src="'+oe+'" alt="'+fe+'"';return ue&&(we+=' title="'+ue+'"'),we+=this.options.xhtml?"/>":">",we},ye.text=function(oe){return oe},ke}(),J=function(){function ke(){}var ye=ke.prototype;return ye.strong=function(oe){return oe},ye.em=function(oe){return oe},ye.codespan=function(oe){return oe},ye.del=function(oe){return oe},ye.html=function(oe){return oe},ye.text=function(oe){return oe},ye.link=function(oe,ue,fe){return""+fe},ye.image=function(oe,ue,fe){return""+fe},ye.br=function(){return""},ke}(),ae=function(){function ke(){this.seen={}}var ye=ke.prototype;return ye.serialize=function(oe){return oe.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},ye.getNextSafeSlug=function(oe,ue){var fe=oe,we=0;if(this.seen.hasOwnProperty(fe)){we=this.seen[oe];do we++,fe=oe+"-"+we;while(this.seen.hasOwnProperty(fe))}return ue||(this.seen[oe]=we,this.seen[fe]=0),fe},ye.slug=function(oe,ue){ue===void 0&&(ue={});var fe=this.serialize(oe);return this.getNextSafeSlug(fe,ue.dryrun)},ke}(),he=A.defaults,Fe=L.unescape,He=function(){function ke(Ae){this.options=Ae||he,this.options.renderer=this.options.renderer||new se,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new J,this.slugger=new ae}ke.parse=function(oe,ue){var fe=new ke(ue);return fe.parse(oe)},ke.parseInline=function(oe,ue){var fe=new ke(ue);return fe.parseInline(oe)};var ye=ke.prototype;return ye.parse=function(oe,ue){ue===void 0&&(ue=!0);var fe="",we,q,pe,Se,Te,Oe,je,qe,Ze,nt,ct,Ee,Ce,ce,Q,Be,De,Ke,et=oe.length;for(we=0;we<et;we++)switch(nt=oe[we],nt.type){case"space":continue;case"hr":{fe+=this.renderer.hr();continue}case"heading":{fe+=this.renderer.heading(this.parseInline(nt.tokens),nt.depth,Fe(this.parseInline(nt.tokens,this.textRenderer)),this.slugger);continue}case"code":{fe+=this.renderer.code(nt.text,nt.lang,nt.escaped);continue}case"table":{for(qe="",je="",Se=nt.header.length,q=0;q<Se;q++)je+=this.renderer.tablecell(this.parseInline(nt.tokens.header[q]),{header:!0,align:nt.align[q]});for(qe+=this.renderer.tablerow(je),Ze="",Se=nt.cells.length,q=0;q<Se;q++){for(Oe=nt.tokens.cells[q],je="",Te=Oe.length,pe=0;pe<Te;pe++)je+=this.renderer.tablecell(this.parseInline(Oe[pe]),{header:!1,align:nt.align[pe]});Ze+=this.renderer.tablerow(je)}fe+=this.renderer.table(qe,Ze);continue}case"blockquote":{Ze=this.parse(nt.tokens),fe+=this.renderer.blockquote(Ze);continue}case"list":{for(ct=nt.ordered,Ee=nt.start,Ce=nt.loose,Se=nt.items.length,Ze="",q=0;q<Se;q++)Q=nt.items[q],Be=Q.checked,De=Q.task,ce="",Q.task&&(Ke=this.renderer.checkbox(Be),Ce?Q.tokens.length>0&&Q.tokens[0].type==="text"?(Q.tokens[0].text=Ke+" "+Q.tokens[0].text,Q.tokens[0].tokens&&Q.tokens[0].tokens.length>0&&Q.tokens[0].tokens[0].type==="text"&&(Q.tokens[0].tokens[0].text=Ke+" "+Q.tokens[0].tokens[0].text)):Q.tokens.unshift({type:"text",text:Ke}):ce+=Ke),ce+=this.parse(Q.tokens,Ce),Ze+=this.renderer.listitem(ce,De,Be);fe+=this.renderer.list(Ze,ct,Ee);continue}case"html":{fe+=this.renderer.html(nt.text);continue}case"paragraph":{fe+=this.renderer.paragraph(this.parseInline(nt.tokens));continue}case"text":{for(Ze=nt.tokens?this.parseInline(nt.tokens):nt.text;we+1<et&&oe[we+1].type==="text";)nt=oe[++we],Ze+=`
`+(nt.tokens?this.parseInline(nt.tokens):nt.text);fe+=ue?this.renderer.paragraph(Ze):Ze;continue}default:{var tt='Token with "'+nt.type+'" type was not found.';if(this.options.silent){console.error(tt);return}else throw new Error(tt)}}return fe},ye.parseInline=function(oe,ue){ue=ue||this.renderer;var fe="",we,q,pe=oe.length;for(we=0;we<pe;we++)switch(q=oe[we],q.type){case"escape":{fe+=ue.text(q.text);break}case"html":{fe+=ue.html(q.text);break}case"link":{fe+=ue.link(q.href,q.title,this.parseInline(q.tokens,ue));break}case"image":{fe+=ue.image(q.href,q.title,q.text);break}case"strong":{fe+=ue.strong(this.parseInline(q.tokens,ue));break}case"em":{fe+=ue.em(this.parseInline(q.tokens,ue));break}case"codespan":{fe+=ue.codespan(q.text);break}case"br":{fe+=ue.br();break}case"del":{fe+=ue.del(this.parseInline(q.tokens,ue));break}case"text":{fe+=ue.text(q.text);break}default:{var Se='Token with "'+q.type+'" type was not found.';if(this.options.silent){console.error(Se);return}else throw new Error(Se)}}return fe},ke}(),_e=L.merge,Ye=L.checkSanitizeDeprecation,K=L.escape,ie=A.getDefaults,ve=A.changeDefaults,Me=A.defaults;function xe(ke,ye,Ae){if(typeof ke=="undefined"||ke===null)throw new Error("marked(): input parameter is undefined or null");if(typeof ke!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(ke)+", string expected");if(typeof ye=="function"&&(Ae=ye,ye=null),ye=_e({},xe.defaults,ye||{}),Ye(ye),Ae){var oe=ye.highlight,ue;try{ue=Ge.lex(ke,ye)}catch(pe){return Ae(pe)}var fe=function(Se){var Te;if(!Se)try{Te=He.parse(ue,ye)}catch(Oe){Se=Oe}return ye.highlight=oe,Se?Ae(Se):Ae(null,Te)};if(!oe||oe.length<3||(delete ye.highlight,!ue.length))return fe();var we=0;xe.walkTokens(ue,function(pe){pe.type==="code"&&(we++,setTimeout(function(){oe(pe.text,pe.lang,function(Se,Te){if(Se)return fe(Se);Te!=null&&Te!==pe.text&&(pe.text=Te,pe.escaped=!0),we--,we===0&&fe()})},0))}),we===0&&fe();return}try{var q=Ge.lex(ke,ye);return ye.walkTokens&&xe.walkTokens(q,ye.walkTokens),He.parse(q,ye)}catch(pe){if(pe.message+=`
Please report this to https://github.com/markedjs/marked.`,ye.silent)return"<p>An error occurred:</p><pre>"+K(pe.message+"",!0)+"</pre>";throw pe}}xe.options=xe.setOptions=function(ke){return _e(xe.defaults,ke),ve(xe.defaults),xe},xe.getDefaults=ie,xe.defaults=Me,xe.use=function(ke){var ye=_e({},ke);if(ke.renderer&&function(){var oe=xe.defaults.renderer||new se,ue=function(q){var pe=oe[q];oe[q]=function(){for(var Se=arguments.length,Te=new Array(Se),Oe=0;Oe<Se;Oe++)Te[Oe]=arguments[Oe];var je=ke.renderer[q].apply(oe,Te);return je===!1&&(je=pe.apply(oe,Te)),je}};for(var fe in ke.renderer)ue(fe);ye.renderer=oe}(),ke.tokenizer&&function(){var oe=xe.defaults.tokenizer||new j,ue=function(q){var pe=oe[q];oe[q]=function(){for(var Se=arguments.length,Te=new Array(Se),Oe=0;Oe<Se;Oe++)Te[Oe]=arguments[Oe];var je=ke.tokenizer[q].apply(oe,Te);return je===!1&&(je=pe.apply(oe,Te)),je}};for(var fe in ke.tokenizer)ue(fe);ye.tokenizer=oe}(),ke.walkTokens){var Ae=xe.defaults.walkTokens;ye.walkTokens=function(oe){ke.walkTokens(oe),Ae&&Ae(oe)}}xe.setOptions(ye)},xe.walkTokens=function(ke,ye){for(var Ae=C(ke),oe;!(oe=Ae()).done;){var ue=oe.value;switch(ye(ue),ue.type){case"table":{for(var fe=C(ue.tokens.header),we;!(we=fe()).done;){var q=we.value;xe.walkTokens(q,ye)}for(var pe=C(ue.tokens.cells),Se;!(Se=pe()).done;)for(var Te=Se.value,Oe=C(Te),je;!(je=Oe()).done;){var qe=je.value;xe.walkTokens(qe,ye)}break}case"list":{xe.walkTokens(ue.items,ye);break}default:ue.tokens&&xe.walkTokens(ue.tokens,ye)}}},xe.parseInline=function(ke,ye){if(typeof ke=="undefined"||ke===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof ke!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(ke)+", string expected");ye=_e({},xe.defaults,ye||{}),Ye(ye);try{var Ae=Ge.lexInline(ke,ye);return ye.walkTokens&&xe.walkTokens(Ae,ye.walkTokens),He.parseInline(Ae,ye)}catch(oe){if(oe.message+=`
Please report this to https://github.com/markedjs/marked.`,ye.silent)return"<p>An error occurred:</p><pre>"+K(oe.message+"",!0)+"</pre>";throw oe}},xe.Parser=He,xe.parser=He.parse,xe.Renderer=se,xe.TextRenderer=J,xe.Lexer=Ge,xe.lexer=Ge.lex,xe.Tokenizer=j,xe.Slugger=ae,xe.parse=xe;var Je=xe;return Je}),define(me[72],ge([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MovingAverage=e.Counter=e.rot=e.clamp=void 0;function p(A,P,E){return Math.min(Math.max(A,P),E)}e.clamp=p;function R(A,P){return(P+A%P)%P}e.rot=R;class C{constructor(){this._next=0}getNext(){return this._next++}}e.Counter=C;class y{constructor(){this._n=1,this._val=0}update(P){return this._val=this._val+(P-this._val)/this._n,this._n+=1,this}get value(){return this._val}}e.MovingAverage=y}),function(){function X(C){const y=[];typeof C=="number"&&y.push("code/timeOrigin",C);function A(E){y.push(E,Date.now())}function P(){const E=[];for(let k=0;k<y.length;k+=2)E.push({name:y[k],startTime:y[k+1]});return E}return{mark:A,getMarks:P}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function")return typeof performance.timeOrigin!="number"&&!performance.timing?X():{mark(C){performance.mark(C)},getMarks(){let C=performance.timeOrigin;typeof C!="number"&&(C=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const y=[{name:"code/timeOrigin",startTime:Math.round(C)}];for(const A of performance.getEntriesByType("mark"))y.push({name:A.name,startTime:Math.round(C+A.startTime)});return y}};if(typeof process=="object"){const C=Math.round((require.nodeRequire||require)("perf_hooks").performance.timeOrigin);return X(C)}else return console.trace("perf-util loaded in UNKNOWN environment"),X()}function p(C){return C.MonacoPerformanceMarks||(C.MonacoPerformanceMarks=e()),C.MonacoPerformanceMarks}var R;typeof global=="object"?R=global:typeof self=="object"?R=self:R={},typeof define=="function"?define("vs/base/common/performance",[],function(){return p(R)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=p(R):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),R.perf=p(R))}(),define(me[11],ge([0,1]),function(X,e){"use strict";var p;Object.defineProperty(e,"__esModule",{value:!0}),e.isLittleEndian=e.OS=e.OperatingSystem=e.setImmediate=e.translationsConfigFile=e.locale=e.Language=e.language=e.userAgent=e.platform=e.isIOS=e.isWeb=e.isNative=e.isLinuxSnap=e.isLinux=e.isMacintosh=e.isWindows=e.PlatformToString=e.Platform=e.isPreferringBrowserCodeLoad=e.browserCodeLoadingCacheStrategy=e.isElectronSandboxed=e.globals=void 0;const R="en";let C=!1,y=!1,A=!1,P=!1,E=!1,k=!1,r=!1,I,l=R,f,c;e.globals=typeof self=="object"?self:typeof global=="object"?global:{};let u;typeof e.globals.vscode!="undefined"&&typeof e.globals.vscode.process!="undefined"?u=e.globals.vscode.process:typeof process!="undefined"&&(u=process);const S=typeof((p=u==null?void 0:u.versions)===null||p===void 0?void 0:p.electron)=="string"&&u.type==="renderer";if(e.isElectronSandboxed=S&&(u==null?void 0:u.sandboxed),e.browserCodeLoadingCacheStrategy=(()=>{if(e.isElectronSandboxed)return"bypassHeatCheck";const n=u==null?void 0:u.env.VSCODE_BROWSER_CODE_LOADING;if(typeof n=="string")return n==="none"||n==="code"||n==="bypassHeatCheck"||n==="bypassHeatCheckAndEagerCompile"?n:"bypassHeatCheck"})(),e.isPreferringBrowserCodeLoad=typeof e.browserCodeLoadingCacheStrategy=="string",typeof navigator=="object"&&!S)c=navigator.userAgent,C=c.indexOf("Windows")>=0,y=c.indexOf("Macintosh")>=0,r=(c.indexOf("Macintosh")>=0||c.indexOf("iPad")>=0||c.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,A=c.indexOf("Linux")>=0,k=!0,I=navigator.language,l=I;else if(typeof u=="object"){C=u.platform==="win32",y=u.platform==="darwin",A=u.platform==="linux",P=A&&!!u.env.SNAP&&!!u.env.SNAP_REVISION,I=R,l=R;const n=u.env.VSCODE_NLS_CONFIG;if(n)try{const o=JSON.parse(n),v=o.availableLanguages["*"];I=o.locale,l=v||R,f=o._translationsConfigFile}catch(o){}E=!0}else console.error("Unable to resolve platform.");var w;(function(n){n[n.Web=0]="Web",n[n.Mac=1]="Mac",n[n.Linux=2]="Linux",n[n.Windows=3]="Windows"})(w=e.Platform||(e.Platform={}));function b(n){switch(n){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.PlatformToString=b;let d=0;y?d=1:C?d=3:A&&(d=2),e.isWindows=C,e.isMacintosh=y,e.isLinux=A,e.isLinuxSnap=P,e.isNative=E,e.isWeb=k,e.isIOS=r,e.platform=d,e.userAgent=c,e.language=l;var h;(function(n){function o(){return e.language}n.value=o;function v(){return e.language.length===2?e.language==="en":e.language.length>=3?e.language[0]==="e"&&e.language[1]==="n"&&e.language[2]==="-":!1}n.isDefaultVariant=v;function m(){return e.language==="en"}n.isDefault=m})(h=e.Language||(e.Language={})),e.locale=I,e.translationsConfigFile=f,e.setImmediate=function(){if(e.globals.setImmediate)return e.globals.setImmediate.bind(e.globals);if(typeof e.globals.postMessage=="function"&&!e.globals.importScripts){let v=[];e.globals.addEventListener("message",_=>{if(_.data&&_.data.vscodeSetImmediateId)for(let D=0,a=v.length;D<a;D++){const T=v[D];if(T.id===_.data.vscodeSetImmediateId){v.splice(D,1),T.callback();return}}});let m=0;return _=>{const D=++m;v.push({id:D,callback:_}),e.globals.postMessage({vscodeSetImmediateId:D},"*")}}if(typeof(u==null?void 0:u.nextTick)=="function")return u.nextTick.bind(u);const o=Promise.resolve();return v=>o.then(v)}();var g;(function(n){n[n.Windows=1]="Windows",n[n.Macintosh=2]="Macintosh",n[n.Linux=3]="Linux"})(g=e.OperatingSystem||(e.OperatingSystem={})),e.OS=y||r?2:C?1:3;let t=!0,i=!1;function s(){if(!i){i=!0;const n=new Uint8Array(2);n[0]=1,n[1]=2,t=new Uint16Array(n.buffer)[0]===(2<<8)+1}return t}e.isLittleEndian=s}),define(me[37],ge([0,1,11]),function(X,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.nextTick=e.platform=e.env=e.cwd=void 0;let R;if(typeof p.globals.vscode!="undefined"&&typeof p.globals.vscode.process!="undefined"){const C=p.globals.vscode.process;R={get platform(){return C.platform},get env(){return C.env},cwd(){return C.cwd()},nextTick(y){return p.setImmediate(y)}}}else typeof process!="undefined"?R={get platform(){return process.platform},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()},nextTick(C){return process.nextTick(C)}}:R={get platform(){return p.isWindows?"win32":p.isMacintosh?"darwin":"linux"},nextTick(C){return p.setImmediate(C)},get env(){return{}},cwd(){return"/"}};e.cwd=R.cwd,e.env=R.env,e.platform=R.platform,e.nextTick=R.nextTick}),define(me[9],ge([0,1,37]),function(X,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.delimiter=e.sep=e.toNamespacedPath=e.parse=e.format=e.extname=e.basename=e.dirname=e.relative=e.resolve=e.join=e.isAbsolute=e.normalize=e.posix=e.win32=void 0;const R=65,C=97,y=90,A=122,P=46,E=47,k=92,r=58,I=63;class l extends Error{constructor(h,g,t){let i;typeof g=="string"&&g.indexOf("not ")===0?(i="must not be",g=g.replace(/^not /,"")):i="must be";const s=h.indexOf(".")!==-1?"property":"argument";let n=`The "${h}" ${s} ${i} of type ${g}`;n+=`. Received type ${typeof t}`,super(n),this.code="ERR_INVALID_ARG_TYPE"}}function f(d,h){if(typeof d!="string")throw new l(h,"string",d)}function c(d){return d===E||d===k}function u(d){return d===E}function S(d){return d>=R&&d<=y||d>=C&&d<=A}function w(d,h,g,t){let i="",s=0,n=-1,o=0,v=0;for(let m=0;m<=d.length;++m){if(m<d.length)v=d.charCodeAt(m);else{if(t(v))break;v=E}if(t(v)){if(!(n===m-1||o===1))if(o===2){if(i.length<2||s!==2||i.charCodeAt(i.length-1)!==P||i.charCodeAt(i.length-2)!==P){if(i.length>2){const _=i.lastIndexOf(g);_===-1?(i="",s=0):(i=i.slice(0,_),s=i.length-1-i.lastIndexOf(g)),n=m,o=0;continue}else if(i.length!==0){i="",s=0,n=m,o=0;continue}}h&&(i+=i.length>0?`${g}..`:"..",s=2)}else i.length>0?i+=`${g}${d.slice(n+1,m)}`:i=d.slice(n+1,m),s=m-n-1;n=m,o=0}else v===P&&o!==-1?++o:o=-1}return i}function b(d,h){if(h===null||typeof h!="object")throw new l("pathObject","Object",h);const g=h.dir||h.root,t=h.base||`${h.name||""}${h.ext||""}`;return g?g===h.root?`${g}${t}`:`${g}${d}${t}`:t}e.win32={resolve(...d){let h="",g="",t=!1;for(let i=d.length-1;i>=-1;i--){let s;if(i>=0){if(s=d[i],f(s,"path"),s.length===0)continue}else h.length===0?s=p.cwd():(s=p.env[`=${h}`]||p.cwd(),(s===void 0||s.slice(0,2).toLowerCase()!==h.toLowerCase()&&s.charCodeAt(2)===k)&&(s=`${h}\\`));const n=s.length;let o=0,v="",m=!1;const _=s.charCodeAt(0);if(n===1)c(_)&&(o=1,m=!0);else if(c(_))if(m=!0,c(s.charCodeAt(1))){let D=2,a=D;for(;D<n&&!c(s.charCodeAt(D));)D++;if(D<n&&D!==a){const T=s.slice(a,D);for(a=D;D<n&&c(s.charCodeAt(D));)D++;if(D<n&&D!==a){for(a=D;D<n&&!c(s.charCodeAt(D));)D++;(D===n||D!==a)&&(v=`\\\\${T}\\${s.slice(a,D)}`,o=D)}}}else o=1;else S(_)&&s.charCodeAt(1)===r&&(v=s.slice(0,2),o=2,n>2&&c(s.charCodeAt(2))&&(m=!0,o=3));if(v.length>0)if(h.length>0){if(v.toLowerCase()!==h.toLowerCase())continue}else h=v;if(t){if(h.length>0)break}else if(g=`${s.slice(o)}\\${g}`,t=m,m&&h.length>0)break}return g=w(g,!t,"\\",c),t?`${h}\\${g}`:`${h}${g}`||"."},normalize(d){f(d,"path");const h=d.length;if(h===0)return".";let g=0,t,i=!1;const s=d.charCodeAt(0);if(h===1)return u(s)?"\\":d;if(c(s))if(i=!0,c(d.charCodeAt(1))){let o=2,v=o;for(;o<h&&!c(d.charCodeAt(o));)o++;if(o<h&&o!==v){const m=d.slice(v,o);for(v=o;o<h&&c(d.charCodeAt(o));)o++;if(o<h&&o!==v){for(v=o;o<h&&!c(d.charCodeAt(o));)o++;if(o===h)return`\\\\${m}\\${d.slice(v)}\\`;o!==v&&(t=`\\\\${m}\\${d.slice(v,o)}`,g=o)}}}else g=1;else S(s)&&d.charCodeAt(1)===r&&(t=d.slice(0,2),g=2,h>2&&c(d.charCodeAt(2))&&(i=!0,g=3));let n=g<h?w(d.slice(g),!i,"\\",c):"";return n.length===0&&!i&&(n="."),n.length>0&&c(d.charCodeAt(h-1))&&(n+="\\"),t===void 0?i?`\\${n}`:n:i?`${t}\\${n}`:`${t}${n}`},isAbsolute(d){f(d,"path");const h=d.length;if(h===0)return!1;const g=d.charCodeAt(0);return c(g)||h>2&&S(g)&&d.charCodeAt(1)===r&&c(d.charCodeAt(2))},join(...d){if(d.length===0)return".";let h,g;for(let s=0;s<d.length;++s){const n=d[s];f(n,"path"),n.length>0&&(h===void 0?h=g=n:h+=`\\${n}`)}if(h===void 0)return".";let t=!0,i=0;if(typeof g=="string"&&c(g.charCodeAt(0))){++i;const s=g.length;s>1&&c(g.charCodeAt(1))&&(++i,s>2&&(c(g.charCodeAt(2))?++i:t=!1))}if(t){for(;i<h.length&&c(h.charCodeAt(i));)i++;i>=2&&(h=`\\${h.slice(i)}`)}return e.win32.normalize(h)},relative(d,h){if(f(d,"from"),f(h,"to"),d===h)return"";const g=e.win32.resolve(d),t=e.win32.resolve(h);if(g===t||(d=g.toLowerCase(),h=t.toLowerCase(),d===h))return"";let i=0;for(;i<d.length&&d.charCodeAt(i)===k;)i++;let s=d.length;for(;s-1>i&&d.charCodeAt(s-1)===k;)s--;const n=s-i;let o=0;for(;o<h.length&&h.charCodeAt(o)===k;)o++;let v=h.length;for(;v-1>o&&h.charCodeAt(v-1)===k;)v--;const m=v-o,_=n<m?n:m;let D=-1,a=0;for(;a<_;a++){const L=d.charCodeAt(i+a);if(L!==h.charCodeAt(o+a))break;L===k&&(D=a)}if(a!==_){if(D===-1)return t}else{if(m>_){if(h.charCodeAt(o+a)===k)return t.slice(o+a+1);if(a===2)return t.slice(o+a)}n>_&&(d.charCodeAt(i+a)===k?D=a:a===2&&(D=3)),D===-1&&(D=0)}let T="";for(a=i+D+1;a<=s;++a)(a===s||d.charCodeAt(a)===k)&&(T+=T.length===0?"..":"\\..");return o+=D,T.length>0?`${T}${t.slice(o,v)}`:(t.charCodeAt(o)===k&&++o,t.slice(o,v))},toNamespacedPath(d){if(typeof d!="string")return d;if(d.length===0)return"";const h=e.win32.resolve(d);if(h.length<=2)return d;if(h.charCodeAt(0)===k){if(h.charCodeAt(1)===k){const g=h.charCodeAt(2);if(g!==I&&g!==P)return`\\\\?\\UNC\\${h.slice(2)}`}}else if(S(h.charCodeAt(0))&&h.charCodeAt(1)===r&&h.charCodeAt(2)===k)return`\\\\?\\${h}`;return d},dirname(d){f(d,"path");const h=d.length;if(h===0)return".";let g=-1,t=0;const i=d.charCodeAt(0);if(h===1)return c(i)?d:".";if(c(i)){if(g=t=1,c(d.charCodeAt(1))){let o=2,v=o;for(;o<h&&!c(d.charCodeAt(o));)o++;if(o<h&&o!==v){for(v=o;o<h&&c(d.charCodeAt(o));)o++;if(o<h&&o!==v){for(v=o;o<h&&!c(d.charCodeAt(o));)o++;if(o===h)return d;o!==v&&(g=t=o+1)}}}}else S(i)&&d.charCodeAt(1)===r&&(g=h>2&&c(d.charCodeAt(2))?3:2,t=g);let s=-1,n=!0;for(let o=h-1;o>=t;--o)if(c(d.charCodeAt(o))){if(!n){s=o;break}}else n=!1;if(s===-1){if(g===-1)return".";s=g}return d.slice(0,s)},basename(d,h){h!==void 0&&f(h,"ext"),f(d,"path");let g=0,t=-1,i=!0,s;if(d.length>=2&&S(d.charCodeAt(0))&&d.charCodeAt(1)===r&&(g=2),h!==void 0&&h.length>0&&h.length<=d.length){if(h===d)return"";let n=h.length-1,o=-1;for(s=d.length-1;s>=g;--s){const v=d.charCodeAt(s);if(c(v)){if(!i){g=s+1;break}}else o===-1&&(i=!1,o=s+1),n>=0&&(v===h.charCodeAt(n)?--n==-1&&(t=s):(n=-1,t=o))}return g===t?t=o:t===-1&&(t=d.length),d.slice(g,t)}for(s=d.length-1;s>=g;--s)if(c(d.charCodeAt(s))){if(!i){g=s+1;break}}else t===-1&&(i=!1,t=s+1);return t===-1?"":d.slice(g,t)},extname(d){f(d,"path");let h=0,g=-1,t=0,i=-1,s=!0,n=0;d.length>=2&&d.charCodeAt(1)===r&&S(d.charCodeAt(0))&&(h=t=2);for(let o=d.length-1;o>=h;--o){const v=d.charCodeAt(o);if(c(v)){if(!s){t=o+1;break}continue}i===-1&&(s=!1,i=o+1),v===P?g===-1?g=o:n!==1&&(n=1):g!==-1&&(n=-1)}return g===-1||i===-1||n===0||n===1&&g===i-1&&g===t+1?"":d.slice(g,i)},format:b.bind(null,"\\"),parse(d){f(d,"path");const h={root:"",dir:"",base:"",ext:"",name:""};if(d.length===0)return h;const g=d.length;let t=0,i=d.charCodeAt(0);if(g===1)return c(i)?(h.root=h.dir=d,h):(h.base=h.name=d,h);if(c(i)){if(t=1,c(d.charCodeAt(1))){let D=2,a=D;for(;D<g&&!c(d.charCodeAt(D));)D++;if(D<g&&D!==a){for(a=D;D<g&&c(d.charCodeAt(D));)D++;if(D<g&&D!==a){for(a=D;D<g&&!c(d.charCodeAt(D));)D++;D===g?t=D:D!==a&&(t=D+1)}}}}else if(S(i)&&d.charCodeAt(1)===r){if(g<=2)return h.root=h.dir=d,h;if(t=2,c(d.charCodeAt(2))){if(g===3)return h.root=h.dir=d,h;t=3}}t>0&&(h.root=d.slice(0,t));let s=-1,n=t,o=-1,v=!0,m=d.length-1,_=0;for(;m>=t;--m){if(i=d.charCodeAt(m),c(i)){if(!v){n=m+1;break}continue}o===-1&&(v=!1,o=m+1),i===P?s===-1?s=m:_!==1&&(_=1):s!==-1&&(_=-1)}return o!==-1&&(s===-1||_===0||_===1&&s===o-1&&s===n+1?h.base=h.name=d.slice(n,o):(h.name=d.slice(n,s),h.base=d.slice(n,o),h.ext=d.slice(s,o))),n>0&&n!==t?h.dir=d.slice(0,n-1):h.dir=h.root,h},sep:"\\",delimiter:";",win32:null,posix:null},e.posix={resolve(...d){let h="",g=!1;for(let t=d.length-1;t>=-1&&!g;t--){const i=t>=0?d[t]:p.cwd();f(i,"path"),i.length!==0&&(h=`${i}/${h}`,g=i.charCodeAt(0)===E)}return h=w(h,!g,"/",u),g?`/${h}`:h.length>0?h:"."},normalize(d){if(f(d,"path"),d.length===0)return".";const h=d.charCodeAt(0)===E,g=d.charCodeAt(d.length-1)===E;return d=w(d,!h,"/",u),d.length===0?h?"/":g?"./":".":(g&&(d+="/"),h?`/${d}`:d)},isAbsolute(d){return f(d,"path"),d.length>0&&d.charCodeAt(0)===E},join(...d){if(d.length===0)return".";let h;for(let g=0;g<d.length;++g){const t=d[g];f(t,"path"),t.length>0&&(h===void 0?h=t:h+=`/${t}`)}return h===void 0?".":e.posix.normalize(h)},relative(d,h){if(f(d,"from"),f(h,"to"),d===h||(d=e.posix.resolve(d),h=e.posix.resolve(h),d===h))return"";const g=1,t=d.length,i=t-g,s=1,n=h.length-s,o=i<n?i:n;let v=-1,m=0;for(;m<o;m++){const D=d.charCodeAt(g+m);if(D!==h.charCodeAt(s+m))break;D===E&&(v=m)}if(m===o)if(n>o){if(h.charCodeAt(s+m)===E)return h.slice(s+m+1);if(m===0)return h.slice(s+m)}else i>o&&(d.charCodeAt(g+m)===E?v=m:m===0&&(v=0));let _="";for(m=g+v+1;m<=t;++m)(m===t||d.charCodeAt(m)===E)&&(_+=_.length===0?"..":"/..");return`${_}${h.slice(s+v)}`},toNamespacedPath(d){return d},dirname(d){if(f(d,"path"),d.length===0)return".";const h=d.charCodeAt(0)===E;let g=-1,t=!0;for(let i=d.length-1;i>=1;--i)if(d.charCodeAt(i)===E){if(!t){g=i;break}}else t=!1;return g===-1?h?"/":".":h&&g===1?"//":d.slice(0,g)},basename(d,h){h!==void 0&&f(h,"ext"),f(d,"path");let g=0,t=-1,i=!0,s;if(h!==void 0&&h.length>0&&h.length<=d.length){if(h===d)return"";let n=h.length-1,o=-1;for(s=d.length-1;s>=0;--s){const v=d.charCodeAt(s);if(v===E){if(!i){g=s+1;break}}else o===-1&&(i=!1,o=s+1),n>=0&&(v===h.charCodeAt(n)?--n==-1&&(t=s):(n=-1,t=o))}return g===t?t=o:t===-1&&(t=d.length),d.slice(g,t)}for(s=d.length-1;s>=0;--s)if(d.charCodeAt(s)===E){if(!i){g=s+1;break}}else t===-1&&(i=!1,t=s+1);return t===-1?"":d.slice(g,t)},extname(d){f(d,"path");let h=-1,g=0,t=-1,i=!0,s=0;for(let n=d.length-1;n>=0;--n){const o=d.charCodeAt(n);if(o===E){if(!i){g=n+1;break}continue}t===-1&&(i=!1,t=n+1),o===P?h===-1?h=n:s!==1&&(s=1):h!==-1&&(s=-1)}return h===-1||t===-1||s===0||s===1&&h===t-1&&h===g+1?"":d.slice(h,t)},format:b.bind(null,"/"),parse(d){f(d,"path");const h={root:"",dir:"",base:"",ext:"",name:""};if(d.length===0)return h;const g=d.charCodeAt(0)===E;let t;g?(h.root="/",t=1):t=0;let i=-1,s=0,n=-1,o=!0,v=d.length-1,m=0;for(;v>=t;--v){const _=d.charCodeAt(v);if(_===E){if(!o){s=v+1;break}continue}n===-1&&(o=!1,n=v+1),_===P?i===-1?i=v:m!==1&&(m=1):i!==-1&&(m=-1)}if(n!==-1){const _=s===0&&g?1:s;i===-1||m===0||m===1&&i===n-1&&i===s+1?h.base=h.name=d.slice(_,n):(h.name=d.slice(_,i),h.base=d.slice(_,n),h.ext=d.slice(i,n))}return s>0?h.dir=d.slice(0,s-1):g&&(h.dir="/"),h},sep:"/",delimiter:":",win32:null,posix:null},e.posix.win32=e.win32.win32=e.win32,e.posix.posix=e.win32.posix=e.posix,e.normalize=p.platform==="win32"?e.win32.normalize:e.posix.normalize,e.isAbsolute=p.platform==="win32"?e.win32.isAbsolute:e.posix.isAbsolute,e.join=p.platform==="win32"?e.win32.join:e.posix.join,e.resolve=p.platform==="win32"?e.win32.resolve:e.posix.resolve,e.relative=p.platform==="win32"?e.win32.relative:e.posix.relative,e.dirname=p.platform==="win32"?e.win32.dirname:e.posix.dirname,e.basename=p.platform==="win32"?e.win32.basename:e.posix.basename,e.extname=p.platform==="win32"?e.win32.extname:e.posix.extname,e.format=p.platform==="win32"?e.win32.format:e.posix.format,e.parse=p.platform==="win32"?e.win32.parse:e.posix.parse,e.toNamespacedPath=p.platform==="win32"?e.win32.toNamespacedPath:e.posix.toNamespacedPath,e.sep=p.platform==="win32"?e.win32.sep:e.posix.sep,e.delimiter=p.platform==="win32"?e.win32.delimiter:e.posix.delimiter}),define(me[135],ge([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.sanitizeProcessEnvironment=e.TerminateResponseCode=e.Source=void 0;var p;(function(y){y[y.stdout=0]="stdout",y[y.stderr=1]="stderr"})(p=e.Source||(e.Source={}));var R;(function(y){y[y.Success=0]="Success",y[y.Unknown=1]="Unknown",y[y.AccessDenied=2]="AccessDenied",y[y.ProcessNotFound=3]="ProcessNotFound"})(R=e.TerminateResponseCode||(e.TerminateResponseCode={}));function C(y,...A){const P=A.reduce((r,I)=>(r[I]=!0,r),{}),E=[/^ELECTRON_.+$/,/^VSCODE_.+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(y).filter(r=>!P[r]).forEach(r=>{for(let I=0;I<E.length;I++)if(r.search(E[I])!==-1){delete y[r];break}})}e.sanitizeProcessEnvironment=C}),define(me[43],ge([0,1,11]),function(X,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StopWatch=void 0;const R=p.globals.performance&&typeof p.globals.performance.now=="function";class C{constructor(A){this._highResolution=R&&A,this._startTime=this._now(),this._stopTime=-1}static create(A=!0){return new C(A)}stop(){this._stopTime=this._now()}elapsed(){return this._stopTime!==-1?this._stopTime-this._startTime:this._now()-this._startTime}_now(){return this._highResolution?p.globals.performance.now():Date.now()}}e.StopWatch=C}),define(me[3],ge([0,1,14,69,6,71,43]),function(X,e,p,R,C,y,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Relay=e.EventBufferer=e.EventMultiplexer=e.DebounceEmitter=e.PauseableEmitter=e.Emitter=e.setGlobalLeakWarningThreshold=e.Event=void 0;var P;(function(b){b.None=()=>C.Disposable.None;function d(ee){return(z,N=null,W)=>{let M=!1,j;return j=ee(O=>{if(!M)return j?j.dispose():M=!0,z.call(N,O)},null,W),M&&j.dispose(),j}}b.once=d;function h(ee,z){return o((N,W=null,M)=>ee(j=>N.call(W,z(j)),null,M))}b.map=h;function g(ee,z){return o((N,W=null,M)=>ee(j=>{z(j),N.call(W,j)},null,M))}b.forEach=g;function t(ee,z){return o((N,W=null,M)=>ee(j=>z(j)&&N.call(W,j),null,M))}b.filter=t;function i(ee){return ee}b.signal=i;function s(...ee){return(z,N=null,W)=>C.combinedDisposable(...ee.map(M=>M(j=>z.call(N,j),null,W)))}b.any=s;function n(ee,z,N){let W=N;return h(ee,M=>(W=z(W,M),W))}b.reduce=n;function o(ee){let z;const N=new l({onFirstListenerAdd(){z=ee(N.fire,N)},onLastListenerRemove(){z.dispose()}});return N.event}function v(ee,z,N=100,W=!1,M){let j,O,F,B=0;const $=new l({leakWarningThreshold:M,onFirstListenerAdd(){j=ee(Y=>{B++,O=z(O,Y),W&&!F&&($.fire(O),O=void 0),clearTimeout(F),F=setTimeout(()=>{const le=O;O=void 0,F=void 0,(!W||B>1)&&$.fire(le),B=0},N)})},onLastListenerRemove(){j.dispose()}});return $.event}b.debounce=v;function m(ee,z=(N,W)=>N===W){let N=!0,W;return t(ee,M=>{const j=N||!z(M,W);return N=!1,W=M,j})}b.latch=m;function _(ee,z){return[b.filter(ee,z),b.filter(ee,N=>!z(N))]}b.split=_;function D(ee,z=!1,N=[]){let W=N.slice(),M=ee(F=>{W?W.push(F):O.fire(F)});const j=()=>{W&&W.forEach(F=>O.fire(F)),W=null},O=new l({onFirstListenerAdd(){M||(M=ee(F=>O.fire(F)))},onFirstListenerDidAdd(){W&&(z?setTimeout(j):j())},onLastListenerRemove(){M&&M.dispose(),M=null}});return O.event}b.buffer=D;class a{constructor(z){this.event=z}map(z){return new a(h(this.event,z))}forEach(z){return new a(g(this.event,z))}filter(z){return new a(t(this.event,z))}reduce(z,N){return new a(n(this.event,z,N))}latch(){return new a(m(this.event))}debounce(z,N=100,W=!1,M){return new a(v(this.event,z,N,W,M))}on(z,N,W){return this.event(z,N,W)}once(z,N,W){return d(this.event)(z,N,W)}}function T(ee){return new a(ee)}b.chain=T;function L(ee,z,N=W=>W){const W=(...F)=>O.fire(N(...F)),M=()=>ee.on(z,W),j=()=>ee.removeListener(z,W),O=new l({onFirstListenerAdd:M,onLastListenerRemove:j});return O.event}b.fromNodeEventEmitter=L;function U(ee,z,N=W=>W){const W=(...F)=>O.fire(N(...F)),M=()=>ee.addEventListener(z,W),j=()=>ee.removeEventListener(z,W),O=new l({onFirstListenerAdd:M,onLastListenerRemove:j});return O.event}b.fromDOMEventEmitter=U;function G(ee){return new Promise(z=>d(ee)(z))}b.toPromise=G})(P=e.Event||(e.Event={}));class E{constructor(d){this._listenerCount=0,this._invocationCount=0,this._elapsedOverall=0,this._name=`${d}_${E._idPool++}`}start(d){this._stopWatch=new A.StopWatch(!0),this._listenerCount=d}stop(){if(this._stopWatch){const d=this._stopWatch.elapsed();this._elapsedOverall+=d,this._invocationCount+=1,console.info(`did FIRE ${this._name}: elapsed_ms: ${d.toFixed(5)}, listener: ${this._listenerCount} (elapsed_overall: ${this._elapsedOverall.toFixed(2)}, invocations: ${this._invocationCount})`),this._stopWatch=void 0}}}E._idPool=0;let k=-1;function r(b){const d=k;return k=b,{dispose(){k=d}}}e.setGlobalLeakWarningThreshold=r;class I{constructor(d,h=Math.random().toString(18).slice(2,5)){this.customThreshold=d,this.name=h,this._warnCountdown=0}dispose(){this._stacks&&this._stacks.clear()}check(d){let h=k;if(typeof this.customThreshold=="number"&&(h=this.customThreshold),h<=0||d<h)return;this._stacks||(this._stacks=new Map);const g=new Error().stack.split(`
`).slice(3).join(`
`),t=this._stacks.get(g)||0;if(this._stacks.set(g,t+1),this._warnCountdown-=1,this._warnCountdown<=0){this._warnCountdown=h*.5;let i,s=0;for(const[n,o]of this._stacks)(!i||s<o)&&(i=n,s=o);console.warn(`[${this.name}] potential listener LEAK detected, having ${d} listeners already. MOST frequent listener (${s}):`),console.warn(i)}return()=>{const i=this._stacks.get(g)||0;this._stacks.set(g,i-1)}}}class l{constructor(d){var h;this._disposed=!1,this._options=d,this._leakageMon=k>0?new I(this._options&&this._options.leakWarningThreshold):void 0,this._perfMon=((h=this._options)===null||h===void 0?void 0:h._profName)?new E(this._options._profName):void 0}get event(){return this._event||(this._event=(d,h,g)=>{var t;this._listeners||(this._listeners=new y.LinkedList);const i=this._listeners.isEmpty();i&&this._options&&this._options.onFirstListenerAdd&&this._options.onFirstListenerAdd(this);const s=this._listeners.push(h?[d,h]:d);i&&this._options&&this._options.onFirstListenerDidAdd&&this._options.onFirstListenerDidAdd(this),this._options&&this._options.onListenerDidAdd&&this._options.onListenerDidAdd(this,d,h);const n=(t=this._leakageMon)===null||t===void 0?void 0:t.check(this._listeners.size);let o;return o={dispose:()=>{n&&n(),o.dispose=l._noop,this._disposed||(s(),this._options&&this._options.onLastListenerRemove&&(this._listeners&&!this._listeners.isEmpty()||this._options.onLastListenerRemove(this)))}},g instanceof C.DisposableStore?g.add(o):Array.isArray(g)&&g.push(o),o}),this._event}fire(d){var h,g;if(this._listeners){this._deliveryQueue||(this._deliveryQueue=new y.LinkedList);for(let t of this._listeners)this._deliveryQueue.push([t,d]);for((h=this._perfMon)===null||h===void 0||h.start(this._deliveryQueue.size);this._deliveryQueue.size>0;){const[t,i]=this._deliveryQueue.shift();try{typeof t=="function"?t.call(void 0,i):t[0].call(t[1],i)}catch(s){p.onUnexpectedError(s)}}(g=this._perfMon)===null||g===void 0||g.stop()}}dispose(){var d,h,g,t,i;this._disposed||(this._disposed=!0,(d=this._listeners)===null||d===void 0||d.clear(),(h=this._deliveryQueue)===null||h===void 0||h.clear(),(t=(g=this._options)===null||g===void 0?void 0:g.onLastListenerRemove)===null||t===void 0||t.call(g),(i=this._leakageMon)===null||i===void 0||i.dispose())}}e.Emitter=l,l._noop=function(){};class f extends l{constructor(d){super(d);this._isPaused=0,this._eventQueue=new y.LinkedList,this._mergeFn=d==null?void 0:d.merge}pause(){this._isPaused++}resume(){if(this._isPaused!==0&&--this._isPaused==0)if(this._mergeFn){const d=Array.from(this._eventQueue);this._eventQueue.clear(),super.fire(this._mergeFn(d))}else for(;!this._isPaused&&this._eventQueue.size!==0;)super.fire(this._eventQueue.shift())}fire(d){this._listeners&&(this._isPaused!==0?this._eventQueue.push(d):super.fire(d))}}e.PauseableEmitter=f;class c extends f{constructor(d){var h;super(d);this._delay=(h=d.delay)!==null&&h!==void 0?h:100}fire(d){this._handle||(this.pause(),this._handle=setTimeout(()=>{this._handle=void 0,this.resume()},this._delay)),super.fire(d)}}e.DebounceEmitter=c;class u{constructor(){this.hasListeners=!1,this.events=[],this.emitter=new l({onFirstListenerAdd:()=>this.onFirstListenerAdd(),onLastListenerRemove:()=>this.onLastListenerRemove()})}get event(){return this.emitter.event}add(d){const h={event:d,listener:null};this.events.push(h),this.hasListeners&&this.hook(h);const g=()=>{this.hasListeners&&this.unhook(h);const t=this.events.indexOf(h);this.events.splice(t,1)};return C.toDisposable(R.once(g))}onFirstListenerAdd(){this.hasListeners=!0,this.events.forEach(d=>this.hook(d))}onLastListenerRemove(){this.hasListeners=!1,this.events.forEach(d=>this.unhook(d))}hook(d){d.listener=d.event(h=>this.emitter.fire(h))}unhook(d){d.listener&&d.listener.dispose(),d.listener=null}dispose(){this.emitter.dispose()}}e.EventMultiplexer=u;class S{constructor(){this.buffers=[]}wrapEvent(d){return(h,g,t)=>d(i=>{const s=this.buffers[this.buffers.length-1];s?s.push(()=>h.call(g,i)):h.call(g,i)},void 0,t)}bufferEvents(d){const h=[];this.buffers.push(h);const g=d();return this.buffers.pop(),h.forEach(t=>t()),g}}e.EventBufferer=S;class w{constructor(){this.listening=!1,this.inputEvent=P.None,this.inputEventListener=C.Disposable.None,this.emitter=new l({onFirstListenerDidAdd:()=>{this.listening=!0,this.inputEventListener=this.inputEvent(this.emitter.fire,this.emitter)},onLastListenerRemove:()=>{this.listening=!1,this.inputEventListener.dispose()}}),this.event=this.emitter.event}set input(d){this.inputEvent=d,this.listening&&(this.inputEventListener.dispose(),this.inputEventListener=d(this.emitter.fire,this.emitter))}dispose(){this.inputEventListener.dispose(),this.emitter.dispose()}}e.Relay=w}),define(me[21],ge([0,1,3]),function(X,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CancellationTokenSource=e.CancellationToken=void 0;const R=Object.freeze(function(P,E){const k=setTimeout(P.bind(E),0);return{dispose(){clearTimeout(k)}}});var C;(function(P){function E(k){return k===P.None||k===P.Cancelled||k instanceof y?!0:!k||typeof k!="object"?!1:typeof k.isCancellationRequested=="boolean"&&typeof k.onCancellationRequested=="function"}P.isCancellationToken=E,P.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:p.Event.None}),P.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:R})})(C=e.CancellationToken||(e.CancellationToken={}));class y{constructor(){this._isCancelled=!1,this._emitter=null}cancel(){this._isCancelled||(this._isCancelled=!0,this._emitter&&(this._emitter.fire(void 0),this.dispose()))}get isCancellationRequested(){return this._isCancelled}get onCancellationRequested(){return this._isCancelled?R:(this._emitter||(this._emitter=new p.Emitter),this._emitter.event)}dispose(){this._emitter&&(this._emitter.dispose(),this._emitter=null)}}class A{constructor(E){this._token=void 0,this._parentListener=void 0,this._parentListener=E&&E.onCancellationRequested(this.cancel,this)}get token(){return this._token||(this._token=new y),this._token}cancel(){this._token?this._token instanceof y&&this._token.cancel():this._token=C.Cancelled}dispose(E=!1){E&&this.cancel(),this._parentListener&&this._parentListener.dispose(),this._token?this._token instanceof y&&this._token.dispose():this._token=C.None}}e.CancellationTokenSource=A}),define(me[90],ge([0,1,3]),function(X,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CSSIcon=e.getClassNamesArray=e.Codicon=e.getCodiconAriaLabel=e.registerCodicon=e.iconRegistry=void 0;class R{constructor(){this._icons=new Map,this._onDidRegister=new p.Emitter}add(I){const l=this._icons.get(I.id);l?I.description?l.description=I.description:console.error(`Duplicate registration of codicon ${I.id}`):(this._icons.set(I.id,I),this._onDidRegister.fire(I))}get(I){return this._icons.get(I)}get all(){return this._icons.values()}get onDidRegister(){return this._onDidRegister.event}}const C=new R;e.iconRegistry=C;function y(r,I){return new P(r,I)}e.registerCodicon=y;function A(r){return r?r.replace(/\$\((.*?)\)/g,(I,l)=>` ${l} `).trim():""}e.getCodiconAriaLabel=A;class P{constructor(I,l,f){this.id=I,this.definition=l,this.description=f,C.add(this)}get classNames(){return"codicon codicon-"+this.id}get classNamesArray(){return["codicon","codicon-"+this.id]}get cssSelector(){return".codicon.codicon-"+this.id}}e.Codicon=P;function E(r,I){const l=["codicon","codicon-"+r];return I&&l.push("codicon-modifier-"+I),l}e.getClassNamesArray=E;var k;(function(r){r.iconNameSegment="[A-Za-z0-9]+",r.iconNameExpression="[A-Za-z0-9\\-]+",r.iconModifierExpression="~[A-Za-z]+";const I=new RegExp(`^(${r.iconNameExpression})(${r.iconModifierExpression})?$`);function l(u){if(u instanceof P)return["codicon","codicon-"+u.id];const S=I.exec(u.id);if(!S)return l(P.error);let[,w,b]=S;const d=["codicon","codicon-"+w];return b&&d.push("codicon-modifier-"+b.substr(1)),d}r.asClassNameArray=l;function f(u){return l(u).join(" ")}r.asClassName=f;function c(u){return"."+l(u).join(".")}r.asCSSSelector=c})(k=e.CSSIcon||(e.CSSIcon={})),function(r){r.add=new r("add",{fontCharacter:"\\ea60"}),r.plus=new r("plus",{fontCharacter:"\\ea60"}),r.gistNew=new r("gist-new",{fontCharacter:"\\ea60"}),r.repoCreate=new r("repo-create",{fontCharacter:"\\ea60"}),r.lightbulb=new r("lightbulb",{fontCharacter:"\\ea61"}),r.lightBulb=new r("light-bulb",{fontCharacter:"\\ea61"}),r.repo=new r("repo",{fontCharacter:"\\ea62"}),r.repoDelete=new r("repo-delete",{fontCharacter:"\\ea62"}),r.gistFork=new r("gist-fork",{fontCharacter:"\\ea63"}),r.repoForked=new r("repo-forked",{fontCharacter:"\\ea63"}),r.gitPullRequest=new r("git-pull-request",{fontCharacter:"\\ea64"}),r.gitPullRequestAbandoned=new r("git-pull-request-abandoned",{fontCharacter:"\\ea64"}),r.recordKeys=new r("record-keys",{fontCharacter:"\\ea65"}),r.keyboard=new r("keyboard",{fontCharacter:"\\ea65"}),r.tag=new r("tag",{fontCharacter:"\\ea66"}),r.tagAdd=new r("tag-add",{fontCharacter:"\\ea66"}),r.tagRemove=new r("tag-remove",{fontCharacter:"\\ea66"}),r.person=new r("person",{fontCharacter:"\\ea67"}),r.personFollow=new r("person-follow",{fontCharacter:"\\ea67"}),r.personOutline=new r("person-outline",{fontCharacter:"\\ea67"}),r.personFilled=new r("person-filled",{fontCharacter:"\\ea67"}),r.gitBranch=new r("git-branch",{fontCharacter:"\\ea68"}),r.gitBranchCreate=new r("git-branch-create",{fontCharacter:"\\ea68"}),r.gitBranchDelete=new r("git-branch-delete",{fontCharacter:"\\ea68"}),r.sourceControl=new r("source-control",{fontCharacter:"\\ea68"}),r.mirror=new r("mirror",{fontCharacter:"\\ea69"}),r.mirrorPublic=new r("mirror-public",{fontCharacter:"\\ea69"}),r.star=new r("star",{fontCharacter:"\\ea6a"}),r.starAdd=new r("star-add",{fontCharacter:"\\ea6a"}),r.starDelete=new r("star-delete",{fontCharacter:"\\ea6a"}),r.starEmpty=new r("star-empty",{fontCharacter:"\\ea6a"}),r.comment=new r("comment",{fontCharacter:"\\ea6b"}),r.commentAdd=new r("comment-add",{fontCharacter:"\\ea6b"}),r.alert=new r("alert",{fontCharacter:"\\ea6c"}),r.warning=new r("warning",{fontCharacter:"\\ea6c"}),r.search=new r("search",{fontCharacter:"\\ea6d"}),r.searchSave=new r("search-save",{fontCharacter:"\\ea6d"}),r.logOut=new r("log-out",{fontCharacter:"\\ea6e"}),r.signOut=new r("sign-out",{fontCharacter:"\\ea6e"}),r.logIn=new r("log-in",{fontCharacter:"\\ea6f"}),r.signIn=new r("sign-in",{fontCharacter:"\\ea6f"}),r.eye=new r("eye",{fontCharacter:"\\ea70"}),r.eyeUnwatch=new r("eye-unwatch",{fontCharacter:"\\ea70"}),r.eyeWatch=new r("eye-watch",{fontCharacter:"\\ea70"}),r.circleFilled=new r("circle-filled",{fontCharacter:"\\ea71"}),r.primitiveDot=new r("primitive-dot",{fontCharacter:"\\ea71"}),r.closeDirty=new r("close-dirty",{fontCharacter:"\\ea71"}),r.debugBreakpoint=new r("debug-breakpoint",{fontCharacter:"\\ea71"}),r.debugBreakpointDisabled=new r("debug-breakpoint-disabled",{fontCharacter:"\\ea71"}),r.debugHint=new r("debug-hint",{fontCharacter:"\\ea71"}),r.primitiveSquare=new r("primitive-square",{fontCharacter:"\\ea72"}),r.edit=new r("edit",{fontCharacter:"\\ea73"}),r.pencil=new r("pencil",{fontCharacter:"\\ea73"}),r.info=new r("info",{fontCharacter:"\\ea74"}),r.issueOpened=new r("issue-opened",{fontCharacter:"\\ea74"}),r.gistPrivate=new r("gist-private",{fontCharacter:"\\ea75"}),r.gitForkPrivate=new r("git-fork-private",{fontCharacter:"\\ea75"}),r.lock=new r("lock",{fontCharacter:"\\ea75"}),r.mirrorPrivate=new r("mirror-private",{fontCharacter:"\\ea75"}),r.close=new r("close",{fontCharacter:"\\ea76"}),r.removeClose=new r("remove-close",{fontCharacter:"\\ea76"}),r.x=new r("x",{fontCharacter:"\\ea76"}),r.repoSync=new r("repo-sync",{fontCharacter:"\\ea77"}),r.sync=new r("sync",{fontCharacter:"\\ea77"}),r.clone=new r("clone",{fontCharacter:"\\ea78"}),r.desktopDownload=new r("desktop-download",{fontCharacter:"\\ea78"}),r.beaker=new r("beaker",{fontCharacter:"\\ea79"}),r.microscope=new r("microscope",{fontCharacter:"\\ea79"}),r.vm=new r("vm",{fontCharacter:"\\ea7a"}),r.deviceDesktop=new r("device-desktop",{fontCharacter:"\\ea7a"}),r.file=new r("file",{fontCharacter:"\\ea7b"}),r.fileText=new r("file-text",{fontCharacter:"\\ea7b"}),r.more=new r("more",{fontCharacter:"\\ea7c"}),r.ellipsis=new r("ellipsis",{fontCharacter:"\\ea7c"}),r.kebabHorizontal=new r("kebab-horizontal",{fontCharacter:"\\ea7c"}),r.mailReply=new r("mail-reply",{fontCharacter:"\\ea7d"}),r.reply=new r("reply",{fontCharacter:"\\ea7d"}),r.organization=new r("organization",{fontCharacter:"\\ea7e"}),r.organizationFilled=new r("organization-filled",{fontCharacter:"\\ea7e"}),r.organizationOutline=new r("organization-outline",{fontCharacter:"\\ea7e"}),r.newFile=new r("new-file",{fontCharacter:"\\ea7f"}),r.fileAdd=new r("file-add",{fontCharacter:"\\ea7f"}),r.newFolder=new r("new-folder",{fontCharacter:"\\ea80"}),r.fileDirectoryCreate=new r("file-directory-create",{fontCharacter:"\\ea80"}),r.trash=new r("trash",{fontCharacter:"\\ea81"}),r.trashcan=new r("trashcan",{fontCharacter:"\\ea81"}),r.history=new r("history",{fontCharacter:"\\ea82"}),r.clock=new r("clock",{fontCharacter:"\\ea82"}),r.folder=new r("folder",{fontCharacter:"\\ea83"}),r.fileDirectory=new r("file-directory",{fontCharacter:"\\ea83"}),r.symbolFolder=new r("symbol-folder",{fontCharacter:"\\ea83"}),r.logoGithub=new r("logo-github",{fontCharacter:"\\ea84"}),r.markGithub=new r("mark-github",{fontCharacter:"\\ea84"}),r.github=new r("github",{fontCharacter:"\\ea84"}),r.terminal=new r("terminal",{fontCharacter:"\\ea85"}),r.console=new r("console",{fontCharacter:"\\ea85"}),r.repl=new r("repl",{fontCharacter:"\\ea85"}),r.zap=new r("zap",{fontCharacter:"\\ea86"}),r.symbolEvent=new r("symbol-event",{fontCharacter:"\\ea86"}),r.error=new r("error",{fontCharacter:"\\ea87"}),r.stop=new r("stop",{fontCharacter:"\\ea87"}),r.variable=new r("variable",{fontCharacter:"\\ea88"}),r.symbolVariable=new r("symbol-variable",{fontCharacter:"\\ea88"}),r.array=new r("array",{fontCharacter:"\\ea8a"}),r.symbolArray=new r("symbol-array",{fontCharacter:"\\ea8a"}),r.symbolModule=new r("symbol-module",{fontCharacter:"\\ea8b"}),r.symbolPackage=new r("symbol-package",{fontCharacter:"\\ea8b"}),r.symbolNamespace=new r("symbol-namespace",{fontCharacter:"\\ea8b"}),r.symbolObject=new r("symbol-object",{fontCharacter:"\\ea8b"}),r.symbolMethod=new r("symbol-method",{fontCharacter:"\\ea8c"}),r.symbolFunction=new r("symbol-function",{fontCharacter:"\\ea8c"}),r.symbolConstructor=new r("symbol-constructor",{fontCharacter:"\\ea8c"}),r.symbolBoolean=new r("symbol-boolean",{fontCharacter:"\\ea8f"}),r.symbolNull=new r("symbol-null",{fontCharacter:"\\ea8f"}),r.symbolNumeric=new r("symbol-numeric",{fontCharacter:"\\ea90"}),r.symbolNumber=new r("symbol-number",{fontCharacter:"\\ea90"}),r.symbolStructure=new r("symbol-structure",{fontCharacter:"\\ea91"}),r.symbolStruct=new r("symbol-struct",{fontCharacter:"\\ea91"}),r.symbolParameter=new r("symbol-parameter",{fontCharacter:"\\ea92"}),r.symbolTypeParameter=new r("symbol-type-parameter",{fontCharacter:"\\ea92"}),r.symbolKey=new r("symbol-key",{fontCharacter:"\\ea93"}),r.symbolText=new r("symbol-text",{fontCharacter:"\\ea93"}),r.symbolReference=new r("symbol-reference",{fontCharacter:"\\ea94"}),r.goToFile=new r("go-to-file",{fontCharacter:"\\ea94"}),r.symbolEnum=new r("symbol-enum",{fontCharacter:"\\ea95"}),r.symbolValue=new r("symbol-value",{fontCharacter:"\\ea95"}),r.symbolRuler=new r("symbol-ruler",{fontCharacter:"\\ea96"}),r.symbolUnit=new r("symbol-unit",{fontCharacter:"\\ea96"}),r.activateBreakpoints=new r("activate-breakpoints",{fontCharacter:"\\ea97"}),r.archive=new r("archive",{fontCharacter:"\\ea98"}),r.arrowBoth=new r("arrow-both",{fontCharacter:"\\ea99"}),r.arrowDown=new r("arrow-down",{fontCharacter:"\\ea9a"}),r.arrowLeft=new r("arrow-left",{fontCharacter:"\\ea9b"}),r.arrowRight=new r("arrow-right",{fontCharacter:"\\ea9c"}),r.arrowSmallDown=new r("arrow-small-down",{fontCharacter:"\\ea9d"}),r.arrowSmallLeft=new r("arrow-small-left",{fontCharacter:"\\ea9e"}),r.arrowSmallRight=new r("arrow-small-right",{fontCharacter:"\\ea9f"}),r.arrowSmallUp=new r("arrow-small-up",{fontCharacter:"\\eaa0"}),r.arrowUp=new r("arrow-up",{fontCharacter:"\\eaa1"}),r.bell=new r("bell",{fontCharacter:"\\eaa2"}),r.bold=new r("bold",{fontCharacter:"\\eaa3"}),r.book=new r("book",{fontCharacter:"\\eaa4"}),r.bookmark=new r("bookmark",{fontCharacter:"\\eaa5"}),r.debugBreakpointConditionalUnverified=new r("debug-breakpoint-conditional-unverified",{fontCharacter:"\\eaa6"}),r.debugBreakpointConditional=new r("debug-breakpoint-conditional",{fontCharacter:"\\eaa7"}),r.debugBreakpointConditionalDisabled=new r("debug-breakpoint-conditional-disabled",{fontCharacter:"\\eaa7"}),r.debugBreakpointDataUnverified=new r("debug-breakpoint-data-unverified",{fontCharacter:"\\eaa8"}),r.debugBreakpointData=new r("debug-breakpoint-data",{fontCharacter:"\\eaa9"}),r.debugBreakpointDataDisabled=new r("debug-breakpoint-data-disabled",{fontCharacter:"\\eaa9"}),r.debugBreakpointLogUnverified=new r("debug-breakpoint-log-unverified",{fontCharacter:"\\eaaa"}),r.debugBreakpointLog=new r("debug-breakpoint-log",{fontCharacter:"\\eaab"}),r.debugBreakpointLogDisabled=new r("debug-breakpoint-log-disabled",{fontCharacter:"\\eaab"}),r.briefcase=new r("briefcase",{fontCharacter:"\\eaac"}),r.broadcast=new r("broadcast",{fontCharacter:"\\eaad"}),r.browser=new r("browser",{fontCharacter:"\\eaae"}),r.bug=new r("bug",{fontCharacter:"\\eaaf"}),r.calendar=new r("calendar",{fontCharacter:"\\eab0"}),r.caseSensitive=new r("case-sensitive",{fontCharacter:"\\eab1"}),r.check=new r("check",{fontCharacter:"\\eab2"}),r.checklist=new r("checklist",{fontCharacter:"\\eab3"}),r.chevronDown=new r("chevron-down",{fontCharacter:"\\eab4"}),r.chevronLeft=new r("chevron-left",{fontCharacter:"\\eab5"}),r.chevronRight=new r("chevron-right",{fontCharacter:"\\eab6"}),r.chevronUp=new r("chevron-up",{fontCharacter:"\\eab7"}),r.chromeClose=new r("chrome-close",{fontCharacter:"\\eab8"}),r.chromeMaximize=new r("chrome-maximize",{fontCharacter:"\\eab9"}),r.chromeMinimize=new r("chrome-minimize",{fontCharacter:"\\eaba"}),r.chromeRestore=new r("chrome-restore",{fontCharacter:"\\eabb"}),r.circleOutline=new r("circle-outline",{fontCharacter:"\\eabc"}),r.debugBreakpointUnverified=new r("debug-breakpoint-unverified",{fontCharacter:"\\eabc"}),r.circleSlash=new r("circle-slash",{fontCharacter:"\\eabd"}),r.circuitBoard=new r("circuit-board",{fontCharacter:"\\eabe"}),r.clearAll=new r("clear-all",{fontCharacter:"\\eabf"}),r.clippy=new r("clippy",{fontCharacter:"\\eac0"}),r.closeAll=new r("close-all",{fontCharacter:"\\eac1"}),r.cloudDownload=new r("cloud-download",{fontCharacter:"\\eac2"}),r.cloudUpload=new r("cloud-upload",{fontCharacter:"\\eac3"}),r.code=new r("code",{fontCharacter:"\\eac4"}),r.collapseAll=new r("collapse-all",{fontCharacter:"\\eac5"}),r.colorMode=new r("color-mode",{fontCharacter:"\\eac6"}),r.commentDiscussion=new r("comment-discussion",{fontCharacter:"\\eac7"}),r.compareChanges=new r("compare-changes",{fontCharacter:"\\eafd"}),r.creditCard=new r("credit-card",{fontCharacter:"\\eac9"}),r.dash=new r("dash",{fontCharacter:"\\eacc"}),r.dashboard=new r("dashboard",{fontCharacter:"\\eacd"}),r.database=new r("database",{fontCharacter:"\\eace"}),r.debugContinue=new r("debug-continue",{fontCharacter:"\\eacf"}),r.debugDisconnect=new r("debug-disconnect",{fontCharacter:"\\ead0"}),r.debugPause=new r("debug-pause",{fontCharacter:"\\ead1"}),r.debugRestart=new r("debug-restart",{fontCharacter:"\\ead2"}),r.debugStart=new r("debug-start",{fontCharacter:"\\ead3"}),r.debugStepInto=new r("debug-step-into",{fontCharacter:"\\ead4"}),r.debugStepOut=new r("debug-step-out",{fontCharacter:"\\ead5"}),r.debugStepOver=new r("debug-step-over",{fontCharacter:"\\ead6"}),r.debugStop=new r("debug-stop",{fontCharacter:"\\ead7"}),r.debug=new r("debug",{fontCharacter:"\\ead8"}),r.deviceCameraVideo=new r("device-camera-video",{fontCharacter:"\\ead9"}),r.deviceCamera=new r("device-camera",{fontCharacter:"\\eada"}),r.deviceMobile=new r("device-mobile",{fontCharacter:"\\eadb"}),r.diffAdded=new r("diff-added",{fontCharacter:"\\eadc"}),r.diffIgnored=new r("diff-ignored",{fontCharacter:"\\eadd"}),r.diffModified=new r("diff-modified",{fontCharacter:"\\eade"}),r.diffRemoved=new r("diff-removed",{fontCharacter:"\\eadf"}),r.diffRenamed=new r("diff-renamed",{fontCharacter:"\\eae0"}),r.diff=new r("diff",{fontCharacter:"\\eae1"}),r.discard=new r("discard",{fontCharacter:"\\eae2"}),r.editorLayout=new r("editor-layout",{fontCharacter:"\\eae3"}),r.emptyWindow=new r("empty-window",{fontCharacter:"\\eae4"}),r.exclude=new r("exclude",{fontCharacter:"\\eae5"}),r.extensions=new r("extensions",{fontCharacter:"\\eae6"}),r.eyeClosed=new r("eye-closed",{fontCharacter:"\\eae7"}),r.fileBinary=new r("file-binary",{fontCharacter:"\\eae8"}),r.fileCode=new r("file-code",{fontCharacter:"\\eae9"}),r.fileMedia=new r("file-media",{fontCharacter:"\\eaea"}),r.filePdf=new r("file-pdf",{fontCharacter:"\\eaeb"}),r.fileSubmodule=new r("file-submodule",{fontCharacter:"\\eaec"}),r.fileSymlinkDirectory=new r("file-symlink-directory",{fontCharacter:"\\eaed"}),r.fileSymlinkFile=new r("file-symlink-file",{fontCharacter:"\\eaee"}),r.fileZip=new r("file-zip",{fontCharacter:"\\eaef"}),r.files=new r("files",{fontCharacter:"\\eaf0"}),r.filter=new r("filter",{fontCharacter:"\\eaf1"}),r.flame=new r("flame",{fontCharacter:"\\eaf2"}),r.foldDown=new r("fold-down",{fontCharacter:"\\eaf3"}),r.foldUp=new r("fold-up",{fontCharacter:"\\eaf4"}),r.fold=new r("fold",{fontCharacter:"\\eaf5"}),r.folderActive=new r("folder-active",{fontCharacter:"\\eaf6"}),r.folderOpened=new r("folder-opened",{fontCharacter:"\\eaf7"}),r.gear=new r("gear",{fontCharacter:"\\eaf8"}),r.gift=new r("gift",{fontCharacter:"\\eaf9"}),r.gistSecret=new r("gist-secret",{fontCharacter:"\\eafa"}),r.gist=new r("gist",{fontCharacter:"\\eafb"}),r.gitCommit=new r("git-commit",{fontCharacter:"\\eafc"}),r.gitCompare=new r("git-compare",{fontCharacter:"\\eafd"}),r.gitMerge=new r("git-merge",{fontCharacter:"\\eafe"}),r.githubAction=new r("github-action",{fontCharacter:"\\eaff"}),r.githubAlt=new r("github-alt",{fontCharacter:"\\eb00"}),r.globe=new r("globe",{fontCharacter:"\\eb01"}),r.grabber=new r("grabber",{fontCharacter:"\\eb02"}),r.graph=new r("graph",{fontCharacter:"\\eb03"}),r.gripper=new r("gripper",{fontCharacter:"\\eb04"}),r.heart=new r("heart",{fontCharacter:"\\eb05"}),r.home=new r("home",{fontCharacter:"\\eb06"}),r.horizontalRule=new r("horizontal-rule",{fontCharacter:"\\eb07"}),r.hubot=new r("hubot",{fontCharacter:"\\eb08"}),r.inbox=new r("inbox",{fontCharacter:"\\eb09"}),r.issueClosed=new r("issue-closed",{fontCharacter:"\\eb0a"}),r.issueReopened=new r("issue-reopened",{fontCharacter:"\\eb0b"}),r.issues=new r("issues",{fontCharacter:"\\eb0c"}),r.italic=new r("italic",{fontCharacter:"\\eb0d"}),r.jersey=new r("jersey",{fontCharacter:"\\eb0e"}),r.json=new r("json",{fontCharacter:"\\eb0f"}),r.kebabVertical=new r("kebab-vertical",{fontCharacter:"\\eb10"}),r.key=new r("key",{fontCharacter:"\\eb11"}),r.law=new r("law",{fontCharacter:"\\eb12"}),r.lightbulbAutofix=new r("lightbulb-autofix",{fontCharacter:"\\eb13"}),r.linkExternal=new r("link-external",{fontCharacter:"\\eb14"}),r.link=new r("link",{fontCharacter:"\\eb15"}),r.listOrdered=new r("list-ordered",{fontCharacter:"\\eb16"}),r.listUnordered=new r("list-unordered",{fontCharacter:"\\eb17"}),r.liveShare=new r("live-share",{fontCharacter:"\\eb18"}),r.loading=new r("loading",{fontCharacter:"\\eb19"}),r.location=new r("location",{fontCharacter:"\\eb1a"}),r.mailRead=new r("mail-read",{fontCharacter:"\\eb1b"}),r.mail=new r("mail",{fontCharacter:"\\eb1c"}),r.markdown=new r("markdown",{fontCharacter:"\\eb1d"}),r.megaphone=new r("megaphone",{fontCharacter:"\\eb1e"}),r.mention=new r("mention",{fontCharacter:"\\eb1f"}),r.milestone=new r("milestone",{fontCharacter:"\\eb20"}),r.mortarBoard=new r("mortar-board",{fontCharacter:"\\eb21"}),r.move=new r("move",{fontCharacter:"\\eb22"}),r.multipleWindows=new r("multiple-windows",{fontCharacter:"\\eb23"}),r.mute=new r("mute",{fontCharacter:"\\eb24"}),r.noNewline=new r("no-newline",{fontCharacter:"\\eb25"}),r.note=new r("note",{fontCharacter:"\\eb26"}),r.octoface=new r("octoface",{fontCharacter:"\\eb27"}),r.openPreview=new r("open-preview",{fontCharacter:"\\eb28"}),r.package_=new r("package",{fontCharacter:"\\eb29"}),r.paintcan=new r("paintcan",{fontCharacter:"\\eb2a"}),r.pin=new r("pin",{fontCharacter:"\\eb2b"}),r.play=new r("play",{fontCharacter:"\\eb2c"}),r.run=new r("run",{fontCharacter:"\\eb2c"}),r.plug=new r("plug",{fontCharacter:"\\eb2d"}),r.preserveCase=new r("preserve-case",{fontCharacter:"\\eb2e"}),r.preview=new r("preview",{fontCharacter:"\\eb2f"}),r.project=new r("project",{fontCharacter:"\\eb30"}),r.pulse=new r("pulse",{fontCharacter:"\\eb31"}),r.question=new r("question",{fontCharacter:"\\eb32"}),r.quote=new r("quote",{fontCharacter:"\\eb33"}),r.radioTower=new r("radio-tower",{fontCharacter:"\\eb34"}),r.reactions=new r("reactions",{fontCharacter:"\\eb35"}),r.references=new r("references",{fontCharacter:"\\eb36"}),r.refresh=new r("refresh",{fontCharacter:"\\eb37"}),r.regex=new r("regex",{fontCharacter:"\\eb38"}),r.remoteExplorer=new r("remote-explorer",{fontCharacter:"\\eb39"}),r.remote=new r("remote",{fontCharacter:"\\eb3a"}),r.remove=new r("remove",{fontCharacter:"\\eb3b"}),r.replaceAll=new r("replace-all",{fontCharacter:"\\eb3c"}),r.replace=new r("replace",{fontCharacter:"\\eb3d"}),r.repoClone=new r("repo-clone",{fontCharacter:"\\eb3e"}),r.repoForcePush=new r("repo-force-push",{fontCharacter:"\\eb3f"}),r.repoPull=new r("repo-pull",{fontCharacter:"\\eb40"}),r.repoPush=new r("repo-push",{fontCharacter:"\\eb41"}),r.report=new r("report",{fontCharacter:"\\eb42"}),r.requestChanges=new r("request-changes",{fontCharacter:"\\eb43"}),r.rocket=new r("rocket",{fontCharacter:"\\eb44"}),r.rootFolderOpened=new r("root-folder-opened",{fontCharacter:"\\eb45"}),r.rootFolder=new r("root-folder",{fontCharacter:"\\eb46"}),r.rss=new r("rss",{fontCharacter:"\\eb47"}),r.ruby=new r("ruby",{fontCharacter:"\\eb48"}),r.saveAll=new r("save-all",{fontCharacter:"\\eb49"}),r.saveAs=new r("save-as",{fontCharacter:"\\eb4a"}),r.save=new r("save",{fontCharacter:"\\eb4b"}),r.screenFull=new r("screen-full",{fontCharacter:"\\eb4c"}),r.screenNormal=new r("screen-normal",{fontCharacter:"\\eb4d"}),r.searchStop=new r("search-stop",{fontCharacter:"\\eb4e"}),r.server=new r("server",{fontCharacter:"\\eb50"}),r.settingsGear=new r("settings-gear",{fontCharacter:"\\eb51"}),r.settings=new r("settings",{fontCharacter:"\\eb52"}),r.shield=new r("shield",{fontCharacter:"\\eb53"}),r.smiley=new r("smiley",{fontCharacter:"\\eb54"}),r.sortPrecedence=new r("sort-precedence",{fontCharacter:"\\eb55"}),r.splitHorizontal=new r("split-horizontal",{fontCharacter:"\\eb56"}),r.splitVertical=new r("split-vertical",{fontCharacter:"\\eb57"}),r.squirrel=new r("squirrel",{fontCharacter:"\\eb58"}),r.starFull=new r("star-full",{fontCharacter:"\\eb59"}),r.starHalf=new r("star-half",{fontCharacter:"\\eb5a"}),r.symbolClass=new r("symbol-class",{fontCharacter:"\\eb5b"}),r.symbolColor=new r("symbol-color",{fontCharacter:"\\eb5c"}),r.symbolConstant=new r("symbol-constant",{fontCharacter:"\\eb5d"}),r.symbolEnumMember=new r("symbol-enum-member",{fontCharacter:"\\eb5e"}),r.symbolField=new r("symbol-field",{fontCharacter:"\\eb5f"}),r.symbolFile=new r("symbol-file",{fontCharacter:"\\eb60"}),r.symbolInterface=new r("symbol-interface",{fontCharacter:"\\eb61"}),r.symbolKeyword=new r("symbol-keyword",{fontCharacter:"\\eb62"}),r.symbolMisc=new r("symbol-misc",{fontCharacter:"\\eb63"}),r.symbolOperator=new r("symbol-operator",{fontCharacter:"\\eb64"}),r.symbolProperty=new r("symbol-property",{fontCharacter:"\\eb65"}),r.wrench=new r("wrench",{fontCharacter:"\\eb65"}),r.wrenchSubaction=new r("wrench-subaction",{fontCharacter:"\\eb65"}),r.symbolSnippet=new r("symbol-snippet",{fontCharacter:"\\eb66"}),r.tasklist=new r("tasklist",{fontCharacter:"\\eb67"}),r.telescope=new r("telescope",{fontCharacter:"\\eb68"}),r.textSize=new r("text-size",{fontCharacter:"\\eb69"}),r.threeBars=new r("three-bars",{fontCharacter:"\\eb6a"}),r.thumbsdown=new r("thumbsdown",{fontCharacter:"\\eb6b"}),r.thumbsup=new r("thumbsup",{fontCharacter:"\\eb6c"}),r.tools=new r("tools",{fontCharacter:"\\eb6d"}),r.triangleDown=new r("triangle-down",{fontCharacter:"\\eb6e"}),r.triangleLeft=new r("triangle-left",{fontCharacter:"\\eb6f"}),r.triangleRight=new r("triangle-right",{fontCharacter:"\\eb70"}),r.triangleUp=new r("triangle-up",{fontCharacter:"\\eb71"}),r.twitter=new r("twitter",{fontCharacter:"\\eb72"}),r.unfold=new r("unfold",{fontCharacter:"\\eb73"}),r.unlock=new r("unlock",{fontCharacter:"\\eb74"}),r.unmute=new r("unmute",{fontCharacter:"\\eb75"}),r.unverified=new r("unverified",{fontCharacter:"\\eb76"}),r.verified=new r("verified",{fontCharacter:"\\eb77"}),r.versions=new r("versions",{fontCharacter:"\\eb78"}),r.vmActive=new r("vm-active",{fontCharacter:"\\eb79"}),r.vmOutline=new r("vm-outline",{fontCharacter:"\\eb7a"}),r.vmRunning=new r("vm-running",{fontCharacter:"\\eb7b"}),r.watch=new r("watch",{fontCharacter:"\\eb7c"}),r.whitespace=new r("whitespace",{fontCharacter:"\\eb7d"}),r.wholeWord=new r("whole-word",{fontCharacter:"\\eb7e"}),r.window=new r("window",{fontCharacter:"\\eb7f"}),r.wordWrap=new r("word-wrap",{fontCharacter:"\\eb80"}),r.zoomIn=new r("zoom-in",{fontCharacter:"\\eb81"}),r.zoomOut=new r("zoom-out",{fontCharacter:"\\eb82"}),r.listFilter=new r("list-filter",{fontCharacter:"\\eb83"}),r.listFlat=new r("list-flat",{fontCharacter:"\\eb84"}),r.listSelection=new r("list-selection",{fontCharacter:"\\eb85"}),r.selection=new r("selection",{fontCharacter:"\\eb85"}),r.listTree=new r("list-tree",{fontCharacter:"\\eb86"}),r.debugBreakpointFunctionUnverified=new r("debug-breakpoint-function-unverified",{fontCharacter:"\\eb87"}),r.debugBreakpointFunction=new r("debug-breakpoint-function",{fontCharacter:"\\eb88"}),r.debugBreakpointFunctionDisabled=new r("debug-breakpoint-function-disabled",{fontCharacter:"\\eb88"}),r.debugStackframeActive=new r("debug-stackframe-active",{fontCharacter:"\\eb89"}),r.debugStackframeDot=new r("debug-stackframe-dot",{fontCharacter:"\\eb8a"}),r.debugStackframe=new r("debug-stackframe",{fontCharacter:"\\eb8b"}),r.debugStackframeFocused=new r("debug-stackframe-focused",{fontCharacter:"\\eb8b"}),r.debugBreakpointUnsupported=new r("debug-breakpoint-unsupported",{fontCharacter:"\\eb8c"}),r.symbolString=new r("symbol-string",{fontCharacter:"\\eb8d"}),r.debugReverseContinue=new r("debug-reverse-continue",{fontCharacter:"\\eb8e"}),r.debugStepBack=new r("debug-step-back",{fontCharacter:"\\eb8f"}),r.debugRestartFrame=new r("debug-restart-frame",{fontCharacter:"\\eb90"}),r.callIncoming=new r("call-incoming",{fontCharacter:"\\eb92"}),r.callOutgoing=new r("call-outgoing",{fontCharacter:"\\eb93"}),r.menu=new r("menu",{fontCharacter:"\\eb94"}),r.expandAll=new r("expand-all",{fontCharacter:"\\eb95"}),r.feedback=new r("feedback",{fontCharacter:"\\eb96"}),r.groupByRefType=new r("group-by-ref-type",{fontCharacter:"\\eb97"}),r.ungroupByRefType=new r("ungroup-by-ref-type",{fontCharacter:"\\eb98"}),r.account=new r("account",{fontCharacter:"\\eb99"}),r.bellDot=new r("bell-dot",{fontCharacter:"\\eb9a"}),r.debugConsole=new r("debug-console",{fontCharacter:"\\eb9b"}),r.library=new r("library",{fontCharacter:"\\eb9c"}),r.output=new r("output",{fontCharacter:"\\eb9d"}),r.runAll=new r("run-all",{fontCharacter:"\\eb9e"}),r.syncIgnored=new r("sync-ignored",{fontCharacter:"\\eb9f"}),r.pinned=new r("pinned",{fontCharacter:"\\eba0"}),r.githubInverted=new r("github-inverted",{fontCharacter:"\\eba1"}),r.debugAlt=new r("debug-alt",{fontCharacter:"\\eb91"}),r.serverProcess=new r("server-process",{fontCharacter:"\\eba2"}),r.serverEnvironment=new r("server-environment",{fontCharacter:"\\eba3"}),r.pass=new r("pass",{fontCharacter:"\\eba4"}),r.stopCircle=new r("stop-circle",{fontCharacter:"\\eba5"}),r.playCircle=new r("play-circle",{fontCharacter:"\\eba6"}),r.record=new r("record",{fontCharacter:"\\eba7"}),r.debugAltSmall=new r("debug-alt-small",{fontCharacter:"\\eba8"}),r.vmConnect=new r("vm-connect",{fontCharacter:"\\eba9"}),r.cloud=new r("cloud",{fontCharacter:"\\ebaa"}),r.merge=new r("merge",{fontCharacter:"\\ebab"}),r.exportIcon=new r("export",{fontCharacter:"\\ebac"}),r.graphLeft=new r("graph-left",{fontCharacter:"\\ebad"}),r.magnet=new r("magnet",{fontCharacter:"\\ebae"}),r.notebook=new r("notebook",{fontCharacter:"\\ebaf"}),r.redo=new r("redo",{fontCharacter:"\\ebb0"}),r.checkAll=new r("check-all",{fontCharacter:"\\ebb1"}),r.pinnedDirty=new r("pinned-dirty",{fontCharacter:"\\ebb2"}),r.passFilled=new r("pass-filled",{fontCharacter:"\\ebb3"}),r.circleLargeFilled=new r("circle-large-filled",{fontCharacter:"\\ebb4"}),r.circleLargeOutline=new r("circle-large-outline",{fontCharacter:"\\ebb5"}),r.combine=new r("combine",{fontCharacter:"\\ebb6"}),r.gather=new r("gather",{fontCharacter:"\\ebb6"}),r.table=new r("table",{fontCharacter:"\\ebb7"}),r.variableGroup=new r("variable-group",{fontCharacter:"\\ebb8"}),r.typeHierarchy=new r("type-hierarchy",{fontCharacter:"\\ebb9"}),r.typeHierarchySub=new r("type-hierarchy-sub",{fontCharacter:"\\ebba"}),r.typeHierarchySuper=new r("type-hierarchy-super",{fontCharacter:"\\ebbb"}),r.gitPullRequestCreate=new r("git-pull-request-create",{fontCharacter:"\\ebbc"}),r.runAbove=new r("run-above",{fontCharacter:"\\ebbd"}),r.runBelow=new r("run-below",{fontCharacter:"\\ebbe"}),r.notebookTemplate=new r("notebook-template",{fontCharacter:"\\ebbf"}),r.debugRerun=new r("debug-rerun",{fontCharacter:"\\ebc0"}),r.workspaceTrusted=new r("workspace-trusted",{fontCharacter:"\\ebc1"}),r.workspaceUntrusted=new r("workspace-untrusted",{fontCharacter:"\\ebc2"}),r.workspaceUnspecified=new r("workspace-unspecified",{fontCharacter:"\\ebc3"}),r.terminalCmd=new r("terminal-cmd",{fontCharacter:"\\ebc4"}),r.terminalDebian=new r("terminal-debian",{fontCharacter:"\\ebc5"}),r.terminalLinux=new r("terminal-linux",{fontCharacter:"\\ebc6"}),r.terminalPowershell=new r("terminal-powershell",{fontCharacter:"\\ebc7"}),r.terminalTmux=new r("terminal-tmux",{fontCharacter:"\\ebc8"}),r.terminalUbuntu=new r("terminal-ubuntu",{fontCharacter:"\\ebc9"}),r.terminalBash=new r("terminal-bash",{fontCharacter:"\\ebca"}),r.arrowSwap=new r("arrow-swap",{fontCharacter:"\\ebcb"}),r.copy=new r("copy",{fontCharacter:"\\ebcc"}),r.personAdd=new r("person-add",{fontCharacter:"\\ebcd"}),r.filterFilled=new r("filter-filled",{fontCharacter:"\\ebce"}),r.wand=new r("wand",{fontCharacter:"\\ebcf"}),r.debugLineByLine=new r("debug-line-by-line",{fontCharacter:"\\ebd0"}),r.inspect=new r("inspect",{fontCharacter:"\\ebd1"}),r.dropDownButton=new r("drop-down-button",r.chevronDown.definition)}(P=e.Codicon||(e.Codicon={}))}),define(me[91],ge([0,1,14,6]),function(X,e,p,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=void 0;function C(d){const h=d;return h?[h.on,h.pause,h.resume,h.destroy].every(g=>typeof g=="function"):!1}e.isReadableStream=C;function y(d){const h=d;return h?C(h.stream)&&Array.isArray(h.buffer)&&typeof h.ended=="boolean":!1}e.isReadableBufferedStream=y;function A(d,h){return new P(d,h)}e.newWriteableStream=A;class P{constructor(h,g){this.reducer=h,this.options=g,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(h){var g;if(!this.state.destroyed){if(this.state.flowing)this.emitData(h);else if(this.buffer.data.push(h),typeof((g=this.options)===null||g===void 0?void 0:g.highWaterMark)=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(t=>this.pendingWritePromises.push(t))}}error(h){this.state.destroyed||(this.state.flowing?this.emitError(h):this.buffer.error.push(h))}end(h){this.state.destroyed||(typeof h!="undefined"&&this.write(h),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(h){this.listeners.data.slice(0).forEach(g=>g(h))}emitError(h){this.listeners.error.length===0?p.onUnexpectedError(h):this.listeners.error.slice(0).forEach(g=>g(h))}emitEnd(){this.listeners.end.slice(0).forEach(h=>h())}on(h,g){if(!this.state.destroyed)switch(h){case"data":this.listeners.data.push(g),this.resume();break;case"end":this.listeners.end.push(g),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(g),this.state.flowing&&this.flowErrors();break}}removeListener(h,g){if(this.state.destroyed)return;let t;switch(h){case"data":t=this.listeners.data;break;case"end":t=this.listeners.end;break;case"error":t=this.listeners.error;break}if(t){const i=t.indexOf(g);i>=0&&t.splice(i,1)}}flowData(){if(this.buffer.data.length>0){const h=this.reducer(this.buffer.data);this.emitData(h),this.buffer.data.length=0;const g=[...this.pendingWritePromises];this.pendingWritePromises.length=0,g.forEach(t=>t())}}flowErrors(){if(this.listeners.error.length>0){for(const h of this.buffer.error)this.emitError(h);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function E(d,h){const g=[];let t;for(;(t=d.read())!==null;)g.push(t);return h(g)}e.consumeReadable=E;function k(d,h,g){const t=[];let i;for(;(i=d.read())!==null&&t.length<g;)t.push(i);return i===null&&t.length>0?h(t):{read:()=>{if(t.length>0)return t.shift();if(typeof i!="undefined"){const s=i;return i=void 0,s}return d.read()}}}e.peekReadable=k;function r(d,h){return new Promise((g,t)=>{const i=[];I(d,{onData:s=>{h&&i.push(s)},onError:s=>{h?t(s):g(void 0)},onEnd:()=>{g(h?h(i):void 0)}})})}e.consumeStream=r;function I(d,h){d.on("error",g=>h.onError(g)),d.on("end",()=>h.onEnd()),d.on("data",g=>h.onData(g))}e.listenStream=I;function l(d,h){return new Promise((g,t)=>{const i=new R.DisposableStore,s=[],n=m=>{if(s.push(m),s.length>h)return i.dispose(),d.pause(),g({stream:d,buffer:s,ended:!1})},o=m=>t(m),v=()=>g({stream:d,buffer:s,ended:!0});i.add(R.toDisposable(()=>d.removeListener("error",o))),d.on("error",o),i.add(R.toDisposable(()=>d.removeListener("end",v))),d.on("end",v),i.add(R.toDisposable(()=>d.removeListener("data",n))),d.on("data",n)})}e.peekStream=l;function f(d,h){const g=A(h);return g.end(d),g}e.toStream=f;function c(){const d=A(()=>{throw new Error("not supported")});return d.end(),d}e.emptyStream=c;function u(d){let h=!1;return{read:()=>h?null:(h=!0,d)}}e.toReadable=u;function S(d,h,g){const t=A(g);return I(d,{onData:i=>t.write(h.data(i)),onError:i=>t.error(h.error?h.error(i):i),onEnd:()=>t.end()}),t}e.transform=S;function w(d,h,g){let t=!1;return{read:()=>{const i=h.read();return t?i:(t=!0,i!==null?g([d,i]):d)}}}e.prefixedReadable=w;function b(d,h,g){let t=!1;const i=A(g);return I(h,{onData:s=>t?i.write(s):(t=!0,i.write(g([d,s]))),onError:s=>i.error(s),onEnd:()=>{t||(t=!0,i.write(d)),i.end()}}),i}e.prefixedStream=b}),define(me[8],ge([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLeftDeleteOffset=e.GraphemeBreakType=e.breakBetweenGraphemeBreakType=e.getGraphemeBreakType=e.singleLetterHash=e.getNLines=e.uppercaseFirstLetter=e.containsUppercaseCharacter=e.fuzzyContains=e.stripUTF8BOM=e.startsWithUTF8BOM=e.UTF8_BOM_CHARACTER=e.removeAnsiEscapeCodes=e.lcut=e.isEmojiImprecise=e.isFullWidthCharacter=e.containsFullWidthCharacter=e.containsUnusualLineTerminators=e.UNUSUAL_LINE_TERMINATORS=e.isBasicASCII=e.containsEmoji=e.containsRTL=e.decodeUTF8=e.encodeUTF8=e.getCharContainingOffset=e.prevCharLength=e.nextCharLength=e.getNextCodePoint=e.computeCodePoint=e.isLowSurrogate=e.isHighSurrogate=e.commonSuffixLength=e.commonPrefixLength=e.startsWithIgnoreCase=e.equalsIgnoreCase=e.isUpperAsciiLetter=e.isLowerAsciiLetter=e.compareSubstringIgnoreCase=e.compareIgnoreCase=e.compareSubstring=e.compare=e.lastNonWhitespaceIndex=e.getLeadingWhitespace=e.firstNonWhitespaceIndex=e.splitLines=e.regExpFlags=e.regExpContainsBackreference=e.regExpLeadsToEndlessLoop=e.createRegExp=e.stripWildcards=e.convertSimple2RegExpPattern=e.rtrim=e.ltrim=e.trim=e.truncate=e.count=e.escapeRegExpCharacters=e.escape=e.format2=e.format=e.isFalsyOrWhitespace=void 0;function p(q){return!q||typeof q!="string"?!0:q.trim().length===0}e.isFalsyOrWhitespace=p;const R=/{(\d+)}/g;function C(q,...pe){return pe.length===0?q:q.replace(R,function(Se,Te){const Oe=parseInt(Te,10);return isNaN(Oe)||Oe<0||Oe>=pe.length?Se:pe[Oe]})}e.format=C;const y=/{([^}]+)}/g;function A(q,pe){return q.replace(y,(Se,Te)=>{var Oe;return(Oe=pe[Te])!==null&&Oe!==void 0?Oe:Se})}e.format2=A;function P(q){return q.replace(/[<>&]/g,function(pe){switch(pe){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return pe}})}e.escape=P;function E(q){return q.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.escapeRegExpCharacters=E;function k(q,pe){let Se=0;const Te=pe.charCodeAt(0);for(let Oe=q.length-1;Oe>=0;Oe--)q.charCodeAt(Oe)===Te&&Se++;return Se}e.count=k;function r(q,pe,Se="\u2026"){return q.length<=pe?q:`${q.substr(0,pe)}${Se}`}e.truncate=r;function I(q,pe=" "){const Se=l(q,pe);return f(Se,pe)}e.trim=I;function l(q,pe){if(!q||!pe)return q;const Se=pe.length;if(Se===0||q.length===0)return q;let Te=0;for(;q.indexOf(pe,Te)===Te;)Te=Te+Se;return q.substring(Te)}e.ltrim=l;function f(q,pe){if(!q||!pe)return q;const Se=pe.length,Te=q.length;if(Se===0||Te===0)return q;let Oe=Te,je=-1;for(;je=q.lastIndexOf(pe,Oe-1),!(je===-1||je+Se!==Oe);){if(je===0)return"";Oe=je}return q.substring(0,Oe)}e.rtrim=f;function c(q){return q.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.convertSimple2RegExpPattern=c;function u(q){return q.replace(/\*/g,"")}e.stripWildcards=u;function S(q,pe,Se={}){if(!q)throw new Error("Cannot create regex from empty string");pe||(q=E(q)),Se.wholeWord&&(/\B/.test(q.charAt(0))||(q="\\b"+q),/\B/.test(q.charAt(q.length-1))||(q=q+"\\b"));let Te="";return Se.global&&(Te+="g"),Se.matchCase||(Te+="i"),Se.multiline&&(Te+="m"),Se.unicode&&(Te+="u"),new RegExp(q,Te)}e.createRegExp=S;function w(q){return q.source==="^"||q.source==="^$"||q.source==="$"||q.source==="^\\s*$"?!1:!!(q.exec("")&&q.lastIndex===0)}e.regExpLeadsToEndlessLoop=w;function b(q){return!!q.match(/([^\\]|^)(\\\\)*\\\d+/)}e.regExpContainsBackreference=b;function d(q){return(q.global?"g":"")+(q.ignoreCase?"i":"")+(q.multiline?"m":"")+(q.unicode?"u":"")}e.regExpFlags=d;function h(q){return q.split(/\r\n|\r|\n/)}e.splitLines=h;function g(q){for(let pe=0,Se=q.length;pe<Se;pe++){const Te=q.charCodeAt(pe);if(Te!==32&&Te!==9)return pe}return-1}e.firstNonWhitespaceIndex=g;function t(q,pe=0,Se=q.length){for(let Te=pe;Te<Se;Te++){const Oe=q.charCodeAt(Te);if(Oe!==32&&Oe!==9)return q.substring(pe,Te)}return q.substring(pe,Se)}e.getLeadingWhitespace=t;function i(q,pe=q.length-1){for(let Se=pe;Se>=0;Se--){const Te=q.charCodeAt(Se);if(Te!==32&&Te!==9)return Se}return-1}e.lastNonWhitespaceIndex=i;function s(q,pe){return q<pe?-1:q>pe?1:0}e.compare=s;function n(q,pe,Se=0,Te=q.length,Oe=0,je=pe.length){for(;Se<Te&&Oe<je;Se++,Oe++){let nt=q.charCodeAt(Se),ct=pe.charCodeAt(Oe);if(nt<ct)return-1;if(nt>ct)return 1}const qe=Te-Se,Ze=je-Oe;return qe<Ze?-1:qe>Ze?1:0}e.compareSubstring=n;function o(q,pe){return v(q,pe,0,q.length,0,pe.length)}e.compareIgnoreCase=o;function v(q,pe,Se=0,Te=q.length,Oe=0,je=pe.length){for(;Se<Te&&Oe<je;Se++,Oe++){let nt=q.charCodeAt(Se),ct=pe.charCodeAt(Oe);if(nt===ct)continue;const Ee=nt-ct;if(!(Ee===32&&_(ct))&&!(Ee===-32&&_(nt)))return m(nt)&&m(ct)?Ee:n(q.toLowerCase(),pe.toLowerCase(),Se,Te,Oe,je)}const qe=Te-Se,Ze=je-Oe;return qe<Ze?-1:qe>Ze?1:0}e.compareSubstringIgnoreCase=v;function m(q){return q>=97&&q<=122}e.isLowerAsciiLetter=m;function _(q){return q>=65&&q<=90}e.isUpperAsciiLetter=_;function D(q){return m(q)||_(q)}function a(q,pe){return q.length===pe.length&&T(q,pe)}e.equalsIgnoreCase=a;function T(q,pe,Se=q.length){for(let Te=0;Te<Se;Te++){const Oe=q.charCodeAt(Te),je=pe.charCodeAt(Te);if(Oe!==je){if(D(Oe)&&D(je)){const qe=Math.abs(Oe-je);if(qe!==0&&qe!==32)return!1}else if(String.fromCharCode(Oe).toLowerCase()!==String.fromCharCode(je).toLowerCase())return!1}}return!0}function L(q,pe){const Se=pe.length;return pe.length>q.length?!1:T(q,pe,Se)}e.startsWithIgnoreCase=L;function U(q,pe){let Se,Te=Math.min(q.length,pe.length);for(Se=0;Se<Te;Se++)if(q.charCodeAt(Se)!==pe.charCodeAt(Se))return Se;return Te}e.commonPrefixLength=U;function G(q,pe){let Se,Te=Math.min(q.length,pe.length);const Oe=q.length-1,je=pe.length-1;for(Se=0;Se<Te;Se++)if(q.charCodeAt(Oe-Se)!==pe.charCodeAt(je-Se))return Se;return Te}e.commonSuffixLength=G;function ee(q){return 55296<=q&&q<=56319}e.isHighSurrogate=ee;function z(q){return 56320<=q&&q<=57343}e.isLowSurrogate=z;function N(q,pe){return(q-55296<<10)+(pe-56320)+65536}e.computeCodePoint=N;function W(q,pe,Se){const Te=q.charCodeAt(Se);if(ee(Te)&&Se+1<pe){const Oe=q.charCodeAt(Se+1);if(z(Oe))return N(Te,Oe)}return Te}e.getNextCodePoint=W;function M(q,pe){const Se=q.charCodeAt(pe-1);if(z(Se)&&pe>1){const Te=q.charCodeAt(pe-2);if(ee(Te))return N(Te,Se)}return Se}function j(q,pe){const Se=ke.getInstance(),Te=pe,Oe=q.length,je=W(q,Oe,pe);pe+=je>=65536?2:1;let qe=Se.getGraphemeBreakType(je);for(;pe<Oe;){const Ze=W(q,Oe,pe),nt=Se.getGraphemeBreakType(Ze);if(xe(qe,nt))break;pe+=Ze>=65536?2:1,qe=nt}return pe-Te}e.nextCharLength=j;function O(q,pe){const Se=ke.getInstance(),Te=pe,Oe=M(q,pe);pe-=Oe>=65536?2:1;let je=Se.getGraphemeBreakType(Oe);for(;pe>0;){const qe=M(q,pe),Ze=Se.getGraphemeBreakType(qe);if(xe(Ze,je))break;pe-=qe>=65536?2:1,je=Ze}return Te-pe}e.prevCharLength=O;function F(q,pe){const Se=ke.getInstance(),Te=q.length,Oe=pe,je=W(q,Te,pe),qe=Se.getGraphemeBreakType(je);pe+=je>=65536?2:1;let Ze=qe;for(;pe<Te;){const ct=W(q,Te,pe),Ee=Se.getGraphemeBreakType(ct);if(xe(Ze,Ee))break;pe+=ct>=65536?2:1,Ze=Ee}const nt=pe;for(pe=Oe,Ze=qe;pe>0;){const ct=M(q,pe),Ee=Se.getGraphemeBreakType(ct);if(xe(Ee,Ze))break;pe-=ct>=65536?2:1,Ze=Ee}return[pe,nt]}function B(q,pe){return pe>0&&z(q.charCodeAt(pe))?F(q,pe-1):F(q,pe)}e.getCharContainingOffset=B;function $(q){const pe=q.length;let Se=0,Te=0;for(;Te<pe;){const qe=W(q,pe,Te);Te+=qe>=65536?2:1,qe<128?Se+=1:qe<2048?Se+=2:qe<65536?Se+=3:Se+=4}const Oe=new Uint8Array(Se);Te=0;let je=0;for(;Te<pe;){const qe=W(q,pe,Te);Te+=qe>=65536?2:1,qe<128?Oe[je++]=qe:qe<2048?(Oe[je++]=192|(qe&1984)>>>6,Oe[je++]=128|(qe&63)>>>0):qe<65536?(Oe[je++]=224|(qe&61440)>>>12,Oe[je++]=128|(qe&4032)>>>6,Oe[je++]=128|(qe&63)>>>0):(Oe[je++]=240|(qe&1835008)>>>18,Oe[je++]=128|(qe&258048)>>>12,Oe[je++]=128|(qe&4032)>>>6,Oe[je++]=128|(qe&63)>>>0)}return Oe}e.encodeUTF8=$;function Y(q){const pe=q.byteLength,Se=[];let Te=0;for(;Te<pe;){const Oe=q[Te];let je;if(Oe>=240&&Te+3<pe?je=(q[Te++]&7)<<18>>>0|(q[Te++]&63)<<12>>>0|(q[Te++]&63)<<6>>>0|(q[Te++]&63)<<0>>>0:Oe>=224&&Te+2<pe?je=(q[Te++]&15)<<12>>>0|(q[Te++]&63)<<6>>>0|(q[Te++]&63)<<0>>>0:Oe>=192&&Te+1<pe?je=(q[Te++]&31)<<6>>>0|(q[Te++]&63)<<0>>>0:je=q[Te++],je>=0&&je<=55295||je>=57344&&je<=65535)Se.push(String.fromCharCode(je));else if(je>=65536&&je<=1114111){const qe=je-65536,Ze=55296+((qe&1047552)>>>10),nt=56320+((qe&1023)>>>0);Se.push(String.fromCharCode(Ze)),Se.push(String.fromCharCode(nt))}else Se.push(String.fromCharCode(65533))}return Se.join("")}e.decodeUTF8=Y;const le=/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u08BD\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE33\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDCFF]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD50-\uDFFF]|\uD83B[\uDC00-\uDEBB])/;function be(q){return le.test(q)}e.containsRTL=be;const Le=/(?:[\u231A\u231B\u23F0\u23F3\u2600-\u27BF\u2B50\u2B55]|\uD83C[\uDDE6-\uDDFF\uDF00-\uDFFF]|\uD83D[\uDC00-\uDE4F\uDE80-\uDEFC\uDFE0-\uDFEB]|\uD83E[\uDD00-\uDDFF\uDE70-\uDED6])/;function Ie(q){return Le.test(q)}e.containsEmoji=Ie;const Ue=/^[\t\n\r\x20-\x7E]*$/;function Qe(q){return Ue.test(q)}e.isBasicASCII=Qe,e.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function ze(q){return e.UNUSUAL_LINE_TERMINATORS.test(q)}e.containsUnusualLineTerminators=ze;function Ge(q){for(let pe=0,Se=q.length;pe<Se;pe++)if(V(q.charCodeAt(pe)))return!0;return!1}e.containsFullWidthCharacter=Ge;function V(q){return q=+q,q>=11904&&q<=55215||q>=63744&&q<=64255||q>=65281&&q<=65374}e.isFullWidthCharacter=V;function Z(q){return q>=127462&&q<=127487||q===8986||q===8987||q===9200||q===9203||q>=9728&&q<=10175||q===11088||q===11093||q>=127744&&q<=128591||q>=128640&&q<=128764||q>=128992&&q<=129003||q>=129280&&q<=129535||q>=129648&&q<=129750}e.isEmojiImprecise=Z;function ne(q,pe){if(q.length<pe)return q;const Se=/\b/g;let Te=0;for(;Se.test(q)&&!(q.length-Se.lastIndex<pe);)Te=Se.lastIndex,Se.lastIndex+=1;return q.substring(Te).replace(/^\s/,"")}e.lcut=ne;const se=/\x1B\x5B[12]?K/g,J=/\x1b\[\d+m/g,ae=/\x1b\[0?m/g;function he(q){return q&&(q=q.replace(se,""),q=q.replace(J,""),q=q.replace(ae,"")),q}e.removeAnsiEscapeCodes=he,e.UTF8_BOM_CHARACTER=String.fromCharCode(65279);function Fe(q){return!!(q&&q.length>0&&q.charCodeAt(0)===65279)}e.startsWithUTF8BOM=Fe;function He(q){return Fe(q)?q.substr(1):q}e.stripUTF8BOM=He;function _e(q,pe){if(!q||!pe||q.length<pe.length)return!1;const Se=pe.length,Te=q.toLowerCase();let Oe=0,je=-1;for(;Oe<Se;){const qe=Te.indexOf(pe[Oe],je+1);if(qe<0)return!1;je=qe,Oe++}return!0}e.fuzzyContains=_e;function Ye(q,pe=!1){return q?(pe&&(q=q.replace(/\\./g,"")),q.toLowerCase()!==q):!1}e.containsUppercaseCharacter=Ye;function K(q){return q.charAt(0).toUpperCase()+q.slice(1)}e.uppercaseFirstLetter=K;function ie(q,pe=1){if(pe===0)return"";let Se=-1;do Se=q.indexOf(`
`,Se+1),pe--;while(pe>0&&Se>=0);return Se===-1?q:(q[Se-1]==="\r"&&Se--,q.substr(0,Se))}e.getNLines=ie;function ve(q){const pe=90-65+1;return q=q%(2*pe),q<pe?String.fromCharCode(97+q):String.fromCharCode(65+q-pe)}e.singleLetterHash=ve;function Me(q){return ke.getInstance().getGraphemeBreakType(q)}e.getGraphemeBreakType=Me;function xe(q,pe){return q===0?pe!==5&&pe!==7:q===2&&pe===3?!1:q===4||q===2||q===3||pe===4||pe===2||pe===3?!0:!(q===8&&(pe===8||pe===9||pe===11||pe===12)||(q===11||q===9)&&(pe===9||pe===10)||(q===12||q===10)&&pe===10||pe===5||pe===13||pe===7||q===1||q===13&&pe===14||q===6&&pe===6)}e.breakBetweenGraphemeBreakType=xe;var Je;(function(q){q[q.Other=0]="Other",q[q.Prepend=1]="Prepend",q[q.CR=2]="CR",q[q.LF=3]="LF",q[q.Control=4]="Control",q[q.Extend=5]="Extend",q[q.Regional_Indicator=6]="Regional_Indicator",q[q.SpacingMark=7]="SpacingMark",q[q.L=8]="L",q[q.V=9]="V",q[q.T=10]="T",q[q.LV=11]="LV",q[q.LVT=12]="LVT",q[q.ZWJ=13]="ZWJ",q[q.Extended_Pictographic=14]="Extended_Pictographic"})(Je=e.GraphemeBreakType||(e.GraphemeBreakType={}));class ke{constructor(){this._data=ye()}static getInstance(){return ke._INSTANCE||(ke._INSTANCE=new ke),ke._INSTANCE}getGraphemeBreakType(pe){if(pe<32)return pe===10?3:pe===13?2:4;if(pe<127)return 0;const Se=this._data,Te=Se.length/3;let Oe=1;for(;Oe<=Te;)if(pe<Se[3*Oe])Oe=2*Oe;else if(pe>Se[3*Oe+1])Oe=2*Oe+1;else return Se[3*Oe+2];return 0}}ke._INSTANCE=null;function ye(){return JSON.parse("[0,0,0,51592,51592,11,44424,44424,11,72251,72254,5,7150,7150,7,48008,48008,11,55176,55176,11,128420,128420,14,3276,3277,5,9979,9980,14,46216,46216,11,49800,49800,11,53384,53384,11,70726,70726,5,122915,122916,5,129320,129327,14,2558,2558,5,5906,5908,5,9762,9763,14,43360,43388,8,45320,45320,11,47112,47112,11,48904,48904,11,50696,50696,11,52488,52488,11,54280,54280,11,70082,70083,1,71350,71350,7,73111,73111,5,127892,127893,14,128726,128727,14,129473,129474,14,2027,2035,5,2901,2902,5,3784,3789,5,6754,6754,5,8418,8420,5,9877,9877,14,11088,11088,14,44008,44008,5,44872,44872,11,45768,45768,11,46664,46664,11,47560,47560,11,48456,48456,11,49352,49352,11,50248,50248,11,51144,51144,11,52040,52040,11,52936,52936,11,53832,53832,11,54728,54728,11,69811,69814,5,70459,70460,5,71096,71099,7,71998,71998,5,72874,72880,5,119149,119149,7,127374,127374,14,128335,128335,14,128482,128482,14,128765,128767,14,129399,129400,14,129680,129685,14,1476,1477,5,2377,2380,7,2759,2760,5,3137,3140,7,3458,3459,7,4153,4154,5,6432,6434,5,6978,6978,5,7675,7679,5,9723,9726,14,9823,9823,14,9919,9923,14,10035,10036,14,42736,42737,5,43596,43596,5,44200,44200,11,44648,44648,11,45096,45096,11,45544,45544,11,45992,45992,11,46440,46440,11,46888,46888,11,47336,47336,11,47784,47784,11,48232,48232,11,48680,48680,11,49128,49128,11,49576,49576,11,50024,50024,11,50472,50472,11,50920,50920,11,51368,51368,11,51816,51816,11,52264,52264,11,52712,52712,11,53160,53160,11,53608,53608,11,54056,54056,11,54504,54504,11,54952,54952,11,68108,68111,5,69933,69940,5,70197,70197,7,70498,70499,7,70845,70845,5,71229,71229,5,71727,71735,5,72154,72155,5,72344,72345,5,73023,73029,5,94095,94098,5,121403,121452,5,126981,127182,14,127538,127546,14,127990,127990,14,128391,128391,14,128445,128449,14,128500,128505,14,128752,128752,14,129160,129167,14,129356,129356,14,129432,129442,14,129648,129651,14,129751,131069,14,173,173,4,1757,1757,1,2274,2274,1,2494,2494,5,2641,2641,5,2876,2876,5,3014,3016,7,3262,3262,7,3393,3396,5,3570,3571,7,3968,3972,5,4228,4228,7,6086,6086,5,6679,6680,5,6912,6915,5,7080,7081,5,7380,7392,5,8252,8252,14,9096,9096,14,9748,9749,14,9784,9786,14,9833,9850,14,9890,9894,14,9938,9938,14,9999,9999,14,10085,10087,14,12349,12349,14,43136,43137,7,43454,43456,7,43755,43755,7,44088,44088,11,44312,44312,11,44536,44536,11,44760,44760,11,44984,44984,11,45208,45208,11,45432,45432,11,45656,45656,11,45880,45880,11,46104,46104,11,46328,46328,11,46552,46552,11,46776,46776,11,47000,47000,11,47224,47224,11,47448,47448,11,47672,47672,11,47896,47896,11,48120,48120,11,48344,48344,11,48568,48568,11,48792,48792,11,49016,49016,11,49240,49240,11,49464,49464,11,49688,49688,11,49912,49912,11,50136,50136,11,50360,50360,11,50584,50584,11,50808,50808,11,51032,51032,11,51256,51256,11,51480,51480,11,51704,51704,11,51928,51928,11,52152,52152,11,52376,52376,11,52600,52600,11,52824,52824,11,53048,53048,11,53272,53272,11,53496,53496,11,53720,53720,11,53944,53944,11,54168,54168,11,54392,54392,11,54616,54616,11,54840,54840,11,55064,55064,11,65438,65439,5,69633,69633,5,69837,69837,1,70018,70018,7,70188,70190,7,70368,70370,7,70465,70468,7,70712,70719,5,70835,70840,5,70850,70851,5,71132,71133,5,71340,71340,7,71458,71461,5,71985,71989,7,72002,72002,7,72193,72202,5,72281,72283,5,72766,72766,7,72885,72886,5,73104,73105,5,92912,92916,5,113824,113827,4,119173,119179,5,121505,121519,5,125136,125142,5,127279,127279,14,127489,127490,14,127570,127743,14,127900,127901,14,128254,128254,14,128369,128370,14,128400,128400,14,128425,128432,14,128468,128475,14,128489,128494,14,128715,128720,14,128745,128745,14,128759,128760,14,129004,129023,14,129296,129304,14,129340,129342,14,129388,129392,14,129404,129407,14,129454,129455,14,129485,129487,14,129659,129663,14,129719,129727,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2363,2363,7,2402,2403,5,2507,2508,7,2622,2624,7,2691,2691,7,2786,2787,5,2881,2884,5,3006,3006,5,3072,3072,5,3170,3171,5,3267,3268,7,3330,3331,7,3406,3406,1,3538,3540,5,3655,3662,5,3897,3897,5,4038,4038,5,4184,4185,5,4352,4447,8,6068,6069,5,6155,6157,5,6448,6449,7,6742,6742,5,6783,6783,5,6966,6970,5,7042,7042,7,7143,7143,7,7212,7219,5,7412,7412,5,8206,8207,4,8294,8303,4,8596,8601,14,9410,9410,14,9742,9742,14,9757,9757,14,9770,9770,14,9794,9794,14,9828,9828,14,9855,9855,14,9882,9882,14,9900,9903,14,9929,9933,14,9963,9967,14,9987,9988,14,10006,10006,14,10062,10062,14,10175,10175,14,11744,11775,5,42607,42607,5,43043,43044,7,43263,43263,5,43444,43445,7,43569,43570,5,43698,43700,5,43766,43766,5,44032,44032,11,44144,44144,11,44256,44256,11,44368,44368,11,44480,44480,11,44592,44592,11,44704,44704,11,44816,44816,11,44928,44928,11,45040,45040,11,45152,45152,11,45264,45264,11,45376,45376,11,45488,45488,11,45600,45600,11,45712,45712,11,45824,45824,11,45936,45936,11,46048,46048,11,46160,46160,11,46272,46272,11,46384,46384,11,46496,46496,11,46608,46608,11,46720,46720,11,46832,46832,11,46944,46944,11,47056,47056,11,47168,47168,11,47280,47280,11,47392,47392,11,47504,47504,11,47616,47616,11,47728,47728,11,47840,47840,11,47952,47952,11,48064,48064,11,48176,48176,11,48288,48288,11,48400,48400,11,48512,48512,11,48624,48624,11,48736,48736,11,48848,48848,11,48960,48960,11,49072,49072,11,49184,49184,11,49296,49296,11,49408,49408,11,49520,49520,11,49632,49632,11,49744,49744,11,49856,49856,11,49968,49968,11,50080,50080,11,50192,50192,11,50304,50304,11,50416,50416,11,50528,50528,11,50640,50640,11,50752,50752,11,50864,50864,11,50976,50976,11,51088,51088,11,51200,51200,11,51312,51312,11,51424,51424,11,51536,51536,11,51648,51648,11,51760,51760,11,51872,51872,11,51984,51984,11,52096,52096,11,52208,52208,11,52320,52320,11,52432,52432,11,52544,52544,11,52656,52656,11,52768,52768,11,52880,52880,11,52992,52992,11,53104,53104,11,53216,53216,11,53328,53328,11,53440,53440,11,53552,53552,11,53664,53664,11,53776,53776,11,53888,53888,11,54000,54000,11,54112,54112,11,54224,54224,11,54336,54336,11,54448,54448,11,54560,54560,11,54672,54672,11,54784,54784,11,54896,54896,11,55008,55008,11,55120,55120,11,64286,64286,5,66272,66272,5,68900,68903,5,69762,69762,7,69817,69818,5,69927,69931,5,70003,70003,5,70070,70078,5,70094,70094,7,70194,70195,7,70206,70206,5,70400,70401,5,70463,70463,7,70475,70477,7,70512,70516,5,70722,70724,5,70832,70832,5,70842,70842,5,70847,70848,5,71088,71089,7,71102,71102,7,71219,71226,5,71231,71232,5,71342,71343,7,71453,71455,5,71463,71467,5,71737,71738,5,71995,71996,5,72000,72000,7,72145,72147,7,72160,72160,5,72249,72249,7,72273,72278,5,72330,72342,5,72752,72758,5,72850,72871,5,72882,72883,5,73018,73018,5,73031,73031,5,73109,73109,5,73461,73462,7,94031,94031,5,94192,94193,7,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,126976,126979,14,127184,127231,14,127344,127345,14,127405,127461,14,127514,127514,14,127561,127567,14,127778,127779,14,127896,127896,14,127985,127986,14,127995,127999,5,128326,128328,14,128360,128366,14,128378,128378,14,128394,128397,14,128405,128406,14,128422,128423,14,128435,128443,14,128453,128464,14,128479,128480,14,128484,128487,14,128496,128498,14,128640,128709,14,128723,128724,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129096,129103,14,129292,129292,14,129311,129311,14,129329,129330,14,129344,129349,14,129360,129374,14,129394,129394,14,129402,129402,14,129413,129425,14,129445,129450,14,129466,129471,14,129483,129483,14,129511,129535,14,129653,129655,14,129667,129670,14,129705,129711,14,129731,129743,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2307,2307,7,2366,2368,7,2382,2383,7,2434,2435,7,2497,2500,5,2519,2519,5,2563,2563,7,2631,2632,5,2677,2677,5,2750,2752,7,2763,2764,7,2817,2817,5,2879,2879,5,2891,2892,7,2914,2915,5,3008,3008,5,3021,3021,5,3076,3076,5,3146,3149,5,3202,3203,7,3264,3265,7,3271,3272,7,3298,3299,5,3390,3390,5,3402,3404,7,3426,3427,5,3535,3535,5,3544,3550,7,3635,3635,7,3763,3763,7,3893,3893,5,3953,3966,5,3981,3991,5,4145,4145,7,4157,4158,5,4209,4212,5,4237,4237,5,4520,4607,10,5970,5971,5,6071,6077,5,6089,6099,5,6277,6278,5,6439,6440,5,6451,6456,7,6683,6683,5,6744,6750,5,6765,6770,7,6846,6846,5,6964,6964,5,6972,6972,5,7019,7027,5,7074,7077,5,7083,7085,5,7146,7148,7,7154,7155,7,7222,7223,5,7394,7400,5,7416,7417,5,8204,8204,5,8233,8233,4,8288,8292,4,8413,8416,5,8482,8482,14,8986,8987,14,9193,9203,14,9654,9654,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9775,14,9792,9792,14,9800,9811,14,9825,9826,14,9831,9831,14,9852,9853,14,9872,9873,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9936,9936,14,9941,9960,14,9974,9974,14,9982,9985,14,9992,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10145,10145,14,11013,11015,14,11503,11505,5,12334,12335,5,12951,12951,14,42612,42621,5,43014,43014,5,43047,43047,7,43204,43205,5,43335,43345,5,43395,43395,7,43450,43451,7,43561,43566,5,43573,43574,5,43644,43644,5,43710,43711,5,43758,43759,7,44005,44005,5,44012,44012,7,44060,44060,11,44116,44116,11,44172,44172,11,44228,44228,11,44284,44284,11,44340,44340,11,44396,44396,11,44452,44452,11,44508,44508,11,44564,44564,11,44620,44620,11,44676,44676,11,44732,44732,11,44788,44788,11,44844,44844,11,44900,44900,11,44956,44956,11,45012,45012,11,45068,45068,11,45124,45124,11,45180,45180,11,45236,45236,11,45292,45292,11,45348,45348,11,45404,45404,11,45460,45460,11,45516,45516,11,45572,45572,11,45628,45628,11,45684,45684,11,45740,45740,11,45796,45796,11,45852,45852,11,45908,45908,11,45964,45964,11,46020,46020,11,46076,46076,11,46132,46132,11,46188,46188,11,46244,46244,11,46300,46300,11,46356,46356,11,46412,46412,11,46468,46468,11,46524,46524,11,46580,46580,11,46636,46636,11,46692,46692,11,46748,46748,11,46804,46804,11,46860,46860,11,46916,46916,11,46972,46972,11,47028,47028,11,47084,47084,11,47140,47140,11,47196,47196,11,47252,47252,11,47308,47308,11,47364,47364,11,47420,47420,11,47476,47476,11,47532,47532,11,47588,47588,11,47644,47644,11,47700,47700,11,47756,47756,11,47812,47812,11,47868,47868,11,47924,47924,11,47980,47980,11,48036,48036,11,48092,48092,11,48148,48148,11,48204,48204,11,48260,48260,11,48316,48316,11,48372,48372,11,48428,48428,11,48484,48484,11,48540,48540,11,48596,48596,11,48652,48652,11,48708,48708,11,48764,48764,11,48820,48820,11,48876,48876,11,48932,48932,11,48988,48988,11,49044,49044,11,49100,49100,11,49156,49156,11,49212,49212,11,49268,49268,11,49324,49324,11,49380,49380,11,49436,49436,11,49492,49492,11,49548,49548,11,49604,49604,11,49660,49660,11,49716,49716,11,49772,49772,11,49828,49828,11,49884,49884,11,49940,49940,11,49996,49996,11,50052,50052,11,50108,50108,11,50164,50164,11,50220,50220,11,50276,50276,11,50332,50332,11,50388,50388,11,50444,50444,11,50500,50500,11,50556,50556,11,50612,50612,11,50668,50668,11,50724,50724,11,50780,50780,11,50836,50836,11,50892,50892,11,50948,50948,11,51004,51004,11,51060,51060,11,51116,51116,11,51172,51172,11,51228,51228,11,51284,51284,11,51340,51340,11,51396,51396,11,51452,51452,11,51508,51508,11,51564,51564,11,51620,51620,11,51676,51676,11,51732,51732,11,51788,51788,11,51844,51844,11,51900,51900,11,51956,51956,11,52012,52012,11,52068,52068,11,52124,52124,11,52180,52180,11,52236,52236,11,52292,52292,11,52348,52348,11,52404,52404,11,52460,52460,11,52516,52516,11,52572,52572,11,52628,52628,11,52684,52684,11,52740,52740,11,52796,52796,11,52852,52852,11,52908,52908,11,52964,52964,11,53020,53020,11,53076,53076,11,53132,53132,11,53188,53188,11,53244,53244,11,53300,53300,11,53356,53356,11,53412,53412,11,53468,53468,11,53524,53524,11,53580,53580,11,53636,53636,11,53692,53692,11,53748,53748,11,53804,53804,11,53860,53860,11,53916,53916,11,53972,53972,11,54028,54028,11,54084,54084,11,54140,54140,11,54196,54196,11,54252,54252,11,54308,54308,11,54364,54364,11,54420,54420,11,54476,54476,11,54532,54532,11,54588,54588,11,54644,54644,11,54700,54700,11,54756,54756,11,54812,54812,11,54868,54868,11,54924,54924,11,54980,54980,11,55036,55036,11,55092,55092,11,55148,55148,11,55216,55238,9,65056,65071,5,65529,65531,4,68097,68099,5,68159,68159,5,69446,69456,5,69688,69702,5,69808,69810,7,69815,69816,7,69821,69821,1,69888,69890,5,69932,69932,7,69957,69958,7,70016,70017,5,70067,70069,7,70079,70080,7,70089,70092,5,70095,70095,5,70191,70193,5,70196,70196,5,70198,70199,5,70367,70367,5,70371,70378,5,70402,70403,7,70462,70462,5,70464,70464,5,70471,70472,7,70487,70487,5,70502,70508,5,70709,70711,7,70720,70721,7,70725,70725,7,70750,70750,5,70833,70834,7,70841,70841,7,70843,70844,7,70846,70846,7,70849,70849,7,71087,71087,5,71090,71093,5,71100,71101,5,71103,71104,5,71216,71218,7,71227,71228,7,71230,71230,7,71339,71339,5,71341,71341,5,71344,71349,5,71351,71351,5,71456,71457,7,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123628,123631,5,125252,125258,5,126980,126980,14,127183,127183,14,127245,127247,14,127340,127343,14,127358,127359,14,127377,127386,14,127462,127487,6,127491,127503,14,127535,127535,14,127548,127551,14,127568,127569,14,127744,127777,14,127780,127891,14,127894,127895,14,127897,127899,14,127902,127984,14,127987,127989,14,127991,127994,14,128000,128253,14,128255,128317,14,128329,128334,14,128336,128359,14,128367,128368,14,128371,128377,14,128379,128390,14,128392,128393,14,128398,128399,14,128401,128404,14,128407,128419,14,128421,128421,14,128424,128424,14,128433,128434,14,128444,128444,14,128450,128452,14,128465,128467,14,128476,128478,14,128481,128481,14,128483,128483,14,128488,128488,14,128495,128495,14,128499,128499,14,128506,128591,14,128710,128714,14,128721,128722,14,128725,128725,14,128728,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129664,129666,14,129671,129679,14,129686,129704,14,129712,129718,14,129728,129730,14,129744,129750,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2259,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3134,3136,5,3142,3144,5,3157,3158,5,3201,3201,5,3260,3260,5,3263,3263,5,3266,3266,5,3270,3270,5,3274,3275,7,3285,3286,5,3328,3329,5,3387,3388,5,3391,3392,7,3398,3400,7,3405,3405,5,3415,3415,5,3457,3457,5,3530,3530,5,3536,3537,7,3542,3542,5,3551,3551,5,3633,3633,5,3636,3642,5,3761,3761,5,3764,3772,5,3864,3865,5,3895,3895,5,3902,3903,7,3967,3967,7,3974,3975,5,3993,4028,5,4141,4144,5,4146,4151,5,4155,4156,7,4182,4183,7,4190,4192,5,4226,4226,5,4229,4230,5,4253,4253,5,4448,4519,9,4957,4959,5,5938,5940,5,6002,6003,5,6070,6070,7,6078,6085,7,6087,6088,7,6109,6109,5,6158,6158,4,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6848,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7673,5,8203,8203,4,8205,8205,13,8232,8232,4,8234,8238,4,8265,8265,14,8293,8293,4,8400,8412,5,8417,8417,5,8421,8432,5,8505,8505,14,8617,8618,14,9000,9000,14,9167,9167,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9776,9783,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9935,14,9937,9937,14,9939,9940,14,9961,9962,14,9968,9973,14,9975,9978,14,9981,9981,14,9986,9986,14,9989,9989,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10084,14,10133,10135,14,10160,10160,14,10548,10549,14,11035,11036,14,11093,11093,14,11647,11647,5,12330,12333,5,12336,12336,14,12441,12442,5,12953,12953,14,42608,42610,5,42654,42655,5,43010,43010,5,43019,43019,5,43045,43046,5,43052,43052,5,43188,43203,7,43232,43249,5,43302,43309,5,43346,43347,7,43392,43394,5,43443,43443,5,43446,43449,5,43452,43453,5,43493,43493,5,43567,43568,7,43571,43572,7,43587,43587,5,43597,43597,7,43696,43696,5,43703,43704,5,43713,43713,5,43756,43757,5,43765,43765,7,44003,44004,7,44006,44007,7,44009,44010,7,44013,44013,5,44033,44059,12,44061,44087,12,44089,44115,12,44117,44143,12,44145,44171,12,44173,44199,12,44201,44227,12,44229,44255,12,44257,44283,12,44285,44311,12,44313,44339,12,44341,44367,12,44369,44395,12,44397,44423,12,44425,44451,12,44453,44479,12,44481,44507,12,44509,44535,12,44537,44563,12,44565,44591,12,44593,44619,12,44621,44647,12,44649,44675,12,44677,44703,12,44705,44731,12,44733,44759,12,44761,44787,12,44789,44815,12,44817,44843,12,44845,44871,12,44873,44899,12,44901,44927,12,44929,44955,12,44957,44983,12,44985,45011,12,45013,45039,12,45041,45067,12,45069,45095,12,45097,45123,12,45125,45151,12,45153,45179,12,45181,45207,12,45209,45235,12,45237,45263,12,45265,45291,12,45293,45319,12,45321,45347,12,45349,45375,12,45377,45403,12,45405,45431,12,45433,45459,12,45461,45487,12,45489,45515,12,45517,45543,12,45545,45571,12,45573,45599,12,45601,45627,12,45629,45655,12,45657,45683,12,45685,45711,12,45713,45739,12,45741,45767,12,45769,45795,12,45797,45823,12,45825,45851,12,45853,45879,12,45881,45907,12,45909,45935,12,45937,45963,12,45965,45991,12,45993,46019,12,46021,46047,12,46049,46075,12,46077,46103,12,46105,46131,12,46133,46159,12,46161,46187,12,46189,46215,12,46217,46243,12,46245,46271,12,46273,46299,12,46301,46327,12,46329,46355,12,46357,46383,12,46385,46411,12,46413,46439,12,46441,46467,12,46469,46495,12,46497,46523,12,46525,46551,12,46553,46579,12,46581,46607,12,46609,46635,12,46637,46663,12,46665,46691,12,46693,46719,12,46721,46747,12,46749,46775,12,46777,46803,12,46805,46831,12,46833,46859,12,46861,46887,12,46889,46915,12,46917,46943,12,46945,46971,12,46973,46999,12,47001,47027,12,47029,47055,12,47057,47083,12,47085,47111,12,47113,47139,12,47141,47167,12,47169,47195,12,47197,47223,12,47225,47251,12,47253,47279,12,47281,47307,12,47309,47335,12,47337,47363,12,47365,47391,12,47393,47419,12,47421,47447,12,47449,47475,12,47477,47503,12,47505,47531,12,47533,47559,12,47561,47587,12,47589,47615,12,47617,47643,12,47645,47671,12,47673,47699,12,47701,47727,12,47729,47755,12,47757,47783,12,47785,47811,12,47813,47839,12,47841,47867,12,47869,47895,12,47897,47923,12,47925,47951,12,47953,47979,12,47981,48007,12,48009,48035,12,48037,48063,12,48065,48091,12,48093,48119,12,48121,48147,12,48149,48175,12,48177,48203,12,48205,48231,12,48233,48259,12,48261,48287,12,48289,48315,12,48317,48343,12,48345,48371,12,48373,48399,12,48401,48427,12,48429,48455,12,48457,48483,12,48485,48511,12,48513,48539,12,48541,48567,12,48569,48595,12,48597,48623,12,48625,48651,12,48653,48679,12,48681,48707,12,48709,48735,12,48737,48763,12,48765,48791,12,48793,48819,12,48821,48847,12,48849,48875,12,48877,48903,12,48905,48931,12,48933,48959,12,48961,48987,12,48989,49015,12,49017,49043,12,49045,49071,12,49073,49099,12,49101,49127,12,49129,49155,12,49157,49183,12,49185,49211,12,49213,49239,12,49241,49267,12,49269,49295,12,49297,49323,12,49325,49351,12,49353,49379,12,49381,49407,12,49409,49435,12,49437,49463,12,49465,49491,12,49493,49519,12,49521,49547,12,49549,49575,12,49577,49603,12,49605,49631,12,49633,49659,12,49661,49687,12,49689,49715,12,49717,49743,12,49745,49771,12,49773,49799,12,49801,49827,12,49829,49855,12,49857,49883,12,49885,49911,12,49913,49939,12,49941,49967,12,49969,49995,12,49997,50023,12,50025,50051,12,50053,50079,12,50081,50107,12,50109,50135,12,50137,50163,12,50165,50191,12,50193,50219,12,50221,50247,12,50249,50275,12,50277,50303,12,50305,50331,12,50333,50359,12,50361,50387,12,50389,50415,12,50417,50443,12,50445,50471,12,50473,50499,12,50501,50527,12,50529,50555,12,50557,50583,12,50585,50611,12,50613,50639,12,50641,50667,12,50669,50695,12,50697,50723,12,50725,50751,12,50753,50779,12,50781,50807,12,50809,50835,12,50837,50863,12,50865,50891,12,50893,50919,12,50921,50947,12,50949,50975,12,50977,51003,12,51005,51031,12,51033,51059,12,51061,51087,12,51089,51115,12,51117,51143,12,51145,51171,12,51173,51199,12,51201,51227,12,51229,51255,12,51257,51283,12,51285,51311,12,51313,51339,12,51341,51367,12,51369,51395,12,51397,51423,12,51425,51451,12,51453,51479,12,51481,51507,12,51509,51535,12,51537,51563,12,51565,51591,12,51593,51619,12,51621,51647,12,51649,51675,12,51677,51703,12,51705,51731,12,51733,51759,12,51761,51787,12,51789,51815,12,51817,51843,12,51845,51871,12,51873,51899,12,51901,51927,12,51929,51955,12,51957,51983,12,51985,52011,12,52013,52039,12,52041,52067,12,52069,52095,12,52097,52123,12,52125,52151,12,52153,52179,12,52181,52207,12,52209,52235,12,52237,52263,12,52265,52291,12,52293,52319,12,52321,52347,12,52349,52375,12,52377,52403,12,52405,52431,12,52433,52459,12,52461,52487,12,52489,52515,12,52517,52543,12,52545,52571,12,52573,52599,12,52601,52627,12,52629,52655,12,52657,52683,12,52685,52711,12,52713,52739,12,52741,52767,12,52769,52795,12,52797,52823,12,52825,52851,12,52853,52879,12,52881,52907,12,52909,52935,12,52937,52963,12,52965,52991,12,52993,53019,12,53021,53047,12,53049,53075,12,53077,53103,12,53105,53131,12,53133,53159,12,53161,53187,12,53189,53215,12,53217,53243,12,53245,53271,12,53273,53299,12,53301,53327,12,53329,53355,12,53357,53383,12,53385,53411,12,53413,53439,12,53441,53467,12,53469,53495,12,53497,53523,12,53525,53551,12,53553,53579,12,53581,53607,12,53609,53635,12,53637,53663,12,53665,53691,12,53693,53719,12,53721,53747,12,53749,53775,12,53777,53803,12,53805,53831,12,53833,53859,12,53861,53887,12,53889,53915,12,53917,53943,12,53945,53971,12,53973,53999,12,54001,54027,12,54029,54055,12,54057,54083,12,54085,54111,12,54113,54139,12,54141,54167,12,54169,54195,12,54197,54223,12,54225,54251,12,54253,54279,12,54281,54307,12,54309,54335,12,54337,54363,12,54365,54391,12,54393,54419,12,54421,54447,12,54449,54475,12,54477,54503,12,54505,54531,12,54533,54559,12,54561,54587,12,54589,54615,12,54617,54643,12,54645,54671,12,54673,54699,12,54701,54727,12,54729,54755,12,54757,54783,12,54785,54811,12,54813,54839,12,54841,54867,12,54869,54895,12,54897,54923,12,54925,54951,12,54953,54979,12,54981,55007,12,55009,55035,12,55037,55063,12,55065,55091,12,55093,55119,12,55121,55147,12,55149,55175,12,55177,55203,12,55243,55291,10,65024,65039,5,65279,65279,4,65520,65528,4,66045,66045,5,66422,66426,5,68101,68102,5,68152,68154,5,68325,68326,5,69291,69292,5,69632,69632,7,69634,69634,7,69759,69761,5]")}function Ae(q,pe){if(q===0)return 0;const Se=oe(q,pe);if(Se!==void 0)return Se;const Te=M(pe,q);return q-=ue(Te),q}e.getLeftDeleteOffset=Ae;function oe(q,pe){let Se=M(pe,q);for(q-=ue(Se);fe(Se)||Se===65039||Se===8419;){if(q===0)return;Se=M(pe,q),q-=ue(Se)}if(!!Z(Se)){if(q>=0){const Te=M(pe,q);Te===8205&&(q-=ue(Te))}return q}}function ue(q){return q>=65536?2:1}function fe(q){return 127995<=q&&q<=127999}var we;(function(q){q[q.zwj=8205]="zwj",q[q.emojiVariantSelector=65039]="emojiVariantSelector",q[q.enclosingKeyCap=8419]="enclosingKeyCap"})(we||(we={}))}),define(me[22],ge([0,1,8,91]),function(X,e,p,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const C=typeof Buffer!="undefined",y=typeof TextEncoder!="undefined",A=typeof TextDecoder!="undefined";let P,E;class k{constructor(m){this.buffer=m,this.byteLength=this.buffer.byteLength}static alloc(m){return C?new k(Buffer.allocUnsafe(m)):new k(new Uint8Array(m))}static wrap(m){return C&&!Buffer.isBuffer(m)&&(m=Buffer.from(m.buffer,m.byteOffset,m.byteLength)),new k(m)}static fromString(m,_){return!((_==null?void 0:_.dontUseNodeBuffer)||!1)&&C?new k(Buffer.from(m)):y?(P||(P=new TextEncoder),new k(P.encode(m))):new k(p.encodeUTF8(m))}static concat(m,_){if(typeof _=="undefined"){_=0;for(let T=0,L=m.length;T<L;T++)_+=m[T].byteLength}const D=k.alloc(_);let a=0;for(let T=0,L=m.length;T<L;T++){const U=m[T];D.set(U,a),a+=U.byteLength}return D}toString(){return C?this.buffer.toString():A?(E||(E=new TextDecoder),E.decode(this.buffer)):p.decodeUTF8(this.buffer)}slice(m,_){return new k(this.buffer.subarray(m,_))}set(m,_){m instanceof k?this.buffer.set(m.buffer,_):this.buffer.set(m,_)}readUInt32BE(m){return l(this.buffer,m)}writeUInt32BE(m,_){f(this.buffer,m,_)}readUInt32LE(m){return c(this.buffer,m)}writeUInt32LE(m,_){u(this.buffer,m,_)}readUInt8(m){return S(this.buffer,m)}writeUInt8(m,_){w(this.buffer,m,_)}}e.VSBuffer=k;function r(v,m){return v[m+0]<<0>>>0|v[m+1]<<8>>>0}e.readUInt16LE=r;function I(v,m,_){v[_+0]=m&255,m=m>>>8,v[_+1]=m&255}e.writeUInt16LE=I;function l(v,m){return v[m]*2**24+v[m+1]*2**16+v[m+2]*2**8+v[m+3]}e.readUInt32BE=l;function f(v,m,_){v[_+3]=m,m=m>>>8,v[_+2]=m,m=m>>>8,v[_+1]=m,m=m>>>8,v[_]=m}e.writeUInt32BE=f;function c(v,m){return v[m+0]<<0>>>0|v[m+1]<<8>>>0|v[m+2]<<16>>>0|v[m+3]<<24>>>0}e.readUInt32LE=c;function u(v,m,_){v[_+0]=m&255,m=m>>>8,v[_+1]=m&255,m=m>>>8,v[_+2]=m&255,m=m>>>8,v[_+3]=m&255}e.writeUInt32LE=u;function S(v,m){return v[m]}e.readUInt8=S;function w(v,m,_){v[_]=m}e.writeUInt8=w;function b(v){return R.consumeReadable(v,m=>k.concat(m))}e.readableToBuffer=b;function d(v){return R.toReadable(v)}e.bufferToReadable=d;function h(v){return R.consumeStream(v,m=>k.concat(m))}e.streamToBuffer=h;async function g(v){return v.ended?k.concat(v.buffer):k.concat([...v.buffer,await h(v.stream)])}e.bufferedStreamToBuffer=g;function t(v){return R.toStream(v,m=>k.concat(m))}e.bufferToStream=t;function i(v){return R.transform(v,{data:m=>typeof m=="string"?k.fromString(m):k.wrap(m)},m=>k.concat(m))}e.streamToBufferReadableStream=i;function s(v){return R.newWriteableStream(m=>k.concat(m),v)}e.newWriteableBufferStream=s;function n(v,m){return R.prefixedReadable(v,m,_=>k.concat(_))}e.prefixedBufferReadable=n;function o(v,m){return R.prefixedStream(v,m,_=>k.concat(_))}e.prefixedBufferStream=o}),define(me[73],ge([0,1,8]),function(X,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringSHA1=e.toHexString=e.Hasher=e.stringHash=e.doHash=e.hash=void 0;function R(w){return C(w,0)}e.hash=R;function C(w,b){switch(typeof w){case"object":return w===null?y(349,b):Array.isArray(w)?E(w,b):k(w,b);case"string":return P(w,b);case"boolean":return A(w,b);case"number":return y(w,b);case"undefined":return y(937,b);default:return y(617,b)}}e.doHash=C;function y(w,b){return(b<<5)-b+w|0}function A(w,b){return y(w?433:863,b)}function P(w,b){b=y(149417,b);for(let d=0,h=w.length;d<h;d++)b=y(w.charCodeAt(d),b);return b}e.stringHash=P;function E(w,b){return b=y(104579,b),w.reduce((d,h)=>C(h,d),b)}function k(w,b){return b=y(181387,b),Object.keys(w).sort().reduce((d,h)=>(d=P(h,d),C(w[h],d)),b)}class r{constructor(){this._value=0}get value(){return this._value}hash(b){return this._value=C(b,this._value),this._value}}e.Hasher=r;var I;(function(w){w[w.BLOCK_SIZE=64]="BLOCK_SIZE",w[w.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(I||(I={}));function l(w,b,d=32){const h=d-b,g=~((1<<h)-1);return(w<<b|(g&w)>>>h)>>>0}function f(w,b=0,d=w.byteLength,h=0){for(let g=0;g<d;g++)w[b+g]=h}function c(w,b,d="0"){for(;w.length<b;)w=d+w;return w}function u(w,b=32){return w instanceof ArrayBuffer?Array.from(new Uint8Array(w)).map(d=>d.toString(16).padStart(2,"0")).join(""):c((w>>>0).toString(16),b/4)}e.toHexString=u;class S{constructor(){this._h0=1732584193,this._h1=4023233417,this._h2=2562383102,this._h3=271733878,this._h4=3285377520,this._buff=new Uint8Array(64+3),this._buffDV=new DataView(this._buff.buffer),this._buffLen=0,this._totalLen=0,this._leftoverHighSurrogate=0,this._finished=!1}update(b){const d=b.length;if(d===0)return;const h=this._buff;let g=this._buffLen,t=this._leftoverHighSurrogate,i,s;for(t!==0?(i=t,s=-1,t=0):(i=b.charCodeAt(0),s=0);;){let n=i;if(p.isHighSurrogate(i))if(s+1<d){const o=b.charCodeAt(s+1);p.isLowSurrogate(o)?(s++,n=p.computeCodePoint(i,o)):n=65533}else{t=i;break}else p.isLowSurrogate(i)&&(n=65533);if(g=this._push(h,g,n),s++,s<d)i=b.charCodeAt(s);else break}this._buffLen=g,this._leftoverHighSurrogate=t}_push(b,d,h){return h<128?b[d++]=h:h<2048?(b[d++]=192|(h&1984)>>>6,b[d++]=128|(h&63)>>>0):h<65536?(b[d++]=224|(h&61440)>>>12,b[d++]=128|(h&4032)>>>6,b[d++]=128|(h&63)>>>0):(b[d++]=240|(h&1835008)>>>18,b[d++]=128|(h&258048)>>>12,b[d++]=128|(h&4032)>>>6,b[d++]=128|(h&63)>>>0),d>=64&&(this._step(),d-=64,this._totalLen+=64,b[0]=b[64+0],b[1]=b[64+1],b[2]=b[64+2]),d}digest(){return this._finished||(this._finished=!0,this._leftoverHighSurrogate&&(this._leftoverHighSurrogate=0,this._buffLen=this._push(this._buff,this._buffLen,65533)),this._totalLen+=this._buffLen,this._wrapUp()),u(this._h0)+u(this._h1)+u(this._h2)+u(this._h3)+u(this._h4)}_wrapUp(){this._buff[this._buffLen++]=128,f(this._buff,this._buffLen),this._buffLen>56&&(this._step(),f(this._buff));const b=8*this._totalLen;this._buffDV.setUint32(56,Math.floor(b/4294967296),!1),this._buffDV.setUint32(60,b%4294967296,!1),this._step()}_step(){const b=S._bigBlock32,d=this._buffDV;for(let m=0;m<64;m+=4)b.setUint32(m,d.getUint32(m,!1),!1);for(let m=64;m<320;m+=4)b.setUint32(m,l(b.getUint32(m-12,!1)^b.getUint32(m-32,!1)^b.getUint32(m-56,!1)^b.getUint32(m-64,!1),1),!1);let h=this._h0,g=this._h1,t=this._h2,i=this._h3,s=this._h4,n,o,v;for(let m=0;m<80;m++)m<20?(n=g&t|~g&i,o=1518500249):m<40?(n=g^t^i,o=1859775393):m<60?(n=g&t|g&i|t&i,o=2400959708):(n=g^t^i,o=3395469782),v=l(h,5)+n+s+o+b.getUint32(m*4,!1)&4294967295,s=i,i=t,t=l(g,30),g=h,h=v;this._h0=this._h0+h&4294967295,this._h1=this._h1+g&4294967295,this._h2=this._h2+t&4294967295,this._h3=this._h3+i&4294967295,this._h4=this._h4+s&4294967295}}e.StringSHA1=S,S._bigBlock32=new DataView(new ArrayBuffer(320))}),define(me[54],ge([0,1,8]),function(X,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var R;(function(C){C[C.Ignore=0]="Ignore",C[C.Info=1]="Info",C[C.Warning=2]="Warning",C[C.Error=3]="Error"})(R||(R={})),function(C){const y="error",A="warning",P="warn",E="info",k="ignore";function r(l){return l?p.equalsIgnoreCase(y,l)?C.Error:p.equalsIgnoreCase(A,l)||p.equalsIgnoreCase(P,l)?C.Warning:p.equalsIgnoreCase(E,l)?C.Info:C.Ignore:C.Ignore}C.fromValue=r;function I(l){switch(l){case C.Error:return y;case C.Warning:return A;case C.Info:return E;default:return k}}C.toString=I}(R||(R={})),e.default=R}),define(me[15],ge([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.assertNever=e.NotImplementedProxy=e.withUndefinedAsNull=e.withNullAsUndefined=e.createProxyObject=e.getAllMethodNames=e.getAllPropertyNames=e.validateConstraint=e.validateConstraints=e.areFunctions=e.isFunction=e.isEmptyObject=e.assertAllDefined=e.assertIsDefined=e.assertType=e.isUndefinedOrNull=e.isDefined=e.isUndefined=e.isBoolean=e.isIterable=e.isNumber=e.isObject=e.isStringArray=e.isString=e.isArray=void 0;function p(m){return Array.isArray(m)}e.isArray=p;function R(m){return typeof m=="string"}e.isString=R;function C(m){return Array.isArray(m)&&m.every(_=>R(_))}e.isStringArray=C;function y(m){return typeof m=="object"&&m!==null&&!Array.isArray(m)&&!(m instanceof RegExp)&&!(m instanceof Date)}e.isObject=y;function A(m){return typeof m=="number"&&!isNaN(m)}e.isNumber=A;function P(m){return!!m&&typeof m[Symbol.iterator]=="function"}e.isIterable=P;function E(m){return m===!0||m===!1}e.isBoolean=E;function k(m){return typeof m=="undefined"}e.isUndefined=k;function r(m){return!I(m)}e.isDefined=r;function I(m){return k(m)||m===null}e.isUndefinedOrNull=I;function l(m,_){if(!m)throw new Error(_?`Unexpected type, expected '${_}'`:"Unexpected type")}e.assertType=l;function f(m){if(I(m))throw new Error("Assertion Failed: argument is undefined or null");return m}e.assertIsDefined=f;function c(...m){const _=[];for(let D=0;D<m.length;D++){const a=m[D];if(I(a))throw new Error(`Assertion Failed: argument at index ${D} is undefined or null`);_.push(a)}return _}e.assertAllDefined=c;const u=Object.prototype.hasOwnProperty;function S(m){if(!y(m))return!1;for(let _ in m)if(u.call(m,_))return!1;return!0}e.isEmptyObject=S;function w(m){return typeof m=="function"}e.isFunction=w;function b(...m){return m.length>0&&m.every(w)}e.areFunctions=b;function d(m,_){const D=Math.min(m.length,_.length);for(let a=0;a<D;a++)h(m[a],_[a])}e.validateConstraints=d;function h(m,_){if(R(_)){if(typeof m!==_)throw new Error(`argument does not match constraint: typeof ${_}`)}else if(w(_)){try{if(m instanceof _)return}catch(D){}if(!I(m)&&m.constructor===_||_.length===1&&_.call(void 0,m)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.validateConstraint=h;function g(m){let _=[],D=Object.getPrototypeOf(m);for(;Object.prototype!==D;)_=_.concat(Object.getOwnPropertyNames(D)),D=Object.getPrototypeOf(D);return _}e.getAllPropertyNames=g;function t(m){const _=[];for(const D of g(m))typeof m[D]=="function"&&_.push(D);return _}e.getAllMethodNames=t;function i(m,_){const D=T=>function(){const L=Array.prototype.slice.call(arguments,0);return _(T,L)};let a={};for(const T of m)a[T]=D(T);return a}e.createProxyObject=i;function s(m){return m===null?void 0:m}e.withNullAsUndefined=s;function n(m){return typeof m=="undefined"?null:m}e.withUndefinedAsNull=n;function o(m){return class{constructor(){return new Proxy({},{get(_,D){if(_[D])return _[D];throw new Error(`Not Implemented: ${m}->${String(D)}`)}})}}}e.NotImplementedProxy=o;function v(m){throw new Error("Unreachable")}e.assertNever=v}),define(me[29],ge([0,1,11,8,9,15]),function(X,e,p,R,C,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toPosixPath=e.toSlashes=e.isPathSeparator=void 0;function A(s){return s===47||s===92}e.isPathSeparator=A;function P(s){return s.replace(/[\\/]/g,C.posix.sep)}e.toSlashes=P;function E(s){return s.indexOf("/")===-1&&(s=P(s)),/^[a-zA-Z]:(\/|$)/.test(s)&&(s="/"+s),s}e.toPosixPath=E;function k(s,n=C.posix.sep){if(!s)return"";const o=s.length,v=s.charCodeAt(0);if(A(v)){if(A(s.charCodeAt(1))&&!A(s.charCodeAt(2))){let _=3;const D=_;for(;_<o&&!A(s.charCodeAt(_));_++);if(D!==_&&!A(s.charCodeAt(_+1))){for(_+=1;_<o;_++)if(A(s.charCodeAt(_)))return s.slice(0,_+1).replace(/[\\/]/g,n)}}return n}else if(w(v)&&s.charCodeAt(1)===58)return A(s.charCodeAt(2))?s.slice(0,2)+n:s.slice(0,2);let m=s.indexOf("://");if(m!==-1){for(m+=3;m<o;m++)if(A(s.charCodeAt(m)))return s.slice(0,m+1)}return""}e.getRoot=k;function r(s){if(!p.isWindows||!s||s.length<5)return!1;let n=s.charCodeAt(0);if(n!==92||(n=s.charCodeAt(1),n!==92))return!1;let o=2;const v=o;for(;o<s.length&&(n=s.charCodeAt(o),n!==92);o++);return!(v===o||(n=s.charCodeAt(o+1),isNaN(n)||n===92))}e.isUNC=r;const I=/[\\/:\*\?"<>\|]/g,l=/[\\/]/g,f=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function c(s,n=p.isWindows){const o=n?I:l;return!(!s||s.length===0||/^\s+$/.test(s)||(o.lastIndex=0,o.test(s))||n&&f.test(s)||s==="."||s===".."||n&&s[s.length-1]==="."||n&&s.length!==s.trim().length||s.length>255)}e.isValidBasename=c;function u(s,n,o){const v=s===n;return!o||v?v:!s||!n?!1:R.equalsIgnoreCase(s,n)}e.isEqual=u;function S(s,n,o,v=C.sep){if(s===n)return!0;if(!s||!n||n.length>s.length)return!1;if(o){if(!R.startsWithIgnoreCase(s,n))return!1;if(n.length===s.length)return!0;let _=n.length;return n.charAt(n.length-1)===v&&_--,s.charAt(_)===v}return n.charAt(n.length-1)!==v&&(n+=v),s.indexOf(n)===0}e.isEqualOrParent=S;function w(s){return s>=65&&s<=90||s>=97&&s<=122}e.isWindowsDriveLetter=w;function b(s,n){return p.isWindows&&s.endsWith(":")&&(s+=C.sep),C.isAbsolute(s)||(s=C.join(n,s)),s=C.normalize(s),p.isWindows?(s=R.rtrim(s,C.sep),s.endsWith(":")&&(s+=C.sep)):(s=R.rtrim(s,C.sep),s||(s=C.sep)),s}e.sanitizeFilePath=b;function d(s){const n=C.normalize(s);return p.isWindows?s.length>3?!1:h(n)&&(s.length===2||n.charCodeAt(2)===92):n===C.posix.sep}e.isRootOrDriveLetter=d;function h(s){return p.isWindows?w(s.charCodeAt(0))&&s.charCodeAt(1)===58:!1}e.hasDriveLetter=h;function g(s){return h(s)?s[0]:void 0}e.getDriveLetter=g;function t(s,n,o){return n.length>s.length?-1:s===n?0:(o&&(s=s.toLowerCase(),n=n.toLowerCase()),s.indexOf(n))}e.indexOfPath=t;function i(s){const n=s.split(":");let o,v,m;if(n.forEach(_=>{const D=Number(_);y.isNumber(D)?v===void 0?v=D:m===void 0&&(m=D):o=o?[o,_].join(":"):_}),!o)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:o,line:v!==void 0?v:void 0,column:m!==void 0?m:v!==void 0?1:void 0}}e.parseLineAndColumnAware=i}),define(me[25],ge([0,1,15]),function(X,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.filter=e.getCaseInsensitive=e.distinct=e.getOrDefault=e.safeStringify=e.equals=e.mixin=e.cloneAndChange=e.deepFreeze=e.deepClone=void 0;function R(u){if(!u||typeof u!="object"||u instanceof RegExp)return u;const S=Array.isArray(u)?[]:{};return Object.keys(u).forEach(w=>{u[w]&&typeof u[w]=="object"?S[w]=R(u[w]):S[w]=u[w]}),S}e.deepClone=R;function C(u){if(!u||typeof u!="object")return u;const S=[u];for(;S.length>0;){const w=S.shift();Object.freeze(w);for(const b in w)if(y.call(w,b)){const d=w[b];typeof d=="object"&&!Object.isFrozen(d)&&S.push(d)}}return u}e.deepFreeze=C;const y=Object.prototype.hasOwnProperty;function A(u,S){return P(u,S,new Set)}e.cloneAndChange=A;function P(u,S,w){if(p.isUndefinedOrNull(u))return u;const b=S(u);if(typeof b!="undefined")return b;if(p.isArray(u)){const d=[];for(const h of u)d.push(P(h,S,w));return d}if(p.isObject(u)){if(w.has(u))throw new Error("Cannot clone recursive data-structure");w.add(u);const d={};for(let h in u)y.call(u,h)&&(d[h]=P(u[h],S,w));return w.delete(u),d}return u}function E(u,S,w=!0){return p.isObject(u)?(p.isObject(S)&&Object.keys(S).forEach(b=>{b in u?w&&(p.isObject(u[b])&&p.isObject(S[b])?E(u[b],S[b],w):u[b]=S[b]):u[b]=S[b]}),u):S}e.mixin=E;function k(u,S){if(u===S)return!0;if(u==null||S===null||S===void 0||typeof u!=typeof S||typeof u!="object"||Array.isArray(u)!==Array.isArray(S))return!1;let w,b;if(Array.isArray(u)){if(u.length!==S.length)return!1;for(w=0;w<u.length;w++)if(!k(u[w],S[w]))return!1}else{const d=[];for(b in u)d.push(b);d.sort();const h=[];for(b in S)h.push(b);if(h.sort(),!k(d,h))return!1;for(w=0;w<d.length;w++)if(!k(u[d[w]],S[d[w]]))return!1}return!0}e.equals=k;function r(u){const S=new Set;return JSON.stringify(u,(w,b)=>{if(p.isObject(b)||Array.isArray(b)){if(S.has(b))return"[Circular]";S.add(b)}return b})}e.safeStringify=r;function I(u,S,w){const b=S(u);return typeof b=="undefined"?w:b}e.getOrDefault=I;function l(u,S){const w=Object.create(null);return!u||!S||Object.keys(S).forEach(d=>{const h=u[d],g=S[d];k(h,g)||(w[d]=g)}),w}e.distinct=l;function f(u,S){const w=S.toLowerCase(),b=Object.keys(u).find(d=>d.toLowerCase()===w);return b?u[b]:u[S]}e.getCaseInsensitive=f;function c(u,S){const w=Object.create(null);for(const b of Object.keys(u))S(b,u[b])&&(w[b]=u[b]);return w}e.filter=c}),define(me[92],ge([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toUint32=e.toUint8=e.Constants=void 0;var p;(function(y){y[y.MAX_SAFE_SMALL_INTEGER=1073741824]="MAX_SAFE_SMALL_INTEGER",y[y.MIN_SAFE_SMALL_INTEGER=-1073741824]="MIN_SAFE_SMALL_INTEGER",y[y.MAX_UINT_8=255]="MAX_UINT_8",y[y.MAX_UINT_16=65535]="MAX_UINT_16",y[y.MAX_UINT_32=4294967295]="MAX_UINT_32",y[y.UNICODE_SUPPLEMENTARY_PLANE_BEGIN=65536]="UNICODE_SUPPLEMENTARY_PLANE_BEGIN"})(p=e.Constants||(e.Constants={}));function R(y){return y<0?0:y>255?255:y|0}e.toUint8=R;function C(y){return y<0?0:y>4294967295?4294967295:y|0}e.toUint32=C}),define(me[2],ge([0,1,11,9]),function(X,e,p,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.uriToFsPath=e.URI=void 0;const C=/^\w[\w\d+.-]*$/,y=/^\//,A=/^\/\//;function P(s,n){if(!s.scheme&&n)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${s.authority}", path: "${s.path}", query: "${s.query}", fragment: "${s.fragment}"}`);if(s.scheme&&!C.test(s.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(s.path){if(s.authority){if(!y.test(s.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(A.test(s.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function E(s,n){return!s&&!n?"file":s}function k(s,n){switch(s){case"https":case"http":case"file":n?n[0]!==I&&(n=I+n):n=I;break}return n}const r="",I="/",l=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class f{constructor(n,o,v,m,_,D=!1){typeof n=="object"?(this.scheme=n.scheme||r,this.authority=n.authority||r,this.path=n.path||r,this.query=n.query||r,this.fragment=n.fragment||r):(this.scheme=E(n,D),this.authority=o||r,this.path=k(this.scheme,v||r),this.query=m||r,this.fragment=_||r,P(this,D))}static isUri(n){return n instanceof f?!0:n?typeof n.authority=="string"&&typeof n.fragment=="string"&&typeof n.path=="string"&&typeof n.query=="string"&&typeof n.scheme=="string"&&typeof n.fsPath=="string"&&typeof n.with=="function"&&typeof n.toString=="function":!1}get fsPath(){return d(this,!1)}with(n){if(!n)return this;let{scheme:o,authority:v,path:m,query:_,fragment:D}=n;return o===void 0?o=this.scheme:o===null&&(o=r),v===void 0?v=this.authority:v===null&&(v=r),m===void 0?m=this.path:m===null&&(m=r),_===void 0?_=this.query:_===null&&(_=r),D===void 0?D=this.fragment:D===null&&(D=r),o===this.scheme&&v===this.authority&&m===this.path&&_===this.query&&D===this.fragment?this:new u(o,v,m,_,D)}static parse(n,o=!1){const v=l.exec(n);return v?new u(v[2]||r,i(v[4]||r),i(v[5]||r),i(v[7]||r),i(v[9]||r),o):new u(r,r,r,r,r)}static file(n){let o=r;if(p.isWindows&&(n=n.replace(/\\/g,I)),n[0]===I&&n[1]===I){const v=n.indexOf(I,2);v===-1?(o=n.substring(2),n=I):(o=n.substring(2,v),n=n.substring(v)||I)}return new u("file",o,n,r,r)}static from(n){const o=new u(n.scheme,n.authority,n.path,n.query,n.fragment);return P(o,!0),o}static joinPath(n,...o){if(!n.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let v;return p.isWindows&&n.scheme==="file"?v=f.file(R.win32.join(d(n,!0),...o)).path:v=R.posix.join(n.path,...o),n.with({path:v})}toString(n=!1){return h(this,n)}toJSON(){return this}static revive(n){if(n){if(n instanceof f)return n;{const o=new u(n);return o._formatted=n.external,o._fsPath=n._sep===c?n.fsPath:null,o}}else return n}}e.URI=f;const c=p.isWindows?1:void 0;class u extends f{constructor(){super(...arguments);this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=d(this,!1)),this._fsPath}toString(n=!1){return n?h(this,!0):(this._formatted||(this._formatted=h(this,!1)),this._formatted)}toJSON(){const n={$mid:1};return this._fsPath&&(n.fsPath=this._fsPath,n._sep=c),this._formatted&&(n.external=this._formatted),this.path&&(n.path=this.path),this.scheme&&(n.scheme=this.scheme),this.authority&&(n.authority=this.authority),this.query&&(n.query=this.query),this.fragment&&(n.fragment=this.fragment),n}}const S={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function w(s,n){let o,v=-1;for(let m=0;m<s.length;m++){const _=s.charCodeAt(m);if(_>=97&&_<=122||_>=65&&_<=90||_>=48&&_<=57||_===45||_===46||_===95||_===126||n&&_===47)v!==-1&&(o+=encodeURIComponent(s.substring(v,m)),v=-1),o!==void 0&&(o+=s.charAt(m));else{o===void 0&&(o=s.substr(0,m));const D=S[_];D!==void 0?(v!==-1&&(o+=encodeURIComponent(s.substring(v,m)),v=-1),o+=D):v===-1&&(v=m)}}return v!==-1&&(o+=encodeURIComponent(s.substring(v))),o!==void 0?o:s}function b(s){let n;for(let o=0;o<s.length;o++){const v=s.charCodeAt(o);v===35||v===63?(n===void 0&&(n=s.substr(0,o)),n+=S[v]):n!==void 0&&(n+=s[o])}return n!==void 0?n:s}function d(s,n){let o;return s.authority&&s.path.length>1&&s.scheme==="file"?o=`//${s.authority}${s.path}`:s.path.charCodeAt(0)===47&&(s.path.charCodeAt(1)>=65&&s.path.charCodeAt(1)<=90||s.path.charCodeAt(1)>=97&&s.path.charCodeAt(1)<=122)&&s.path.charCodeAt(2)===58?n?o=s.path.substr(1):o=s.path[1].toLowerCase()+s.path.substr(2):o=s.path,p.isWindows&&(o=o.replace(/\//g,"\\")),o}e.uriToFsPath=d;function h(s,n){const o=n?b:w;let v="",{scheme:m,authority:_,path:D,query:a,fragment:T}=s;if(m&&(v+=m,v+=":"),(_||m==="file")&&(v+=I,v+=I),_){let L=_.indexOf("@");if(L!==-1){const U=_.substr(0,L);_=_.substr(L+1),L=U.indexOf(":"),L===-1?v+=o(U,!1):(v+=o(U.substr(0,L),!1),v+=":",v+=o(U.substr(L+1),!1)),v+="@"}_=_.toLowerCase(),L=_.indexOf(":"),L===-1?v+=o(_,!1):(v+=o(_.substr(0,L),!1),v+=_.substr(L))}if(D){if(D.length>=3&&D.charCodeAt(0)===47&&D.charCodeAt(2)===58){const L=D.charCodeAt(1);L>=65&&L<=90&&(D=`/${String.fromCharCode(L+32)}:${D.substr(3)}`)}else if(D.length>=2&&D.charCodeAt(1)===58){const L=D.charCodeAt(0);L>=65&&L<=90&&(D=`${String.fromCharCode(L+32)}:${D.substr(2)}`)}v+=o(D,!0)}return a&&(v+="?",v+=o(a,!1)),T&&(v+="#",v+=n?T:w(T,!1)),v}function g(s){try{return decodeURIComponent(s)}catch(n){return s.length>3?s.substr(0,3)+g(s.substr(3)):s}}const t=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function i(s){return s.match(t)?s.replace(t,n=>g(n)):s}});var rt=this&&this.__classPrivateFieldSet||function(X,e,p,R,C){if(R==="m")throw new TypeError("Private method is not writable");if(R==="a"&&!C)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?X!==e||!C:!e.has(X))throw new TypeError("Cannot write private member to an object whose class did not declare it");return R==="a"?C.call(X,p):C?C.value=p:e.set(X,p),p},$e=this&&this.__classPrivateFieldGet||function(X,e,p,R){if(p==="a"&&!R)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?X!==e||!R:!e.has(X))throw new TypeError("Cannot read private member from an object whose class did not declare it");return p==="m"?R:p==="a"?R.call(X):R?R.value:e.get(X)};define(me[23],ge([0,1,2,8]),function(X,e,p,R){"use strict";var C,y,A;Object.defineProperty(e,"__esModule",{value:!0}),e.ReadonlyMapView=e.LRUCache=e.LinkedMap=e.Touch=e.ResourceMap=e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=e.setToString=e.mapToString=e.getOrSet=void 0;function P(t,i,s){let n=t.get(i);return n===void 0&&(n=s,t.set(i,n)),n}e.getOrSet=P;function E(t){const i=[];return t.forEach((s,n)=>{i.push(`${n} => ${s}`)}),`Map(${t.size}) {${i.join(", ")}}`}e.mapToString=E;function k(t){const i=[];return t.forEach(s=>{i.push(s)}),`Set(${t.size}) {${i.join(", ")}}`}e.setToString=k;class r{constructor(){this._value="",this._pos=0}reset(i){return this._value=i,this._pos=0,this}next(){return this._pos+=1,this}hasNext(){return this._pos<this._value.length-1}cmp(i){const s=i.charCodeAt(0),n=this._value.charCodeAt(this._pos);return s-n}value(){return this._value[this._pos]}}e.StringIterator=r;class I{constructor(i=!0){this._caseSensitive=i}reset(i){return this._value=i,this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let i=!0;for(;this._to<this._value.length;this._to++)if(this._value.charCodeAt(this._to)===46)if(i)this._from++;else break;else i=!1;return this}cmp(i){return this._caseSensitive?R.compareSubstring(i,this._value,0,i.length,this._from,this._to):R.compareSubstringIgnoreCase(i,this._value,0,i.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.ConfigKeysIterator=I;class l{constructor(i=!0,s=!0){this._splitOnBackslash=i,this._caseSensitive=s}reset(i){return this._value=i.replace(/\\$|\/$/,""),this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let i=!0;for(;this._to<this._value.length;this._to++){const s=this._value.charCodeAt(this._to);if(s===47||this._splitOnBackslash&&s===92)if(i)this._from++;else break;else i=!1}return this}cmp(i){return this._caseSensitive?R.compareSubstring(i,this._value,0,i.length,this._from,this._to):R.compareSubstringIgnoreCase(i,this._value,0,i.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.PathIterator=l;var f;(function(t){t[t.Scheme=1]="Scheme",t[t.Authority=2]="Authority",t[t.Path=3]="Path",t[t.Query=4]="Query",t[t.Fragment=5]="Fragment"})(f||(f={}));class c{constructor(i){this._ignorePathCasing=i,this._states=[],this._stateIdx=0}reset(i){return this._value=i,this._states=[],this._value.scheme&&this._states.push(1),this._value.authority&&this._states.push(2),this._value.path&&(this._pathIterator=new l(!1,!this._ignorePathCasing(i)),this._pathIterator.reset(i.path),this._pathIterator.value()&&this._states.push(3)),this._value.query&&this._states.push(4),this._value.fragment&&this._states.push(5),this._stateIdx=0,this}next(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()?this._pathIterator.next():this._stateIdx+=1,this}hasNext(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()||this._stateIdx<this._states.length-1}cmp(i){if(this._states[this._stateIdx]===1)return R.compareIgnoreCase(i,this._value.scheme);if(this._states[this._stateIdx]===2)return R.compareIgnoreCase(i,this._value.authority);if(this._states[this._stateIdx]===3)return this._pathIterator.cmp(i);if(this._states[this._stateIdx]===4)return R.compare(i,this._value.query);if(this._states[this._stateIdx]===5)return R.compare(i,this._value.fragment);throw new Error}value(){if(this._states[this._stateIdx]===1)return this._value.scheme;if(this._states[this._stateIdx]===2)return this._value.authority;if(this._states[this._stateIdx]===3)return this._pathIterator.value();if(this._states[this._stateIdx]===4)return this._value.query;if(this._states[this._stateIdx]===5)return this._value.fragment;throw new Error}}e.UriIterator=c;class u{isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}}class S{constructor(i){this._iter=i}static forUris(i=()=>!1){return new S(new c(i))}static forPaths(){return new S(new l)}static forStrings(){return new S(new r)}static forConfigKeys(){return new S(new I)}clear(){this._root=void 0}set(i,s){const n=this._iter.reset(i);let o;for(this._root||(this._root=new u,this._root.segment=n.value()),o=this._root;;){const m=n.cmp(o.segment);if(m>0)o.left||(o.left=new u,o.left.segment=n.value()),o=o.left;else if(m<0)o.right||(o.right=new u,o.right.segment=n.value()),o=o.right;else if(n.hasNext())n.next(),o.mid||(o.mid=new u,o.mid.segment=n.value()),o=o.mid;else break}const v=o.value;return o.value=s,o.key=i,v}get(i){var s;return(s=this._getNode(i))===null||s===void 0?void 0:s.value}_getNode(i){const s=this._iter.reset(i);let n=this._root;for(;n;){const o=s.cmp(n.segment);if(o>0)n=n.left;else if(o<0)n=n.right;else if(s.hasNext())s.next(),n=n.mid;else break}return n}has(i){const s=this._getNode(i);return!((s==null?void 0:s.value)===void 0&&(s==null?void 0:s.mid)===void 0)}delete(i){return this._delete(i,!1)}deleteSuperstr(i){return this._delete(i,!0)}_delete(i,s){const n=this._iter.reset(i),o=[];let v=this._root;for(;v;){const m=n.cmp(v.segment);if(m>0)o.push([1,v]),v=v.left;else if(m<0)o.push([-1,v]),v=v.right;else if(n.hasNext())n.next(),o.push([0,v]),v=v.mid;else{for(s?(v.left=void 0,v.mid=void 0,v.right=void 0):v.value=void 0;o.length>0&&v.isEmpty();){let[_,D]=o.pop();switch(_){case 1:D.left=void 0;break;case 0:D.mid=void 0;break;case-1:D.right=void 0;break}v=D}break}}}findSubstr(i){const s=this._iter.reset(i);let n=this._root,o;for(;n;){const v=s.cmp(n.segment);if(v>0)n=n.left;else if(v<0)n=n.right;else if(s.hasNext())s.next(),o=n.value||o,n=n.mid;else break}return n&&n.value||o}findSuperstr(i){const s=this._iter.reset(i);let n=this._root;for(;n;){const o=s.cmp(n.segment);if(o>0)n=n.left;else if(o<0)n=n.right;else if(s.hasNext())s.next(),n=n.mid;else return n.mid?this._entries(n.mid):void 0}}forEach(i){for(const[s,n]of this)i(n,s)}*[Symbol.iterator](){yield*this._entries(this._root)}*_entries(i){if(!i)return;const s=[i];for(;s.length>0;){const n=s.pop();n&&(n.value&&(yield[n.key,n.value]),n.left&&s.push(n.left),n.mid&&s.push(n.mid),n.right&&s.push(n.right))}}}e.TernarySearchTree=S;class w{constructor(i,s){this[C]="ResourceMap",i instanceof w?(this.map=new Map(i.map),this.toKey=s??w.defaultToKey):(this.map=new Map,this.toKey=i??w.defaultToKey)}set(i,s){return this.map.set(this.toKey(i),s),this}get(i){return this.map.get(this.toKey(i))}has(i){return this.map.has(this.toKey(i))}get size(){return this.map.size}clear(){this.map.clear()}delete(i){return this.map.delete(this.toKey(i))}forEach(i,s){typeof s!="undefined"&&(i=i.bind(s));for(let[n,o]of this.map)i(o,p.URI.parse(n),this)}values(){return this.map.values()}*keys(){for(let i of this.map.keys())yield p.URI.parse(i)}*entries(){for(let i of this.map.entries())yield[p.URI.parse(i[0]),i[1]]}*[(C=Symbol.toStringTag,Symbol.iterator)](){for(let i of this.map)yield[p.URI.parse(i[0]),i[1]]}}e.ResourceMap=w,w.defaultToKey=t=>t.toString();var b;(function(t){t[t.None=0]="None",t[t.AsOld=1]="AsOld",t[t.AsNew=2]="AsNew"})(b=e.Touch||(e.Touch={}));class d{constructor(){this[y]="LinkedMap",this._map=new Map,this._head=void 0,this._tail=void 0,this._size=0,this._state=0}clear(){this._map.clear(),this._head=void 0,this._tail=void 0,this._size=0,this._state++}isEmpty(){return!this._head&&!this._tail}get size(){return this._size}get first(){var i;return(i=this._head)===null||i===void 0?void 0:i.value}get last(){var i;return(i=this._tail)===null||i===void 0?void 0:i.value}has(i){return this._map.has(i)}get(i,s=0){const n=this._map.get(i);if(!!n)return s!==0&&this.touch(n,s),n.value}set(i,s,n=0){let o=this._map.get(i);if(o)o.value=s,n!==0&&this.touch(o,n);else{switch(o={key:i,value:s,next:void 0,previous:void 0},n){case 0:this.addItemLast(o);break;case 1:this.addItemFirst(o);break;case 2:this.addItemLast(o);break;default:this.addItemLast(o);break}this._map.set(i,o),this._size++}return this}delete(i){return!!this.remove(i)}remove(i){const s=this._map.get(i);if(!!s)return this._map.delete(i),this.removeItem(s),this._size--,s.value}shift(){if(!this._head&&!this._tail)return;if(!this._head||!this._tail)throw new Error("Invalid list");const i=this._head;return this._map.delete(i.key),this.removeItem(i),this._size--,i.value}forEach(i,s){const n=this._state;let o=this._head;for(;o;){if(s?i.bind(s)(o.value,o.key,this):i(o.value,o.key,this),this._state!==n)throw new Error("LinkedMap got modified during iteration.");o=o.next}}keys(){const i=this,s=this._state;let n=this._head;const o={[Symbol.iterator](){return o},next(){if(i._state!==s)throw new Error("LinkedMap got modified during iteration.");if(n){const v={value:n.key,done:!1};return n=n.next,v}else return{value:void 0,done:!0}}};return o}values(){const i=this,s=this._state;let n=this._head;const o={[Symbol.iterator](){return o},next(){if(i._state!==s)throw new Error("LinkedMap got modified during iteration.");if(n){const v={value:n.value,done:!1};return n=n.next,v}else return{value:void 0,done:!0}}};return o}entries(){const i=this,s=this._state;let n=this._head;const o={[Symbol.iterator](){return o},next(){if(i._state!==s)throw new Error("LinkedMap got modified during iteration.");if(n){const v={value:[n.key,n.value],done:!1};return n=n.next,v}else return{value:void 0,done:!0}}};return o}[(y=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}trimOld(i){if(i>=this.size)return;if(i===0){this.clear();return}let s=this._head,n=this.size;for(;s&&n>i;)this._map.delete(s.key),s=s.next,n--;this._head=s,this._size=n,s&&(s.previous=void 0),this._state++}addItemFirst(i){if(!this._head&&!this._tail)this._tail=i;else if(this._head)i.next=this._head,this._head.previous=i;else throw new Error("Invalid list");this._head=i,this._state++}addItemLast(i){if(!this._head&&!this._tail)this._head=i;else if(this._tail)i.previous=this._tail,this._tail.next=i;else throw new Error("Invalid list");this._tail=i,this._state++}removeItem(i){if(i===this._head&&i===this._tail)this._head=void 0,this._tail=void 0;else if(i===this._head){if(!i.next)throw new Error("Invalid list");i.next.previous=void 0,this._head=i.next}else if(i===this._tail){if(!i.previous)throw new Error("Invalid list");i.previous.next=void 0,this._tail=i.previous}else{const s=i.next,n=i.previous;if(!s||!n)throw new Error("Invalid list");s.previous=n,n.next=s}i.next=void 0,i.previous=void 0,this._state++}touch(i,s){if(!this._head||!this._tail)throw new Error("Invalid list");if(!(s!==1&&s!==2)){if(s===1){if(i===this._head)return;const n=i.next,o=i.previous;i===this._tail?(o.next=void 0,this._tail=o):(n.previous=o,o.next=n),i.previous=void 0,i.next=this._head,this._head.previous=i,this._head=i,this._state++}else if(s===2){if(i===this._tail)return;const n=i.next,o=i.previous;i===this._head?(n.previous=void 0,this._head=n):(n.previous=o,o.next=n),i.next=void 0,i.previous=this._tail,this._tail.next=i,this._tail=i,this._state++}}}toJSON(){const i=[];return this.forEach((s,n)=>{i.push([n,s])}),i}fromJSON(i){this.clear();for(const[s,n]of i)this.set(s,n)}}e.LinkedMap=d;class h extends d{constructor(i,s=1){super();this._limit=i,this._ratio=Math.min(Math.max(0,s),1)}get limit(){return this._limit}set limit(i){this._limit=i,this.checkTrim()}get ratio(){return this._ratio}set ratio(i){this._ratio=Math.min(Math.max(0,i),1),this.checkTrim()}get(i,s=2){return super.get(i,s)}peek(i){return super.get(i,0)}set(i,s){return super.set(i,s,2),this.checkTrim(),this}checkTrim(){this.size>this._limit&&this.trimOld(Math.round(this._limit*this._ratio))}}e.LRUCache=h;class g{constructor(i){A.set(this,void 0),rt(this,A,i,"f")}get size(){return $e(this,A,"f").size}forEach(i,s){$e(this,A,"f").forEach(i,s)}get(i){return $e(this,A,"f").get(i)}has(i){return $e(this,A,"f").has(i)}entries(){return $e(this,A,"f").entries()}keys(){return $e(this,A,"f").keys()}values(){return $e(this,A,"f").values()}[(A=new WeakMap,Symbol.iterator)](){return $e(this,A,"f").entries()}}e.ReadonlyMapView=g}),define(me[93],ge([0,1,23,8]),function(X,e,p,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fuzzyScoreGraceful=e.fuzzyScoreGracefulAggressive=e.fuzzyScore=e.FuzzyScore=e.isPatternInWord=e.createMatches=e.anyScore=e.matchesFuzzy2=e.matchesFuzzy=e.matchesWords=e.matchesCamelCase=e.isUpper=e.matchesSubString=e.matchesContiguousSubString=e.matchesPrefix=e.matchesStrictPrefix=e.or=void 0;function C(...J){return function(ae,he){for(let Fe=0,He=J.length;Fe<He;Fe++){const _e=J[Fe](ae,he);if(_e)return _e}return null}}e.or=C,e.matchesStrictPrefix=y.bind(void 0,!1),e.matchesPrefix=y.bind(void 0,!0);function y(J,ae,he){if(!he||he.length<ae.length)return null;let Fe;return J?Fe=R.startsWithIgnoreCase(he,ae):Fe=he.indexOf(ae)===0,Fe?ae.length>0?[{start:0,end:ae.length}]:[]:null}function A(J,ae){const he=ae.toLowerCase().indexOf(J.toLowerCase());return he===-1?null:[{start:he,end:he+J.length}]}e.matchesContiguousSubString=A;function P(J,ae){return E(J.toLowerCase(),ae.toLowerCase(),0,0)}e.matchesSubString=P;function E(J,ae,he,Fe){if(he===J.length)return[];if(Fe===ae.length)return null;if(J[he]===ae[Fe]){let He=null;return(He=E(J,ae,he+1,Fe+1))?w({start:Fe,end:Fe+1},He):null}return E(J,ae,he,Fe+1)}function k(J){return 97<=J&&J<=122}function r(J){return 65<=J&&J<=90}e.isUpper=r;function I(J){return 48<=J&&J<=57}function l(J){return J===32||J===9||J===10||J===13}const f=new Set;"`~!@#$%^&*()-=+[{]}\\|;:'\",.<>/?".split("").forEach(J=>f.add(J.charCodeAt(0)));function c(J){return l(J)||f.has(J)}function u(J,ae){return J===ae||c(J)&&c(ae)}function S(J){return k(J)||r(J)||I(J)}function w(J,ae){return ae.length===0?ae=[J]:J.end===ae[0].start?ae[0].start=J.start:ae.unshift(J),ae}function b(J,ae){for(let he=ae;he<J.length;he++){const Fe=J.charCodeAt(he);if(r(Fe)||I(Fe)||he>0&&!S(J.charCodeAt(he-1)))return he}return J.length}function d(J,ae,he,Fe){if(he===J.length)return[];if(Fe===ae.length)return null;if(J[he]!==ae[Fe].toLowerCase())return null;{let He=null,_e=Fe+1;for(He=d(J,ae,he+1,Fe+1);!He&&(_e=b(ae,_e))<ae.length;)He=d(J,ae,he+1,_e),_e++;return He===null?null:w({start:Fe,end:Fe+1},He)}}function h(J){let ae=0,he=0,Fe=0,He=0,_e=0;for(let Me=0;Me<J.length;Me++)_e=J.charCodeAt(Me),r(_e)&&ae++,k(_e)&&he++,S(_e)&&Fe++,I(_e)&&He++;const Ye=ae/J.length,K=he/J.length,ie=Fe/J.length,ve=He/J.length;return{upperPercent:Ye,lowerPercent:K,alphaPercent:ie,numericPercent:ve}}function g(J){const{upperPercent:ae,lowerPercent:he}=J;return he===0&&ae>.6}function t(J){const{upperPercent:ae,lowerPercent:he,alphaPercent:Fe,numericPercent:He}=J;return he>.2&&ae<.8&&Fe>.6&&He<.2}function i(J){let ae=0,he=0,Fe=0,He=0;for(let _e=0;_e<J.length;_e++)Fe=J.charCodeAt(_e),r(Fe)&&ae++,k(Fe)&&he++,l(Fe)&&He++;return(ae===0||he===0)&&He===0?J.length<=30:ae<=5}function s(J,ae){if(!ae||(ae=ae.trim(),ae.length===0)||!i(J)||ae.length>60)return null;const he=h(ae);if(!t(he)){if(!g(he))return null;ae=ae.toLowerCase()}let Fe=null,He=0;for(J=J.toLowerCase();He<ae.length&&(Fe=d(J,ae,0,He))===null;)He=b(ae,He+1);return Fe}e.matchesCamelCase=s;function n(J,ae,he=!1){if(!ae||ae.length===0)return null;let Fe=null,He=0;for(J=J.toLowerCase(),ae=ae.toLowerCase();He<ae.length&&(Fe=o(J,ae,0,He,he))===null;)He=v(ae,He+1);return Fe}e.matchesWords=n;function o(J,ae,he,Fe,He){if(he===J.length)return[];if(Fe===ae.length)return null;if(u(J.charCodeAt(he),ae.charCodeAt(Fe))){let _e=null,Ye=Fe+1;if(_e=o(J,ae,he+1,Fe+1,He),!He)for(;!_e&&(Ye=v(ae,Ye))<ae.length;)_e=o(J,ae,he+1,Ye,He),Ye++;return _e===null?null:w({start:Fe,end:Fe+1},_e)}else return null}function v(J,ae){for(let he=ae;he<J.length;he++)if(c(J.charCodeAt(he))||he>0&&c(J.charCodeAt(he-1)))return he;return J.length}const m=C(e.matchesPrefix,s,A),_=C(e.matchesPrefix,s,P),D=new p.LRUCache(1e4);function a(J,ae,he=!1){if(typeof J!="string"||typeof ae!="string")return null;let Fe=D.get(J);Fe||(Fe=new RegExp(R.convertSimple2RegExpPattern(J),"i"),D.set(J,Fe));const He=Fe.exec(ae);return He?[{start:He.index,end:He.index+He[0].length}]:he?_(J,ae):m(J,ae)}e.matchesFuzzy=a;function T(J,ae){const he=Qe(J,J.toLowerCase(),0,ae,ae.toLowerCase(),0,!0);return he?U(he):null}e.matchesFuzzy2=T;function L(J,ae,he,Fe,He,_e){const Ye=Math.min(13,J.length);for(;he<Ye;he++){const K=Qe(J,ae,he,Fe,He,_e,!1);if(K)return K}return[0,_e]}e.anyScore=L;function U(J){if(typeof J=="undefined")return[];const ae=[],he=J[1];for(let Fe=J.length-1;Fe>1;Fe--){const He=J[Fe]+he,_e=ae[ae.length-1];_e&&_e.end===He?_e.end=He+1:ae.push({start:He,end:He+1})}return ae}e.createMatches=U;const G=128;function ee(){const J=[],ae=[];for(let he=0;he<=G;he++)ae[he]=0;for(let he=0;he<=G;he++)J.push(ae.slice(0));return J}function z(J){const ae=[];for(let he=0;he<=J;he++)ae[he]=0;return ae}const N=z(2*G),W=z(2*G),M=ee(),j=ee(),O=ee(),F=!1;function B(J,ae,he,Fe,He){function _e(K,ie,ve=" "){for(;K.length<ie;)K=ve+K;return K}let Ye=` |   |${Fe.split("").map(K=>_e(K,3)).join("|")}
`;for(let K=0;K<=he;K++)K===0?Ye+=" |":Ye+=`${ae[K-1]}|`,Ye+=J[K].slice(0,He+1).map(ie=>_e(ie.toString(),3)).join("|")+`
`;return Ye}function $(J,ae,he,Fe){J=J.substr(ae),he=he.substr(Fe),console.log(B(j,J,J.length,he,he.length)),console.log(B(O,J,J.length,he,he.length)),console.log(B(M,J,J.length,he,he.length))}function Y(J,ae){if(ae<0||ae>=J.length)return!1;const he=J.codePointAt(ae);switch(he){case 95:case 45:case 46:case 32:case 47:case 92:case 39:case 34:case 58:case 36:case 60:case 40:case 91:return!0;case void 0:return!1;default:return!!R.isEmojiImprecise(he)}}function le(J,ae){if(ae<0||ae>=J.length)return!1;switch(J.charCodeAt(ae)){case 32:case 9:return!0;default:return!1}}function be(J,ae,he){return ae[J]!==he[J]}function Le(J,ae,he,Fe,He,_e,Ye=!1){for(;ae<he&&He<_e;)J[ae]===Fe[He]&&(Ye&&(N[ae]=He),ae+=1),He+=1;return ae===he}e.isPatternInWord=Le;var Ie;(function(J){J[J.Diag=1]="Diag",J[J.Left=2]="Left",J[J.LeftLeft=3]="LeftLeft"})(Ie||(Ie={}));var Ue;(function(J){J.Default=[-100,0];function ae(he){return!he||he.length===2&&he[0]===-100&&he[1]===0}J.isDefault=ae})(Ue=e.FuzzyScore||(e.FuzzyScore={}));function Qe(J,ae,he,Fe,He,_e,Ye){const K=J.length>G?G:J.length,ie=Fe.length>G?G:Fe.length;if(he>=K||_e>=ie||K-he>ie-_e||!Le(ae,he,K,He,_e,ie,!0))return;ze(K,ie,he,_e,ae,He);let ve=1,Me=1,xe=he,Je=_e;const ke=[!1];for(ve=1,xe=he;xe<K;ve++,xe++){const fe=N[xe],we=W[xe],q=xe+1<K?W[xe+1]:ie;for(Me=fe-_e+1,Je=fe;Je<q;Me++,Je++){let pe=Number.MIN_SAFE_INTEGER,Se=!1;Je<=we&&(pe=Ge(J,ae,xe,he,Fe,He,Je,ie,_e,M[ve-1][Me-1]===0,ke));let Te=0;pe!==Number.MAX_SAFE_INTEGER&&(Se=!0,Te=pe+j[ve-1][Me-1]);const Oe=Je>fe,je=Oe?j[ve][Me-1]+(M[ve][Me-1]>0?-5:0):0,qe=Je>fe+1&&M[ve][Me-1]>0,Ze=qe?j[ve][Me-2]+(M[ve][Me-2]>0?-5:0):0;if(qe&&(!Oe||Ze>=je)&&(!Se||Ze>=Te))j[ve][Me]=Ze,O[ve][Me]=3,M[ve][Me]=0;else if(Oe&&(!Se||je>=Te))j[ve][Me]=je,O[ve][Me]=2,M[ve][Me]=0;else if(Se)j[ve][Me]=Te,O[ve][Me]=1,M[ve][Me]=M[ve-1][Me-1]+1;else throw new Error("not possible")}}if(F&&$(J,he,Fe,_e),!ke[0]&&!Ye)return;ve--,Me--;const ye=[j[ve][Me],_e];let Ae=0,oe=0;for(;ve>=1;){let fe=Me;do{const we=O[ve][fe];if(we===3)fe=fe-2;else if(we===2)fe=fe-1;else break}while(fe>=1);Ae>1&&ae[he+ve-1]===He[_e+Me-1]&&!be(fe+_e-1,Fe,He)&&Ae+1>M[ve][fe]&&(fe=Me),fe===Me?Ae++:Ae=1,oe||(oe=fe),ve--,Me=fe-1,ye.push(Me)}ie===K&&(ye[0]+=2);const ue=oe-K;return ye[0]-=ue,ye}e.fuzzyScore=Qe;function ze(J,ae,he,Fe,He,_e){let Ye=J-1,K=ae-1;for(;Ye>=he&&K>=Fe;)He[Ye]===_e[K]&&(W[Ye]=K,Ye--),K--}function Ge(J,ae,he,Fe,He,_e,Ye,K,ie,ve,Me){if(ae[he]!==_e[Ye])return Number.MIN_SAFE_INTEGER;let xe=1,Je=!1;return Ye===he-Fe?xe=J[he]===He[Ye]?7:5:be(Ye,He,_e)&&(Ye===0||!be(Ye-1,He,_e))?(xe=J[he]===He[Ye]?7:5,Je=!0):Y(_e,Ye)&&(Ye===0||!Y(_e,Ye-1))?xe=5:(Y(_e,Ye-1)||le(_e,Ye-1))&&(xe=5,Je=!0),xe>1&&he===Fe&&(Me[0]=!0),Je||(Je=be(Ye,He,_e)||Y(_e,Ye-1)||le(_e,Ye-1)),he===Fe?Ye>ie&&(xe-=Je?3:5):ve?xe+=Je?2:0:xe+=Je?0:1,Ye+1===K&&(xe-=Je?3:5),xe}function V(J,ae,he,Fe,He,_e,Ye){return ne(J,ae,he,Fe,He,_e,!0,Ye)}e.fuzzyScoreGracefulAggressive=V;function Z(J,ae,he,Fe,He,_e,Ye){return ne(J,ae,he,Fe,He,_e,!1,Ye)}e.fuzzyScoreGraceful=Z;function ne(J,ae,he,Fe,He,_e,Ye,K){let ie=Qe(J,ae,he,Fe,He,_e,K);if(ie&&!Ye)return ie;if(J.length>=3){const ve=Math.min(7,J.length-1);for(let Me=he+1;Me<ve;Me++){const xe=se(J,Me);if(xe){const Je=Qe(xe,xe.toLowerCase(),he,Fe,He,_e,K);Je&&(Je[0]-=3,(!ie||Je[0]>ie[0])&&(ie=Je))}}}return ie}function se(J,ae){if(ae+1>=J.length)return;const he=J[ae],Fe=J[ae+1];if(he!==Fe)return J.slice(0,ae)+Fe+he+J.slice(ae+2)}}),define(me[136],ge([0,1,90,93,8]),function(X,e,p,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.matchesFuzzyIconAware=e.parseLabelWithIcons=e.stripIcons=e.markdownEscapeEscapedIcons=e.escapeIcons=e.iconStartMarker=void 0,e.iconStartMarker="$(";const y=new RegExp(`\\$\\(${p.CSSIcon.iconNameExpression}(?:${p.CSSIcon.iconModifierExpression})?\\)`,"g"),A=new RegExp(`(\\\\)?${y.source}`,"g");function P(u){return u.replace(A,(S,w)=>w?S:`\\${S}`)}e.escapeIcons=P;const E=new RegExp(`\\\\${y.source}`,"g");function k(u){return u.replace(E,S=>`\\${S}`)}e.markdownEscapeEscapedIcons=k;const r=new RegExp(`(\\s)?(\\\\)?${y.source}(\\s)?`,"g");function I(u){return u.indexOf(e.iconStartMarker)===-1?u:u.replace(r,(S,w,b,d)=>b?S:w||d||"")}e.stripIcons=I;function l(u){const S=u.indexOf(e.iconStartMarker);return S===-1?{text:u}:f(u,S)}e.parseLabelWithIcons=l;function f(u,S){const w=[];let b="";function d(v){if(v){b+=v;for(const m of v)w.push(t)}}let h=-1,g="",t=0,i,s,n=S;const o=u.length;for(d(u.substr(0,S));n<o;)i=u[n],s=u[n+1],i===e.iconStartMarker[0]&&s===e.iconStartMarker[1]?(h=n,d(g),g=e.iconStartMarker,n++):i===")"&&h!==-1?(t+=n-h+1,h=-1,g=""):h!==-1?/^[a-z0-9\-]$/i.test(i)?g+=i:(d(g),h=-1,g=""):d(i),n++;return d(g),{text:b,iconOffsets:w}}function c(u,S,w=!1){const{text:b,iconOffsets:d}=S;if(!d||d.length===0)return R.matchesFuzzy(u,b,w);const h=C.ltrim(b," "),g=b.length-h.length,t=R.matchesFuzzy(u,h,w);if(t)for(const i of t){const s=d[i.start+g]+g;i.start+=s,i.end+=s}return t}e.matchesFuzzyIconAware=c}),define(me[94],ge([0,1,136,14]),function(X,e,p,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseHrefAndDimensions=e.removeMarkdownEscapes=e.escapeMarkdownSyntaxTokens=e.markdownStringEqual=e.isMarkdownString=e.isEmptyMarkdownString=e.MarkdownString=e.MarkdownStringTextNewlineStyle=void 0;var C;(function(l){l[l.Paragraph=0]="Paragraph",l[l.Break=1]="Break"})(C=e.MarkdownStringTextNewlineStyle||(e.MarkdownStringTextNewlineStyle={}));class y{constructor(f="",c=!1){var u,S;if(this.value=f,typeof this.value!="string")throw R.illegalArgument("value");typeof c=="boolean"?(this.isTrusted=c,this.supportThemeIcons=!1):(this.isTrusted=(u=c.isTrusted)!==null&&u!==void 0?u:void 0,this.supportThemeIcons=(S=c.supportThemeIcons)!==null&&S!==void 0?S:!1)}appendText(f,c=0){return this.value+=k(this.supportThemeIcons?p.escapeIcons(f):f).replace(/([ \t]+)/g,(u,S)=>"&nbsp;".repeat(S.length)).replace(/^>/gm,"\\>").replace(/\n/g,c===1?`\\
`:`

`),this}appendMarkdown(f){return this.value+=f,this}appendCodeblock(f,c){return this.value+="\n```",this.value+=f,this.value+=`
`,this.value+=c,this.value+="\n```\n",this}}e.MarkdownString=y;function A(l){return P(l)?!l.value:Array.isArray(l)?l.every(A):!0}e.isEmptyMarkdownString=A;function P(l){return l instanceof y?!0:l&&typeof l=="object"?typeof l.value=="string"&&(typeof l.isTrusted=="boolean"||l.isTrusted===void 0)&&(typeof l.supportThemeIcons=="boolean"||l.supportThemeIcons===void 0):!1}e.isMarkdownString=P;function E(l,f){return l===f?!0:!l||!f?!1:l.value===f.value&&l.isTrusted===f.isTrusted&&l.supportThemeIcons===f.supportThemeIcons}e.markdownStringEqual=E;function k(l){return l.replace(/[\\`*_{}[\]()#+\-.!]/g,"\\$&")}e.escapeMarkdownSyntaxTokens=k;function r(l){return l&&l.replace(/\\([\\`*_{}[\]()#+\-.!])/g,"$1")}e.removeMarkdownEscapes=r;function I(l){const f=[],c=l.split("|").map(S=>S.trim());l=c[0];const u=c[1];if(u){const S=/height=(\d+)/.exec(u),w=/width=(\d+)/.exec(u),b=S?S[1]:"",d=w?w[1]:"",h=isFinite(parseInt(d)),g=isFinite(parseInt(b));h&&f.push(`width="${d}"`),g&&f.push(`height="${b}"`)}return{href:l,dimensions:f}}e.parseHrefAndDimensions=I}),define(me[55],ge([0,1,22,8,2]),function(X,e,p,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.MarshalledId=e.parse=e.stringify=void 0;function y(r){return JSON.stringify(r,E)}e.stringify=y;function A(r){let I=JSON.parse(r);return I=k(I),I}e.parse=A;var P;(function(r){r[r.Uri=1]="Uri",r[r.Regexp=2]="Regexp",r[r.ScmResource=3]="ScmResource",r[r.ScmResourceGroup=4]="ScmResourceGroup",r[r.ScmProvider=5]="ScmProvider",r[r.CommentController=6]="CommentController",r[r.CommentThread=7]="CommentThread",r[r.CommentThreadReply=8]="CommentThreadReply",r[r.CommentNode=9]="CommentNode",r[r.CommentThreadNode=10]="CommentThreadNode",r[r.TimelineActionContext=11]="TimelineActionContext",r[r.NotebookCellActionContext=12]="NotebookCellActionContext",r[r.TestItemContext=13]="TestItemContext"})(P=e.MarshalledId||(e.MarshalledId={}));function E(r,I){return I instanceof RegExp?{$mid:2,source:I.source,flags:R.regExpFlags(I)}:I}function k(r,I=0){if(!r||I>200)return r;if(typeof r=="object"){switch(r.$mid){case 1:return C.URI.revive(r);case 2:return new RegExp(r.source,r.flags)}if(r instanceof p.VSBuffer||r instanceof Uint8Array)return r;if(Array.isArray(r))for(let l=0;l<r.length;++l)r[l]=k(r[l],I+1);else for(const l in r)Object.hasOwnProperty.call(r,l)&&(r[l]=k(r[l],I+1))}return r}e.revive=k}),define(me[10],ge([0,1,2,11]),function(X,e,p,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileAccess=e.RemoteAuthorities=e.Schemas=void 0;var C;(function(P){P.inMemory="inmemory",P.vscode="vscode",P.internal="private",P.walkThrough="walkThrough",P.walkThroughSnippet="walkThroughSnippet",P.http="http",P.https="https",P.file="file",P.mailto="mailto",P.untitled="untitled",P.data="data",P.command="command",P.vscodeRemote="vscode-remote",P.vscodeRemoteResource="vscode-remote-resource",P.userData="vscode-userdata",P.vscodeCustomEditor="vscode-custom-editor",P.vscodeNotebook="vscode-notebook",P.vscodeNotebookCell="vscode-notebook-cell",P.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",P.vscodeNotebookCellOutput="vscode-notebook-cell-output",P.vscodeInteractive="vscode-interactive",P.vscodeInteractiveInput="vscode-interactive-input",P.vscodeSettings="vscode-settings",P.vscodeWorkspaceTrust="vscode-workspace-trust",P.vscodeTerminal="vscode-terminal",P.webviewPanel="webview-panel",P.vscodeWebview="vscode-webview",P.extension="extension",P.vscodeFileResource="vscode-file",P.tmp="tmp"})(C=e.Schemas||(e.Schemas={}));class y{constructor(){this._hosts=Object.create(null),this._ports=Object.create(null),this._connectionTokens=Object.create(null),this._preferredWebSchema="http",this._delegate=null}setPreferredWebSchema(E){this._preferredWebSchema=E}setDelegate(E){this._delegate=E}set(E,k,r){this._hosts[E]=k,this._ports[E]=r}setConnectionToken(E,k){this._connectionTokens[E]=k}rewrite(E){if(this._delegate)return this._delegate(E);const k=E.authority;let r=this._hosts[k];r&&r.indexOf(":")!==-1&&(r=`[${r}]`);const I=this._ports[k],l=this._connectionTokens[k];let f=`path=${encodeURIComponent(E.path)}`;return typeof l=="string"&&(f+=`&tkn=${encodeURIComponent(l)}`),p.URI.from({scheme:R.isWeb?this._preferredWebSchema:C.vscodeRemoteResource,authority:`${r}:${I}`,path:"/vscode-remote-resource",query:f})}}e.RemoteAuthorities=new y;class A{constructor(){this.FALLBACK_AUTHORITY="vscode-app"}asBrowserUri(E,k,r){const I=this.toUri(E,k);if(I.scheme===C.vscodeRemote)return e.RemoteAuthorities.rewrite(I);let l=!1;return R.isNative&&(r||R.isPreferringBrowserCodeLoad)&&I.scheme===C.file&&(l=!0),I.scheme===C.file&&typeof R.globals.importScripts=="function"&&R.globals.origin==="vscode-file://vscode-app"&&(l=!0),l?I.with({scheme:C.vscodeFileResource,authority:I.authority||this.FALLBACK_AUTHORITY,query:null,fragment:null}):I}asFileUri(E,k){const r=this.toUri(E,k);return r.scheme===C.vscodeFileResource?r.with({scheme:C.file,authority:r.authority!==this.FALLBACK_AUTHORITY?r.authority:null,query:null,fragment:null}):r}toUri(E,k){return p.URI.isUri(E)?E:p.URI.parse(k.toUrl(E))}}e.FileAccess=new A}),define(me[74],ge([0,1,23]),function(X,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeAccents=e.normalizeNFD=e.normalizeNFC=e.canNormalize=void 0,e.canNormalize=typeof String.prototype.normalize=="function";const R=new p.LRUCache(1e4);function C(k){return E(k,"NFC",R)}e.normalizeNFC=C;const y=new p.LRUCache(1e4);function A(k){return E(k,"NFD",y)}e.normalizeNFD=A;const P=/[^\u0000-\u0080]/;function E(k,r,I){if(!e.canNormalize||!k)return k;const l=I.get(k);if(l)return l;let f;return P.test(k)?f=k.normalize(r):f=k,I.set(k,f),f}e.removeAccents=function(){if(e.canNormalize){const k=/[\u0300-\u036f]/g;return function(r){return A(r).replace(k,"")}}else return function(k){return k}}()}),define(me[24],ge([0,1,29,9,2,8,10,11]),function(X,e,p,R,C,y,A,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function E(f){return C.uriToFsPath(f,!0)}e.originalFSPath=E;class k{constructor(c){this._ignorePathCasing=c}compare(c,u,S=!1){return c===u?0:y.compare(this.getComparisonKey(c,S),this.getComparisonKey(u,S))}isEqual(c,u,S=!1){return c===u?!0:!c||!u?!1:this.getComparisonKey(c,S)===this.getComparisonKey(u,S)}getComparisonKey(c,u=!1){return c.with({path:this._ignorePathCasing(c)?c.path.toLowerCase():void 0,fragment:u?null:void 0}).toString()}ignorePathCasing(c){return this._ignorePathCasing(c)}isEqualOrParent(c,u,S=!1){if(c.scheme===u.scheme){if(c.scheme===A.Schemas.file)return p.isEqualOrParent(E(c),E(u),this._ignorePathCasing(c))&&c.query===u.query&&(S||c.fragment===u.fragment);if(e.isEqualAuthority(c.authority,u.authority))return p.isEqualOrParent(c.path,u.path,this._ignorePathCasing(c),"/")&&c.query===u.query&&(S||c.fragment===u.fragment)}return!1}joinPath(c,...u){return C.URI.joinPath(c,...u)}basenameOrAuthority(c){return e.basename(c)||c.authority}basename(c){return R.posix.basename(c.path)}extname(c){return R.posix.extname(c.path)}dirname(c){if(c.path.length===0)return c;let u;return c.scheme===A.Schemas.file?u=C.URI.file(R.dirname(E(c))).path:(u=R.posix.dirname(c.path),c.authority&&u.length&&u.charCodeAt(0)!==47&&(console.error(`dirname("${c.toString})) resulted in a relative path`),u="/")),c.with({path:u})}normalizePath(c){if(!c.path.length)return c;let u;return c.scheme===A.Schemas.file?u=C.URI.file(R.normalize(E(c))).path:u=R.posix.normalize(c.path),c.with({path:u})}relativePath(c,u){if(c.scheme!==u.scheme||!e.isEqualAuthority(c.authority,u.authority))return;if(c.scheme===A.Schemas.file){const b=R.relative(E(c),E(u));return P.isWindows?p.toSlashes(b):b}let S=c.path||"/",w=u.path||"/";if(this._ignorePathCasing(c)){let b=0;for(const d=Math.min(S.length,w.length);b<d&&!(S.charCodeAt(b)!==w.charCodeAt(b)&&S.charAt(b).toLowerCase()!==w.charAt(b).toLowerCase());b++);S=w.substr(0,b)+S.substr(b)}return R.posix.relative(S,w)}resolvePath(c,u){if(c.scheme===A.Schemas.file){const S=C.URI.file(R.resolve(E(c),u));return c.with({authority:S.authority,path:S.path})}return u=p.toPosixPath(u),c.with({path:R.posix.resolve(c.path,u)})}isAbsolutePath(c){return!!c.path&&c.path[0]==="/"}isEqualAuthority(c,u){return c===u||y.equalsIgnoreCase(c,u)}hasTrailingPathSeparator(c,u=R.sep){if(c.scheme===A.Schemas.file){const S=E(c);return S.length>p.getRoot(S).length&&S[S.length-1]===u}else{const S=c.path;return S.length>1&&S.charCodeAt(S.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(c.fsPath)}}removeTrailingPathSeparator(c,u=R.sep){return e.hasTrailingPathSeparator(c,u)?c.with({path:c.path.substr(0,c.path.length-1)}):c}addTrailingPathSeparator(c,u=R.sep){let S=!1;if(c.scheme===A.Schemas.file){const w=E(c);S=w!==void 0&&w.length===p.getRoot(w).length&&w[w.length-1]===u}else{u="/";const w=c.path;S=w.length===1&&w.charCodeAt(w.length-1)===47}return!S&&!e.hasTrailingPathSeparator(c,u)?c.with({path:c.path+"/"}):c}}e.ExtUri=k,e.extUri=new k(()=>!1),e.extUriBiasedIgnorePathCase=new k(f=>f.scheme===A.Schemas.file?!P.isLinux:!0),e.extUriIgnorePathCase=new k(f=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function r(f,c){const u=[];for(let S=0;S<f.length;S++){const w=c(f[S]);f.some((b,d)=>d===S?!1:e.isEqualOrParent(w,c(b)))||u.push(f[S])}return u}e.distinctParents=r;var I;(function(f){f.META_DATA_LABEL="label",f.META_DATA_DESCRIPTION="description",f.META_DATA_SIZE="size",f.META_DATA_MIME="mime";function c(u){const S=new Map;u.path.substring(u.path.indexOf(";")+1,u.path.lastIndexOf(";")).split(";").forEach(d=>{const[h,g]=d.split(":");h&&g&&S.set(h,g)});const b=u.path.substring(0,u.path.indexOf(";"));return b&&S.set(f.META_DATA_MIME,b),S}f.parseMetaData=c})(I=e.DataUri||(e.DataUri={}));function l(f,c,u){if(c){let S=f.path;return S&&S[0]!==R.posix.sep&&(S=R.posix.sep+S),f.with({scheme:u,authority:c,path:S})}return f.with({scheme:u})}e.toLocalResource=l}),define(me[16],ge([0,1,21,14,3,6,71,24]),function(X,e,p,R,C,y,A,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.AsyncEmitter=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.IdleValue=e.runWhenIdle=e.ThrottledWorker=e.RunOnceWorker=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.ignoreErrors=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function E(O){return!!O&&typeof O.then=="function"}e.isThenable=E;function k(O){const F=new p.CancellationTokenSource,B=O(F.token),$=new Promise((Y,le)=>{F.token.onCancellationRequested(()=>{le(R.canceled())}),Promise.resolve(B).then(be=>{F.dispose(),Y(be)},be=>{F.dispose(),le(be)})});return new class{cancel(){F.cancel()}then(Y,le){return $.then(Y,le)}catch(Y){return this.then(void 0,Y)}finally(Y){return $.finally(Y)}}}e.createCancelablePromise=k;function r(O,F,B){return Promise.race([O,new Promise($=>F.onCancellationRequested(()=>$(B)))])}e.raceCancellation=r;async function I(O){let F=-1;const B=O.map((Y,le)=>Y.then(be=>(F=le,be))),$=await Promise.race(B);return O.forEach((Y,le)=>{le!==F&&Y.cancel()}),$}e.raceCancellablePromises=I;function l(O,F,B){let $;const Y=setTimeout(()=>{$==null||$(void 0),B==null||B()},F);return Promise.race([O.finally(()=>clearTimeout(Y)),new Promise(le=>$=le)])}e.raceTimeout=l;function f(O){return new Promise((F,B)=>{const $=O();E($)?$.then(F,B):F($)})}e.asPromise=f;class c{constructor(){this.activePromise=null,this.queuedPromise=null,this.queuedPromiseFactory=null}queue(F){if(this.activePromise){if(this.queuedPromiseFactory=F,!this.queuedPromise){const B=()=>{this.queuedPromise=null;const $=this.queue(this.queuedPromiseFactory);return this.queuedPromiseFactory=null,$};this.queuedPromise=new Promise($=>{this.activePromise.then(B,B).then($)})}return new Promise((B,$)=>{this.queuedPromise.then(B,$)})}return this.activePromise=F(),new Promise((B,$)=>{this.activePromise.then(Y=>{this.activePromise=null,B(Y)},Y=>{this.activePromise=null,$(Y)})})}}e.Throttler=c;class u{constructor(){this.current=Promise.resolve(null)}queue(F){return this.current=this.current.then(()=>F(),()=>F())}}e.Sequencer=u;class S{constructor(){this.promiseMap=new Map}queue(F,B){var $;const le=(($=this.promiseMap.get(F))!==null&&$!==void 0?$:Promise.resolve()).catch(()=>{}).then(B).finally(()=>{this.promiseMap.get(F)===le&&this.promiseMap.delete(F)});return this.promiseMap.set(F,le),le}}e.SequencerByKey=S;class w{constructor(F){this.defaultDelay=F,this.timeout=null,this.completionPromise=null,this.doResolve=null,this.doReject=null,this.task=null}trigger(F,B=this.defaultDelay){return this.task=F,this.cancelTimeout(),this.completionPromise||(this.completionPromise=new Promise(($,Y)=>{this.doResolve=$,this.doReject=Y}).then(()=>{if(this.completionPromise=null,this.doResolve=null,this.task){const $=this.task;return this.task=null,$()}})),this.timeout=setTimeout(()=>{this.timeout=null,this.doResolve&&this.doResolve(null)},B),this.completionPromise}isTriggered(){return this.timeout!==null}cancel(){this.cancelTimeout(),this.completionPromise&&(this.doReject&&this.doReject(R.canceled()),this.completionPromise=null)}cancelTimeout(){this.timeout!==null&&(clearTimeout(this.timeout),this.timeout=null)}dispose(){this.cancel()}}e.Delayer=w;class b{constructor(F){this.delayer=new w(F),this.throttler=new c}trigger(F,B){return this.delayer.trigger(()=>this.throttler.queue(F),B)}isTriggered(){return this.delayer.isTriggered()}cancel(){this.delayer.cancel()}dispose(){this.delayer.dispose()}}e.ThrottledDelayer=b;class d{constructor(){this._isOpen=!1,this._promise=new Promise((F,B)=>{this._completePromise=F})}isOpen(){return this._isOpen}open(){this._isOpen=!0,this._completePromise(!0)}wait(){return this._promise}}e.Barrier=d;class h extends d{constructor(F){super();this._timeout=setTimeout(()=>this.open(),F)}open(){clearTimeout(this._timeout),super.open()}}e.AutoOpenBarrier=h;function g(O,F){return F?new Promise((B,$)=>{const Y=setTimeout(B,O);F.onCancellationRequested(()=>{clearTimeout(Y),$(R.canceled())})}):k(B=>g(O,B))}e.timeout=g;function t(O,F=0){const B=setTimeout(O,F);return y.toDisposable(()=>clearTimeout(B))}e.disposableTimeout=t;function i(O){return O.then(void 0,F=>{})}e.ignoreErrors=i;function s(O){const F=[];let B=0;const $=O.length;function Y(){return B<$?O[B++]():null}function le(be){be!=null&&F.push(be);const Le=Y();return Le?Le.then(le):Promise.resolve(F)}return Promise.resolve(null).then(le)}e.sequence=s;function n(O,F=$=>!!$,B=null){let $=0;const Y=O.length,le=()=>{if($>=Y)return Promise.resolve(B);const be=O[$++];return Promise.resolve(be()).then(Ie=>F(Ie)?Promise.resolve(Ie):le())};return le()}e.first=n;function o(O,F=$=>!!$,B=null){if(O.length===0)return Promise.resolve(B);let $=O.length;const Y=()=>{var le,be;$=-1;for(const Le of O)(be=(le=Le).cancel)===null||be===void 0||be.call(le)};return new Promise((le,be)=>{for(const Le of O)Le.then(Ie=>{--$>=0&&F(Ie)?(Y(),le(Ie)):$===0&&le(B)}).catch(Ie=>{--$>=0&&(Y(),be(Ie))})})}e.firstParallel=o;class v{constructor(F){this._size=0,this.maxDegreeOfParalellism=F,this.outstandingPromises=[],this.runningPromises=0,this._onFinished=new C.Emitter}get onFinished(){return this._onFinished.event}get size(){return this._size}queue(F){return this._size++,new Promise((B,$)=>{this.outstandingPromises.push({factory:F,c:B,e:$}),this.consume()})}consume(){for(;this.outstandingPromises.length&&this.runningPromises<this.maxDegreeOfParalellism;){const F=this.outstandingPromises.shift();this.runningPromises++;const B=F.factory();B.then(F.c,F.e),B.then(()=>this.consumed(),()=>this.consumed())}}consumed(){this._size--,this.runningPromises--,this.outstandingPromises.length>0?this.consume():this._onFinished.fire()}dispose(){this._onFinished.dispose()}}e.Limiter=v;class m extends v{constructor(){super(1)}}e.Queue=m;class _{constructor(){this.queues=new Map}queueFor(F,B=P.extUri){const $=B.getComparisonKey(F);let Y=this.queues.get($);return Y||(Y=new m,C.Event.once(Y.onFinished)(()=>{Y==null||Y.dispose(),this.queues.delete($)}),this.queues.set($,Y)),Y}dispose(){this.queues.forEach(F=>F.dispose()),this.queues.clear()}}e.ResourceQueue=_;class D{constructor(F,B){this._token=-1,typeof F=="function"&&typeof B=="number"&&this.setIfNotSet(F,B)}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearTimeout(this._token),this._token=-1)}cancelAndSet(F,B){this.cancel(),this._token=setTimeout(()=>{this._token=-1,F()},B)}setIfNotSet(F,B){this._token===-1&&(this._token=setTimeout(()=>{this._token=-1,F()},B))}}e.TimeoutTimer=D;class a{constructor(){this._token=-1}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearInterval(this._token),this._token=-1)}cancelAndSet(F,B){this.cancel(),this._token=setInterval(()=>{F()},B)}}e.IntervalTimer=a;class T{constructor(F,B){this.timeoutToken=-1,this.runner=F,this.timeout=B,this.timeoutHandler=this.onTimeout.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearTimeout(this.timeoutToken),this.timeoutToken=-1)}schedule(F=this.timeout){this.cancel(),this.timeoutToken=setTimeout(this.timeoutHandler,F)}get delay(){return this.timeout}set delay(F){this.timeout=F}isScheduled(){return this.timeoutToken!==-1}onTimeout(){this.timeoutToken=-1,this.runner&&this.doRun()}doRun(){this.runner&&this.runner()}}e.RunOnceScheduler=T;class L extends T{constructor(F,B){super(F,B);this.units=[]}work(F){this.units.push(F),this.isScheduled()||this.schedule()}doRun(){const F=this.units;this.units=[],this.runner&&this.runner(F)}dispose(){this.units=[],super.dispose()}}e.RunOnceWorker=L;class U extends y.Disposable{constructor(F,B,$,Y){super();this.maxWorkChunkSize=F,this.maxPendingWork=B,this.throttleDelay=$,this.handler=Y,this.pendingWork=[],this.throttler=this._register(new y.MutableDisposable),this.disposed=!1}get pending(){return this.pendingWork.length}work(F){if(this.disposed)return!1;if(typeof this.maxPendingWork=="number"){if(this.throttler.value){if(this.pending+F.length>this.maxPendingWork)return!1}else if(this.pending+F.length-this.maxWorkChunkSize>this.maxPendingWork)return!1}return this.pendingWork.push(...F),this.throttler.value||this.doWork(),!0}doWork(){this.handler(this.pendingWork.splice(0,this.maxWorkChunkSize)),this.pendingWork.length>0&&(this.throttler.value=new T(()=>{this.throttler.clear(),this.doWork()},this.throttleDelay),this.throttler.value.schedule())}dispose(){super.dispose(),this.disposed=!0}}e.ThrottledWorker=U,function(){if(typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"){const O=Object.freeze({didTimeout:!0,timeRemaining(){return 15}});e.runWhenIdle=F=>{const B=setTimeout(()=>F(O));let $=!1;return{dispose(){$||($=!0,clearTimeout(B))}}}}else e.runWhenIdle=(O,F)=>{const B=requestIdleCallback(O,typeof F=="number"?{timeout:F}:void 0);let $=!1;return{dispose(){$||($=!0,cancelIdleCallback(B))}}}}();class G{constructor(F){this._didRun=!1,this._executor=()=>{try{this._value=F()}catch(B){this._error=B}finally{this._didRun=!0}},this._handle=e.runWhenIdle(()=>this._executor())}dispose(){this._handle.dispose()}get value(){if(this._didRun||(this._handle.dispose(),this._executor()),this._error)throw this._error;return this._value}}e.IdleValue=G;async function ee(O,F,B){let $;for(let Y=0;Y<B;Y++)try{return await O()}catch(le){$=le,await g(F)}throw $}e.retry=ee;class z{hasPending(F){return this._pending?typeof F=="number"?this._pending.taskId===F:!!this._pending:!1}get pending(){return this._pending?this._pending.promise:void 0}cancelPending(){var F;(F=this._pending)===null||F===void 0||F.cancel()}setPending(F,B,$){return this._pending={taskId:F,cancel:()=>$==null?void 0:$(),promise:B},B.then(()=>this.donePending(F),()=>this.donePending(F)),B}donePending(F){this._pending&&F===this._pending.taskId&&(this._pending=void 0,this.triggerNext())}triggerNext(){if(this._next){const F=this._next;this._next=void 0,F.run().then(F.promiseResolve,F.promiseReject)}}setNext(F){if(this._next)this._next.run=F;else{let B,$;const Y=new Promise((le,be)=>{B=le,$=be});this._next={run:F,promise:Y,promiseResolve:B,promiseReject:$}}return this._next.promise}}e.TaskSequentializer=z;class N{constructor(F){this.interval=F,this.lastIncrementTime=0,this.value=0}increment(){const F=Date.now();return F-this.lastIncrementTime>this.interval&&(this.lastIncrementTime=F,this.value=0),this.value++,this.value}}e.IntervalCounter=N;class W{constructor(){this.rejected=!1,this.resolved=!1,this.p=new Promise((F,B)=>{this.completeCallback=F,this.errorCallback=B})}get isRejected(){return this.rejected}get isResolved(){return this.resolved}get isSettled(){return this.rejected||this.resolved}complete(F){return new Promise(B=>{this.completeCallback(F),this.resolved=!0,B()})}error(F){return new Promise(B=>{this.errorCallback(F),this.rejected=!0,B()})}cancel(){new Promise(F=>{this.errorCallback(R.canceled()),this.rejected=!0,F()})}}e.DeferredPromise=W;class M extends C.Emitter{async fireAsync(F,B,$){if(!!this._listeners){this._asyncDeliveryQueue||(this._asyncDeliveryQueue=new A.LinkedList);for(const Y of this._listeners)this._asyncDeliveryQueue.push([Y,F]);for(;this._asyncDeliveryQueue.size>0&&!B.isCancellationRequested;){const[Y,le]=this._asyncDeliveryQueue.shift(),be=[],Le=Object.assign(Object.assign({},le),{waitUntil:Ie=>{if(Object.isFrozen(be))throw new Error("waitUntil can NOT be called asynchronous");$&&(Ie=$(Ie,typeof Y=="function"?Y:Y[0])),be.push(Ie)}});try{typeof Y=="function"?Y.call(void 0,Le):Y[0].call(Y[1],Le)}catch(Ie){R.onUnexpectedError(Ie);continue}Object.freeze(be),await j.settled(be).catch(Ie=>R.onUnexpectedError(Ie))}}}}e.AsyncEmitter=M;var j;(function(O){async function F(B){let $;const Y=await Promise.all(B.map(le=>le.then(be=>be,be=>{$||($=be)})));if(typeof $!="undefined")throw $;return Y}O.settled=F})(j=e.Promises||(e.Promises={}))}),define(me[95],ge([0,1,9,16]),function(X,e,p,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.compareByPrefix=e.compareAnything=e.comparePaths=e.compareFileExtensionsUnicode=e.compareFileExtensionsLower=e.compareFileExtensionsUpper=e.compareFileExtensionsDefault=e.compareFileExtensions=e.noIntlCompareFileNames=e.compareFileNamesUnicode=e.compareFileNamesLower=e.compareFileNamesUpper=e.compareFileNamesDefault=e.compareFileNames=void 0;const C=new R.IdleValue(()=>{const D=new Intl.Collator(void 0,{numeric:!0,sensitivity:"base"});return{collator:D,collatorIsNumeric:D.resolvedOptions().numeric}}),y=new R.IdleValue(()=>({collator:new Intl.Collator(void 0,{numeric:!0})})),A=new R.IdleValue(()=>({collator:new Intl.Collator(void 0,{numeric:!0,sensitivity:"accent"})}));function P(D,a,T=!1){const L=D||"",U=a||"",G=C.value.collator.compare(L,U);return C.value.collatorIsNumeric&&G===0&&L!==U?L<U?-1:1:G}e.compareFileNames=P;function E(D,a){const T=y.value.collator;return D=D||"",a=a||"",g(T,D,a)}e.compareFileNamesDefault=E;function k(D,a){const T=y.value.collator;return D=D||"",a=a||"",n(D,a)||g(T,D,a)}e.compareFileNamesUpper=k;function r(D,a){const T=y.value.collator;return D=D||"",a=a||"",s(D,a)||g(T,D,a)}e.compareFileNamesLower=r;function I(D,a){return D=D||"",a=a||"",D===a?0:D<a?-1:1}e.compareFileNamesUnicode=I;function l(D,a,T=!1){T||(D=D&&D.toLowerCase(),a=a&&a.toLowerCase());const[L,U]=d(D),[G,ee]=d(a);return L!==G?L<G?-1:1:U===ee?0:U<ee?-1:1}e.noIntlCompareFileNames=l;function f(D,a){const[T,L]=d(D),[U,G]=d(a);let ee=C.value.collator.compare(L,G);if(ee===0){if(C.value.collatorIsNumeric&&L!==G)return L<G?-1:1;if(ee=C.value.collator.compare(T,U),C.value.collatorIsNumeric&&ee===0&&T!==U)return T<U?-1:1}return ee}e.compareFileExtensions=f;function c(D,a){D=D||"",a=a||"";const T=h(D),L=h(a),U=y.value.collator,G=A.value.collator;return g(G,T,L)||g(U,D,a)}e.compareFileExtensionsDefault=c;function u(D,a){D=D||"",a=a||"";const T=h(D),L=h(a),U=y.value.collator,G=A.value.collator;return g(G,T,L)||n(D,a)||g(U,D,a)}e.compareFileExtensionsUpper=u;function S(D,a){D=D||"",a=a||"";const T=h(D),L=h(a),U=y.value.collator,G=A.value.collator;return g(G,T,L)||s(D,a)||g(U,D,a)}e.compareFileExtensionsLower=S;function w(D,a){D=D||"",a=a||"";const T=h(D).toLowerCase(),L=h(a).toLowerCase();return T!==L?T<L?-1:1:D!==a?D<a?-1:1:0}e.compareFileExtensionsUnicode=w;const b=/^(.*?)(\.([^.]*))?$/;function d(D,a=!1){const T=D?b.exec(D):[];let L=[T&&T[1]||"",T&&T[3]||""];return a&&(!L[0]&&L[1]||L[0]&&L[0].charAt(0)===".")&&(L=[L[0]+"."+L[1],""]),L}function h(D){const a=D?b.exec(D):[];return a&&a[1]&&a[1].charAt(0)!=="."&&a[3]||""}function g(D,a,T){let L=D.compare(a,T);return L!==0?L:a.length!==T.length?a.length<T.length?-1:1:0}function t(D){const a=D.charAt(0);return a.toLocaleUpperCase()!==a}function i(D){const a=D.charAt(0);return a.toLocaleLowerCase()!==a}function s(D,a){return t(D)&&i(a)?-1:i(D)&&t(a)?1:0}function n(D,a){return i(D)&&t(a)?-1:t(D)&&i(a)?1:0}function o(D,a,T=!1){return T||(D=D&&D.toLowerCase(),a=a&&a.toLowerCase()),D===a?0:D<a?-1:1}function v(D,a,T=!1){const L=D.split(p.sep),U=a.split(p.sep),G=L.length-1,ee=U.length-1;let z,N;for(let W=0;;W++){if(z=G===W,N=ee===W,z&&N)return P(L[W],U[W],T);if(z)return-1;if(N)return 1;const M=o(L[W],U[W],T);if(M!==0)return M}}e.comparePaths=v;function m(D,a,T){const L=D.toLowerCase(),U=a.toLowerCase(),G=_(D,a,T);if(G)return G;const ee=L.endsWith(T),z=U.endsWith(T);if(ee!==z)return ee?-1:1;const N=P(L,U);return N!==0?N:L.localeCompare(U)}e.compareAnything=m;function _(D,a,T){const L=D.toLowerCase(),U=a.toLowerCase(),G=L.startsWith(T),ee=U.startsWith(T);if(G!==ee)return G?-1:1;if(G&&ee){if(L.length<U.length)return-1;if(L.length>U.length)return 1}return 0}e.compareByPrefix=_}),define(me[96],ge([0,1,95,93,9,11,8]),function(X,e,p,R,C,y,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.pieceToQuery=e.prepareQuery=e.compareItemsByFuzzyScore=e.scoreItemFuzzy=e.scoreFuzzy2=e.scoreFuzzy=void 0;const P=0,E=[P,[]];function k(z,N,W,M){if(!z||!N)return E;const j=z.length,O=N.length;if(j<O)return E;const F=z.toLowerCase();return!M&&!F.includes(W)?E:r(N,W,O,z,F,j)}e.scoreFuzzy=k;function r(z,N,W,M,j,O){const F=[],B=[];for(let be=0;be<W;be++){const Le=be*O,Ie=Le-O,Ue=be>0,Qe=z[be],ze=N[be];for(let Ge=0;Ge<O;Ge++){const V=Ge>0,Z=Le+Ge,ne=Z-1,se=Ie+Ge-1,J=V?F[ne]:0,ae=Ue&&V?F[se]:0,he=Ue&&V?B[se]:0;let Fe;!ae&&Ue?Fe=0:Fe=I(Qe,ze,M,j,Ge,he),Fe&&ae+Fe>=J?(B[Z]=he+1,F[Z]=ae+Fe):(B[Z]=P,F[Z]=J)}}const $=[];let Y=W-1,le=O-1;for(;Y>=0&&le>=0;){const be=Y*O+le;B[be]===P||($.push(le),Y--),le--}return[F[W*O-1],$.reverse()]}function I(z,N,W,M,j,O){let F=0;if(!l(N,M[j]))return F;if(F+=1,O>0&&(F+=O*5),z===W[j]&&(F+=1),j===0)F+=8;else{const B=f(W.charCodeAt(j-1));B?F+=B:R.isUpper(W.charCodeAt(j))&&(F+=2)}return F}function l(z,N){return z===N?!0:z==="/"||z==="\\"?N==="/"||N==="\\":!1}function f(z){switch(z){case 47:case 92:return 5;case 95:case 45:case 46:case 32:case 39:case 34:case 58:return 4;default:return 0}}const c=[void 0,[]];function u(z,N,W=0,M=0){const j=N;return j.values&&j.values.length>1?S(z,j.values,W,M):w(z,N,W,M)}e.scoreFuzzy2=u;function S(z,N,W,M){let j=0;const O=[];for(const F of N){const[B,$]=w(z,F,W,M);if(typeof B!="number")return c;j+=B,O.push(...$)}return[j,v(O)]}function w(z,N,W,M){const j=R.fuzzyScore(N.original,N.originalLowercase,W,z,z.toLowerCase(),M,!0);return j?[j[0],R.createMatches(j)]:c}const b=Object.freeze({score:0}),d=1<<18,h=1<<17,g=1<<16;function t(z,N,W,M,j){if(!z||!N.normalized)return b;const O=M.getItemLabel(z);if(!O)return b;const F=M.getItemDescription(z);let B;F?B=`${O}${F}${N.normalized}${Array.isArray(N.values)?N.values.length:""}${W}`:B=`${O}${N.normalized}${Array.isArray(N.values)?N.values.length:""}${W}`;const $=j[B];if($)return $;const Y=i(O,F,M.getItemPath(z),N,W);return j[B]=Y,Y}e.scoreItemFuzzy=t;function i(z,N,W,M,j){const O=!W||!M.containsPathSeparator;return W&&(y.isLinux?M.pathNormalized===W:A.equalsIgnoreCase(M.pathNormalized,W))?{score:d,labelMatch:[{start:0,end:z.length}],descriptionMatch:N?[{start:0,end:N.length}]:void 0}:M.values&&M.values.length>1?s(z,N,W,M.values,O,j):n(z,N,W,M,O,j)}function s(z,N,W,M,j,O){let F=0;const B=[],$=[];for(const Y of M){const{score:le,labelMatch:be,descriptionMatch:Le}=n(z,N,W,Y,j,O);if(le===P)return b;F+=le,be&&B.push(...be),Le&&$.push(...Le)}return{score:F,labelMatch:v(B),descriptionMatch:v($)}}function n(z,N,W,M,j,O){if(j||!N){const[F,B]=k(z,M.normalized,M.normalizedLowercase,O);if(F){const $=R.matchesPrefix(M.normalized,z);let Y;return $?(Y=h,Y+=Math.round(M.normalized.length/z.length*100)):Y=g,{score:Y+F,labelMatch:$||o(B)}}}if(N){let F=N;W&&(F=`${N}${C.sep}`);const B=F.length,$=`${F}${z}`,[Y,le]=k($,M.normalized,M.normalizedLowercase,O);if(Y){const be=o(le),Le=[],Ie=[];return be.forEach(Ue=>{Ue.start<B&&Ue.end>B?(Le.push({start:0,end:Ue.end-B}),Ie.push({start:Ue.start,end:B})):Ue.start>=B?Le.push({start:Ue.start-B,end:Ue.end-B}):Ie.push(Ue)}),{score:Y,labelMatch:Le,descriptionMatch:Ie}}}return b}function o(z){const N=[];if(!z)return N;let W;for(const M of z)W&&W.end===M?W.end+=1:(W={start:M,end:M+1},N.push(W));return N}function v(z){const N=z.sort((j,O)=>j.start-O.start),W=[];let M;for(const j of N)!M||!m(M,j)?(M=j,W.push(j)):(M.start=Math.min(M.start,j.start),M.end=Math.max(M.end,j.end));return W}function m(z,N){return!(z.end<N.start||N.end<z.start)}function _(z,N,W,M,j,O){const F=t(z,W,M,j,O),B=t(N,W,M,j,O),$=F.score,Y=B.score;if(($===d||Y===d)&&$!==Y)return $===d?-1:1;if($>g||Y>g){if($!==Y)return $>Y?-1:1;if($<h&&Y<h){const ze=a(F.labelMatch,B.labelMatch);if(ze!==0)return ze}const Ue=j.getItemLabel(z)||"",Qe=j.getItemLabel(N)||"";if(Ue.length!==Qe.length)return Ue.length-Qe.length}if($!==Y)return $>Y?-1:1;const le=Array.isArray(F.labelMatch)&&F.labelMatch.length>0,be=Array.isArray(B.labelMatch)&&B.labelMatch.length>0;if(le&&!be)return-1;if(be&&!le)return 1;const Le=D(z,F,j),Ie=D(N,B,j);return Le&&Ie&&Le!==Ie?Ie>Le?-1:1:T(z,N,W,j)}e.compareItemsByFuzzyScore=_;function D(z,N,W){let M=-1,j=-1;if(N.descriptionMatch&&N.descriptionMatch.length?M=N.descriptionMatch[0].start:N.labelMatch&&N.labelMatch.length&&(M=N.labelMatch[0].start),N.labelMatch&&N.labelMatch.length){if(j=N.labelMatch[N.labelMatch.length-1].end,N.descriptionMatch&&N.descriptionMatch.length){const O=W.getItemDescription(z);O&&(j+=O.length)}}else N.descriptionMatch&&N.descriptionMatch.length&&(j=N.descriptionMatch[N.descriptionMatch.length-1].end);return j-M}function a(z,N){if(!z&&!N||(!z||!z.length)&&(!N||!N.length))return 0;if(!N||!N.length)return-1;if(!z||!z.length)return 1;const W=z[0].start,j=z[z.length-1].end-W,O=N[0].start,B=N[N.length-1].end-O;return j===B?0:B<j?1:-1}function T(z,N,W,M){const j=M.getItemLabel(z)||"",O=M.getItemLabel(N)||"",F=M.getItemDescription(z),B=M.getItemDescription(N),$=j.length+(F?F.length:0),Y=O.length+(B?B.length:0);if($!==Y)return $-Y;const le=M.getItemPath(z),be=M.getItemPath(N);return le&&be&&le.length!==be.length?le.length-be.length:j!==O?p.compareAnything(j,O,W.normalized):F&&B&&F!==B?p.compareAnything(F,B,W.normalized):le&&be&&le!==be?p.compareAnything(le,be,W.normalized):0}const L=" ";function U(z){typeof z!="string"&&(z="");const N=z.toLowerCase(),{pathNormalized:W,normalized:M,normalizedLowercase:j}=G(z),O=W.indexOf(C.sep)>=0;let F;const B=z.split(L);if(B.length>1)for(const $ of B){const{pathNormalized:Y,normalized:le,normalizedLowercase:be}=G($);le&&(F||(F=[]),F.push({original:$,originalLowercase:$.toLowerCase(),pathNormalized:Y,normalized:le,normalizedLowercase:be}))}return{original:z,originalLowercase:N,pathNormalized:W,normalized:M,normalizedLowercase:j,values:F,containsPathSeparator:O}}e.prepareQuery=U;function G(z){let N;y.isWindows?N=z.replace(/\//g,C.sep):N=z.replace(/\\/g,C.sep);const W=A.stripWildcards(N).replace(/\s/g,"");return{pathNormalized:N,normalized:W,normalizedLowercase:W.toLowerCase()}}function ee(z){return Array.isArray(z)?U(z.map(N=>N.original).join(L)):U(z.original)}e.pieceToQuery=ee}),define(me[30],ge([0,1,8,29,9,23,16]),function(X,e,p,R,C,y,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPathTerms=e.getBasenameTerms=e.isRelativePattern=e.hasSiblingFn=e.hasSiblingPromiseFn=e.parse=e.match=e.splitGlobAware=e.getEmptyExpression=void 0;function P(){return Object.create(null)}e.getEmptyExpression=P;const E="**",k="/",r="[/\\\\]",I="[^/\\\\]",l=/\//g;function f(F){switch(F){case 0:return"";case 1:return`${I}*?`;default:return`(?:${r}|${I}+${r}|${r}${I}+)*?`}}function c(F,B){if(!F)return[];const $=[];let Y=!1,le=!1,be="";for(const Le of F){switch(Le){case B:if(!Y&&!le){$.push(be),be="";continue}break;case"{":Y=!0;break;case"}":Y=!1;break;case"[":le=!0;break;case"]":le=!1;break}be+=Le}return be&&$.push(be),$}e.splitGlobAware=c;function u(F){if(!F)return"";let B="";const $=c(F,k);if($.every(Y=>Y===E))B=".*";else{let Y=!1;$.forEach((le,be)=>{if(le===E){Y||(B+=f(2),Y=!0);return}let Le=!1,Ie="",Ue=!1,Qe="";for(const ze of le){if(ze!=="}"&&Le){Ie+=ze;continue}if(Ue&&(ze!=="]"||!Qe)){let Ge;ze==="-"?Ge=ze:(ze==="^"||ze==="!")&&!Qe?Ge="^":ze===k?Ge="":Ge=p.escapeRegExpCharacters(ze),Qe+=Ge;continue}switch(ze){case"{":Le=!0;continue;case"[":Ue=!0;continue;case"}":B+=`(?:${c(Ie,",").map(Z=>u(Z)).join("|")})`,Le=!1,Ie="";break;case"]":B+="["+Qe+"]",Ue=!1,Qe="";break;case"?":B+=I;continue;case"*":B+=f(1);continue;default:B+=p.escapeRegExpCharacters(ze)}}be<$.length-1&&($[be+1]!==E||be+2<$.length)&&(B+=r),Y=!1})}return B}const S=/^\*\*\/\*\.[\w\.-]+$/,w=/^\*\*\/([\w\.-]+)\/?$/,b=/^{\*\*\/[\*\.]?[\w\.-]+\/?(,\*\*\/[\*\.]?[\w\.-]+\/?)*}$/,d=/^{\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?(,\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?)*}$/,h=/^\*\*((\/[\w\.-]+)+)\/?$/,g=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,t=new y.LRUCache(1e4),i=function(){return!1},s=function(){return null};function n(F,B){if(!F)return s;let $;typeof F!="string"?$=F.pattern:$=F,$=$.trim();const Y=`${$}_${!!B.trimForExclusions}`;let le=t.get(Y);if(le)return o(le,F);let be;if(S.test($)){const Le=$.substr(4);le=function(Ie,Ue){return typeof Ie=="string"&&Ie.endsWith(Le)?$:null}}else(be=w.exec(v($,B)))?le=m(be[1],$):(B.trimForExclusions?d:b).test($)?le=_($,B):(be=h.exec(v($,B)))?le=D(be[1].substr(1),$,!0):(be=g.exec(v($,B)))?le=D(be[1],$,!1):le=a($);return t.set(Y,le),o(le,F)}function o(F,B){return typeof B=="string"?F:function($,Y){return R.isEqualOrParent($,B.base)?F(C.relative(B.base,$),Y):null}}function v(F,B){return B.trimForExclusions&&F.endsWith("/**")?F.substr(0,F.length-2):F}function m(F,B){const $=`/${F}`,Y=`\\${F}`,le=function(Le,Ie){return typeof Le!="string"?null:Ie?Ie===F?B:null:Le===F||Le.endsWith($)||Le.endsWith(Y)?B:null},be=[F];return le.basenames=be,le.patterns=[B],le.allBasenames=be,le}function _(F,B){const $=O(F.slice(1,-1).split(",").map(Ie=>n(Ie,B)).filter(Ie=>Ie!==s),F),Y=$.length;if(!Y)return s;if(Y===1)return $[0];const le=function(Ie,Ue){for(let Qe=0,ze=$.length;Qe<ze;Qe++)if($[Qe](Ie,Ue))return F;return null},be=$.find(Ie=>!!Ie.allBasenames);be&&(le.allBasenames=be.allBasenames);const Le=$.reduce((Ie,Ue)=>Ue.allPaths?Ie.concat(Ue.allPaths):Ie,[]);return Le.length&&(le.allPaths=Le),le}function D(F,B,$){const Y=C.sep===C.posix.sep,le=Y?F:F.replace(l,C.sep),be=C.sep+le,Le=C.posix.sep+F,Ie=$?function(Ue,Qe){return typeof Ue=="string"&&(Ue===le||Ue.endsWith(be)||!Y&&(Ue===F||Ue.endsWith(Le)))?B:null}:function(Ue,Qe){return typeof Ue=="string"&&(Ue===le||!Y&&Ue===F)?B:null};return Ie.allPaths=[($?"*/":"./")+F],Ie}function a(F){try{const B=new RegExp(`^${u(F)}$`);return function($){return B.lastIndex=0,typeof $=="string"&&B.test($)?F:null}}catch(B){return s}}function T(F,B,$){return!F||typeof B!="string"?!1:L(F)(B,void 0,$)}e.match=T;function L(F,B={}){if(!F)return i;if(typeof F=="string"||z(F)){const $=n(F,B);if($===s)return i;const Y=function(le,be){return!!$(le,be)};return $.allBasenames&&(Y.allBasenames=$.allBasenames),$.allPaths&&(Y.allPaths=$.allPaths),Y}return M(F,B)}e.parse=L;function U(F){if(!F)return;let B;return $=>(B||(B=(F()||Promise.resolve([])).then(Y=>Y?ee(Y):{})),B.then(Y=>!!Y[$]))}e.hasSiblingPromiseFn=U;function G(F){if(!F)return;let B;return $=>{if(!B){const Y=F();B=Y?ee(Y):{}}return!!B[$]}}e.hasSiblingFn=G;function ee(F){const B={};for(const $ of F)B[$]=!0;return B}function z(F){const B=F;return B&&typeof B.base=="string"&&typeof B.pattern=="string"}e.isRelativePattern=z;function N(F){return F.allBasenames||[]}e.getBasenameTerms=N;function W(F){return F.allPaths||[]}e.getPathTerms=W;function M(F,B){const $=O(Object.getOwnPropertyNames(F).map(Ie=>j(Ie,F[Ie],B)).filter(Ie=>Ie!==s)),Y=$.length;if(!Y)return s;if(!$.some(Ie=>!!Ie.requiresSiblings)){if(Y===1)return $[0];const Ie=function(ze,Ge){for(let V=0,Z=$.length;V<Z;V++){const ne=$[V](ze,Ge);if(ne)return ne}return null},Ue=$.find(ze=>!!ze.allBasenames);Ue&&(Ie.allBasenames=Ue.allBasenames);const Qe=$.reduce((ze,Ge)=>Ge.allPaths?ze.concat(Ge.allPaths):ze,[]);return Qe.length&&(Ie.allPaths=Qe),Ie}const le=function(Ie,Ue,Qe){let ze;for(let Ge=0,V=$.length;Ge<V;Ge++){const Z=$[Ge];Z.requiresSiblings&&Qe&&(Ue||(Ue=C.basename(Ie)),ze||(ze=Ue.substr(0,Ue.length-C.extname(Ie).length)));const ne=Z(Ie,Ue,ze,Qe);if(ne)return ne}return null},be=$.find(Ie=>!!Ie.allBasenames);be&&(le.allBasenames=be.allBasenames);const Le=$.reduce((Ie,Ue)=>Ue.allPaths?Ie.concat(Ue.allPaths):Ie,[]);return Le.length&&(le.allPaths=Le),le}function j(F,B,$){if(B===!1)return s;const Y=n(F,$);if(Y===s)return s;if(typeof B=="boolean")return Y;if(B){const le=B.when;if(typeof le=="string"){const be=(Le,Ie,Ue,Qe)=>{if(!Qe||!Y(Le,Ie))return null;const ze=le.replace("$(basename)",Ue),Ge=Qe(ze);return A.isThenable(Ge)?Ge.then(V=>V?F:null):Ge?F:null};return be.requiresSiblings=!0,be}}return Y}function O(F,B){const $=F.filter(Ie=>!!Ie.basenames);if($.length<2)return F;const Y=$.reduce((Ie,Ue)=>{const Qe=Ue.basenames;return Qe?Ie.concat(Qe):Ie},[]);let le;if(B){le=[];for(let Ie=0,Ue=Y.length;Ie<Ue;Ie++)le.push(B)}else le=$.reduce((Ie,Ue)=>{const Qe=Ue.patterns;return Qe?Ie.concat(Qe):Ie},[]);const be=function(Ie,Ue){if(typeof Ie!="string")return null;if(!Ue){let ze;for(ze=Ie.length;ze>0;ze--){const Ge=Ie.charCodeAt(ze-1);if(Ge===47||Ge===92)break}Ue=Ie.substr(ze)}const Qe=Y.indexOf(Ue);return Qe!==-1?le[Qe]:null};be.basenames=Y,be.patterns=le,be.allBasenames=Y;const Le=F.filter(Ie=>!Ie.basenames);return Le.push(be),Le}}),define(me[75],ge([0,1,2,9,8,10,11,24,29]),function(X,e,p,R,C,y,A,P,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.splitName=e.unmnemonicLabel=e.mnemonicButtonLabel=e.mnemonicMenuLabel=e.template=e.shorten=e.untildify=e.tildify=e.normalizeDriveLetter=e.getBaseLabel=e.getPathLabel=void 0;function k(n,o,v){if(typeof n=="string"&&(n=p.URI.file(n)),v){const _=v.getWorkspaceFolder(n);if(_){const D=v.getWorkspace().folders.length>1;let a;if(P.isEqual(_.uri,n)?a="":a=P.relativePath(_.uri,n),D){const T=_.name?_.name:P.basename(_.uri);a=a?T+" \u2022 "+a:T}return a}}if(n.scheme!==y.Schemas.file&&n.scheme!==y.Schemas.untitled)return n.with({query:null,fragment:null}).toString(!0);if(E.hasDriveLetter(n.fsPath))return R.normalize(I(n.fsPath));let m=R.normalize(n.fsPath);return!A.isWindows&&(o==null?void 0:o.userHome)&&(m=f(m,o.userHome.fsPath)),m}e.getPathLabel=k;function r(n){if(!n)return;typeof n=="string"&&(n=p.URI.file(n));const o=P.basename(n)||(n.scheme===y.Schemas.file?n.fsPath:n.path);return A.isWindows&&E.isRootOrDriveLetter(o)?I(o):o}e.getBaseLabel=r;function I(n){return E.hasDriveLetter(n)?n.charAt(0).toUpperCase()+n.slice(1):n}e.normalizeDriveLetter=I;let l=Object.create(null);function f(n,o){if(A.isWindows||!n||!o)return n;let v=l.original===o?l.normalized:void 0;return v||(v=`${C.rtrim(o,R.posix.sep)}${R.posix.sep}`,l={original:o,normalized:v}),(A.isLinux?n.startsWith(v):C.startsWithIgnoreCase(n,v))&&(n=`~/${n.substr(v.length)}`),n}e.tildify=f;function c(n,o){return n.replace(/^~($|\/|\\)/,`${o}$1`)}e.untildify=c;const u="\u2026",S="\\\\",w="~";function b(n,o=R.sep){const v=new Array(n.length);let m=!1;for(let _=0;_<n.length;_++){let D=n[_];if(D===""){v[_]=`.${o}`;continue}if(!D){v[_]=D;continue}m=!0;let a="";D.indexOf(S)===0?(a=D.substr(0,D.indexOf(S)+S.length),D=D.substr(D.indexOf(S)+S.length)):D.indexOf(o)===0?(a=D.substr(0,D.indexOf(o)+o.length),D=D.substr(D.indexOf(o)+o.length)):D.indexOf(w)===0&&(a=D.substr(0,D.indexOf(w)+w.length),D=D.substr(D.indexOf(w)+w.length));const T=D.split(o);for(let L=1;m&&L<=T.length;L++)for(let U=T.length-L;m&&U>=0;U--){m=!1;let G=T.slice(U,U+L).join(o);for(let ee=0;!m&&ee<n.length;ee++)if(ee!==_&&n[ee]&&n[ee].indexOf(G)>-1){const z=U+L===T.length,N=U>0&&n[ee].indexOf(o)>-1?o+G:G,W=n[ee].endsWith(N);m=!z||W}if(!m){let ee="";(T[0].endsWith(":")||a!=="")&&(U===1&&(U=0,L++,G=T[0]+o+G),U>0&&(ee=T[0]+o),ee=a+ee),U>0&&(ee=ee+u+o),ee=ee+G,U+L<T.length&&(ee=ee+o+u),v[_]=ee}}m&&(v[_]=D)}return v}e.shorten=b;var d;(function(n){n[n.TEXT=0]="TEXT",n[n.VARIABLE=1]="VARIABLE",n[n.SEPARATOR=2]="SEPARATOR"})(d||(d={}));function h(n,o=Object.create(null)){const v=[];let m=!1,_="";for(const D of n)if(D==="$"||m&&D==="{")_&&v.push({value:_,type:d.TEXT}),_="",m=!0;else if(D==="}"&&m){const a=o[_];if(typeof a=="string")a.length&&v.push({value:a,type:d.VARIABLE});else if(a){const T=v[v.length-1];(!T||T.type!==d.SEPARATOR)&&v.push({value:a.label,type:d.SEPARATOR})}_="",m=!1}else _+=D;return _&&!m&&v.push({value:_,type:d.TEXT}),v.filter((D,a)=>{if(D.type===d.SEPARATOR){const T=v[a-1],L=v[a+1];return[T,L].every(U=>U&&(U.type===d.VARIABLE||U.type===d.TEXT)&&U.value.length>0)}return!0}).map(D=>D.value).join("")}e.template=h;function g(n,o){return A.isMacintosh||o?n.replace(/\(&&\w\)|&&/g,"").replace(/&/g,A.isMacintosh?"&":"&&"):n.replace(/&&|&/g,v=>v==="&"?"&&":"&")}e.mnemonicMenuLabel=g;function t(n,o){return A.isMacintosh||o?n.replace(/\(&&\w\)|&&/g,""):A.isWindows?n.replace(/&&|&/g,v=>v==="&"?"&&":"&"):n.replace(/&&/g,"_")}e.mnemonicButtonLabel=t;function i(n){return n.replace(/&/g,"&&")}e.unmnemonicLabel=i;function s(n){const o=n.indexOf("/")!==-1?R.posix:R.win32,v=o.basename(n),m=o.dirname(n);return v.length?{name:v,parentPath:m}:{name:m,parentPath:""}}e.splitName=s}),define(me[97],ge([0,1,9,8,30,10,24]),function(X,e,p,R,C,y,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.normalizeMimeType=e.getExtensionForMimeType=e.getMediaMime=e.isUnspecific=e.guessMimeTypes=e.clearTextMimes=e.registerTextMime=e.Mimes=void 0;var P;(function(i){i.text="text/plain",i.binary="application/octet-stream",i.unknown="application/unknown",i.markdown="text/markdown"})(P=e.Mimes||(e.Mimes={}));let E=[],k=[],r=[];function I(i,s=!1){const n=l(i);E.push(n),n.userConfigured?r.push(n):k.push(n),s&&!n.userConfigured&&E.forEach(o=>{o.mime===n.mime||o.userConfigured||(n.extension&&o.extension===n.extension&&console.warn(`Overwriting extension <<${n.extension}>> to now point to mime <<${n.mime}>>`),n.filename&&o.filename===n.filename&&console.warn(`Overwriting filename <<${n.filename}>> to now point to mime <<${n.mime}>>`),n.filepattern&&o.filepattern===n.filepattern&&console.warn(`Overwriting filepattern <<${n.filepattern}>> to now point to mime <<${n.mime}>>`),n.firstline&&o.firstline===n.firstline&&console.warn(`Overwriting firstline <<${n.firstline}>> to now point to mime <<${n.mime}>>`))})}e.registerTextMime=I;function l(i){return{id:i.id,mime:i.mime,filename:i.filename,extension:i.extension,filepattern:i.filepattern,firstline:i.firstline,userConfigured:i.userConfigured,filenameLowercase:i.filename?i.filename.toLowerCase():void 0,extensionLowercase:i.extension?i.extension.toLowerCase():void 0,filepatternLowercase:i.filepattern?i.filepattern.toLowerCase():void 0,filepatternOnPath:i.filepattern?i.filepattern.indexOf(p.posix.sep)>=0:!1}}function f(i){i?(E=E.filter(s=>!s.userConfigured),r=[]):(E=[],k=[],r=[])}e.clearTextMimes=f;function c(i,s){let n;if(i)switch(i.scheme){case y.Schemas.file:n=i.fsPath;break;case y.Schemas.data:n=A.DataUri.parseMetaData(i).get(A.DataUri.META_DATA_LABEL);break;default:n=i.path}if(!n)return[P.unknown];n=n.toLowerCase();const o=p.basename(n),v=u(n,o,r);if(v)return[v,P.text];const m=u(n,o,k);if(m)return[m,P.text];if(s){const _=S(s);if(_)return[_,P.text]}return[P.unknown]}e.guessMimeTypes=c;function u(i,s,n){let o=null,v=null,m=null;for(let _=n.length-1;_>=0;_--){const D=n[_];if(s===D.filenameLowercase){o=D;break}if(D.filepattern&&(!v||D.filepattern.length>v.filepattern.length)){const a=D.filepatternOnPath?i:s;C.match(D.filepatternLowercase,a)&&(v=D)}D.extension&&(!m||D.extension.length>m.extension.length)&&s.endsWith(D.extensionLowercase)&&(m=D)}return o?o.mime:v?v.mime:m?m.mime:null}function S(i){if(R.startsWithUTF8BOM(i)&&(i=i.substr(1)),i.length>0)for(let s=E.length-1;s>=0;s--){const n=E[s];if(!n.firstline)continue;const o=i.match(n.firstline);if(o&&o.length>0)return n.mime}return null}function w(i){return i?typeof i=="string"?i===P.binary||i===P.text||i===P.unknown:i.length===1&&w(i[0]):!0}e.isUnspecific=w;const b={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function d(i){const s=p.extname(i);return b[s.toLowerCase()]}e.getMediaMime=d;function h(i){for(const s in b)if(b[s]===i)return s}e.getExtensionForMimeType=h;const g=/^(.+)\/(.+?)(;.+)?$/;function t(i,s){var n;const o=g.exec(i);return o?`${o[1].toLowerCase()}/${o[2].toLowerCase()}${(n=o[3])!==null&&n!==void 0?n:""}`:s?void 0:i}e.normalizeMimeType=t}),define(me[98],ge([0,1,2]),function(X,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.transformAndReviveIncomingURIs=e.transformIncomingURIs=e.transformOutgoingURIs=e.DefaultURITransformer=e.URITransformer=void 0;function R(r){return r.toJSON()}class C{constructor(I){this._uriTransformer=I}transformIncoming(I){const l=this._uriTransformer.transformIncoming(I);return l===I?I:R(p.URI.from(l))}transformOutgoing(I){const l=this._uriTransformer.transformOutgoing(I);return l===I?I:R(p.URI.from(l))}transformOutgoingURI(I){const l=this._uriTransformer.transformOutgoing(I);return l===I?I:p.URI.from(l)}transformOutgoingScheme(I){return this._uriTransformer.transformOutgoingScheme(I)}}e.URITransformer=C,e.DefaultURITransformer=new class{transformIncoming(r){return r}transformOutgoing(r){return r}transformOutgoingURI(r){return r}transformOutgoingScheme(r){return r}};function y(r,I,l){if(!r||l>200)return null;if(typeof r=="object"){if(r instanceof p.URI)return I.transformOutgoing(r);for(let f in r)if(Object.hasOwnProperty.call(r,f)){const c=y(r[f],I,l+1);c!==null&&(r[f]=c)}}return null}function A(r,I){const l=y(r,I,0);return l===null?r:l}e.transformOutgoingURIs=A;function P(r,I,l,f){if(!r||f>200)return null;if(typeof r=="object"){if(r.$mid===1)return l?p.URI.revive(I.transformIncoming(r)):I.transformIncoming(r);for(let c in r)if(Object.hasOwnProperty.call(r,c)){const u=P(r[c],I,l,f+1);u!==null&&(r[c]=u)}}return null}function E(r,I){const l=P(r,I,!1,0);return l===null?r:l}e.transformIncomingURIs=E;function k(r,I){const l=P(r,I,!0,0);return l===null?r:l}e.transformAndReviveIncomingURIs=k}),define(me[32],ge([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const p=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function R(E){return p.test(E)}e.isUUID=R;const C=new Uint8Array(16),y=[];for(let E=0;E<256;E++)y.push(E.toString(16).padStart(2,"0"));let A;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?A=crypto.getRandomValues.bind(crypto):A=function(E){for(let k=0;k<E.length;k++)E[k]=Math.floor(Math.random()*256);return E};function P(){A(C),C[6]=C[6]&15|64,C[8]=C[8]&63|128;let E=0,k="";return k+=y[C[E++]],k+=y[C[E++]],k+=y[C[E++]],k+=y[C[E++]],k+="-",k+=y[C[E++]],k+=y[C[E++]],k+="-",k+=y[C[E++]],k+=y[C[E++]],k+="-",k+=y[C[E++]],k+=y[C[E++]],k+="-",k+=y[C[E++]],k+=y[C[E++]],k+=y[C[E++]],k+=y[C[E++]],k+=y[C[E++]],k+=y[C[E++]],k}e.generateUuid=P}),define(me[137],ge([0,1,99]),function(X,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LineDecoder=void 0;class R{constructor(y="utf8"){this.stringDecoder=new p.StringDecoder(y),this.remaining=null}write(y){const A=[],P=this.remaining?this.remaining+this.stringDecoder.write(y):this.stringDecoder.write(y);if(P.length<1)return A;let E=0,k,r=E;for(;r<P.length;)if(k=P.charCodeAt(r),k===13||k===10){if(A.push(P.substring(E,r)),r++,r<P.length){const I=k;k=P.charCodeAt(r),(I===13&&k===10||I===10&&k===13)&&r++}E=r}else r++;return this.remaining=E<P.length?P.substr(E):null,A}end(){return this.remaining}}e.LineDecoder=R}),define(me[28],ge([0,1,56,100,277,9,16,11,29,32,74,24,2]),function(X,e,p,R,C,y,A,P,E,k,r,I,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.writeFileSync=e.SymlinkSupport=e.whenDeleted=e.readdirSync=e.rimrafSync=e.RimRafMode=void 0;var f;(function(N){N[N.UNLINK=0]="UNLINK",N[N.MOVE=1]="MOVE"})(f=e.RimRafMode||(e.RimRafMode={}));async function c(N,W=f.UNLINK){if(E.isRootOrDriveLetter(N))throw new Error("rimraf - will refuse to recursively delete root");return W===f.UNLINK?S(N):u(N)}async function u(N){try{const W=y.join(R.tmpdir(),k.generateUuid());try{await e.Promises.rename(N,W)}catch(M){return S(N)}S(W).catch(M=>{})}catch(W){if(W.code!=="ENOENT")throw W}}async function S(N){return e.Promises.rmdir(N,{recursive:!0,maxRetries:3})}function w(N){if(E.isRootOrDriveLetter(N))throw new Error("rimraf - will refuse to recursively delete root");p.rmdirSync(N,{recursive:!0})}e.rimrafSync=w;async function b(N,W){return g(await(W?d(N):C.promisify(p.readdir)(N)))}async function d(N){try{return await C.promisify(p.readdir)(N,{withFileTypes:!0})}catch(j){console.warn("[node.js fs] readdir with filetypes failed with error: ",j)}const W=[],M=await b(N);for(const j of M){let O=!1,F=!1,B=!1;try{const $=await e.Promises.lstat(y.join(N,j));O=$.isFile(),F=$.isDirectory(),B=$.isSymbolicLink()}catch($){console.warn("[node.js fs] unexpected error from lstat after readdir: ",$)}W.push({name:j,isFile:()=>O,isDirectory:()=>F,isSymbolicLink:()=>B})}return W}function h(N){return g(p.readdirSync(N))}e.readdirSync=h;function g(N){return N.map(W=>typeof W=="string"?P.isMacintosh?r.normalizeNFC(W):W:(W.name=P.isMacintosh?r.normalizeNFC(W.name):W.name,W))}async function t(N){const W=await b(N),M=[];for(const j of W)await s.existsDirectory(y.join(N,j))&&M.push(j);return M}function i(N,W=1e3){return new Promise(M=>{let j=!1;const O=setInterval(()=>{j||(j=!0,p.access(N,F=>{j=!1,F&&(clearInterval(O),M(void 0))}))},W)})}e.whenDeleted=i;var s;(function(N){async function W(O){let F;try{if(F=await e.Promises.lstat(O),!F.isSymbolicLink())return{stat:F}}catch(B){}try{return{stat:await e.Promises.stat(O),symbolicLink:(F==null?void 0:F.isSymbolicLink())?{dangling:!1}:void 0}}catch(B){if(B.code==="ENOENT"&&F)return{stat:F,symbolicLink:{dangling:!0}};if(P.isWindows&&B.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink(O)),symbolicLink:{dangling:!1}}}catch($){if($.code==="ENOENT"&&F)return{stat:F,symbolicLink:{dangling:!0}};throw $}throw B}}N.stat=W;async function M(O){try{const{stat:F,symbolicLink:B}=await N.stat(O);return F.isFile()&&(B==null?void 0:B.dangling)!==!0}catch(F){}return!1}N.existsFile=M;async function j(O){try{const{stat:F,symbolicLink:B}=await N.stat(O);return F.isDirectory()&&(B==null?void 0:B.dangling)!==!0}catch(F){}return!1}N.existsDirectory=j})(s=e.SymlinkSupport||(e.SymlinkSupport={}));const n=new A.ResourceQueue;function o(N,W,M){return n.queueFor(l.URI.file(N),I.extUriBiasedIgnorePathCase).queue(()=>{const j=D(M);return new Promise((O,F)=>m(N,W,j,B=>B?F(B):O()))})}let v=!0;function m(N,W,M,j){if(!v)return p.writeFile(N,W,{mode:M.mode,flag:M.flag},j);p.open(N,M.flag,M.mode,(O,F)=>{if(O)return j(O);p.writeFile(F,W,B=>{if(B)return p.close(F,()=>j(B));p.fdatasync(F,$=>($&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",$),v=!1),p.close(F,Y=>j(Y))))})})}function _(N,W,M){const j=D(M);if(!v)return p.writeFileSync(N,W,{mode:j.mode,flag:j.flag});const O=p.openSync(N,j.flag,j.mode);try{p.writeFileSync(O,W);try{p.fdatasyncSync(O)}catch(F){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",F),v=!1}}finally{p.closeSync(O)}}e.writeFileSync=_;function D(N){return N?{mode:typeof N.mode=="number"?N.mode:438,flag:typeof N.flag=="string"?N.flag:"w"}:{mode:438,flag:"w"}}async function a(N,W){if(N===W)return;async function M(j){try{const O=await e.Promises.lstat(j);if(O.isDirectory()||O.isSymbolicLink())return;await e.Promises.utimes(j,O.atime,new Date)}catch(O){}}try{await e.Promises.rename(N,W),await M(W)}catch(j){if(N.toLowerCase()!==W.toLowerCase()&&j.code==="EXDEV"||N.endsWith("."))await T(N,W,{preserveSymlinks:!1}),await c(N,f.MOVE),await M(W);else throw j}}async function T(N,W,M){return U(N,W,{root:{source:N,target:W},options:M,handledSourcePaths:new Set})}const L=511;async function U(N,W,M){if(M.handledSourcePaths.has(N))return;M.handledSourcePaths.add(N);const{stat:j,symbolicLink:O}=await s.stat(N);if(O){if(M.options.preserveSymlinks)try{return await z(N,W,M)}catch(F){console.warn("[node.js fs] copy of symlink failed: ",F)}if(O.dangling)return}return j.isDirectory()?G(N,W,j.mode&L,M):ee(N,W,j.mode&L)}async function G(N,W,M,j){await e.Promises.mkdir(W,{recursive:!0,mode:M});const O=await b(N);for(const F of O)await U(y.join(N,F),y.join(W,F),j)}async function ee(N,W,M){await e.Promises.copyFile(N,W),await e.Promises.chmod(W,M)}async function z(N,W,M){let j=await e.Promises.readlink(N);E.isEqualOrParent(j,M.root.source,!P.isLinux)&&(j=y.join(M.root.target,j.substr(M.root.source.length+1))),await e.Promises.symlink(j,W)}e.Promises=new class{get access(){return C.promisify(p.access)}get stat(){return C.promisify(p.stat)}get lstat(){return C.promisify(p.lstat)}get utimes(){return C.promisify(p.utimes)}get read(){return C.promisify(p.read)}get readFile(){return C.promisify(p.readFile)}get write(){return C.promisify(p.write)}get appendFile(){return C.promisify(p.appendFile)}get fdatasync(){return C.promisify(p.fdatasync)}get truncate(){return C.promisify(p.truncate)}get rename(){return C.promisify(p.rename)}get copyFile(){return C.promisify(p.copyFile)}get open(){return C.promisify(p.open)}get close(){return C.promisify(p.close)}get symlink(){return C.promisify(p.symlink)}get readlink(){return C.promisify(p.readlink)}get chmod(){return C.promisify(p.chmod)}get mkdir(){return C.promisify(p.mkdir)}get unlink(){return C.promisify(p.unlink)}get rmdir(){return C.promisify(p.rmdir)}get realpath(){return C.promisify(p.realpath)}async exists(N){try{return await e.Promises.access(N),!0}catch(W){return!1}}get readdir(){return b}get readDirsInDir(){return t}get writeFile(){return o}get rm(){return c}get move(){return a}get copy(){return T}}}),define(me[101],ge([0,1,56,8,9,28]),function(X,e,p,R,C,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.realpathSync=e.realpath=e.realcaseSync=void 0;function A(r){const I=C.dirname(r);if(r===I)return r;const l=(C.basename(r)||r).toLowerCase();try{const c=y.readdirSync(I).filter(u=>u.toLowerCase()===l);if(c.length===1){const u=A(I);if(u)return C.join(u,c[0])}else if(c.length>1){const u=c.indexOf(l);if(u>=0){const S=A(I);if(S)return C.join(S,c[u])}}}catch(f){}return null}e.realcaseSync=A;async function P(r){try{return await y.Promises.realpath(r)}catch(I){const l=k(r);return await y.Promises.access(l,p.constants.R_OK),l}}e.realpath=P;function E(r){try{return p.realpathSync(r)}catch(I){const l=k(r);return p.accessSync(l,p.constants.R_OK),l}}e.realpathSync=E;function k(r){return R.rtrim(C.normalize(r),C.sep)}});var Ve=this&&this.__decorate||function(X,e,p,R){var C=arguments.length,y=C<3?e:R===null?R=Object.getOwnPropertyDescriptor(e,p):R,A;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")y=Reflect.decorate(X,e,p,R);else for(var P=X.length-1;P>=0;P--)(A=X[P])&&(y=(C<3?A(y):C>3?A(e,p,y):A(e,p))||y);return C>3&&y&&Object.defineProperty(e,p,y),y};define(me[102],ge([0,1,3,6,16,21,14,22,18,15,55,8,51]),function(X,e,p,R,C,y,A,P,E,k,r,I,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IPCLogger=e.logWithColors=e.ProxyChannel=e.StaticRouter=e.getNextTickChannel=e.getDelayedChannel=e.IPCClient=e.IPCServer=e.ChannelClient=e.RequestInitiator=e.ChannelServer=e.ResponseType=e.RequestType=void 0;var f;(function(O){O[O.Promise=100]="Promise",O[O.PromiseCancel=101]="PromiseCancel",O[O.EventListen=102]="EventListen",O[O.EventDispose=103]="EventDispose"})(f=e.RequestType||(e.RequestType={}));function c(O){switch(O){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var u;(function(O){O[O.Initialize=200]="Initialize",O[O.PromiseSuccess=201]="PromiseSuccess",O[O.PromiseError=202]="PromiseError",O[O.PromiseErrorObj=203]="PromiseErrorObj",O[O.EventFire=204]="EventFire"})(u=e.ResponseType||(e.ResponseType={}));function S(O){switch(O){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var w;(function(O){O[O.Uninitialized=0]="Uninitialized",O[O.Idle=1]="Idle"})(w||(w={}));class b{constructor(F){this.buffer=F,this.pos=0}read(F){const B=this.buffer.slice(this.pos,this.pos+F);return this.pos+=B.byteLength,B}}class d{constructor(){this.buffers=[]}get buffer(){return P.VSBuffer.concat(this.buffers)}write(F){this.buffers.push(F)}}var h;(function(O){O[O.Undefined=0]="Undefined",O[O.String=1]="String",O[O.Buffer=2]="Buffer",O[O.VSBuffer=3]="VSBuffer",O[O.Array=4]="Array",O[O.Object=5]="Object"})(h||(h={}));function g(O){const F=P.VSBuffer.alloc(4);return F.writeUInt32BE(O,0),F}function t(O){return O.read(4).readUInt32BE(0)}function i(O){const F=P.VSBuffer.alloc(1);return F.writeUInt8(O,0),F}const s={Undefined:i(h.Undefined),String:i(h.String),Buffer:i(h.Buffer),VSBuffer:i(h.VSBuffer),Array:i(h.Array),Object:i(h.Object)},n=typeof Buffer!="undefined";function o(O,F){if(typeof F=="undefined")O.write(s.Undefined);else if(typeof F=="string"){const B=P.VSBuffer.fromString(F);O.write(s.String),O.write(g(B.byteLength)),O.write(B)}else if(n&&Buffer.isBuffer(F)){const B=P.VSBuffer.wrap(F);O.write(s.Buffer),O.write(g(B.byteLength)),O.write(B)}else if(F instanceof P.VSBuffer)O.write(s.VSBuffer),O.write(g(F.byteLength)),O.write(F);else if(Array.isArray(F)){O.write(s.Array),O.write(g(F.length));for(const B of F)o(O,B)}else{const B=P.VSBuffer.fromString(JSON.stringify(F));O.write(s.Object),O.write(g(B.byteLength)),O.write(B)}}function v(O){switch(O.read(1).readUInt8(0)){case h.Undefined:return;case h.String:return O.read(t(O)).toString();case h.Buffer:return O.read(t(O)).buffer;case h.VSBuffer:return O.read(t(O));case h.Array:{const B=t(O),$=[];for(let Y=0;Y<B;Y++)$.push(v(O));return $}case h.Object:return JSON.parse(O.read(t(O)).toString())}}class m{constructor(F,B,$=null,Y=1e3){this.protocol=F,this.ctx=B,this.logger=$,this.timeoutDelay=Y,this.channels=new Map,this.activeRequests=new Map,this.pendingRequests=new Map,this.protocolListener=this.protocol.onMessage(le=>this.onRawMessage(le)),this.sendResponse({type:200})}registerChannel(F,B){this.channels.set(F,B),setTimeout(()=>this.flushPendingRequests(F),0)}sendResponse(F){switch(F.type){case 200:{const B=this.send([F.type]);this.logger&&this.logger.logOutgoing(B,0,1,S(F.type));return}case 201:case 202:case 204:case 203:{const B=this.send([F.type,F.id],F.data);this.logger&&this.logger.logOutgoing(B,F.id,1,S(F.type),F.data);return}}}send(F,B=void 0){const $=new d;return o($,F),o($,B),this.sendBuffer($.buffer)}sendBuffer(F){try{return this.protocol.send(F),F.byteLength}catch(B){return 0}}onRawMessage(F){const B=new b(F),$=v(B),Y=v(B),le=$[0];switch(le){case 100:return this.logger&&this.logger.logIncoming(F.byteLength,$[1],1,`${c(le)}: ${$[2]}.${$[3]}`,Y),this.onPromise({type:le,id:$[1],channelName:$[2],name:$[3],arg:Y});case 102:return this.logger&&this.logger.logIncoming(F.byteLength,$[1],1,`${c(le)}: ${$[2]}.${$[3]}`,Y),this.onEventListen({type:le,id:$[1],channelName:$[2],name:$[3],arg:Y});case 101:return this.logger&&this.logger.logIncoming(F.byteLength,$[1],1,`${c(le)}`),this.disposeActiveRequest({type:le,id:$[1]});case 103:return this.logger&&this.logger.logIncoming(F.byteLength,$[1],1,`${c(le)}`),this.disposeActiveRequest({type:le,id:$[1]})}}onPromise(F){const B=this.channels.get(F.channelName);if(!B){this.collectPendingRequest(F);return}const $=new y.CancellationTokenSource;let Y;try{Y=B.call(this.ctx,F.name,F.arg,$.token)}catch(Le){Y=Promise.reject(Le)}const le=F.id;Y.then(Le=>{this.sendResponse({id:le,data:Le,type:201}),this.activeRequests.delete(F.id)},Le=>{Le instanceof Error?this.sendResponse({id:le,data:{message:Le.message,name:Le.name,stack:Le.stack?Le.stack.split?Le.stack.split(`
`):Le.stack:void 0},type:202}):this.sendResponse({id:le,data:Le,type:203}),this.activeRequests.delete(F.id)});const be=R.toDisposable(()=>$.cancel());this.activeRequests.set(F.id,be)}onEventListen(F){const B=this.channels.get(F.channelName);if(!B){this.collectPendingRequest(F);return}const $=F.id,le=B.listen(this.ctx,F.name,F.arg)(be=>this.sendResponse({id:$,data:be,type:204}));this.activeRequests.set(F.id,le)}disposeActiveRequest(F){const B=this.activeRequests.get(F.id);B&&(B.dispose(),this.activeRequests.delete(F.id))}collectPendingRequest(F){let B=this.pendingRequests.get(F.channelName);B||(B=[],this.pendingRequests.set(F.channelName,B));const $=setTimeout(()=>{console.error(`Unknown channel: ${F.channelName}`),F.type===100&&this.sendResponse({id:F.id,data:{name:"Unknown channel",message:`Channel name '${F.channelName}' timed out after ${this.timeoutDelay}ms`,stack:void 0},type:202})},this.timeoutDelay);B.push({request:F,timeoutTimer:$})}flushPendingRequests(F){const B=this.pendingRequests.get(F);if(B){for(const $ of B)switch(clearTimeout($.timeoutTimer),$.request.type){case 100:this.onPromise($.request);break;case 102:this.onEventListen($.request);break}this.pendingRequests.delete(F)}}dispose(){this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),this.activeRequests.forEach(F=>F.dispose()),this.activeRequests.clear()}}e.ChannelServer=m;var _;(function(O){O[O.LocalSide=0]="LocalSide",O[O.OtherSide=1]="OtherSide"})(_=e.RequestInitiator||(e.RequestInitiator={}));class D{constructor(F,B=null){this.protocol=F,this.isDisposed=!1,this.state=w.Uninitialized,this.activeRequests=new Set,this.handlers=new Map,this.lastRequestId=0,this._onDidInitialize=new p.Emitter,this.onDidInitialize=this._onDidInitialize.event,this.protocolListener=this.protocol.onMessage($=>this.onBuffer($)),this.logger=B}getChannel(F){const B=this;return{call($,Y,le){return B.isDisposed?Promise.reject(A.canceled()):B.requestPromise(F,$,Y,le)},listen($,Y){return B.isDisposed?Promise.reject(A.canceled()):B.requestEvent(F,$,Y)}}}requestPromise(F,B,$,Y=y.CancellationToken.None){const le=this.lastRequestId++,Le={id:le,type:100,channelName:F,name:B,arg:$};if(Y.isCancellationRequested)return Promise.reject(A.canceled());let Ie;return new Promise((Qe,ze)=>{if(Y.isCancellationRequested)return ze(A.canceled());const Ge=()=>{const se=J=>{switch(J.type){case 201:this.handlers.delete(le),Qe(J.data);break;case 202:this.handlers.delete(le);const ae=new Error(J.data.message);ae.stack=J.data.stack,ae.name=J.data.name,ze(ae);break;case 203:this.handlers.delete(le),ze(J.data);break}};this.handlers.set(le,se),this.sendRequest(Le)};let V=null;this.state===w.Idle?Ge():(V=C.createCancelablePromise(se=>this.whenInitialized()),V.then(()=>{V=null,Ge()}));const Z=()=>{V?(V.cancel(),V=null):this.sendRequest({id:le,type:101}),ze(A.canceled())},ne=Y.onCancellationRequested(Z);Ie=R.combinedDisposable(R.toDisposable(Z),ne),this.activeRequests.add(Ie)}).finally(()=>{this.activeRequests.delete(Ie)})}requestEvent(F,B,$){const Y=this.lastRequestId++,be={id:Y,type:102,channelName:F,name:B,arg:$};let Le=null;const Ie=new p.Emitter({onFirstListenerAdd:()=>{Le=C.createCancelablePromise(Qe=>this.whenInitialized()),Le.then(()=>{Le=null,this.activeRequests.add(Ie),this.sendRequest(be)})},onLastListenerRemove:()=>{Le?(Le.cancel(),Le=null):(this.activeRequests.delete(Ie),this.sendRequest({id:Y,type:103}))}}),Ue=Qe=>Ie.fire(Qe.data);return this.handlers.set(Y,Ue),Ie.event}sendRequest(F){switch(F.type){case 100:case 102:{const B=this.send([F.type,F.id,F.channelName,F.name],F.arg);this.logger&&this.logger.logOutgoing(B,F.id,0,`${c(F.type)}: ${F.channelName}.${F.name}`,F.arg);return}case 101:case 103:{const B=this.send([F.type,F.id]);this.logger&&this.logger.logOutgoing(B,F.id,0,c(F.type));return}}}send(F,B=void 0){const $=new d;return o($,F),o($,B),this.sendBuffer($.buffer)}sendBuffer(F){try{return this.protocol.send(F),F.byteLength}catch(B){return 0}}onBuffer(F){const B=new b(F),$=v(B),Y=v(B),le=$[0];switch(le){case 200:return this.logger&&this.logger.logIncoming(F.byteLength,0,0,S(le)),this.onResponse({type:$[0]});case 201:case 202:case 204:case 203:return this.logger&&this.logger.logIncoming(F.byteLength,$[1],0,S(le),Y),this.onResponse({type:$[0],id:$[1],data:Y})}}onResponse(F){if(F.type===200){this.state=w.Idle,this._onDidInitialize.fire();return}const B=this.handlers.get(F.id);B&&B(F)}get onDidInitializePromise(){return p.Event.toPromise(this.onDidInitialize)}whenInitialized(){return this.state===w.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.isDisposed=!0,this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),this.activeRequests.forEach(F=>F.dispose()),this.activeRequests.clear()}}Ve([l.memoize],D.prototype,"onDidInitializePromise",null),e.ChannelClient=D;class a{constructor(F){this.channels=new Map,this._connections=new Set,this._onDidAddConnection=new p.Emitter,this.onDidAddConnection=this._onDidAddConnection.event,this._onDidRemoveConnection=new p.Emitter,this.onDidRemoveConnection=this._onDidRemoveConnection.event,F(({protocol:B,onDidClientDisconnect:$})=>{p.Event.once(B.onMessage)(le=>{const be=new b(le),Le=v(be),Ie=new m(B,Le),Ue=new D(B);this.channels.forEach((ze,Ge)=>Ie.registerChannel(Ge,ze));const Qe={channelServer:Ie,channelClient:Ue,ctx:Le};this._connections.add(Qe),this._onDidAddConnection.fire(Qe),$(()=>{Ie.dispose(),Ue.dispose(),this._connections.delete(Qe),this._onDidRemoveConnection.fire(Qe)})})})}get connections(){const F=[];return this._connections.forEach(B=>F.push(B)),F}getChannel(F,B){const $=this;return{call(Y,le,be){let Le;if(k.isFunction(B)){let Ue=E.getRandomElement($.connections.filter(B));Le=Ue?Promise.resolve(Ue):p.Event.toPromise(p.Event.filter($.onDidAddConnection,B))}else Le=B.routeCall($,Y,le);const Ie=Le.then(Ue=>Ue.channelClient.getChannel(F));return L(Ie).call(Y,le,be)},listen(Y,le){if(k.isFunction(B))return $.getMulticastEvent(F,B,Y,le);const be=B.routeEvent($,Y,le).then(Le=>Le.channelClient.getChannel(F));return L(be).listen(Y,le)}}}getMulticastEvent(F,B,$,Y){const le=this;let be=new R.DisposableStore;const Le=new p.Emitter({onFirstListenerAdd:()=>{be=new R.DisposableStore;const Ie=new p.EventMultiplexer,Ue=new Map,Qe=Ge=>{const Z=Ge.channelClient.getChannel(F).listen($,Y),ne=Ie.add(Z);Ue.set(Ge,ne)},ze=Ge=>{const V=Ue.get(Ge);!V||(V.dispose(),Ue.delete(Ge))};le.connections.filter(B).forEach(Qe),p.Event.filter(le.onDidAddConnection,B)(Qe,void 0,be),le.onDidRemoveConnection(ze,void 0,be),Ie.event(Le.fire,Le,be),be.add(Ie)},onLastListenerRemove:()=>{be.dispose()}});return Le.event}registerChannel(F,B){this.channels.set(F,B),this._connections.forEach($=>{$.channelServer.registerChannel(F,B)})}dispose(){this.channels.clear(),this._connections.clear(),this._onDidAddConnection.dispose(),this._onDidRemoveConnection.dispose()}}e.IPCServer=a;class T{constructor(F,B,$=null){const Y=new d;o(Y,B),F.send(Y.buffer),this.channelClient=new D(F,$),this.channelServer=new m(F,B,$)}getChannel(F){return this.channelClient.getChannel(F)}registerChannel(F,B){this.channelServer.registerChannel(F,B)}dispose(){this.channelClient.dispose(),this.channelServer.dispose()}}e.IPCClient=T;function L(O){return{call(F,B,$){return O.then(Y=>Y.call(F,B,$))},listen(F,B){const $=new p.Relay;return O.then(Y=>$.input=Y.listen(F,B)),$.event}}}e.getDelayedChannel=L;function U(O){let F=!1;return{call(B,$,Y){return F?O.call(B,$,Y):C.timeout(0).then(()=>F=!0).then(()=>O.call(B,$,Y))},listen(B,$){if(F)return O.listen(B,$);const Y=new p.Relay;return C.timeout(0).then(()=>F=!0).then(()=>Y.input=O.listen(B,$)),Y.event}}}e.getNextTickChannel=U;class G{constructor(F){this.fn=F}routeCall(F){return this.route(F)}routeEvent(F){return this.route(F)}async route(F){for(const B of F.connections)if(await Promise.resolve(this.fn(B.ctx)))return Promise.resolve(B);return await p.Event.toPromise(F.onDidAddConnection),await this.route(F)}}e.StaticRouter=G;var ee;(function(O){function F(Y,le){const be=Y,Le=le&&le.disableMarshalling,Ie=new Map;for(const Ue in be)$(Ue)&&Ie.set(Ue,p.Event.buffer(be[Ue],!0));return new class{listen(Ue,Qe){const ze=Ie.get(Qe);if(ze)return ze;throw new Error(`Event not found: ${Qe}`)}call(Ue,Qe,ze){const Ge=be[Qe];if(typeof Ge=="function"){if(!Le&&Array.isArray(ze))for(let V=0;V<ze.length;V++)ze[V]=r.revive(ze[V]);return Ge.apply(be,ze)}throw new Error(`Method not found: ${Qe}`)}}}O.fromService=F;function B(Y,le){const be=le&&le.disableMarshalling;return new Proxy({},{get(Le,Ie){var Ue;if(typeof Ie=="string")return((Ue=le==null?void 0:le.properties)===null||Ue===void 0?void 0:Ue.has(Ie))?le.properties.get(Ie):$(Ie)?Y.listen(Ie):async function(...Qe){let ze;le&&!k.isUndefinedOrNull(le.context)?ze=[le.context,...Qe]:ze=Qe;const Ge=await Y.call(Ie,ze);return be?Ge:r.revive(Ge)};throw new Error(`Property not found: ${String(Ie)}`)}})}O.toService=B;function $(Y){return Y[0]==="o"&&Y[1]==="n"&&I.isUpperAsciiLetter(Y.charCodeAt(2))}})(ee=e.ProxyChannel||(e.ProxyChannel={}));const z=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function N(O){if(Array.isArray(O))return O;if(O&&typeof O=="object"&&typeof O.toString=="function"){let F=O.toString();if(F!=="[object Object]")return F}return O}function W(O){return Array.isArray(O)?O.map(N):N(O)}function M(O,F,B,$,Y,le,be){be=W(be);const Le=z[Y],Ie=Le[$%Le.length];let Ue=[`%c[${O}]%c[${String(F).padStart(7," ")}]%c[len: ${String(B).padStart(5," ")}]%c${String($).padStart(5," ")} - ${le}`,"color: darkgreen","color: grey","color: grey",`color: ${Ie}`];/\($/.test(le)?(Ue=Ue.concat(be),Ue.push(")")):Ue.push(be),console.log.apply(console,Ue)}e.logWithColors=M;class j{constructor(F,B){this._outgoingPrefix=F,this._incomingPrefix=B,this._totalIncoming=0,this._totalOutgoing=0}logOutgoing(F,B,$,Y,le){this._totalOutgoing+=F,M(this._outgoingPrefix,this._totalOutgoing,F,B,$,Y,le)}logIncoming(F,B,$,Y,le){this._totalIncoming+=F,M(this._incomingPrefix,this._totalIncoming,F,B,$,Y,le)}}e.IPCLogger=j}),define(me[103],ge([0,1,3,102,6,22,11,37]),function(X,e,p,R,C,y,A,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PersistentProtocol=e.BufferedEmitter=e.Client=e.Protocol=e.ProtocolConstants=e.ChunkStream=e.SocketCloseEventType=void 0;var E;(function(s){s[s.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",s[s.WebSocketCloseEvent=1]="WebSocketCloseEvent"})(E=e.SocketCloseEventType||(e.SocketCloseEventType={}));let k=null;function r(){return k||(k=y.VSBuffer.alloc(0)),k}class I{constructor(){this._chunks=[],this._totalLength=0}get byteLength(){return this._totalLength}acceptChunk(n){this._chunks.push(n),this._totalLength+=n.byteLength}read(n){return this._read(n,!0)}peek(n){return this._read(n,!1)}_read(n,o){if(n===0)return r();if(n>this._totalLength)throw new Error("Cannot read so many bytes!");if(this._chunks[0].byteLength===n){const D=this._chunks[0];return o&&(this._chunks.shift(),this._totalLength-=n),D}if(this._chunks[0].byteLength>n){const D=this._chunks[0].slice(0,n);return o&&(this._chunks[0]=this._chunks[0].slice(n),this._totalLength-=n),D}let v=y.VSBuffer.alloc(n),m=0,_=0;for(;n>0;){const D=this._chunks[_];if(D.byteLength>n){const a=D.slice(0,n);v.set(a,m),m+=n,o&&(this._chunks[_]=D.slice(n),this._totalLength-=n),n-=n}else v.set(D,m),m+=D.byteLength,o?(this._chunks.shift(),this._totalLength-=D.byteLength):_++,n-=D.byteLength}return v}}e.ChunkStream=I;var l;(function(s){s[s.None=0]="None",s[s.Regular=1]="Regular",s[s.Control=2]="Control",s[s.Ack=3]="Ack",s[s.KeepAlive=4]="KeepAlive",s[s.Disconnect=5]="Disconnect",s[s.ReplayRequest=6]="ReplayRequest"})(l||(l={}));var f;(function(s){s[s.HeaderLength=13]="HeaderLength",s[s.AcknowledgeTime=2e3]="AcknowledgeTime",s[s.AcknowledgeTimeoutTime=2e4]="AcknowledgeTimeoutTime",s[s.KeepAliveTime=5e3]="KeepAliveTime",s[s.KeepAliveTimeoutTime=2e4]="KeepAliveTimeoutTime",s[s.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",s[s.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime"})(f=e.ProtocolConstants||(e.ProtocolConstants={}));class c{constructor(n,o,v,m){this.type=n,this.id=o,this.ack=v,this.data=m,this.writtenTime=0}get size(){return this.data.byteLength}}class u extends C.Disposable{constructor(n){super();this._onMessage=this._register(new p.Emitter),this.onMessage=this._onMessage.event,this._state={readHead:!0,readLen:13,messageType:0,id:0,ack:0},this._socket=n,this._isDisposed=!1,this._incomingData=new I,this._register(this._socket.onData(o=>this.acceptChunk(o))),this.lastReadTime=Date.now()}acceptChunk(n){if(!(!n||n.byteLength===0))for(this.lastReadTime=Date.now(),this._incomingData.acceptChunk(n);this._incomingData.byteLength>=this._state.readLen;){const o=this._incomingData.read(this._state.readLen);if(this._state.readHead)this._state.readHead=!1,this._state.readLen=o.readUInt32BE(9),this._state.messageType=o.readUInt8(0),this._state.id=o.readUInt32BE(1),this._state.ack=o.readUInt32BE(5);else{const v=this._state.messageType,m=this._state.id,_=this._state.ack;if(this._state.readHead=!0,this._state.readLen=13,this._state.messageType=0,this._state.id=0,this._state.ack=0,this._onMessage.fire(new c(v,m,_,o)),this._isDisposed)break}}}readEntireBuffer(){return this._incomingData.read(this._incomingData.byteLength)}dispose(){this._isDisposed=!0,super.dispose()}}class S{constructor(n){this._isDisposed=!1,this._socket=n,this._data=[],this._totalLength=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch(n){}this._isDisposed=!0}drain(){return this.flush(),this._socket.drain()}flush(){this._writeNow()}write(n){if(this._isDisposed)return;n.writtenTime=Date.now(),this.lastWriteTime=Date.now();const o=y.VSBuffer.alloc(13);o.writeUInt8(n.type,0),o.writeUInt32BE(n.id,1),o.writeUInt32BE(n.ack,5),o.writeUInt32BE(n.data.byteLength,9),this._writeSoon(o,n.data)}_bufferAdd(n,o){const v=this._totalLength===0;return this._data.push(n,o),this._totalLength+=n.byteLength+o.byteLength,v}_bufferTake(){const n=y.VSBuffer.concat(this._data,this._totalLength);return this._data.length=0,this._totalLength=0,n}_writeSoon(n,o){this._bufferAdd(n,o)&&A.setImmediate(()=>{this._writeNow()})}_writeNow(){this._totalLength!==0&&this._socket.write(this._bufferTake())}}class w extends C.Disposable{constructor(n){super();this._onMessage=new p.Emitter,this.onMessage=this._onMessage.event,this._onDidDispose=new p.Emitter,this.onDidDispose=this._onDidDispose.event,this._socket=n,this._socketWriter=this._register(new S(this._socket)),this._socketReader=this._register(new u(this._socket)),this._register(this._socketReader.onMessage(o=>{o.type===1&&this._onMessage.fire(o.data)})),this._register(this._socket.onClose(()=>this._onDidDispose.fire()))}drain(){return this._socketWriter.drain()}getSocket(){return this._socket}sendDisconnect(){}send(n){this._socketWriter.write(new c(1,0,0,n))}}e.Protocol=w;class b extends R.IPCClient{constructor(n,o,v=null){super(n,o,v);this.protocol=n}static fromSocket(n,o){return new b(new w(n),o)}get onDidDispose(){return this.protocol.onDidDispose}dispose(){super.dispose();const n=this.protocol.getSocket();this.protocol.sendDisconnect(),this.protocol.dispose(),n.end()}}e.Client=b;class d{constructor(){this._hasListeners=!1,this._isDeliveringMessages=!1,this._bufferedMessages=[],this._emitter=new p.Emitter({onFirstListenerAdd:()=>{this._hasListeners=!0,P.nextTick(()=>this._deliverMessages())},onLastListenerRemove:()=>{this._hasListeners=!1}}),this.event=this._emitter.event}_deliverMessages(){if(!this._isDeliveringMessages){for(this._isDeliveringMessages=!0;this._hasListeners&&this._bufferedMessages.length>0;)this._emitter.fire(this._bufferedMessages.shift());this._isDeliveringMessages=!1}}fire(n){this._hasListeners?this._bufferedMessages.length>0?this._bufferedMessages.push(n):this._emitter.fire(n):this._bufferedMessages.push(n)}flushBuffer(){this._bufferedMessages=[]}}e.BufferedEmitter=d;class h{constructor(n){this.data=n,this.next=null}}class g{constructor(){this._first=null,this._last=null}peek(){return this._first?this._first.data:null}toArray(){let n=[],o=0,v=this._first;for(;v;)n[o++]=v.data,v=v.next;return n}pop(){if(!!this._first){if(this._first===this._last){this._first=null,this._last=null;return}this._first=this._first.next}}push(n){const o=new h(n);if(!this._first){this._first=o,this._last=o;return}this._last.next=o,this._last=o}}class t{constructor(){this.lastRuns=[];const n=Date.now();for(let o=0;o<t._HISTORY_LENGTH;o++)this.lastRuns[o]=n-1e3*o;setInterval(()=>{for(let o=t._HISTORY_LENGTH;o>=1;o--)this.lastRuns[o]=this.lastRuns[o-1];this.lastRuns[0]=Date.now()},1e3)}static getInstance(){return t._INSTANCE||(t._INSTANCE=new t),t._INSTANCE}load(){const n=Date.now(),o=(1+t._HISTORY_LENGTH)*1e3;let v=0;for(let m=0;m<t._HISTORY_LENGTH;m++)n-this.lastRuns[m]<=o&&v++;return 1-v/t._HISTORY_LENGTH}hasHighLoad(){return this.load()>=.5}}t._HISTORY_LENGTH=10,t._INSTANCE=null;class i{constructor(n,o=null){this._loadEstimator=t.getInstance(),this._onControlMessage=new d,this.onControlMessage=this._onControlMessage.event,this._onMessage=new d,this.onMessage=this._onMessage.event,this._onDidDispose=new d,this.onDidDispose=this._onDidDispose.event,this._onSocketClose=new d,this.onSocketClose=this._onSocketClose.event,this._onSocketTimeout=new d,this.onSocketTimeout=this._onSocketTimeout.event,this._isReconnecting=!1,this._outgoingUnackMsg=new g,this._outgoingMsgId=0,this._outgoingAckId=0,this._outgoingAckTimeout=null,this._incomingMsgId=0,this._incomingAckId=0,this._incomingMsgLastTime=0,this._incomingAckTimeout=null,this._outgoingKeepAliveTimeout=null,this._incomingKeepAliveTimeout=null,this._lastReplayRequestTime=0,this._socketDisposables=[],this._socket=n,this._socketWriter=new S(this._socket),this._socketDisposables.push(this._socketWriter),this._socketReader=new u(this._socket),this._socketDisposables.push(this._socketReader),this._socketDisposables.push(this._socketReader.onMessage(v=>this._receiveMessage(v))),this._socketDisposables.push(this._socket.onClose(v=>this._onSocketClose.fire(v))),o&&this._socketReader.acceptChunk(o),this._sendKeepAliveCheck(),this._recvKeepAliveCheck()}get unacknowledgedCount(){return this._outgoingMsgId-this._outgoingAckId}dispose(){this._outgoingAckTimeout&&(clearTimeout(this._outgoingAckTimeout),this._outgoingAckTimeout=null),this._incomingAckTimeout&&(clearTimeout(this._incomingAckTimeout),this._incomingAckTimeout=null),this._outgoingKeepAliveTimeout&&(clearTimeout(this._outgoingKeepAliveTimeout),this._outgoingKeepAliveTimeout=null),this._incomingKeepAliveTimeout&&(clearTimeout(this._incomingKeepAliveTimeout),this._incomingKeepAliveTimeout=null),this._socketDisposables=C.dispose(this._socketDisposables)}drain(){return this._socketWriter.drain()}sendDisconnect(){const n=new c(5,0,0,r());this._socketWriter.write(n),this._socketWriter.flush()}_sendKeepAliveCheck(){if(this._outgoingKeepAliveTimeout)return;const n=Date.now()-this._socketWriter.lastWriteTime;if(n>=5e3){const o=new c(4,0,0,r());this._socketWriter.write(o),this._sendKeepAliveCheck();return}this._outgoingKeepAliveTimeout=setTimeout(()=>{this._outgoingKeepAliveTimeout=null,this._sendKeepAliveCheck()},5e3-n+5)}_recvKeepAliveCheck(){if(this._incomingKeepAliveTimeout)return;const n=Date.now()-this._socketReader.lastReadTime;if(n>=2e4&&!this._loadEstimator.hasHighLoad()){this._onSocketTimeout.fire(void 0);return}this._incomingKeepAliveTimeout=setTimeout(()=>{this._incomingKeepAliveTimeout=null,this._recvKeepAliveCheck()},Math.max(2e4-n,0)+5)}getSocket(){return this._socket}getMillisSinceLastIncomingData(){return Date.now()-this._socketReader.lastReadTime}beginAcceptReconnection(n,o){this._isReconnecting=!0,this._socketDisposables=C.dispose(this._socketDisposables),this._onControlMessage.flushBuffer(),this._onSocketClose.flushBuffer(),this._onSocketTimeout.flushBuffer(),this._socket.dispose(),this._lastReplayRequestTime=0,this._socket=n,this._socketWriter=new S(this._socket),this._socketDisposables.push(this._socketWriter),this._socketReader=new u(this._socket),this._socketDisposables.push(this._socketReader),this._socketDisposables.push(this._socketReader.onMessage(v=>this._receiveMessage(v))),this._socketDisposables.push(this._socket.onClose(v=>this._onSocketClose.fire(v))),this._socketReader.acceptChunk(o)}endAcceptReconnection(){this._isReconnecting=!1;const n=this._outgoingUnackMsg.toArray();for(let o=0,v=n.length;o<v;o++)this._socketWriter.write(n[o]);this._recvAckCheck(),this._sendKeepAliveCheck(),this._recvKeepAliveCheck()}acceptDisconnect(){this._onDidDispose.fire()}_receiveMessage(n){if(n.ack>this._outgoingAckId){this._outgoingAckId=n.ack;do{const o=this._outgoingUnackMsg.peek();if(o&&o.id<=n.ack)this._outgoingUnackMsg.pop();else break}while(!0)}if(n.type===1){if(n.id>this._incomingMsgId)if(n.id!==this._incomingMsgId+1){const o=Date.now();o-this._lastReplayRequestTime>1e4&&(this._lastReplayRequestTime=o,this._socketWriter.write(new c(6,0,0,r())))}else this._incomingMsgId=n.id,this._incomingMsgLastTime=Date.now(),this._sendAckCheck(),this._onMessage.fire(n.data)}else if(n.type===2)this._onControlMessage.fire(n.data);else if(n.type===5)this._onDidDispose.fire();else if(n.type===6){const o=this._outgoingUnackMsg.toArray();for(let v=0,m=o.length;v<m;v++)this._socketWriter.write(o[v]);this._recvAckCheck()}}readEntireBuffer(){return this._socketReader.readEntireBuffer()}flush(){this._socketWriter.flush()}send(n){const o=++this._outgoingMsgId;this._incomingAckId=this._incomingMsgId;const v=new c(1,o,this._incomingAckId,n);this._outgoingUnackMsg.push(v),this._isReconnecting||(this._socketWriter.write(v),this._recvAckCheck())}sendControl(n){const o=new c(2,0,0,n);this._socketWriter.write(o)}_sendAckCheck(){if(this._incomingMsgId<=this._incomingAckId||this._incomingAckTimeout)return;const n=Date.now()-this._incomingMsgLastTime;if(n>=2e3){this._sendAck();return}this._incomingAckTimeout=setTimeout(()=>{this._incomingAckTimeout=null,this._sendAckCheck()},2e3-n+5)}_recvAckCheck(){if(this._outgoingMsgId<=this._outgoingAckId||this._outgoingAckTimeout)return;const n=this._outgoingUnackMsg.peek(),o=Date.now()-n.writtenTime;if(o>=2e4&&!this._loadEstimator.hasHighLoad()){this._onSocketTimeout.fire(void 0);return}this._outgoingAckTimeout=setTimeout(()=>{this._outgoingAckTimeout=null,this._recvAckCheck()},Math.max(2e4-o,0)+5)}_sendAck(){if(this._incomingMsgId<=this._incomingAckId)return;this._incomingAckId=this._incomingMsgId;const n=new c(3,0,this._incomingAckId,r());this._socketWriter.write(n)}}e.PersistentProtocol=i}),define(me[104],ge([0,1,92]),function(X,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CharacterSet=e.CharacterClassifier=void 0;class R{constructor(P){let E=p.toUint8(P);this._defaultValue=E,this._asciiMap=R._createAsciiMap(E),this._map=new Map}static _createAsciiMap(P){let E=new Uint8Array(256);for(let k=0;k<256;k++)E[k]=P;return E}set(P,E){let k=p.toUint8(E);P>=0&&P<256?this._asciiMap[P]=k:this._map.set(P,k)}get(P){return P>=0&&P<256?this._asciiMap[P]:this._map.get(P)||this._defaultValue}}e.CharacterClassifier=R;var C;(function(A){A[A.False=0]="False",A[A.True=1]="True"})(C||(C={}));class y{constructor(){this._actual=new R(0)}add(P){this._actual.set(P,1)}has(P){return this._actual.get(P)===1}}e.CharacterSet=y}),define(me[138],ge([0,1,104]),function(X,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMapForWordSeparators=e.WordCharacterClassifier=e.WordCharacterClass=void 0;var R;(function(A){A[A.Regular=0]="Regular",A[A.Whitespace=1]="Whitespace",A[A.WordSeparator=2]="WordSeparator"})(R=e.WordCharacterClass||(e.WordCharacterClass={}));class C extends p.CharacterClassifier{constructor(P){super(0);for(let E=0,k=P.length;E<k;E++)this.set(P.charCodeAt(E),2);this.set(32,1),this.set(9,1)}}e.WordCharacterClassifier=C;function y(A){let P={};return E=>(P.hasOwnProperty(E)||(P[E]=A(E)),P[E])}e.getMapForWordSeparators=y(A=>new C(A))}),define(me[44],ge([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Position=void 0;class p{constructor(C,y){this.lineNumber=C,this.column=y}with(C=this.lineNumber,y=this.column){return C===this.lineNumber&&y===this.column?this:new p(C,y)}delta(C=0,y=0){return this.with(this.lineNumber+C,this.column+y)}equals(C){return p.equals(this,C)}static equals(C,y){return!C&&!y?!0:!!C&&!!y&&C.lineNumber===y.lineNumber&&C.column===y.column}isBefore(C){return p.isBefore(this,C)}static isBefore(C,y){return C.lineNumber<y.lineNumber?!0:y.lineNumber<C.lineNumber?!1:C.column<y.column}isBeforeOrEqual(C){return p.isBeforeOrEqual(this,C)}static isBeforeOrEqual(C,y){return C.lineNumber<y.lineNumber?!0:y.lineNumber<C.lineNumber?!1:C.column<=y.column}static compare(C,y){let A=C.lineNumber|0,P=y.lineNumber|0;if(A===P){let E=C.column|0,k=y.column|0;return E-k}return A-P}clone(){return new p(this.lineNumber,this.column)}toString(){return"("+this.lineNumber+","+this.column+")"}static lift(C){return new p(C.lineNumber,C.column)}static isIPosition(C){return C&&typeof C.lineNumber=="number"&&typeof C.column=="number"}}e.Position=p}),define(me[40],ge([0,1,44]),function(X,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Range=void 0;class R{constructor(y,A,P,E){y>P||y===P&&A>E?(this.startLineNumber=P,this.startColumn=E,this.endLineNumber=y,this.endColumn=A):(this.startLineNumber=y,this.startColumn=A,this.endLineNumber=P,this.endColumn=E)}isEmpty(){return R.isEmpty(this)}static isEmpty(y){return y.startLineNumber===y.endLineNumber&&y.startColumn===y.endColumn}containsPosition(y){return R.containsPosition(this,y)}static containsPosition(y,A){return!(A.lineNumber<y.startLineNumber||A.lineNumber>y.endLineNumber||A.lineNumber===y.startLineNumber&&A.column<y.startColumn||A.lineNumber===y.endLineNumber&&A.column>y.endColumn)}containsRange(y){return R.containsRange(this,y)}static containsRange(y,A){return!(A.startLineNumber<y.startLineNumber||A.endLineNumber<y.startLineNumber||A.startLineNumber>y.endLineNumber||A.endLineNumber>y.endLineNumber||A.startLineNumber===y.startLineNumber&&A.startColumn<y.startColumn||A.endLineNumber===y.endLineNumber&&A.endColumn>y.endColumn)}strictContainsRange(y){return R.strictContainsRange(this,y)}static strictContainsRange(y,A){return!(A.startLineNumber<y.startLineNumber||A.endLineNumber<y.startLineNumber||A.startLineNumber>y.endLineNumber||A.endLineNumber>y.endLineNumber||A.startLineNumber===y.startLineNumber&&A.startColumn<=y.startColumn||A.endLineNumber===y.endLineNumber&&A.endColumn>=y.endColumn)}plusRange(y){return R.plusRange(this,y)}static plusRange(y,A){let P,E,k,r;return A.startLineNumber<y.startLineNumber?(P=A.startLineNumber,E=A.startColumn):A.startLineNumber===y.startLineNumber?(P=A.startLineNumber,E=Math.min(A.startColumn,y.startColumn)):(P=y.startLineNumber,E=y.startColumn),A.endLineNumber>y.endLineNumber?(k=A.endLineNumber,r=A.endColumn):A.endLineNumber===y.endLineNumber?(k=A.endLineNumber,r=Math.max(A.endColumn,y.endColumn)):(k=y.endLineNumber,r=y.endColumn),new R(P,E,k,r)}intersectRanges(y){return R.intersectRanges(this,y)}static intersectRanges(y,A){let P=y.startLineNumber,E=y.startColumn,k=y.endLineNumber,r=y.endColumn,I=A.startLineNumber,l=A.startColumn,f=A.endLineNumber,c=A.endColumn;return P<I?(P=I,E=l):P===I&&(E=Math.max(E,l)),k>f?(k=f,r=c):k===f&&(r=Math.min(r,c)),P>k||P===k&&E>r?null:new R(P,E,k,r)}equalsRange(y){return R.equalsRange(this,y)}static equalsRange(y,A){return!!y&&!!A&&y.startLineNumber===A.startLineNumber&&y.startColumn===A.startColumn&&y.endLineNumber===A.endLineNumber&&y.endColumn===A.endColumn}getEndPosition(){return R.getEndPosition(this)}static getEndPosition(y){return new p.Position(y.endLineNumber,y.endColumn)}getStartPosition(){return R.getStartPosition(this)}static getStartPosition(y){return new p.Position(y.startLineNumber,y.startColumn)}toString(){return"["+this.startLineNumber+","+this.startColumn+" -> "+this.endLineNumber+","+this.endColumn+"]"}setEndPosition(y,A){return new R(this.startLineNumber,this.startColumn,y,A)}setStartPosition(y,A){return new R(y,A,this.endLineNumber,this.endColumn)}collapseToStart(){return R.collapseToStart(this)}static collapseToStart(y){return new R(y.startLineNumber,y.startColumn,y.startLineNumber,y.startColumn)}static fromPositions(y,A=y){return new R(y.lineNumber,y.column,A.lineNumber,A.column)}static lift(y){return y?new R(y.startLineNumber,y.startColumn,y.endLineNumber,y.endColumn):null}static isIRange(y){return y&&typeof y.startLineNumber=="number"&&typeof y.startColumn=="number"&&typeof y.endLineNumber=="number"&&typeof y.endColumn=="number"}static areIntersectingOrTouching(y,A){return!(y.endLineNumber<A.startLineNumber||y.endLineNumber===A.startLineNumber&&y.endColumn<A.startColumn||A.endLineNumber<y.startLineNumber||A.endLineNumber===y.startLineNumber&&A.endColumn<y.startColumn)}static areIntersecting(y,A){return!(y.endLineNumber<A.startLineNumber||y.endLineNumber===A.startLineNumber&&y.endColumn<=A.startColumn||A.endLineNumber<y.startLineNumber||A.endLineNumber===y.startLineNumber&&A.endColumn<=y.startColumn)}static compareRangesUsingStarts(y,A){if(y&&A){const k=y.startLineNumber|0,r=A.startLineNumber|0;if(k===r){const I=y.startColumn|0,l=A.startColumn|0;if(I===l){const f=y.endLineNumber|0,c=A.endLineNumber|0;if(f===c){const u=y.endColumn|0,S=A.endColumn|0;return u-S}return f-c}return I-l}return k-r}return(y?1:0)-(A?1:0)}static compareRangesUsingEnds(y,A){return y.endLineNumber===A.endLineNumber?y.endColumn===A.endColumn?y.startLineNumber===A.startLineNumber?y.startColumn-A.startColumn:y.startLineNumber-A.startLineNumber:y.endColumn-A.endColumn:y.endLineNumber-A.endLineNumber}static spansMultipleLines(y){return y.endLineNumber>y.startLineNumber}}e.Range=R}),define(me[139],ge([0,1,44,40]),function(X,e,p,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Selection=e.SelectionDirection=void 0;var C;(function(A){A[A.LTR=0]="LTR",A[A.RTL=1]="RTL"})(C=e.SelectionDirection||(e.SelectionDirection={}));class y extends R.Range{constructor(P,E,k,r){super(P,E,k,r);this.selectionStartLineNumber=P,this.selectionStartColumn=E,this.positionLineNumber=k,this.positionColumn=r}toString(){return"["+this.selectionStartLineNumber+","+this.selectionStartColumn+" -> "+this.positionLineNumber+","+this.positionColumn+"]"}equalsSelection(P){return y.selectionsEqual(this,P)}static selectionsEqual(P,E){return P.selectionStartLineNumber===E.selectionStartLineNumber&&P.selectionStartColumn===E.selectionStartColumn&&P.positionLineNumber===E.positionLineNumber&&P.positionColumn===E.positionColumn}getDirection(){return this.selectionStartLineNumber===this.startLineNumber&&this.selectionStartColumn===this.startColumn?0:1}setEndPosition(P,E){return this.getDirection()===0?new y(this.startLineNumber,this.startColumn,P,E):new y(P,E,this.startLineNumber,this.startColumn)}getPosition(){return new p.Position(this.positionLineNumber,this.positionColumn)}setStartPosition(P,E){return this.getDirection()===0?new y(P,E,this.endLineNumber,this.endColumn):new y(this.endLineNumber,this.endColumn,P,E)}static fromPositions(P,E=P){return new y(P.lineNumber,P.column,E.lineNumber,E.column)}static liftSelection(P){return new y(P.selectionStartLineNumber,P.selectionStartColumn,P.positionLineNumber,P.positionColumn)}static selectionsArrEqual(P,E){if(P&&!E||!P&&E)return!1;if(!P&&!E)return!0;if(P.length!==E.length)return!1;for(let k=0,r=P.length;k<r;k++)if(!this.selectionsEqual(P[k],E[k]))return!1;return!0}static isISelection(P){return P&&typeof P.selectionStartLineNumber=="number"&&typeof P.selectionStartColumn=="number"&&typeof P.positionLineNumber=="number"&&typeof P.positionColumn=="number"}static createWithDirection(P,E,k,r,I){return I===0?new y(P,E,k,r):new y(k,r,P,E)}}e.Selection=y}),define(me[105],ge([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ApplyEditsResult=e.ValidAnnotatedEditOperation=e.ModelConstants=e.PositionNormalizationAffinity=e.TrackedRangeStickiness=e.FindMatch=e.TextModelResolvedOptions=e.EndOfLineSequence=e.DefaultEndOfLine=e.EndOfLinePreference=e.MinimapPosition=e.OverviewRulerLane=void 0;var p;(function(c){c[c.Left=1]="Left",c[c.Center=2]="Center",c[c.Right=4]="Right",c[c.Full=7]="Full"})(p=e.OverviewRulerLane||(e.OverviewRulerLane={}));var R;(function(c){c[c.Inline=1]="Inline",c[c.Gutter=2]="Gutter"})(R=e.MinimapPosition||(e.MinimapPosition={}));var C;(function(c){c[c.TextDefined=0]="TextDefined",c[c.LF=1]="LF",c[c.CRLF=2]="CRLF"})(C=e.EndOfLinePreference||(e.EndOfLinePreference={}));var y;(function(c){c[c.LF=1]="LF",c[c.CRLF=2]="CRLF"})(y=e.DefaultEndOfLine||(e.DefaultEndOfLine={}));var A;(function(c){c[c.LF=0]="LF",c[c.CRLF=1]="CRLF"})(A=e.EndOfLineSequence||(e.EndOfLineSequence={}));class P{constructor(u){this.tabSize=Math.max(1,u.tabSize|0),this.indentSize=u.tabSize|0,this.insertSpaces=Boolean(u.insertSpaces),this.defaultEOL=u.defaultEOL|0,this.trimAutoWhitespace=Boolean(u.trimAutoWhitespace)}equals(u){return this.tabSize===u.tabSize&&this.indentSize===u.indentSize&&this.insertSpaces===u.insertSpaces&&this.defaultEOL===u.defaultEOL&&this.trimAutoWhitespace===u.trimAutoWhitespace}createChangeEvent(u){return{tabSize:this.tabSize!==u.tabSize,indentSize:this.indentSize!==u.indentSize,insertSpaces:this.insertSpaces!==u.insertSpaces,trimAutoWhitespace:this.trimAutoWhitespace!==u.trimAutoWhitespace}}}e.TextModelResolvedOptions=P;class E{constructor(u,S){this.range=u,this.matches=S}}e.FindMatch=E;var k;(function(c){c[c.AlwaysGrowsWhenTypingAtEdges=0]="AlwaysGrowsWhenTypingAtEdges",c[c.NeverGrowsWhenTypingAtEdges=1]="NeverGrowsWhenTypingAtEdges",c[c.GrowsOnlyWhenTypingBefore=2]="GrowsOnlyWhenTypingBefore",c[c.GrowsOnlyWhenTypingAfter=3]="GrowsOnlyWhenTypingAfter"})(k=e.TrackedRangeStickiness||(e.TrackedRangeStickiness={}));var r;(function(c){c[c.Left=0]="Left",c[c.Right=1]="Right"})(r=e.PositionNormalizationAffinity||(e.PositionNormalizationAffinity={}));var I;(function(c){c[c.FIRST_LINE_DETECTION_LENGTH_LIMIT=1e3]="FIRST_LINE_DETECTION_LENGTH_LIMIT"})(I=e.ModelConstants||(e.ModelConstants={}));class l{constructor(u,S,w,b,d,h){this.identifier=u,this.range=S,this.text=w,this.forceMoveMarkers=b,this.isAutoWhitespaceEdit=d,this._isTracked=h}}e.ValidAnnotatedEditOperation=l;class f{constructor(u,S,w){this.reverseEdits=u,this.changes=S,this.trimAutoWhitespaceLineNumbers=w}}e.ApplyEditsResult=f}),define(me[140],ge([0,1,8,138,44,40,105]),function(X,e,p,R,C,y,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Searcher=e.isValidMatch=e.TextModelSearch=e.createFindMatch=e.SearchData=e.isMultilineRegexSource=e.SearchParams=void 0;const P=999;class E{constructor(d,h,g,t){this.searchString=d,this.isRegex=h,this.matchCase=g,this.wordSeparators=t}parseSearchRequest(){if(this.searchString==="")return null;let d;this.isRegex?d=k(this.searchString):d=this.searchString.indexOf(`
`)>=0;let h=null;try{h=p.createRegExp(this.searchString,this.isRegex,{matchCase:this.matchCase,wholeWord:!1,multiline:d,global:!0,unicode:!0})}catch(t){return null}if(!h)return null;let g=!this.isRegex&&!d;return g&&this.searchString.toLowerCase()!==this.searchString.toUpperCase()&&(g=this.matchCase),new r(h,this.wordSeparators?R.getMapForWordSeparators(this.wordSeparators):null,g?this.searchString:null)}}e.SearchParams=E;function k(b){if(!b||b.length===0)return!1;for(let d=0,h=b.length;d<h;d++)if(b.charCodeAt(d)===92){if(d++,d>=h)break;const t=b.charCodeAt(d);if(t===110||t===114||t===87||t===119)return!0}return!1}e.isMultilineRegexSource=k;class r{constructor(d,h,g){this.regex=d,this.wordSeparators=h,this.simpleSearch=g}}e.SearchData=r;function I(b,d,h){if(!h)return new A.FindMatch(b,null);let g=[];for(let t=0,i=d.length;t<i;t++)g[t]=d[t];return new A.FindMatch(b,g)}e.createFindMatch=I;class l{constructor(d){let h=[],g=0;for(let t=0,i=d.length;t<i;t++)d.charCodeAt(t)===10&&(h[g++]=t);this._lineFeedsOffsets=h}findLineFeedCountBeforeOffset(d){const h=this._lineFeedsOffsets;let g=0,t=h.length-1;if(t===-1||d<=h[0])return 0;for(;g<t;){const i=g+((t-g)/2>>0);h[i]>=d?t=i-1:h[i+1]>=d?(g=i,t=i):g=i+1}return g+1}}class f{static findMatches(d,h,g,t,i){const s=h.parseSearchRequest();return s?s.regex.multiline?this._doFindMatchesMultiline(d,g,new w(s.wordSeparators,s.regex),t,i):this._doFindMatchesLineByLine(d,g,s,t,i):[]}static _getMultilineMatchRange(d,h,g,t,i,s){let n,o=0;t?(o=t.findLineFeedCountBeforeOffset(i),n=h+i+o):n=h+i;let v;if(t){let a=t.findLineFeedCountBeforeOffset(i+s.length)-o;v=n+s.length+a}else v=n+s.length;const m=d.getPositionAt(n),_=d.getPositionAt(v);return new y.Range(m.lineNumber,m.column,_.lineNumber,_.column)}static _doFindMatchesMultiline(d,h,g,t,i){const s=d.getOffsetAt(h.getStartPosition()),n=d.getValueInRange(h,1),o=d.getEOL()===`\r
`?new l(n):null,v=[];let m=0,_;for(g.reset(0);_=g.next(n);)if(v[m++]=I(this._getMultilineMatchRange(d,s,n,o,_.index,_[0]),_,t),m>=i)return v;return v}static _doFindMatchesLineByLine(d,h,g,t,i){const s=[];let n=0;if(h.startLineNumber===h.endLineNumber){const v=d.getLineContent(h.startLineNumber).substring(h.startColumn-1,h.endColumn-1);return n=this._findMatchesInLine(g,v,h.startLineNumber,h.startColumn-1,n,s,t,i),s}const o=d.getLineContent(h.startLineNumber).substring(h.startColumn-1);n=this._findMatchesInLine(g,o,h.startLineNumber,h.startColumn-1,n,s,t,i);for(let v=h.startLineNumber+1;v<h.endLineNumber&&n<i;v++)n=this._findMatchesInLine(g,d.getLineContent(v),v,0,n,s,t,i);if(n<i){const v=d.getLineContent(h.endLineNumber).substring(0,h.endColumn-1);n=this._findMatchesInLine(g,v,h.endLineNumber,0,n,s,t,i)}return s}static _findMatchesInLine(d,h,g,t,i,s,n,o){const v=d.wordSeparators;if(!n&&d.simpleSearch){const D=d.simpleSearch,a=D.length,T=h.length;let L=-a;for(;(L=h.indexOf(D,L+a))!==-1;)if((!v||S(v,h,T,L,a))&&(s[i++]=new A.FindMatch(new y.Range(g,L+1+t,g,L+1+a+t),null),i>=o))return i;return i}const m=new w(d.wordSeparators,d.regex);let _;m.reset(0);do if(_=m.next(h),_&&(s[i++]=I(new y.Range(g,_.index+1+t,g,_.index+1+_[0].length+t),_,n),i>=o))return i;while(_);return i}static findNextMatch(d,h,g,t){const i=h.parseSearchRequest();if(!i)return null;const s=new w(i.wordSeparators,i.regex);return i.regex.multiline?this._doFindNextMatchMultiline(d,g,s,t):this._doFindNextMatchLineByLine(d,g,s,t)}static _doFindNextMatchMultiline(d,h,g,t){const i=new C.Position(h.lineNumber,1),s=d.getOffsetAt(i),n=d.getLineCount(),o=d.getValueInRange(new y.Range(i.lineNumber,i.column,n,d.getLineMaxColumn(n)),1),v=d.getEOL()===`\r
`?new l(o):null;g.reset(h.column-1);let m=g.next(o);return m?I(this._getMultilineMatchRange(d,s,o,v,m.index,m[0]),m,t):h.lineNumber!==1||h.column!==1?this._doFindNextMatchMultiline(d,new C.Position(1,1),g,t):null}static _doFindNextMatchLineByLine(d,h,g,t){const i=d.getLineCount(),s=h.lineNumber,n=d.getLineContent(s),o=this._findFirstMatchInLine(g,n,s,h.column,t);if(o)return o;for(let v=1;v<=i;v++){const m=(s+v-1)%i,_=d.getLineContent(m+1),D=this._findFirstMatchInLine(g,_,m+1,1,t);if(D)return D}return null}static _findFirstMatchInLine(d,h,g,t,i){d.reset(t-1);const s=d.next(h);return s?I(new y.Range(g,s.index+1,g,s.index+1+s[0].length),s,i):null}static findPreviousMatch(d,h,g,t){const i=h.parseSearchRequest();if(!i)return null;const s=new w(i.wordSeparators,i.regex);return i.regex.multiline?this._doFindPreviousMatchMultiline(d,g,s,t):this._doFindPreviousMatchLineByLine(d,g,s,t)}static _doFindPreviousMatchMultiline(d,h,g,t){const i=this._doFindMatchesMultiline(d,new y.Range(1,1,h.lineNumber,h.column),g,t,10*P);if(i.length>0)return i[i.length-1];const s=d.getLineCount();return h.lineNumber!==s||h.column!==d.getLineMaxColumn(s)?this._doFindPreviousMatchMultiline(d,new C.Position(s,d.getLineMaxColumn(s)),g,t):null}static _doFindPreviousMatchLineByLine(d,h,g,t){const i=d.getLineCount(),s=h.lineNumber,n=d.getLineContent(s).substring(0,h.column-1),o=this._findLastMatchInLine(g,n,s,t);if(o)return o;for(let v=1;v<=i;v++){const m=(i+s-v-1)%i,_=d.getLineContent(m+1),D=this._findLastMatchInLine(g,_,m+1,t);if(D)return D}return null}static _findLastMatchInLine(d,h,g,t){let i=null,s;for(d.reset(0);s=d.next(h);)i=I(new y.Range(g,s.index+1,g,s.index+1+s[0].length),s,t);return i}}e.TextModelSearch=f;function c(b,d,h,g,t){if(g===0)return!0;const i=d.charCodeAt(g-1);if(b.get(i)!==0||i===13||i===10)return!0;if(t>0){const s=d.charCodeAt(g);if(b.get(s)!==0)return!0}return!1}function u(b,d,h,g,t){if(g+t===h)return!0;const i=d.charCodeAt(g+t);if(b.get(i)!==0||i===13||i===10)return!0;if(t>0){const s=d.charCodeAt(g+t-1);if(b.get(s)!==0)return!0}return!1}function S(b,d,h,g,t){return c(b,d,h,g,t)&&u(b,d,h,g,t)}e.isValidMatch=S;class w{constructor(d,h){this._wordSeparators=d,this._searchRegex=h,this._prevMatchStartIndex=-1,this._prevMatchLength=0}reset(d){this._searchRegex.lastIndex=d,this._prevMatchStartIndex=-1,this._prevMatchLength=0}next(d){const h=d.length;let g;do{if(this._prevMatchStartIndex+this._prevMatchLength===h||(g=this._searchRegex.exec(d),!g))return null;const t=g.index,i=g[0].length;if(t===this._prevMatchStartIndex&&i===this._prevMatchLength){if(i===0){p.getNextCodePoint(d,h,this._searchRegex.lastIndex)>65535?this._searchRegex.lastIndex+=2:this._searchRegex.lastIndex+=1;continue}return null}if(this._prevMatchStartIndex=t,this._prevMatchLength=i,!this._wordSeparators||S(this._wordSeparators,d,h,t,i))return g}while(g);return null}}e.Searcher=w}),define(me[106],ge([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getWordAtText=e.ensureValidWordDefinition=e.DEFAULT_WORD_REGEXP=e.USUAL_WORD_SEPARATORS=void 0,e.USUAL_WORD_SEPARATORS="`~!@#$%^&*()-=+[{]}\\|;:'\",.<>/?";function p(P=""){let E="(-?\\d*\\.\\d\\w*)|([^";for(const k of e.USUAL_WORD_SEPARATORS)P.indexOf(k)>=0||(E+="\\"+k);return E+="\\s]+)",new RegExp(E,"g")}e.DEFAULT_WORD_REGEXP=p();function R(P){let E=e.DEFAULT_WORD_REGEXP;if(P&&P instanceof RegExp)if(P.global)E=P;else{let k="g";P.ignoreCase&&(k+="i"),P.multiline&&(k+="m"),P.unicode&&(k+="u"),E=new RegExp(P.source,k)}return E.lastIndex=0,E}e.ensureValidWordDefinition=R;const C={maxLen:1e3,windowSize:15,timeBudget:150};function y(P,E,k,r,I=C){if(k.length>I.maxLen){let S=P-I.maxLen/2;return S<0?S=0:r+=S,k=k.substring(S,P+I.maxLen/2),y(P,E,k,r,I)}const l=Date.now(),f=P-1-r;let c=-1,u=null;for(let S=1;!(Date.now()-l>=I.timeBudget);S++){const w=f-I.windowSize*S;E.lastIndex=Math.max(0,w);const b=A(E,k,f,c);if(!b&&u||(u=b,w<=0))break;c=w}if(u){let S={word:u[0],startColumn:r+1+u.index,endColumn:r+1+u.index+u[0].length};return E.lastIndex=0,S}return null}e.getWordAtText=y;function A(P,E,k,r){let I;for(;I=P.exec(E);){const l=I.index||0;if(l<=k&&P.lastIndex>=k)return I;if(r>0&&l>r)return null}return null}}),define(me[141],ge([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AutoClosingPairs=e.StandardAutoClosingPairConditional=e.IndentAction=void 0;var p;(function(A){A[A.None=0]="None",A[A.Indent=1]="Indent",A[A.IndentOutdent=2]="IndentOutdent",A[A.Outdent=3]="Outdent"})(p=e.IndentAction||(e.IndentAction={}));class R{constructor(P){if(this.open=P.open,this.close=P.close,this._standardTokenMask=0,Array.isArray(P.notIn))for(let E=0,k=P.notIn.length;E<k;E++)switch(P.notIn[E]){case"string":this._standardTokenMask|=2;break;case"comment":this._standardTokenMask|=1;break;case"regex":this._standardTokenMask|=4;break}}isOK(P){return(this._standardTokenMask&P)==0}}e.StandardAutoClosingPairConditional=R;class C{constructor(P){this.autoClosingPairsOpenByStart=new Map,this.autoClosingPairsOpenByEnd=new Map,this.autoClosingPairsCloseByStart=new Map,this.autoClosingPairsCloseByEnd=new Map,this.autoClosingPairsCloseSingleChar=new Map;for(const E of P)y(this.autoClosingPairsOpenByStart,E.open.charAt(0),E),y(this.autoClosingPairsOpenByEnd,E.open.charAt(E.open.length-1),E),y(this.autoClosingPairsCloseByStart,E.close.charAt(0),E),y(this.autoClosingPairsCloseByEnd,E.close.charAt(E.close.length-1),E),E.close.length===1&&E.open.length===1&&y(this.autoClosingPairsCloseSingleChar,E.close,E)}}e.AutoClosingPairs=C;function y(A,P,E){A.has(P)?A.get(P).push(E):A.set(P,[E])}}),define(me[76],ge([0,1,30,9]),function(X,e,p,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.score=void 0;function C(y,A,P,E){if(Array.isArray(y)){let k=0;for(const r of y){const I=C(r,A,P,E);if(I===10)return I;I>k&&(k=I)}return k}else{if(typeof y=="string")return E?y==="*"?5:y===P?10:0:0;if(y){const{language:k,pattern:r,scheme:I,hasAccessToAllModels:l}=y;if(!E&&!l)return 0;let f=0;if(I)if(I===A.scheme)f=10;else if(I==="*")f=5;else return 0;if(k)if(k===P)f=10;else if(k==="*")f=Math.max(f,5);else return 0;if(r){let c;if(typeof r=="string"?c=r:c=Object.assign(Object.assign({},r),{base:R.normalize(r.base)}),c===A.fsPath||p.match(c,A.fsPath))f=10;else return 0}return f}else return 0}}e.score=C}),define(me[142],ge([0,1,104]),function(X,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.computeLinks=e.LinkComputer=e.StateMachine=e.Uint8Matrix=e.State=void 0;var R;(function(f){f[f.Invalid=0]="Invalid",f[f.Start=1]="Start",f[f.H=2]="H",f[f.HT=3]="HT",f[f.HTT=4]="HTT",f[f.HTTP=5]="HTTP",f[f.F=6]="F",f[f.FI=7]="FI",f[f.FIL=8]="FIL",f[f.BeforeColon=9]="BeforeColon",f[f.AfterColon=10]="AfterColon",f[f.AlmostThere=11]="AlmostThere",f[f.End=12]="End",f[f.Accept=13]="Accept",f[f.LastKnownState=14]="LastKnownState"})(R=e.State||(e.State={}));class C{constructor(c,u,S){const w=new Uint8Array(c*u);for(let b=0,d=c*u;b<d;b++)w[b]=S;this._data=w,this.rows=c,this.cols=u}get(c,u){return this._data[c*this.cols+u]}set(c,u,S){this._data[c*this.cols+u]=S}}e.Uint8Matrix=C;class y{constructor(c){let u=0,S=0;for(let b=0,d=c.length;b<d;b++){let[h,g,t]=c[b];g>u&&(u=g),h>S&&(S=h),t>S&&(S=t)}u++,S++;let w=new C(S,u,0);for(let b=0,d=c.length;b<d;b++){let[h,g,t]=c[b];w.set(h,g,t)}this._states=w,this._maxCharCode=u}nextState(c,u){return u<0||u>=this._maxCharCode?0:this._states.get(c,u)}}e.StateMachine=y;let A=null;function P(){return A===null&&(A=new y([[1,104,2],[1,72,2],[1,102,6],[1,70,6],[2,116,3],[2,84,3],[3,116,4],[3,84,4],[4,112,5],[4,80,5],[5,115,9],[5,83,9],[5,58,10],[6,105,7],[6,73,7],[7,108,8],[7,76,8],[8,101,9],[8,69,9],[9,58,10],[10,47,11],[11,47,12]])),A}var E;(function(f){f[f.None=0]="None",f[f.ForceTermination=1]="ForceTermination",f[f.CannotEndIn=2]="CannotEndIn"})(E||(E={}));let k=null;function r(){if(k===null){k=new p.CharacterClassifier(0);const f=` 	<>'"\u3001\u3002\uFF61\uFF64\uFF0C\uFF0E\uFF1A\uFF1B\u2018\u3008\u300C\u300E\u3014\uFF08\uFF3B\uFF5B\uFF62\uFF63\uFF5D\uFF3D\uFF09\u3015\u300F\u300D\u3009\u2019\uFF40\uFF5E\u2026`;for(let u=0;u<f.length;u++)k.set(f.charCodeAt(u),1);const c=".,;";for(let u=0;u<c.length;u++)k.set(c.charCodeAt(u),2)}return k}class I{static _createLink(c,u,S,w,b){let d=b-1;do{const h=u.charCodeAt(d);if(c.get(h)!==2)break;d--}while(d>w);if(w>0){const h=u.charCodeAt(w-1),g=u.charCodeAt(d);(h===40&&g===41||h===91&&g===93||h===123&&g===125)&&d--}return{range:{startLineNumber:S,startColumn:w+1,endLineNumber:S,endColumn:d+2},url:u.substring(w,d+1)}}static computeLinks(c,u=P()){const S=r();let w=[];for(let b=1,d=c.getLineCount();b<=d;b++){const h=c.getLineContent(b),g=h.length;let t=0,i=0,s=0,n=1,o=!1,v=!1,m=!1,_=!1;for(;t<g;){let D=!1;const a=h.charCodeAt(t);if(n===13){let T;switch(a){case 40:o=!0,T=0;break;case 41:T=o?0:1;break;case 91:m=!0,v=!0,T=0;break;case 93:m=!1,T=v?0:1;break;case 123:_=!0,T=0;break;case 125:T=_?0:1;break;case 39:T=s===34||s===96?0:1;break;case 34:T=s===39||s===96?0:1;break;case 96:T=s===39||s===34?0:1;break;case 42:T=s===42?1:0;break;case 124:T=s===124?1:0;break;case 32:T=m?0:1;break;default:T=S.get(a)}T===1&&(w.push(I._createLink(S,h,b,i,t)),D=!0)}else if(n===12){let T;a===91?(v=!0,T=0):T=S.get(a),T===1?D=!0:n=13}else n=u.nextState(n,a),n===0&&(D=!0);D&&(n=1,o=!1,v=!1,_=!1,i=t+1,s=a),t++}n===13&&w.push(I._createLink(S,h,b,i,g))}return w}}e.LinkComputer=I;function l(f){return!f||typeof f.getLineCount!="function"||typeof f.getLineContent!="function"?[]:I.computeLinks(f)}e.computeLinks=l}),define(me[143],ge([0,1,3,6]),function(X,e,p,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TokenizationRegistryImpl=void 0;class C{constructor(){this._map=new Map,this._promises=new Map,this._onDidChange=new p.Emitter,this.onDidChange=this._onDidChange.event,this._colorMap=null}fire(A){this._onDidChange.fire({changedLanguages:A,changedColorMap:!1})}register(A,P){return this._map.set(A,P),this.fire([A]),R.toDisposable(()=>{this._map.get(A)===P&&(this._map.delete(A),this.fire([A]))})}registerPromise(A,P){let E=null,k=!1;return this._promises.set(A,P.then(r=>{this._promises.delete(A),!(k||!r)&&(E=this.register(A,r))})),R.toDisposable(()=>{k=!0,E&&E.dispose()})}getPromise(A){const P=this.get(A);if(P)return Promise.resolve(P);const E=this._promises.get(A);return E?E.then(k=>this.get(A)):null}get(A){return this._map.get(A)||null}setColorMap(A){this._colorMap=A,this._onDidChange.fire({changedLanguages:Array.from(this._map.keys()),changedColorMap:!0})}getColorMap(){return this._colorMap}getDefaultBackground(){return this._colorMap&&this._colorMap.length>2?this._colorMap[2]:null}}e.TokenizationRegistryImpl=C}),define(me[107],ge([0,1,22,11]),function(X,e,p,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.decodeSemanticTokensDto=e.encodeSemanticTokensDto=void 0;var C;(function(I){I[I.Full=1]="Full",I[I.Delta=2]="Delta"})(C||(C={}));function y(I){for(let l=0,f=I.length;l<f;l+=4){const c=I[l+0],u=I[l+1],S=I[l+2],w=I[l+3];I[l+0]=w,I[l+1]=S,I[l+2]=u,I[l+3]=c}}function A(I){const l=new Uint8Array(I.buffer,I.byteOffset,I.length*4);return R.isLittleEndian()||y(l),p.VSBuffer.wrap(l)}function P(I){const l=I.buffer;if(R.isLittleEndian()||y(l),l.byteOffset%4==0)return new Uint32Array(l.buffer,l.byteOffset,l.length/4);{const f=new Uint8Array(l.byteLength);return f.set(l),new Uint32Array(f.buffer,f.byteOffset,f.length/4)}}function E(I){const l=new Uint32Array(k(I));let f=0;if(l[f++]=I.id,I.type==="full")l[f++]=1,l[f++]=I.data.length,l.set(I.data,f),f+=I.data.length;else{l[f++]=2,l[f++]=I.deltas.length;for(const c of I.deltas)l[f++]=c.start,l[f++]=c.deleteCount,c.data?(l[f++]=c.data.length,l.set(c.data,f),f+=c.data.length):l[f++]=0}return A(l)}e.encodeSemanticTokensDto=E;function k(I){let l=0;if(l+=1+1,I.type==="full")l+=1+I.data.length;else{l+=1,l+=(1+1+1)*I.deltas.length;for(const f of I.deltas)f.data&&(l+=f.data.length)}return l}function r(I){const l=P(I);let f=0;const c=l[f++];if(l[f++]===1){const b=l[f++],d=l.subarray(f,f+b);return f+=b,{id:c,type:"full",data:d}}const S=l[f++];let w=[];for(let b=0;b<S;b++){const d=l[f++],h=l[f++],g=l[f++];let t;g>0&&(t=l.subarray(f,f+g),f+=g),w[b]={start:d,deleteCount:h,data:t}}return{id:c,type:"delta",deltas:w}}e.decodeSemanticTokensDto=r}),define(me[108],ge([0,1,92]),function(X,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PrefixSumComputer=e.PrefixSumIndexOfResult=void 0;class R{constructor(A,P){this.index=A,this.remainder=P}}e.PrefixSumIndexOfResult=R;class C{constructor(A){this.values=A,this.prefixSum=new Uint32Array(A.length),this.prefixSumValidIndex=new Int32Array(1),this.prefixSumValidIndex[0]=-1}getCount(){return this.values.length}insertValues(A,P){A=p.toUint32(A);const E=this.values,k=this.prefixSum,r=P.length;return r===0?!1:(this.values=new Uint32Array(E.length+r),this.values.set(E.subarray(0,A),0),this.values.set(E.subarray(A),A+r),this.values.set(P,A),A-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=A-1),this.prefixSum=new Uint32Array(this.values.length),this.prefixSumValidIndex[0]>=0&&this.prefixSum.set(k.subarray(0,this.prefixSumValidIndex[0]+1)),!0)}changeValue(A,P){return A=p.toUint32(A),P=p.toUint32(P),this.values[A]===P?!1:(this.values[A]=P,A-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=A-1),!0)}removeValues(A,P){A=p.toUint32(A),P=p.toUint32(P);const E=this.values,k=this.prefixSum;if(A>=E.length)return!1;let r=E.length-A;return P>=r&&(P=r),P===0?!1:(this.values=new Uint32Array(E.length-P),this.values.set(E.subarray(0,A),0),this.values.set(E.subarray(A+P),A),this.prefixSum=new Uint32Array(this.values.length),A-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=A-1),this.prefixSumValidIndex[0]>=0&&this.prefixSum.set(k.subarray(0,this.prefixSumValidIndex[0]+1)),!0)}getTotalSum(){return this.values.length===0?0:this._getPrefixSum(this.values.length-1)}getPrefixSum(A){return A<0?0:(A=p.toUint32(A),this._getPrefixSum(A))}_getPrefixSum(A){if(A<=this.prefixSumValidIndex[0])return this.prefixSum[A];let P=this.prefixSumValidIndex[0]+1;P===0&&(this.prefixSum[0]=this.values[0],P++),A>=this.values.length&&(A=this.values.length-1);for(let E=P;E<=A;E++)this.prefixSum[E]=this.prefixSum[E-1]+this.values[E];return this.prefixSumValidIndex[0]=Math.max(this.prefixSumValidIndex[0],A),this.prefixSum[A]}getIndexOf(A){A=Math.floor(A),this.getTotalSum();let P=0,E=this.values.length-1,k=0,r=0,I=0;for(;P<=E;)if(k=P+(E-P)/2|0,r=this.prefixSum[k],I=r-this.values[k],A<I)E=k-1;else if(A>=r)P=k+1;else break;return new R(k,A-I)}}e.PrefixSumComputer=C}),define(me[144],ge([0,1,8,44,108]),function(X,e,p,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MirrorTextModel=void 0;class y{constructor(P,E,k,r){this._uri=P,this._lines=E,this._eol=k,this._versionId=r,this._lineStarts=null,this._cachedTextValue=null}dispose(){this._lines.length=0}get version(){return this._versionId}getText(){return this._cachedTextValue===null&&(this._cachedTextValue=this._lines.join(this._eol)),this._cachedTextValue}onEvents(P){P.eol&&P.eol!==this._eol&&(this._eol=P.eol,this._lineStarts=null);const E=P.changes;for(const k of E)this._acceptDeleteRange(k.range),this._acceptInsertText(new R.Position(k.range.startLineNumber,k.range.startColumn),k.text);this._versionId=P.versionId,this._cachedTextValue=null}_ensureLineStarts(){if(!this._lineStarts){const P=this._eol.length,E=this._lines.length,k=new Uint32Array(E);for(let r=0;r<E;r++)k[r]=this._lines[r].length+P;this._lineStarts=new C.PrefixSumComputer(k)}}_setLineText(P,E){this._lines[P]=E,this._lineStarts&&this._lineStarts.changeValue(P,this._lines[P].length+this._eol.length)}_acceptDeleteRange(P){if(P.startLineNumber===P.endLineNumber){if(P.startColumn===P.endColumn)return;this._setLineText(P.startLineNumber-1,this._lines[P.startLineNumber-1].substring(0,P.startColumn-1)+this._lines[P.startLineNumber-1].substring(P.endColumn-1));return}this._setLineText(P.startLineNumber-1,this._lines[P.startLineNumber-1].substring(0,P.startColumn-1)+this._lines[P.endLineNumber-1].substring(P.endColumn-1)),this._lines.splice(P.startLineNumber,P.endLineNumber-P.startLineNumber),this._lineStarts&&this._lineStarts.removeValues(P.startLineNumber,P.endLineNumber-P.startLineNumber)}_acceptInsertText(P,E){if(E.length===0)return;let k=p.splitLines(E);if(k.length===1){this._setLineText(P.lineNumber-1,this._lines[P.lineNumber-1].substring(0,P.column-1)+k[0]+this._lines[P.lineNumber-1].substring(P.column-1));return}k[k.length-1]+=this._lines[P.lineNumber-1].substring(P.column-1),this._setLineText(P.lineNumber-1,this._lines[P.lineNumber-1].substring(0,P.column-1)+k[0]);let r=new Uint32Array(k.length-1);for(let I=1;I<k.length;I++)this._lines.splice(P.lineNumber+I-1,0,k[I]),r[I-1]=k[I].length+this._eol.length;this._lineStarts&&this._lineStarts.insertValues(P.lineNumber,r)}}e.MirrorTextModel=y}),define(me[145],ge([19,20]),function(X,e){return X.create("vs/base/common/date",e)}),define(me[146],ge([0,1,145]),function(X,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalISOString=e.fromNow=void 0;const R=60,C=R*60,y=C*24,A=y*7,P=y*30,E=y*365;function k(I,l){typeof I!="number"&&(I=I.getTime());const f=Math.round((new Date().getTime()-I)/1e3);if(f<-30)return p.localize(0,null,k(new Date().getTime()+f*1e3,!1));if(f<30)return p.localize(1,null);let c;return f<R?(c=f,l?c===1?p.localize(2,null,c):p.localize(3,null,c):c===1?p.localize(4,null,c):p.localize(5,null,c)):f<C?(c=Math.floor(f/R),l?c===1?p.localize(6,null,c):p.localize(7,null,c):c===1?p.localize(8,null,c):p.localize(9,null,c)):f<y?(c=Math.floor(f/C),l?c===1?p.localize(10,null,c):p.localize(11,null,c):c===1?p.localize(12,null,c):p.localize(13,null,c)):f<A?(c=Math.floor(f/y),l?c===1?p.localize(14,null,c):p.localize(15,null,c):c===1?p.localize(16,null,c):p.localize(17,null,c)):f<P?(c=Math.floor(f/A),l?c===1?p.localize(18,null,c):p.localize(19,null,c):c===1?p.localize(20,null,c):p.localize(21,null,c)):f<E?(c=Math.floor(f/P),l?c===1?p.localize(22,null,c):p.localize(23,null,c):c===1?p.localize(24,null,c):p.localize(25,null,c)):(c=Math.floor(f/E),l?c===1?p.localize(26,null,c):p.localize(27,null,c):c===1?p.localize(28,null,c):p.localize(29,null,c))}e.fromNow=k;function r(I){return I.getFullYear()+"-"+String(I.getMonth()+1).padStart(2,"0")+"-"+String(I.getDate()).padStart(2,"0")+"T"+String(I.getHours()).padStart(2,"0")+":"+String(I.getMinutes()).padStart(2,"0")+":"+String(I.getSeconds()).padStart(2,"0")+"."+(I.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.toLocalISOString=r}),define(me[147],ge([19,20]),function(X,e){return X.create("vs/base/common/errorMessage",e)}),define(me[57],ge([0,1,147,15,18]),function(X,e,p,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toErrorMessage=void 0;function y(k,r){return r&&(k.stack||k.stacktrace)?p.localize(0,null,P(k),A(k.stack)||A(k.stacktrace)):P(k)}function A(k){return Array.isArray(k)?k.join(`
`):k}function P(k){return typeof k.code=="string"&&typeof k.errno=="number"&&typeof k.syscall=="string"?p.localize(1,null,k.message):k.message||p.localize(2,null)}function E(k=null,r=!1){if(!k)return p.localize(3,null);if(Array.isArray(k)){const I=C.coalesce(k),l=E(I[0],r);return I.length>1?p.localize(4,null,l,I.length):l}if(R.isString(k))return k;if(k.detail){const I=k.detail;if(I.error)return y(I.error,r);if(I.exception)return y(I.exception,r)}return k.stack?y(k,r):k.message?k.message:p.localize(5,null)}e.toErrorMessage=E}),define(me[148],ge([19,20]),function(X,e){return X.create("vs/base/node/processes",e)}),define(me[109],ge([0,1,9,28,38,148,37,15,25,29,11,137,10]),function(X,e,p,R,C,y,A,P,E,k,r,I,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.createQueuedSender=e.LineProcess=e.AbstractProcess=e.getWindowsShell=e.TerminateResponseCode=e.Source=void 0;function f(h){switch(h){case 0:return 0;case 1:return 2;case 128:return 3;default:return 1}}function c(h,g){if(r.isWindows)try{const t={stdio:["pipe","pipe","ignore"]};g&&(t.cwd=g);const i=C.execFile("taskkill",["/T","/F","/PID",h.pid.toString()],t);return new Promise(s=>{i.once("error",n=>{s({success:!1,error:n})}),i.once("exit",(n,o)=>{s(n===0?{success:!0}:{success:!1,code:n!==null?n:1})})})}catch(t){return Promise.resolve({success:!1,error:t,code:t.status?f(t.status):1})}else if(r.isLinux||r.isMacintosh)try{const t=l.FileAccess.asFileUri("vs/base/node/terminateProcess.sh",X).fsPath;return new Promise(i=>{C.execFile(t,[h.pid.toString()],{encoding:"utf8",shell:!0},(s,n,o)=>{i(s?{success:!1,error:s}:{success:!0})})})}catch(t){return Promise.resolve({success:!1,error:t})}else h.kill("SIGKILL");return Promise.resolve({success:!0})}function u(h=A.env){return h.comspec||"cmd.exe"}e.getWindowsShell=u;class S{constructor(g,t,i,s){if(t!==void 0&&i!==void 0&&s!==void 0)this.cmd=g,this.args=t,this.shell=i,this.options=s;else{const n=g;this.cmd=n.command,this.shell=n.isShellCommand,this.args=n.args.slice(0),this.options=n.options||{}}if(this.childProcess=null,this.childProcessPromise=null,this.terminateRequested=!1,this.options.env){const n=Object.create(null);Object.keys(A.env).forEach(o=>{n[o]=A.env[o]}),Object.keys(this.options.env).forEach(o=>{n[o]=this.options.env[o]}),this.options.env=n}}getSanitizedCommand(){let g=this.cmd.toLowerCase();const t=g.lastIndexOf(p.sep);return t!==-1&&(g=g.substring(t+1)),S.WellKnowCommands[g]?g:"other"}start(g){return r.isWindows&&(this.options&&this.options.cwd&&k.isUNC(this.options.cwd)||!this.options&&k.isUNC(A.cwd()))?Promise.reject(new Error(y.localize(0,null))):this.useExec().then(t=>{let i,s;const n=new Promise((o,v)=>{i=o,s=v});if(t){let o=this.cmd;this.args&&(o=o+" "+this.args.join(" ")),this.childProcess=C.exec(o,this.options,(v,m,_)=>{this.childProcess=null;const D=v;D&&D.killed?s({killed:this.terminateRequested,stdout:m.toString(),stderr:_.toString()}):this.handleExec(i,g,v,m,_)})}else{let o=null;const v=m=>{this.childProcess=null,this.childProcessPromise=null,this.handleClose(m,i,g,s);const _={terminated:this.terminateRequested};P.isNumber(m)&&(_.cmdCode=m),i(_)};if(this.shell&&r.isWindows){const m=E.deepClone(this.options);m.windowsVerbatimArguments=!0,m.detached=!1;let _=!1,D=!1;const a=[];let T=this.ensureQuotes(this.cmd);a.push(T.value),_=T.quoted,this.args&&this.args.forEach(U=>{T=this.ensureQuotes(U),a.push(T.value),D=D&&T.quoted});const L=["/s","/c"];_?D?L.push('"'+a.join(" ")+'"'):a.length>1?L.push('"'+a[0]+'" '+a.slice(1).join(" ")):L.push('"'+a[0]+'"'):L.push(a.join(" ")),o=C.spawn(u(),L,m)}else this.cmd&&(o=C.spawn(this.cmd,this.args,this.options));o&&(this.childProcess=o,this.childProcessPromise=Promise.resolve(o),this.pidResolve&&(this.pidResolve(P.isNumber(o.pid)?o.pid:-1),this.pidResolve=void 0),o.on("error",m=>{this.childProcess=null,s({terminated:this.terminateRequested,error:m})}),o.pid&&(this.childProcess.on("close",v),this.handleSpawn(o,i,g,s,!0)))}return n})}handleClose(g,t,i,s){}ensureQuotes(g){return S.regexp.test(g)?{value:'"'+g+'"',quoted:!0}:{value:g,quoted:g.length>0&&g[0]==='"'&&g[g.length-1]==='"'}}get pid(){return this.childProcessPromise?this.childProcessPromise.then(g=>g.pid,g=>-1):new Promise(g=>{this.pidResolve=g})}terminate(){return this.childProcessPromise?this.childProcessPromise.then(g=>(this.terminateRequested=!0,c(g,this.options.cwd).then(t=>(t.success&&(this.childProcess=null),t))),g=>({success:!0})):Promise.resolve({success:!0})}useExec(){return new Promise(g=>{if(!this.shell||!r.isWindows)return g(!1);const t=C.spawn(u(),["/s","/c"]);t.on("error",i=>g(!0)),t.on("exit",i=>g(!1))})}}e.AbstractProcess=S,S.WellKnowCommands={ant:!0,cmake:!0,eslint:!0,gradle:!0,grunt:!0,gulp:!0,jake:!0,jenkins:!0,jshint:!0,make:!0,maven:!0,msbuild:!0,msc:!0,nmake:!0,npm:!0,rake:!0,tsc:!0,xbuild:!0},S.regexp=/^[^"].* .*[^"]/;class w extends S{constructor(g,t,i,s){super(g,t,i,s);this.stdoutLineDecoder=null,this.stderrLineDecoder=null}handleExec(g,t,i,s,n){[s,n].forEach((o,v)=>{const m=new I.LineDecoder;m.write(o).forEach(a=>{t({line:a,source:v===0?0:1})});const D=m.end();D&&t({line:D,source:v===0?0:1})}),g({terminated:this.terminateRequested,error:i})}handleSpawn(g,t,i,s,n){const o=new I.LineDecoder,v=new I.LineDecoder;g.stdout.on("data",m=>{o.write(m).forEach(D=>i({line:D,source:0}))}),g.stderr.on("data",m=>{v.write(m).forEach(D=>i({line:D,source:1}))}),this.stdoutLineDecoder=o,this.stderrLineDecoder=v}handleClose(g,t,i,s){const n=this.stdoutLineDecoder?this.stdoutLineDecoder.end():null;n&&i({line:n,source:0});const o=this.stderrLineDecoder?this.stderrLineDecoder.end():null;o&&i({line:o,source:1})}}e.LineProcess=w;function b(h){let g=[],t=!1;const i=function(s){if(t){g.push(s);return}(!h.send(s,o=>{if(o&&console.error(o),t=!1,g.length>0){const v=g.slice(0);g=[],v.forEach(m=>i(m))}})||r.isWindows)&&(t=!0)};return{send:i}}e.createQueuedSender=b;var d;(function(h){async function g(t,i,s){if(p.isAbsolute(t))return t;if(i===void 0&&(i=A.cwd()),p.dirname(t)!=="."||(s===void 0&&P.isString(A.env.PATH)&&(s=A.env.PATH.split(p.delimiter)),s===void 0||s.length===0))return p.join(i,t);async function o(v){return await R.Promises.exists(v)?!(await R.Promises.stat(v)).isDirectory():!1}for(let v of s){let m;if(p.isAbsolute(v)?m=p.join(v,t):m=p.join(i,v,t),await o(m))return m;let _=m+".com";if(await o(_)||(_=m+".exe",await o(_)))return _}return p.join(i,t)}h.findExecutable=g})(d=e.win32||(e.win32={}))}),define(me[149],ge([19,20]),function(X,e){return X.create("vs/editor/common/config/editorOptions",e)}),define(me[150],ge([0,1,149,11,106]),function(X,e,p,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorOptions=e.EditorOption=e.editorOptionsRegistry=e.EDITOR_MODEL_DEFAULTS=e.EDITOR_FONT_DEFAULTS=e.WrappingIndent=e.filterValidationDecorations=e.RenderLineNumbersType=e.EditorLayoutInfoComputer=e.RenderMinimap=e.EditorFontLigatures=e.cursorStyleToString=e.TextEditorCursorStyle=e.TextEditorCursorBlinkingStyle=e.stringSet=e.boolean=e.ComputeOptionsMemory=e.ValidatedEditorOptions=e.ConfigurationChangedEvent=e.MINIMAP_GUTTER_WIDTH=e.EditorAutoIndentStrategy=void 0;var y;(function(K){K[K.None=0]="None",K[K.Keep=1]="Keep",K[K.Brackets=2]="Brackets",K[K.Advanced=3]="Advanced",K[K.Full=4]="Full"})(y=e.EditorAutoIndentStrategy||(e.EditorAutoIndentStrategy={})),e.MINIMAP_GUTTER_WIDTH=8;class A{constructor(ie){this._values=ie}hasChanged(ie){return this._values[ie]}}e.ConfigurationChangedEvent=A;class P{constructor(){this._values=[]}_read(ie){return this._values[ie]}get(ie){return this._values[ie]}_write(ie,ve){this._values[ie]=ve}}e.ValidatedEditorOptions=P;class E{constructor(){this.stableMinimapLayoutInput=null,this.stableFitMaxMinimapScale=0,this.stableFitRemainingWidth=0}}e.ComputeOptionsMemory=E;class k{constructor(ie,ve,Me,xe){this.id=ie,this.name=ve,this.defaultValue=Me,this.schema=xe}compute(ie,ve,Me){return Me}}class r{constructor(ie,ve=null){this.schema=void 0,this.id=ie,this.name="_never_",this.defaultValue=void 0,this.deps=ve}validate(ie){return this.defaultValue}}class I{constructor(ie,ve,Me,xe){this.id=ie,this.name=ve,this.defaultValue=Me,this.schema=xe}validate(ie){return typeof ie=="undefined"?this.defaultValue:ie}compute(ie,ve,Me){return Me}}function l(K,ie){return typeof K=="undefined"?ie:K==="false"?!1:Boolean(K)}e.boolean=l;class f extends I{constructor(ie,ve,Me,xe=void 0){typeof xe!="undefined"&&(xe.type="boolean",xe.default=Me),super(ie,ve,Me,xe)}validate(ie){return l(ie,this.defaultValue)}}class c extends I{constructor(ie,ve,Me,xe,Je,ke=void 0){typeof ke!="undefined"&&(ke.type="integer",ke.default=Me,ke.minimum=xe,ke.maximum=Je),super(ie,ve,Me,ke),this.minimum=xe,this.maximum=Je}static clampedInt(ie,ve,Me,xe){if(typeof ie=="undefined")return ve;let Je=parseInt(ie,10);return isNaN(Je)?ve:(Je=Math.max(Me,Je),Je=Math.min(xe,Je),Je|0)}validate(ie){return c.clampedInt(ie,this.defaultValue,this.minimum,this.maximum)}}class u extends I{constructor(ie,ve,Me,xe,Je){typeof Je!="undefined"&&(Je.type="number",Je.default=Me),super(ie,ve,Me,Je),this.validationFn=xe}static clamp(ie,ve,Me){return ie<ve?ve:ie>Me?Me:ie}static float(ie,ve){if(typeof ie=="number")return ie;if(typeof ie=="undefined")return ve;const Me=parseFloat(ie);return isNaN(Me)?ve:Me}validate(ie){return this.validationFn(u.float(ie,this.defaultValue))}}class S extends I{static string(ie,ve){return typeof ie!="string"?ve:ie}constructor(ie,ve,Me,xe=void 0){typeof xe!="undefined"&&(xe.type="string",xe.default=Me),super(ie,ve,Me,xe)}validate(ie){return S.string(ie,this.defaultValue)}}function w(K,ie,ve){return typeof K!="string"||ve.indexOf(K)===-1?ie:K}e.stringSet=w;class b extends I{constructor(ie,ve,Me,xe,Je=void 0){typeof Je!="undefined"&&(Je.type="string",Je.enum=xe,Je.default=Me),super(ie,ve,Me,Je),this._allowedValues=xe}validate(ie){return w(ie,this.defaultValue,this._allowedValues)}}class d extends k{constructor(ie,ve,Me,xe,Je,ke,ye=void 0){typeof ye!="undefined"&&(ye.type="string",ye.enum=Je,ye.default=xe),super(ie,ve,Me,ye),this._allowedValues=Je,this._convert=ke}validate(ie){return typeof ie!="string"?this.defaultValue:this._allowedValues.indexOf(ie)===-1?this.defaultValue:this._convert(ie)}}function h(K){switch(K){case"none":return 0;case"keep":return 1;case"brackets":return 2;case"advanced":return 3;case"full":return 4}}class g extends k{constructor(){super(2,"accessibilitySupport",0,{type:"string",enum:["auto","on","off"],enumDescriptions:[p.localize(0,null),p.localize(1,null),p.localize(2,null)],default:"auto",description:p.localize(3,null)})}validate(ie){switch(ie){case"auto":return 0;case"off":return 1;case"on":return 2}return this.defaultValue}compute(ie,ve,Me){return Me===0?ie.accessibilitySupport:Me}}class t extends k{constructor(){const ie={insertSpace:!0,ignoreEmptyLines:!0};super(17,"comments",ie,{"editor.comments.insertSpace":{type:"boolean",default:ie.insertSpace,description:p.localize(4,null)},"editor.comments.ignoreEmptyLines":{type:"boolean",default:ie.ignoreEmptyLines,description:p.localize(5,null)}})}validate(ie){if(!ie||typeof ie!="object")return this.defaultValue;const ve=ie;return{insertSpace:l(ve.insertSpace,this.defaultValue.insertSpace),ignoreEmptyLines:l(ve.ignoreEmptyLines,this.defaultValue.ignoreEmptyLines)}}}var i;(function(K){K[K.Hidden=0]="Hidden",K[K.Blink=1]="Blink",K[K.Smooth=2]="Smooth",K[K.Phase=3]="Phase",K[K.Expand=4]="Expand",K[K.Solid=5]="Solid"})(i=e.TextEditorCursorBlinkingStyle||(e.TextEditorCursorBlinkingStyle={}));function s(K){switch(K){case"blink":return 1;case"smooth":return 2;case"phase":return 3;case"expand":return 4;case"solid":return 5}}var n;(function(K){K[K.Line=1]="Line",K[K.Block=2]="Block",K[K.Underline=3]="Underline",K[K.LineThin=4]="LineThin",K[K.BlockOutline=5]="BlockOutline",K[K.UnderlineThin=6]="UnderlineThin"})(n=e.TextEditorCursorStyle||(e.TextEditorCursorStyle={}));function o(K){switch(K){case n.Line:return"line";case n.Block:return"block";case n.Underline:return"underline";case n.LineThin:return"line-thin";case n.BlockOutline:return"block-outline";case n.UnderlineThin:return"underline-thin"}}e.cursorStyleToString=o;function v(K){switch(K){case"line":return n.Line;case"block":return n.Block;case"underline":return n.Underline;case"line-thin":return n.LineThin;case"block-outline":return n.BlockOutline;case"underline-thin":return n.UnderlineThin}}class m extends r{constructor(){super(125,[63,31])}compute(ie,ve,Me){const xe=["monaco-editor"];return ve.get(31)&&xe.push(ve.get(31)),ie.extraEditorClassName&&xe.push(ie.extraEditorClassName),ve.get(63)==="default"?xe.push("mouse-default"):ve.get(63)==="copy"&&xe.push("mouse-copy"),ve.get(98)&&xe.push("showUnused"),ve.get(123)&&xe.push("showDeprecated"),xe.join(" ")}}class _ extends f{constructor(){super(30,"emptySelectionClipboard",!0,{description:p.localize(6,null)})}compute(ie,ve,Me){return Me&&ie.emptySelectionClipboard}}class D extends k{constructor(){const ie={cursorMoveOnType:!0,seedSearchStringFromSelection:!0,autoFindInSelection:"never",globalFindClipboard:!1,addExtraSpaceOnTop:!0,loop:!0};super(33,"find",ie,{"editor.find.cursorMoveOnType":{type:"boolean",default:ie.cursorMoveOnType,description:p.localize(7,null)},"editor.find.seedSearchStringFromSelection":{type:"boolean",default:ie.seedSearchStringFromSelection,description:p.localize(8,null)},"editor.find.autoFindInSelection":{type:"string",enum:["never","always","multiline"],default:ie.autoFindInSelection,enumDescriptions:[p.localize(9,null),p.localize(10,null),p.localize(11,null)],description:p.localize(12,null)},"editor.find.globalFindClipboard":{type:"boolean",default:ie.globalFindClipboard,description:p.localize(13,null),included:R.isMacintosh},"editor.find.addExtraSpaceOnTop":{type:"boolean",default:ie.addExtraSpaceOnTop,description:p.localize(14,null)},"editor.find.loop":{type:"boolean",default:ie.loop,description:p.localize(15,null)}})}validate(ie){if(!ie||typeof ie!="object")return this.defaultValue;const ve=ie;return{cursorMoveOnType:l(ve.cursorMoveOnType,this.defaultValue.cursorMoveOnType),seedSearchStringFromSelection:l(ve.seedSearchStringFromSelection,this.defaultValue.seedSearchStringFromSelection),autoFindInSelection:typeof ie.autoFindInSelection=="boolean"?ie.autoFindInSelection?"always":"never":w(ve.autoFindInSelection,this.defaultValue.autoFindInSelection,["never","always","multiline"]),globalFindClipboard:l(ve.globalFindClipboard,this.defaultValue.globalFindClipboard),addExtraSpaceOnTop:l(ve.addExtraSpaceOnTop,this.defaultValue.addExtraSpaceOnTop),loop:l(ve.loop,this.defaultValue.loop)}}}class a extends k{constructor(){super(41,"fontLigatures",a.OFF,{anyOf:[{type:"boolean",description:p.localize(16,null)},{type:"string",description:p.localize(17,null)}],description:p.localize(18,null),default:!1})}validate(ie){return typeof ie=="undefined"?this.defaultValue:typeof ie=="string"?ie==="false"?a.OFF:ie==="true"?a.ON:ie:Boolean(ie)?a.ON:a.OFF}}e.EditorFontLigatures=a,a.OFF='"liga" off, "calt" off',a.ON='"liga" on, "calt" on';class T extends r{constructor(){super(40)}compute(ie,ve,Me){return ie.fontInfo}}class L extends I{constructor(){super(42,"fontSize",e.EDITOR_FONT_DEFAULTS.fontSize,{type:"number",minimum:6,maximum:100,default:e.EDITOR_FONT_DEFAULTS.fontSize,description:p.localize(19,null)})}validate(ie){let ve=u.float(ie,this.defaultValue);return ve===0?e.EDITOR_FONT_DEFAULTS.fontSize:u.clamp(ve,6,100)}compute(ie,ve,Me){return ie.fontInfo.fontSize}}class U extends k{constructor(){super(43,"fontWeight",e.EDITOR_FONT_DEFAULTS.fontWeight,{anyOf:[{type:"number",minimum:U.MINIMUM_VALUE,maximum:U.MAXIMUM_VALUE,errorMessage:p.localize(20,null)},{type:"string",pattern:"^(normal|bold|1000|[1-9][0-9]{0,2})$"},{enum:U.SUGGESTION_VALUES}],default:e.EDITOR_FONT_DEFAULTS.fontWeight,description:p.localize(21,null)})}validate(ie){return ie==="normal"||ie==="bold"?ie:String(c.clampedInt(ie,e.EDITOR_FONT_DEFAULTS.fontWeight,U.MINIMUM_VALUE,U.MAXIMUM_VALUE))}}U.SUGGESTION_VALUES=["normal","bold","100","200","300","400","500","600","700","800","900"],U.MINIMUM_VALUE=1,U.MAXIMUM_VALUE=1e3;class G extends k{constructor(){const ie={multiple:"peek",multipleDefinitions:"peek",multipleTypeDefinitions:"peek",multipleDeclarations:"peek",multipleImplementations:"peek",multipleReferences:"peek",alternativeDefinitionCommand:"editor.action.goToReferences",alternativeTypeDefinitionCommand:"editor.action.goToReferences",alternativeDeclarationCommand:"editor.action.goToReferences",alternativeImplementationCommand:"",alternativeReferenceCommand:""},ve={type:"string",enum:["peek","gotoAndPeek","goto"],default:ie.multiple,enumDescriptions:[p.localize(22,null),p.localize(23,null),p.localize(24,null)]},Me=["","editor.action.referenceSearch.trigger","editor.action.goToReferences","editor.action.peekImplementation","editor.action.goToImplementation","editor.action.peekTypeDefinition","editor.action.goToTypeDefinition","editor.action.peekDeclaration","editor.action.revealDeclaration","editor.action.peekDefinition","editor.action.revealDefinitionAside","editor.action.revealDefinition"];super(47,"gotoLocation",ie,{"editor.gotoLocation.multiple":{deprecationMessage:p.localize(25,null)},"editor.gotoLocation.multipleDefinitions":Object.assign({description:p.localize(26,null)},ve),"editor.gotoLocation.multipleTypeDefinitions":Object.assign({description:p.localize(27,null)},ve),"editor.gotoLocation.multipleDeclarations":Object.assign({description:p.localize(28,null)},ve),"editor.gotoLocation.multipleImplementations":Object.assign({description:p.localize(29,null)},ve),"editor.gotoLocation.multipleReferences":Object.assign({description:p.localize(30,null)},ve),"editor.gotoLocation.alternativeDefinitionCommand":{type:"string",default:ie.alternativeDefinitionCommand,enum:Me,description:p.localize(31,null)},"editor.gotoLocation.alternativeTypeDefinitionCommand":{type:"string",default:ie.alternativeTypeDefinitionCommand,enum:Me,description:p.localize(32,null)},"editor.gotoLocation.alternativeDeclarationCommand":{type:"string",default:ie.alternativeDeclarationCommand,enum:Me,description:p.localize(33,null)},"editor.gotoLocation.alternativeImplementationCommand":{type:"string",default:ie.alternativeImplementationCommand,enum:Me,description:p.localize(34,null)},"editor.gotoLocation.alternativeReferenceCommand":{type:"string",default:ie.alternativeReferenceCommand,enum:Me,description:p.localize(35,null)}})}validate(ie){var ve,Me,xe,Je,ke;if(!ie||typeof ie!="object")return this.defaultValue;const ye=ie;return{multiple:w(ye.multiple,this.defaultValue.multiple,["peek","gotoAndPeek","goto"]),multipleDefinitions:(ve=ye.multipleDefinitions)!==null&&ve!==void 0?ve:w(ye.multipleDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleTypeDefinitions:(Me=ye.multipleTypeDefinitions)!==null&&Me!==void 0?Me:w(ye.multipleTypeDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleDeclarations:(xe=ye.multipleDeclarations)!==null&&xe!==void 0?xe:w(ye.multipleDeclarations,"peek",["peek","gotoAndPeek","goto"]),multipleImplementations:(Je=ye.multipleImplementations)!==null&&Je!==void 0?Je:w(ye.multipleImplementations,"peek",["peek","gotoAndPeek","goto"]),multipleReferences:(ke=ye.multipleReferences)!==null&&ke!==void 0?ke:w(ye.multipleReferences,"peek",["peek","gotoAndPeek","goto"]),alternativeDefinitionCommand:S.string(ye.alternativeDefinitionCommand,this.defaultValue.alternativeDefinitionCommand),alternativeTypeDefinitionCommand:S.string(ye.alternativeTypeDefinitionCommand,this.defaultValue.alternativeTypeDefinitionCommand),alternativeDeclarationCommand:S.string(ye.alternativeDeclarationCommand,this.defaultValue.alternativeDeclarationCommand),alternativeImplementationCommand:S.string(ye.alternativeImplementationCommand,this.defaultValue.alternativeImplementationCommand),alternativeReferenceCommand:S.string(ye.alternativeReferenceCommand,this.defaultValue.alternativeReferenceCommand)}}}class ee extends k{constructor(){const ie={enabled:!0,delay:300,sticky:!0};super(50,"hover",ie,{"editor.hover.enabled":{type:"boolean",default:ie.enabled,description:p.localize(36,null)},"editor.hover.delay":{type:"number",default:ie.delay,description:p.localize(37,null)},"editor.hover.sticky":{type:"boolean",default:ie.sticky,description:p.localize(38,null)}})}validate(ie){if(!ie||typeof ie!="object")return this.defaultValue;const ve=ie;return{enabled:l(ve.enabled,this.defaultValue.enabled),delay:c.clampedInt(ve.delay,this.defaultValue.delay,0,1e4),sticky:l(ve.sticky,this.defaultValue.sticky)}}}var z;(function(K){K[K.None=0]="None",K[K.Text=1]="Text",K[K.Blocks=2]="Blocks"})(z=e.RenderMinimap||(e.RenderMinimap={}));class N extends r{constructor(){super(128,[46,55,35,62,90,57,58,92,115,118,119,120,2])}compute(ie,ve,Me){return N.computeLayout(ve,{memory:ie.memory,outerWidth:ie.outerWidth,outerHeight:ie.outerHeight,isDominatedByLongLines:ie.isDominatedByLongLines,lineHeight:ie.fontInfo.lineHeight,viewLineCount:ie.viewLineCount,lineNumbersDigitCount:ie.lineNumbersDigitCount,typicalHalfwidthCharacterWidth:ie.fontInfo.typicalHalfwidthCharacterWidth,maxDigitWidth:ie.fontInfo.maxDigitWidth,pixelRatio:ie.pixelRatio})}static computeContainedMinimapLineCount(ie){const ve=ie.height/ie.lineHeight,Me=ie.scrollBeyondLastLine?ve-1:0,xe=(ie.viewLineCount+Me)/(ie.pixelRatio*ie.height),Je=Math.floor(ie.viewLineCount/xe);return{typicalViewportLineCount:ve,extraLinesBeyondLastLine:Me,desiredRatio:xe,minimapLineCount:Je}}static _computeMinimapLayout(ie,ve){const Me=ie.outerWidth,xe=ie.outerHeight,Je=ie.pixelRatio;if(!ie.minimap.enabled)return{renderMinimap:0,minimapLeft:0,minimapWidth:0,minimapHeightIsEditorHeight:!1,minimapIsSampling:!1,minimapScale:1,minimapLineHeight:1,minimapCanvasInnerWidth:0,minimapCanvasInnerHeight:Math.floor(Je*xe),minimapCanvasOuterWidth:0,minimapCanvasOuterHeight:xe};const ke=ve.stableMinimapLayoutInput,ye=ke&&ie.outerHeight===ke.outerHeight&&ie.lineHeight===ke.lineHeight&&ie.typicalHalfwidthCharacterWidth===ke.typicalHalfwidthCharacterWidth&&ie.pixelRatio===ke.pixelRatio&&ie.scrollBeyondLastLine===ke.scrollBeyondLastLine&&ie.minimap.enabled===ke.minimap.enabled&&ie.minimap.side===ke.minimap.side&&ie.minimap.size===ke.minimap.size&&ie.minimap.showSlider===ke.minimap.showSlider&&ie.minimap.renderCharacters===ke.minimap.renderCharacters&&ie.minimap.maxColumn===ke.minimap.maxColumn&&ie.minimap.scale===ke.minimap.scale&&ie.verticalScrollbarWidth===ke.verticalScrollbarWidth&&ie.isViewportWrapping===ke.isViewportWrapping,Ae=ie.lineHeight,oe=ie.typicalHalfwidthCharacterWidth,ue=ie.scrollBeyondLastLine,fe=ie.minimap.renderCharacters;let we=Je>=2?Math.round(ie.minimap.scale*2):ie.minimap.scale;const q=ie.minimap.maxColumn,pe=ie.minimap.size,Se=ie.minimap.side,Te=ie.verticalScrollbarWidth,Oe=ie.viewLineCount,je=ie.remainingWidth,qe=ie.isViewportWrapping,Ze=fe?2:3;let nt=Math.floor(Je*xe);const ct=nt/Je;let Ee=!1,Ce=!1,ce=Ze*we,Q=we/Je,Be=1;if(pe==="fill"||pe==="fit"){const{typicalViewportLineCount:wt,extraLinesBeyondLastLine:Et,desiredRatio:vt,minimapLineCount:Bt}=N.computeContainedMinimapLineCount({viewLineCount:Oe,scrollBeyondLastLine:ue,height:xe,lineHeight:Ae,pixelRatio:Je});if(Oe/Bt>1)Ee=!0,Ce=!0,we=1,ce=1,Q=we/Je;else{let ht=!1,ut=we+1;if(pe==="fit"){const ft=Math.ceil((Oe+Et)*ce);qe&&ye&&je<=ve.stableFitRemainingWidth?(ht=!0,ut=ve.stableFitMaxMinimapScale):ht=ft>nt}if(pe==="fill"||ht){Ee=!0;const ft=we;ce=Math.min(Ae*Je,Math.max(1,Math.floor(1/vt))),qe&&ye&&je<=ve.stableFitRemainingWidth&&(ut=ve.stableFitMaxMinimapScale),we=Math.min(ut,Math.max(1,Math.floor(ce/Ze))),we>ft&&(Be=Math.min(2,we/ft)),Q=we/Je/Be,nt=Math.ceil(Math.max(wt,Oe+Et)*ce),qe?(ve.stableMinimapLayoutInput=ie,ve.stableFitRemainingWidth=je,ve.stableFitMaxMinimapScale=we):(ve.stableMinimapLayoutInput=null,ve.stableFitRemainingWidth=0)}}}const De=Math.floor(q*Q),Ke=Math.min(De,Math.max(0,Math.floor((je-Te-2)*Q/(oe+Q)))+e.MINIMAP_GUTTER_WIDTH);let et=Math.floor(Je*Ke);const tt=et/Je;et=Math.floor(et*Be);const st=fe?1:2,pt=Se==="left"?0:Me-Ke-Te;return{renderMinimap:st,minimapLeft:pt,minimapWidth:Ke,minimapHeightIsEditorHeight:Ee,minimapIsSampling:Ce,minimapScale:we,minimapLineHeight:ce,minimapCanvasInnerWidth:et,minimapCanvasInnerHeight:nt,minimapCanvasOuterWidth:tt,minimapCanvasOuterHeight:ct}}static computeLayout(ie,ve){const Me=ve.outerWidth|0,xe=ve.outerHeight|0,Je=ve.lineHeight|0,ke=ve.lineNumbersDigitCount|0,ye=ve.typicalHalfwidthCharacterWidth,Ae=ve.maxDigitWidth,oe=ve.pixelRatio,ue=ve.viewLineCount,fe=ie.get(120),we=fe==="inherit"?ie.get(119):fe,q=we==="inherit"?ie.get(115):we,pe=ie.get(118),Se=ie.get(2),Te=ve.isDominatedByLongLines,Oe=ie.get(46),je=ie.get(57).renderType!==0,qe=ie.get(58),Ze=ie.get(92),nt=ie.get(62),ct=ie.get(90),Ee=ct.verticalScrollbarSize,Ce=ct.verticalHasArrows,ce=ct.arrowSize,Q=ct.horizontalScrollbarSize,Be=ie.get(55),De=ie.get(35);let Ke;if(typeof Be=="string"&&/^\d+(\.\d+)?ch$/.test(Be)){const At=parseFloat(Be.substr(0,Be.length-2));Ke=c.clampedInt(At*ye,0,0,1e3)}else Ke=c.clampedInt(Be,0,0,1e3);De&&(Ke+=16);let et=0;if(je){const At=Math.max(ke,qe);et=Math.round(At*Ae)}let tt=0;Oe&&(tt=Je);let st=0,pt=st+tt,wt=pt+et,Et=wt+Ke;const vt=Me-tt-et-Ke;let Bt=!1,_t=!1,ht=-1;Se!==2&&(we==="inherit"&&Te?(Bt=!0,_t=!0):q==="on"||q==="bounded"?_t=!0:q==="wordWrapColumn"&&(ht=pe));const ut=N._computeMinimapLayout({outerWidth:Me,outerHeight:xe,lineHeight:Je,typicalHalfwidthCharacterWidth:ye,pixelRatio:oe,scrollBeyondLastLine:Ze,minimap:nt,verticalScrollbarWidth:Ee,viewLineCount:ue,remainingWidth:vt,isViewportWrapping:_t},ve.memory||new E);ut.renderMinimap!==0&&ut.minimapLeft===0&&(st+=ut.minimapWidth,pt+=ut.minimapWidth,wt+=ut.minimapWidth,Et+=ut.minimapWidth);const ft=vt-ut.minimapWidth,Ht=Math.max(1,Math.floor((ft-Ee-2)/ye)),kt=Ce?ce:0;return _t&&(ht=Math.max(1,Ht),q==="bounded"&&(ht=Math.min(ht,pe))),{width:Me,height:xe,glyphMarginLeft:st,glyphMarginWidth:tt,lineNumbersLeft:pt,lineNumbersWidth:et,decorationsLeft:wt,decorationsWidth:Ke,contentLeft:Et,contentWidth:ft,minimap:ut,viewportColumn:Ht,isWordWrapMinified:Bt,isViewportWrapping:_t,wrappingColumn:ht,verticalScrollbarWidth:Ee,horizontalScrollbarHeight:Q,overviewRuler:{top:kt,width:Ee,height:xe-2*kt,right:0}}}}e.EditorLayoutInfoComputer=N;class W extends k{constructor(){const ie={enabled:!0};super(54,"lightbulb",ie,{"editor.lightbulb.enabled":{type:"boolean",default:ie.enabled,description:p.localize(39,null)}})}validate(ie){return!ie||typeof ie!="object"?this.defaultValue:{enabled:l(ie.enabled,this.defaultValue.enabled)}}}class M extends k{constructor(){const ie={enabled:!0,fontSize:0,fontFamily:e.EDITOR_FONT_DEFAULTS.fontFamily};super(124,"inlayHints",ie,{"editor.inlayHints.enabled":{type:"boolean",default:ie.enabled,description:p.localize(40,null)},"editor.inlayHints.fontSize":{type:"number",default:ie.fontSize,markdownDescription:p.localize(41,null)},"editor.inlayHints.fontFamily":{type:"string",default:ie.fontFamily,description:p.localize(42,null)}})}validate(ie){if(!ie||typeof ie!="object")return this.defaultValue;const ve=ie;return{enabled:l(ve.enabled,this.defaultValue.enabled),fontSize:c.clampedInt(ve.fontSize,this.defaultValue.fontSize,0,100),fontFamily:S.string(ve.fontFamily,this.defaultValue.fontFamily)}}}class j extends u{constructor(){super(56,"lineHeight",e.EDITOR_FONT_DEFAULTS.lineHeight,ie=>u.clamp(ie,0,150),{markdownDescription:p.localize(43,null)})}compute(ie,ve,Me){return ie.fontInfo.lineHeight}}class O extends k{constructor(){const ie={enabled:!0,size:"proportional",side:"right",showSlider:"mouseover",renderCharacters:!0,maxColumn:120,scale:1};super(62,"minimap",ie,{"editor.minimap.enabled":{type:"boolean",default:ie.enabled,description:p.localize(44,null)},"editor.minimap.size":{type:"string",enum:["proportional","fill","fit"],enumDescriptions:[p.localize(45,null),p.localize(46,null),p.localize(47,null)],default:ie.size,description:p.localize(48,null)},"editor.minimap.side":{type:"string",enum:["left","right"],default:ie.side,description:p.localize(49,null)},"editor.minimap.showSlider":{type:"string",enum:["always","mouseover"],default:ie.showSlider,description:p.localize(50,null)},"editor.minimap.scale":{type:"number",default:ie.scale,minimum:1,maximum:3,enum:[1,2,3],description:p.localize(51,null)},"editor.minimap.renderCharacters":{type:"boolean",default:ie.renderCharacters,description:p.localize(52,null)},"editor.minimap.maxColumn":{type:"number",default:ie.maxColumn,description:p.localize(53,null)}})}validate(ie){if(!ie||typeof ie!="object")return this.defaultValue;const ve=ie;return{enabled:l(ve.enabled,this.defaultValue.enabled),size:w(ve.size,this.defaultValue.size,["proportional","fill","fit"]),side:w(ve.side,this.defaultValue.side,["right","left"]),showSlider:w(ve.showSlider,this.defaultValue.showSlider,["always","mouseover"]),renderCharacters:l(ve.renderCharacters,this.defaultValue.renderCharacters),scale:c.clampedInt(ve.scale,1,1,3),maxColumn:c.clampedInt(ve.maxColumn,this.defaultValue.maxColumn,1,1e4)}}}function F(K){return K==="ctrlCmd"?R.isMacintosh?"metaKey":"ctrlKey":"altKey"}class B extends k{constructor(){super(72,"padding",{top:0,bottom:0},{"editor.padding.top":{type:"number",default:0,minimum:0,maximum:1e3,description:p.localize(54,null)},"editor.padding.bottom":{type:"number",default:0,minimum:0,maximum:1e3,description:p.localize(55,null)}})}validate(ie){if(!ie||typeof ie!="object")return this.defaultValue;const ve=ie;return{top:c.clampedInt(ve.top,0,0,1e3),bottom:c.clampedInt(ve.bottom,0,0,1e3)}}}class $ extends k{constructor(){const ie={enabled:!0,cycle:!1};super(73,"parameterHints",ie,{"editor.parameterHints.enabled":{type:"boolean",default:ie.enabled,description:p.localize(56,null)},"editor.parameterHints.cycle":{type:"boolean",default:ie.cycle,description:p.localize(57,null)}})}validate(ie){if(!ie||typeof ie!="object")return this.defaultValue;const ve=ie;return{enabled:l(ve.enabled,this.defaultValue.enabled),cycle:l(ve.cycle,this.defaultValue.cycle)}}}class Y extends r{constructor(){super(126)}compute(ie,ve,Me){return ie.pixelRatio}}class le extends k{constructor(){const ie={other:!0,comments:!1,strings:!1};super(76,"quickSuggestions",ie,{anyOf:[{type:"boolean"},{type:"object",properties:{strings:{type:"boolean",default:ie.strings,description:p.localize(58,null)},comments:{type:"boolean",default:ie.comments,description:p.localize(59,null)},other:{type:"boolean",default:ie.other,description:p.localize(60,null)}}}],default:ie,description:p.localize(61,null)});this.defaultValue=ie}validate(ie){if(typeof ie=="boolean")return ie;if(ie&&typeof ie=="object"){const ve=ie,Me={other:l(ve.other,this.defaultValue.other),comments:l(ve.comments,this.defaultValue.comments),strings:l(ve.strings,this.defaultValue.strings)};return Me.other&&Me.comments&&Me.strings?!0:!Me.other&&!Me.comments&&!Me.strings?!1:Me}return this.defaultValue}}var be;(function(K){K[K.Off=0]="Off",K[K.On=1]="On",K[K.Relative=2]="Relative",K[K.Interval=3]="Interval",K[K.Custom=4]="Custom"})(be=e.RenderLineNumbersType||(e.RenderLineNumbersType={}));class Le extends k{constructor(){super(57,"lineNumbers",{renderType:1,renderFn:null},{type:"string",enum:["off","on","relative","interval"],enumDescriptions:[p.localize(62,null),p.localize(63,null),p.localize(64,null),p.localize(65,null)],default:"on",description:p.localize(66,null)})}validate(ie){let ve=this.defaultValue.renderType,Me=this.defaultValue.renderFn;return typeof ie!="undefined"&&(typeof ie=="function"?(ve=4,Me=ie):ie==="interval"?ve=3:ie==="relative"?ve=2:ie==="on"?ve=1:ve=0),{renderType:ve,renderFn:Me}}}function Ie(K){const ie=K.get(85);return ie==="editable"?K.get(78):ie!=="on"}e.filterValidationDecorations=Ie;class Ue extends k{constructor(){const ie=[],ve={type:"number",description:p.localize(67,null)};super(89,"rulers",ie,{type:"array",items:{anyOf:[ve,{type:["object"],properties:{column:ve,color:{type:"string",description:p.localize(68,null),format:"color-hex"}}}]},default:ie,description:p.localize(69,null)})}validate(ie){if(Array.isArray(ie)){let ve=[];for(let Me of ie)if(typeof Me=="number")ve.push({column:c.clampedInt(Me,0,0,1e4),color:null});else if(Me&&typeof Me=="object"){const xe=Me;ve.push({column:c.clampedInt(xe.column,0,0,1e4),color:xe.color})}return ve.sort((Me,xe)=>Me.column-xe.column),ve}return this.defaultValue}}function Qe(K,ie){if(typeof K!="string")return ie;switch(K){case"hidden":return 2;case"visible":return 3;default:return 1}}class ze extends k{constructor(){super(90,"scrollbar",{vertical:1,horizontal:1,arrowSize:11,useShadows:!0,verticalHasArrows:!1,horizontalHasArrows:!1,horizontalScrollbarSize:12,horizontalSliderSize:12,verticalScrollbarSize:14,verticalSliderSize:14,handleMouseWheel:!0,alwaysConsumeMouseWheel:!0,scrollByPage:!1})}validate(ie){if(!ie||typeof ie!="object")return this.defaultValue;const ve=ie,Me=c.clampedInt(ve.horizontalScrollbarSize,this.defaultValue.horizontalScrollbarSize,0,1e3),xe=c.clampedInt(ve.verticalScrollbarSize,this.defaultValue.verticalScrollbarSize,0,1e3);return{arrowSize:c.clampedInt(ve.arrowSize,this.defaultValue.arrowSize,0,1e3),vertical:Qe(ve.vertical,this.defaultValue.vertical),horizontal:Qe(ve.horizontal,this.defaultValue.horizontal),useShadows:l(ve.useShadows,this.defaultValue.useShadows),verticalHasArrows:l(ve.verticalHasArrows,this.defaultValue.verticalHasArrows),horizontalHasArrows:l(ve.horizontalHasArrows,this.defaultValue.horizontalHasArrows),handleMouseWheel:l(ve.handleMouseWheel,this.defaultValue.handleMouseWheel),alwaysConsumeMouseWheel:l(ve.alwaysConsumeMouseWheel,this.defaultValue.alwaysConsumeMouseWheel),horizontalScrollbarSize:Me,horizontalSliderSize:c.clampedInt(ve.horizontalSliderSize,Me,0,1e3),verticalScrollbarSize:xe,verticalSliderSize:c.clampedInt(ve.verticalSliderSize,xe,0,1e3),scrollByPage:l(ve.scrollByPage,this.defaultValue.scrollByPage)}}}class Ge extends k{constructor(){const ie={enabled:!1,mode:"prefix"};super(52,"inlineSuggest",ie,{"editor.inlineSuggest.enabled":{type:"boolean",default:ie.enabled,description:p.localize(70,null)},"editor.inlineSuggest.mode":{type:"string",enum:["prefix","subwordDiff"],enumDescriptions:[p.localize(71,null),p.localize(72,null)],default:ie.mode,description:p.localize(73,null)}})}validate(ie){if(!ie||typeof ie!="object")return this.defaultValue;const ve=ie;return{enabled:l(ve.enabled,this.defaultValue.enabled),mode:w(ve.mode,this.defaultValue.mode,["prefix","subwordDiff"])}}}class V extends k{constructor(){const ie={insertMode:"insert",filterGraceful:!0,snippetsPreventQuickSuggestions:!0,localityBonus:!1,shareSuggestSelections:!1,showIcons:!0,showStatusBar:!1,preview:!1,previewMode:"subwordDiff",showInlineDetails:!0,showMethods:!0,showFunctions:!0,showConstructors:!0,showDeprecated:!0,showFields:!0,showVariables:!0,showClasses:!0,showStructs:!0,showInterfaces:!0,showModules:!0,showProperties:!0,showEvents:!0,showOperators:!0,showUnits:!0,showValues:!0,showConstants:!0,showEnums:!0,showEnumMembers:!0,showKeywords:!0,showWords:!0,showColors:!0,showFiles:!0,showReferences:!0,showFolders:!0,showTypeParameters:!0,showSnippets:!0,showUsers:!0,showIssues:!0};super(104,"suggest",ie,{"editor.suggest.insertMode":{type:"string",enum:["insert","replace"],enumDescriptions:[p.localize(74,null),p.localize(75,null)],default:ie.insertMode,description:p.localize(76,null)},"editor.suggest.filterGraceful":{type:"boolean",default:ie.filterGraceful,description:p.localize(77,null)},"editor.suggest.localityBonus":{type:"boolean",default:ie.localityBonus,description:p.localize(78,null)},"editor.suggest.shareSuggestSelections":{type:"boolean",default:ie.shareSuggestSelections,markdownDescription:p.localize(79,null)},"editor.suggest.snippetsPreventQuickSuggestions":{type:"boolean",default:ie.snippetsPreventQuickSuggestions,description:p.localize(80,null)},"editor.suggest.showIcons":{type:"boolean",default:ie.showIcons,description:p.localize(81,null)},"editor.suggest.showStatusBar":{type:"boolean",default:ie.showStatusBar,description:p.localize(82,null)},"editor.suggest.preview":{type:"boolean",default:ie.preview,description:p.localize(83,null)},"editor.suggest.previewMode":{type:"string",enum:["prefix","subwordDiff"],enumDescriptions:[p.localize(84,null),p.localize(85,null)],default:ie.previewMode,description:p.localize(86,null)},"editor.suggest.showInlineDetails":{type:"boolean",default:ie.showInlineDetails,description:p.localize(87,null)},"editor.suggest.maxVisibleSuggestions":{type:"number",deprecationMessage:p.localize(88,null)},"editor.suggest.filteredTypes":{type:"object",deprecationMessage:p.localize(89,null)},"editor.suggest.showMethods":{type:"boolean",default:!0,markdownDescription:p.localize(90,null)},"editor.suggest.showFunctions":{type:"boolean",default:!0,markdownDescription:p.localize(91,null)},"editor.suggest.showConstructors":{type:"boolean",default:!0,markdownDescription:p.localize(92,null)},"editor.suggest.showDeprecated":{type:"boolean",default:!0,markdownDescription:p.localize(93,null)},"editor.suggest.showFields":{type:"boolean",default:!0,markdownDescription:p.localize(94,null)},"editor.suggest.showVariables":{type:"boolean",default:!0,markdownDescription:p.localize(95,null)},"editor.suggest.showClasses":{type:"boolean",default:!0,markdownDescription:p.localize(96,null)},"editor.suggest.showStructs":{type:"boolean",default:!0,markdownDescription:p.localize(97,null)},"editor.suggest.showInterfaces":{type:"boolean",default:!0,markdownDescription:p.localize(98,null)},"editor.suggest.showModules":{type:"boolean",default:!0,markdownDescription:p.localize(99,null)},"editor.suggest.showProperties":{type:"boolean",default:!0,markdownDescription:p.localize(100,null)},"editor.suggest.showEvents":{type:"boolean",default:!0,markdownDescription:p.localize(101,null)},"editor.suggest.showOperators":{type:"boolean",default:!0,markdownDescription:p.localize(102,null)},"editor.suggest.showUnits":{type:"boolean",default:!0,markdownDescription:p.localize(103,null)},"editor.suggest.showValues":{type:"boolean",default:!0,markdownDescription:p.localize(104,null)},"editor.suggest.showConstants":{type:"boolean",default:!0,markdownDescription:p.localize(105,null)},"editor.suggest.showEnums":{type:"boolean",default:!0,markdownDescription:p.localize(106,null)},"editor.suggest.showEnumMembers":{type:"boolean",default:!0,markdownDescription:p.localize(107,null)},"editor.suggest.showKeywords":{type:"boolean",default:!0,markdownDescription:p.localize(108,null)},"editor.suggest.showWords":{type:"boolean",default:!0,markdownDescription:p.localize(109,null)},"editor.suggest.showColors":{type:"boolean",default:!0,markdownDescription:p.localize(110,null)},"editor.suggest.showFiles":{type:"boolean",default:!0,markdownDescription:p.localize(111,null)},"editor.suggest.showReferences":{type:"boolean",default:!0,markdownDescription:p.localize(112,null)},"editor.suggest.showCustomcolors":{type:"boolean",default:!0,markdownDescription:p.localize(113,null)},"editor.suggest.showFolders":{type:"boolean",default:!0,markdownDescription:p.localize(114,null)},"editor.suggest.showTypeParameters":{type:"boolean",default:!0,markdownDescription:p.localize(115,null)},"editor.suggest.showSnippets":{type:"boolean",default:!0,markdownDescription:p.localize(116,null)},"editor.suggest.showUsers":{type:"boolean",default:!0,markdownDescription:p.localize(117,null)},"editor.suggest.showIssues":{type:"boolean",default:!0,markdownDescription:p.localize(118,null)}})}validate(ie){if(!ie||typeof ie!="object")return this.defaultValue;const ve=ie;return{insertMode:w(ve.insertMode,this.defaultValue.insertMode,["insert","replace"]),filterGraceful:l(ve.filterGraceful,this.defaultValue.filterGraceful),snippetsPreventQuickSuggestions:l(ve.snippetsPreventQuickSuggestions,this.defaultValue.filterGraceful),localityBonus:l(ve.localityBonus,this.defaultValue.localityBonus),shareSuggestSelections:l(ve.shareSuggestSelections,this.defaultValue.shareSuggestSelections),showIcons:l(ve.showIcons,this.defaultValue.showIcons),showStatusBar:l(ve.showStatusBar,this.defaultValue.showStatusBar),preview:l(ve.preview,this.defaultValue.preview),previewMode:w(ve.previewMode,this.defaultValue.previewMode,["prefix","subwordDiff"]),showInlineDetails:l(ve.showInlineDetails,this.defaultValue.showInlineDetails),showMethods:l(ve.showMethods,this.defaultValue.showMethods),showFunctions:l(ve.showFunctions,this.defaultValue.showFunctions),showConstructors:l(ve.showConstructors,this.defaultValue.showConstructors),showDeprecated:l(ve.showDeprecated,this.defaultValue.showDeprecated),showFields:l(ve.showFields,this.defaultValue.showFields),showVariables:l(ve.showVariables,this.defaultValue.showVariables),showClasses:l(ve.showClasses,this.defaultValue.showClasses),showStructs:l(ve.showStructs,this.defaultValue.showStructs),showInterfaces:l(ve.showInterfaces,this.defaultValue.showInterfaces),showModules:l(ve.showModules,this.defaultValue.showModules),showProperties:l(ve.showProperties,this.defaultValue.showProperties),showEvents:l(ve.showEvents,this.defaultValue.showEvents),showOperators:l(ve.showOperators,this.defaultValue.showOperators),showUnits:l(ve.showUnits,this.defaultValue.showUnits),showValues:l(ve.showValues,this.defaultValue.showValues),showConstants:l(ve.showConstants,this.defaultValue.showConstants),showEnums:l(ve.showEnums,this.defaultValue.showEnums),showEnumMembers:l(ve.showEnumMembers,this.defaultValue.showEnumMembers),showKeywords:l(ve.showKeywords,this.defaultValue.showKeywords),showWords:l(ve.showWords,this.defaultValue.showWords),showColors:l(ve.showColors,this.defaultValue.showColors),showFiles:l(ve.showFiles,this.defaultValue.showFiles),showReferences:l(ve.showReferences,this.defaultValue.showReferences),showFolders:l(ve.showFolders,this.defaultValue.showFolders),showTypeParameters:l(ve.showTypeParameters,this.defaultValue.showTypeParameters),showSnippets:l(ve.showSnippets,this.defaultValue.showSnippets),showUsers:l(ve.showUsers,this.defaultValue.showUsers),showIssues:l(ve.showIssues,this.defaultValue.showIssues)}}}class Z extends k{constructor(){super(100,"smartSelect",{selectLeadingAndTrailingWhitespace:!0},{"editor.smartSelect.selectLeadingAndTrailingWhitespace":{description:p.localize(119,null),default:!0,type:"boolean"}})}validate(ie){return!ie||typeof ie!="object"?this.defaultValue:{selectLeadingAndTrailingWhitespace:l(ie.selectLeadingAndTrailingWhitespace,this.defaultValue.selectLeadingAndTrailingWhitespace)}}}class ne extends r{constructor(){super(127,[78])}compute(ie,ve,Me){return ve.get(78)?!0:ie.tabFocusMode}}var se;(function(K){K[K.None=0]="None",K[K.Same=1]="Same",K[K.Indent=2]="Indent",K[K.DeepIndent=3]="DeepIndent"})(se=e.WrappingIndent||(e.WrappingIndent={}));function J(K){switch(K){case"none":return 0;case"same":return 1;case"indent":return 2;case"deepIndent":return 3}}class ae extends r{constructor(){super(129,[128])}compute(ie,ve,Me){const xe=ve.get(128);return{isDominatedByLongLines:ie.isDominatedByLongLines,isWordWrapMinified:xe.isWordWrapMinified,isViewportWrapping:xe.isViewportWrapping,wrappingColumn:xe.wrappingColumn}}}const he="Consolas, 'Courier New', monospace",Fe="Menlo, Monaco, 'Courier New', monospace",He="'Droid Sans Mono', 'monospace', monospace, 'Droid Sans Fallback'";e.EDITOR_FONT_DEFAULTS={fontFamily:R.isMacintosh?Fe:R.isLinux?He:he,fontWeight:"normal",fontSize:R.isMacintosh?12:14,lineHeight:0,letterSpacing:0},e.EDITOR_MODEL_DEFAULTS={tabSize:4,indentSize:4,insertSpaces:!0,detectIndentation:!0,trimAutoWhitespace:!0,largeFileOptimizations:!0},e.editorOptionsRegistry=[];function _e(K){return e.editorOptionsRegistry[K.id]=K,K}var Ye;(function(K){K[K.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",K[K.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",K[K.accessibilitySupport=2]="accessibilitySupport",K[K.accessibilityPageSize=3]="accessibilityPageSize",K[K.ariaLabel=4]="ariaLabel",K[K.autoClosingBrackets=5]="autoClosingBrackets",K[K.autoClosingDelete=6]="autoClosingDelete",K[K.autoClosingOvertype=7]="autoClosingOvertype",K[K.autoClosingQuotes=8]="autoClosingQuotes",K[K.autoIndent=9]="autoIndent",K[K.automaticLayout=10]="automaticLayout",K[K.autoSurround=11]="autoSurround",K[K.codeLens=12]="codeLens",K[K.codeLensFontFamily=13]="codeLensFontFamily",K[K.codeLensFontSize=14]="codeLensFontSize",K[K.colorDecorators=15]="colorDecorators",K[K.columnSelection=16]="columnSelection",K[K.comments=17]="comments",K[K.contextmenu=18]="contextmenu",K[K.copyWithSyntaxHighlighting=19]="copyWithSyntaxHighlighting",K[K.cursorBlinking=20]="cursorBlinking",K[K.cursorSmoothCaretAnimation=21]="cursorSmoothCaretAnimation",K[K.cursorStyle=22]="cursorStyle",K[K.cursorSurroundingLines=23]="cursorSurroundingLines",K[K.cursorSurroundingLinesStyle=24]="cursorSurroundingLinesStyle",K[K.cursorWidth=25]="cursorWidth",K[K.disableLayerHinting=26]="disableLayerHinting",K[K.disableMonospaceOptimizations=27]="disableMonospaceOptimizations",K[K.domReadOnly=28]="domReadOnly",K[K.dragAndDrop=29]="dragAndDrop",K[K.emptySelectionClipboard=30]="emptySelectionClipboard",K[K.extraEditorClassName=31]="extraEditorClassName",K[K.fastScrollSensitivity=32]="fastScrollSensitivity",K[K.find=33]="find",K[K.fixedOverflowWidgets=34]="fixedOverflowWidgets",K[K.folding=35]="folding",K[K.foldingStrategy=36]="foldingStrategy",K[K.foldingHighlight=37]="foldingHighlight",K[K.unfoldOnClickAfterEndOfLine=38]="unfoldOnClickAfterEndOfLine",K[K.fontFamily=39]="fontFamily",K[K.fontInfo=40]="fontInfo",K[K.fontLigatures=41]="fontLigatures",K[K.fontSize=42]="fontSize",K[K.fontWeight=43]="fontWeight",K[K.formatOnPaste=44]="formatOnPaste",K[K.formatOnType=45]="formatOnType",K[K.glyphMargin=46]="glyphMargin",K[K.gotoLocation=47]="gotoLocation",K[K.hideCursorInOverviewRuler=48]="hideCursorInOverviewRuler",K[K.highlightActiveIndentGuide=49]="highlightActiveIndentGuide",K[K.hover=50]="hover",K[K.inDiffEditor=51]="inDiffEditor",K[K.inlineSuggest=52]="inlineSuggest",K[K.letterSpacing=53]="letterSpacing",K[K.lightbulb=54]="lightbulb",K[K.lineDecorationsWidth=55]="lineDecorationsWidth",K[K.lineHeight=56]="lineHeight",K[K.lineNumbers=57]="lineNumbers",K[K.lineNumbersMinChars=58]="lineNumbersMinChars",K[K.linkedEditing=59]="linkedEditing",K[K.links=60]="links",K[K.matchBrackets=61]="matchBrackets",K[K.minimap=62]="minimap",K[K.mouseStyle=63]="mouseStyle",K[K.mouseWheelScrollSensitivity=64]="mouseWheelScrollSensitivity",K[K.mouseWheelZoom=65]="mouseWheelZoom",K[K.multiCursorMergeOverlapping=66]="multiCursorMergeOverlapping",K[K.multiCursorModifier=67]="multiCursorModifier",K[K.multiCursorPaste=68]="multiCursorPaste",K[K.occurrencesHighlight=69]="occurrencesHighlight",K[K.overviewRulerBorder=70]="overviewRulerBorder",K[K.overviewRulerLanes=71]="overviewRulerLanes",K[K.padding=72]="padding",K[K.parameterHints=73]="parameterHints",K[K.peekWidgetDefaultFocus=74]="peekWidgetDefaultFocus",K[K.definitionLinkOpensInPeek=75]="definitionLinkOpensInPeek",K[K.quickSuggestions=76]="quickSuggestions",K[K.quickSuggestionsDelay=77]="quickSuggestionsDelay",K[K.readOnly=78]="readOnly",K[K.renameOnType=79]="renameOnType",K[K.renderControlCharacters=80]="renderControlCharacters",K[K.renderIndentGuides=81]="renderIndentGuides",K[K.renderFinalNewline=82]="renderFinalNewline",K[K.renderLineHighlight=83]="renderLineHighlight",K[K.renderLineHighlightOnlyWhenFocus=84]="renderLineHighlightOnlyWhenFocus",K[K.renderValidationDecorations=85]="renderValidationDecorations",K[K.renderWhitespace=86]="renderWhitespace",K[K.revealHorizontalRightPadding=87]="revealHorizontalRightPadding",K[K.roundedSelection=88]="roundedSelection",K[K.rulers=89]="rulers",K[K.scrollbar=90]="scrollbar",K[K.scrollBeyondLastColumn=91]="scrollBeyondLastColumn",K[K.scrollBeyondLastLine=92]="scrollBeyondLastLine",K[K.scrollPredominantAxis=93]="scrollPredominantAxis",K[K.selectionClipboard=94]="selectionClipboard",K[K.selectionHighlight=95]="selectionHighlight",K[K.selectOnLineNumbers=96]="selectOnLineNumbers",K[K.showFoldingControls=97]="showFoldingControls",K[K.showUnused=98]="showUnused",K[K.snippetSuggestions=99]="snippetSuggestions",K[K.smartSelect=100]="smartSelect",K[K.smoothScrolling=101]="smoothScrolling",K[K.stickyTabStops=102]="stickyTabStops",K[K.stopRenderingLineAfter=103]="stopRenderingLineAfter",K[K.suggest=104]="suggest",K[K.suggestFontSize=105]="suggestFontSize",K[K.suggestLineHeight=106]="suggestLineHeight",K[K.suggestOnTriggerCharacters=107]="suggestOnTriggerCharacters",K[K.suggestSelection=108]="suggestSelection",K[K.tabCompletion=109]="tabCompletion",K[K.tabIndex=110]="tabIndex",K[K.unusualLineTerminators=111]="unusualLineTerminators",K[K.useShadowDOM=112]="useShadowDOM",K[K.useTabStops=113]="useTabStops",K[K.wordSeparators=114]="wordSeparators",K[K.wordWrap=115]="wordWrap",K[K.wordWrapBreakAfterCharacters=116]="wordWrapBreakAfterCharacters",K[K.wordWrapBreakBeforeCharacters=117]="wordWrapBreakBeforeCharacters",K[K.wordWrapColumn=118]="wordWrapColumn",K[K.wordWrapOverride1=119]="wordWrapOverride1",K[K.wordWrapOverride2=120]="wordWrapOverride2",K[K.wrappingIndent=121]="wrappingIndent",K[K.wrappingStrategy=122]="wrappingStrategy",K[K.showDeprecated=123]="showDeprecated",K[K.inlayHints=124]="inlayHints",K[K.editorClassName=125]="editorClassName",K[K.pixelRatio=126]="pixelRatio",K[K.tabFocusMode=127]="tabFocusMode",K[K.layoutInfo=128]="layoutInfo",K[K.wrappingInfo=129]="wrappingInfo"})(Ye=e.EditorOption||(e.EditorOption={})),e.EditorOptions={acceptSuggestionOnCommitCharacter:_e(new f(0,"acceptSuggestionOnCommitCharacter",!0,{markdownDescription:p.localize(120,null)})),acceptSuggestionOnEnter:_e(new b(1,"acceptSuggestionOnEnter","on",["on","smart","off"],{markdownEnumDescriptions:["",p.localize(121,null),""],markdownDescription:p.localize(122,null)})),accessibilitySupport:_e(new g),accessibilityPageSize:_e(new c(3,"accessibilityPageSize",10,1,1073741824,{description:p.localize(123,null)})),ariaLabel:_e(new S(4,"ariaLabel",p.localize(124,null))),autoClosingBrackets:_e(new b(5,"autoClosingBrackets","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",p.localize(125,null),p.localize(126,null),""],description:p.localize(127,null)})),autoClosingDelete:_e(new b(6,"autoClosingDelete","auto",["always","auto","never"],{enumDescriptions:["",p.localize(128,null),""],description:p.localize(129,null)})),autoClosingOvertype:_e(new b(7,"autoClosingOvertype","auto",["always","auto","never"],{enumDescriptions:["",p.localize(130,null),""],description:p.localize(131,null)})),autoClosingQuotes:_e(new b(8,"autoClosingQuotes","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",p.localize(132,null),p.localize(133,null),""],description:p.localize(134,null)})),autoIndent:_e(new d(9,"autoIndent",4,"full",["none","keep","brackets","advanced","full"],h,{enumDescriptions:[p.localize(135,null),p.localize(136,null),p.localize(137,null),p.localize(138,null),p.localize(139,null)],description:p.localize(140,null)})),automaticLayout:_e(new f(10,"automaticLayout",!1)),autoSurround:_e(new b(11,"autoSurround","languageDefined",["languageDefined","quotes","brackets","never"],{enumDescriptions:[p.localize(141,null),p.localize(142,null),p.localize(143,null),""],description:p.localize(144,null)})),stickyTabStops:_e(new f(102,"stickyTabStops",!1,{description:p.localize(145,null)})),codeLens:_e(new f(12,"codeLens",!0,{description:p.localize(146,null)})),codeLensFontFamily:_e(new S(13,"codeLensFontFamily","",{description:p.localize(147,null)})),codeLensFontSize:_e(new c(14,"codeLensFontSize",0,0,100,{type:"number",default:0,minimum:0,maximum:100,markdownDescription:p.localize(148,null)})),colorDecorators:_e(new f(15,"colorDecorators",!0,{description:p.localize(149,null)})),columnSelection:_e(new f(16,"columnSelection",!1,{description:p.localize(150,null)})),comments:_e(new t),contextmenu:_e(new f(18,"contextmenu",!0)),copyWithSyntaxHighlighting:_e(new f(19,"copyWithSyntaxHighlighting",!0,{description:p.localize(151,null)})),cursorBlinking:_e(new d(20,"cursorBlinking",1,"blink",["blink","smooth","phase","expand","solid"],s,{description:p.localize(152,null)})),cursorSmoothCaretAnimation:_e(new f(21,"cursorSmoothCaretAnimation",!1,{description:p.localize(153,null)})),cursorStyle:_e(new d(22,"cursorStyle",n.Line,"line",["line","block","underline","line-thin","block-outline","underline-thin"],v,{description:p.localize(154,null)})),cursorSurroundingLines:_e(new c(23,"cursorSurroundingLines",0,0,1073741824,{description:p.localize(155,null)})),cursorSurroundingLinesStyle:_e(new b(24,"cursorSurroundingLinesStyle","default",["default","all"],{enumDescriptions:[p.localize(156,null),p.localize(157,null)],description:p.localize(158,null)})),cursorWidth:_e(new c(25,"cursorWidth",0,0,1073741824,{markdownDescription:p.localize(159,null)})),disableLayerHinting:_e(new f(26,"disableLayerHinting",!1)),disableMonospaceOptimizations:_e(new f(27,"disableMonospaceOptimizations",!1)),domReadOnly:_e(new f(28,"domReadOnly",!1)),dragAndDrop:_e(new f(29,"dragAndDrop",!0,{description:p.localize(160,null)})),emptySelectionClipboard:_e(new _),extraEditorClassName:_e(new S(31,"extraEditorClassName","")),fastScrollSensitivity:_e(new u(32,"fastScrollSensitivity",5,K=>K<=0?5:K,{markdownDescription:p.localize(161,null)})),find:_e(new D),fixedOverflowWidgets:_e(new f(34,"fixedOverflowWidgets",!1)),folding:_e(new f(35,"folding",!0,{description:p.localize(162,null)})),foldingStrategy:_e(new b(36,"foldingStrategy","auto",["auto","indentation"],{enumDescriptions:[p.localize(163,null),p.localize(164,null)],description:p.localize(165,null)})),foldingHighlight:_e(new f(37,"foldingHighlight",!0,{description:p.localize(166,null)})),unfoldOnClickAfterEndOfLine:_e(new f(38,"unfoldOnClickAfterEndOfLine",!1,{description:p.localize(167,null)})),fontFamily:_e(new S(39,"fontFamily",e.EDITOR_FONT_DEFAULTS.fontFamily,{description:p.localize(168,null)})),fontInfo:_e(new T),fontLigatures2:_e(new a),fontSize:_e(new L),fontWeight:_e(new U),formatOnPaste:_e(new f(44,"formatOnPaste",!1,{description:p.localize(169,null)})),formatOnType:_e(new f(45,"formatOnType",!1,{description:p.localize(170,null)})),glyphMargin:_e(new f(46,"glyphMargin",!0,{description:p.localize(171,null)})),gotoLocation:_e(new G),hideCursorInOverviewRuler:_e(new f(48,"hideCursorInOverviewRuler",!1,{description:p.localize(172,null)})),highlightActiveIndentGuide:_e(new f(49,"highlightActiveIndentGuide",!0,{description:p.localize(173,null)})),hover:_e(new ee),inDiffEditor:_e(new f(51,"inDiffEditor",!1)),letterSpacing:_e(new u(53,"letterSpacing",e.EDITOR_FONT_DEFAULTS.letterSpacing,K=>u.clamp(K,-5,20),{description:p.localize(174,null)})),lightbulb:_e(new W),lineDecorationsWidth:_e(new I(55,"lineDecorationsWidth",10)),lineHeight:_e(new j),lineNumbers:_e(new Le),lineNumbersMinChars:_e(new c(58,"lineNumbersMinChars",5,1,300)),linkedEditing:_e(new f(59,"linkedEditing",!1,{description:p.localize(175,null)})),links:_e(new f(60,"links",!0,{description:p.localize(176,null)})),matchBrackets:_e(new b(61,"matchBrackets","always",["always","near","never"],{description:p.localize(177,null)})),minimap:_e(new O),mouseStyle:_e(new b(63,"mouseStyle","text",["text","default","copy"])),mouseWheelScrollSensitivity:_e(new u(64,"mouseWheelScrollSensitivity",1,K=>K===0?1:K,{markdownDescription:p.localize(178,null)})),mouseWheelZoom:_e(new f(65,"mouseWheelZoom",!1,{markdownDescription:p.localize(179,null)})),multiCursorMergeOverlapping:_e(new f(66,"multiCursorMergeOverlapping",!0,{description:p.localize(180,null)})),multiCursorModifier:_e(new d(67,"multiCursorModifier","altKey","alt",["ctrlCmd","alt"],F,{markdownEnumDescriptions:[p.localize(181,null),p.localize(182,null)],markdownDescription:p.localize(183,null)})),multiCursorPaste:_e(new b(68,"multiCursorPaste","spread",["spread","full"],{markdownEnumDescriptions:[p.localize(184,null),p.localize(185,null)],markdownDescription:p.localize(186,null)})),occurrencesHighlight:_e(new f(69,"occurrencesHighlight",!0,{description:p.localize(187,null)})),overviewRulerBorder:_e(new f(70,"overviewRulerBorder",!0,{description:p.localize(188,null)})),overviewRulerLanes:_e(new c(71,"overviewRulerLanes",3,0,3)),padding:_e(new B),parameterHints:_e(new $),peekWidgetDefaultFocus:_e(new b(74,"peekWidgetDefaultFocus","tree",["tree","editor"],{enumDescriptions:[p.localize(189,null),p.localize(190,null)],description:p.localize(191,null)})),definitionLinkOpensInPeek:_e(new f(75,"definitionLinkOpensInPeek",!1,{description:p.localize(192,null)})),quickSuggestions:_e(new le),quickSuggestionsDelay:_e(new c(77,"quickSuggestionsDelay",10,0,1073741824,{description:p.localize(193,null)})),readOnly:_e(new f(78,"readOnly",!1)),renameOnType:_e(new f(79,"renameOnType",!1,{description:p.localize(194,null),markdownDeprecationMessage:p.localize(195,null)})),renderControlCharacters:_e(new f(80,"renderControlCharacters",!1,{description:p.localize(196,null)})),renderIndentGuides:_e(new f(81,"renderIndentGuides",!0,{description:p.localize(197,null)})),renderFinalNewline:_e(new f(82,"renderFinalNewline",!0,{description:p.localize(198,null)})),renderLineHighlight:_e(new b(83,"renderLineHighlight","line",["none","gutter","line","all"],{enumDescriptions:["","","",p.localize(199,null)],description:p.localize(200,null)})),renderLineHighlightOnlyWhenFocus:_e(new f(84,"renderLineHighlightOnlyWhenFocus",!1,{description:p.localize(201,null)})),renderValidationDecorations:_e(new b(85,"renderValidationDecorations","editable",["editable","on","off"])),renderWhitespace:_e(new b(86,"renderWhitespace","selection",["none","boundary","selection","trailing","all"],{enumDescriptions:["",p.localize(202,null),p.localize(203,null),p.localize(204,null),""],description:p.localize(205,null)})),revealHorizontalRightPadding:_e(new c(87,"revealHorizontalRightPadding",30,0,1e3)),roundedSelection:_e(new f(88,"roundedSelection",!0,{description:p.localize(206,null)})),rulers:_e(new Ue),scrollbar:_e(new ze),scrollBeyondLastColumn:_e(new c(91,"scrollBeyondLastColumn",5,0,1073741824,{description:p.localize(207,null)})),scrollBeyondLastLine:_e(new f(92,"scrollBeyondLastLine",!0,{description:p.localize(208,null)})),scrollPredominantAxis:_e(new f(93,"scrollPredominantAxis",!0,{description:p.localize(209,null)})),selectionClipboard:_e(new f(94,"selectionClipboard",!0,{description:p.localize(210,null),included:R.isLinux})),selectionHighlight:_e(new f(95,"selectionHighlight",!0,{description:p.localize(211,null)})),selectOnLineNumbers:_e(new f(96,"selectOnLineNumbers",!0)),showFoldingControls:_e(new b(97,"showFoldingControls","mouseover",["always","mouseover"],{enumDescriptions:[p.localize(212,null),p.localize(213,null)],description:p.localize(214,null)})),showUnused:_e(new f(98,"showUnused",!0,{description:p.localize(215,null)})),showDeprecated:_e(new f(123,"showDeprecated",!0,{description:p.localize(216,null)})),inlayHints:_e(new M),snippetSuggestions:_e(new b(99,"snippetSuggestions","inline",["top","bottom","inline","none"],{enumDescriptions:[p.localize(217,null),p.localize(218,null),p.localize(219,null),p.localize(220,null)],description:p.localize(221,null)})),smartSelect:_e(new Z),smoothScrolling:_e(new f(101,"smoothScrolling",!1,{description:p.localize(222,null)})),stopRenderingLineAfter:_e(new c(103,"stopRenderingLineAfter",1e4,-1,1073741824)),suggest:_e(new V),inlineSuggest:_e(new Ge),suggestFontSize:_e(new c(105,"suggestFontSize",0,0,1e3,{markdownDescription:p.localize(223,null)})),suggestLineHeight:_e(new c(106,"suggestLineHeight",0,0,1e3,{markdownDescription:p.localize(224,null)})),suggestOnTriggerCharacters:_e(new f(107,"suggestOnTriggerCharacters",!0,{description:p.localize(225,null)})),suggestSelection:_e(new b(108,"suggestSelection","recentlyUsed",["first","recentlyUsed","recentlyUsedByPrefix"],{markdownEnumDescriptions:[p.localize(226,null),p.localize(227,null),p.localize(228,null)],description:p.localize(229,null)})),tabCompletion:_e(new b(109,"tabCompletion","off",["on","off","onlySnippets"],{enumDescriptions:[p.localize(230,null),p.localize(231,null),p.localize(232,null)],description:p.localize(233,null)})),tabIndex:_e(new c(110,"tabIndex",0,-1,1073741824)),unusualLineTerminators:_e(new b(111,"unusualLineTerminators","prompt",["auto","off","prompt"],{enumDescriptions:[p.localize(234,null),p.localize(235,null),p.localize(236,null)],description:p.localize(237,null)})),useShadowDOM:_e(new f(112,"useShadowDOM",!0)),useTabStops:_e(new f(113,"useTabStops",!0,{description:p.localize(238,null)})),wordSeparators:_e(new S(114,"wordSeparators",C.USUAL_WORD_SEPARATORS,{description:p.localize(239,null)})),wordWrap:_e(new b(115,"wordWrap","off",["off","on","wordWrapColumn","bounded"],{markdownEnumDescriptions:[p.localize(240,null),p.localize(241,null),p.localize(242,null),p.localize(243,null)],description:p.localize(244,null)})),wordWrapBreakAfterCharacters:_e(new S(116,"wordWrapBreakAfterCharacters"," 	})]?|/&.,;\xA2\xB0\u2032\u2033\u2030\u2103\u3001\u3002\uFF61\uFF64\uFFE0\uFF0C\uFF0E\uFF1A\uFF1B\uFF1F\uFF01\uFF05\u30FB\uFF65\u309D\u309E\u30FD\u30FE\u30FC\u30A1\u30A3\u30A5\u30A7\u30A9\u30C3\u30E3\u30E5\u30E7\u30EE\u30F5\u30F6\u3041\u3043\u3045\u3047\u3049\u3063\u3083\u3085\u3087\u308E\u3095\u3096\u31F0\u31F1\u31F2\u31F3\u31F4\u31F5\u31F6\u31F7\u31F8\u31F9\u31FA\u31FB\u31FC\u31FD\u31FE\u31FF\u3005\u303B\uFF67\uFF68\uFF69\uFF6A\uFF6B\uFF6C\uFF6D\uFF6E\uFF6F\uFF70\u201D\u3009\u300B\u300D\u300F\u3011\u3015\uFF09\uFF3D\uFF5D\uFF63")),wordWrapBreakBeforeCharacters:_e(new S(117,"wordWrapBreakBeforeCharacters","([{\u2018\u201C\u3008\u300A\u300C\u300E\u3010\u3014\uFF08\uFF3B\uFF5B\uFF62\xA3\xA5\uFF04\uFFE1\uFFE5+\uFF0B")),wordWrapColumn:_e(new c(118,"wordWrapColumn",80,1,1073741824,{markdownDescription:p.localize(245,null)})),wordWrapOverride1:_e(new b(119,"wordWrapOverride1","inherit",["off","on","inherit"])),wordWrapOverride2:_e(new b(120,"wordWrapOverride2","inherit",["off","on","inherit"])),wrappingIndent:_e(new d(121,"wrappingIndent",1,"same",["none","same","indent","deepIndent"],J,{enumDescriptions:[p.localize(246,null),p.localize(247,null),p.localize(248,null),p.localize(249,null)],description:p.localize(250,null)})),wrappingStrategy:_e(new b(122,"wrappingStrategy","simple",["simple","advanced"],{enumDescriptions:[p.localize(251,null),p.localize(252,null)],description:p.localize(253,null)})),editorClassName:_e(new m),pixelRatio:_e(new Y),tabFocusMode:_e(new ne),layoutInfo:_e(new N),wrappingInfo:_e(new ae)}}),define(me[151],ge([19,20]),function(X,e){return X.create("vs/platform/configuration/common/configurationRegistry",e)}),define(me[152],ge([19,20]),function(X,e){return X.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(me[153],ge([19,20]),function(X,e){return X.create("vs/platform/extensions/common/extensionValidator",e)}),define(me[154],ge([19,20]),function(X,e){return X.create("vs/platform/externalTerminal/node/externalTerminalService",e)}),define(me[155],ge([19,20]),function(X,e){return X.create("vs/platform/files/common/files",e)}),define(me[156],ge([19,20]),function(X,e){return X.create("vs/platform/markers/common/markers",e)}),define(me[157],ge([19,20]),function(X,e){return X.create("vs/platform/workspaces/common/workspaces",e)}),define(me[158],ge([19,20]),function(X,e){return X.create("vs/workbench/api/common/extHostDiagnostics",e)}),define(me[159],ge([19,20]),function(X,e){return X.create("vs/workbench/api/common/extHostExtensionService",e)}),define(me[160],ge([19,20]),function(X,e){return X.create("vs/workbench/api/common/extHostProgress",e)}),define(me[161],ge([19,20]),function(X,e){return X.create("vs/workbench/api/common/extHostStatusBar",e)}),define(me[162],ge([19,20]),function(X,e){return X.create("vs/workbench/api/common/extHostTerminalService",e)}),define(me[163],ge([19,20]),function(X,e){return X.create("vs/workbench/api/common/extHostTreeViews",e)}),define(me[164],ge([19,20]),function(X,e){return X.create("vs/workbench/api/common/extHostWorkspace",e)}),define(me[165],ge([19,20]),function(X,e){return X.create("vs/workbench/api/node/extHostDebugService",e)}),define(me[166],ge([19,20]),function(X,e){return X.create("vs/workbench/contrib/debug/common/abstractDebugAdapter",e)}),define(me[167],ge([19,20]),function(X,e){return X.create("vs/workbench/contrib/debug/node/debugAdapter",e)}),define(me[168],ge([19,20]),function(X,e){return X.create("vs/workbench/contrib/search/common/queryBuilder",e)}),define(me[169],ge([19,20]),function(X,e){return X.create("vs/workbench/contrib/tasks/common/taskService",e)}),define(me[170],ge([19,20]),function(X,e){return X.create("vs/workbench/services/configurationResolver/common/variableResolver",e)}),define(me[171],ge([0,1,2]),function(X,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextEditorSelectionRevealType=e.EditorOpenContext=e.EditorOverride=e.EditorActivation=e.isResourceEditorInput=void 0;function R(E){const k=E;return p.URI.isUri(k==null?void 0:k.resource)}e.isResourceEditorInput=R;var C;(function(E){E[E.ACTIVATE=0]="ACTIVATE",E[E.RESTORE=1]="RESTORE",E[E.PRESERVE=2]="PRESERVE"})(C=e.EditorActivation||(e.EditorActivation={}));var y;(function(E){E[E.PICK=0]="PICK",E[E.DISABLED=1]="DISABLED",E[E.EXCLUSIVE_ONLY=2]="EXCLUSIVE_ONLY"})(y=e.EditorOverride||(e.EditorOverride={}));var A;(function(E){E[E.API=0]="API",E[E.USER=1]="USER"})(A=e.EditorOpenContext||(e.EditorOpenContext={}));var P;(function(E){E[E.Center=0]="Center",E[E.CenterIfOutsideViewport=1]="CenterIfOutsideViewport",E[E.NearTop=2]="NearTop",E[E.NearTopIfOutsideViewport=3]="NearTopIfOutsideViewport"})(P=e.TextEditorSelectionRevealType||(e.TextEditorSelectionRevealType={}))}),define(me[172],ge([0,1,153]),function(X,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEngineValid=e.isValidExtensionVersion=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const R=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,C=/^-(\d{4})(\d{2})(\d{2})$/;function y(l){return l=l.trim(),l==="*"||R.test(l)}e.isValidVersionStr=y;function A(l){if(!y(l))return null;if(l=l.trim(),l==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};let f=l.match(R);return f?{hasCaret:f[1]==="^",hasGreaterEquals:f[1]===">=",majorBase:f[2]==="x"?0:parseInt(f[2],10),majorMustEqual:f[2]!=="x",minorBase:f[4]==="x"?0:parseInt(f[4],10),minorMustEqual:f[4]!=="x",patchBase:f[6]==="x"?0:parseInt(f[6],10),patchMustEqual:f[6]!=="x",preRelease:f[8]||null}:null}e.parseVersion=A;function P(l){if(!l)return null;let f=l.majorBase,c=l.majorMustEqual,u=l.minorBase,S=l.minorMustEqual,w=l.patchBase,b=l.patchMustEqual;l.hasCaret&&(f===0||(S=!1),b=!1);let d=0;if(l.preRelease){const h=C.exec(l.preRelease);if(h){const[,g,t,i]=h;d=Date.UTC(Number(g),Number(t)-1,Number(i))}}return{majorBase:f,majorMustEqual:c,minorBase:u,minorMustEqual:S,patchBase:w,patchMustEqual:b,isMinimum:l.hasGreaterEquals,notBefore:d}}e.normalizeVersion=P;function E(l,f,c){let u;typeof l=="string"?u=P(A(l)):u=l;let S;f instanceof Date?S=f.getTime():typeof f=="string"&&(S=new Date(f).getTime());let w;if(typeof c=="string"?w=P(A(c)):w=c,!u||!w)return!1;let b=u.majorBase,d=u.minorBase,h=u.patchBase,g=w.majorBase,t=w.minorBase,i=w.patchBase,s=w.notBefore,n=w.majorMustEqual,o=w.minorMustEqual,v=w.patchMustEqual;return w.isMinimum?b>g?!0:b<g?!1:d>t?!0:d<t||S&&S<s?!1:h>=i:(b===1&&g===0&&(!n||!o||!v)&&(g=1,t=0,i=0,n=!0,o=!1,v=!1),b<g?!1:b>g?!n:d<t?!1:d>t?!o:h<i?!1:h>i?!v:!(S&&S<s))}e.isValidVersion=E;function k(l,f,c,u){return c.isBuiltin||typeof c.main=="undefined"?!0:I(l,f,c.engines.vscode,u)}e.isValidExtensionVersion=k;function r(l,f,c){return l==="*"||I(f,c,l)}e.isEngineValid=r;function I(l,f,c,u=[]){let S=P(A(c));if(!S)return u.push(p.localize(0,null,c)),!1;if(S.majorBase===0){if(!S.majorMustEqual||!S.minorMustEqual)return u.push(p.localize(1,null,c)),!1}else if(!S.majorMustEqual)return u.push(p.localize(2,null,c)),!1;return E(l,f,S)?!0:(u.push(p.localize(3,null,l,c)),!1)}}),define(me[110],ge([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createSyncDescriptor=e.SyncDescriptor=void 0;class p{constructor(y,A=[],P=!1){this.ctor=y,this.staticArguments=A,this.supportsDelayedInstantiation=P}}e.SyncDescriptor=p;const R=(C,...y)=>new p(C,y);e.createSyncDescriptor=R}),define(me[77],ge([0,1,110]),function(X,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingletonServiceDescriptors=e.registerSingleton=void 0;const R=[];function C(A,P,E){P instanceof p.SyncDescriptor||(P=new p.SyncDescriptor(P,[],E)),R.push([A,P])}e.registerSingleton=C;function y(){return R}e.getSingletonServiceDescriptors=y}),define(me[173],ge([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class p{constructor(y){this.incoming=new Map,this.outgoing=new Map,this.data=y}}e.Node=p;class R{constructor(y){this._hashFn=y,this._nodes=new Map}roots(){const y=[];for(let A of this._nodes.values())A.outgoing.size===0&&y.push(A);return y}insertEdge(y,A){const P=this.lookupOrInsertNode(y),E=this.lookupOrInsertNode(A);P.outgoing.set(this._hashFn(A),E),E.incoming.set(this._hashFn(y),P)}removeNode(y){const A=this._hashFn(y);this._nodes.delete(A);for(let P of this._nodes.values())P.outgoing.delete(A),P.incoming.delete(A)}lookupOrInsertNode(y){const A=this._hashFn(y);let P=this._nodes.get(A);return P||(P=new p(y),this._nodes.set(A,P)),P}lookup(y){return this._nodes.get(this._hashFn(y))}isEmpty(){return this._nodes.size===0}toString(){let y=[];for(let[A,P]of this._nodes)y.push(`${A}, (incoming)[${[...P.incoming.keys()].join(", ")}], (outgoing)[${[...P.outgoing.keys()].join(",")}]`);return y.join(`
`)}findCycleSlow(){for(let[y,A]of this._nodes){const P=new Set([y]),E=this._findCycle(A,P);if(E)return E}}_findCycle(y,A){for(let[P,E]of y.outgoing){if(A.has(P))return[...A,P].join(" -> ");A.add(P);const k=this._findCycle(E,A);if(k)return k;A.delete(P)}}}e.Graph=R}),define(me[4],ge([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.optional=e.refineServiceDecorator=e.createDecorator=e.IInstantiationService=e._util=void 0;var p;(function(P){P.serviceIds=new Map,P.DI_TARGET="$di$target",P.DI_DEPENDENCIES="$di$dependencies";function E(k){return k[P.DI_DEPENDENCIES]||[]}P.getServiceDependencies=E})(p=e._util||(e._util={})),e.IInstantiationService=C("instantiationService");function R(P,E,k,r){E[p.DI_TARGET]===E?E[p.DI_DEPENDENCIES].push({id:P,index:k,optional:r}):(E[p.DI_DEPENDENCIES]=[{id:P,index:k,optional:r}],E[p.DI_TARGET]=E)}function C(P){if(p.serviceIds.has(P))return p.serviceIds.get(P);const E=function(k,r,I){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");R(E,k,I,!1)};return E.toString=()=>P,p.serviceIds.set(P,E),E}e.createDecorator=C;function y(P){return P}e.refineServiceDecorator=y;function A(P){return function(E,k,r){if(arguments.length!==3)throw new Error("@optional-decorator can only be used to decorate a parameter");R(P,E,r,!0)}}e.optional=A}),define(me[174],ge([0,1,4]),function(X,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.shouldSynchronizeModel=e.IModelService=void 0,e.IModelService=p.createDecorator("modelService");function R(C){return!C.isTooLargeForSyncing()&&!C.isForSimpleWidget}e.shouldSynchronizeModel=R}),define(me[175],ge([0,1,3,73,6,23,72,76,174]),function(X,e,p,R,C,y,A,P,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LanguageFeatureRequestDelays=e.LanguageFeatureRegistry=void 0;function k(l){return typeof l=="string"?!1:Array.isArray(l)?l.every(k):!!l.exclusive}class r{constructor(){this._clock=0,this._entries=[],this._onDidChange=new p.Emitter}get onDidChange(){return this._onDidChange.event}register(f,c){let u={selector:f,provider:c,_score:-1,_time:this._clock++};return this._entries.push(u),this._lastCandidate=void 0,this._onDidChange.fire(this._entries.length),C.toDisposable(()=>{if(u){let S=this._entries.indexOf(u);S>=0&&(this._entries.splice(S,1),this._lastCandidate=void 0,this._onDidChange.fire(this._entries.length),u=void 0)}})}has(f){return this.all(f).length>0}all(f){if(!f)return[];this._updateScores(f);const c=[];for(let u of this._entries)u._score>0&&c.push(u.provider);return c}ordered(f){const c=[];return this._orderedForEach(f,u=>c.push(u.provider)),c}orderedGroups(f){const c=[];let u,S;return this._orderedForEach(f,w=>{u&&S===w._score?u.push(w.provider):(S=w._score,u=[w.provider],c.push(u))}),c}_orderedForEach(f,c){if(!!f){this._updateScores(f);for(const u of this._entries)u._score>0&&c(u)}}_updateScores(f){let c={uri:f.uri.toString(),language:f.getLanguageIdentifier().language};if(!(this._lastCandidate&&this._lastCandidate.language===c.language&&this._lastCandidate.uri===c.uri)){this._lastCandidate=c;for(let u of this._entries)if(u._score=P.score(u.selector,f.uri,f.getLanguageIdentifier().language,E.shouldSynchronizeModel(f)),k(u.selector)&&u._score>0){for(let S of this._entries)S._score=0;u._score=1e3;break}this._entries.sort(r._compareByScoreAndTime)}}static _compareByScoreAndTime(f,c){return f._score<c._score?1:f._score>c._score?-1:f._time<c._time?1:f._time>c._time?-1:0}}e.LanguageFeatureRegistry=r;class I{constructor(f,c,u=Number.MAX_SAFE_INTEGER){this._registry=f,this.min=c,this.max=u,this._cache=new y.LRUCache(50,.7)}_key(f){return f.id+R.hash(this._registry.all(f))}_clamp(f){return f===void 0?this.min:Math.min(this.max,Math.max(this.min,Math.floor(f*1.3)))}get(f){const c=this._key(f),u=this._cache.get(c);return this._clamp(u==null?void 0:u.value)}update(f,c){const u=this._key(f);let S=this._cache.get(u);return S||(S=new A.MovingAverage,this._cache.set(u,S)),S.update(c),this.get(f)}}e.LanguageFeatureRequestDelays=I}),define(me[78],ge([0,1,2,40,175,143,90]),function(X,e,p,R,C,y,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExternalUriOpenerPriority=e.TokenizationRegistry=e.DocumentRangeSemanticTokensProviderRegistry=e.DocumentSemanticTokensProviderRegistry=e.FoldingRangeProviderRegistry=e.SelectionRangeRegistry=e.ColorProviderRegistry=e.LinkProviderRegistry=e.OnTypeFormattingEditProviderRegistry=e.DocumentRangeFormattingEditProviderRegistry=e.DocumentFormattingEditProviderRegistry=e.CodeActionProviderRegistry=e.InlayHintsProviderRegistry=e.CodeLensProviderRegistry=e.TypeDefinitionProviderRegistry=e.ImplementationProviderRegistry=e.DeclarationProviderRegistry=e.DefinitionProviderRegistry=e.LinkedEditingRangeProviderRegistry=e.DocumentHighlightProviderRegistry=e.DocumentSymbolProviderRegistry=e.InlineValuesProviderRegistry=e.EvaluatableExpressionProviderRegistry=e.HoverProviderRegistry=e.SignatureHelpProviderRegistry=e.InlineCompletionsProviderRegistry=e.CompletionProviderRegistry=e.RenameProviderRegistry=e.ReferenceProviderRegistry=e.InlayHintKind=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.SymbolKinds=e.SymbolTag=e.SymbolKind=e.isLocationLink=e.DocumentHighlightKind=e.SignatureHelpTriggerKind=e.CodeActionTriggerType=e.InlineCompletionTriggerKind=e.CompletionTriggerKind=e.CompletionItemInsertTextRule=e.CompletionItemTag=e.completionKindFromString=e.completionKindToCssClass=e.CompletionItemKind=e.TokenMetadata=e.MetadataConsts=e.StandardTokenType=e.ColorId=e.FontStyle=e.LanguageIdentifier=e.LanguageId=void 0;var P;(function(a){a[a.Null=0]="Null",a[a.PlainText=1]="PlainText"})(P=e.LanguageId||(e.LanguageId={}));class E{constructor(T,L){this.language=T,this.id=L}}e.LanguageIdentifier=E;var k;(function(a){a[a.NotSet=-1]="NotSet",a[a.None=0]="None",a[a.Italic=1]="Italic",a[a.Bold=2]="Bold",a[a.Underline=4]="Underline"})(k=e.FontStyle||(e.FontStyle={}));var r;(function(a){a[a.None=0]="None",a[a.DefaultForeground=1]="DefaultForeground",a[a.DefaultBackground=2]="DefaultBackground"})(r=e.ColorId||(e.ColorId={}));var I;(function(a){a[a.Other=0]="Other",a[a.Comment=1]="Comment",a[a.String=2]="String",a[a.RegEx=4]="RegEx"})(I=e.StandardTokenType||(e.StandardTokenType={}));var l;(function(a){a[a.LANGUAGEID_MASK=255]="LANGUAGEID_MASK",a[a.TOKEN_TYPE_MASK=1792]="TOKEN_TYPE_MASK",a[a.FONT_STYLE_MASK=14336]="FONT_STYLE_MASK",a[a.FOREGROUND_MASK=8372224]="FOREGROUND_MASK",a[a.BACKGROUND_MASK=4286578688]="BACKGROUND_MASK",a[a.ITALIC_MASK=2048]="ITALIC_MASK",a[a.BOLD_MASK=4096]="BOLD_MASK",a[a.UNDERLINE_MASK=8192]="UNDERLINE_MASK",a[a.SEMANTIC_USE_ITALIC=1]="SEMANTIC_USE_ITALIC",a[a.SEMANTIC_USE_BOLD=2]="SEMANTIC_USE_BOLD",a[a.SEMANTIC_USE_UNDERLINE=4]="SEMANTIC_USE_UNDERLINE",a[a.SEMANTIC_USE_FOREGROUND=8]="SEMANTIC_USE_FOREGROUND",a[a.SEMANTIC_USE_BACKGROUND=16]="SEMANTIC_USE_BACKGROUND",a[a.LANGUAGEID_OFFSET=0]="LANGUAGEID_OFFSET",a[a.TOKEN_TYPE_OFFSET=8]="TOKEN_TYPE_OFFSET",a[a.FONT_STYLE_OFFSET=11]="FONT_STYLE_OFFSET",a[a.FOREGROUND_OFFSET=14]="FOREGROUND_OFFSET",a[a.BACKGROUND_OFFSET=23]="BACKGROUND_OFFSET"})(l=e.MetadataConsts||(e.MetadataConsts={}));class f{static getLanguageId(T){return(T&255)>>>0}static getTokenType(T){return(T&1792)>>>8}static getFontStyle(T){return(T&14336)>>>11}static getForeground(T){return(T&8372224)>>>14}static getBackground(T){return(T&4286578688)>>>23}static getClassNameFromMetadata(T){let L=this.getForeground(T),U="mtk"+L,G=this.getFontStyle(T);return G&1&&(U+=" mtki"),G&2&&(U+=" mtkb"),G&4&&(U+=" mtku"),U}static getInlineStyleFromMetadata(T,L){const U=this.getForeground(T),G=this.getFontStyle(T);let ee=`color: ${L[U]};`;return G&1&&(ee+="font-style: italic;"),G&2&&(ee+="font-weight: bold;"),G&4&&(ee+="text-decoration: underline;"),ee}}e.TokenMetadata=f;var c;(function(a){a[a.Method=0]="Method",a[a.Function=1]="Function",a[a.Constructor=2]="Constructor",a[a.Field=3]="Field",a[a.Variable=4]="Variable",a[a.Class=5]="Class",a[a.Struct=6]="Struct",a[a.Interface=7]="Interface",a[a.Module=8]="Module",a[a.Property=9]="Property",a[a.Event=10]="Event",a[a.Operator=11]="Operator",a[a.Unit=12]="Unit",a[a.Value=13]="Value",a[a.Constant=14]="Constant",a[a.Enum=15]="Enum",a[a.EnumMember=16]="EnumMember",a[a.Keyword=17]="Keyword",a[a.Text=18]="Text",a[a.Color=19]="Color",a[a.File=20]="File",a[a.Reference=21]="Reference",a[a.Customcolor=22]="Customcolor",a[a.Folder=23]="Folder",a[a.TypeParameter=24]="TypeParameter",a[a.User=25]="User",a[a.Issue=26]="Issue",a[a.Snippet=27]="Snippet"})(c=e.CompletionItemKind||(e.CompletionItemKind={})),e.completionKindToCssClass=function(){let a=Object.create(null);return a[0]="symbol-method",a[1]="symbol-function",a[2]="symbol-constructor",a[3]="symbol-field",a[4]="symbol-variable",a[5]="symbol-class",a[6]="symbol-struct",a[7]="symbol-interface",a[8]="symbol-module",a[9]="symbol-property",a[10]="symbol-event",a[11]="symbol-operator",a[12]="symbol-unit",a[13]="symbol-value",a[14]="symbol-constant",a[15]="symbol-enum",a[16]="symbol-enum-member",a[17]="symbol-keyword",a[27]="symbol-snippet",a[18]="symbol-text",a[19]="symbol-color",a[20]="symbol-file",a[21]="symbol-reference",a[22]="symbol-customcolor",a[23]="symbol-folder",a[24]="symbol-type-parameter",a[25]="account",a[26]="issues",function(T){const L=a[T];let U=L&&A.iconRegistry.get(L);return U||(console.info("No codicon found for CompletionItemKind "+T),U=A.Codicon.symbolProperty),U.classNames}}(),e.completionKindFromString=function(){let a=Object.create(null);return a.method=0,a.function=1,a.constructor=2,a.field=3,a.variable=4,a.class=5,a.struct=6,a.interface=7,a.module=8,a.property=9,a.event=10,a.operator=11,a.unit=12,a.value=13,a.constant=14,a.enum=15,a["enum-member"]=16,a.enumMember=16,a.keyword=17,a.snippet=27,a.text=18,a.color=19,a.file=20,a.reference=21,a.customcolor=22,a.folder=23,a["type-parameter"]=24,a.typeParameter=24,a.account=25,a.issue=26,function(T,L){let U=a[T];return typeof U=="undefined"&&!L&&(U=9),U}}();var u;(function(a){a[a.Deprecated=1]="Deprecated"})(u=e.CompletionItemTag||(e.CompletionItemTag={}));var S;(function(a){a[a.KeepWhitespace=1]="KeepWhitespace",a[a.InsertAsSnippet=4]="InsertAsSnippet"})(S=e.CompletionItemInsertTextRule||(e.CompletionItemInsertTextRule={}));var w;(function(a){a[a.Invoke=0]="Invoke",a[a.TriggerCharacter=1]="TriggerCharacter",a[a.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(w=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var b;(function(a){a[a.Automatic=0]="Automatic",a[a.Explicit=1]="Explicit"})(b=e.InlineCompletionTriggerKind||(e.InlineCompletionTriggerKind={}));var d;(function(a){a[a.Invoke=1]="Invoke",a[a.Auto=2]="Auto"})(d=e.CodeActionTriggerType||(e.CodeActionTriggerType={}));var h;(function(a){a[a.Invoke=1]="Invoke",a[a.TriggerCharacter=2]="TriggerCharacter",a[a.ContentChange=3]="ContentChange"})(h=e.SignatureHelpTriggerKind||(e.SignatureHelpTriggerKind={}));var g;(function(a){a[a.Text=0]="Text",a[a.Read=1]="Read",a[a.Write=2]="Write"})(g=e.DocumentHighlightKind||(e.DocumentHighlightKind={}));function t(a){return a&&p.URI.isUri(a.uri)&&R.Range.isIRange(a.range)&&(R.Range.isIRange(a.originSelectionRange)||R.Range.isIRange(a.targetSelectionRange))}e.isLocationLink=t;var i;(function(a){a[a.File=0]="File",a[a.Module=1]="Module",a[a.Namespace=2]="Namespace",a[a.Package=3]="Package",a[a.Class=4]="Class",a[a.Method=5]="Method",a[a.Property=6]="Property",a[a.Field=7]="Field",a[a.Constructor=8]="Constructor",a[a.Enum=9]="Enum",a[a.Interface=10]="Interface",a[a.Function=11]="Function",a[a.Variable=12]="Variable",a[a.Constant=13]="Constant",a[a.String=14]="String",a[a.Number=15]="Number",a[a.Boolean=16]="Boolean",a[a.Array=17]="Array",a[a.Object=18]="Object",a[a.Key=19]="Key",a[a.Null=20]="Null",a[a.EnumMember=21]="EnumMember",a[a.Struct=22]="Struct",a[a.Event=23]="Event",a[a.Operator=24]="Operator",a[a.TypeParameter=25]="TypeParameter"})(i=e.SymbolKind||(e.SymbolKind={}));var s;(function(a){a[a.Deprecated=1]="Deprecated"})(s=e.SymbolTag||(e.SymbolTag={}));var n;(function(a){const T=new Map;T.set("file",0),T.set("module",1),T.set("namespace",2),T.set("package",3),T.set("class",4),T.set("method",5),T.set("property",6),T.set("field",7),T.set("constructor",8),T.set("enum",9),T.set("interface",10),T.set("function",11),T.set("variable",12),T.set("constant",13),T.set("string",14),T.set("number",15),T.set("boolean",16),T.set("array",17),T.set("object",18),T.set("key",19),T.set("null",20),T.set("enum-member",21),T.set("struct",22),T.set("event",23),T.set("operator",24),T.set("type-parameter",25);const L=new Map;L.set(0,"file"),L.set(1,"module"),L.set(2,"namespace"),L.set(3,"package"),L.set(4,"class"),L.set(5,"method"),L.set(6,"property"),L.set(7,"field"),L.set(8,"constructor"),L.set(9,"enum"),L.set(10,"interface"),L.set(11,"function"),L.set(12,"variable"),L.set(13,"constant"),L.set(14,"string"),L.set(15,"number"),L.set(16,"boolean"),L.set(17,"array"),L.set(18,"object"),L.set(19,"key"),L.set(20,"null"),L.set(21,"enum-member"),L.set(22,"struct"),L.set(23,"event"),L.set(24,"operator"),L.set(25,"type-parameter");function U(z){return T.get(z)}a.fromString=U;function G(z){return L.get(z)}a.toString=G;function ee(z,N){const W=L.get(z);let M=W&&A.iconRegistry.get("symbol-"+W);return M||(console.info("No codicon found for SymbolKind "+z),M=A.Codicon.symbolProperty),`${N?"inline":"block"} ${M.classNames}`}a.toCssClassName=ee})(n=e.SymbolKinds||(e.SymbolKinds={}));class o{constructor(T){this.value=T}}e.FoldingRangeKind=o,o.Comment=new o("comment"),o.Imports=new o("imports"),o.Region=new o("region");var v;(function(a){a[a.Collapsed=0]="Collapsed",a[a.Expanded=1]="Expanded"})(v=e.CommentThreadCollapsibleState||(e.CommentThreadCollapsibleState={}));var m;(function(a){a[a.Editing=0]="Editing",a[a.Preview=1]="Preview"})(m=e.CommentMode||(e.CommentMode={}));var _;(function(a){a[a.Other=0]="Other",a[a.Type=1]="Type",a[a.Parameter=2]="Parameter"})(_=e.InlayHintKind||(e.InlayHintKind={})),e.ReferenceProviderRegistry=new C.LanguageFeatureRegistry,e.RenameProviderRegistry=new C.LanguageFeatureRegistry,e.CompletionProviderRegistry=new C.LanguageFeatureRegistry,e.InlineCompletionsProviderRegistry=new C.LanguageFeatureRegistry,e.SignatureHelpProviderRegistry=new C.LanguageFeatureRegistry,e.HoverProviderRegistry=new C.LanguageFeatureRegistry,e.EvaluatableExpressionProviderRegistry=new C.LanguageFeatureRegistry,e.InlineValuesProviderRegistry=new C.LanguageFeatureRegistry,e.DocumentSymbolProviderRegistry=new C.LanguageFeatureRegistry,e.DocumentHighlightProviderRegistry=new C.LanguageFeatureRegistry,e.LinkedEditingRangeProviderRegistry=new C.LanguageFeatureRegistry,e.DefinitionProviderRegistry=new C.LanguageFeatureRegistry,e.DeclarationProviderRegistry=new C.LanguageFeatureRegistry,e.ImplementationProviderRegistry=new C.LanguageFeatureRegistry,e.TypeDefinitionProviderRegistry=new C.LanguageFeatureRegistry,e.CodeLensProviderRegistry=new C.LanguageFeatureRegistry,e.InlayHintsProviderRegistry=new C.LanguageFeatureRegistry,e.CodeActionProviderRegistry=new C.LanguageFeatureRegistry,e.DocumentFormattingEditProviderRegistry=new C.LanguageFeatureRegistry,e.DocumentRangeFormattingEditProviderRegistry=new C.LanguageFeatureRegistry,e.OnTypeFormattingEditProviderRegistry=new C.LanguageFeatureRegistry,e.LinkProviderRegistry=new C.LanguageFeatureRegistry,e.ColorProviderRegistry=new C.LanguageFeatureRegistry,e.SelectionRangeRegistry=new C.LanguageFeatureRegistry,e.FoldingRangeProviderRegistry=new C.LanguageFeatureRegistry,e.DocumentSemanticTokensProviderRegistry=new C.LanguageFeatureRegistry,e.DocumentRangeSemanticTokensProviderRegistry=new C.LanguageFeatureRegistry,e.TokenizationRegistry=new y.TokenizationRegistryImpl;var D;(function(a){a[a.None=0]="None",a[a.Option=1]="Option",a[a.Default=2]="Default",a[a.Preferred=3]="Preferred"})(D=e.ExternalUriOpenerPriority||(e.ExternalUriOpenerPriority={}))}),define(me[111],ge([0,1,8,4,11]),function(X,e,p,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SET_CONTEXT_COMMAND_ID=e.IContextKeyService=e.RawContextKey=e.ContextKeyOrExpr=e.ContextKeyAndExpr=e.ContextKeyNotRegexExpr=e.ContextKeyRegexExpr=e.ContextKeySmallerEqualsExpr=e.ContextKeySmallerExpr=e.ContextKeyGreaterEqualsExpr=e.ContextKeyGreaterExpr=e.ContextKeyNotExpr=e.ContextKeyNotEqualsExpr=e.ContextKeyNotInExpr=e.ContextKeyInExpr=e.ContextKeyEqualsExpr=e.ContextKeyDefinedExpr=e.ContextKeyTrueExpr=e.ContextKeyFalseExpr=e.ContextKeyExpr=e.ContextKeyExprType=void 0;let y=C.userAgent||"";const A=new Map;A.set("false",!1),A.set("true",!0),A.set("isMac",C.isMacintosh),A.set("isLinux",C.isLinux),A.set("isWindows",C.isWindows),A.set("isWeb",C.isWeb),A.set("isMacNative",C.isMacintosh&&!C.isWeb),A.set("isEdge",y.indexOf("Edg/")>=0),A.set("isFirefox",y.indexOf("Firefox")>=0),A.set("isChrome",y.indexOf("Chrome")>=0),A.set("isSafari",y.indexOf("Safari")>=0);const P=Object.prototype.hasOwnProperty;var E;(function(D){D[D.False=0]="False",D[D.True=1]="True",D[D.Defined=2]="Defined",D[D.Not=3]="Not",D[D.Equals=4]="Equals",D[D.NotEquals=5]="NotEquals",D[D.And=6]="And",D[D.Regex=7]="Regex",D[D.NotRegex=8]="NotRegex",D[D.Or=9]="Or",D[D.In=10]="In",D[D.NotIn=11]="NotIn",D[D.Greater=12]="Greater",D[D.GreaterEquals=13]="GreaterEquals",D[D.Smaller=14]="Smaller",D[D.SmallerEquals=15]="SmallerEquals"})(E=e.ContextKeyExprType||(e.ContextKeyExprType={}));class k{static false(){return I.INSTANCE}static true(){return l.INSTANCE}static has(a){return f.create(a)}static equals(a,T){return c.create(a,T)}static notEquals(a,T){return w.create(a,T)}static regex(a,T){return i.create(a,T)}static in(a,T){return u.create(a,T)}static not(a){return b.create(a)}static and(...a){return n.create(a)}static or(...a){return o.create(a)}static greater(a,T){return d.create(a,T)}static less(a,T){return g.create(a,T)}static deserialize(a,T=!1){if(!!a)return this._deserializeOrExpression(a,T)}static _deserializeOrExpression(a,T){let L=a.split("||");return o.create(L.map(U=>this._deserializeAndExpression(U,T)))}static _deserializeAndExpression(a,T){let L=a.split("&&");return n.create(L.map(U=>this._deserializeOne(U,T)))}static _deserializeOne(a,T){if(a=a.trim(),a.indexOf("!=")>=0){let L=a.split("!=");return w.create(L[0].trim(),this._deserializeValue(L[1],T))}if(a.indexOf("==")>=0){let L=a.split("==");return c.create(L[0].trim(),this._deserializeValue(L[1],T))}if(a.indexOf("=~")>=0){let L=a.split("=~");return i.create(L[0].trim(),this._deserializeRegexValue(L[1],T))}if(a.indexOf(" in ")>=0){let L=a.split(" in ");return u.create(L[0].trim(),L[1].trim())}if(/^[^<=>]+>=[^<=>]+$/.test(a)){const L=a.split(">=");return h.create(L[0].trim(),L[1].trim())}if(/^[^<=>]+>[^<=>]+$/.test(a)){const L=a.split(">");return d.create(L[0].trim(),L[1].trim())}if(/^[^<=>]+<=[^<=>]+$/.test(a)){const L=a.split("<=");return t.create(L[0].trim(),L[1].trim())}if(/^[^<=>]+<[^<=>]+$/.test(a)){const L=a.split("<");return g.create(L[0].trim(),L[1].trim())}return/^\!\s*/.test(a)?b.create(a.substr(1).trim()):f.create(a)}static _deserializeValue(a,T){if(a=a.trim(),a==="true")return!0;if(a==="false")return!1;let L=/^'([^']*)'$/.exec(a);return L?L[1].trim():a}static _deserializeRegexValue(a,T){if(p.isFalsyOrWhitespace(a)){if(T)throw new Error("missing regexp-value for =~-expression");return console.warn("missing regexp-value for =~-expression"),null}let L=a.indexOf("/"),U=a.lastIndexOf("/");if(L===U||L<0){if(T)throw new Error(`bad regexp-value '${a}', missing /-enclosure`);return console.warn(`bad regexp-value '${a}', missing /-enclosure`),null}let G=a.slice(L+1,U),ee=a[U+1]==="i"?"i":"";try{return new RegExp(G,ee)}catch(z){if(T)throw new Error(`bad regexp-value '${a}', parse error: ${z}`);return console.warn(`bad regexp-value '${a}', parse error: ${z}`),null}}}e.ContextKeyExpr=k;function r(D,a){return D.cmp(a)}class I{constructor(){this.type=0}cmp(a){return this.type-a.type}equals(a){return a.type===this.type}evaluate(a){return!1}serialize(){return"false"}keys(){return[]}map(a){return this}negate(){return l.INSTANCE}}e.ContextKeyFalseExpr=I,I.INSTANCE=new I;class l{constructor(){this.type=1}cmp(a){return this.type-a.type}equals(a){return a.type===this.type}evaluate(a){return!0}serialize(){return"true"}keys(){return[]}map(a){return this}negate(){return I.INSTANCE}}e.ContextKeyTrueExpr=l,l.INSTANCE=new l;class f{constructor(a){this.key=a,this.type=2}static create(a){const T=A.get(a);return typeof T=="boolean"?T?l.INSTANCE:I.INSTANCE:new f(a)}cmp(a){return a.type!==this.type?this.type-a.type:m(this.key,a.key)}equals(a){return a.type===this.type?this.key===a.key:!1}evaluate(a){return!!a.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(a){return a.mapDefined(this.key)}negate(){return b.create(this.key)}}e.ContextKeyDefinedExpr=f;class c{constructor(a,T){this.key=a,this.value=T,this.type=4}static create(a,T){if(typeof T=="boolean")return T?f.create(a):b.create(a);const L=A.get(a);return typeof L=="boolean"?T===(L?"true":"false")?l.INSTANCE:I.INSTANCE:new c(a,T)}cmp(a){return a.type!==this.type?this.type-a.type:_(this.key,this.value,a.key,a.value)}equals(a){return a.type===this.type?this.key===a.key&&this.value===a.value:!1}evaluate(a){return a.getValue(this.key)==this.value}serialize(){return`${this.key} == '${this.value}'`}keys(){return[this.key]}map(a){return a.mapEquals(this.key,this.value)}negate(){return w.create(this.key,this.value)}}e.ContextKeyEqualsExpr=c;class u{constructor(a,T){this.key=a,this.valueKey=T,this.type=10}static create(a,T){return new u(a,T)}cmp(a){return a.type!==this.type?this.type-a.type:_(this.key,this.valueKey,a.key,a.valueKey)}equals(a){return a.type===this.type?this.key===a.key&&this.valueKey===a.valueKey:!1}evaluate(a){const T=a.getValue(this.valueKey),L=a.getValue(this.key);return Array.isArray(T)?T.indexOf(L)>=0:typeof L=="string"&&typeof T=="object"&&T!==null?P.call(T,L):!1}serialize(){return`${this.key} in '${this.valueKey}'`}keys(){return[this.key,this.valueKey]}map(a){return a.mapIn(this.key,this.valueKey)}negate(){return S.create(this)}}e.ContextKeyInExpr=u;class S{constructor(a){this._actual=a,this.type=11}static create(a){return new S(a)}cmp(a){return a.type!==this.type?this.type-a.type:this._actual.cmp(a._actual)}equals(a){return a.type===this.type?this._actual.equals(a._actual):!1}evaluate(a){return!this._actual.evaluate(a)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(a){return new S(this._actual.map(a))}negate(){return this._actual}}e.ContextKeyNotInExpr=S;class w{constructor(a,T){this.key=a,this.value=T,this.type=5}static create(a,T){if(typeof T=="boolean")return T?b.create(a):f.create(a);const L=A.get(a);return typeof L=="boolean"?T===(L?"true":"false")?I.INSTANCE:l.INSTANCE:new w(a,T)}cmp(a){return a.type!==this.type?this.type-a.type:_(this.key,this.value,a.key,a.value)}equals(a){return a.type===this.type?this.key===a.key&&this.value===a.value:!1}evaluate(a){return a.getValue(this.key)!=this.value}serialize(){return`${this.key} != '${this.value}'`}keys(){return[this.key]}map(a){return a.mapNotEquals(this.key,this.value)}negate(){return c.create(this.key,this.value)}}e.ContextKeyNotEqualsExpr=w;class b{constructor(a){this.key=a,this.type=3}static create(a){const T=A.get(a);return typeof T=="boolean"?T?I.INSTANCE:l.INSTANCE:new b(a)}cmp(a){return a.type!==this.type?this.type-a.type:m(this.key,a.key)}equals(a){return a.type===this.type?this.key===a.key:!1}evaluate(a){return!a.getValue(this.key)}serialize(){return`!${this.key}`}keys(){return[this.key]}map(a){return a.mapNot(this.key)}negate(){return f.create(this.key)}}e.ContextKeyNotExpr=b;class d{constructor(a,T){this.key=a,this.value=T,this.type=12}static create(a,T){return new d(a,T)}cmp(a){return a.type!==this.type?this.type-a.type:_(this.key,this.value,a.key,a.value)}equals(a){return a.type===this.type?this.key===a.key&&this.value===a.value:!1}evaluate(a){return parseFloat(a.getValue(this.key))>parseFloat(this.value)}serialize(){return`${this.key} > ${this.value}`}keys(){return[this.key]}map(a){return a.mapGreater(this.key,this.value)}negate(){return t.create(this.key,this.value)}}e.ContextKeyGreaterExpr=d;class h{constructor(a,T){this.key=a,this.value=T,this.type=13}static create(a,T){return new h(a,T)}cmp(a){return a.type!==this.type?this.type-a.type:_(this.key,this.value,a.key,a.value)}equals(a){return a.type===this.type?this.key===a.key&&this.value===a.value:!1}evaluate(a){return parseFloat(a.getValue(this.key))>=parseFloat(this.value)}serialize(){return`${this.key} >= ${this.value}`}keys(){return[this.key]}map(a){return a.mapGreaterEquals(this.key,this.value)}negate(){return g.create(this.key,this.value)}}e.ContextKeyGreaterEqualsExpr=h;class g{constructor(a,T){this.key=a,this.value=T,this.type=14}static create(a,T){return new g(a,T)}cmp(a){return a.type!==this.type?this.type-a.type:_(this.key,this.value,a.key,a.value)}equals(a){return a.type===this.type?this.key===a.key&&this.value===a.value:!1}evaluate(a){return parseFloat(a.getValue(this.key))<parseFloat(this.value)}serialize(){return`${this.key} < ${this.value}`}keys(){return[this.key]}map(a){return a.mapSmaller(this.key,this.value)}negate(){return h.create(this.key,this.value)}}e.ContextKeySmallerExpr=g;class t{constructor(a,T){this.key=a,this.value=T,this.type=15}static create(a,T){return new t(a,T)}cmp(a){return a.type!==this.type?this.type-a.type:_(this.key,this.value,a.key,a.value)}equals(a){return a.type===this.type?this.key===a.key&&this.value===a.value:!1}evaluate(a){return parseFloat(a.getValue(this.key))<=parseFloat(this.value)}serialize(){return`${this.key} <= ${this.value}`}keys(){return[this.key]}map(a){return a.mapSmallerEquals(this.key,this.value)}negate(){return d.create(this.key,this.value)}}e.ContextKeySmallerEqualsExpr=t;class i{constructor(a,T){this.key=a,this.regexp=T,this.type=7}static create(a,T){return new i(a,T)}cmp(a){if(a.type!==this.type)return this.type-a.type;if(this.key<a.key)return-1;if(this.key>a.key)return 1;const T=this.regexp?this.regexp.source:"",L=a.regexp?a.regexp.source:"";return T<L?-1:T>L?1:0}equals(a){if(a.type===this.type){const T=this.regexp?this.regexp.source:"",L=a.regexp?a.regexp.source:"";return this.key===a.key&&T===L}return!1}evaluate(a){let T=a.getValue(this.key);return this.regexp?this.regexp.test(T):!1}serialize(){const a=this.regexp?`/${this.regexp.source}/${this.regexp.ignoreCase?"i":""}`:"/invalid/";return`${this.key} =~ ${a}`}keys(){return[this.key]}map(a){return a.mapRegex(this.key,this.regexp)}negate(){return s.create(this)}}e.ContextKeyRegexExpr=i;class s{constructor(a){this._actual=a,this.type=8}static create(a){return new s(a)}cmp(a){return a.type!==this.type?this.type-a.type:this._actual.cmp(a._actual)}equals(a){return a.type===this.type?this._actual.equals(a._actual):!1}evaluate(a){return!this._actual.evaluate(a)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(a){return new s(this._actual.map(a))}negate(){return this._actual}}e.ContextKeyNotRegexExpr=s;class n{constructor(a){this.expr=a,this.type=6}static create(a){return n._normalizeArr(a)}cmp(a){if(a.type!==this.type)return this.type-a.type;if(this.expr.length<a.expr.length)return-1;if(this.expr.length>a.expr.length)return 1;for(let T=0,L=this.expr.length;T<L;T++){const U=r(this.expr[T],a.expr[T]);if(U!==0)return U}return 0}equals(a){if(a.type===this.type){if(this.expr.length!==a.expr.length)return!1;for(let T=0,L=this.expr.length;T<L;T++)if(!this.expr[T].equals(a.expr[T]))return!1;return!0}return!1}evaluate(a){for(let T=0,L=this.expr.length;T<L;T++)if(!this.expr[T].evaluate(a))return!1;return!0}static _normalizeArr(a){const T=[];let L=!1;for(const U of a)if(!!U){if(U.type===1){L=!0;continue}if(U.type===0)return I.INSTANCE;if(U.type===6){T.push(...U.expr);continue}T.push(U)}if(T.length===0&&L)return l.INSTANCE;if(T.length!==0){if(T.length===1)return T[0];for(T.sort(r);T.length>1;){const U=T[T.length-1];if(U.type!==9)break;T.pop();const G=T.pop(),ee=o.create(U.expr.map(z=>n.create([z,G])));ee&&(T.push(ee),T.sort(r))}return T.length===1?T[0]:new n(T)}}serialize(){return this.expr.map(a=>a.serialize()).join(" && ")}keys(){const a=[];for(let T of this.expr)a.push(...T.keys());return a}map(a){return new n(this.expr.map(T=>T.map(a)))}negate(){let a=[];for(let T of this.expr)a.push(T.negate());return o.create(a)}}e.ContextKeyAndExpr=n;class o{constructor(a){this.expr=a,this.type=9}static create(a){const T=o._normalizeArr(a);if(T.length!==0)return T.length===1?T[0]:new o(T)}cmp(a){if(a.type!==this.type)return this.type-a.type;if(this.expr.length<a.expr.length)return-1;if(this.expr.length>a.expr.length)return 1;for(let T=0,L=this.expr.length;T<L;T++){const U=r(this.expr[T],a.expr[T]);if(U!==0)return U}return 0}equals(a){if(a.type===this.type){if(this.expr.length!==a.expr.length)return!1;for(let T=0,L=this.expr.length;T<L;T++)if(!this.expr[T].equals(a.expr[T]))return!1;return!0}return!1}evaluate(a){for(let T=0,L=this.expr.length;T<L;T++)if(this.expr[T].evaluate(a))return!0;return!1}static _normalizeArr(a){let T=[],L=!1;if(a){for(let U=0,G=a.length;U<G;U++){const ee=a[U];if(!!ee){if(ee.type===0){L=!0;continue}if(ee.type===1)return[l.INSTANCE];if(ee.type===9){T=T.concat(ee.expr);continue}T.push(ee)}}if(T.length===0&&L)return[I.INSTANCE];T.sort(r)}return T}serialize(){return this.expr.map(a=>a.serialize()).join(" || ")}keys(){const a=[];for(let T of this.expr)a.push(...T.keys());return a}map(a){return new o(this.expr.map(T=>T.map(a)))}negate(){let a=[];for(let L of this.expr)a.push(L.negate());const T=L=>L.type===9?L.expr:[L];for(;a.length>1;){const L=a.shift(),U=a.shift(),G=[];for(const ee of T(L))for(const z of T(U))G.push(k.and(ee,z));a.unshift(k.or(...G))}return a[0]}}e.ContextKeyOrExpr=o;class v extends f{constructor(a,T,L){super(a);this._defaultValue=T,typeof L=="object"?v._info.push(Object.assign(Object.assign({},L),{key:a})):L!==!0&&v._info.push({key:a,description:L,type:T!=null?typeof T:void 0})}static all(){return v._info.values()}bindTo(a){return a.createKey(this.key,this._defaultValue)}getValue(a){return a.getContextKeyValue(this.key)}toNegated(){return k.not(this.key)}isEqualTo(a){return k.equals(this.key,a)}notEqualsTo(a){return k.notEquals(this.key,a)}}e.RawContextKey=v,v._info=[],e.IContextKeyService=R.createDecorator("contextKeyService"),e.SET_CONTEXT_COMMAND_ID="setContext";function m(D,a){return D<a?-1:D>a?1:0}function _(D,a,T,L){return D<T?-1:D>T?1:a<L?-1:a>L?1:0}}),define(me[176],ge([0,1,4]),function(X,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=p.createDecorator("environmentService"),e.INativeEnvironmentService=p.refineServiceDecorator(e.IEnvironmentService)}),define(me[177],ge([0,1,152,4,10]),function(X,e,p,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtensionManagementCLIService=e.PreferencesLocalizedLabel=e.PreferencesLabel=e.ExtensionsChannelId=e.ExtensionsLocalizedLabel=e.ExtensionsLabel=e.DefaultIconPath=e.IExtensionTipsService=e.IGlobalExtensionEnablementService=e.ENABLED_EXTENSIONS_STORAGE_PATH=e.DISABLED_EXTENSIONS_STORAGE_PATH=e.IExtensionManagementService=e.ExtensionManagementError=e.INSTALL_ERROR_INCOMPATIBLE=e.INSTALL_ERROR_MALICIOUS=e.INSTALL_ERROR_NOT_SUPPORTED=e.IExtensionGalleryService=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.isIExtensionIdentifier=e.WEB_EXTENSION_TAG=e.EXTENSION_IDENTIFIER_REGEX=e.EXTENSION_IDENTIFIER_PATTERN=void 0,e.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.EXTENSION_IDENTIFIER_REGEX=new RegExp(e.EXTENSION_IDENTIFIER_PATTERN),e.WEB_EXTENSION_TAG="__web_extension";function y(I){return I&&typeof I=="object"&&typeof I.id=="string"&&(!I.uuid||typeof I.uuid=="string")}e.isIExtensionIdentifier=y;var A;(function(I){I[I.NoneOrRelevance=0]="NoneOrRelevance",I[I.LastUpdatedDate=1]="LastUpdatedDate",I[I.Title=2]="Title",I[I.PublisherName=3]="PublisherName",I[I.InstallCount=4]="InstallCount",I[I.PublishedDate=5]="PublishedDate",I[I.AverageRating=6]="AverageRating",I[I.WeightedRating=12]="WeightedRating"})(A=e.SortBy||(e.SortBy={}));var P;(function(I){I[I.Default=0]="Default",I[I.Ascending=1]="Ascending",I[I.Descending=2]="Descending"})(P=e.SortOrder||(e.SortOrder={}));var E;(function(I){I.Uninstall="uninstall"})(E=e.StatisticType||(e.StatisticType={}));var k;(function(I){I[I.None=0]="None",I[I.Install=1]="Install",I[I.Update=2]="Update"})(k=e.InstallOperation||(e.InstallOperation={})),e.IExtensionGalleryService=R.createDecorator("extensionGalleryService"),e.INSTALL_ERROR_NOT_SUPPORTED="notsupported",e.INSTALL_ERROR_MALICIOUS="malicious",e.INSTALL_ERROR_INCOMPATIBLE="incompatible";class r extends Error{constructor(l,f){super(l);this.code=f}}e.ExtensionManagementError=r,e.IExtensionManagementService=R.createDecorator("extensionManagementService"),e.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",e.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",e.IGlobalExtensionEnablementService=R.createDecorator("IGlobalExtensionEnablementService"),e.IExtensionTipsService=R.createDecorator("IExtensionTipsService"),e.DefaultIconPath=C.FileAccess.asBrowserUri("./media/defaultIcon.png",X).toString(!0),e.ExtensionsLabel=p.localize(0,null),e.ExtensionsLocalizedLabel={value:e.ExtensionsLabel,original:"Extensions"},e.ExtensionsChannelId="extensions",e.PreferencesLabel=p.localize(1,null),e.PreferencesLocalizedLabel={value:e.PreferencesLabel,original:"Preferences"},e.IExtensionManagementCLIService=R.createDecorator("IExtensionManagementCLIService")}),define(me[26],ge([0,1,8,4]),function(X,e,p,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isAuthenticaionProviderExtension=e.isLanguagePackExtension=e.ExtensionIdentifier=e.ExtensionType=e.EXTENSION_CATEGORIES=e.isIExtensionIdentifier=e.getWorkpaceSupportTypeMessage=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=e.MANIFEST_CACHE_FOLDER=void 0,e.MANIFEST_CACHE_FOLDER="CachedExtensions",e.USER_MANIFEST_CACHE_FILE="user",e.BUILTIN_MANIFEST_CACHE_FILE="builtin";function C(r){if(typeof r=="object"&&r!==null&&r.supported!==!0)return r.description}e.getWorkpaceSupportTypeMessage=C;function y(r){return r&&typeof r=="object"&&typeof r.id=="string"&&(!r.uuid||typeof r.uuid=="string")}e.isIExtensionIdentifier=y,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var A;(function(r){r[r.System=0]="System",r[r.User=1]="User"})(A=e.ExtensionType||(e.ExtensionType={}));class P{constructor(I){this.value=I,this._lower=I.toLowerCase()}static equals(I,l){if(typeof I=="undefined"||I===null)return typeof l=="undefined"||l===null;if(typeof l=="undefined"||l===null)return!1;if(typeof I=="string"||typeof l=="string"){let f=typeof I=="string"?I:I.value,c=typeof l=="string"?l:l.value;return p.equalsIgnoreCase(f,c)}return I._lower===l._lower}static toKey(I){return typeof I=="string"?I.toLowerCase():I._lower}}e.ExtensionIdentifier=P;function E(r){return r.contributes&&r.contributes.localizations?r.contributes.localizations.length>0:!1}e.isLanguagePackExtension=E;function k(r){return r.contributes&&r.contributes.authentication?r.contributes.authentication.length>0:!1}e.isAuthenticaionProviderExtension=k,e.IBuiltinExtensionsScannerService=R.createDecorator("IBuiltinExtensionsScannerService")}),define(me[178],ge([0,1,8,26]),function(X,e,p,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMaliciousExtensionsSet=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.ExtensionIdentifierWithVersion=e.areSameExtensions=void 0;function C(f,c){return f.uuid&&c.uuid?f.uuid===c.uuid:f.id===c.id?!0:p.compareIgnoreCase(f.id,c.id)===0}e.areSameExtensions=C;class y{constructor(c,u){this.version=u,this.id=c.id,this.uuid=c.uuid}key(){return`${this.id}-${this.version}`}equals(c){return c instanceof y?C(this,c)&&this.version===c.version:!1}}e.ExtensionIdentifierWithVersion=y;function A(f,c){return`${f}.${c}`}e.getExtensionId=A;function P(f){return f.toLocaleLowerCase()}e.adoptToGalleryExtensionId=P;function E(f,c){return P(A(f,c))}e.getGalleryExtensionId=E;function k(f,c){const u=[],S=w=>{for(const b of u)if(b.some(d=>C(c(d),c(w))))return b;return null};for(const w of f){const b=S(w);b?b.push(w):u.push([w])}return u}e.groupByExtension=k;function r(f){return{id:f.identifier.id,name:f.manifest.name,galleryId:null,publisherId:f.publisherId,publisherName:f.manifest.publisher,publisherDisplayName:f.publisherDisplayName,dependencies:f.manifest.extensionDependencies&&f.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=r;function I(f){return Object.assign({id:f.identifier.id,name:f.name,galleryId:f.identifier.uuid,publisherId:f.publisherId,publisherName:f.publisher,publisherDisplayName:f.publisherDisplayName,dependencies:!!(f.properties.dependencies&&f.properties.dependencies.length>0)},f.telemetryData)}e.getGalleryExtensionTelemetryData=I,e.BetterMergeId=new R.ExtensionIdentifier("pprice.better-merge");function l(f){const c=new Set;for(const u of f)u.malicious&&c.add(u.id.id);return c}e.getMaliciousExtensionsSet=l}),define(me[179],ge([0,1,4]),function(X,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExternalTerminalMainService=e.DEFAULT_TERMINAL_OSX=e.IExternalTerminalService=void 0,e.IExternalTerminalService=p.createDecorator("externalTerminal"),e.DEFAULT_TERMINAL_OSX="Terminal.app",e.IExternalTerminalMainService=p.createDecorator("externalTerminal")}),define(me[180],ge([0,1,38,9,109,154,28,11,179,10,135]),function(X,e,p,R,C,y,A,P,E,k,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinuxExternalTerminalService=e.MacExternalTerminalService=e.WindowsExternalTerminalService=void 0;const I=y.localize(0,null);class l{async getDefaultTerminalForPlatforms(){const h=await u.getDefaultTerminalLinuxReady();return{windows:f.getDefaultTerminalWindows(),linux:h,osx:"xterm"}}}class f extends l{openTerminal(h,g){return this.spawnTerminal(p,h,C.getWindowsShell(),g)}spawnTerminal(h,g,t,i){const s=g.windowsExec||f.getDefaultTerminalWindows();i&&i[1]===":"&&(i=i[0].toUpperCase()+i.substr(1));const n=R.basename(s).toLowerCase();if(n==="cmder"||n==="cmder.exe")return h.spawn(s,i?[i]:void 0),Promise.resolve(void 0);const o=["/c","start","/wait"];return s.indexOf(" ")>=0&&o.push('""'),o.push(s),(n==="wt"||n==="wt.exe")&&o.push("-d ."),new Promise((v,m)=>{const _=S(process),D=h.spawn(t,o,{cwd:i,env:_});D.on("error",m),D.on("exit",()=>v())})}runInTerminal(h,g,t,i,s){const n="windowsExec"in s&&s.windowsExec?s.windowsExec:f.getDefaultTerminalWindows();return new Promise((o,v)=>{const m=`"${g} - ${I}"`,_=`""${t.join('" "')}" & pause"`,D=["/c","start",m,"/wait",n,"/c",_],a=Object.assign({},S(process),i);Object.keys(a).filter(U=>a[U]===null).forEach(U=>delete a[U]);const T={cwd:g,env:a,windowsVerbatimArguments:!0};p.spawn(f.CMD,D,T).on("error",U=>{v(w(U))}),o(void 0)})}static getDefaultTerminalWindows(){if(!f._DEFAULT_TERMINAL_WINDOWS){const h=!!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432");f._DEFAULT_TERMINAL_WINDOWS=`${process.env.windir?process.env.windir:"C:\\Windows"}\\${h?"Sysnative":"System32"}\\cmd.exe`}return f._DEFAULT_TERMINAL_WINDOWS}}e.WindowsExternalTerminalService=f,f.CMD="cmd.exe";class c extends l{openTerminal(h,g){return this.spawnTerminal(p,h,g)}runInTerminal(h,g,t,i,s){const n=s.osxExec||E.DEFAULT_TERMINAL_OSX;return new Promise((o,v)=>{if(n===E.DEFAULT_TERMINAL_OSX||n==="iTerm.app"){const m=n===E.DEFAULT_TERMINAL_OSX?"TerminalHelper":"iTermHelper",D=[k.FileAccess.asFileUri(`vs/workbench/contrib/externalTerminal/node/${m}.scpt`,X).fsPath,"-t",h||I,"-w",g];for(let L of t)D.push("-a"),D.push(L);if(i)for(let L in i){const U=i[L];U===null?(D.push("-u"),D.push(L)):(D.push("-e"),D.push(`${L}=${U}`))}let a="";const T=p.spawn(c.OSASCRIPT,D);T.on("error",L=>{v(w(L))}),T.stderr.on("data",L=>{a+=L.toString()}),T.on("exit",L=>{if(L===0)o(void 0);else if(a){const U=a.split(`
`,1);v(new Error(U[0]))}else v(new Error(y.localize(1,null,m,L)))})}else v(new Error(y.localize(2,null,n)))})}spawnTerminal(h,g,t){const i=g.osxExec||E.DEFAULT_TERMINAL_OSX;return new Promise((s,n)=>{const o=["-a",i];t&&o.push(t);const v=h.spawn("/usr/bin/open",o);v.on("error",n),v.on("exit",()=>s())})}}e.MacExternalTerminalService=c,c.OSASCRIPT="/usr/bin/osascript";class u extends l{openTerminal(h,g){return this.spawnTerminal(p,h,g)}runInTerminal(h,g,t,i,s){const n=s.linuxExec?Promise.resolve(s.linuxExec):u.getDefaultTerminalLinuxReady();return new Promise((o,v)=>{let m=[];n.then(_=>{_.indexOf("gnome-terminal")>=0?m.push("-x"):m.push("-e"),m.push("bash"),m.push("-c");const D=`${b(t)}; echo; read -p "${u.WAIT_MESSAGE}" -n1;`;m.push(`''${D}''`);const a=Object.assign({},process.env,i);Object.keys(a).filter(G=>a[G]===null).forEach(G=>delete a[G]);const T={cwd:g,env:a};let L="";const U=p.spawn(_,m,T);U.on("error",G=>{v(w(G))}),U.stderr.on("data",G=>{L+=G.toString()}),U.on("exit",G=>{if(G===0)o(void 0);else if(L){const ee=L.split(`
`,1);v(new Error(ee[0]))}else v(new Error(y.localize(4,null,_,G)))})})})}static async getDefaultTerminalLinuxReady(){return u._DEFAULT_TERMINAL_LINUX_READY||(u._DEFAULT_TERMINAL_LINUX_READY=new Promise(async h=>{P.isLinux?await A.Promises.exists("/etc/debian_version")?h("x-terminal-emulator"):process.env.DESKTOP_SESSION==="gnome"||process.env.DESKTOP_SESSION==="gnome-classic"?h("gnome-terminal"):process.env.DESKTOP_SESSION==="kde-plasma"?h("konsole"):process.env.COLORTERM?h(process.env.COLORTERM):process.env.TERM?h(process.env.TERM):h("xterm"):h("xterm")})),u._DEFAULT_TERMINAL_LINUX_READY}spawnTerminal(h,g,t){const i=g.linuxExec?Promise.resolve(g.linuxExec):u.getDefaultTerminalLinuxReady();return new Promise((s,n)=>{i.then(o=>{const v=S(process),m=h.spawn(o,[],{cwd:t,env:v});m.on("error",n),m.on("exit",()=>s())})})}}e.LinuxExternalTerminalService=u,u.WAIT_MESSAGE=y.localize(3,null);function S(d){const h=d.env;return r.sanitizeProcessEnvironment(h),h}function w(d){return"errno"in d&&d.errno==="ENOENT"&&"path"in d&&typeof d.path=="string"?new Error(y.localize(5,null,d.path)):d}function b(d){let h="";for(let g of d)g.indexOf(" ")>=0?h+='"'+g+'"':h+=g,h+=" ";return h}}),define(me[41],ge([0,1,155,9,2,4,8,15,23]),function(X,e,p,R,C,y,A,P,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPlatformLimits=e.Arch=e.ByteSize=e.FALLBACK_MAX_MEMORY_SIZE_MB=e.MIN_MAX_MEMORY_SIZE_MB=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.NotModifiedSinceFileOperationError=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.isFileOpenForWriteOptions=e.IFileService=void 0,e.IFileService=y.createDecorator("fileService");function k(N){return N.create===!0}e.isFileOpenForWriteOptions=k;var r;(function(N){N[N.Unknown=0]="Unknown",N[N.File=1]="File",N[N.Directory=2]="Directory",N[N.SymbolicLink=64]="SymbolicLink"})(r=e.FileType||(e.FileType={}));var I;(function(N){N[N.Readonly=1]="Readonly"})(I=e.FilePermission||(e.FilePermission={}));var l;(function(N){N[N.FileReadWrite=2]="FileReadWrite",N[N.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",N[N.FileReadStream=16]="FileReadStream",N[N.FileFolderCopy=8]="FileFolderCopy",N[N.PathCaseSensitive=1024]="PathCaseSensitive",N[N.Readonly=2048]="Readonly",N[N.Trash=4096]="Trash",N[N.FileWriteUnlock=8192]="FileWriteUnlock"})(l=e.FileSystemProviderCapabilities||(e.FileSystemProviderCapabilities={}));function f(N){return!!(N.capabilities&2)}e.hasReadWriteCapability=f;function c(N){return!!(N.capabilities&8)}e.hasFileFolderCopyCapability=c;function u(N){return!!(N.capabilities&4)}e.hasOpenReadWriteCloseCapability=u;function S(N){return!!(N.capabilities&16)}e.hasFileReadStreamCapability=S;var w;(function(N){N.FileExists="EntryExists",N.FileNotFound="EntryNotFound",N.FileNotADirectory="EntryNotADirectory",N.FileIsADirectory="EntryIsADirectory",N.FileExceedsMemoryLimit="EntryExceedsMemoryLimit",N.FileTooLarge="EntryTooLarge",N.FileWriteLocked="EntryWriteLocked",N.NoPermissions="NoPermissions",N.Unavailable="Unavailable",N.Unknown="Unknown"})(w=e.FileSystemProviderErrorCode||(e.FileSystemProviderErrorCode={}));class b extends Error{constructor(W,M){super(W);this.code=M}}e.FileSystemProviderError=b;function d(N,W){const M=new b(N.toString(),W);return g(M,W),M}e.createFileSystemProviderError=d;function h(N){return N||d(p.localize(0,null),w.Unknown)}e.ensureFileSystemProviderError=h;function g(N,W){return N.name=W?`${W} (FileSystemError)`:"FileSystemError",N}e.markAsFileSystemProviderError=g;function t(N){if(!N)return w.Unknown;if(N instanceof b)return N.code;const W=/^(.+) \(FileSystemError\)$/.exec(N.name);if(!W)return w.Unknown;switch(W[1]){case w.FileExists:return w.FileExists;case w.FileIsADirectory:return w.FileIsADirectory;case w.FileNotADirectory:return w.FileNotADirectory;case w.FileNotFound:return w.FileNotFound;case w.FileExceedsMemoryLimit:return w.FileExceedsMemoryLimit;case w.FileTooLarge:return w.FileTooLarge;case w.FileWriteLocked:return w.FileWriteLocked;case w.NoPermissions:return w.NoPermissions;case w.Unavailable:return w.Unavailable}return w.Unknown}e.toFileSystemProviderErrorCode=t;function i(N){if(N instanceof _)return N.fileOperationResult;switch(t(N)){case w.FileNotFound:return 1;case w.FileIsADirectory:return 0;case w.FileNotADirectory:return 10;case w.FileWriteLocked:return 5;case w.NoPermissions:return 6;case w.FileExists:return 4;case w.FileExceedsMemoryLimit:return 9;case w.FileTooLarge:return 7;default:return 11}}e.toFileOperationResult=i;var s;(function(N){N[N.CREATE=0]="CREATE",N[N.DELETE=1]="DELETE",N[N.MOVE=2]="MOVE",N[N.COPY=3]="COPY"})(s=e.FileOperation||(e.FileOperation={}));class n{constructor(W,M,j){this.resource=W,this.operation=M,this.target=j}isOperation(W){return this.operation===W}}e.FileOperationEvent=n;var o;(function(N){N[N.UPDATED=0]="UPDATED",N[N.ADDED=1]="ADDED",N[N.DELETED=2]="DELETED"})(o=e.FileChangeType||(e.FileChangeType={}));class v{constructor(W,M){this.added=void 0,this.updated=void 0,this.deleted=void 0;for(const j of W)switch(j.type){case 1:this.added||(this.added=E.TernarySearchTree.forUris(()=>M)),this.added.set(j.resource,j);break;case 0:this.updated||(this.updated=E.TernarySearchTree.forUris(()=>M)),this.updated.set(j.resource,j);break;case 2:this.deleted||(this.deleted=E.TernarySearchTree.forUris(()=>M)),this.deleted.set(j.resource,j);break}}contains(W,...M){return this.doContains(W,{includeChildren:!1},...M)}affects(W,...M){return this.doContains(W,{includeChildren:!0},...M)}doContains(W,M,...j){var O,F,B,$,Y,le;if(!W)return!1;const be=j.length>0;return!!((!be||j.includes(1))&&(((O=this.added)===null||O===void 0?void 0:O.get(W))||M.includeChildren&&((F=this.added)===null||F===void 0?void 0:F.findSuperstr(W)))||(!be||j.includes(0))&&(((B=this.updated)===null||B===void 0?void 0:B.get(W))||M.includeChildren&&(($=this.updated)===null||$===void 0?void 0:$.findSuperstr(W)))||(!be||j.includes(2))&&(((Y=this.deleted)===null||Y===void 0?void 0:Y.findSubstr(W))||M.includeChildren&&((le=this.deleted)===null||le===void 0?void 0:le.findSuperstr(W))))}gotAdded(){return!!this.added}gotDeleted(){return!!this.deleted}gotUpdated(){return!!this.updated}get rawAdded(){return this.added}get rawDeleted(){return this.deleted}}e.FileChangesEvent=v;function m(N,W,M){return!N||!W||N===W||W.length>N.length?!1:(W.charAt(W.length-1)!==R.sep&&(W+=R.sep),M?A.startsWithIgnoreCase(N,W):N.indexOf(W)===0)}e.isParent=m;class _ extends Error{constructor(W,M,j){super(W);this.fileOperationResult=M,this.options=j}}e.FileOperationError=_;class D extends _{constructor(W,M,j){super(W,2,j);this.stat=M}}e.NotModifiedSinceFileOperationError=D;var a;(function(N){N[N.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",N[N.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",N[N.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",N[N.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",N[N.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",N[N.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",N[N.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",N[N.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",N[N.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",N[N.FILE_EXCEEDS_MEMORY_LIMIT=9]="FILE_EXCEEDS_MEMORY_LIMIT",N[N.FILE_NOT_DIRECTORY=10]="FILE_NOT_DIRECTORY",N[N.FILE_OTHER_ERROR=11]="FILE_OTHER_ERROR"})(a=e.FileOperationResult||(e.FileOperationResult={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude";var T;(function(N){N[N.FILE=0]="FILE",N[N.FOLDER=1]="FOLDER",N[N.ROOT_FOLDER=2]="ROOT_FOLDER"})(T=e.FileKind||(e.FileKind={})),e.ETAG_DISABLED="";function L(N){if(!(typeof N.size!="number"||typeof N.mtime!="number"))return N.mtime.toString(29)+N.size.toString(31)}e.etag=L;async function U(N,W){if(!W.canHandleResource(C.URI.from({scheme:N.scheme})))return new Promise(M=>{const j=W.onDidChangeFileSystemProviderRegistrations(O=>{O.scheme===N.scheme&&O.added&&(j.dispose(),M())})})}e.whenProviderRegistered=U,e.MIN_MAX_MEMORY_SIZE_MB=2048,e.FALLBACK_MAX_MEMORY_SIZE_MB=4096;class G{static formatSize(W){return P.isNumber(W)||(W=0),W<G.KB?p.localize(1,null,W.toFixed(0)):W<G.MB?p.localize(2,null,(W/G.KB).toFixed(2)):W<G.GB?p.localize(3,null,(W/G.MB).toFixed(2)):W<G.TB?p.localize(4,null,(W/G.GB).toFixed(2)):p.localize(5,null,(W/G.TB).toFixed(2))}}e.ByteSize=G,G.KB=1024,G.MB=G.KB*G.KB,G.GB=G.MB*G.KB,G.TB=G.GB*G.KB;var ee;(function(N){N[N.IA32=0]="IA32",N[N.OTHER=1]="OTHER"})(ee=e.Arch||(e.Arch={}));function z(N){return{maxFileSize:N===0?300*G.MB:16*G.GB,maxHeapSize:N===0?700*G.MB:2*700*G.MB}}e.getPlatformLimits=z}),define(me[79],ge([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class p{constructor(...C){this._entries=new Map;for(let[y,A]of C)this.set(y,A)}set(C,y){const A=this._entries.get(C);return this._entries.set(C,y),A}has(C){return this._entries.has(C)}get(C){return this._entries.get(C)}}e.ServiceCollection=p}),define(me[181],ge([0,1,14,173,110,4,79,16]),function(X,e,p,R,C,y,A,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InstantiationService=void 0;const E=!1;class k extends Error{constructor(c){var u;super("cyclic dependency between services");this.message=(u=c.findCycleSlow())!==null&&u!==void 0?u:`UNABLE to detect cycle, dumping graph: 
${c.toString()}`}}class r{constructor(c=new A.ServiceCollection,u=!1,S){this._activeInstantiations=new Set,this._services=c,this._strict=u,this._parent=S,this._services.set(y.IInstantiationService,this)}createChild(c){return new r(c,this._strict,this)}invokeFunction(c,...u){let S=l.traceInvocation(c),w=!1;try{return c({get:(d,h)=>{if(w)throw p.illegalState("service accessor is only valid during the invocation of its target method");const g=this._getOrCreateServiceInstance(d,S);if(!g&&h!==y.optional)throw new Error(`[invokeFunction] unknown service '${d}'`);return g}},...u)}finally{w=!0,S.stop()}}createInstance(c,...u){let S,w;return c instanceof C.SyncDescriptor?(S=l.traceCreation(c.ctor),w=this._createInstance(c.ctor,c.staticArguments.concat(u),S)):(S=l.traceCreation(c),w=this._createInstance(c,u,S)),S.stop(),w}_createInstance(c,u=[],S){let w=y._util.getServiceDependencies(c).sort((h,g)=>h.index-g.index),b=[];for(const h of w){let g=this._getOrCreateServiceInstance(h.id,S);if(!g&&this._strict&&!h.optional)throw new Error(`[createInstance] ${c.name} depends on UNKNOWN service ${h.id}.`);b.push(g)}let d=w.length>0?w[0].index:u.length;if(u.length!==d){console.warn(`[createInstance] First service dependency of ${c.name} at position ${d+1} conflicts with ${u.length} static arguments`);let h=d-u.length;h>0?u=u.concat(new Array(h)):u=u.slice(0,d)}return new c(...[...u,...b])}_setServiceInstance(c,u){if(this._services.get(c)instanceof C.SyncDescriptor)this._services.set(c,u);else if(this._parent)this._parent._setServiceInstance(c,u);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(c){let u=this._services.get(c);return!u&&this._parent?this._parent._getServiceInstanceOrDescriptor(c):u}_getOrCreateServiceInstance(c,u){let S=this._getServiceInstanceOrDescriptor(c);return S instanceof C.SyncDescriptor?this._safeCreateAndCacheServiceInstance(c,S,u.branch(c,!0)):(u.branch(c,!1),S)}_safeCreateAndCacheServiceInstance(c,u,S){if(this._activeInstantiations.has(c))throw new Error(`illegal state - RECURSIVELY instantiating service '${c}'`);this._activeInstantiations.add(c);try{return this._createAndCacheServiceInstance(c,u,S)}finally{this._activeInstantiations.delete(c)}}_createAndCacheServiceInstance(c,u,S){const w=new R.Graph(h=>h.id.toString());let b=0;const d=[{id:c,desc:u,_trace:S}];for(;d.length;){const h=d.pop();if(w.lookupOrInsertNode(h),b++>1e3)throw new k(w);for(let g of y._util.getServiceDependencies(h.desc.ctor)){let t=this._getServiceInstanceOrDescriptor(g.id);if(!t&&!g.optional&&console.warn(`[createInstance] ${c} depends on ${g.id} which is NOT registered.`),t instanceof C.SyncDescriptor){const i={id:g.id,desc:t,_trace:h._trace.branch(g.id,!0)};w.insertEdge(h,i),d.push(i)}}}for(;;){const h=w.roots();if(h.length===0){if(!w.isEmpty())throw new k(w);break}for(const{data:g}of h){if(this._getServiceInstanceOrDescriptor(g.id)instanceof C.SyncDescriptor){const i=this._createServiceInstanceWithOwner(g.id,g.desc.ctor,g.desc.staticArguments,g.desc.supportsDelayedInstantiation,g._trace);this._setServiceInstance(g.id,i)}w.removeNode(g)}}return this._getServiceInstanceOrDescriptor(c)}_createServiceInstanceWithOwner(c,u,S=[],w,b){if(this._services.get(c)instanceof C.SyncDescriptor)return this._createServiceInstance(u,S,w,b);if(this._parent)return this._parent._createServiceInstanceWithOwner(c,u,S,w,b);throw new Error(`illegalState - creating UNKNOWN service instance ${u.name}`)}_createServiceInstance(c,u=[],S,w){if(S){const b=new P.IdleValue(()=>this._createInstance(c,u,w));return new Proxy(Object.create(null),{get(d,h){if(h in d)return d[h];let g=b.value,t=g[h];return typeof t!="function"||(t=t.bind(g),d[h]=t),t},set(d,h,g){return b.value[h]=g,!0}})}else return this._createInstance(c,u,w)}}e.InstantiationService=r;var I;(function(f){f[f.Creation=0]="Creation",f[f.Invocation=1]="Invocation",f[f.Branch=2]="Branch"})(I||(I={}));class l{constructor(c,u){this.type=c,this.name=u,this._start=Date.now(),this._dep=[]}static traceInvocation(c){return E?new l(1,c.name||c.toString().substring(0,42).replace(/\n/g,"")):l._None}static traceCreation(c){return E?new l(0,c.name):l._None}branch(c,u){let S=new l(2,c.toString());return this._dep.push([c,u,S]),S}stop(){let c=Date.now()-this._start;l._totals+=c;let u=!1;function S(b,d){let h=[],g=new Array(b+1).join("	");for(const[t,i,s]of d._dep)if(i&&s){u=!0,h.push(`${g}CREATES -> ${t}`);let n=S(b+1,s);n&&h.push(n)}else h.push(`${g}uses -> ${t}`);return h.join(`
`)}let w=[`${this.type===0?"CREATE":"CALL"} ${this.name}`,`${S(1,this)}`,`DONE, took ${c.toFixed(2)}ms (grand total ${l._totals.toFixed(2)}ms)`];(c>2||u)&&console.log(w.join(`
`))}}l._None=new class extends l{constructor(){super(-1,null)}stop(){}branch(){return this}},l._totals=0}),define(me[12],ge([0,1,4,6,11,3,57]),function(X,e,p,R,C,y,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogLevelToString=e.parseLogLevel=e.getLogLevel=e.NullLogService=e.AbstractLoggerService=e.LogService=e.MultiplexLogService=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=p.createDecorator("logService"),e.ILoggerService=p.createDecorator("loggerService");function P(){return new Date().toISOString()}var E;(function(g){g[g.Trace=0]="Trace",g[g.Debug=1]="Debug",g[g.Info=2]="Info",g[g.Warning=3]="Warning",g[g.Error=4]="Error",g[g.Critical=5]="Critical",g[g.Off=6]="Off"})(E=e.LogLevel||(e.LogLevel={})),e.DEFAULT_LOG_LEVEL=E.Info;class k extends R.Disposable{constructor(){super(...arguments);this.level=e.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new y.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(t){this.level!==t&&(this.level=t,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}}e.AbstractLogger=k;class r extends k{constructor(t){super();this.logAlways=t}checkLogLevel(t){return this.logAlways||this.getLevel()<=t}trace(t,...i){this.checkLogLevel(E.Trace)&&this.log(E.Trace,this.format([t,...i]))}debug(t,...i){this.checkLogLevel(E.Debug)&&this.log(E.Debug,this.format([t,...i]))}info(t,...i){this.checkLogLevel(E.Info)&&this.log(E.Info,this.format([t,...i]))}warn(t,...i){this.checkLogLevel(E.Warning)&&this.log(E.Warning,this.format([t,...i]))}error(t,...i){if(this.checkLogLevel(E.Error))if(t instanceof Error){const s=Array.prototype.slice.call(arguments);s[0]=t.stack,this.log(E.Error,this.format(s))}else this.log(E.Error,this.format([t,...i]))}critical(t,...i){this.checkLogLevel(E.Critical)&&this.log(E.Critical,this.format([t,...i]))}flush(){}format(t){let i="";for(let s=0;s<t.length;s++){let n=t[s];if(typeof n=="object")try{n=JSON.stringify(n)}catch(o){}i+=(s>0?" ":"")+n}return i}}e.AbstractMessageLogger=r;class I extends k{constructor(t=e.DEFAULT_LOG_LEVEL){super();this.setLevel(t),this.useColors=!C.isWindows}trace(t,...i){this.getLevel()<=E.Trace&&(this.useColors?console.log(`[90m[main ${P()}][0m`,t,...i):console.log(`[main ${P()}]`,t,...i))}debug(t,...i){this.getLevel()<=E.Debug&&(this.useColors?console.log(`[90m[main ${P()}][0m`,t,...i):console.log(`[main ${P()}]`,t,...i))}info(t,...i){this.getLevel()<=E.Info&&(this.useColors?console.log(`[90m[main ${P()}][0m`,t,...i):console.log(`[main ${P()}]`,t,...i))}warn(t,...i){this.getLevel()<=E.Warning&&(this.useColors?console.warn(`[93m[main ${P()}][0m`,t,...i):console.warn(`[main ${P()}]`,t,...i))}error(t,...i){this.getLevel()<=E.Error&&(this.useColors?console.error(`[91m[main ${P()}][0m`,t,...i):console.error(`[main ${P()}]`,t,...i))}critical(t,...i){this.getLevel()<=E.Critical&&(this.useColors?console.error(`[90m[main ${P()}][0m`,t,...i):console.error(`[main ${P()}]`,t,...i))}dispose(){}flush(){}}e.ConsoleMainLogger=I;class l extends k{constructor(t=e.DEFAULT_LOG_LEVEL){super();this.setLevel(t)}trace(t,...i){this.getLevel()<=E.Trace&&console.log("%cTRACE","color: #888",t,...i)}debug(t,...i){this.getLevel()<=E.Debug&&console.log("%cDEBUG","background: #eee; color: #888",t,...i)}info(t,...i){this.getLevel()<=E.Info&&console.log("%c INFO","color: #33f",t,...i)}warn(t,...i){this.getLevel()<=E.Warning&&console.log("%c WARN","color: #993",t,...i)}error(t,...i){this.getLevel()<=E.Error&&console.log("%c  ERR","color: #f33",t,...i)}critical(t,...i){this.getLevel()<=E.Critical&&console.log("%cCRITI","background: #f33; color: white",t,...i)}dispose(){}flush(){}}e.ConsoleLogger=l;class f extends k{constructor(t,i=e.DEFAULT_LOG_LEVEL){super();this.adapter=t,this.setLevel(i)}trace(t,...i){this.getLevel()<=E.Trace&&this.adapter.log(E.Trace,[this.extractMessage(t),...i])}debug(t,...i){this.getLevel()<=E.Debug&&this.adapter.log(E.Debug,[this.extractMessage(t),...i])}info(t,...i){this.getLevel()<=E.Info&&this.adapter.log(E.Info,[this.extractMessage(t),...i])}warn(t,...i){this.getLevel()<=E.Warning&&this.adapter.log(E.Warning,[this.extractMessage(t),...i])}error(t,...i){this.getLevel()<=E.Error&&this.adapter.log(E.Error,[this.extractMessage(t),...i])}critical(t,...i){this.getLevel()<=E.Critical&&this.adapter.log(E.Critical,[this.extractMessage(t),...i])}extractMessage(t){return typeof t=="string"?t:A.toErrorMessage(t,this.getLevel()<=E.Trace)}dispose(){}flush(){}}e.AdapterLogger=f;class c extends k{constructor(t){super();this.logServices=t,t.length&&this.setLevel(t[0].getLevel())}setLevel(t){for(const i of this.logServices)i.setLevel(t);super.setLevel(t)}trace(t,...i){for(const s of this.logServices)s.trace(t,...i)}debug(t,...i){for(const s of this.logServices)s.debug(t,...i)}info(t,...i){for(const s of this.logServices)s.info(t,...i)}warn(t,...i){for(const s of this.logServices)s.warn(t,...i)}error(t,...i){for(const s of this.logServices)s.error(t,...i)}critical(t,...i){for(const s of this.logServices)s.critical(t,...i)}flush(){for(const t of this.logServices)t.flush()}dispose(){for(const t of this.logServices)t.dispose()}}e.MultiplexLogService=c;class u extends R.Disposable{constructor(t){super();this.logger=t,this._register(t)}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(t){this.logger.setLevel(t)}getLevel(){return this.logger.getLevel()}trace(t,...i){this.logger.trace(t,...i)}debug(t,...i){this.logger.debug(t,...i)}info(t,...i){this.logger.info(t,...i)}warn(t,...i){this.logger.warn(t,...i)}error(t,...i){this.logger.error(t,...i)}critical(t,...i){this.logger.critical(t,...i)}flush(){this.logger.flush()}}e.LogService=u;class S extends R.Disposable{constructor(t,i){super();this.logLevel=t,this.loggers=new Map,this.logLevelChangeableLoggers=[],this._register(i(s=>{this.logLevel=s,this.logLevelChangeableLoggers.forEach(n=>n.setLevel(s))}))}createLogger(t,i){let s=this.loggers.get(t.toString());return s||(s=this.doCreateLogger(t,(i==null?void 0:i.always)?E.Trace:this.logLevel,i),this.loggers.set(t.toString(),s),(i==null?void 0:i.always)||this.logLevelChangeableLoggers.push(s)),s}dispose(){this.logLevelChangeableLoggers.splice(0,this.logLevelChangeableLoggers.length),this.loggers.forEach(t=>t.dispose()),this.loggers.clear(),super.dispose()}}e.AbstractLoggerService=S;class w{constructor(){this.onDidChangeLogLevel=new y.Emitter().event}setLevel(t){}getLevel(){return E.Info}trace(t,...i){}debug(t,...i){}info(t,...i){}warn(t,...i){}error(t,...i){}critical(t,...i){}dispose(){}flush(){}}e.NullLogService=w;function b(g){if(g.verbose)return E.Trace;if(typeof g.logLevel=="string"){const t=d(g.logLevel.toLowerCase());if(t!==void 0)return t}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=b;function d(g){switch(g){case"trace":return E.Trace;case"debug":return E.Debug;case"info":return E.Info;case"warn":return E.Warning;case"error":return E.Error;case"critical":return E.Critical;case"off":return E.Off}}e.parseLogLevel=d;function h(g){switch(g){case E.Trace:return"trace";case E.Debug:return"debug";case E.Info:return"info";case E.Warning:return"warn";case E.Error:return"error";case E.Critical:return"critical";case E.Off:return"off"}}e.LogLevelToString=h}),define(me[112],ge([0,1,12,41]),function(X,e,p,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SpdLogLogger=e.createRotatingLogger=void 0;async function C(E,k,r,I){try{const l=await new Promise((f,c)=>{X(["spdlog"],f,c)});return l.setFlushOn(p.LogLevel.Trace),l.createAsyncRotatingLogger(E,k,r,I)}catch(l){console.error(l)}return null}function y(E,k,r,I){const l=X.__$__nodeRequire("spdlog");return l.setFlushOn(p.LogLevel.Trace),l.createRotatingLogger(E,k,r,I)}e.createRotatingLogger=y;function A(E,k,r){switch(k){case p.LogLevel.Trace:E.trace(r);break;case p.LogLevel.Debug:E.debug(r);break;case p.LogLevel.Info:E.info(r);break;case p.LogLevel.Warning:E.warn(r);break;case p.LogLevel.Error:E.error(r);break;case p.LogLevel.Critical:E.critical(r);break;default:throw new Error("Invalid log level")}}class P extends p.AbstractMessageLogger{constructor(k,r,I,l){super();this.name=k,this.filepath=r,this.rotating=I,this.buffer=[],this.setLevel(l),this._loggerCreationPromise=this._createSpdLogLogger(),this._register(this.onDidChangeLogLevel(f=>{this._logger&&this._logger.setLevel(f)}))}_createSpdLogLogger(){const k=this.rotating?6:1,r=30/k*R.ByteSize.MB;return C(this.name,this.filepath,r,k).then(I=>{if(I){this._logger=I,this._logger.setLevel(this.getLevel());for(const{level:l,message:f}of this.buffer)A(this._logger,l,f);this.buffer=[]}})}log(k,r){this._logger?A(this._logger,k,r):this.getLevel()<=k&&this.buffer.push({level:k,message:r})}clearFormatters(){this._logger?this._logger.clearFormatters():this._loggerCreationPromise.then(()=>this.clearFormatters())}flush(){this._logger?this._logger.flush():this._loggerCreationPromise.then(()=>this.flush())}dispose(){this._logger?this.disposeLogger():this._loggerCreationPromise.then(()=>this.disposeLogger())}disposeLogger(){this._logger&&(this._logger.drop(),this._logger=void 0)}}e.SpdLogLogger=P}),define(me[113],ge([0,1,4,156,54]),function(X,e,p,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IMarkerService=e.IMarkerData=e.MarkerSeverity=e.MarkerTag=void 0;var y;(function(E){E[E.Unnecessary=1]="Unnecessary",E[E.Deprecated=2]="Deprecated"})(y=e.MarkerTag||(e.MarkerTag={}));var A;(function(E){E[E.Hint=1]="Hint",E[E.Info=2]="Info",E[E.Warning=4]="Warning",E[E.Error=8]="Error"})(A=e.MarkerSeverity||(e.MarkerSeverity={})),function(E){function k(c,u){return u-c}E.compare=k;const r=Object.create(null);r[E.Error]=R.localize(0,null),r[E.Warning]=R.localize(1,null),r[E.Info]=R.localize(2,null);function I(c){return r[c]||""}E.toString=I;function l(c){switch(c){case C.default.Error:return E.Error;case C.default.Warning:return E.Warning;case C.default.Info:return E.Info;case C.default.Ignore:return E.Hint}}E.fromSeverity=l;function f(c){switch(c){case E.Error:return C.default.Error;case E.Warning:return C.default.Warning;case E.Info:return C.default.Info;case E.Hint:return C.default.Ignore}}E.toSeverity=f}(A=e.MarkerSeverity||(e.MarkerSeverity={}));var P;(function(E){const k="";function r(l){return I(l,!0)}E.makeKey=r;function I(l,f){let c=[k];return l.source?c.push(l.source.replace("\xA6","\\\xA6")):c.push(k),l.code?typeof l.code=="string"?c.push(l.code.replace("\xA6","\\\xA6")):c.push(l.code.value.replace("\xA6","\\\xA6")):c.push(k),l.severity!==void 0&&l.severity!==null?c.push(A.toString(l.severity)):c.push(k),l.message&&f?c.push(l.message.replace("\xA6","\\\xA6")):c.push(k),l.startLineNumber!==void 0&&l.startLineNumber!==null?c.push(l.startLineNumber.toString()):c.push(k),l.startColumn!==void 0&&l.startColumn!==null?c.push(l.startColumn.toString()):c.push(k),l.endLineNumber!==void 0&&l.endLineNumber!==null?c.push(l.endLineNumber.toString()):c.push(k),l.endColumn!==void 0&&l.endColumn!==null?c.push(l.endColumn.toString()):c.push(k),c.push(k),c.join("\xA6")}E.makeKeyOptionalMessage=I})(P=e.IMarkerData||(e.IMarkerData={})),e.IMarkerService=p.createDecorator("markerService")}),define(me[182],ge([0,1,54,4,3]),function(X,e,p,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NoOpProgress=e.NoOpNotification=e.NotificationsFilter=e.NeverShowAgainScope=e.INotificationService=e.Severity=void 0,e.Severity=p.default,e.INotificationService=R.createDecorator("notificationService");var y;(function(k){k[k.WORKSPACE=0]="WORKSPACE",k[k.GLOBAL=1]="GLOBAL"})(y=e.NeverShowAgainScope||(e.NeverShowAgainScope={}));var A;(function(k){k[k.OFF=0]="OFF",k[k.SILENT=1]="SILENT",k[k.ERROR=2]="ERROR"})(A=e.NotificationsFilter||(e.NotificationsFilter={}));class P{constructor(){this.progress=new E,this.onDidClose=C.Event.None,this.onDidChangeVisibility=C.Event.None}updateSeverity(r){}updateMessage(r){}updateActions(r){}close(){}}e.NoOpNotification=P;class E{infinite(){}done(){}total(r){}worked(r){}}e.NoOpProgress=E}),define(me[183],ge([0,1,6,8,2,4]),function(X,e,p,R,C,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.matchesScheme=e.NullOpenerService=e.IOpenerService=void 0,e.IOpenerService=y.createDecorator("openerService"),e.NullOpenerService=Object.freeze({_serviceBrand:void 0,registerOpener(){return p.Disposable.None},registerValidator(){return p.Disposable.None},registerExternalUriResolver(){return p.Disposable.None},setDefaultExternalOpener(){},registerExternalOpener(){return p.Disposable.None},async open(){return!1},async resolveExternalUri(P){return{resolved:P,dispose(){}}}});function A(P,E){return C.URI.isUri(P)?R.equalsIgnoreCase(P.scheme,E):R.startsWithIgnoreCase(P,E+":")}e.matchesScheme=A}),define(me[184],ge([0,1,10,11,37,24]),function(X,e,p,R,C,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let A;if(typeof R.globals.vscode!="undefined"&&typeof R.globals.vscode.context!="undefined"){const P=R.globals.vscode.context.configuration();if(P)A=P.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(typeof(X==null?void 0:X.__$__nodeRequire)=="function"){const P=y.dirname(p.FileAccess.asFileUri("",X));A=X.__$__nodeRequire(y.joinPath(P,"product.json").fsPath);const E=X.__$__nodeRequire(y.joinPath(P,"package.json").fsPath);C.env.VSCODE_DEV&&Object.assign(A,{nameShort:`${A.nameShort} Dev`,nameLong:`${A.nameLong} Dev`,dataFolderName:`${A.dataFolderName}-dev`}),Object.assign(A,{version:E.version})}else A={},Object.keys(A).length===0&&Object.assign(A,{version:"1.58.0-dev",nameShort:R.isWeb?"Code Web - OSS Dev":"Code - OSS Dev",nameLong:R.isWeb?"Code Web - OSS Dev":"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt",extensionAllowedProposedApi:["ms-vscode.vscode-js-profile-flame","ms-vscode.vscode-js-profile-table","ms-vscode.remotehub","ms-vscode.remotehub-insiders","GitHub.remotehub","GitHub.remotehub-insiders"]});e.default=A});var We=this&&this.__param||function(X,e){return function(p,R){e(p,R,X)}};define(me[114],ge([0,1,4,21,6,16]),function(X,e,p,R,C,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IEditorProgressService=e.LongRunningOperation=e.UnmanagedProgress=e.Progress=e.emptyProgressRunner=e.ProgressLocation=e.IProgressService=void 0,e.IProgressService=p.createDecorator("progressService");var A;(function(r){r[r.Explorer=1]="Explorer",r[r.Scm=3]="Scm",r[r.Extensions=5]="Extensions",r[r.Window=10]="Window",r[r.Notification=15]="Notification",r[r.Dialog=20]="Dialog"})(A=e.ProgressLocation||(e.ProgressLocation={})),e.emptyProgressRunner=Object.freeze({total(){},worked(){},done(){}});class P{constructor(I){this.callback=I}get value(){return this._value}report(I){this._value=I,this.callback(this._value)}}e.Progress=P,P.None=Object.freeze({report(){}});let E=class extends C.Disposable{constructor(I,l){super();this.deferred=new y.DeferredPromise,l.withProgress(I,f=>(this.reporter=f,this.lastStep&&f.report(this.lastStep),this.deferred.p)),this._register(C.toDisposable(()=>this.deferred.complete()))}report(I){this.reporter?this.reporter.report(I):this.lastStep=I}};E=Ve([We(1,e.IProgressService)],E),e.UnmanagedProgress=E;class k extends C.Disposable{constructor(I){super();this.progressIndicator=I,this.currentOperationId=0,this.currentOperationDisposables=this._register(new C.DisposableStore)}start(I){this.stop();const l=++this.currentOperationId,f=new R.CancellationTokenSource;return this.currentProgressTimeout=setTimeout(()=>{l===this.currentOperationId&&(this.currentProgressRunner=this.progressIndicator.show(!0))},I),this.currentOperationDisposables.add(C.toDisposable(()=>clearTimeout(this.currentProgressTimeout))),this.currentOperationDisposables.add(C.toDisposable(()=>f.cancel())),this.currentOperationDisposables.add(C.toDisposable(()=>this.currentProgressRunner?this.currentProgressRunner.done():void 0)),{id:l,token:f.token,stop:()=>this.doStop(l),isCurrent:()=>this.currentOperationId===l}}stop(){this.doStop(this.currentOperationId)}doStop(I){this.currentOperationId===I&&this.currentOperationDisposables.clear()}}e.LongRunningOperation=k,e.IEditorProgressService=p.createDecorator("editorProgressService")}),define(me[58],ge([0,1,15,50]),function(X,e,p,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class C{constructor(){this.data=new Map}add(A,P){R.ok(p.isString(A)),R.ok(p.isObject(P)),R.ok(!this.data.has(A),"There is already an extension with this id"),this.data.set(A,P)}knows(A){return this.data.has(A)}as(A){return this.data.get(A)||null}}e.Registry=new C}),define(me[185],ge([0,1,58,3]),function(X,e,p,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function C(P){return P.length>0&&P.charAt(P.length-1)==="#"?P.substring(0,P.length-1):P}class y{constructor(){this._onDidChangeSchema=new R.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(E,k){this.schemasById[C(E)]=k,this._onDidChangeSchema.fire(E)}notifySchemaChanged(E){this._onDidChangeSchema.fire(E)}getSchemaContributions(){return{schemas:this.schemasById}}}const A=new y;p.Registry.add(e.Extensions.JSONContribution,A)}),define(me[80],ge([0,1,151,3,58,15,185]),function(X,e,p,R,C,y,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.overrideIdentifierFromKey=e.OVERRIDE_PROPERTY_PATTERN=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=void 0,e.Extensions={Configuration:"base.contributions.configuration"};var P;(function(S){S[S.APPLICATION=1]="APPLICATION",S[S.MACHINE=2]="MACHINE",S[S.WINDOW=3]="WINDOW",S[S.RESOURCE=4]="RESOURCE",S[S.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",S[S.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(P=e.ConfigurationScope||(e.ConfigurationScope={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage";const E=C.Registry.as(A.Extensions.JSONContribution);class k{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new R.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new R.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.defaultValues={},this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:p.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!1,errorMessage:"Unknown editor configuration setting",allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.excludedConfigurationProperties={},E.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema)}registerConfiguration(w,b=!0){this.registerConfigurations([w],b)}registerConfigurations(w,b=!0){const d=[];w.forEach(h=>{d.push(...this.validateAndRegisterProperties(h,b,h.extensionInfo)),this.configurationContributors.push(h),this.registerJSONConfiguration(h)}),E.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(d)}deregisterConfigurations(w){const b=[],d=h=>{if(h.properties)for(const g in h.properties)b.push(g),delete this.configurationProperties[g],this.removeFromSchema(g,h.properties[g]);h.allOf&&h.allOf.forEach(g=>d(g))};for(const h of w){d(h);const g=this.configurationContributors.indexOf(h);g!==-1&&this.configurationContributors.splice(g,1)}E.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(b)}registerDefaultConfigurations(w){const b=[],d=[];for(const h of w)for(const g in h)if(b.push(g),e.OVERRIDE_PROPERTY_PATTERN.test(g)){this.defaultValues[g]=Object.assign(Object.assign({},this.defaultValues[g]||{}),h[g]);const t={type:"object",default:this.defaultValues[g],description:p.localize(1,null,g),$ref:e.resourceLanguageSettingsSchemaId};d.push(I(g)),this.configurationProperties[g]=t,this.defaultLanguageConfigurationOverridesNode.properties[g]=t}else{this.defaultValues[g]=h[g];const t=this.configurationProperties[g];t&&(this.updatePropertyDefaultValue(g,t),this.updateSchema(g,t))}this.registerOverrideIdentifiers(d),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(b)}deregisterDefaultConfigurations(w){const b=[];for(const d of w)for(const h in d)if(b.push(h),delete this.defaultValues[h],e.OVERRIDE_PROPERTY_PATTERN.test(h))delete this.configurationProperties[h],delete this.defaultLanguageConfigurationOverridesNode.properties[h];else{const g=this.configurationProperties[h];g&&(this.updatePropertyDefaultValue(h,g),this.updateSchema(h,g))}this.updateOverridePropertyPatternKey(),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(b)}notifyConfigurationSchemaUpdated(...w){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(w){for(const b of w)this.overrideIdentifiers.add(b);this.updateOverridePropertyPatternKey()}validateAndRegisterProperties(w,b=!0,d,h=3){var g;h=y.isUndefinedOrNull(w.scope)?h:w.scope;let t=[],i=w.properties;if(i)for(let n in i){if(b&&c(n)){delete i[n];continue}const o=i[n];if(this.updatePropertyDefaultValue(n,o),e.OVERRIDE_PROPERTY_PATTERN.test(n)?o.scope=void 0:(o.scope=y.isUndefinedOrNull(o.scope)?h:o.scope,o.restricted=y.isUndefinedOrNull(o.restricted)?!!((g=d==null?void 0:d.restrictedConfigurations)===null||g===void 0?void 0:g.includes(n)):o.restricted),i[n].hasOwnProperty("included")&&!i[n].included){this.excludedConfigurationProperties[n]=i[n],delete i[n];continue}else this.configurationProperties[n]=i[n];!i[n].deprecationMessage&&i[n].markdownDeprecationMessage&&(i[n].deprecationMessage=i[n].markdownDeprecationMessage),t.push(n)}let s=w.allOf;if(s)for(let n of s)t.push(...this.validateAndRegisterProperties(n,b,d,h));return t}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}registerJSONConfiguration(w){const b=d=>{let h=d.properties;if(h)for(const t in h)this.updateSchema(t,h[t]);let g=d.allOf;g&&g.forEach(b)};b(w)}updateSchema(w,b){switch(e.allSettings.properties[w]=b,b.scope){case 1:e.applicationSettings.properties[w]=b;break;case 2:e.machineSettings.properties[w]=b;break;case 6:e.machineOverridableSettings.properties[w]=b;break;case 3:e.windowSettings.properties[w]=b;break;case 4:e.resourceSettings.properties[w]=b;break;case 5:e.resourceSettings.properties[w]=b,this.resourceLanguageSettingsSchema.properties[w]=b;break}}removeFromSchema(w,b){switch(delete e.allSettings.properties[w],b.scope){case 1:delete e.applicationSettings.properties[w];break;case 2:delete e.machineSettings.properties[w];break;case 6:delete e.machineOverridableSettings.properties[w];break;case 3:delete e.windowSettings.properties[w];break;case 4:case 5:delete e.resourceSettings.properties[w];break}}updateOverridePropertyPatternKey(){for(const w of this.overrideIdentifiers.values()){const b=`[${w}]`,d={type:"object",description:p.localize(2,null),errorMessage:p.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(b,d),e.allSettings.properties[b]=d,e.applicationSettings.properties[b]=d,e.machineSettings.properties[b]=d,e.machineOverridableSettings.properties[b]=d,e.windowSettings.properties[b]=d,e.resourceSettings.properties[b]=d}this._onDidSchemaChange.fire()}updatePropertyDefaultValue(w,b){let d=this.defaultValues[w];y.isUndefined(d)&&(d=b.default),y.isUndefined(d)&&(d=l(b.type)),b.default=d}}const r="\\[.*\\]$";e.OVERRIDE_PROPERTY_PATTERN=new RegExp(r);function I(S){return S.substring(1,S.length-1)}e.overrideIdentifierFromKey=I;function l(S){switch(Array.isArray(S)?S[0]:S){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=l;const f=new k;C.Registry.add(e.Extensions.Configuration,f);function c(S){return S.trim()?e.OVERRIDE_PROPERTY_PATTERN.test(S)?p.localize(5,null,S):f.getConfigurationProperties()[S]!==void 0?p.localize(6,null,S):null:p.localize(4,null)}e.validateProperty=c;function u(){const S=[],w=f.getConfigurationProperties();for(const b of Object.keys(w))S.push([b,w[b].scope]);return S.push(["launch",4]),S.push(["task",4]),S}e.getScopes=u}),define(me[115],ge([0,1,25,15,2,58,4,80]),function(X,e,p,R,C,y,A,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMigratedSettingValue=e.keyFromOverrideIdentifier=e.getDefaultValues=e.getConfigurationKeys=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.toOverrides=e.compare=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=A.createDecorator("configurationService");function E(i){return i&&typeof i=="object"&&(!i.overrideIdentifier||typeof i.overrideIdentifier=="string")&&(!i.resource||i.resource instanceof C.URI)}e.isConfigurationOverrides=E;var k;(function(i){i[i.USER=1]="USER",i[i.USER_LOCAL=2]="USER_LOCAL",i[i.USER_REMOTE=3]="USER_REMOTE",i[i.WORKSPACE=4]="WORKSPACE",i[i.WORKSPACE_FOLDER=5]="WORKSPACE_FOLDER",i[i.DEFAULT=6]="DEFAULT",i[i.MEMORY=7]="MEMORY"})(k=e.ConfigurationTarget||(e.ConfigurationTarget={}));function r(i){switch(i){case 1:return"USER";case 2:return"USER_LOCAL";case 3:return"USER_REMOTE";case 4:return"WORKSPACE";case 5:return"WORKSPACE_FOLDER";case 6:return"DEFAULT";case 7:return"MEMORY"}}e.ConfigurationTargetToString=r;function I(i,s){const n=s?i?s.keys.filter(T=>i.keys.indexOf(T)===-1):[...s.keys]:[],o=i?s?i.keys.filter(T=>s.keys.indexOf(T)===-1):[...i.keys]:[],v=[];if(s&&i){for(const T of i.keys)if(s.keys.indexOf(T)!==-1){const L=w(i.contents,T),U=w(s.contents,T);p.equals(L,U)||v.push(T)}}const m=[],_=T=>{const L={};for(const U of T)for(const G of U.identifiers)L[g(G)]=U;return L},D=s?_(s.overrides):{},a=i?_(i.overrides):{};if(Object.keys(D).length)for(const T of n){const L=D[T];L&&m.push([P.overrideIdentifierFromKey(T),L.keys])}if(Object.keys(a).length)for(const T of o){const L=a[T];L&&m.push([P.overrideIdentifierFromKey(T),L.keys])}if(Object.keys(D).length&&Object.keys(a).length)for(const T of v){const L=a[T],U=D[T];if(L&&U){const G=I({contents:L.contents,keys:L.keys,overrides:[]},{contents:U.contents,keys:U.keys,overrides:[]});m.push([P.overrideIdentifierFromKey(T),[...G.added,...G.removed,...G.updated]])}}return{added:n,removed:o,updated:v,overrides:m}}e.compare=I;function l(i,s){const n=[];for(const o of Object.keys(i))if(P.OVERRIDE_PROPERTY_PATTERN.test(o)){const v={};for(const m in i[o])v[m]=i[o][m];n.push({identifiers:[P.overrideIdentifierFromKey(o).trim()],keys:Object.keys(v),contents:f(v,s)})}return n}e.toOverrides=l;function f(i,s){const n=Object.create(null);for(let o in i)c(n,o,i[o],s);return n}e.toValuesTree=f;function c(i,s,n,o){const v=s.split("."),m=v.pop();let _=i;for(let D=0;D<v.length;D++){let a=v[D],T=_[a];switch(typeof T){case"undefined":T=_[a]=Object.create(null);break;case"object":break;default:o(`Ignoring ${s} as ${v.slice(0,D+1).join(".")} is ${JSON.stringify(T)}`);return}_=T}if(typeof _=="object"&&_!==null)try{_[m]=n}catch(D){o(`Ignoring ${s} as ${v.join(".")} is ${JSON.stringify(_)}`)}else o(`Ignoring ${s} as ${v.join(".")} is ${JSON.stringify(_)}`)}e.addToValueTree=c;function u(i,s){const n=s.split(".");S(i,n)}e.removeFromValueTree=u;function S(i,s){const n=s.shift();if(s.length===0){delete i[n];return}if(Object.keys(i).indexOf(n)!==-1){const o=i[n];typeof o=="object"&&!Array.isArray(o)&&(S(o,s),Object.keys(o).length===0&&delete i[n])}}function w(i,s,n){function o(_,D){let a=_;for(const T of D){if(typeof a!="object"||a===null)return;a=a[T]}return a}const v=s.split("."),m=o(i,v);return typeof m=="undefined"?n:m}e.getConfigurationValue=w;function b(i,s,n){Object.keys(s).forEach(o=>{o!=="__proto__"&&(o in i?R.isObject(i[o])&&R.isObject(s[o])?b(i[o],s[o],n):n&&(i[o]=s[o]):i[o]=s[o])})}e.merge=b;function d(){const i=y.Registry.as(P.Extensions.Configuration).getConfigurationProperties();return Object.keys(i)}e.getConfigurationKeys=d;function h(){const i=Object.create(null),s=y.Registry.as(P.Extensions.Configuration).getConfigurationProperties();for(let n in s){let o=s[n].default;c(i,n,o,v=>console.error(`Conflict in default settings: ${v}`))}return i}e.getDefaultValues=h;function g(i){return`[${i}]`}e.keyFromOverrideIdentifier=g;function t(i,s,n){const o=i.inspect(s),v=i.inspect(n);return typeof o.userValue!="undefined"||typeof o.workspaceValue!="undefined"||typeof o.workspaceFolderValue!="undefined"?o.value:typeof v.userValue!="undefined"||typeof v.workspaceValue!="undefined"||typeof v.workspaceFolderValue!="undefined"?v.value:o.defaultValue}e.getMigratedSettingValue=t}),define(me[186],ge([0,1,53,23,18,15,25,2,80,115,58,6,3]),function(X,e,p,R,C,y,A,P,E,k,r,I,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AllKeysConfigurationChangeEvent=e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.DefaultConfigurationModel=e.ConfigurationModel=void 0;class f{constructor(t={},i=[],s=[]){this._contents=t,this._keys=i,this._overrides=s,this.isFrozen=!1}get contents(){return this.checkAndFreeze(this._contents)}get overrides(){return this.checkAndFreeze(this._overrides)}get keys(){return this.checkAndFreeze(this._keys)}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}getValue(t){return t?k.getConfigurationValue(this.contents,t):this.contents}getOverrideValue(t,i){const s=this.getContentsForOverrideIdentifer(i);return s?t?k.getConfigurationValue(s,t):s:void 0}getKeysForOverrideIdentifier(t){for(const i of this.overrides)if(i.identifiers.indexOf(t)!==-1)return i.keys;return[]}override(t){const i=this.getContentsForOverrideIdentifer(t);if(!i||typeof i!="object"||!Object.keys(i).length)return this;let s={};for(const n of C.distinct([...Object.keys(this.contents),...Object.keys(i)])){let o=this.contents[n],v=i[n];v&&(typeof o=="object"&&typeof v=="object"?(o=A.deepClone(o),this.mergeContents(o,v)):o=v),s[n]=o}return new f(s,this.keys,this.overrides)}merge(...t){const i=A.deepClone(this.contents),s=A.deepClone(this.overrides),n=[...this.keys];for(const o of t){this.mergeContents(i,o.contents);for(const v of o.overrides){const[m]=s.filter(_=>C.equals(_.identifiers,v.identifiers));m?this.mergeContents(m.contents,v.contents):s.push(A.deepClone(v))}for(const v of o.keys)n.indexOf(v)===-1&&n.push(v)}return new f(i,n,s)}freeze(){return this.isFrozen=!0,this}mergeContents(t,i){for(const s of Object.keys(i)){if(s in t&&y.isObject(t[s])&&y.isObject(i[s])){this.mergeContents(t[s],i[s]);continue}t[s]=A.deepClone(i[s])}}checkAndFreeze(t){return this.isFrozen&&!Object.isFrozen(t)?A.deepFreeze(t):t}getContentsForOverrideIdentifer(t){for(const i of this.overrides)if(i.identifiers.indexOf(t)!==-1)return i.contents;return null}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}setValue(t,i){this.addKey(t),k.addToValueTree(this.contents,t,i,s=>{throw new Error(s)})}removeValue(t){this.removeKey(t)&&k.removeFromValueTree(this.contents,t)}addKey(t){let i=this.keys.length;for(let s=0;s<i;s++)t.indexOf(this.keys[s])===0&&(i=s);this.keys.splice(i,1,t)}removeKey(t){let i=this.keys.indexOf(t);return i!==-1?(this.keys.splice(i,1),!0):!1}}e.ConfigurationModel=f;class c extends f{constructor(){const t=k.getDefaultValues(),i=k.getConfigurationKeys(),s=[];for(const n of Object.keys(t))E.OVERRIDE_PROPERTY_PATTERN.test(n)&&s.push({identifiers:[E.overrideIdentifierFromKey(n).trim()],keys:Object.keys(t[n]),contents:k.toValuesTree(t[n],o=>console.error(`Conflict in default settings file: ${o}`))});super(t,i,s)}}e.DefaultConfigurationModel=c;class u{constructor(t){this._name=t,this._raw=null,this._configurationModel=null,this._restrictedConfigurations=[],this._parseErrors=[]}get configurationModel(){return this._configurationModel||new f}get restrictedConfigurations(){return this._restrictedConfigurations}get errors(){return this._parseErrors}parse(t,i){if(!y.isUndefinedOrNull(t)){const s=this.doParseContent(t);this.parseRaw(s,i)}}reparse(t){this._raw&&this.parseRaw(this._raw,t)}parseRaw(t,i){this._raw=t;const{contents:s,keys:n,overrides:o,restricted:v}=this.doParseRaw(t,i);this._configurationModel=new f(s,n,o),this._restrictedConfigurations=v||[]}doParseContent(t){let i={},s=null,n=[],o=[],v=[];function m(D){Array.isArray(n)?n.push(D):s&&(n[s]=D)}let _={onObjectBegin:()=>{let D={};m(D),o.push(n),n=D,s=null},onObjectProperty:D=>{s=D},onObjectEnd:()=>{n=o.pop()},onArrayBegin:()=>{let D=[];m(D),o.push(n),n=D,s=null},onArrayEnd:()=>{n=o.pop()},onLiteralValue:m,onError:(D,a,T)=>{v.push({error:D,offset:a,length:T})}};if(t)try{p.visit(t,_),i=n[0]||{}}catch(D){console.error(`Error while parsing settings file ${this._name}: ${D}`),this._parseErrors=[D]}return i}doParseRaw(t,i){const s=r.Registry.as(E.Extensions.Configuration).getConfigurationProperties(),n=this.filter(t,s,!0,i);t=n.raw;const o=k.toValuesTree(t,_=>console.error(`Conflict in settings file ${this._name}: ${_}`)),v=Object.keys(t),m=k.toOverrides(t,_=>console.error(`Conflict in settings file ${this._name}: ${_}`));return{contents:o,keys:v,overrides:m,restricted:n.restricted}}filter(t,i,s,n){if(!(n==null?void 0:n.scopes)&&!(n==null?void 0:n.skipRestricted))return{raw:t,restricted:[]};const o={},v=[];for(let m in t)if(E.OVERRIDE_PROPERTY_PATTERN.test(m)&&s){const _=this.filter(t[m],i,!1,n);o[m]=_.raw,v.push(..._.restricted)}else{const _=i[m],D=_?typeof _.scope!="undefined"?_.scope:3:void 0;(_==null?void 0:_.restricted)&&v.push(m),(D===void 0||n.scopes===void 0||n.scopes.includes(D))&&(n.skipRestricted&&(_==null?void 0:_.restricted)||(o[m]=t[m]))}return{raw:o,restricted:v}}}e.ConfigurationModelParser=u;class S extends I.Disposable{constructor(t,i,s,n){super();this.userSettingsResource=t,this.scopes=i,this.fileService=n,this._onDidChange=this._register(new l.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new u(this.userSettingsResource.toString()),this.parseOptions={scopes:this.scopes},this._register(this.fileService.watch(s.dirname(this.userSettingsResource))),this._register(this.fileService.watch(this.userSettingsResource)),this._register(l.Event.filter(this.fileService.onDidFilesChange,o=>o.contains(this.userSettingsResource))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const t=await this.fileService.readFile(this.userSettingsResource);return this.parser.parse(t.value.toString()||"{}",this.parseOptions),this.parser.configurationModel}catch(t){return new f}}reparse(){return this.parser.reparse(this.parseOptions),this.parser.configurationModel}getRestrictedSettings(){return this.parser.restrictedConfigurations}}e.UserSettings=S;class w{constructor(t,i,s=new f,n=new f,o=new R.ResourceMap,v=new f,m=new R.ResourceMap,_=!0){this._defaultConfiguration=t,this._localUserConfiguration=i,this._remoteUserConfiguration=s,this._workspaceConfiguration=n,this._folderConfigurations=o,this._memoryConfiguration=v,this._memoryConfigurationByResource=m,this._freeze=_,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new R.ResourceMap,this._userConfiguration=null}getValue(t,i,s){return this.getConsolidateConfigurationModel(i,s).getValue(t)}updateValue(t,i,s={}){let n;s.resource?(n=this._memoryConfigurationByResource.get(s.resource),n||(n=new f,this._memoryConfigurationByResource.set(s.resource,n))):n=this._memoryConfiguration,i===void 0?n.removeValue(t):n.setValue(t,i),s.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(t,i,s){const n=this.getConsolidateConfigurationModel(i,s),o=this.getFolderConfigurationModelForResource(i.resource,s),v=i.resource?this._memoryConfigurationByResource.get(i.resource)||this._memoryConfiguration:this._memoryConfiguration,m=i.overrideIdentifier?this._defaultConfiguration.freeze().override(i.overrideIdentifier).getValue(t):this._defaultConfiguration.freeze().getValue(t),_=i.overrideIdentifier?this.userConfiguration.freeze().override(i.overrideIdentifier).getValue(t):this.userConfiguration.freeze().getValue(t),D=i.overrideIdentifier?this.localUserConfiguration.freeze().override(i.overrideIdentifier).getValue(t):this.localUserConfiguration.freeze().getValue(t),a=i.overrideIdentifier?this.remoteUserConfiguration.freeze().override(i.overrideIdentifier).getValue(t):this.remoteUserConfiguration.freeze().getValue(t),T=s?i.overrideIdentifier?this._workspaceConfiguration.freeze().override(i.overrideIdentifier).getValue(t):this._workspaceConfiguration.freeze().getValue(t):void 0,L=o?i.overrideIdentifier?o.freeze().override(i.overrideIdentifier).getValue(t):o.freeze().getValue(t):void 0,U=i.overrideIdentifier?v.override(i.overrideIdentifier).getValue(t):v.getValue(t),G=n.getValue(t),ee=C.distinct(C.flatten(n.overrides.map(z=>z.identifiers))).filter(z=>n.getOverrideValue(t,z)!==void 0);return{defaultValue:m,userValue:_,userLocalValue:D,userRemoteValue:a,workspaceValue:T,workspaceFolderValue:L,memoryValue:U,value:G,default:m!==void 0?{value:this._defaultConfiguration.freeze().getValue(t),override:i.overrideIdentifier?this._defaultConfiguration.freeze().getOverrideValue(t,i.overrideIdentifier):void 0}:void 0,user:_!==void 0?{value:this.userConfiguration.freeze().getValue(t),override:i.overrideIdentifier?this.userConfiguration.freeze().getOverrideValue(t,i.overrideIdentifier):void 0}:void 0,userLocal:D!==void 0?{value:this.localUserConfiguration.freeze().getValue(t),override:i.overrideIdentifier?this.localUserConfiguration.freeze().getOverrideValue(t,i.overrideIdentifier):void 0}:void 0,userRemote:a!==void 0?{value:this.remoteUserConfiguration.freeze().getValue(t),override:i.overrideIdentifier?this.remoteUserConfiguration.freeze().getOverrideValue(t,i.overrideIdentifier):void 0}:void 0,workspace:T!==void 0?{value:this._workspaceConfiguration.freeze().getValue(t),override:i.overrideIdentifier?this._workspaceConfiguration.freeze().getOverrideValue(t,i.overrideIdentifier):void 0}:void 0,workspaceFolder:L!==void 0?{value:o==null?void 0:o.freeze().getValue(t),override:i.overrideIdentifier?o==null?void 0:o.freeze().getOverrideValue(t,i.overrideIdentifier):void 0}:void 0,memory:U!==void 0?{value:v.getValue(t),override:i.overrideIdentifier?v.getOverrideValue(t,i.overrideIdentifier):void 0}:void 0,overrideIdentifiers:ee.length?ee:void 0}}keys(t){const i=this.getFolderConfigurationModelForResource(void 0,t);return{default:this._defaultConfiguration.freeze().keys,user:this.userConfiguration.freeze().keys,workspace:this._workspaceConfiguration.freeze().keys,workspaceFolder:i?i.freeze().keys:[]}}updateDefaultConfiguration(t){this._defaultConfiguration=t,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(t){this._localUserConfiguration=t,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(t){this._remoteUserConfiguration=t,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(t){this._workspaceConfiguration=t,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(t,i){this._folderConfigurations.set(t,i),this._foldersConsolidatedConfigurations.delete(t)}deleteFolderConfiguration(t){this.folderConfigurations.delete(t),this._foldersConsolidatedConfigurations.delete(t)}compareAndUpdateDefaultConfiguration(t,i){const s=i.filter(n=>E.OVERRIDE_PROPERTY_PATTERN.test(n)).map(n=>{const o=E.overrideIdentifierFromKey(n),v=this._defaultConfiguration.getKeysForOverrideIdentifier(o),m=t.getKeysForOverrideIdentifier(o),_=[...m.filter(D=>v.indexOf(D)===-1),...v.filter(D=>m.indexOf(D)===-1),...v.filter(D=>!A.equals(this._defaultConfiguration.override(o).getValue(D),t.override(o).getValue(D)))];return[o,_]});return this.updateDefaultConfiguration(t),{keys:i,overrides:s}}compareAndUpdateLocalUserConfiguration(t){const{added:i,updated:s,removed:n,overrides:o}=k.compare(this.localUserConfiguration,t),v=[...i,...s,...n];return v.length&&this.updateLocalUserConfiguration(t),{keys:v,overrides:o}}compareAndUpdateRemoteUserConfiguration(t){const{added:i,updated:s,removed:n,overrides:o}=k.compare(this.remoteUserConfiguration,t);let v=[...i,...s,...n];return v.length&&this.updateRemoteUserConfiguration(t),{keys:v,overrides:o}}compareAndUpdateWorkspaceConfiguration(t){const{added:i,updated:s,removed:n,overrides:o}=k.compare(this.workspaceConfiguration,t);let v=[...i,...s,...n];return v.length&&this.updateWorkspaceConfiguration(t),{keys:v,overrides:o}}compareAndUpdateFolderConfiguration(t,i){const s=this.folderConfigurations.get(t),{added:n,updated:o,removed:v,overrides:m}=k.compare(s,i);let _=[...n,...o,...v];return(_.length||!s)&&this.updateFolderConfiguration(t,i),{keys:_,overrides:m}}compareAndDeleteFolderConfiguration(t){const i=this.folderConfigurations.get(t);if(!i)throw new Error("Unknown folder");this.deleteFolderConfiguration(t);const{added:s,updated:n,removed:o,overrides:v}=k.compare(i,void 0);return{keys:[...s,...n,...o],overrides:v}}get defaults(){return this._defaultConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration),this._freeze&&this._userConfiguration.freeze()),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidateConfigurationModel(t,i){let s=this.getConsolidatedConfigurationModelForResource(t,i);return t.overrideIdentifier?s.override(t.overrideIdentifier):s}getConsolidatedConfigurationModelForResource({resource:t},i){let s=this.getWorkspaceConsolidatedConfiguration();if(i&&t){const n=i.getFolder(t);n&&(s=this.getFolderConsolidatedConfiguration(n.uri)||s);const o=this._memoryConfigurationByResource.get(t);o&&(s=s.merge(o))}return s}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration),this._freeze&&(this._workspaceConfiguration=this._workspaceConfiguration.freeze())),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(t){let i=this._foldersConsolidatedConfigurations.get(t);if(!i){const s=this.getWorkspaceConsolidatedConfiguration(),n=this._folderConfigurations.get(t);n?(i=s.merge(n),this._freeze&&(i=i.freeze()),this._foldersConsolidatedConfigurations.set(t,i)):i=s}return i}getFolderConfigurationModelForResource(t,i){if(i&&t){const s=i.getFolder(t);if(s)return this._folderConfigurations.get(s.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((t,i)=>{const{contents:s,overrides:n,keys:o}=this._folderConfigurations.get(i);return t.push([i,{contents:s,overrides:n,keys:o}]),t},[])}}allKeys(){const t=new Set;return this._defaultConfiguration.freeze().keys.forEach(i=>t.add(i)),this.userConfiguration.freeze().keys.forEach(i=>t.add(i)),this._workspaceConfiguration.freeze().keys.forEach(i=>t.add(i)),this._folderConfigurations.forEach(i=>i.freeze().keys.forEach(s=>t.add(s))),[...t.values()]}getAllKeysForOverrideIdentifier(t){const i=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(t).forEach(s=>i.add(s)),this.userConfiguration.getKeysForOverrideIdentifier(t).forEach(s=>i.add(s)),this._workspaceConfiguration.getKeysForOverrideIdentifier(t).forEach(s=>i.add(s)),this._folderConfigurations.forEach(s=>s.getKeysForOverrideIdentifier(t).forEach(n=>i.add(n))),[...i.values()]}static parse(t){const i=this.parseConfigurationModel(t.defaults),s=this.parseConfigurationModel(t.user),n=this.parseConfigurationModel(t.workspace),o=t.folders.reduce((v,m)=>(v.set(P.URI.revive(m[0]),this.parseConfigurationModel(m[1])),v),new R.ResourceMap);return new w(i,s,new f,n,o,new f,new R.ResourceMap,!1)}static parseConfigurationModel(t){return new f(t.contents,t.keys,t.overrides).freeze()}}e.Configuration=w;function b(...g){if(g.length===0)return{keys:[],overrides:[]};if(g.length===1)return g[0];const t=new Set,i=new Map;for(const n of g)n.keys.forEach(o=>t.add(o)),n.overrides.forEach(([o,v])=>{const m=R.getOrSet(i,o,new Set);v.forEach(_=>m.add(_))});const s=[];return i.forEach((n,o)=>s.push([o,[...n.values()]])),{keys:[...t.values()],overrides:s}}e.mergeChanges=b;class d{constructor(t,i,s,n){this.change=t,this.previous=i,this.currentConfiguraiton=s,this.currentWorkspace=n,this._previousConfiguration=void 0;const o=new Set;t.keys.forEach(m=>o.add(m)),t.overrides.forEach(([,m])=>m.forEach(_=>o.add(_))),this.affectedKeys=[...o.values()];const v=new f;this.affectedKeys.forEach(m=>v.setValue(m,{})),this.affectedKeysTree=v.contents}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=w.parse(this.previous.data)),this._previousConfiguration}affectsConfiguration(t,i){var s;if(this.doesAffectedKeysTreeContains(this.affectedKeysTree,t)){if(i){const n=this.previousConfiguration?this.previousConfiguration.getValue(t,i,(s=this.previous)===null||s===void 0?void 0:s.workspace):void 0,o=this.currentConfiguraiton.getValue(t,i,this.currentWorkspace);return!A.equals(n,o)}return!0}return!1}doesAffectedKeysTreeContains(t,i){let s=k.toValuesTree({[i]:!0},()=>{}),n;for(;typeof s=="object"&&(n=Object.keys(s)[0]);){if(t=t[n],!t)return!1;s=s[n]}return!0}}e.ConfigurationChangeEvent=d;class h extends d{constructor(t,i,s,n){super({keys:t.allKeys(),overrides:[]},void 0,t,i);this.source=s,this.sourceConfig=n}}e.AllKeysConfigurationChangeEvent=h}),define(me[116],ge([0,1,4]),function(X,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteAuthorityResolverError=e.RemoteAuthorityResolverErrorCode=e.IRemoteAuthorityResolverService=void 0,e.IRemoteAuthorityResolverService=p.createDecorator("remoteAuthorityResolverService");var R;(function(y){y.Unknown="Unknown",y.NotAvailable="NotAvailable",y.TemporarilyNotAvailable="TemporarilyNotAvailable",y.NoResolverFound="NoResolverFound"})(R=e.RemoteAuthorityResolverErrorCode||(e.RemoteAuthorityResolverErrorCode={}));class C extends Error{constructor(A,P=R.Unknown,E){super(A);this._message=A,this._code=P,this._detail=E,this.isHandled=P===R.NotAvailable&&E===!0,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,C.prototype)}static isTemporarilyNotAvailable(A){return A instanceof C&&A._code===R.TemporarilyNotAvailable}static isNoResolverFound(A){return A instanceof C&&A._code===R.NoResolverFound}static isHandled(A){return A instanceof C&&A.isHandled}}e.RemoteAuthorityResolverError=C}),define(me[81],ge([0,1,10]),function(X,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isVirtualWorkspace=e.getVirtualWorkspaceScheme=e.getVirtualWorkspaceLocation=e.isVirtualResource=e.getRemoteName=e.getRemoteAuthority=void 0;function R(k){return k.scheme===p.Schemas.vscodeRemote?k.authority:void 0}e.getRemoteAuthority=R;function C(k){if(!k)return;const r=k.indexOf("+");return r<0?k:k.substr(0,r)}e.getRemoteName=C;function y(k){return k.scheme!==p.Schemas.file&&k.scheme!==p.Schemas.vscodeRemote}e.isVirtualResource=y;function A(k){if(k.folders.length)return k.folders.every(r=>y(r.uri))?k.folders[0].uri:void 0;if(k.configuration&&y(k.configuration))return k.configuration}e.getVirtualWorkspaceLocation=A;function P(k){var r;return(r=A(k))===null||r===void 0?void 0:r.scheme}e.getVirtualWorkspaceScheme=P;function E(k){return A(k)!==void 0}e.isVirtualWorkspace=E}),define(me[187],ge([0,1,3,11,4,12]),function(X,e,p,R,C,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractTunnelService=e.isPortPrivileged=e.isAllInterfaces=e.ALL_INTERFACES_ADDRESSES=e.isLocalhost=e.LOCALHOST_ADDRESSES=e.extractLocalHostUriMetaDataForPortMapping=e.ProvidedOnAutoForward=e.TunnelProtocol=e.ITunnelService=void 0,e.ITunnelService=C.createDecorator("tunnelService");var A;(function(f){f.Http="http",f.Https="https"})(A=e.TunnelProtocol||(e.TunnelProtocol={}));var P;(function(f){f[f.Notify=1]="Notify",f[f.OpenBrowser=2]="OpenBrowser",f[f.OpenPreview=3]="OpenPreview",f[f.Silent=4]="Silent",f[f.Ignore=5]="Ignore",f[f.OpenBrowserOnce=6]="OpenBrowserOnce"})(P=e.ProvidedOnAutoForward||(e.ProvidedOnAutoForward={}));function E(f){if(f.scheme!=="http"&&f.scheme!=="https")return;const c=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(f.authority);if(!!c)return{address:c[1],port:+c[2]}}e.extractLocalHostUriMetaDataForPortMapping=E,e.LOCALHOST_ADDRESSES=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function k(f){return e.LOCALHOST_ADDRESSES.indexOf(f)>=0}e.isLocalhost=k,e.ALL_INTERFACES_ADDRESSES=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function r(f){return e.ALL_INTERFACES_ADDRESSES.indexOf(f)>=0}e.isAllInterfaces=r;function I(f,c){return c?c!==1&&f<1024:!R.isWindows&&f<1024}e.isPortPrivileged=I;let l=class{constructor(c){this.logService=c,this._onTunnelOpened=new p.Emitter,this.onTunnelOpened=this._onTunnelOpened.event,this._onTunnelClosed=new p.Emitter,this.onTunnelClosed=this._onTunnelClosed.event,this._onAddedTunnelProvider=new p.Emitter,this.onAddedTunnelProvider=this._onAddedTunnelProvider.event,this._tunnels=new Map,this._canElevate=!1,this._canMakePublic=!1}get hasTunnelProvider(){return!!this._tunnelProvider}setTunnelProvider(c,u){return this._tunnelProvider=c,c?(this._canElevate=u.elevation,this._canMakePublic=u.public,this._onAddedTunnelProvider.fire(),{dispose:()=>{this._tunnelProvider=void 0,this._canElevate=!1,this._canMakePublic=!1}}):(this._canElevate=!1,this._canMakePublic=!1,this._onAddedTunnelProvider.fire(),{dispose:()=>{}})}get canElevate(){return this._canElevate}get canMakePublic(){return this._canMakePublic}get tunnels(){return new Promise(async c=>{const u=[],S=Array.from(this._tunnels.values());for(let w of S){const b=Array.from(w.values());for(let d of b){const h=await d.value;h&&u.push(h)}}c(u)})}async dispose(){for(const c of this._tunnels.values()){for(const{value:u}of c.values())await u.then(S=>S==null?void 0:S.dispose());c.clear()}this._tunnels.clear()}openTunnel(c,u,S,w,b=!1,d=!1,h){if(this.logService.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${u}:${S} on local port ${w}.`),!c)return;u||(u="localhost");const g=this.retainOrCreateTunnel(c,u,S,w,b,d,h);return g?g.then(t=>{if(!t){this.logService.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.removeEmptyTunnelFromMap(u,S);return}this.logService.trace("ForwardedPorts: (TunnelService) New tunnel established.");const i=this.makeTunnel(t);return(t.tunnelRemoteHost!==u||t.tunnelRemotePort!==S)&&this.logService.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),this._onTunnelOpened.fire(i),i}):(this.logService.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),g)}makeTunnel(c){return{tunnelRemotePort:c.tunnelRemotePort,tunnelRemoteHost:c.tunnelRemoteHost,tunnelLocalPort:c.tunnelLocalPort,localAddress:c.localAddress,public:c.public,protocol:c.protocol,dispose:async()=>{this.logService.trace(`ForwardedPorts: (TunnelService) dispose request for ${c.tunnelRemoteHost}:${c.tunnelRemotePort} `);const u=this._tunnels.get(c.tunnelRemoteHost);if(u){const S=u.get(c.tunnelRemotePort);S&&(S.refcount--,await this.tryDisposeTunnel(c.tunnelRemoteHost,c.tunnelRemotePort,S))}}}}async tryDisposeTunnel(c,u,S){if(S.refcount<=0){this.logService.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${c}:${u}.`);const w=S.value.then(async b=>{b&&(await b.dispose(!0),this._onTunnelClosed.fire({host:b.tunnelRemoteHost,port:b.tunnelRemotePort}))});return this._tunnels.has(c)&&this._tunnels.get(c).delete(u),w}}async closeTunnel(c,u){this.logService.trace(`ForwardedPorts: (TunnelService) close request for ${c}:${u} `);const S=this._tunnels.get(c);if(S&&S.has(u)){const w=S.get(u);w.refcount=0,await this.tryDisposeTunnel(c,u,w)}}addTunnelToMap(c,u,S){this._tunnels.has(c)||this._tunnels.set(c,new Map),this._tunnels.get(c).set(u,{refcount:1,value:S})}async removeEmptyTunnelFromMap(c,u){const S=this._tunnels.get(c);S&&(await S.get(u)||S.delete(u),S.size===0&&this._tunnels.delete(c))}getTunnelFromMap(c,u){let S=[c];k(c)?(S.push(...e.LOCALHOST_ADDRESSES),S.push(...e.ALL_INTERFACES_ADDRESSES)):r(c)&&S.push(...e.ALL_INTERFACES_ADDRESSES);const w=S.map(b=>this._tunnels.get(b));for(const b of w){const d=b==null?void 0:b.get(u);if(d)return d}}canTunnel(c){return!!E(c)}createWithProvider(c,u,S,w,b,d,h){this.logService.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${u}:${S} on local port ${w}.`);const t={elevationRequired:b?I(w===void 0?S:w):!1},i={remoteAddress:{host:u,port:S},localAddressPort:w,public:d,protocol:h},s=c.forwardPort(i,t);return this.logService.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),s&&this.addTunnelToMap(u,S,s),s}};l=Ve([We(0,y.ILogService)],l),e.AbstractTunnelService=l}),define(me[188],ge([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SignService=void 0;class p{vsda(){return new Promise((C,y)=>X(["vsda"],C,y))}async sign(C){try{const y=await this.vsda(),A=new y.signer;if(A)return A.sign(C)}catch(y){}return C}}e.SignService=p}),define(me[189],ge([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminalDataBufferer=void 0;class p{constructor(C){this._callback=C,this._terminalBufferMap=new Map}dispose(){for(const C of this._terminalBufferMap.values())C.dispose()}startBuffering(C,y,A=5){let P;return P=y(E=>{const k=typeof E=="string"?E:E.data;let r=this._terminalBufferMap.get(C);if(r){r.data.push(k);return}const I=setTimeout(()=>this.flushBuffer(C),A);r={data:[k],timeoutId:I,dispose:()=>{clearTimeout(I),this.flushBuffer(C),P.dispose()}},this._terminalBufferMap.set(C,r)}),P}stopBuffering(C){const y=this._terminalBufferMap.get(C);y&&y.dispose()}flushBuffer(C){const y=this._terminalBufferMap.get(C);y&&(this._terminalBufferMap.delete(C),this._callback(C,y.data.join("")))}}e.TerminalDataBufferer=p}),define(me[45],ge([0,1,2,24,4,23]),function(X,e,p,R,C,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toWorkspaceFolder=e.WorkspaceFolder=e.Workspace=e.isWorkspaceFolder=e.isWorkspace=e.WorkbenchState=e.IWorkspaceContextService=void 0,e.IWorkspaceContextService=C.createDecorator("contextService");var A;(function(l){l[l.EMPTY=1]="EMPTY",l[l.FOLDER=2]="FOLDER",l[l.WORKSPACE=3]="WORKSPACE"})(A=e.WorkbenchState||(e.WorkbenchState={}));function P(l){const f=l;return!!(f&&typeof f=="object"&&typeof f.id=="string"&&Array.isArray(f.folders))}e.isWorkspace=P;function E(l){const f=l;return!!(f&&typeof f=="object"&&p.URI.isUri(f.uri)&&typeof f.name=="string"&&typeof f.toResource=="function")}e.isWorkspaceFolder=E;class k{constructor(f,c,u,S){this._id=f,this._configuration=u,this._ignorePathCasing=S,this._foldersMap=y.TernarySearchTree.forUris(this._ignorePathCasing),this.folders=c}update(f){this._id=f.id,this._configuration=f.configuration,this._ignorePathCasing=f._ignorePathCasing,this.folders=f.folders}get folders(){return this._folders}set folders(f){this._folders=f,this.updateFoldersMap()}get id(){return this._id}get configuration(){return this._configuration}set configuration(f){this._configuration=f}getFolder(f){return f&&this._foldersMap.findSubstr(f.with({scheme:f.scheme,authority:f.authority,path:f.path}))||null}updateFoldersMap(){this._foldersMap=y.TernarySearchTree.forUris(this._ignorePathCasing);for(const f of this.folders)this._foldersMap.set(f.uri,f)}toJSON(){return{id:this.id,folders:this.folders,configuration:this.configuration}}}e.Workspace=k;class r{constructor(f,c){this.raw=c,this.uri=f.uri,this.index=f.index,this.name=f.name}toResource(f){return R.joinPath(this.uri,f)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.WorkspaceFolder=r;function I(l){return new r({uri:l,index:0,name:R.basenameOrAuthority(l)},{uri:l.toString()})}e.toWorkspaceFolder=I}),define(me[190],ge([0,1,4,157,45,2,11,9,24,133,53,10,75,29,81]),function(X,e,p,R,C,y,A,P,E,k,r,I,l,f,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toStoreData=e.restoreRecentlyOpened=e.useSlashForPath=e.rewriteWorkspaceFileForNewLocation=e.toWorkspaceFolders=e.getStoredWorkspaceFolder=e.isRawUriWorkspaceFolder=e.isRawFileWorkspaceFolder=e.isStoredWorkspaceFolder=e.isUntitledWorkspace=e.reviveIdentifier=e.isWorkspaceIdentifier=e.toWorkspaceIdentifier=e.isSingleFolderWorkspaceIdentifier=e.isRecentFile=e.isRecentFolder=e.isRecentWorkspace=e.IWorkspacesService=e.hasWorkspaceFileExtension=e.UNTITLED_WORKSPACE_NAME=e.WORKSPACE_FILTER=e.WORKSPACE_EXTENSION=void 0,e.WORKSPACE_EXTENSION="code-workspace";const u=`.${e.WORKSPACE_EXTENSION}`;e.WORKSPACE_FILTER=[{name:R.localize(0,null),extensions:[e.WORKSPACE_EXTENSION]}],e.UNTITLED_WORKSPACE_NAME="workspace.json";function S(N){return(typeof N=="string"?P.extname(N):E.extname(N))===u}e.hasWorkspaceFileExtension=S,e.IWorkspacesService=p.createDecorator("workspacesService");function w(N){return N.hasOwnProperty("workspace")}e.isRecentWorkspace=w;function b(N){return N.hasOwnProperty("folderUri")}e.isRecentFolder=b;function d(N){return N.hasOwnProperty("fileUri")}e.isRecentFile=d;function h(N){const W=N;return typeof(W==null?void 0:W.id)=="string"&&y.URI.isUri(W.uri)}e.isSingleFolderWorkspaceIdentifier=h;function g(N){if(N.configuration)return{id:N.id,configPath:N.configuration};if(N.folders.length===1)return{id:N.id,uri:N.folders[0].uri}}e.toWorkspaceIdentifier=g;function t(N){const W=N;return typeof(W==null?void 0:W.id)=="string"&&y.URI.isUri(W.configPath)}e.isWorkspaceIdentifier=t;function i(N){const W=N;if(W==null?void 0:W.uri)return{id:W.id,uri:y.URI.revive(W.uri)};const M=N;if(M==null?void 0:M.configPath)return{id:M.id,configPath:y.URI.revive(M.configPath)};if(N==null?void 0:N.id)return{id:N.id}}e.reviveIdentifier=i;function s(N,W){return E.extUriBiasedIgnorePathCase.isEqualOrParent(N,W.untitledWorkspacesHome)}e.isUntitledWorkspace=s;function n(N){return o(N)||v(N)}e.isStoredWorkspaceFolder=n;function o(N){const W=N;return typeof(W==null?void 0:W.path)=="string"&&(!W.name||typeof W.name=="string")}e.isRawFileWorkspaceFolder=o;function v(N){const W=N;return typeof(W==null?void 0:W.uri)=="string"&&(!W.name||typeof W.name=="string")}e.isRawUriWorkspaceFolder=v;function m(N,W,M,j,O=!A.isWindows,F){if(N.scheme!==j.scheme)return{name:M,uri:N.toString(!0)};let B=W?void 0:F.relativePath(j,N);if(B!==void 0)B.length===0?B=".":A.isWindows&&N.scheme===I.Schemas.file&&!O&&(B=B.replace(/\//g,"\\"));else if(N.scheme===I.Schemas.file)B=N.fsPath,A.isWindows&&(B=l.normalizeDriveLetter(B),O&&(B=f.toSlashes(B)));else{if(!F.isEqualAuthority(N.authority,j.authority))return{name:M,uri:N.toString(!0)};B=N.path}return{name:M,path:B}}e.getStoredWorkspaceFolder=m;function _(N,W,M){let j=[],O=new Set;const F=M.dirname(W);for(let B of N){let $;if(o(B))B.path&&($=M.resolvePath(F,B.path));else if(v(B))try{$=y.URI.parse(B.uri),$.path[0]!=="/"&&($=$.with({path:"/"+$.path}))}catch(Y){console.warn(Y)}if($){let Y=M.getComparisonKey($);if(!O.has(Y)){O.add(Y);const le=B.name||M.basenameOrAuthority($);j.push(new C.WorkspaceFolder({uri:$,name:le,index:j.length},B))}}}return j}e.toWorkspaceFolders=_;function D(N,W,M,j,O){let F=a(W,N);const B=O.dirname(W),$=O.dirname(j),Y=[],le=T(F.folders);for(const Ue of F.folders){const Qe=o(Ue)?O.resolvePath(B,Ue.path):y.URI.parse(Ue.uri);let ze;M?ze=!1:ze=!o(Ue)||P.isAbsolute(Ue.path),Y.push(m(Qe,ze,Ue.name,$,le,O))}const be={insertSpaces:!1,tabSize:4,eol:A.isLinux||A.isMacintosh?`
`:`\r
`},Le=k.setProperty(N,["folders"],Y,be);let Ie=k.applyEdits(N,Le);return F.remoteAuthority===c.getRemoteAuthority(j)&&(Ie=k.applyEdits(Ie,k.removeProperty(Ie,["remoteAuthority"],be))),Ie}e.rewriteWorkspaceFileForNewLocation=D;function a(N,W){let M=r.parse(W);if(M&&Array.isArray(M.folders))M.folders=M.folders.filter(j=>n(j));else throw new Error(`${N} looks like an invalid workspace file.`);return M}function T(N){return A.isWindows?N.some(W=>o(W)&&W.path.indexOf("/")>=0):!0}e.useSlashForPath=T;function L(N){return N.workspace&&typeof N.workspace=="object"&&typeof N.workspace.id=="string"&&typeof N.workspace.configPath=="string"}function U(N){return typeof N.folderUri=="string"}function G(N){return typeof N.fileUri=="string"}function ee(N,W){const M={workspaces:[],files:[]};if(N){const j=function(F,B){for(let $=0;$<F.length;$++)try{B(F[$],$)}catch(Y){W.warn(`Error restoring recent entry ${JSON.stringify(F[$])}: ${Y.toString()}. Skip entry.`)}},O=N;if(Array.isArray(O.entries))j(O.entries,F=>{const B=F.label,$=F.remoteAuthority;L(F)?M.workspaces.push({label:B,remoteAuthority:$,workspace:{id:F.workspace.id,configPath:y.URI.parse(F.workspace.configPath)}}):U(F)?M.workspaces.push({label:B,remoteAuthority:$,folderUri:y.URI.parse(F.folderUri)}):G(F)&&M.files.push({label:B,remoteAuthority:$,fileUri:y.URI.parse(F.fileUri)})});else{const F=N;Array.isArray(F.workspaces3)&&j(F.workspaces3,(B,$)=>{const Y=Array.isArray(F.workspaceLabels)&&F.workspaceLabels[$]||void 0;typeof B=="object"&&typeof B.id=="string"&&typeof B.configURIPath=="string"?M.workspaces.push({label:Y,workspace:{id:B.id,configPath:y.URI.parse(B.configURIPath)}}):typeof B=="string"&&M.workspaces.push({label:Y,folderUri:y.URI.parse(B)})}),Array.isArray(F.files2)&&j(F.files2,(B,$)=>{const Y=Array.isArray(F.fileLabels)&&F.fileLabels[$]||void 0;typeof B=="string"&&M.files.push({label:Y,fileUri:y.URI.parse(B)})})}}return M}e.restoreRecentlyOpened=ee;function z(N){const W={entries:[]};for(const M of N.workspaces)b(M)?W.entries.push({folderUri:M.folderUri.toString(),label:M.label,remoteAuthority:M.remoteAuthority}):W.entries.push({workspace:{id:M.workspace.id,configPath:M.workspace.configPath.toString()},label:M.label,remoteAuthority:M.remoteAuthority});for(const M of N.files)W.entries.push({fileUri:M.fileUri.toString(),label:M.label,remoteAuthority:M.remoteAuthority});return W}e.toStoreData=z}),define(me[82],ge([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Cache=void 0;class p{constructor(C){this.id=C,this._data=new Map,this._idPool=1}add(C){const y=this._idPool++;return this._data.set(y,C),this.logDebugInfo(),y}get(C,y){return this._data.has(C)?this._data.get(C)[y]:void 0}delete(C){this._data.delete(C),this.logDebugInfo()}logDebugInfo(){!p.enableDebugLogging||console.log(`${this.id} cache size \u2014 ${this._data.size}`)}}e.Cache=p,p.enableDebugLogging=!1}),define(me[46],ge([0,1,2,3,4]),function(X,e,p,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorTabs=e.IExtHostEditorTabs=void 0,e.IExtHostEditorTabs=C.createDecorator("IExtHostEditorTabs");class y{constructor(){this._onDidChangeTabs=new R.Emitter,this.onDidChangeTabs=this._onDidChangeTabs.event,this._tabs=[]}get tabs(){return this._tabs}$acceptEditorTabs(P){this._tabs=P.map(E=>({name:E.name,group:E.group,resource:p.URI.revive(E.resource),isActive:E.isActive})),this._onDidChangeTabs.fire()}}e.ExtHostEditorTabs=y}),define(me[59],ge([0,1,10,4]),function(X,e,p,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostFileSystemInfo=e.ExtHostFileSystemInfo=void 0;class C{constructor(){this._systemSchemes=new Set(Object.keys(p.Schemas)),this._providerInfo=new Map}$acceptProviderInfos(A,P){P===null?this._providerInfo.delete(A):this._providerInfo.set(A,P)}isFreeScheme(A){return!this._providerInfo.has(A)&&!this._systemSchemes.has(A)}getCapabilities(A){return this._providerInfo.get(A)}}e.ExtHostFileSystemInfo=C,e.IExtHostFileSystemInfo=R.createDecorator("IExtHostFileSystemInfo")}),define(me[27],ge([0,1,4]),function(X,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostInitDataService=void 0,e.IExtHostInitDataService=p.createDecorator("IExtHostInitDataService")}),define(me[191],ge([0,1,16]),function(X,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionGlobalMemento=e.ExtensionMemento=void 0;class R{constructor(A,P,E){this._deferredPromises=new Map,this._id=A,this._shared=P,this._storage=E,this._init=this._storage.getValue(this._shared,this._id,Object.create(null)).then(k=>(this._value=k,this)),this._storageListener=this._storage.onDidChangeStorage(k=>{k.shared===this._shared&&k.key===this._id&&(this._value=k.value)}),this._scheduler=new p.RunOnceScheduler(()=>{const k=this._deferredPromises;this._deferredPromises=new Map,(async()=>{try{await this._storage.setValue(this._shared,this._id,this._value);for(const r of k.values())r.complete()}catch(r){for(const I of k.values())I.error(r)}})()},0)}get keys(){var A;return Object.entries((A=this._value)!==null&&A!==void 0?A:{}).filter(([,P])=>P!==void 0).map(([P])=>P)}get whenReady(){return this._init}get(A,P){let E=this._value[A];return typeof E=="undefined"&&(E=P),E}update(A,P){this._value[A]=P;let E=this._deferredPromises.get(A);if(E!==void 0)return E.p;const k=new p.DeferredPromise;return this._deferredPromises.set(A,k),this._scheduler.isScheduled()||this._scheduler.schedule(),k.p}dispose(){this._storageListener.dispose()}}e.ExtensionMemento=R;class C extends R{constructor(A,P){super(A.identifier.value,!0,P);this._extension=A}setKeysForSync(A){this._storage.registerExtensionStorageKeysToSync({id:this._id,version:this._extension.version},A)}}e.ExtensionGlobalMemento=C}),define(me[192],ge([0,1,3,2,12]),function(X,e,p,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocuments=void 0;let y=class{constructor(P,E){this._logService=P,this._notebooksAndEditors=E,this._onDidChangeNotebookDocumentMetadata=new p.Emitter,this.onDidChangeNotebookDocumentMetadata=this._onDidChangeNotebookDocumentMetadata.event,this._onDidSaveNotebookDocument=new p.Emitter,this.onDidSaveNotebookDocument=this._onDidSaveNotebookDocument.event}$acceptModelChanged(P,E,k){this._notebooksAndEditors.getNotebookDocument(R.URI.revive(P)).acceptModelChanged(E,k)}$acceptDirtyStateChanged(P,E){this._notebooksAndEditors.getNotebookDocument(R.URI.revive(P)).acceptDirty(E)}$acceptModelSaved(P){const E=this._notebooksAndEditors.getNotebookDocument(R.URI.revive(P));this._onDidSaveNotebookDocument.fire(E.apiNotebook)}$acceptDocumentPropertiesChanged(P,E){this._logService.debug("ExtHostNotebook#$acceptDocumentPropertiesChanged",P.path,E);const k=this._notebooksAndEditors.getNotebookDocument(R.URI.revive(P));k.acceptDocumentPropertiesChanged(E),E.metadata&&this._onDidChangeNotebookDocumentMetadata.fire({document:k.apiNotebook})}};y=Ve([We(0,C.ILogService)],y),e.ExtHostNotebookDocuments=y}),define(me[13],ge([0,1,4]),function(X,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostRpcService=e.IExtHostRpcService=void 0,e.IExtHostRpcService=p.createDecorator("IExtHostRpcService");class R{constructor(y){this.getProxy=y.getProxy.bind(y),this.set=y.set.bind(y),this.assertRegistered=y.assertRegistered.bind(y),this.drain=y.drain.bind(y)}}e.ExtHostRpcService=R});var rt=this&&this.__classPrivateFieldSet||function(X,e,p,R,C){if(R==="m")throw new TypeError("Private method is not writable");if(R==="a"&&!C)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?X!==e||!C:!e.has(X))throw new TypeError("Cannot write private member to an object whose class did not declare it");return R==="a"?C.call(X,p):C?C.value=p:e.set(X,p),p},$e=this&&this.__classPrivateFieldGet||function(X,e,p,R){if(p==="a"&&!R)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?X!==e||!R:!e.has(X))throw new TypeError("Cannot read private member from an object whose class did not declare it");return p==="m"?R:p==="a"?R.call(X):R?R.value:e.get(X)};define(me[193],ge([0,1,26,3]),function(X,e,p,R){"use strict";var C;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionSecrets=void 0;class y{constructor(P,E){C.set(this,void 0),this._onDidChange=new R.Emitter,this.onDidChange=this._onDidChange.event,this._id=p.ExtensionIdentifier.toKey(P.identifier),rt(this,C,E,"f"),$e(this,C,"f").onDidChangePassword(k=>{k.extensionId===this._id&&this._onDidChange.fire({key:k.key})})}get(P){return $e(this,C,"f").get(this._id,P)}store(P,E){return $e(this,C,"f").store(this._id,P,E)}delete(P){return $e(this,C,"f").delete(this._id,P)}}e.ExtensionSecrets=y,C=new WeakMap}),define(me[117],ge([0,1,4,3]),function(X,e,p,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTelemetry=e.ExtHostTelemetry=void 0;class C{constructor(){this._onDidChangeTelemetryEnabled=new R.Emitter,this.onDidChangeTelemetryEnabled=this._onDidChangeTelemetryEnabled.event,this._enabled=!1}getTelemetryEnabled(){return this._enabled}$initializeTelemetryEnabled(A){this._enabled=A}$onDidChangeTelemetryEnabled(A){this._enabled=A,this._onDidChangeTelemetryEnabled.fire(A)}}e.ExtHostTelemetry=C,e.IExtHostTelemetry=p.createDecorator("IExtHostTelemetry")}),define(me[118],ge([0,1,3]),function(X,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPrivateApiFor=e.ExtHostTestItemEventType=void 0;var R;(function(A){A[A.NewChild=0]="NewChild",A[A.Disposed=1]="Disposed",A[A.Invalidated=2]="Invalidated",A[A.SetProp=3]="SetProp"})(R=e.ExtHostTestItemEventType||(e.ExtHostTestItemEventType={}));const C=new WeakMap,y=A=>{let P=C.get(A);return P||(P={children:new Map,bus:new p.Emitter},C.set(A,P)),P};e.getPrivateApiFor=y}),define(me[47],ge([0,1,4,3,13]),function(X,e,p,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTunnelService=e.IExtHostTunnelService=e.TunnelDto=void 0;var y;(function(P){function E(r){return{remoteAddress:r.remoteAddress,localAddress:r.localAddress,public:!!r.public,protocol:r.protocol}}P.fromApiTunnel=E;function k(r){return{remoteAddress:{host:r.tunnelRemoteHost,port:r.tunnelRemotePort},localAddress:r.localAddress,public:r.public,protocol:r.protocol}}P.fromServiceTunnel=k})(y=e.TunnelDto||(e.TunnelDto={})),e.IExtHostTunnelService=p.createDecorator("IExtHostTunnelService");let A=class{constructor(E){this.onDidChangeTunnels=new R.Emitter().event}async $applyCandidateFilter(E){return E}async openTunnel(E,k){}async getTunnels(){return[]}async setTunnelExtensionFunctions(E){return{dispose:()=>{}}}registerPortsAttributesProvider(E,k){return{dispose:()=>{}}}async $providePortAttributes(E,k,r,I,l){return[]}async $forwardPort(E,k){}async $closeTunnel(E){}async $onDidTunnelsChange(){}async $registerCandidateFinder(){}};A=Ve([We(0,C.IExtHostRpcService)],A),e.ExtHostTunnelService=A});var rt=this&&this.__classPrivateFieldSet||function(X,e,p,R,C){if(R==="m")throw new TypeError("Private method is not writable");if(R==="a"&&!C)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?X!==e||!C:!e.has(X))throw new TypeError("Cannot write private member to an object whose class did not declare it");return R==="a"?C.call(X,p):C?C.value=p:e.set(X,p),p},$e=this&&this.__classPrivateFieldGet||function(X,e,p,R){if(p==="a"&&!R)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?X!==e||!R:!e.has(X))throw new TypeError("Cannot read private member from an object whose class did not declare it");return p==="m"?R:p==="a"?R.call(X):R?R.value:e.get(X)};define(me[7],ge([0,1,18,14,94,23,97,15,2,32,41,116,118]),function(X,e,p,R,C,y,A,P,E,k,r,I,l){"use strict";var f,c,u,S,w,b,d,h,g,t,i,s,n,o,v,m,_,D;Object.defineProperty(e,"__esModule",{value:!0}),e.PortAutoForwardAction=e.WorkspaceTrustState=e.ExternalUriOpenerPriority=e.TestMessage=e.TestItemImpl=e.TestRunRequest=e.TestMessageSeverity=e.TestResultState=e.PortAttributes=e.LinkedEditingRanges=e.StandardTokenType=e.ExtensionRuntime=e.ExtensionMode=e.TimelineItem=e.NotebookRendererScript=e.NotebookControllerAffinity=e.NotebookCellStatusBarItem=e.NotebookEditorRevealType=e.NotebookCellStatusBarAlignment=e.NotebookCellExecutionState=e.NotebookCellKind=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookData=e.NotebookCellData=e.NotebookRange=e.ColorThemeKind=e.ColorTheme=e.FileDecoration=e.ExtensionKind=e.QuickInputButtons=e.DebugConfigurationProviderTriggerKind=e.DebugConsoleMode=e.SemanticTokensEdits=e.SemanticTokensEdit=e.SemanticTokens=e.SemanticTokensBuilder=e.SemanticTokensLegend=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.FoldingRange=e.FileSystemError=e.FileChangeType=e.InlineValueContext=e.InlineValueEvaluatableExpression=e.InlineValueVariableLookup=e.InlineValueText=e.InlineCompletionTriggerKind=e.EvaluatableExpression=e.DebugAdapterInlineImplementation=e.DebugAdapterNamedPipeServer=e.DebugAdapterServer=e.DebugAdapterExecutable=e.DataBreakpoint=e.FunctionBreakpoint=e.SourceBreakpoint=e.Breakpoint=e.RelativePattern=e.ConfigurationTarget=e.ThemeColor=e.ThemeIcon=e.TreeItemCollapsibleState=e.TreeItem=e.ProgressLocation=e.Task=e.CustomExecution=e.TaskScope=e.ShellQuoting=e.ShellExecution=e.ProcessExecution=e.TaskGroup=e.TaskPanelKind=e.TaskRevealKind=e.TerminalProfile=e.TerminalLink=e.SourceControlInputBoxValidationType=e.ColorFormat=e.ColorPresentation=e.ColorInformation=e.Color=e.DocumentLink=e.DecorationRangeBehavior=e.TextEditorSelectionChangeKind=e.TextEditorRevealType=e.TextDocumentSaveReason=e.TextEditorLineNumbersStyle=e.StatusBarAlignment=e.ViewColumn=e.InlineSuggestions=e.InlineSuggestion=e.CompletionList=e.CompletionItem=e.CompletionItemTag=e.CompletionItemKind=e.CompletionTriggerKind=e.InlayHint=e.InlayHintKind=e.SignatureHelpTriggerKind=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.MarkdownString=e.CodeLens=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.SelectionRange=e.CodeActionKind=e.CodeAction=e.CodeActionTriggerKind=e.DocumentSymbol=e.SymbolInformation=e.SymbolTag=e.SymbolKind=e.DocumentHighlight=e.DocumentHighlightKind=e.Hover=e.Diagnostic=e.DiagnosticRelatedInformation=e.Location=e.DiagnosticSeverity=e.DiagnosticTag=e.SnippetString=e.WorkspaceEdit=e.FileEditType=e.TextEdit=e.EnvironmentVariableMutatorType=e.EndOfLine=e.RemoteAuthorityResolverError=e.ResolvedAuthority=e.Selection=e.Range=e.Position=e.Disposable=void 0;function a(H){function x(){return Reflect.construct(H,arguments,this.constructor)}return Object.defineProperty(x,"name",Object.getOwnPropertyDescriptor(H,"name")),Object.setPrototypeOf(x,H),Object.setPrototypeOf(x.prototype,H.prototype),x}let T=w=class{constructor(x){f.set(this,void 0),rt(this,f,x,"f")}static from(...x){let re=x;return new w(function(){if(re){for(const Pe of re)Pe&&typeof Pe.dispose=="function"&&Pe.dispose();re=void 0}})}dispose(){typeof $e(this,f,"f")=="function"&&($e(this,f,"f").call(this),rt(this,f,void 0,"f"))}};f=new WeakMap,T=w=Ve([a],T),e.Disposable=T;let L=b=class{constructor(x,re){if(x<0)throw R.illegalArgument("line must be non-negative");if(re<0)throw R.illegalArgument("character must be non-negative");this._line=x,this._character=re}static Min(...x){if(x.length===0)throw new TypeError;let re=x[0];for(let Pe=1;Pe<x.length;Pe++){const Xe=x[Pe];Xe.isBefore(re)&&(re=Xe)}return re}static Max(...x){if(x.length===0)throw new TypeError;let re=x[0];for(let Pe=1;Pe<x.length;Pe++){const Xe=x[Pe];Xe.isAfter(re)&&(re=Xe)}return re}static isPosition(x){if(!x)return!1;if(x instanceof b)return!0;let{line:re,character:Pe}=x;return typeof re=="number"&&typeof Pe=="number"}get line(){return this._line}get character(){return this._character}isBefore(x){return this._line<x._line?!0:x._line<this._line?!1:this._character<x._character}isBeforeOrEqual(x){return this._line<x._line?!0:x._line<this._line?!1:this._character<=x._character}isAfter(x){return!this.isBeforeOrEqual(x)}isAfterOrEqual(x){return!this.isBefore(x)}isEqual(x){return this._line===x._line&&this._character===x._character}compareTo(x){return this._line<x._line?-1:this._line>x.line?1:this._character<x._character?-1:this._character>x._character?1:0}translate(x,re=0){if(x===null||re===null)throw R.illegalArgument();let Pe;return typeof x=="undefined"?Pe=0:typeof x=="number"?Pe=x:(Pe=typeof x.lineDelta=="number"?x.lineDelta:0,re=typeof x.characterDelta=="number"?x.characterDelta:0),Pe===0&&re===0?this:new b(this.line+Pe,this.character+re)}with(x,re=this.character){if(x===null||re===null)throw R.illegalArgument();let Pe;return typeof x=="undefined"?Pe=this.line:typeof x=="number"?Pe=x:(Pe=typeof x.line=="number"?x.line:this.line,re=typeof x.character=="number"?x.character:this.character),Pe===this.line&&re===this.character?this:new b(Pe,re)}toJSON(){return{line:this.line,character:this.character}}};L=b=Ve([a],L),e.Position=L;let U=d=class{constructor(x,re,Pe,Xe){let it,ot;if(typeof x=="number"&&typeof re=="number"&&typeof Pe=="number"&&typeof Xe=="number"?(it=new L(x,re),ot=new L(Pe,Xe)):x instanceof L&&re instanceof L&&(it=x,ot=re),!it||!ot)throw new Error("Invalid arguments");it.isBefore(ot)?(this._start=it,this._end=ot):(this._start=ot,this._end=it)}static isRange(x){return x instanceof d?!0:x?L.isPosition(x.start)&&L.isPosition(x.end):!1}get start(){return this._start}get end(){return this._end}contains(x){return x instanceof d?this.contains(x._start)&&this.contains(x._end):x instanceof L?!(x.isBefore(this._start)||this._end.isBefore(x)):!1}isEqual(x){return this._start.isEqual(x._start)&&this._end.isEqual(x._end)}intersection(x){const re=L.Max(x.start,this._start),Pe=L.Min(x.end,this._end);if(!re.isAfter(Pe))return new d(re,Pe)}union(x){if(this.contains(x))return this;if(x.contains(this))return x;const re=L.Min(x.start,this._start),Pe=L.Max(x.end,this.end);return new d(re,Pe)}get isEmpty(){return this._start.isEqual(this._end)}get isSingleLine(){return this._start.line===this._end.line}with(x,re=this.end){if(x===null||re===null)throw R.illegalArgument();let Pe;return x?L.isPosition(x)?Pe=x:(Pe=x.start||this.start,re=x.end||this.end):Pe=this.start,Pe.isEqual(this._start)&&re.isEqual(this.end)?this:new d(Pe,re)}toJSON(){return[this.start,this.end]}};U=d=Ve([a],U),e.Range=U;let G=h=class extends U{constructor(x,re,Pe,Xe){let it,ot;if(typeof x=="number"&&typeof re=="number"&&typeof Pe=="number"&&typeof Xe=="number"?(it=new L(x,re),ot=new L(Pe,Xe)):x instanceof L&&re instanceof L&&(it=x,ot=re),!it||!ot)throw new Error("Invalid arguments");super(it,ot);this._anchor=it,this._active=ot}static isSelection(x){return x instanceof h?!0:x?U.isRange(x)&&L.isPosition(x.anchor)&&L.isPosition(x.active)&&typeof x.isReversed=="boolean":!1}get anchor(){return this._anchor}get active(){return this._active}get isReversed(){return this._anchor===this._end}toJSON(){return{start:this.start,end:this.end,active:this.active,anchor:this.anchor}}};G=h=Ve([a],G),e.Selection=G;class ee{constructor(x,re,Pe){if(typeof x!="string"||x.length===0)throw R.illegalArgument("host");if(typeof re!="number"||re===0||Math.round(re)!==re)throw R.illegalArgument("port");if(typeof Pe!="undefined"&&(typeof Pe!="string"||Pe.length===0||!/^[0-9A-Za-z\-]+$/.test(Pe)))throw R.illegalArgument("connectionToken");this.host=x,this.port=Math.round(re),this.connectionToken=Pe}}e.ResolvedAuthority=ee;class z extends Error{constructor(x,re=I.RemoteAuthorityResolverErrorCode.Unknown,Pe){super(x);this._message=x,this._code=re,this._detail=Pe,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,z.prototype)}static NotAvailable(x,re){return new z(x,I.RemoteAuthorityResolverErrorCode.NotAvailable,re)}static TemporarilyNotAvailable(x){return new z(x,I.RemoteAuthorityResolverErrorCode.TemporarilyNotAvailable)}}e.RemoteAuthorityResolverError=z;var N;(function(H){H[H.LF=1]="LF",H[H.CRLF=2]="CRLF"})(N=e.EndOfLine||(e.EndOfLine={}));var W;(function(H){H[H.Replace=1]="Replace",H[H.Append=2]="Append",H[H.Prepend=3]="Prepend"})(W=e.EnvironmentVariableMutatorType||(e.EnvironmentVariableMutatorType={}));let M=g=class{constructor(x,re){this._range=x,this._newText=re}static isTextEdit(x){return x instanceof g?!0:x?U.isRange(x)&&typeof x.newText=="string":!1}static replace(x,re){return new g(x,re)}static insert(x,re){return g.replace(new U(x,x),re)}static delete(x){return g.replace(x,"")}static setEndOfLine(x){const re=new g(new U(new L(0,0),new L(0,0)),"");return re.newEol=x,re}get range(){return this._range}set range(x){if(x&&!U.isRange(x))throw R.illegalArgument("range");this._range=x}get newText(){return this._newText||""}set newText(x){if(x&&typeof x!="string")throw R.illegalArgument("newText");this._newText=x}get newEol(){return this._newEol}set newEol(x){if(x&&typeof x!="number")throw R.illegalArgument("newEol");this._newEol=x}toJSON(){return{range:this.range,newText:this.newText,newEol:this._newEol}}};M=g=Ve([a],M),e.TextEdit=M;var j;(function(H){H[H.File=1]="File",H[H.Text=2]="Text",H[H.Cell=3]="Cell",H[H.CellReplace=5]="CellReplace"})(j=e.FileEditType||(e.FileEditType={}));let O=class{constructor(){this._edits=[]}_allEntries(){return this._edits}renameFile(x,re,Pe,Xe){this._edits.push({_type:1,from:x,to:re,options:Pe,metadata:Xe})}createFile(x,re,Pe){this._edits.push({_type:1,from:void 0,to:x,options:re,metadata:Pe})}deleteFile(x,re,Pe){this._edits.push({_type:1,from:x,to:void 0,options:re,metadata:Pe})}replaceNotebookMetadata(x,re,Pe){this._edits.push({_type:3,metadata:Pe,uri:x,edit:{editType:5,metadata:re},notebookMetadata:re})}replaceNotebookCells(x,re,Pe,Xe,it){let ot,lt,yt=[],Pt;if(qt.isNotebookRange(re)&&Rt.isNotebookCellDataArray(Pe)&&!Rt.isNotebookCellDataArray(Xe)?(ot=re.start,lt=re.end,yt=Pe,Pt=Xe):typeof re=="number"&&typeof Pe=="number"&&Rt.isNotebookCellDataArray(Xe)&&(ot=re,lt=Pe,yt=Xe,Pt=it),ot===void 0||lt===void 0)throw new Error("Invalid arguments");(ot!==lt||yt.length>0)&&this._edits.push({_type:5,uri:x,index:ot,count:lt-ot,cells:yt,metadata:Pt})}replaceNotebookCellMetadata(x,re,Pe,Xe){this._edits.push({_type:3,metadata:Xe,uri:x,edit:{editType:8,index:re,metadata:Pe}})}replace(x,re,Pe,Xe){this._edits.push({_type:2,uri:x,edit:new M(re,Pe),metadata:Xe})}insert(x,re,Pe,Xe){this.replace(x,new U(re,re),Pe,Xe)}delete(x,re,Pe){this.replace(x,re,"",Pe)}has(x){return this._edits.some(re=>re._type===2&&re.uri.toString()===x.toString())}set(x,re){if(re)for(const Pe of re)Pe&&this._edits.push({_type:2,uri:x,edit:Pe});else{for(let Pe=0;Pe<this._edits.length;Pe++){const Xe=this._edits[Pe];Xe._type===2&&Xe.uri.toString()===x.toString()&&(this._edits[Pe]=void 0)}p.coalesceInPlace(this._edits)}}get(x){const re=[];for(let Pe of this._edits)Pe._type===2&&Pe.uri.toString()===x.toString()&&re.push(Pe.edit);return re}entries(){const x=new y.ResourceMap;for(let re of this._edits)if(re._type===2){let Pe=x.get(re.uri);Pe||(Pe=[re.uri,[]],x.set(re.uri,Pe)),Pe[1].push(re.edit)}return[...x.values()]}get size(){return this.entries().length}toJSON(){return this.entries()}};O=Ve([a],O),e.WorkspaceEdit=O;let F=t=class{constructor(x){this._tabstop=1,this.value=x||""}static isSnippetString(x){return x instanceof t?!0:x?typeof x.value=="string":!1}static _escape(x){return x.replace(/\$|}|\\/g,"\\$&")}appendText(x){return this.value+=t._escape(x),this}appendTabstop(x=this._tabstop++){return this.value+="$",this.value+=x,this}appendPlaceholder(x,re=this._tabstop++){if(typeof x=="function"){const Pe=new t;Pe._tabstop=this._tabstop,x(Pe),this._tabstop=Pe._tabstop,x=Pe.value}else x=t._escape(x);return this.value+="${",this.value+=re,this.value+=":",this.value+=x,this.value+="}",this}appendChoice(x,re=this._tabstop++){const Pe=x.map(Xe=>Xe.replace(/\$|}|\\|,/g,"\\$&")).join(",");return this.value+="${",this.value+=re,this.value+="|",this.value+=Pe,this.value+="|}",this}appendVariable(x,re){if(typeof re=="function"){const Pe=new t;Pe._tabstop=this._tabstop,re(Pe),this._tabstop=Pe._tabstop,re=Pe.value}else typeof re=="string"&&(re=re.replace(/\$|}/g,"\\$&"));return this.value+="${",this.value+=x,re&&(this.value+=":",this.value+=re),this.value+="}",this}};F=t=Ve([a],F),e.SnippetString=F;var B;(function(H){H[H.Unnecessary=1]="Unnecessary",H[H.Deprecated=2]="Deprecated"})(B=e.DiagnosticTag||(e.DiagnosticTag={}));var $;(function(H){H[H.Hint=3]="Hint",H[H.Information=2]="Information",H[H.Warning=1]="Warning",H[H.Error=0]="Error"})($=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));let Y=i=class{constructor(x,re){if(this.uri=x,re)if(re instanceof U)this.range=re;else if(re instanceof L)this.range=new U(re,re);else throw new Error("Illegal argument")}static isLocation(x){return x instanceof i?!0:x?U.isRange(x.range)&&E.URI.isUri(x.uri):!1}toJSON(){return{uri:this.uri,range:this.range}}};Y=i=Ve([a],Y),e.Location=Y;let le=class{constructor(x,re){this.location=x,this.message=re}static is(x){return x?typeof x.message=="string"&&x.location&&U.isRange(x.location.range)&&E.URI.isUri(x.location.uri):!1}static isEqual(x,re){return x===re?!0:!x||!re?!1:x.message===re.message&&x.location.range.isEqual(re.location.range)&&x.location.uri.toString()===re.location.uri.toString()}};le=Ve([a],le),e.DiagnosticRelatedInformation=le;let be=class{constructor(x,re,Pe=$.Error){if(!U.isRange(x))throw new TypeError("range must be set");if(!re)throw new TypeError("message must be set");this.range=x,this.message=re,this.severity=Pe}toJSON(){return{severity:$[this.severity],message:this.message,range:this.range,source:this.source,code:this.code}}static isEqual(x,re){return x===re?!0:!x||!re?!1:x.message===re.message&&x.severity===re.severity&&x.code===re.code&&x.severity===re.severity&&x.source===re.source&&x.range.isEqual(re.range)&&p.equals(x.tags,re.tags)&&p.equals(x.relatedInformation,re.relatedInformation,le.isEqual)}};be=Ve([a],be),e.Diagnostic=be;let Le=class{constructor(x,re){if(!x)throw new Error("Illegal argument, contents must be defined");Array.isArray(x)?this.contents=x:this.contents=[x],this.range=re}};Le=Ve([a],Le),e.Hover=Le;var Ie;(function(H){H[H.Text=0]="Text",H[H.Read=1]="Read",H[H.Write=2]="Write"})(Ie=e.DocumentHighlightKind||(e.DocumentHighlightKind={}));let Ue=class{constructor(x,re=Ie.Text){this.range=x,this.kind=re}toJSON(){return{range:this.range,kind:Ie[this.kind]}}};Ue=Ve([a],Ue),e.DocumentHighlight=Ue;var Qe;(function(H){H[H.File=0]="File",H[H.Module=1]="Module",H[H.Namespace=2]="Namespace",H[H.Package=3]="Package",H[H.Class=4]="Class",H[H.Method=5]="Method",H[H.Property=6]="Property",H[H.Field=7]="Field",H[H.Constructor=8]="Constructor",H[H.Enum=9]="Enum",H[H.Interface=10]="Interface",H[H.Function=11]="Function",H[H.Variable=12]="Variable",H[H.Constant=13]="Constant",H[H.String=14]="String",H[H.Number=15]="Number",H[H.Boolean=16]="Boolean",H[H.Array=17]="Array",H[H.Object=18]="Object",H[H.Key=19]="Key",H[H.Null=20]="Null",H[H.EnumMember=21]="EnumMember",H[H.Struct=22]="Struct",H[H.Event=23]="Event",H[H.Operator=24]="Operator",H[H.TypeParameter=25]="TypeParameter"})(Qe=e.SymbolKind||(e.SymbolKind={}));var ze;(function(H){H[H.Deprecated=1]="Deprecated"})(ze=e.SymbolTag||(e.SymbolTag={}));let Ge=s=class{constructor(x,re,Pe,Xe,it){this.name=x,this.kind=re,this.containerName=it,typeof Pe=="string"&&(this.containerName=Pe),Xe instanceof Y?this.location=Xe:Pe instanceof U&&(this.location=new Y(Xe,Pe)),s.validate(this)}static validate(x){if(!x.name)throw new Error("name must not be falsy")}toJSON(){return{name:this.name,kind:Qe[this.kind],location:this.location,containerName:this.containerName}}};Ge=s=Ve([a],Ge),e.SymbolInformation=Ge;let V=n=class{constructor(x,re,Pe,Xe,it){this.name=x,this.detail=re,this.kind=Pe,this.range=Xe,this.selectionRange=it,this.children=[],n.validate(this)}static validate(x){if(!x.name)throw new Error("name must not be falsy");if(!x.range.contains(x.selectionRange))throw new Error("selectionRange must be contained in fullRange");x.children&&x.children.forEach(n.validate)}};V=n=Ve([a],V),e.DocumentSymbol=V;var Z;(function(H){H[H.Invoke=1]="Invoke",H[H.Automatic=2]="Automatic"})(Z=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}));let ne=class{constructor(x,re){this.title=x,this.kind=re}};ne=Ve([a],ne),e.CodeAction=ne;let se=o=class{constructor(x){this.value=x}append(x){return new o(this.value?this.value+o.sep+x:x)}intersects(x){return this.contains(x)||x.contains(this)}contains(x){return this.value===x.value||x.value.startsWith(this.value+o.sep)}};se.sep=".",se=o=Ve([a],se),e.CodeActionKind=se,se.Empty=new se(""),se.QuickFix=se.Empty.append("quickfix"),se.Refactor=se.Empty.append("refactor"),se.RefactorExtract=se.Refactor.append("extract"),se.RefactorInline=se.Refactor.append("inline"),se.RefactorRewrite=se.Refactor.append("rewrite"),se.Source=se.Empty.append("source"),se.SourceOrganizeImports=se.Source.append("organizeImports"),se.SourceFixAll=se.Source.append("fixAll");let J=class{constructor(x,re){if(this.range=x,this.parent=re,re&&!re.range.contains(this.range))throw new Error("Invalid argument: parent must contain this range")}};J=Ve([a],J),e.SelectionRange=J;class ae{constructor(x,re,Pe,Xe,it,ot){this.kind=x,this.name=re,this.detail=Pe,this.uri=Xe,this.range=it,this.selectionRange=ot}}e.CallHierarchyItem=ae;class he{constructor(x,re){this.fromRanges=re,this.from=x}}e.CallHierarchyIncomingCall=he;class Fe{constructor(x,re){this.fromRanges=re,this.to=x}}e.CallHierarchyOutgoingCall=Fe;let He=class{constructor(x,re){this.range=x,this.command=re}get isResolved(){return!!this.command}};He=Ve([a],He),e.CodeLens=He;let _e=v=class{constructor(x,re=!1){c.set(this,void 0),rt(this,c,new C.MarkdownString(x,{supportThemeIcons:re}),"f")}static isMarkdownString(x){return x instanceof v?!0:x&&x.appendCodeblock&&x.appendMarkdown&&x.appendText&&x.value!==void 0}get value(){return $e(this,c,"f").value}set value(x){$e(this,c,"f").value=x}get isTrusted(){return $e(this,c,"f").isTrusted}set isTrusted(x){$e(this,c,"f").isTrusted=x}get supportThemeIcons(){return $e(this,c,"f").supportThemeIcons}set supportThemeIcons(x){$e(this,c,"f").supportThemeIcons=x}appendText(x){return $e(this,c,"f").appendText(x),this}appendMarkdown(x){return $e(this,c,"f").appendMarkdown(x),this}appendCodeblock(x,re){return $e(this,c,"f").appendCodeblock(re??"",x),this}};c=new WeakMap,_e=v=Ve([a],_e),e.MarkdownString=_e;let Ye=class{constructor(x,re){this.label=x,this.documentation=re}};Ye=Ve([a],Ye),e.ParameterInformation=Ye;let K=class{constructor(x,re){this.label=x,this.documentation=re,this.parameters=[]}};K=Ve([a],K),e.SignatureInformation=K;let ie=class{constructor(){this.activeSignature=0,this.activeParameter=0,this.signatures=[]}};ie=Ve([a],ie),e.SignatureHelp=ie;var ve;(function(H){H[H.Invoke=1]="Invoke",H[H.TriggerCharacter=2]="TriggerCharacter",H[H.ContentChange=3]="ContentChange"})(ve=e.SignatureHelpTriggerKind||(e.SignatureHelpTriggerKind={}));var Me;(function(H){H[H.Other=0]="Other",H[H.Type=1]="Type",H[H.Parameter=2]="Parameter"})(Me=e.InlayHintKind||(e.InlayHintKind={}));let xe=class{constructor(x,re,Pe){this.text=x,this.position=re,this.kind=Pe}};xe=Ve([a],xe),e.InlayHint=xe;var Je;(function(H){H[H.Invoke=0]="Invoke",H[H.TriggerCharacter=1]="TriggerCharacter",H[H.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(Je=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var ke;(function(H){H[H.Text=0]="Text",H[H.Method=1]="Method",H[H.Function=2]="Function",H[H.Constructor=3]="Constructor",H[H.Field=4]="Field",H[H.Variable=5]="Variable",H[H.Class=6]="Class",H[H.Interface=7]="Interface",H[H.Module=8]="Module",H[H.Property=9]="Property",H[H.Unit=10]="Unit",H[H.Value=11]="Value",H[H.Enum=12]="Enum",H[H.Keyword=13]="Keyword",H[H.Snippet=14]="Snippet",H[H.Color=15]="Color",H[H.File=16]="File",H[H.Reference=17]="Reference",H[H.Folder=18]="Folder",H[H.EnumMember=19]="EnumMember",H[H.Constant=20]="Constant",H[H.Struct=21]="Struct",H[H.Event=22]="Event",H[H.Operator=23]="Operator",H[H.TypeParameter=24]="TypeParameter",H[H.User=25]="User",H[H.Issue=26]="Issue"})(ke=e.CompletionItemKind||(e.CompletionItemKind={}));var ye;(function(H){H[H.Deprecated=1]="Deprecated"})(ye=e.CompletionItemTag||(e.CompletionItemTag={}));let Ae=class{constructor(x,re){this.label=x,this.kind=re}toJSON(){return{label:this.label,kind:this.kind&&ke[this.kind],detail:this.detail,documentation:this.documentation,sortText:this.sortText,filterText:this.filterText,preselect:this.preselect,insertText:this.insertText,textEdit:this.textEdit}}};Ae=Ve([a],Ae),e.CompletionItem=Ae;let oe=class{constructor(x=[],re=!1){this.items=x,this.isIncomplete=re}};oe=Ve([a],oe),e.CompletionList=oe;let ue=class{constructor(x,re,Pe){this.text=x,this.range=re,this.command=Pe}};ue=Ve([a],ue),e.InlineSuggestion=ue;let fe=class{constructor(x){this.items=x}};fe=Ve([a],fe),e.InlineSuggestions=fe;var we;(function(H){H[H.Active=-1]="Active",H[H.Beside=-2]="Beside",H[H.One=1]="One",H[H.Two=2]="Two",H[H.Three=3]="Three",H[H.Four=4]="Four",H[H.Five=5]="Five",H[H.Six=6]="Six",H[H.Seven=7]="Seven",H[H.Eight=8]="Eight",H[H.Nine=9]="Nine"})(we=e.ViewColumn||(e.ViewColumn={}));var q;(function(H){H[H.Left=1]="Left",H[H.Right=2]="Right"})(q=e.StatusBarAlignment||(e.StatusBarAlignment={}));var pe;(function(H){H[H.Off=0]="Off",H[H.On=1]="On",H[H.Relative=2]="Relative"})(pe=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var Se;(function(H){H[H.Manual=1]="Manual",H[H.AfterDelay=2]="AfterDelay",H[H.FocusOut=3]="FocusOut"})(Se=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var Te;(function(H){H[H.Default=0]="Default",H[H.InCenter=1]="InCenter",H[H.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",H[H.AtTop=3]="AtTop"})(Te=e.TextEditorRevealType||(e.TextEditorRevealType={}));var Oe;(function(H){H[H.Keyboard=1]="Keyboard",H[H.Mouse=2]="Mouse",H[H.Command=3]="Command"})(Oe=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));var je;(function(H){H[H.OpenOpen=0]="OpenOpen",H[H.ClosedClosed=1]="ClosedClosed",H[H.OpenClosed=2]="OpenClosed",H[H.ClosedOpen=3]="ClosedOpen"})(je=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={})),function(H){function x(re){switch(re){case"keyboard":return H.Keyboard;case"mouse":return H.Mouse;case"api":return H.Command}}H.fromValue=x}(Oe=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));let qe=class{constructor(x,re){if(re&&!E.URI.isUri(re))throw R.illegalArgument("target");if(!U.isRange(x)||x.isEmpty)throw R.illegalArgument("range");this.range=x,this.target=re}};qe=Ve([a],qe),e.DocumentLink=qe;let Ze=class{constructor(x,re,Pe,Xe){this.red=x,this.green=re,this.blue=Pe,this.alpha=Xe}};Ze=Ve([a],Ze),e.Color=Ze;let nt=class{constructor(x,re){if(re&&!(re instanceof Ze))throw R.illegalArgument("color");if(!U.isRange(x)||x.isEmpty)throw R.illegalArgument("range");this.range=x,this.color=re}};nt=Ve([a],nt),e.ColorInformation=nt;let ct=class{constructor(x){if(!x||typeof x!="string")throw R.illegalArgument("label");this.label=x}};ct=Ve([a],ct),e.ColorPresentation=ct;var Ee;(function(H){H[H.RGB=0]="RGB",H[H.HEX=1]="HEX",H[H.HSL=2]="HSL"})(Ee=e.ColorFormat||(e.ColorFormat={}));var Ce;(function(H){H[H.Error=0]="Error",H[H.Warning=1]="Warning",H[H.Information=2]="Information"})(Ce=e.SourceControlInputBoxValidationType||(e.SourceControlInputBoxValidationType={}));class ce{constructor(x,re,Pe){if(this.startIndex=x,this.length=re,this.tooltip=Pe,typeof x!="number"||x<0)throw R.illegalArgument("startIndex");if(typeof re!="number"||re<1)throw R.illegalArgument("length");if(Pe!==void 0&&typeof Pe!="string")throw R.illegalArgument("tooltip")}}e.TerminalLink=ce;class Q{constructor(x){this.options=x,typeof x!="object"&&R.illegalArgument("options")}}e.TerminalProfile=Q;var Be;(function(H){H[H.Always=1]="Always",H[H.Silent=2]="Silent",H[H.Never=3]="Never"})(Be=e.TaskRevealKind||(e.TaskRevealKind={}));var De;(function(H){H[H.Shared=1]="Shared",H[H.Dedicated=2]="Dedicated",H[H.New=3]="New"})(De=e.TaskPanelKind||(e.TaskPanelKind={}));let Ke=m=class{constructor(x,re){if(typeof x!="string"||typeof re!="string")throw R.illegalArgument("name");this._id=x}static from(x){switch(x){case"clean":return m.Clean;case"build":return m.Build;case"rebuild":return m.Rebuild;case"test":return m.Test;default:return}}get id(){return this._id}};Ke.Clean=new m("clean","Clean"),Ke.Build=new m("build","Build"),Ke.Rebuild=new m("rebuild","Rebuild"),Ke.Test=new m("test","Test"),Ke=m=Ve([a],Ke),e.TaskGroup=Ke;function et(H){let x="";for(let re=0;re<H.length;re++)x+=H[re].replace(/,/g,",,")+",";return x}let tt=class{constructor(x,re,Pe){if(typeof x!="string")throw R.illegalArgument("process");this._args=[],this._process=x,re!==void 0&&(Array.isArray(re)?(this._args=re,this._options=Pe):this._options=re)}get process(){return this._process}set process(x){if(typeof x!="string")throw R.illegalArgument("process");this._process=x}get args(){return this._args}set args(x){Array.isArray(x)||(x=[]),this._args=x}get options(){return this._options}set options(x){this._options=x}computeId(){const x=[];if(x.push("process"),this._process!==void 0&&x.push(this._process),this._args&&this._args.length>0)for(let re of this._args)x.push(re);return et(x)}};tt=Ve([a],tt),e.ProcessExecution=tt;let st=class{constructor(x,re,Pe){if(this._args=[],Array.isArray(re)){if(!x)throw R.illegalArgument("command can't be undefined or null");if(typeof x!="string"&&typeof x.value!="string")throw R.illegalArgument("command");this._command=x,this._args=re,this._options=Pe}else{if(typeof x!="string")throw R.illegalArgument("commandLine");this._commandLine=x,this._options=re}}get commandLine(){return this._commandLine}set commandLine(x){if(typeof x!="string")throw R.illegalArgument("commandLine");this._commandLine=x}get command(){return this._command?this._command:""}set command(x){if(typeof x!="string"&&typeof x.value!="string")throw R.illegalArgument("command");this._command=x}get args(){return this._args}set args(x){this._args=x||[]}get options(){return this._options}set options(x){this._options=x}computeId(){const x=[];if(x.push("shell"),this._commandLine!==void 0&&x.push(this._commandLine),this._command!==void 0&&x.push(typeof this._command=="string"?this._command:this._command.value),this._args&&this._args.length>0)for(let re of this._args)x.push(typeof re=="string"?re:re.value);return et(x)}};st=Ve([a],st),e.ShellExecution=st;var pt;(function(H){H[H.Escape=1]="Escape",H[H.Strong=2]="Strong",H[H.Weak=3]="Weak"})(pt=e.ShellQuoting||(e.ShellQuoting={}));var wt;(function(H){H[H.Global=1]="Global",H[H.Workspace=2]="Workspace"})(wt=e.TaskScope||(e.TaskScope={}));class Et{constructor(x){this._callback=x}computeId(){return"customExecution"+k.generateUuid()}set callback(x){this._callback=x}get callback(){return this._callback}}e.CustomExecution=Et;let vt=_=class{constructor(x,re,Pe,Xe,it,ot){this.__deprecated=!1,this._definition=this.definition=x;let lt;typeof re=="string"?(this._name=this.name=re,this._source=this.source=Pe,this.execution=Xe,lt=it,this.__deprecated=!0):re===wt.Global||re===wt.Workspace?(this.target=re,this._name=this.name=Pe,this._source=this.source=Xe,this.execution=it,lt=ot):(this.target=re,this._name=this.name=Pe,this._source=this.source=Xe,this.execution=it,lt=ot),typeof lt=="string"?(this._problemMatchers=[lt],this._hasDefinedMatchers=!0):Array.isArray(lt)?(this._problemMatchers=lt,this._hasDefinedMatchers=!0):(this._problemMatchers=[],this._hasDefinedMatchers=!1),this._isBackground=!1,this._presentationOptions=Object.create(null),this._runOptions=Object.create(null)}get _id(){return this.__id}set _id(x){this.__id=x}get _deprecated(){return this.__deprecated}clear(){this.__id!==void 0&&(this.__id=void 0,this._scope=void 0,this.computeDefinitionBasedOnExecution())}computeDefinitionBasedOnExecution(){this._execution instanceof tt?this._definition={type:_.ProcessType,id:this._execution.computeId()}:this._execution instanceof st?this._definition={type:_.ShellType,id:this._execution.computeId()}:this._execution instanceof Et?this._definition={type:_.ExtensionCallbackType,id:this._execution.computeId()}:this._definition={type:_.EmptyType,id:k.generateUuid()}}get definition(){return this._definition}set definition(x){if(x==null)throw R.illegalArgument("Kind can't be undefined or null");this.clear(),this._definition=x}get scope(){return this._scope}set target(x){this.clear(),this._scope=x}get name(){return this._name}set name(x){if(typeof x!="string")throw R.illegalArgument("name");this.clear(),this._name=x}get execution(){return this._execution}set execution(x){x===null&&(x=void 0),this.clear(),this._execution=x;const re=this._definition.type;(_.EmptyType===re||_.ProcessType===re||_.ShellType===re||_.ExtensionCallbackType===re)&&this.computeDefinitionBasedOnExecution()}get problemMatchers(){return this._problemMatchers}set problemMatchers(x){if(Array.isArray(x))this.clear(),this._problemMatchers=x,this._hasDefinedMatchers=!0;else{this.clear(),this._problemMatchers=[],this._hasDefinedMatchers=!1;return}}get hasDefinedMatchers(){return this._hasDefinedMatchers}get isBackground(){return this._isBackground}set isBackground(x){x!==!0&&x!==!1&&(x=!1),this.clear(),this._isBackground=x}get source(){return this._source}set source(x){if(typeof x!="string"||x.length===0)throw R.illegalArgument("source must be a string of length > 0");this.clear(),this._source=x}get group(){return this._group}set group(x){x===null&&(x=void 0),this.clear(),this._group=x}get detail(){return this._detail}set detail(x){x===null&&(x=void 0),this._detail=x}get presentationOptions(){return this._presentationOptions}set presentationOptions(x){x==null&&(x=Object.create(null)),this.clear(),this._presentationOptions=x}get runOptions(){return this._runOptions}set runOptions(x){x==null&&(x=Object.create(null)),this.clear(),this._runOptions=x}};vt.ExtensionCallbackType="customExecution",vt.ProcessType="process",vt.ShellType="shell",vt.EmptyType="$empty",vt=_=Ve([a],vt),e.Task=vt;var Bt;(function(H){H[H.SourceControl=1]="SourceControl",H[H.Window=10]="Window",H[H.Notification=15]="Notification"})(Bt=e.ProgressLocation||(e.ProgressLocation={}));let _t=class{constructor(x,re=ht.None){this.collapsibleState=re,E.URI.isUri(x)?this.resourceUri=x:this.label=x}};_t=Ve([a],_t),e.TreeItem=_t;var ht;(function(H){H[H.None=0]="None",H[H.Collapsed=1]="Collapsed",H[H.Expanded=2]="Expanded"})(ht=e.TreeItemCollapsibleState||(e.TreeItemCollapsibleState={}));let ut=class{constructor(x,re){this.id=x,this.color=re}};ut=Ve([a],ut),e.ThemeIcon=ut,ut.File=new ut("file"),ut.Folder=new ut("folder");let ft=class{constructor(x){this.id=x}};ft=Ve([a],ft),e.ThemeColor=ft;var Ht;(function(H){H[H.Global=1]="Global",H[H.Workspace=2]="Workspace",H[H.WorkspaceFolder=3]="WorkspaceFolder"})(Ht=e.ConfigurationTarget||(e.ConfigurationTarget={}));let kt=class{constructor(x,re){if(typeof x!="string"&&(!x||!E.URI.isUri(x)&&!E.URI.isUri(x.uri)))throw R.illegalArgument("base");if(typeof re!="string")throw R.illegalArgument("pattern");typeof x=="string"?(this.baseFolder=E.URI.file(x),this.base=x):E.URI.isUri(x)?(this.baseFolder=x,this.base=x.fsPath):(this.baseFolder=x.uri,this.base=x.uri.fsPath),this.pattern=re}};kt=Ve([a],kt),e.RelativePattern=kt;let At=class{constructor(x,re,Pe,Xe){this.enabled=typeof x=="boolean"?x:!0,typeof re=="string"&&(this.condition=re),typeof Pe=="string"&&(this.hitCondition=Pe),typeof Xe=="string"&&(this.logMessage=Xe)}get id(){return this._id||(this._id=k.generateUuid()),this._id}};At=Ve([a],At),e.Breakpoint=At;let Kt=class extends At{constructor(x,re,Pe,Xe,it){super(re,Pe,Xe,it);if(x===null)throw R.illegalArgument("location");this.location=x}};Kt=Ve([a],Kt),e.SourceBreakpoint=Kt;let St=class extends At{constructor(x,re,Pe,Xe,it){super(re,Pe,Xe,it);this.functionName=x}};St=Ve([a],St),e.FunctionBreakpoint=St;let en=class extends At{constructor(x,re,Pe,Xe,it,ot,lt){super(Xe,it,ot,lt);if(!re)throw R.illegalArgument("dataId");this.label=x,this.dataId=re,this.canPersist=Pe}};en=Ve([a],en),e.DataBreakpoint=en;let tn=class{constructor(x,re,Pe){this.command=x,this.args=re||[],this.options=Pe}};tn=Ve([a],tn),e.DebugAdapterExecutable=tn;let gt=class{constructor(x,re){this.port=x,this.host=re}};gt=Ve([a],gt),e.DebugAdapterServer=gt;let Qt=class{constructor(x){this.path=x}};Qt=Ve([a],Qt),e.DebugAdapterNamedPipeServer=Qt;let zt=class{constructor(x){this.implementation=x}};zt=Ve([a],zt),e.DebugAdapterInlineImplementation=zt;let nn=class{constructor(x,re){this.range=x,this.expression=re}};nn=Ve([a],nn),e.EvaluatableExpression=nn;var En;(function(H){H[H.Automatic=0]="Automatic",H[H.Explicit=1]="Explicit"})(En=e.InlineCompletionTriggerKind||(e.InlineCompletionTriggerKind={}));let Dt=class{constructor(x,re){this.range=x,this.text=re}};Dt=Ve([a],Dt),e.InlineValueText=Dt;let Xt=class{constructor(x,re,Pe=!0){this.range=x,this.variableName=re,this.caseSensitiveLookup=Pe}};Xt=Ve([a],Xt),e.InlineValueVariableLookup=Xt;let rn=class{constructor(x,re){this.range=x,this.expression=re}};rn=Ve([a],rn),e.InlineValueEvaluatableExpression=rn;let $t=class{constructor(x,re){this.frameId=x,this.stoppedLocation=re}};$t=Ve([a],$t),e.InlineValueContext=$t;var dt;(function(H){H[H.Changed=1]="Changed",H[H.Created=2]="Created",H[H.Deleted=3]="Deleted"})(dt=e.FileChangeType||(e.FileChangeType={}));let sn=D=class extends Error{constructor(x,re=r.FileSystemProviderErrorCode.Unknown,Pe){var Xe;super(E.URI.isUri(x)?x.toString(!0):x);this.code=(Xe=Pe==null?void 0:Pe.name)!==null&&Xe!==void 0?Xe:"Unknown",r.markAsFileSystemProviderError(this,re),typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,D.prototype),typeof Error.captureStackTrace=="function"&&typeof Pe=="function"&&Error.captureStackTrace(this,Pe)}static FileExists(x){return new D(x,r.FileSystemProviderErrorCode.FileExists,D.FileExists)}static FileNotFound(x){return new D(x,r.FileSystemProviderErrorCode.FileNotFound,D.FileNotFound)}static FileNotADirectory(x){return new D(x,r.FileSystemProviderErrorCode.FileNotADirectory,D.FileNotADirectory)}static FileIsADirectory(x){return new D(x,r.FileSystemProviderErrorCode.FileIsADirectory,D.FileIsADirectory)}static NoPermissions(x){return new D(x,r.FileSystemProviderErrorCode.NoPermissions,D.NoPermissions)}static Unavailable(x){return new D(x,r.FileSystemProviderErrorCode.Unavailable,D.Unavailable)}};sn=D=Ve([a],sn),e.FileSystemError=sn;let Tt=class{constructor(x,re,Pe){this.start=x,this.end=re,this.kind=Pe}};Tt=Ve([a],Tt),e.FoldingRange=Tt;var Vt;(function(H){H[H.Comment=1]="Comment",H[H.Imports=2]="Imports",H[H.Region=3]="Region"})(Vt=e.FoldingRangeKind||(e.FoldingRangeKind={}));var hn;(function(H){H[H.Collapsed=0]="Collapsed",H[H.Expanded=1]="Expanded"})(hn=e.CommentThreadCollapsibleState||(e.CommentThreadCollapsibleState={}));var _n;(function(H){H[H.Editing=0]="Editing",H[H.Preview=1]="Preview"})(_n=e.CommentMode||(e.CommentMode={}));class fn{constructor(x,re=[]){this.tokenTypes=x,this.tokenModifiers=re}}e.SemanticTokensLegend=fn;function Sn(H){return typeof H=="undefined"||P.isStringArray(H)}class Yt{constructor(x){if(this._prevLine=0,this._prevChar=0,this._dataIsSortedAndDeltaEncoded=!0,this._data=[],this._dataLen=0,this._tokenTypeStrToInt=new Map,this._tokenModifierStrToInt=new Map,this._hasLegend=!1,x){this._hasLegend=!0;for(let re=0,Pe=x.tokenTypes.length;re<Pe;re++)this._tokenTypeStrToInt.set(x.tokenTypes[re],re);for(let re=0,Pe=x.tokenModifiers.length;re<Pe;re++)this._tokenModifierStrToInt.set(x.tokenModifiers[re],re)}}push(x,re,Pe,Xe,it){if(typeof x=="number"&&typeof re=="number"&&typeof Pe=="number"&&typeof Xe=="number"&&(typeof it=="number"||typeof it=="undefined"))return typeof it=="undefined"&&(it=0),this._pushEncoded(x,re,Pe,Xe,it);if(U.isRange(x)&&typeof re=="string"&&Sn(Pe))return this._push(x,re,Pe);throw R.illegalArgument()}_push(x,re,Pe){if(!this._hasLegend)throw new Error("Legend must be provided in constructor");if(x.start.line!==x.end.line)throw new Error("`range` cannot span multiple lines");if(!this._tokenTypeStrToInt.has(re))throw new Error("`tokenType` is not in the provided legend");const Xe=x.start.line,it=x.start.character,ot=x.end.character-x.start.character,lt=this._tokenTypeStrToInt.get(re);let yt=0;if(Pe)for(const Pt of Pe){if(!this._tokenModifierStrToInt.has(Pt))throw new Error("`tokenModifier` is not in the provided legend");const Lt=this._tokenModifierStrToInt.get(Pt);yt|=1<<Lt>>>0}this._pushEncoded(Xe,it,ot,lt,yt)}_pushEncoded(x,re,Pe,Xe,it){if(this._dataIsSortedAndDeltaEncoded&&(x<this._prevLine||x===this._prevLine&&re<this._prevChar)){this._dataIsSortedAndDeltaEncoded=!1;const yt=this._data.length/5|0;let Pt=0,Lt=0;for(let Ot=0;Ot<yt;Ot++){let Ut=this._data[5*Ot],un=this._data[5*Ot+1];Ut===0?(Ut=Pt,un+=Lt):Ut+=Pt,this._data[5*Ot]=Ut,this._data[5*Ot+1]=un,Pt=Ut,Lt=un}}let ot=x,lt=re;this._dataIsSortedAndDeltaEncoded&&this._dataLen>0&&(ot-=this._prevLine,ot===0&&(lt-=this._prevChar)),this._data[this._dataLen++]=ot,this._data[this._dataLen++]=lt,this._data[this._dataLen++]=Pe,this._data[this._dataLen++]=Xe,this._data[this._dataLen++]=it,this._prevLine=x,this._prevChar=re}static _sortAndDeltaEncode(x){let re=[];const Pe=x.length/5|0;for(let lt=0;lt<Pe;lt++)re[lt]=lt;re.sort((lt,yt)=>{const Pt=x[5*lt],Lt=x[5*yt];if(Pt===Lt){const Ot=x[5*lt+1],Ut=x[5*yt+1];return Ot-Ut}return Pt-Lt});const Xe=new Uint32Array(x.length);let it=0,ot=0;for(let lt=0;lt<Pe;lt++){const yt=5*re[lt],Pt=x[yt+0],Lt=x[yt+1],Ot=x[yt+2],Ut=x[yt+3],un=x[yt+4],On=Pt-it,Wn=On===0?Lt-ot:Lt,dn=5*lt;Xe[dn+0]=On,Xe[dn+1]=Wn,Xe[dn+2]=Ot,Xe[dn+3]=Ut,Xe[dn+4]=un,it=Pt,ot=Lt}return Xe}build(x){return this._dataIsSortedAndDeltaEncoded?new Ft(new Uint32Array(this._data),x):new Ft(Yt._sortAndDeltaEncode(this._data),x)}}e.SemanticTokensBuilder=Yt;class Ft{constructor(x,re){this.resultId=re,this.data=x}}e.SemanticTokens=Ft;class yn{constructor(x,re,Pe){this.start=x,this.deleteCount=re,this.data=Pe}}e.SemanticTokensEdit=yn;class on{constructor(x,re){this.resultId=re,this.edits=x}}e.SemanticTokensEdits=on;var an;(function(H){H[H.Separate=0]="Separate",H[H.MergeWithParent=1]="MergeWithParent"})(an=e.DebugConsoleMode||(e.DebugConsoleMode={}));var Dn;(function(H){H[H.Initial=1]="Initial",H[H.Dynamic=2]="Dynamic"})(Dn=e.DebugConfigurationProviderTriggerKind||(e.DebugConfigurationProviderTriggerKind={}));let Jt=class{constructor(){}};Jt.Back={iconPath:new ut("arrow-left")},Jt=Ve([a],Jt),e.QuickInputButtons=Jt;var jt;(function(H){H[H.UI=1]="UI",H[H.Workspace=2]="Workspace"})(jt=e.ExtensionKind||(e.ExtensionKind={}));class Cn{constructor(x,re,Pe){this.badge=x,this.tooltip=re,this.color=Pe}static validate(x){if(x.badge&&x.badge.length!==1&&x.badge.length!==2)throw new Error("The 'badge'-property must be undefined or a short character");if(!x.color&&!x.badge&&!x.tooltip)throw new Error("The decoration is empty")}}e.FileDecoration=Cn;let ln=class{constructor(x){this.kind=x}};ln=Ve([a],ln),e.ColorTheme=ln;var kn;(function(H){H[H.Light=1]="Light",H[H.Dark=2]="Dark",H[H.HighContrast=3]="HighContrast"})(kn=e.ColorThemeKind||(e.ColorThemeKind={}));class qt{constructor(x,re){if(x<0)throw R.illegalArgument("start must be positive");if(re<0)throw R.illegalArgument("end must be positive");x<=re?(this._start=x,this._end=re):(this._start=re,this._end=x)}static isNotebookRange(x){return x instanceof qt?!0:x?typeof x.start=="number"&&typeof x.end=="number":!1}get start(){return this._start}get end(){return this._end}get isEmpty(){return this._start===this._end}with(x){let re=this._start,Pe=this._end;return x.start!==void 0&&(re=x.start),x.end!==void 0&&(Pe=x.end),re===this._start&&Pe===this._end?this:new qt(re,Pe)}}e.NotebookRange=qt;class Rt{constructor(x,re,Pe,Xe,it,ot,lt){this.kind=x,this.value=re,this.languageId=Pe,this.mime=Xe,this.outputs=it??[],this.metadata=ot,this.executionSummary=lt,Rt.validate(this)}static validate(x){if(typeof x.kind!="number")throw new Error("NotebookCellData MUST have 'kind' property");if(typeof x.value!="string")throw new Error("NotebookCellData MUST have 'value' property");if(typeof x.languageId!="string")throw new Error("NotebookCellData MUST have 'languageId' property")}static isNotebookCellDataArray(x){return Array.isArray(x)&&x.every(re=>Rt.isNotebookCellData(re))}static isNotebookCellData(x){return!0}}e.NotebookCellData=Rt;class mn{constructor(x){this.cells=x}}e.NotebookData=mn;class It{constructor(x,re){this.data=x,this.mime=re;const Pe=A.normalizeMimeType(re,!0);if(!Pe)throw new Error("INVALID mime type, must not be empty or falsy: "+re);this.mime=Pe}static isNotebookCellOutputItem(x){return x instanceof It?!0:x?typeof x.mime=="string"&&x.data instanceof Uint8Array:!1}static error(x){const re={name:x.name,message:x.message,stack:x.stack};return It.json(re,"application/vnd.code.notebook.error")}static stdout(x){return It.text(x,"application/vnd.code.notebook.stdout")}static stderr(x){return It.text(x,"application/vnd.code.notebook.stderr")}static bytes(x,re="application/octet-stream"){return new It(x,re)}static text(x,re=A.Mimes.text){const Pe=$e(It,u,"f",S).encode(String(x));return new It(Pe,re)}static json(x,re="application/json"){const Pe=JSON.stringify(x,void 0,"	");return It.text(Pe,re)}}e.NotebookCellOutputItem=It,u=It,S={value:new TextEncoder};class Wt{constructor(x,re,Pe){this.items=Wt.ensureUniqueMimeTypes(x,!0),typeof re=="string"?(this.id=re,this.metadata=Pe):(this.id=k.generateUuid(),this.metadata=re??Pe)}static isNotebookCellOutput(x){return x instanceof Wt?!0:!x||typeof x!="object"?!1:typeof x.id=="string"&&P.isArray(x.items)}static ensureUniqueMimeTypes(x,re=!1){const Pe=new Set,Xe=new Set;for(let it=0;it<x.length;it++){const ot=x[it],lt=A.normalizeMimeType(ot.mime);if(!Pe.has(lt)){Pe.add(lt);continue}Xe.add(it),re&&console.warn(`DUPLICATED mime type '${ot.mime}' will be dropped`)}return Xe.size===0?x:x.filter((it,ot)=>!Xe.has(ot))}}e.NotebookCellOutput=Wt;var Ne;(function(H){H[H.Markup=1]="Markup",H[H.Code=2]="Code"})(Ne=e.NotebookCellKind||(e.NotebookCellKind={}));var cn;(function(H){H[H.Idle=1]="Idle",H[H.Pending=2]="Pending",H[H.Executing=3]="Executing"})(cn=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var gn;(function(H){H[H.Left=1]="Left",H[H.Right=2]="Right"})(gn=e.NotebookCellStatusBarAlignment||(e.NotebookCellStatusBarAlignment={}));var mt;(function(H){H[H.Default=0]="Default",H[H.InCenter=1]="InCenter",H[H.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",H[H.AtTop=3]="AtTop"})(mt=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));class Pn{constructor(x,re){this.text=x,this.alignment=re}}e.NotebookCellStatusBarItem=Pn;var In;(function(H){H[H.Default=1]="Default",H[H.Preferred=2]="Preferred"})(In=e.NotebookControllerAffinity||(e.NotebookControllerAffinity={}));class pn{constructor(x,re=[]){this.uri=x,this.provides=p.asArray(re)}}e.NotebookRendererScript=pn;let Zt=class{constructor(x,re){this.label=x,this.timestamp=re}};Zt=Ve([a],Zt),e.TimelineItem=Zt;var An;(function(H){H[H.Production=1]="Production",H[H.Development=2]="Development",H[H.Test=3]="Test"})(An=e.ExtensionMode||(e.ExtensionMode={}));var Tn;(function(H){H[H.Node=1]="Node",H[H.Webworker=2]="Webworker"})(Tn=e.ExtensionRuntime||(e.ExtensionRuntime={}));var Rn;(function(H){H[H.Other=0]="Other",H[H.Comment=1]="Comment",H[H.String=2]="String",H[H.RegEx=4]="RegEx"})(Rn=e.StandardTokenType||(e.StandardTokenType={}));class Ln{constructor(x,re){this.ranges=x,this.wordPattern=re}}e.LinkedEditingRanges=Ln;class vn{constructor(x,re){this._port=x,this._autoForwardAction=re}get port(){return this._port}get autoForwardAction(){return this._autoForwardAction}}e.PortAttributes=vn;var Fn;(function(H){H[H.Unset=0]="Unset",H[H.Queued=1]="Queued",H[H.Running=2]="Running",H[H.Passed=3]="Passed",H[H.Failed=4]="Failed",H[H.Skipped=5]="Skipped",H[H.Errored=6]="Errored"})(Fn=e.TestResultState||(e.TestResultState={}));var wn;(function(H){H[H.Error=0]="Error",H[H.Warning=1]="Warning",H[H.Information=2]="Information",H[H.Hint=3]="Hint"})(wn=e.TestMessageSeverity||(e.TestMessageSeverity={}));const Mt=(H,x,re,Pe)=>{let Xe=re;return{enumerable:!0,configurable:!1,get(){return Xe},set(it){Pe(Xe,it)||(Xe=it,H.bus.fire([3,x,it]))}}},Nt=(H,x)=>H===x,Mn=(H,x)=>H===x?!0:!H||!x?!1:H.isEqual(x);class te{constructor(x,re,Pe=!1){this.tests=x,this.exclude=re,this.debug=Pe}}e.TestRunRequest=te;class de{constructor(x,re,Pe,Xe,it){this.data=Xe;const ot=l.getPrivateApiFor(this);if(Object.defineProperties(this,{id:{value:x,enumerable:!0,writable:!1},uri:{value:Pe,enumerable:!0,writable:!1},parent:{enumerable:!1,value:it,writable:!1},children:{value:new y.ReadonlyMapView(ot.children),enumerable:!0,writable:!1},range:Mt(ot,"range",void 0,Mn),label:Mt(ot,"label",re,Nt),description:Mt(ot,"description",void 0,Nt),runnable:Mt(ot,"runnable",!0,Nt),debuggable:Mt(ot,"debuggable",!1,Nt),canResolveChildren:Mt(ot,"canResolveChildren",!1,Nt),busy:Mt(ot,"busy",!1,Nt),error:Mt(ot,"error",void 0,Nt)}),it){if(!(it instanceof de))throw new Error(`The "parent" passed in for TestItem ${x} is invalid`);const lt=l.getPrivateApiFor(it);if(lt.children.has(x))throw new Error(`Attempted to insert a duplicate test item ID ${x}`);lt.children.set(x,this),lt.bus.fire([0,this])}}invalidate(){l.getPrivateApiFor(this).bus.fire([2])}dispose(){this.parent&&l.getPrivateApiFor(this.parent).children.delete(this.id),l.getPrivateApiFor(this).bus.fire([1])}}e.TestItemImpl=de;class Re{constructor(x){this.message=x,this.severity=wn.Error}static diff(x,re,Pe){const Xe=new Re(x);return Xe.expectedOutput=re,Xe.actualOutput=Pe,Xe}}e.TestMessage=Re;var at;(function(H){H[H.None=0]="None",H[H.Option=1]="Option",H[H.Default=2]="Default",H[H.Preferred=3]="Preferred"})(at=e.ExternalUriOpenerPriority||(e.ExternalUriOpenerPriority={}));var bt;(function(H){H[H.Untrusted=0]="Untrusted",H[H.Trusted=1]="Trusted",H[H.Unspecified=2]="Unspecified"})(bt=e.WorkspaceTrustState||(e.WorkspaceTrustState={}));var Ct;(function(H){H[H.Notify=1]="Notify",H[H.OpenBrowser=2]="OpenBrowser",H[H.OpenPreview=3]="OpenPreview",H[H.Silent=4]="Silent",H[H.Ignore=5]="Ignore",H[H.OpenBrowserOnce=6]="OpenBrowserOnce"})(Ct=e.PortAutoForwardAction||(e.PortAutoForwardAction={}))}),define(me[119],ge([0,1,50,10,8,144,106,7,18]),function(X,e,p,R,C,y,A,P,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentLine=e.ExtHostDocumentData=e.getWordDefinitionFor=e.setWordDefinitionFor=void 0;const k=new Map;function r(c,u){u?k.set(c,u):k.delete(c)}e.setWordDefinitionFor=r;function I(c){return k.get(c)}e.getWordDefinitionFor=I;class l extends y.MirrorTextModel{constructor(u,S,w,b,d,h,g,t){super(S,w,b,d);this._proxy=u,this._languageId=h,this._isDirty=g,this._notebook=t,this._isDisposed=!1}dispose(){p.ok(!this._isDisposed),this._isDisposed=!0,this._isDirty=!1}equalLines(u){return E.equals(this._lines,u)}get document(){if(!this._document){const u=this;this._document={get uri(){return u._uri},get fileName(){return u._uri.fsPath},get isUntitled(){return u._uri.scheme===R.Schemas.untitled},get languageId(){return u._languageId},get version(){return u._versionId},get isClosed(){return u._isDisposed},get isDirty(){return u._isDirty},get notebook(){return u._notebook},save(){return u._save()},getText(S){return S?u._getTextInRange(S):u.getText()},get eol(){return u._eol===`
`?P.EndOfLine.LF:P.EndOfLine.CRLF},get lineCount(){return u._lines.length},lineAt(S){return u._lineAt(S)},offsetAt(S){return u._offsetAt(S)},positionAt(S){return u._positionAt(S)},validateRange(S){return u._validateRange(S)},validatePosition(S){return u._validatePosition(S)},getWordRangeAtPosition(S,w){return u._getWordRangeAtPosition(S,w)}}}return Object.freeze(this._document)}_acceptLanguageId(u){p.ok(!this._isDisposed),this._languageId=u}_acceptIsDirty(u){p.ok(!this._isDisposed),this._isDirty=u}_save(){return this._isDisposed?Promise.reject(new Error("Document has been closed")):this._proxy.$trySaveDocument(this._uri)}_getTextInRange(u){const S=this._validateRange(u);if(S.isEmpty)return"";if(S.isSingleLine)return this._lines[S.start.line].substring(S.start.character,S.end.character);const w=this._eol,b=S.start.line,d=S.end.line,h=[];h.push(this._lines[b].substring(S.start.character));for(let g=b+1;g<d;g++)h.push(this._lines[g]);return h.push(this._lines[d].substring(0,S.end.character)),h.join(w)}_lineAt(u){let S;if(u instanceof P.Position?S=u.line:typeof u=="number"&&(S=u),typeof S!="number"||S<0||S>=this._lines.length||Math.floor(S)!==S)throw new Error("Illegal value for `line`");return new f(S,this._lines[S],S===this._lines.length-1)}_offsetAt(u){return u=this._validatePosition(u),this._ensureLineStarts(),this._lineStarts.getPrefixSum(u.line-1)+u.character}_positionAt(u){u=Math.floor(u),u=Math.max(0,u),this._ensureLineStarts();const S=this._lineStarts.getIndexOf(u),w=this._lines[S.index].length;return new P.Position(S.index,Math.min(S.remainder,w))}_validateRange(u){if(!(u instanceof P.Range))throw new Error("Invalid argument");const S=this._validatePosition(u.start),w=this._validatePosition(u.end);return S===u.start&&w===u.end?u:new P.Range(S.line,S.character,w.line,w.character)}_validatePosition(u){if(!(u instanceof P.Position))throw new Error("Invalid argument");if(this._lines.length===0)return u.with(0,0);let{line:S,character:w}=u,b=!1;if(S<0)S=0,w=0,b=!0;else if(S>=this._lines.length)S=this._lines.length-1,w=this._lines[S].length,b=!0;else{const d=this._lines[S].length;w<0?(w=0,b=!0):w>d&&(w=d,b=!0)}return b?new P.Position(S,w):u}_getWordRangeAtPosition(u,S){const w=this._validatePosition(u);if(!S)S=I(this._languageId);else if(C.regExpLeadsToEndlessLoop(S))throw new Error(`[getWordRangeAtPosition]: ignoring custom regexp '${S.source}' because it matches the empty string.`);const b=A.getWordAtText(w.character+1,A.ensureValidWordDefinition(S),this._lines[w.line],0);if(b)return new P.Range(w.line,b.startColumn-1,w.line,b.endColumn-1)}}e.ExtHostDocumentData=l;class f{constructor(u,S,w){this._line=u,this._text=S,this._isLastLine=w}get lineNumber(){return this._line}get text(){return this._text}get range(){return new P.Range(this._line,0,this._line,this._text.length)}get rangeIncludingLineBreak(){return this._isLastLine?this.range:new P.Range(this._line,0,this._line+1,0)}get firstNonWhitespaceCharacterIndex(){return/^(\s*)/.exec(this._text)[1].length}get isEmptyOrWhitespace(){return this.firstNonWhitespaceCharacterIndex===this._text.length}}e.ExtHostDocumentLine=f}),define(me[194],ge([0,1,7,3,108,6,76,23,2,32]),function(X,e,p,R,C,y,A,P,E,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookConcatDocument=void 0;class r{constructor(l,f,c,u){this._notebook=c,this._selector=u,this._disposables=new y.DisposableStore,this._isClosed=!1,this._versionId=0,this._onDidChange=new R.Emitter,this.onDidChange=this._onDidChange.event,this.uri=E.URI.from({scheme:"vscode-concat-doc",path:k.generateUuid()}),this._init(),this._disposables.add(f.onDidChangeDocument(w=>{const b=this._cellUris.get(w.document.uri);b!==void 0&&(this._cellLengths.changeValue(b,this._cells[b].document.getText().length+1),this._cellLines.changeValue(b,this._cells[b].document.lineCount),this._versionId+=1,this._onDidChange.fire(void 0))}));const S=w=>{w===this._notebook&&(this._init(),this._versionId+=1,this._onDidChange.fire(void 0))};this._disposables.add(l.onDidChangeNotebookCells(w=>S(w.document)))}dispose(){this._disposables.dispose(),this._isClosed=!0}get isClosed(){return this._isClosed}_init(){this._cells=[],this._cellUris=new P.ResourceMap;const l=[],f=[];for(const c of this._notebook.getCells())c.kind===p.NotebookCellKind.Code&&(!this._selector||A.score(this._selector,c.document.uri,c.document.languageId,!0))&&(this._cellUris.set(c.document.uri,this._cells.length),this._cells.push(c),l.push(c.document.getText().length+1),f.push(c.document.lineCount));this._cellLengths=new C.PrefixSumComputer(new Uint32Array(l)),this._cellLines=new C.PrefixSumComputer(new Uint32Array(f))}get version(){return this._versionId}getText(l){var f,c;if(!l){let d="";for(const h of this._cells)d+=h.document.getText()+`
`;return d=d.slice(0,-1),d}if(l.isEmpty)return"";const u=this.locationAt(l.start),S=this.locationAt(l.end),w=this._cells[(f=this._cellUris.get(u.uri))!==null&&f!==void 0?f:-1],b=this._cells[(c=this._cellUris.get(S.uri))!==null&&c!==void 0?c:-1];if(!w||!b)return"";if(w===b)return w.document.getText(new p.Range(u.range.start,S.range.end));{const d=w.document.getText(new p.Range(u.range.start,new p.Position(w.document.lineCount,0))),h=b.document.getText(new p.Range(new p.Position(0,0),S.range.end));return d+`
`+h}}offsetAt(l){const f=this._cellLines.getIndexOf(l.line),c=this._cellLengths.getPrefixSum(f.index-1),u=this._cells[f.index].document.offsetAt(l.with(f.remainder));return c+u}positionAt(l){if(typeof l=="number"){const c=this._cellLengths.getIndexOf(l),u=this._cellLines.getPrefixSum(c.index-1);return this._cells[c.index].document.positionAt(c.remainder).translate(u)}const f=this._cellUris.get(l.uri);if(f!==void 0){const c=this._cellLines.getPrefixSum(f-1);return new p.Position(c+l.range.start.line,l.range.start.character)}return new p.Position(0,0)}locationAt(l){p.Range.isRange(l)||(l=new p.Range(l,l));const f=this._cellLines.getIndexOf(l.start.line);let c=f;l.isEmpty||(c=this._cellLines.getIndexOf(l.end.line));const u=new p.Position(f.remainder,l.start.character),S=new p.Position(c.remainder,l.end.character),w=new p.Range(u,S),b=this._cells[f.index];return new p.Location(b.document.uri,b.document.validateRange(w))}contains(l){return this._cellUris.has(l)}validateRange(l){const f=this.validatePosition(l.start),c=this.validatePosition(l.end);return l.with(f,c)}validatePosition(l){const f=this._cellLines.getIndexOf(l.line),c=new p.Position(f.remainder,l.character),u=this._cells[f.index].document.validatePosition(c),S=this._cellLines.getPrefixSum(f.index-1);return new p.Position(S+u.line,u.character)}}e.ExtHostNotebookConcatDocument=r}),define(me[195],ge([0,1,7,13,3]),function(X,e,p,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTheming=void 0;let y=class{constructor(P){this._actual=new p.ColorTheme(p.ColorThemeKind.Dark),this._onDidChangeActiveColorTheme=new C.Emitter}get activeColorTheme(){return this._actual}$onColorThemeChange(P){let E=P==="light"?p.ColorThemeKind.Light:P==="dark"?p.ColorThemeKind.Dark:p.ColorThemeKind.HighContrast;this._actual=new p.ColorTheme(E),this._onDidChangeActiveColorTheme.fire(this._actual)}get onDidChangeActiveColorTheme(){return this._onDidChangeActiveColorTheme.event}};y=Ve([We(0,R.IExtHostRpcService)],y),e.ExtHostTheming=y}),define(me[60],ge([0,1,4]),function(X,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URITransformerService=e.IURITransformerService=void 0,e.IURITransformerService=p.createDecorator("IURITransformerService");class R{constructor(y){y?(this.transformIncoming=y.transformIncoming.bind(y),this.transformOutgoing=y.transformOutgoing.bind(y),this.transformOutgoingURI=y.transformOutgoingURI.bind(y),this.transformOutgoingScheme=y.transformOutgoingScheme.bind(y)):(this.transformIncoming=A=>A,this.transformOutgoing=A=>A,this.transformOutgoingURI=A=>A,this.transformOutgoingScheme=A=>A)}}e.URITransformerService=R}),define(me[196],ge([0,1,22]),function(X,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeWebviewMessage=e.serializeWebviewMessage=void 0;class R{constructor(){this.buffers=[]}add(E){let k=this.buffers.indexOf(E);return k<0&&(k=this.buffers.length,this.buffers.push(E)),k}}function C(P,E){if(E.serializeBuffersForPostMessage){const k=new R,r=(f,c)=>{if(c instanceof ArrayBuffer){const u=k.add(c);return{$$vscode_array_buffer_reference$$:!0,index:u}}else if(ArrayBuffer.isView(c)){const u=y(c);if(u){const S=k.add(c.buffer);return{$$vscode_array_buffer_reference$$:!0,index:S,view:{type:u,byteLength:c.byteLength,byteOffset:c.byteOffset}}}}return c},I=JSON.stringify(P,r),l=k.buffers.map(f=>{const c=new Uint8Array(f);return p.VSBuffer.wrap(c)});return{message:I,buffers:l}}else return{message:JSON.stringify(P),buffers:[]}}e.serializeWebviewMessage=C;function y(P){switch(P.constructor.name){case"Int8Array":return 1;case"Uint8Array":return 2;case"Uint8ClampedArray":return 3;case"Int16Array":return 4;case"Uint16Array":return 5;case"Int32Array":return 6;case"Uint32Array":return 7;case"Float32Array":return 8;case"Float64Array":return 9;case"BigInt64Array":return 10;case"BigUint64Array":return 11}}function A(P,E){const k=E.map(l=>{const f=new ArrayBuffer(l.byteLength);return new Uint8Array(f).set(l.buffer),f}),r=E.length?(l,f)=>{if(typeof f=="object"&&f.$$vscode_array_buffer_reference$$){const c=f,{index:u}=c,S=k[u];if(c.view)switch(c.view.type){case 1:return new Int8Array(S,c.view.byteOffset,c.view.byteLength/Int8Array.BYTES_PER_ELEMENT);case 2:return new Uint8Array(S,c.view.byteOffset,c.view.byteLength/Uint8Array.BYTES_PER_ELEMENT);case 3:return new Uint8ClampedArray(S,c.view.byteOffset,c.view.byteLength/Uint8ClampedArray.BYTES_PER_ELEMENT);case 4:return new Int16Array(S,c.view.byteOffset,c.view.byteLength/Int16Array.BYTES_PER_ELEMENT);case 5:return new Uint16Array(S,c.view.byteOffset,c.view.byteLength/Uint16Array.BYTES_PER_ELEMENT);case 6:return new Int32Array(S,c.view.byteOffset,c.view.byteLength/Int32Array.BYTES_PER_ELEMENT);case 7:return new Uint32Array(S,c.view.byteOffset,c.view.byteLength/Uint32Array.BYTES_PER_ELEMENT);case 8:return new Float32Array(S,c.view.byteOffset,c.view.byteLength/Float32Array.BYTES_PER_ELEMENT);case 9:return new Float64Array(S,c.view.byteOffset,c.view.byteLength/Float64Array.BYTES_PER_ELEMENT);case 10:return new BigInt64Array(S,c.view.byteOffset,c.view.byteLength/BigInt64Array.BYTES_PER_ELEMENT);case 11:return new BigUint64Array(S,c.view.byteOffset,c.view.byteLength/BigUint64Array.BYTES_PER_ELEMENT);default:throw new Error("Unknown array buffer view type")}return S}return f}:void 0;return{message:JSON.parse(P,r),arrayBuffers:k}}e.deserializeWebviewMessage=A}),define(me[83],ge([0,1,10,2]),function(X,e,p,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.asWebviewUri=e.webviewGenericCspSource=e.webviewRootResourceAuthority=e.webviewResourceBaseHost=void 0,e.webviewResourceBaseHost="vscode-webview.net",e.webviewRootResourceAuthority=`vscode-resource.${e.webviewResourceBaseHost}`,e.webviewGenericCspSource=`https://*.${e.webviewResourceBaseHost}`;function C(y,A){return y.scheme===p.Schemas.http||y.scheme===p.Schemas.https?y:(A&&A.authority&&A.isRemote&&y.scheme===p.Schemas.file&&(y=R.URI.from({scheme:p.Schemas.vscodeRemote,authority:A.authority,path:y.path})),R.URI.from({scheme:p.Schemas.https,authority:`${y.scheme}+${y.authority}.${e.webviewRootResourceAuthority}`,path:y.path,fragment:y.fragment,query:y.query}))}e.asWebviewUri=C}),define(me[197],ge([0,1,3,6,83]),function(X,e,p,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorInsets=void 0;class y{constructor(P,E,k){this._proxy=P,this._editors=E,this._initData=k,this._handlePool=0,this._disposables=new R.DisposableStore,this._insets=new Map,this._disposables.add(E.onDidChangeVisibleTextEditors(()=>{const r=E.getVisibleTextEditors();for(const I of this._insets.values())r.indexOf(I.editor)<0&&I.inset.dispose()}))}dispose(){this._insets.forEach(P=>P.inset.dispose()),this._disposables.dispose()}createWebviewEditorInset(P,E,k,r,I){let l;for(const d of this._editors.getVisibleTextEditors(!0))if(d.value===P){l=d;break}if(!l)throw new Error("not a visible editor");const f=this,c=this._handlePool++,u=new p.Emitter,S=new p.Emitter,w=new class{constructor(){this._html="",this._options=Object.create(null)}asWebviewUri(d){return C.asWebviewUri(d,f._initData.remote)}get cspSource(){return C.webviewGenericCspSource}set options(d){this._options=d,f._proxy.$setOptions(c,d)}get options(){return this._options}set html(d){this._html=d,f._proxy.$setHtml(c,d)}get html(){return this._html}get onDidReceiveMessage(){return u.event}postMessage(d){return f._proxy.$postMessage(c,d)}},b=new class{constructor(){this.editor=P,this.line=E,this.height=k,this.webview=w,this.onDidDispose=S.event}dispose(){f._insets.has(c)&&(f._insets.delete(c),f._proxy.$disposeEditorInset(c),S.fire(),S.dispose(),u.dispose())}};return this._proxy.$createEditorInset(c,l.id,l.value.document.uri,E+1,k,r||{},I.identifier,I.extensionLocation),this._insets.set(c,{editor:P,inset:b,onDidReceiveMessage:u}),b}$onDidDispose(P){const E=this._insets.get(P);E&&E.inset.dispose()}$onDidReceiveMessage(P,E){const k=this._insets.get(P);k&&k.onDidReceiveMessage.fire(E)}}e.ExtHostEditorInsets=y}),define(me[120],ge([0,1,3,16,166]),function(X,e,p,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDebugAdapter=void 0;class y{constructor(){this.pendingRequests=new Map,this.queue=[],this._onError=new p.Emitter,this._onExit=new p.Emitter,this.sequence=1}get onError(){return this._onError.event}get onExit(){return this._onExit.event}onMessage(P){this.messageCallback&&this._onError.fire(new Error("attempt to set more than one 'Message' callback")),this.messageCallback=P}onEvent(P){this.eventCallback&&this._onError.fire(new Error("attempt to set more than one 'Event' callback")),this.eventCallback=P}onRequest(P){this.requestCallback&&this._onError.fire(new Error("attempt to set more than one 'Request' callback")),this.requestCallback=P}sendResponse(P){P.seq>0?this._onError.fire(new Error(`attempt to send more than one response for command ${P.command}`)):this.internalSend("response",P)}sendRequest(P,E,k,r){const I={command:P};if(E&&Object.keys(E).length>0&&(I.arguments=E),this.internalSend("request",I),typeof r=="number"){const l=setTimeout(()=>{clearTimeout(l);const f=this.pendingRequests.get(I.seq);if(f){this.pendingRequests.delete(I.seq);const c={type:"response",seq:0,request_seq:I.seq,success:!1,command:P,message:C.localize(0,null,r,P)};f(c)}},r)}return k&&this.pendingRequests.set(I.seq,k),I.seq}acceptMessage(P){this.messageCallback?this.messageCallback(P):(this.queue.push(P),this.queue.length===1&&this.processQueue())}needsTaskBoundaryBetween(P,E){return P.type!=="event"||E.type!=="event"}async processQueue(){let P;for(;this.queue.length;){if((!P||this.needsTaskBoundaryBetween(this.queue[0],P))&&await R.timeout(0),P=this.queue.shift(),!P)return;switch(P.type){case"event":this.eventCallback&&this.eventCallback(P);break;case"request":this.requestCallback&&this.requestCallback(P);break;case"response":const E=P,k=this.pendingRequests.get(E.request_seq);k&&(this.pendingRequests.delete(E.request_seq),k(E));break}}}internalSend(P,E){E.type=P,E.seq=this.sequence++,this.sendMessage(E)}async cancelPendingRequests(){if(this.pendingRequests.size===0)return Promise.resolve();const P=new Map;this.pendingRequests.forEach((E,k)=>P.set(k,E)),await R.timeout(500),P.forEach((E,k)=>{E({type:"response",seq:0,request_seq:k,success:!1,command:"canceled",message:"canceled"}),this.pendingRequests.delete(k)})}getPendingRequestIds(){return Array.from(this.pendingRequests.keys())}dispose(){this.queue=[]}}e.AbstractDebugAdapter=y}),define(me[198],ge([0,1,8,2,9,25,10]),function(X,e,p,R,C,y,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getVisibleAndSorted=e.convertToVSCPaths=e.convertToDAPaths=e.isUri=e.getExactExpressionStartAndEnd=e.isDebuggerMainContribution=e.getExtensionHostDebugSession=e.isSessionAttach=e.filterExceptionsFromTelemetry=e.formatPII=void 0;const P=/{([^}]+)}/g;function E(i,s,n){return i.replace(P,function(o,v){return s&&v.length>0&&v[0]!=="_"?o:n&&n.hasOwnProperty(v)?n[v]:o})}e.formatPII=E;function k(i){const s={};for(const n of Object.keys(i))n.startsWith("!")||(s[n]=i[n]);return s}e.filterExceptionsFromTelemetry=k;function r(i){return i.configuration.request==="attach"&&!I(i)&&(!i.parentSession||r(i.parentSession))}e.isSessionAttach=r;function I(i){let s=i.configuration.type;if(!!s)return s==="vslsShare"&&(s=i.configuration.adapterProxy.configuration.type),p.equalsIgnoreCase(s,"extensionhost")||p.equalsIgnoreCase(s,"pwa-extensionhost")?i:i.parentSession?I(i.parentSession):void 0}e.getExtensionHostDebugSession=I;function l(i){return i.type&&(i.label||i.program||i.runtime)}e.isDebuggerMainContribution=l;function f(i,s,n){let o,v=0,m=/([^()\[\]{}<>\s+\-/%~#^;=|,`!]|\->)+/g,_=null;for(;_=m.exec(i);){let D=_.index+1,a=D+_[0].length;if(D<=s&&a>=n){o=_[0],v=D;break}}if(o){let D=/\w+/g,a=null;for(;(a=D.exec(o))&&!(a.index+1+v+a[0].length>=n););a&&(o=o.substring(0,D.lastIndex))}return o?{start:v,end:v+o.length-1}:{start:0,end:0}}e.getExactExpressionStartAndEnd=f;const c=/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/;function u(i){return!!(i&&i.match(c))}e.isUri=u;function S(i){if(typeof i.path=="string"&&!(typeof i.sourceReference=="number"&&i.sourceReference>0)){if(u(i.path))return R.URI.parse(i.path);if(C.isAbsolute(i.path))return R.URI.file(i.path)}return i.path}function w(i){if(typeof i.path=="object"){const s=R.URI.revive(i.path);if(s)return s.scheme===A.Schemas.file?s.fsPath:s.toString()}return i.path}function b(i,s){const n=s?S:w,o=y.deepClone(i);return h(o,(v,m)=>{v&&m&&(m.path=n(m))}),o}e.convertToDAPaths=b;function d(i,s){const n=s?S:w,o=y.deepClone(i);return h(o,(v,m)=>{!v&&m&&(m.path=n(m))}),o}e.convertToVSCPaths=d;function h(i,s){switch(i.type){case"event":const n=i;switch(n.event){case"output":s(!1,n.body.source);break;case"loadedSource":s(!1,n.body.source);break;case"breakpoint":s(!1,n.body.breakpoint.source);break;default:break}break;case"request":const o=i;switch(o.command){case"setBreakpoints":s(!0,o.arguments.source);break;case"breakpointLocations":s(!0,o.arguments.source);break;case"source":s(!0,o.arguments.source);break;case"gotoTargets":s(!0,o.arguments.source);break;case"launchVSCode":o.arguments.args.forEach(m=>s(!1,m));break;default:break}break;case"response":const v=i;if(v.success&&v.body)switch(v.command){case"stackTrace":v.body.stackFrames.forEach(m=>s(!1,m.source));break;case"loadedSources":v.body.sources.forEach(m=>s(!1,m));break;case"scopes":v.body.scopes.forEach(m=>s(!1,m.source));break;case"setFunctionBreakpoints":v.body.breakpoints.forEach(m=>s(!1,m.source));break;case"setBreakpoints":v.body.breakpoints.forEach(m=>s(!1,m.source));break;default:break}break}}function g(i){return i.filter(s=>{var n;return!((n=s.presentation)===null||n===void 0?void 0:n.hidden)}).sort((s,n)=>s.presentation?n.presentation?s.presentation.group?n.presentation.group?s.presentation.group!==n.presentation.group?s.presentation.group.localeCompare(n.presentation.group):t(s.presentation.order,n.presentation.order):-1:n.presentation.group?1:t(s.presentation.order,n.presentation.order):-1:n.presentation?1:0)}e.getVisibleAndSorted=g;function t(i,s){return typeof i!="number"?typeof s!="number"?0:1:typeof s!="number"?-1:i-s}}),define(me[199],ge([0,1,28,38,167,121,9,8,25,11,177,120]),function(X,e,p,R,C,y,A,P,E,k,r,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExecutableDebugAdapter=e.NamedPipeDebugAdapter=e.SocketDebugAdapter=e.NetworkDebugAdapter=e.StreamDebugAdapter=void 0;class l extends I.AbstractDebugAdapter{constructor(){super();this.rawData=Buffer.allocUnsafe(0),this.contentLength=-1}connect(b,d){this.outputStream=d,this.rawData=Buffer.allocUnsafe(0),this.contentLength=-1,b.on("data",h=>this.handleData(h))}sendMessage(b){if(this.outputStream){const d=JSON.stringify(b);this.outputStream.write(`Content-Length: ${Buffer.byteLength(d,"utf8")}${l.TWO_CRLF}${d}`,"utf8")}}handleData(b){for(this.rawData=Buffer.concat([this.rawData,b]);;){if(this.contentLength>=0){if(this.rawData.length>=this.contentLength){const d=this.rawData.toString("utf8",0,this.contentLength);if(this.rawData=this.rawData.slice(this.contentLength),this.contentLength=-1,d.length>0)try{this.acceptMessage(JSON.parse(d))}catch(h){this._onError.fire(new Error((h.message||h)+`
`+d))}continue}}else{const d=this.rawData.indexOf(l.TWO_CRLF);if(d!==-1){const g=this.rawData.toString("utf8",0,d).split(l.HEADER_LINESEPARATOR);for(const t of g){const i=t.split(l.HEADER_FIELDSEPARATOR);i[0]==="Content-Length"&&(this.contentLength=Number(i[1]))}this.rawData=this.rawData.slice(d+l.TWO_CRLF.length);continue}}break}}}e.StreamDebugAdapter=l,l.TWO_CRLF=`\r
\r
`,l.HEADER_LINESEPARATOR=/\r?\n/,l.HEADER_FIELDSEPARATOR=/: */;class f extends l{startSession(){return new Promise((b,d)=>{let h=!1;this.socket=this.createConnection(()=>{this.connect(this.socket,this.socket),b(),h=!0}),this.socket.on("close",()=>{h?this._onError.fire(new Error("connection closed")):d(new Error("connection closed"))}),this.socket.on("error",g=>{h?this._onError.fire(g):d(g)})})}async stopSession(){await this.cancelPendingRequests(),this.socket&&(this.socket.end(),this.socket=void 0)}}e.NetworkDebugAdapter=f;class c extends f{constructor(b){super();this.adapterServer=b}createConnection(b){return y.createConnection(this.adapterServer.port,this.adapterServer.host||"127.0.0.1",b)}}e.SocketDebugAdapter=c;class u extends f{constructor(b){super();this.adapterServer=b}createConnection(b){return y.createConnection(this.adapterServer.path,b)}}e.NamedPipeDebugAdapter=u;class S extends l{constructor(b,d,h){super();this.adapterExecutable=b,this.debugType=d,this.outputService=h}async startSession(){const b=this.adapterExecutable.command,d=this.adapterExecutable.args,h=this.adapterExecutable.options||{};try{if(b)if(A.isAbsolute(b)){if(!await p.Promises.exists(b))throw new Error(C.localize(0,null,b))}else b.indexOf("/")<0&&b.indexOf("\\")<0;else throw new Error(C.localize(1,null,this.debugType));let g=process.env;if(h.env&&Object.keys(h.env).length>0&&(g=E.mixin(E.deepClone(process.env),h.env)),b==="node")if(Array.isArray(d)&&d.length>0){const i=!!process.env.ELECTRON_RUN_AS_NODE||!!process.versions.electron,s={env:g,execArgv:i?["-e","delete process.env.ELECTRON_RUN_AS_NODE;require(process.argv[1])"]:[],silent:!0};h.cwd&&(s.cwd=h.cwd);const n=R.fork(d[0],d.slice(1),s);if(!n.pid)throw new Error(C.localize(2,null,d[0]));this.serverProcess=n}else throw new Error(C.localize(3,null));else{const i={env:g};h.cwd&&(i.cwd=h.cwd),this.serverProcess=R.spawn(b,d,i)}this.serverProcess.on("error",i=>{this._onError.fire(i)}),this.serverProcess.on("exit",(i,s)=>{this._onExit.fire(i)}),this.serverProcess.stdout.on("close",()=>{this._onError.fire(new Error("read error"))}),this.serverProcess.stdout.on("error",i=>{this._onError.fire(i)}),this.serverProcess.stdin.on("error",i=>{this._onError.fire(i)});const t=this.outputService;if(t){const i=s=>s.toString().replace(/\r?\n$/mg,"");this.serverProcess.stderr.on("data",s=>{const n=t.getChannel(r.ExtensionsChannelId);n&&n.append(i(s))})}else this.serverProcess.stderr.resume();this.connect(this.serverProcess.stdout,this.serverProcess.stdin)}catch(g){this._onError.fire(g)}}async stopSession(){return this.serverProcess?(await this.cancelPendingRequests(),k.isWindows?new Promise((b,d)=>{const h=R.exec(`taskkill /F /T /PID ${this.serverProcess.pid}`,function(g,t,i){if(g)return d(g)});h.on("exit",b),h.on("error",d)}):(this.serverProcess.kill("SIGTERM"),Promise.resolve(void 0))):Promise.resolve(void 0)}static extract(b,d){if(!b)return;const h=Object.create(null);b.runtime&&(b.runtime.indexOf("./")===0?h.runtime=A.join(d,b.runtime):h.runtime=b.runtime),b.runtimeArgs&&(h.runtimeArgs=b.runtimeArgs),b.program&&(A.isAbsolute(b.program)?h.program=b.program:h.program=A.join(d,b.program)),b.args&&(h.args=b.args);const g=b;return g.win&&(h.win=S.extract(g.win,d)),g.winx86&&(h.winx86=S.extract(g.winx86,d)),g.windows&&(h.windows=S.extract(g.windows,d)),g.osx&&(h.osx=S.extract(g.osx,d)),g.linux&&(h.linux=S.extract(g.linux,d)),h}static platformAdapterExecutable(b,d){let h=Object.create(null);d=d.toLowerCase();for(const o of b)if(o.contributes){const v=o.contributes.debuggers;v&&v.length>0&&v.filter(m=>typeof m.type=="string"&&P.equalsIgnoreCase(m.type,d)).forEach(m=>{const _=S.extract(m,o.extensionLocation.fsPath);h=E.mixin(h,_,o.isBuiltin)})}let g;k.isWindows&&!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432")?g=h.winx86||h.win||h.windows:k.isWindows?g=h.win||h.windows:k.isMacintosh?g=h.osx:k.isLinux&&(g=h.linux),g=g||h;let t=g.program||h.program;const i=g.args||h.args;let s=g.runtime||h.runtime;const n=g.runtimeArgs||h.runtimeArgs;if(s)return{type:"executable",command:s,args:(n||[]).concat(typeof t=="string"?[t]:[]).concat(i||[])};if(t)return{type:"executable",command:t,args:i||[]}}}e.ExecutableDebugAdapter=S}),define(me[200],ge([0,1,38,11,29,180]),function(X,e,p,R,C,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prepareCommand=e.hasChildProcesses=e.runInExternalTerminal=void 0;function A(l,f){return new Promise((c,u)=>{let S="";const w=p.spawn(l,f);w.pid&&w.stdout.on("data",b=>{S+=b.toString()}),w.on("error",b=>{u(b)}),w.on("close",b=>{c(S)})})}let P;function E(l,f){if(!P)if(R.isWindows)P=new y.WindowsExternalTerminalService;else if(R.isMacintosh)P=new y.MacExternalTerminalService;else if(R.isLinux)P=new y.LinuxExternalTerminalService;else throw new Error("external terminals not supported on this platform");const c=f.getConfiguration("terminal");return P.runInTerminal(l.title,l.cwd,l.args,l.env||{},c.external||{})}e.runInExternalTerminal=E;function k(l){return l?R.isWindows?new Promise(async f=>{(await new Promise((u,S)=>{X(["windows-process-tree"],u,S)})).getProcessTree(l,u=>{f(u.children.length>0)})}):A("/usr/bin/pgrep",["-lP",String(l)]).then(f=>{const c=f.trim();return!(c.length===0||c.indexOf(" tmux")>=0)},f=>!0):Promise.resolve(!0)}e.hasChildProcesses=k;var r;(function(l){l[l.cmd=0]="cmd",l[l.powershell=1]="powershell",l[l.bash=2]="bash"})(r||(r={}));function I(l,f,c,u){l=l.trim().toLowerCase();let S;l.indexOf("powershell")>=0||l.indexOf("pwsh")>=0?S=1:l.indexOf("cmd.exe")>=0?S=0:l.indexOf("bash")>=0?S=2:R.isWindows?S=0:S=2;let w,b=" ";switch(S){case 1:if(w=h=>(h=h.replace(/\'/g,"''"),h.length>0&&h.charAt(h.length-1)==="\\"?`'${h}\\'`:`'${h}'`),c){const h=C.getDriveLetter(c);h&&(b+=`${h}:; `),b+=`cd ${w(c)}; `}if(u)for(let h in u){const g=u[h];g===null?b+=`Remove-Item env:${h}; `:b+=`\${env:${h}}='${g}'; `}if(f.length>0){const h=w(f.shift());b+=h[0]==="'"?`& ${h} `:`${h} `;for(let g of f)b+=`${w(g)} `}break;case 0:if(w=h=>(h=h.replace(/\"/g,'""'),h.indexOf(" ")>=0||h.indexOf('"')>=0||h.length===0?`"${h}"`:h),c){const h=C.getDriveLetter(c);h&&(b+=`${h}: && `),b+=`cd ${w(c)} && `}if(u){b+='cmd /C "';for(let h in u){let g=u[h];g===null?b+=`set "${h}=" && `:(g=g.replace(/[\^\&\|\<\>]/g,t=>`^${t}`),b+=`set "${h}=${g}" && `)}}for(let h of f)b+=`${w(h)} `;u&&(b+='"');break;case 2:w=h=>(h=h.replace(/(["'\\\$])/g,"\\$1"),h.indexOf(" ")>=0||h.indexOf(";")>=0||h.length===0?`"${h}"`:h);const d=h=>/[^\w@%\/+=,.:^-]/.test(h)?`'${h.replace(/'/g,"'\\''")}'`:h;if(c&&(b+=`cd ${w(c)} ; `),u){b+="/usr/bin/env";for(let h in u){const g=u[h];g===null?b+=` -u ${d(h)}`:b+=` ${d(`${h}=${g}`)}`}b+=" "}for(let h of f)b+=`${w(h)} `;break}return b}e.prepareCommand=I}),define(me[84],ge([0,1,30,97,10,9,11,111]),function(X,e,p,R,C,y,A,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NotebookWorkingCopyTypeIdentifier=e.CellStatusbarAlignment=e.OpenGettingStarted=e.ConsolidatedRunButton=e.NotebookCellEditorOptionsCustomizations=e.DragAndDropEnabled=e.ShowFoldingControls=e.ConsolidatedOutputButton=e.UndoRedoPerCell=e.GlobalToolbar=e.InsertToolbarLocation=e.FocusIndicator=e.CompactView=e.ExperimentalInsertToolbarAlignment=e.ExperimentalUseMarkdownRenderer=e.NotebookTextDiffEditorPreview=e.ShowCellStatusBar=e.CellToolbarVisibility=e.CellToolbarLocation=e.DisplayOrderKey=e.CellSequence=e.notebookDocumentFilterMatch=e.isDocumentExcludePattern=e.NotebookEditorPriority=e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=e.diff=e.sortMimeTypes=e.mimeTypeIsMergeable=e.mimeTypeSupportedByCore=e.mimeTypeIsAlwaysSecure=e.CellUri=e.CellEditType=e.SelectionStateType=e.NotebookCellsChangeType=e.RendererMessagingSpec=e.NotebookRendererMatch=e.NotebookCellExecutionState=e.NotebookRunState=e.RENDERER_NOT_AVAILABLE=e.BUILTIN_RENDERER_ID=e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=e.NOTEBOOK_DISPLAY_ORDER=e.CellKind=void 0;var E;(function(a){a[a.Markup=1]="Markup",a[a.Code=2]="Code"})(E=e.CellKind||(e.CellKind={})),e.NOTEBOOK_DISPLAY_ORDER=["application/json","application/javascript","text/html","image/svg+xml",R.Mimes.markdown,"image/png","image/jpeg",R.Mimes.text],e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=[R.Mimes.markdown,"application/json",R.Mimes.text,"text/html","image/svg+xml","image/png","image/jpeg"],e.BUILTIN_RENDERER_ID="_builtin",e.RENDERER_NOT_AVAILABLE="_notAvailable";var k;(function(a){a[a.Running=1]="Running",a[a.Idle=2]="Idle"})(k=e.NotebookRunState||(e.NotebookRunState={}));var r;(function(a){a[a.Pending=2]="Pending",a[a.Executing=3]="Executing"})(r=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var I;(function(a){a[a.WithHardKernelDependency=0]="WithHardKernelDependency",a[a.WithOptionalKernelDependency=1]="WithOptionalKernelDependency",a[a.Pure=2]="Pure",a[a.Never=3]="Never"})(I=e.NotebookRendererMatch||(e.NotebookRendererMatch={}));var l;(function(a){a.Always="always",a.Never="never",a.Optional="optional"})(l=e.RendererMessagingSpec||(e.RendererMessagingSpec={}));var f;(function(a){a[a.ModelChange=1]="ModelChange",a[a.Move=2]="Move",a[a.ChangeLanguage=5]="ChangeLanguage",a[a.Initialize=6]="Initialize",a[a.ChangeCellMetadata=7]="ChangeCellMetadata",a[a.Output=8]="Output",a[a.OutputItem=9]="OutputItem",a[a.ChangeCellContent=10]="ChangeCellContent",a[a.ChangeDocumentMetadata=11]="ChangeDocumentMetadata",a[a.ChangeCellInternalMetadata=12]="ChangeCellInternalMetadata",a[a.ChangeCellMime=13]="ChangeCellMime",a[a.Unknown=100]="Unknown"})(f=e.NotebookCellsChangeType||(e.NotebookCellsChangeType={}));var c;(function(a){a[a.Handle=0]="Handle",a[a.Index=1]="Index"})(c=e.SelectionStateType||(e.SelectionStateType={}));var u;(function(a){a[a.Replace=1]="Replace",a[a.Output=2]="Output",a[a.Metadata=3]="Metadata",a[a.CellLanguage=4]="CellLanguage",a[a.DocumentMetadata=5]="DocumentMetadata",a[a.Move=6]="Move",a[a.OutputItems=7]="OutputItems",a[a.PartialMetadata=8]="PartialMetadata",a[a.PartialInternalMetadata=9]="PartialInternalMetadata"})(u=e.CellEditType||(e.CellEditType={}));var S;(function(a){a.scheme=C.Schemas.vscodeNotebookCell;const T=/^ch(\d{7,})/;function L(N,W){return N.with({scheme:a.scheme,fragment:`ch${W.toString().padStart(7,"0")}${N.scheme!==C.Schemas.file?N.scheme:""}`})}a.generate=L;function U(N){if(N.scheme!==a.scheme)return;const W=T.exec(N.fragment);return W?{handle:Number(W[1]),notebook:N.with({scheme:N.fragment.substr(W[0].length)||C.Schemas.file,fragment:null})}:void 0}a.parse=U;function G(N){if(N.scheme!==C.Schemas.vscodeNotebookCellMetadata)return;const W=T.exec(N.fragment);return W?{handle:Number(W[1]),notebook:N.with({scheme:N.fragment.substr(W[0].length)||C.Schemas.file,fragment:null})}:void 0}a.parseCellMetadataUri=G;function ee(N,W,M){return N.with({scheme:M,fragment:`ch${W.toString().padStart(7,"0")}${N.scheme!==C.Schemas.file?N.scheme:""}`})}a.generateCellUri=ee;function z(N,W){if(N.scheme!==W)return;const M=T.exec(N.fragment);return M?{handle:Number(M[1]),notebook:N.with({scheme:N.fragment.substr(M[0].length)||C.Schemas.file,fragment:null})}:void 0}a.parseCellUri=z})(S=e.CellUri||(e.CellUri={}));const w=new Map([["application/javascript",{supportedByCore:!0}],["image/png",{alwaysSecure:!0,supportedByCore:!0}],["image/jpeg",{alwaysSecure:!0,supportedByCore:!0}],["image/git",{alwaysSecure:!0,supportedByCore:!0}],["image/svg+xml",{supportedByCore:!0}],["application/json",{alwaysSecure:!0,supportedByCore:!0}],[R.Mimes.markdown,{alwaysSecure:!0,supportedByCore:!0}],[R.Mimes.text,{alwaysSecure:!0,supportedByCore:!0}],["text/html",{supportedByCore:!0}],["text/x-javascript",{alwaysSecure:!0,supportedByCore:!0}],["application/vnd.code.notebook.error",{alwaysSecure:!0,supportedByCore:!0}],["application/vnd.code.notebook.stdout",{alwaysSecure:!0,supportedByCore:!0,mergeable:!0}],["application/vnd.code.notebook.stderr",{alwaysSecure:!0,supportedByCore:!0,mergeable:!0}]]);function b(a){var T,L;return(L=(T=w.get(a))===null||T===void 0?void 0:T.alwaysSecure)!==null&&L!==void 0?L:!1}e.mimeTypeIsAlwaysSecure=b;function d(a){var T,L;return(L=(T=w.get(a))===null||T===void 0?void 0:T.supportedByCore)!==null&&L!==void 0?L:!1}e.mimeTypeSupportedByCore=d;function h(a){var T,L;return(L=(T=w.get(a))===null||T===void 0?void 0:T.mergeable)!==null&&L!==void 0?L:!1}e.mimeTypeIsMergeable=h;function g(a,T){return A.isWindows&&(a=a.replace(/\//g,"\\"),T=T.replace(/\//g,"\\")),p.match(a,T)}function t(a,T,L){let U=0;for(let G=0;G<T.length;G++){if(g(T[G],a))return U;U++}for(let G=0;G<L.length;G++){if(g(L[G],a))return U;U++}return U}function i(a,T,L){return a.sort((U,G)=>t(U,T,L)-t(G,T,L))}e.sortMimeTypes=i;function s(a,T,L,U=(G,ee)=>G===ee){const G=[];function ee(W,M,j){if(M===0&&j.length===0)return;const O=G[G.length-1];O&&O.start+O.deleteCount===W?(O.deleteCount+=M,O.toInsert.push(...j)):G.push({start:W,deleteCount:M,toInsert:j})}let z=0,N=0;for(;;){if(z===a.length){ee(z,0,T.slice(N));break}if(N===T.length){ee(z,a.length-z,[]);break}const W=a[z],M=T[N];if(U(W,M)){z+=1,N+=1;continue}L(M)?(ee(z,1,[]),z+=1):(ee(z,0,[M]),N+=1)}return G}e.diff=s,e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=new P.RawContextKey("notebookEditorCursorAtBoundary","none");var n;(function(a){a.default="default",a.option="option"})(n=e.NotebookEditorPriority||(e.NotebookEditorPriority={}));function o(a){const T=a;return!!((typeof T.include=="string"||p.isRelativePattern(T.include))&&(typeof T.exclude=="string"||p.isRelativePattern(T.exclude)))}e.isDocumentExcludePattern=o;function v(a,T,L){if(Array.isArray(a.viewType)&&a.viewType.indexOf(T)>=0||a.viewType===T)return!0;if(a.filenamePattern){let U=o(a.filenamePattern)?a.filenamePattern.include:a.filenamePattern,G=o(a.filenamePattern)?a.filenamePattern.exclude:void 0;if(p.match(U,y.basename(L.fsPath).toLowerCase()))return!(G&&p.match(G,y.basename(L.fsPath).toLowerCase()))}return!1}e.notebookDocumentFilterMatch=v;class m{constructor(T){this.textModel=T}getElements(){const T=new Int32Array(this.textModel.cells.length);for(let L=0;L<this.textModel.cells.length;L++)T[L]=this.textModel.cells[L].getHashValue();return T}}e.CellSequence=m,e.DisplayOrderKey="notebook.displayOrder",e.CellToolbarLocation="notebook.cellToolbarLocation",e.CellToolbarVisibility="notebook.cellToolbarVisibility",e.ShowCellStatusBar="notebook.showCellStatusBar",e.NotebookTextDiffEditorPreview="notebook.diff.enablePreview",e.ExperimentalUseMarkdownRenderer="notebook.experimental.useMarkdownRenderer",e.ExperimentalInsertToolbarAlignment="notebook.experimental.insertToolbarAlignment",e.CompactView="notebook.compactView",e.FocusIndicator="notebook.cellFocusIndicator",e.InsertToolbarLocation="notebook.insertToolbarLocation",e.GlobalToolbar="notebook.globalToolbar",e.UndoRedoPerCell="notebook.undoRedoPerCell",e.ConsolidatedOutputButton="notebook.consolidatedOutputButton",e.ShowFoldingControls="notebook.showFoldingControls",e.DragAndDropEnabled="notebook.dragAndDropEnabled",e.NotebookCellEditorOptionsCustomizations="notebook.editorOptionsCustomizations",e.ConsolidatedRunButton="notebook.consolidatedRunButton",e.OpenGettingStarted="notebook.experimental.openGettingStarted";var _;(function(a){a[a.Left=1]="Left",a[a.Right=2]="Right"})(_=e.CellStatusbarAlignment||(e.CellStatusbarAlignment={}));class D{static create(T){return`${D._prefix}${T}`}static parse(T){if(T.startsWith(D._prefix))return T.substr(D._prefix.length)}}e.NotebookWorkingCopyTypeIdentifier=D,D._prefix="notebook/"}),define(me[201],ge([0,1,169,4,111]),function(X,e,p,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.USER_TASKS_GROUP_KEY=e.ITaskService=e.ProcessExecutionSupportedContext=e.ShellExecutionSupportedContext=e.CustomExecutionSupportedContext=void 0,e.CustomExecutionSupportedContext=new C.RawContextKey("customExecutionSupported",!0,p.localize(0,null)),e.ShellExecutionSupportedContext=new C.RawContextKey("shellExecutionSupported",!1,p.localize(1,null)),e.ProcessExecutionSupportedContext=new C.RawContextKey("processExecutionSupported",!1,p.localize(2,null)),e.ITaskService=R.createDecorator("taskService"),e.USER_TASKS_GROUP_KEY="settings"}),define(me[202],ge([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeEnvironmentVariableCollection=e.serializeEnvironmentVariableCollection=void 0;function p(C){return[...C.entries()]}e.serializeEnvironmentVariableCollection=p;function R(C){return new Map(C)}e.deserializeEnvironmentVariableCollection=R}),define(me[122],ge([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractIncrementalTestCollection=e.IncrementalChangeCollector=e.TestDiffOpType=e.applyTestItemUpdate=e.TestItemExpandState=e.identifyTest=void 0;const p=E=>({testId:E.item.extId,controllerId:E.controllerId});e.identifyTest=p;var R;(function(E){E[E.NotExpandable=0]="NotExpandable",E[E.Expandable=1]="Expandable",E[E.BusyExpanding=2]="BusyExpanding",E[E.Expanded=3]="Expanded"})(R=e.TestItemExpandState||(e.TestItemExpandState={}));const C=(E,k)=>{k.expand!==void 0&&(E.expand=k.expand),k.item!==void 0&&(E.item=E.item?Object.assign(E.item,k.item):k.item)};e.applyTestItemUpdate=C;var y;(function(E){E[E.Add=0]="Add",E[E.Update=1]="Update",E[E.Remove=2]="Remove",E[E.IncrementPendingExtHosts=3]="IncrementPendingExtHosts",E[E.Retire=4]="Retire"})(y=e.TestDiffOpType||(e.TestDiffOpType={}));class A{add(k){}update(k){}remove(k,r){}complete(){}}e.IncrementalChangeCollector=A;class P{constructor(){this.items=new Map,this.roots=new Set,this.busyControllerCount=0,this.pendingRootCount=0}apply(k){const r=this.createChangeCollector();for(const I of k)switch(I[0]){case 0:{const l=I[1];if(l.parent){if(this.items.has(l.parent)){const f=this.items.get(l.parent);f.children.add(l.item.extId);const c=this.createItem(l,f);this.items.set(l.item.extId,c),r.add(c)}}else{const f=this.createItem(l);this.roots.add(f),this.items.set(l.item.extId,f),r.add(f)}l.expand===2&&this.busyControllerCount++;break}case 1:{const l=I[1],f=this.items.get(l.extId);if(!f)break;l.expand!==void 0&&(f.expand===2&&this.busyControllerCount--,l.expand===2&&this.busyControllerCount++),e.applyTestItemUpdate(f,l),r.update(f);break}case 2:{const l=this.items.get(I[1]);if(!l)break;l.parent?this.items.get(l.parent).children.delete(l.item.extId):this.roots.delete(l);const f=[[I[1]]];for(;f.length;)for(const c of f.pop()){const u=this.items.get(c);u&&(f.push(u.children),this.items.delete(c),r.remove(u,u!==l),u.expand===2&&this.busyControllerCount--)}break}case 4:this.retireTest(I[1]);break;case 3:this.updatePendingRoots(I[1]);break}r.complete()}retireTest(k){}updatePendingRoots(k){this.pendingRootCount+=k}createChangeCollector(){return new A}}e.AbstractIncrementalTestCollection=P}),define(me[203],ge([0,1,9,37,15,25,11,75,170]),function(X,e,p,R,C,y,A,P,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractVariableResolverService=void 0;class k{constructor(I,l,f){this._contributedVariables=new Map,this._context=I,this._labelService=l,f&&(this._envVariablesPromise=f.then(c=>this.prepareEnv(c)))}prepareEnv(I){if(A.isWindows){const l=Object.create(null);return Object.keys(I).forEach(f=>{l[f.toLowerCase()]=I[f]}),l}return I}resolveWithEnvironment(I,l,f){return this.recursiveResolve(this.prepareEnv(I),l?l.uri:void 0,f)}async resolveAsync(I,l){return this.recursiveResolve(await this._envVariablesPromise,I?I.uri:void 0,l)}async resolveAnyBase(I,l,f,c){const u=y.deepClone(l);return A.isWindows&&u.windows?Object.keys(u.windows).forEach(S=>u[S]=u.windows[S]):A.isMacintosh&&u.osx?Object.keys(u.osx).forEach(S=>u[S]=u.osx[S]):A.isLinux&&u.linux&&Object.keys(u.linux).forEach(S=>u[S]=u.linux[S]),delete u.windows,delete u.osx,delete u.linux,this.recursiveResolve(await this._envVariablesPromise,I?I.uri:void 0,u,f,c)}async resolveAnyAsync(I,l,f){return this.resolveAnyBase(I,l,f)}async resolveAnyMap(I,l,f){const c=new Map;return{newConfig:await this.resolveAnyBase(I,l,f,c),resolvedVariables:c}}resolveWithInteractionReplace(I,l,f,c){throw new Error("resolveWithInteractionReplace not implemented.")}resolveWithInteraction(I,l,f,c){throw new Error("resolveWithInteraction not implemented.")}contributeVariable(I,l){if(this._contributedVariables.has(I))throw new Error("Variable "+I+" is contributed twice.");this._contributedVariables.set(I,l)}recursiveResolve(I,l,f,c,u){if(C.isString(f))return this.resolveString(I,l,f,c,u);if(C.isArray(f))return f.map(S=>this.recursiveResolve(I,l,S,c,u));if(C.isObject(f)){let S=Object.create(null);return Object.keys(f).forEach(w=>{const b=this.resolveString(I,l,w,c,u);S[b]=this.recursiveResolve(I,l,f[w],c,u)}),S}return f}resolveString(I,l,f,c,u){return f.replace(k.VARIABLE_REGEXP,(w,b)=>{if(b.includes(k.VARIABLE_LHS))return w;let d=this.evaluateSingleVariable(I,w,b,l,c);return u&&u.set(b,d),d!==w&&C.isString(d)&&d.match(k.VARIABLE_REGEXP)&&(d=this.resolveString(I,l,d,c,u)),d})}fsPath(I){return this._labelService?this._labelService.getUriLabel(I,{noPrefix:!0}):I.fsPath}evaluateSingleVariable(I,l,f,c,u){let S;const w=f.split(":");w.length>1&&(f=w[0],S=w[1]);const b=()=>{const g=this._context.getFilePath();if(g)return g;throw new Error(E.localize(0,null,l))},d=()=>{const g=b();if(this._context.getWorkspaceFolderPathForFile){const t=this._context.getWorkspaceFolderPathForFile();if(t)return t}throw new Error(E.localize(1,null,l,p.basename(g)))},h=()=>{if(S){const g=this._context.getFolderUri(S);if(g)return g;throw new Error(E.localize(2,null,l,S))}if(c)return c;throw this._context.getWorkspaceFolderCount()>1?new Error(E.localize(3,null,l)):new Error(E.localize(4,null,l))};switch(f){case"env":if(S){if(I){const g=I[A.isWindows?S.toLowerCase():S];if(C.isString(g))return g}return""}throw new Error(E.localize(5,null,l));case"config":if(S){const g=this._context.getConfigurationValue(c,S);if(C.isUndefinedOrNull(g))throw new Error(E.localize(6,null,l,S));if(C.isObject(g))throw new Error(E.localize(7,null,l,S));return g}throw new Error(E.localize(8,null,l));case"command":return this.resolveFromMap(l,S,u,"command");case"input":return this.resolveFromMap(l,S,u,"input");default:switch(f){case"workspaceRoot":case"workspaceFolder":return P.normalizeDriveLetter(this.fsPath(h()));case"cwd":return c||S?P.normalizeDriveLetter(this.fsPath(h())):R.cwd();case"workspaceRootFolderName":case"workspaceFolderBasename":return p.basename(this.fsPath(h()));case"lineNumber":const g=this._context.getLineNumber();if(g)return g;throw new Error(E.localize(9,null,l));case"selectedText":const t=this._context.getSelectedText();if(t)return t;throw new Error(E.localize(10,null,l));case"file":return b();case"fileWorkspaceFolder":return d();case"relativeFile":return c||S?p.relative(this.fsPath(h()),b()):b();case"relativeFileDirname":const i=p.dirname(b());if(c||S){const v=p.relative(this.fsPath(h()),i);return v.length===0?".":v}return i;case"fileDirname":return p.dirname(b());case"fileExtname":return p.extname(b());case"fileBasename":return p.basename(b());case"fileBasenameNoExtension":const s=p.basename(b());return s.slice(0,s.length-p.extname(s).length);case"fileDirnameBasename":return p.basename(p.dirname(b()));case"execPath":const n=this._context.getExecPath();return n||l;case"execInstallFolder":const o=this._context.getAppRoot();return o||l;case"pathSeparator":return p.sep;default:try{const v=S?`${f}:${S}`:f;return this.resolveFromMap(l,v,u,void 0)}catch(v){return l}}}}resolveFromMap(I,l,f,c){if(l&&f){const u=c===void 0?f[l]:f[c+":"+l];if(typeof u=="string")return u;throw new Error(E.localize(11,null,I))}return I}}e.AbstractVariableResolverService=k,k.VARIABLE_LHS="${",k.VARIABLE_REGEXP=/\$\{(.*?)\}/g}),define(me[204],ge([0,1,4]),function(X,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.preferredSideBySideGroupDirection=e.OpenEditorContext=e.GroupChangeKind=e.GroupsOrder=e.MergeGroupMode=e.GroupsArrangement=e.GroupLocation=e.GroupOrientation=e.GroupDirection=e.IEditorGroupsService=void 0,e.IEditorGroupsService=p.createDecorator("editorGroupsService");var R;(function(l){l[l.UP=0]="UP",l[l.DOWN=1]="DOWN",l[l.LEFT=2]="LEFT",l[l.RIGHT=3]="RIGHT"})(R=e.GroupDirection||(e.GroupDirection={}));var C;(function(l){l[l.HORIZONTAL=0]="HORIZONTAL",l[l.VERTICAL=1]="VERTICAL"})(C=e.GroupOrientation||(e.GroupOrientation={}));var y;(function(l){l[l.FIRST=0]="FIRST",l[l.LAST=1]="LAST",l[l.NEXT=2]="NEXT",l[l.PREVIOUS=3]="PREVIOUS"})(y=e.GroupLocation||(e.GroupLocation={}));var A;(function(l){l[l.MINIMIZE_OTHERS=0]="MINIMIZE_OTHERS",l[l.EVEN=1]="EVEN",l[l.TOGGLE=2]="TOGGLE"})(A=e.GroupsArrangement||(e.GroupsArrangement={}));var P;(function(l){l[l.COPY_EDITORS=0]="COPY_EDITORS",l[l.MOVE_EDITORS=1]="MOVE_EDITORS"})(P=e.MergeGroupMode||(e.MergeGroupMode={}));var E;(function(l){l[l.CREATION_TIME=0]="CREATION_TIME",l[l.MOST_RECENTLY_ACTIVE=1]="MOST_RECENTLY_ACTIVE",l[l.GRID_APPEARANCE=2]="GRID_APPEARANCE"})(E=e.GroupsOrder||(e.GroupsOrder={}));var k;(function(l){l[l.GROUP_ACTIVE=0]="GROUP_ACTIVE",l[l.GROUP_INDEX=1]="GROUP_INDEX",l[l.EDITOR_OPEN=2]="EDITOR_OPEN",l[l.EDITOR_CLOSE=3]="EDITOR_CLOSE",l[l.EDITOR_MOVE=4]="EDITOR_MOVE",l[l.EDITOR_ACTIVE=5]="EDITOR_ACTIVE",l[l.EDITOR_LABEL=6]="EDITOR_LABEL",l[l.EDITOR_CAPABILITIES=7]="EDITOR_CAPABILITIES",l[l.EDITOR_PIN=8]="EDITOR_PIN",l[l.EDITOR_STICKY=9]="EDITOR_STICKY",l[l.EDITOR_DIRTY=10]="EDITOR_DIRTY"})(k=e.GroupChangeKind||(e.GroupChangeKind={}));var r;(function(l){l[l.NEW_EDITOR=1]="NEW_EDITOR",l[l.MOVE_EDITOR=2]="MOVE_EDITOR",l[l.COPY_EDITOR=3]="COPY_EDITOR"})(r=e.OpenEditorContext||(e.OpenEditorContext={}));function I(l){return l.getValue("workbench.editor.openSideBySideDirection")==="down"?1:3}e.preferredSideBySideGroupDirection=I}),define(me[205],ge([0,1,4]),function(X,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SIDE_GROUP=e.ACTIVE_GROUP=e.IEditorService=void 0,e.IEditorService=p.createDecorator("editorService"),e.ACTIVE_GROUP=-1,e.SIDE_GROUP=-2}),define(me[17],ge([0,1,18,94,278,55,25,15,2,40,78,171,113,84,205,7]),function(X,e,p,R,C,y,A,P,E,k,r,I,l,f,c,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CodeActionTriggerKind=e.TestResults=e.TestItem=e.TestMessage=e.NotebookRendererScript=e.NotebookDocumentContentOptions=e.NotebookStatusBarItem=e.NotebookDecorationRenderOptions=e.NotebookExclusiveDocumentPattern=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookCellData=e.NotebookData=e.NotebookCellKind=e.NotebookCellExecutionSummary=e.NotebookRange=e.LanguageSelector=e.GlobPattern=e.TextEditorOpenOptions=e.FoldingRangeKind=e.FoldingRange=e.ProgressLocation=e.EndOfLine=e.TextEditorLineNumbersStyle=e.TextDocumentSaveReason=e.SelectionRange=e.Color=e.ColorPresentation=e.DocumentLink=e.InlayHintKind=e.InlayHint=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.CompletionItem=e.CompletionItemKind=e.CompletionItemTag=e.CompletionContext=e.CompletionTriggerKind=e.DocumentHighlight=e.InlineValueContext=e.InlineValue=e.EvaluatableExpression=e.Hover=e.DefinitionLink=e.location=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.DocumentSymbol=e.WorkspaceSymbol=e.SymbolTag=e.SymbolKind=e.WorkspaceEdit=e.TextEdit=e.DecorationRenderOptions=e.DecorationRangeBehavior=e.ThemableDecorationRenderOptions=e.ThemableDecorationAttachmentRenderOptions=e.pathOrURIToURI=e.fromRangeOrRangeWithMessage=e.MarkdownString=e.isDecorationOptionsArr=e.ViewColumn=e.DiagnosticSeverity=e.DiagnosticRelatedInformation=e.Diagnostic=e.DiagnosticTag=e.Position=e.TokenType=e.Range=e.Selection=void 0;var S;(function(Ee){function Ce(Q){const{selectionStartLineNumber:Be,selectionStartColumn:De,positionLineNumber:Ke,positionColumn:et}=Q,tt=new u.Position(Be-1,De-1),st=new u.Position(Ke-1,et-1);return new u.Selection(tt,st)}Ee.to=Ce;function ce(Q){const{anchor:Be,active:De}=Q;return{selectionStartLineNumber:Be.line+1,selectionStartColumn:Be.character+1,positionLineNumber:De.line+1,positionColumn:De.character+1}}Ee.from=ce})(S=e.Selection||(e.Selection={}));var w;(function(Ee){function Ce(Q){if(!Q)return;const{start:Be,end:De}=Q;return{startLineNumber:Be.line+1,startColumn:Be.character+1,endLineNumber:De.line+1,endColumn:De.character+1}}Ee.from=Ce;function ce(Q){if(!Q)return;const{startLineNumber:Be,startColumn:De,endLineNumber:Ke,endColumn:et}=Q;return new u.Range(Be-1,De-1,Ke-1,et-1)}Ee.to=ce})(w=e.Range||(e.Range={}));var b;(function(Ee){function Ce(ce){switch(ce){case 1:return u.StandardTokenType.Comment;case 0:return u.StandardTokenType.Other;case 4:return u.StandardTokenType.RegEx;case 2:return u.StandardTokenType.String}}Ee.to=Ce})(b=e.TokenType||(e.TokenType={}));var d;(function(Ee){function Ce(Q){return new u.Position(Q.lineNumber-1,Q.column-1)}Ee.to=Ce;function ce(Q){return{lineNumber:Q.line+1,column:Q.character+1}}Ee.from=ce})(d=e.Position||(e.Position={}));var h;(function(Ee){function Ce(Q){switch(Q){case u.DiagnosticTag.Unnecessary:return 1;case u.DiagnosticTag.Deprecated:return 2}}Ee.from=Ce;function ce(Q){switch(Q){case 1:return u.DiagnosticTag.Unnecessary;case 2:return u.DiagnosticTag.Deprecated;default:return}}Ee.to=ce})(h=e.DiagnosticTag||(e.DiagnosticTag={}));var g;(function(Ee){function Ce(Q){let Be;return Q.code&&(P.isString(Q.code)||P.isNumber(Q.code)?Be=String(Q.code):Be={value:String(Q.code.value),target:Q.code.target}),Object.assign(Object.assign({},w.from(Q.range)),{message:Q.message,source:Q.source,code:Be,severity:i.from(Q.severity),relatedInformation:Q.relatedInformation&&Q.relatedInformation.map(t.from),tags:Array.isArray(Q.tags)?p.coalesce(Q.tags.map(h.from)):void 0})}Ee.from=Ce;function ce(Q){var Be;const De=new u.Diagnostic(w.to(Q),Q.message,i.to(Q.severity));return De.source=Q.source,De.code=P.isString(Q.code)?Q.code:(Be=Q.code)===null||Be===void 0?void 0:Be.value,De.relatedInformation=Q.relatedInformation&&Q.relatedInformation.map(t.to),De.tags=Q.tags&&p.coalesce(Q.tags.map(h.to)),De}Ee.to=ce})(g=e.Diagnostic||(e.Diagnostic={}));var t;(function(Ee){function Ce(Q){return Object.assign(Object.assign({},w.from(Q.location.range)),{message:Q.message,resource:Q.location.uri})}Ee.from=Ce;function ce(Q){return new u.DiagnosticRelatedInformation(new u.Location(Q.resource,w.to(Q)),Q.message)}Ee.to=ce})(t=e.DiagnosticRelatedInformation||(e.DiagnosticRelatedInformation={}));var i;(function(Ee){function Ce(Q){switch(Q){case u.DiagnosticSeverity.Error:return l.MarkerSeverity.Error;case u.DiagnosticSeverity.Warning:return l.MarkerSeverity.Warning;case u.DiagnosticSeverity.Information:return l.MarkerSeverity.Info;case u.DiagnosticSeverity.Hint:return l.MarkerSeverity.Hint}return l.MarkerSeverity.Error}Ee.from=Ce;function ce(Q){switch(Q){case l.MarkerSeverity.Info:return u.DiagnosticSeverity.Information;case l.MarkerSeverity.Warning:return u.DiagnosticSeverity.Warning;case l.MarkerSeverity.Error:return u.DiagnosticSeverity.Error;case l.MarkerSeverity.Hint:return u.DiagnosticSeverity.Hint;default:return u.DiagnosticSeverity.Error}}Ee.to=ce})(i=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));var s;(function(Ee){function Ce(Q){return typeof Q=="number"&&Q>=u.ViewColumn.One?Q-1:Q===u.ViewColumn.Beside?c.SIDE_GROUP:c.ACTIVE_GROUP}Ee.from=Ce;function ce(Q){if(typeof Q=="number"&&Q>=0)return Q+1;throw new Error("invalid 'EditorGroupColumn'")}Ee.to=ce})(s=e.ViewColumn||(e.ViewColumn={}));function n(Ee){return typeof Ee.range!="undefined"}function o(Ee){return Ee.length===0?!0:!!n(Ee[0])}e.isDecorationOptionsArr=o;var v;(function(Ee){function Ce(et){return et.map(Ee.from)}Ee.fromMany=Ce;function ce(et){return et&&typeof et=="object"&&typeof et.language=="string"&&typeof et.value=="string"}function Q(et){let tt;if(ce(et)){const{language:Et,value:vt}=et;tt={value:"```"+Et+`
`+vt+"\n```\n"}}else u.MarkdownString.isMarkdownString(et)?tt={value:et.value,isTrusted:et.isTrusted,supportThemeIcons:et.supportThemeIcons}:typeof et=="string"?tt={value:et}:tt={value:""};const st=Object.create(null);tt.uris=st;const pt=Et=>{try{let vt=E.URI.parse(Et,!0);vt=vt.with({query:Be(vt.query,st)}),st[Et]=vt}catch(vt){}return""},wt=new C.Renderer;return wt.link=pt,wt.image=Et=>pt(R.parseHrefAndDimensions(Et).href),C(tt.value,{renderer:wt}),tt}Ee.from=Q;function Be(et,tt){if(!et)return et;let st;try{st=y.parse(et)}catch(wt){}if(!st)return et;let pt=!1;return st=A.cloneAndChange(st,wt=>{if(E.URI.isUri(wt)){const Et=`__uri_${Math.random().toString(16).slice(2,8)}`;return tt[Et]=wt,pt=!0,Et}else return}),pt?JSON.stringify(st):et}function De(et){const tt=new u.MarkdownString(et.value,et.supportThemeIcons);return tt.isTrusted=et.isTrusted,tt}Ee.to=De;function Ke(et){if(!!et)return typeof et=="string"?et:Ee.from(et)}Ee.fromStrict=Ke})(v=e.MarkdownString||(e.MarkdownString={}));function m(Ee){return o(Ee)?Ee.map(Ce=>({range:w.from(Ce.range),hoverMessage:Array.isArray(Ce.hoverMessage)?v.fromMany(Ce.hoverMessage):Ce.hoverMessage?v.from(Ce.hoverMessage):void 0,renderOptions:Ce.renderOptions})):Ee.map(Ce=>({range:w.from(Ce)}))}e.fromRangeOrRangeWithMessage=m;function _(Ee){return typeof Ee=="undefined"?Ee:typeof Ee=="string"?E.URI.file(Ee):Ee}e.pathOrURIToURI=_;var D;(function(Ee){function Ce(ce){return typeof ce=="undefined"?ce:{contentText:ce.contentText,contentIconPath:ce.contentIconPath?_(ce.contentIconPath):void 0,border:ce.border,borderColor:ce.borderColor,fontStyle:ce.fontStyle,fontWeight:ce.fontWeight,textDecoration:ce.textDecoration,color:ce.color,backgroundColor:ce.backgroundColor,margin:ce.margin,width:ce.width,height:ce.height}}Ee.from=Ce})(D=e.ThemableDecorationAttachmentRenderOptions||(e.ThemableDecorationAttachmentRenderOptions={}));var a;(function(Ee){function Ce(ce){return typeof ce=="undefined"?ce:{backgroundColor:ce.backgroundColor,outline:ce.outline,outlineColor:ce.outlineColor,outlineStyle:ce.outlineStyle,outlineWidth:ce.outlineWidth,border:ce.border,borderColor:ce.borderColor,borderRadius:ce.borderRadius,borderSpacing:ce.borderSpacing,borderStyle:ce.borderStyle,borderWidth:ce.borderWidth,fontStyle:ce.fontStyle,fontWeight:ce.fontWeight,textDecoration:ce.textDecoration,cursor:ce.cursor,color:ce.color,opacity:ce.opacity,letterSpacing:ce.letterSpacing,gutterIconPath:ce.gutterIconPath?_(ce.gutterIconPath):void 0,gutterIconSize:ce.gutterIconSize,overviewRulerColor:ce.overviewRulerColor,before:ce.before?D.from(ce.before):void 0,after:ce.after?D.from(ce.after):void 0}}Ee.from=Ce})(a=e.ThemableDecorationRenderOptions||(e.ThemableDecorationRenderOptions={}));var T;(function(Ee){function Ce(ce){if(typeof ce=="undefined")return ce;switch(ce){case u.DecorationRangeBehavior.OpenOpen:return 0;case u.DecorationRangeBehavior.ClosedClosed:return 1;case u.DecorationRangeBehavior.OpenClosed:return 2;case u.DecorationRangeBehavior.ClosedOpen:return 3}}Ee.from=Ce})(T=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={}));var L;(function(Ee){function Ce(ce){return{isWholeLine:ce.isWholeLine,rangeBehavior:ce.rangeBehavior?T.from(ce.rangeBehavior):void 0,overviewRulerLane:ce.overviewRulerLane,light:ce.light?a.from(ce.light):void 0,dark:ce.dark?a.from(ce.dark):void 0,backgroundColor:ce.backgroundColor,outline:ce.outline,outlineColor:ce.outlineColor,outlineStyle:ce.outlineStyle,outlineWidth:ce.outlineWidth,border:ce.border,borderColor:ce.borderColor,borderRadius:ce.borderRadius,borderSpacing:ce.borderSpacing,borderStyle:ce.borderStyle,borderWidth:ce.borderWidth,fontStyle:ce.fontStyle,fontWeight:ce.fontWeight,textDecoration:ce.textDecoration,cursor:ce.cursor,color:ce.color,opacity:ce.opacity,letterSpacing:ce.letterSpacing,gutterIconPath:ce.gutterIconPath?_(ce.gutterIconPath):void 0,gutterIconSize:ce.gutterIconSize,overviewRulerColor:ce.overviewRulerColor,before:ce.before?D.from(ce.before):void 0,after:ce.after?D.from(ce.after):void 0}}Ee.from=Ce})(L=e.DecorationRenderOptions||(e.DecorationRenderOptions={}));var U;(function(Ee){function Ce(Q){return{text:Q.newText,eol:Q.newEol&&K.from(Q.newEol),range:w.from(Q.range)}}Ee.from=Ce;function ce(Q){const Be=new u.TextEdit(w.to(Q.range),Q.text);return Be.newEol=typeof Q.eol=="undefined"?void 0:K.to(Q.eol),Be}Ee.to=ce})(U=e.TextEdit||(e.TextEdit={}));var G;(function(Ee){function Ce(Q,Be,De){var Ke,et;const tt={edits:[]};if(Q instanceof u.WorkspaceEdit)for(let st of Q._allEntries())if(st._type===1)tt.edits.push({_type:1,oldUri:st.from,newUri:st.to,options:st.options,metadata:st.metadata});else if(st._type===2){const pt=Be==null?void 0:Be.getDocument(st.uri);tt.edits.push({_type:2,resource:st.uri,edit:U.from(st.edit),modelVersionId:pt==null?void 0:pt.version,metadata:st.metadata})}else st._type===3?tt.edits.push({_type:3,metadata:st.metadata,resource:st.uri,edit:st.edit,notebookMetadata:st.notebookMetadata,notebookVersionId:(Ke=De==null?void 0:De.getNotebookDocument(st.uri,!0))===null||Ke===void 0?void 0:Ke.apiNotebook.version}):st._type===5&&tt.edits.push({_type:3,metadata:st.metadata,resource:st.uri,notebookVersionId:(et=De==null?void 0:De.getNotebookDocument(st.uri,!0))===null||et===void 0?void 0:et.apiNotebook.version,edit:{editType:1,index:st.index,count:st.count,cells:st.cells.map(fe.from)}});return tt}Ee.from=Ce;function ce(Q){const Be=new u.WorkspaceEdit;for(const De of Q.edits)De.edit?Be.replace(E.URI.revive(De.resource),w.to(De.edit.range),De.edit.text):Be.renameFile(E.URI.revive(De.oldUri),E.URI.revive(De.newUri),De.options);return Be}Ee.to=ce})(G=e.WorkspaceEdit||(e.WorkspaceEdit={}));var ee;(function(Ee){const Ce=Object.create(null);Ce[u.SymbolKind.File]=0,Ce[u.SymbolKind.Module]=1,Ce[u.SymbolKind.Namespace]=2,Ce[u.SymbolKind.Package]=3,Ce[u.SymbolKind.Class]=4,Ce[u.SymbolKind.Method]=5,Ce[u.SymbolKind.Property]=6,Ce[u.SymbolKind.Field]=7,Ce[u.SymbolKind.Constructor]=8,Ce[u.SymbolKind.Enum]=9,Ce[u.SymbolKind.Interface]=10,Ce[u.SymbolKind.Function]=11,Ce[u.SymbolKind.Variable]=12,Ce[u.SymbolKind.Constant]=13,Ce[u.SymbolKind.String]=14,Ce[u.SymbolKind.Number]=15,Ce[u.SymbolKind.Boolean]=16,Ce[u.SymbolKind.Array]=17,Ce[u.SymbolKind.Object]=18,Ce[u.SymbolKind.Key]=19,Ce[u.SymbolKind.Null]=20,Ce[u.SymbolKind.EnumMember]=21,Ce[u.SymbolKind.Struct]=22,Ce[u.SymbolKind.Event]=23,Ce[u.SymbolKind.Operator]=24,Ce[u.SymbolKind.TypeParameter]=25;function ce(Be){return typeof Ce[Be]=="number"?Ce[Be]:6}Ee.from=ce;function Q(Be){for(const De in Ce)if(Ce[De]===Be)return Number(De);return u.SymbolKind.Property}Ee.to=Q})(ee=e.SymbolKind||(e.SymbolKind={}));var z;(function(Ee){function Ce(Q){switch(Q){case u.SymbolTag.Deprecated:return 1}}Ee.from=Ce;function ce(Q){switch(Q){case 1:return u.SymbolTag.Deprecated}}Ee.to=ce})(z=e.SymbolTag||(e.SymbolTag={}));var N;(function(Ee){function Ce(Q){return{name:Q.name,kind:ee.from(Q.kind),tags:Q.tags&&Q.tags.map(z.from),containerName:Q.containerName,location:F.from(Q.location)}}Ee.from=Ce;function ce(Q){const Be=new u.SymbolInformation(Q.name,ee.to(Q.kind),Q.containerName,F.to(Q.location));return Be.tags=Q.tags&&Q.tags.map(z.to),Be}Ee.to=ce})(N=e.WorkspaceSymbol||(e.WorkspaceSymbol={}));var W;(function(Ee){function Ce(Q){var Be,De;const Ke={name:Q.name||"!!MISSING: name!!",detail:Q.detail,range:w.from(Q.range),selectionRange:w.from(Q.selectionRange),kind:ee.from(Q.kind),tags:(De=(Be=Q.tags)===null||Be===void 0?void 0:Be.map(z.from))!==null&&De!==void 0?De:[]};return Q.children&&(Ke.children=Q.children.map(Ce)),Ke}Ee.from=Ce;function ce(Q){const Be=new u.DocumentSymbol(Q.name,Q.detail,ee.to(Q.kind),w.to(Q.range),w.to(Q.selectionRange));return p.isNonEmptyArray(Q.tags)&&(Be.tags=Q.tags.map(z.to)),Q.children&&(Be.children=Q.children.map(ce)),Be}Ee.to=ce})(W=e.DocumentSymbol||(e.DocumentSymbol={}));var M;(function(Ee){function Ce(ce){const Q=new u.CallHierarchyItem(ee.to(ce.kind),ce.name,ce.detail||"",E.URI.revive(ce.uri),w.to(ce.range),w.to(ce.selectionRange));return Q._sessionId=ce._sessionId,Q._itemId=ce._itemId,Q}Ee.to=Ce})(M=e.CallHierarchyItem||(e.CallHierarchyItem={}));var j;(function(Ee){function Ce(ce){return new u.CallHierarchyIncomingCall(M.to(ce.from),ce.fromRanges.map(Q=>w.to(Q)))}Ee.to=Ce})(j=e.CallHierarchyIncomingCall||(e.CallHierarchyIncomingCall={}));var O;(function(Ee){function Ce(ce){return new u.CallHierarchyOutgoingCall(M.to(ce.to),ce.fromRanges.map(Q=>w.to(Q)))}Ee.to=Ce})(O=e.CallHierarchyOutgoingCall||(e.CallHierarchyOutgoingCall={}));var F;(function(Ee){function Ce(Q){return{range:Q.range&&w.from(Q.range),uri:Q.uri}}Ee.from=Ce;function ce(Q){return new u.Location(E.URI.revive(Q.uri),w.to(Q.range))}Ee.to=ce})(F=e.location||(e.location={}));var B;(function(Ee){function Ce(Q){const Be=Q,De=Q;return{originSelectionRange:Be.originSelectionRange?w.from(Be.originSelectionRange):void 0,uri:Be.targetUri?Be.targetUri:De.uri,range:w.from(Be.targetRange?Be.targetRange:De.range),targetSelectionRange:Be.targetSelectionRange?w.from(Be.targetSelectionRange):void 0}}Ee.from=Ce;function ce(Q){return{targetUri:E.URI.revive(Q.uri),targetRange:w.to(Q.range),targetSelectionRange:Q.targetSelectionRange?w.to(Q.targetSelectionRange):void 0,originSelectionRange:Q.originSelectionRange?w.to(Q.originSelectionRange):void 0}}Ee.to=ce})(B=e.DefinitionLink||(e.DefinitionLink={}));var $;(function(Ee){function Ce(Q){return{range:w.from(Q.range),contents:v.fromMany(Q.contents)}}Ee.from=Ce;function ce(Q){return new u.Hover(Q.contents.map(v.to),w.to(Q.range))}Ee.to=ce})($=e.Hover||(e.Hover={}));var Y;(function(Ee){function Ce(Q){return{range:w.from(Q.range),expression:Q.expression}}Ee.from=Ce;function ce(Q){return new u.EvaluatableExpression(w.to(Q.range),Q.expression)}Ee.to=ce})(Y=e.EvaluatableExpression||(e.EvaluatableExpression={}));var le;(function(Ee){function Ce(Q){if(Q instanceof u.InlineValueText)return{type:"text",range:w.from(Q.range),text:Q.text};if(Q instanceof u.InlineValueVariableLookup)return{type:"variable",range:w.from(Q.range),variableName:Q.variableName,caseSensitiveLookup:Q.caseSensitiveLookup};if(Q instanceof u.InlineValueEvaluatableExpression)return{type:"expression",range:w.from(Q.range),expression:Q.expression};throw new Error("Unknown 'InlineValue' type")}Ee.from=Ce;function ce(Q){switch(Q.type){case"text":return{range:w.to(Q.range),text:Q.text};case"variable":return{range:w.to(Q.range),variableName:Q.variableName,caseSensitiveLookup:Q.caseSensitiveLookup};case"expression":return{range:w.to(Q.range),expression:Q.expression}}}Ee.to=ce})(le=e.InlineValue||(e.InlineValue={}));var be;(function(Ee){function Ce(Q){return{frameId:Q.frameId,stoppedLocation:w.from(Q.stoppedLocation)}}Ee.from=Ce;function ce(Q){return new u.InlineValueContext(Q.frameId,w.to(Q.stoppedLocation))}Ee.to=ce})(be=e.InlineValueContext||(e.InlineValueContext={}));var Le;(function(Ee){function Ce(Q){return{range:w.from(Q.range),kind:Q.kind}}Ee.from=Ce;function ce(Q){return new u.DocumentHighlight(w.to(Q.range),Q.kind)}Ee.to=ce})(Le=e.DocumentHighlight||(e.DocumentHighlight={}));var Ie;(function(Ee){function Ce(ce){switch(ce){case 1:return u.CompletionTriggerKind.TriggerCharacter;case 2:return u.CompletionTriggerKind.TriggerForIncompleteCompletions;case 0:default:return u.CompletionTriggerKind.Invoke}}Ee.to=Ce})(Ie=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var Ue;(function(Ee){function Ce(ce){return{triggerKind:Ie.to(ce.triggerKind),triggerCharacter:ce.triggerCharacter}}Ee.to=Ce})(Ue=e.CompletionContext||(e.CompletionContext={}));var Qe;(function(Ee){function Ce(Q){switch(Q){case u.CompletionItemTag.Deprecated:return 1}}Ee.from=Ce;function ce(Q){switch(Q){case 1:return u.CompletionItemTag.Deprecated}}Ee.to=ce})(Qe=e.CompletionItemTag||(e.CompletionItemTag={}));var ze;(function(Ee){const Ce=new Map([[u.CompletionItemKind.Method,0],[u.CompletionItemKind.Function,1],[u.CompletionItemKind.Constructor,2],[u.CompletionItemKind.Field,3],[u.CompletionItemKind.Variable,4],[u.CompletionItemKind.Class,5],[u.CompletionItemKind.Interface,7],[u.CompletionItemKind.Struct,6],[u.CompletionItemKind.Module,8],[u.CompletionItemKind.Property,9],[u.CompletionItemKind.Unit,12],[u.CompletionItemKind.Value,13],[u.CompletionItemKind.Constant,14],[u.CompletionItemKind.Enum,15],[u.CompletionItemKind.EnumMember,16],[u.CompletionItemKind.Keyword,17],[u.CompletionItemKind.Snippet,27],[u.CompletionItemKind.Text,18],[u.CompletionItemKind.Color,19],[u.CompletionItemKind.File,20],[u.CompletionItemKind.Reference,21],[u.CompletionItemKind.Folder,23],[u.CompletionItemKind.Event,10],[u.CompletionItemKind.Operator,11],[u.CompletionItemKind.TypeParameter,24],[u.CompletionItemKind.Issue,26],[u.CompletionItemKind.User,25]]);function ce(De){var Ke;return(Ke=Ce.get(De))!==null&&Ke!==void 0?Ke:9}Ee.from=ce;const Q=new Map([[0,u.CompletionItemKind.Method],[1,u.CompletionItemKind.Function],[2,u.CompletionItemKind.Constructor],[3,u.CompletionItemKind.Field],[4,u.CompletionItemKind.Variable],[5,u.CompletionItemKind.Class],[7,u.CompletionItemKind.Interface],[6,u.CompletionItemKind.Struct],[8,u.CompletionItemKind.Module],[9,u.CompletionItemKind.Property],[12,u.CompletionItemKind.Unit],[13,u.CompletionItemKind.Value],[14,u.CompletionItemKind.Constant],[15,u.CompletionItemKind.Enum],[16,u.CompletionItemKind.EnumMember],[17,u.CompletionItemKind.Keyword],[27,u.CompletionItemKind.Snippet],[18,u.CompletionItemKind.Text],[19,u.CompletionItemKind.Color],[20,u.CompletionItemKind.File],[21,u.CompletionItemKind.Reference],[23,u.CompletionItemKind.Folder],[10,u.CompletionItemKind.Event],[11,u.CompletionItemKind.Operator],[24,u.CompletionItemKind.TypeParameter],[25,u.CompletionItemKind.User],[26,u.CompletionItemKind.Issue]]);function Be(De){var Ke;return(Ke=Q.get(De))!==null&&Ke!==void 0?Ke:u.CompletionItemKind.Property}Ee.to=Be})(ze=e.CompletionItemKind||(e.CompletionItemKind={}));var Ge;(function(Ee){function Ce(ce,Q){var Be;const De=new u.CompletionItem(ce.label);return De.insertText=ce.insertText,De.kind=ze.to(ce.kind),De.tags=(Be=ce.tags)===null||Be===void 0?void 0:Be.map(Qe.to),De.detail=ce.detail,De.documentation=R.isMarkdownString(ce.documentation)?v.to(ce.documentation):ce.documentation,De.sortText=ce.sortText,De.filterText=ce.filterText,De.preselect=ce.preselect,De.commitCharacters=ce.commitCharacters,k.Range.isIRange(ce.range)?De.range=w.to(ce.range):typeof ce.range=="object"&&(De.range={inserting:w.to(ce.range.insert),replacing:w.to(ce.range.replace)}),De.keepWhitespace=typeof ce.insertTextRules=="undefined"?!1:Boolean(ce.insertTextRules&1),typeof ce.insertTextRules!="undefined"&&ce.insertTextRules&4?De.insertText=new u.SnippetString(ce.insertText):(De.insertText=ce.insertText,De.textEdit=De.range instanceof u.Range?new u.TextEdit(De.range,De.insertText):void 0),ce.additionalTextEdits&&ce.additionalTextEdits.length>0&&(De.additionalTextEdits=ce.additionalTextEdits.map(Ke=>U.to(Ke))),De.command=Q&&ce.command?Q.fromInternal(ce.command):void 0,De}Ee.to=Ce})(Ge=e.CompletionItem||(e.CompletionItem={}));var V;(function(Ee){function Ce(Q){return{label:Q.label,documentation:Q.documentation?v.fromStrict(Q.documentation):void 0}}Ee.from=Ce;function ce(Q){return{label:Q.label,documentation:R.isMarkdownString(Q.documentation)?v.to(Q.documentation):Q.documentation}}Ee.to=ce})(V=e.ParameterInformation||(e.ParameterInformation={}));var Z;(function(Ee){function Ce(Q){return{label:Q.label,documentation:Q.documentation?v.fromStrict(Q.documentation):void 0,parameters:Array.isArray(Q.parameters)?Q.parameters.map(V.from):[],activeParameter:Q.activeParameter}}Ee.from=Ce;function ce(Q){return{label:Q.label,documentation:R.isMarkdownString(Q.documentation)?v.to(Q.documentation):Q.documentation,parameters:Array.isArray(Q.parameters)?Q.parameters.map(V.to):[],activeParameter:Q.activeParameter}}Ee.to=ce})(Z=e.SignatureInformation||(e.SignatureInformation={}));var ne;(function(Ee){function Ce(Q){return{activeSignature:Q.activeSignature,activeParameter:Q.activeParameter,signatures:Array.isArray(Q.signatures)?Q.signatures.map(Z.from):[]}}Ee.from=Ce;function ce(Q){return{activeSignature:Q.activeSignature,activeParameter:Q.activeParameter,signatures:Array.isArray(Q.signatures)?Q.signatures.map(Z.to):[]}}Ee.to=ce})(ne=e.SignatureHelp||(e.SignatureHelp={}));var se;(function(Ee){function Ce(Q){var Be;return{text:Q.text,position:d.from(Q.position),kind:J.from((Be=Q.kind)!==null&&Be!==void 0?Be:u.InlayHintKind.Other),whitespaceBefore:Q.whitespaceBefore,whitespaceAfter:Q.whitespaceAfter}}Ee.from=Ce;function ce(Q){const Be=new u.InlayHint(Q.text,d.to(Q.position),J.to(Q.kind));return Be.whitespaceAfter=Q.whitespaceAfter,Be.whitespaceBefore=Q.whitespaceBefore,Be}Ee.to=ce})(se=e.InlayHint||(e.InlayHint={}));var J;(function(Ee){function Ce(Q){return Q}Ee.from=Ce;function ce(Q){return Q}Ee.to=ce})(J=e.InlayHintKind||(e.InlayHintKind={}));var ae;(function(Ee){function Ce(Q){return{range:w.from(Q.range),url:Q.target,tooltip:Q.tooltip}}Ee.from=Ce;function ce(Q){let Be;if(Q.url)try{Be=typeof Q.url=="string"?E.URI.parse(Q.url,!0):E.URI.revive(Q.url)}catch(De){}return new u.DocumentLink(w.to(Q.range),Be)}Ee.to=ce})(ae=e.DocumentLink||(e.DocumentLink={}));var he;(function(Ee){function Ce(Q){const Be=new u.ColorPresentation(Q.label);return Q.textEdit&&(Be.textEdit=U.to(Q.textEdit)),Q.additionalTextEdits&&(Be.additionalTextEdits=Q.additionalTextEdits.map(De=>U.to(De))),Be}Ee.to=Ce;function ce(Q){return{label:Q.label,textEdit:Q.textEdit?U.from(Q.textEdit):void 0,additionalTextEdits:Q.additionalTextEdits?Q.additionalTextEdits.map(Be=>U.from(Be)):void 0}}Ee.from=ce})(he=e.ColorPresentation||(e.ColorPresentation={}));var Fe;(function(Ee){function Ce(Q){return new u.Color(Q[0],Q[1],Q[2],Q[3])}Ee.to=Ce;function ce(Q){return[Q.red,Q.green,Q.blue,Q.alpha]}Ee.from=ce})(Fe=e.Color||(e.Color={}));var He;(function(Ee){function Ce(Q){return{range:w.from(Q.range)}}Ee.from=Ce;function ce(Q){return new u.SelectionRange(w.to(Q.range))}Ee.to=ce})(He=e.SelectionRange||(e.SelectionRange={}));var _e;(function(Ee){function Ce(ce){switch(ce){case 2:return u.TextDocumentSaveReason.AfterDelay;case 1:return u.TextDocumentSaveReason.Manual;case 3:case 4:return u.TextDocumentSaveReason.FocusOut}}Ee.to=Ce})(_e=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var Ye;(function(Ee){function Ce(Q){switch(Q){case u.TextEditorLineNumbersStyle.Off:return 0;case u.TextEditorLineNumbersStyle.Relative:return 2;case u.TextEditorLineNumbersStyle.On:default:return 1}}Ee.from=Ce;function ce(Q){switch(Q){case 0:return u.TextEditorLineNumbersStyle.Off;case 2:return u.TextEditorLineNumbersStyle.Relative;case 1:default:return u.TextEditorLineNumbersStyle.On}}Ee.to=ce})(Ye=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var K;(function(Ee){function Ce(Q){if(Q===u.EndOfLine.CRLF)return 1;if(Q===u.EndOfLine.LF)return 0}Ee.from=Ce;function ce(Q){if(Q===1)return u.EndOfLine.CRLF;if(Q===0)return u.EndOfLine.LF}Ee.to=ce})(K=e.EndOfLine||(e.EndOfLine={}));var ie;(function(Ee){function Ce(ce){if(typeof ce=="object")return ce.viewId;switch(ce){case u.ProgressLocation.SourceControl:return 3;case u.ProgressLocation.Window:return 10;case u.ProgressLocation.Notification:return 15}throw new Error("Unknown 'ProgressLocation'")}Ee.from=Ce})(ie=e.ProgressLocation||(e.ProgressLocation={}));var ve;(function(Ee){function Ce(ce){const Q={start:ce.start+1,end:ce.end+1};return ce.kind&&(Q.kind=Me.from(ce.kind)),Q}Ee.from=Ce})(ve=e.FoldingRange||(e.FoldingRange={}));var Me;(function(Ee){function Ce(ce){if(ce)switch(ce){case u.FoldingRangeKind.Comment:return r.FoldingRangeKind.Comment;case u.FoldingRangeKind.Imports:return r.FoldingRangeKind.Imports;case u.FoldingRangeKind.Region:return r.FoldingRangeKind.Region}}Ee.from=Ce})(Me=e.FoldingRangeKind||(e.FoldingRangeKind={}));var xe;(function(Ee){function Ce(ce){if(ce)return{pinned:typeof ce.preview=="boolean"?!ce.preview:void 0,inactive:ce.background,preserveFocus:ce.preserveFocus,selection:typeof ce.selection=="object"?w.from(ce.selection):void 0,override:typeof ce.override=="boolean"?I.EditorOverride.DISABLED:void 0}}Ee.from=Ce})(xe=e.TextEditorOpenOptions||(e.TextEditorOpenOptions={}));var Je;(function(Ee){function Ce(Q){return Q instanceof u.RelativePattern||typeof Q=="string"?Q:ce(Q)?new u.RelativePattern(Q.base,Q.pattern):Q}Ee.from=Ce;function ce(Q){const Be=Q;return Be&&typeof Be.base=="string"&&typeof Be.pattern=="string"}})(Je=e.GlobPattern||(e.GlobPattern={}));var ke;(function(Ee){function Ce(ce){if(ce){if(Array.isArray(ce))return ce.map(Ce);if(typeof ce=="string")return ce;{const Q=ce;return{language:Q.language,scheme:Q.scheme,pattern:typeof Q.pattern=="undefined"?void 0:Je.from(Q.pattern),exclusive:Q.exclusive}}}else return}Ee.from=Ce})(ke=e.LanguageSelector||(e.LanguageSelector={}));var ye;(function(Ee){function Ce(Q){return{start:Q.start,end:Q.end}}Ee.from=Ce;function ce(Q){return new u.NotebookRange(Q.start,Q.end)}Ee.to=ce})(ye=e.NotebookRange||(e.NotebookRange={}));var Ae;(function(Ee){function Ce(Q){return{timing:typeof Q.runStartTime=="number"&&typeof Q.runEndTime=="number"?{startTime:Q.runStartTime,endTime:Q.runEndTime}:void 0,executionOrder:Q.executionOrder,success:Q.lastRunSuccess}}Ee.to=Ce;function ce(Q){var Be,De;return{lastRunSuccess:Q.success,runStartTime:(Be=Q.timing)===null||Be===void 0?void 0:Be.startTime,runEndTime:(De=Q.timing)===null||De===void 0?void 0:De.endTime,executionOrder:Q.executionOrder}}Ee.from=ce})(Ae=e.NotebookCellExecutionSummary||(e.NotebookCellExecutionSummary={}));var oe;(function(Ee){function Ce(Q){switch(Q){case u.NotebookCellKind.Markup:return f.CellKind.Markup;case u.NotebookCellKind.Code:default:return f.CellKind.Code}}Ee.from=Ce;function ce(Q){switch(Q){case f.CellKind.Markup:return u.NotebookCellKind.Markup;case f.CellKind.Code:default:return u.NotebookCellKind.Code}}Ee.to=ce})(oe=e.NotebookCellKind||(e.NotebookCellKind={}));var ue;(function(Ee){function Ce(Q){var Be;const De={metadata:(Be=Q.metadata)!==null&&Be!==void 0?Be:Object.create(null),cells:[]};for(let Ke of Q.cells)u.NotebookCellData.validate(Ke),De.cells.push(fe.from(Ke));return De}Ee.from=Ce;function ce(Q){const Be=new u.NotebookData(Q.cells.map(fe.to));return P.isEmptyObject(Q.metadata)||(Be.metadata=Q.metadata),Be}Ee.to=ce})(ue=e.NotebookData||(e.NotebookData={}));var fe;(function(Ee){function Ce(Q){var Be;return{cellKind:oe.from(Q.kind),language:Q.languageId,mime:Q.mime,source:Q.value,metadata:Q.metadata,internalMetadata:Ae.from((Be=Q.executionSummary)!==null&&Be!==void 0?Be:{}),outputs:Q.outputs?Q.outputs.map(q.from):[]}}Ee.from=Ce;function ce(Q){return new u.NotebookCellData(oe.to(Q.cellKind),Q.source,Q.language,Q.mime,Q.outputs?Q.outputs.map(q.to):void 0,Q.metadata,Q.internalMetadata?Ae.to(Q.internalMetadata):void 0)}Ee.to=ce})(fe=e.NotebookCellData||(e.NotebookCellData={}));var we;(function(Ee){function Ce(Q){return{mime:Q.mime,valueBytes:Array.from(Q.data)}}Ee.from=Ce;function ce(Q){return new u.NotebookCellOutputItem(new Uint8Array(Q.valueBytes),Q.mime)}Ee.to=ce})(we=e.NotebookCellOutputItem||(e.NotebookCellOutputItem={}));var q;(function(Ee){function Ce(Q){return{outputId:Q.id,items:Q.items.map(we.from),metadata:Q.metadata}}Ee.from=Ce;function ce(Q){const Be=Q.items.map(we.to);return new u.NotebookCellOutput(Be,Q.outputId,Q.metadata)}Ee.to=ce})(q=e.NotebookCellOutput||(e.NotebookCellOutput={}));var pe;(function(Ee){function Ce(De){if(De!=null){if(De instanceof u.RelativePattern||typeof De=="string")return De;if(Be(De))return new u.RelativePattern(De.base,De.pattern);if(Q(De))return{include:Je.from(De.include)||void 0,exclude:Je.from(De.exclude)||void 0}}}Ee.from=Ce;function ce(De){return typeof De=="string"?De:Be(De)?{base:De.base,pattern:De.pattern}:{include:De.include,exclude:De.exclude}}Ee.to=ce;function Q(De){const Ke=De,et=Je.from(Ke.include);if(!(et&&et instanceof u.RelativePattern||typeof et=="string"))return!1;const tt=Je.from(Ke.exclude);return!!(tt&&tt instanceof u.RelativePattern||typeof tt=="string")}function Be(De){const Ke=De;return Ke&&typeof Ke.base=="string"&&typeof Ke.pattern=="string"}})(pe=e.NotebookExclusiveDocumentPattern||(e.NotebookExclusiveDocumentPattern={}));var Se;(function(Ee){function Ce(ce){return{backgroundColor:ce.backgroundColor,borderColor:ce.borderColor,top:ce.top?D.from(ce.top):void 0}}Ee.from=Ce})(Se=e.NotebookDecorationRenderOptions||(e.NotebookDecorationRenderOptions={}));var Te;(function(Ee){function Ce(ce,Q,Be){const De=typeof ce.command=="string"?{title:"",command:ce.command}:ce.command;return{alignment:ce.alignment===u.NotebookCellStatusBarAlignment.Left?1:2,command:Q.toInternal(De,Be),text:ce.text,tooltip:ce.tooltip,accessibilityInformation:ce.accessibilityInformation,priority:ce.priority}}Ee.from=Ce})(Te=e.NotebookStatusBarItem||(e.NotebookStatusBarItem={}));var Oe;(function(Ee){function Ce(ce){var Q,Be,De;return{transientOutputs:(Q=ce==null?void 0:ce.transientOutputs)!==null&&Q!==void 0?Q:!1,transientCellMetadata:(Be=ce==null?void 0:ce.transientCellMetadata)!==null&&Be!==void 0?Be:{},transientDocumentMetadata:(De=ce==null?void 0:ce.transientDocumentMetadata)!==null&&De!==void 0?De:{}}}Ee.from=Ce})(Oe=e.NotebookDocumentContentOptions||(e.NotebookDocumentContentOptions={}));var je;(function(Ee){function Ce(Q){return{uri:Q.uri,provides:Q.provides}}Ee.from=Ce;function ce(Q){return new u.NotebookRendererScript(E.URI.revive(Q.uri),Q.provides)}Ee.to=ce})(je=e.NotebookRendererScript||(e.NotebookRendererScript={}));var qe;(function(Ee){function Ce(Q){return{message:v.fromStrict(Q.message)||"",severity:Q.severity,expectedOutput:Q.expectedOutput,actualOutput:Q.actualOutput,location:Q.location?F.from(Q.location):void 0}}Ee.from=Ce;function ce(Q){const Be=new u.TestMessage(typeof Q.message=="string"?Q.message:v.to(Q.message));return Be.severity=Q.severity,Be.actualOutput=Q.actualOutput,Be.expectedOutput=Q.expectedOutput,Be}Ee.to=ce})(qe=e.TestMessage||(e.TestMessage={}));var Ze;(function(Ee){function Ce(Ke){var et,tt;return{extId:Ke.id,label:Ke.label,uri:Ke.uri,range:w.from(Ke.range)||null,debuggable:(et=Ke.debuggable)!==null&&et!==void 0?et:!1,description:Ke.description||null,runnable:(tt=Ke.runnable)!==null&&tt!==void 0?tt:!0,error:Ke.error&&v.fromStrict(Ke.error)||null}}Ee.from=Ce;function ce(Ke){return{extId:Ke.id,label:Ke.label,uri:Ke.uri,range:w.from(Ke.range)||null,debuggable:!1,description:Ke.description||null,error:null,runnable:!0}}Ee.fromResultSnapshot=ce;function Q(Ke){return{id:Ke.extId,label:Ke.label,uri:E.URI.revive(Ke.uri),range:w.to(Ke.range||void 0),dispose:()=>{},canResolveChildren:!1,busy:!1,data:void 0,debuggable:Ke.debuggable,description:Ke.description||void 0,runnable:Ke.runnable}}Ee.toPlain=Q;function Be(Ke,et){const tt=new u.TestItemImpl(Ke.extId,Ke.label,E.URI.revive(Ke.uri),void 0,et);return tt.range=w.to(Ke.range||void 0),tt.debuggable=Ke.debuggable,tt.description=Ke.description||void 0,tt.runnable=Ke.runnable,tt}Ee.to=Be;function De(Ke){let et;for(const tt of Ke.tests)et=Be(tt.item,et);return et}Ee.toItemFromContext=De})(Ze=e.TestItem||(e.TestItem={}));var nt;(function(Ee){const Ce=(Q,Be)=>Object.assign(Object.assign({},Ze.toPlain(Q.item)),{taskStates:Q.tasks.map(De=>({state:De.state,duration:De.duration,messages:De.messages.map(qe.to)})),children:Q.children.map(De=>Be.get(De)).filter(P.isDefined).map(De=>Ce(De,Be))});function ce(Q){const Be=[],De=new Map;for(const Ke of Q.items)De.set(Ke.item.extId,Ke),Ke.direct&&Be.push(Ke);return{completedAt:Q.completedAt,results:Be.map(Ke=>Ce(Ke,De))}}Ee.to=ce})(nt=e.TestResults||(e.TestResults={}));var ct;(function(Ee){function Ce(ce){switch(ce){case 1:return u.CodeActionTriggerKind.Invoke;case 2:return u.CodeActionTriggerKind.Automatic}}Ee.to=Ce})(ct=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}))}),define(me[206],ge([0,1,2,14,7,17,71]),function(X,e,p,R,C,y,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentSaveParticipant=void 0;class P{constructor(k,r,I,l={timeout:1500,errors:3}){this._logService=k,this._documents=r,this._mainThreadBulkEdits=I,this._thresholds=l,this._callbacks=new A.LinkedList,this._badListeners=new WeakMap}dispose(){this._callbacks.clear()}getOnWillSaveTextDocumentEvent(k){return(r,I,l)=>{const c={dispose:this._callbacks.push([r,I,k])};return Array.isArray(l)&&l.push(c),c}}async $participateInSave(k,r){const I=p.URI.revive(k);let l=!1;const f=setTimeout(()=>l=!0,this._thresholds.timeout),c=[];try{for(let u of[...this._callbacks]){if(l)break;const S=this._documents.getDocument(I),w=await this._deliverEventAsyncAndBlameBadListeners(u,{document:S,reason:y.TextDocumentSaveReason.to(r)});c.push(w)}}finally{clearTimeout(f)}return c}_deliverEventAsyncAndBlameBadListeners([k,r,I],l){const f=this._badListeners.get(k);return typeof f=="number"&&f>this._thresholds.errors?Promise.resolve(!1):this._deliverEventAsync(I,k,r,l).then(()=>!0,c=>{if(this._logService.error(`onWillSaveTextDocument-listener from extension '${I.identifier.value}' threw ERROR`),this._logService.error(c),!(c instanceof Error)||c.message!=="concurrent_edits"){const u=this._badListeners.get(k);this._badListeners.set(k,u?u+1:1),typeof u=="number"&&u>this._thresholds.errors&&this._logService.info(`onWillSaveTextDocument-listener from extension '${I.identifier.value}' will now be IGNORED because of timeouts and/or errors`)}return!1})}_deliverEventAsync(k,r,I,l){const f=[],c=Date.now(),{document:u,reason:S}=l,{version:w}=u,b=Object.freeze({document:u,reason:S,waitUntil(d){if(Object.isFrozen(f))throw R.illegalState("waitUntil can not be called async");f.push(Promise.resolve(d))}});try{r.apply(I,[b])}catch(d){return Promise.reject(d)}return Object.freeze(f),new Promise((d,h)=>{const g=setTimeout(()=>h(new Error("timeout")),this._thresholds.timeout);return Promise.all(f).then(t=>{this._logService.debug(`onWillSaveTextDocument-listener from extension '${k.identifier.value}' finished after ${Date.now()-c}ms`),clearTimeout(g),d(t)}).catch(t=>{clearTimeout(g),h(t)})}).then(d=>{const h={edits:[]};for(const g of d)if(Array.isArray(g)&&g.every(t=>t instanceof C.TextEdit))for(const{newText:t,newEol:i,range:s}of g)h.edits.push({_type:2,resource:u.uri,edit:{range:s&&y.Range.from(s),text:t,eol:i&&y.EndOfLine.from(i)}});if(h.edits.length!==0)return w===u.version?this._mainThreadBulkEdits.$tryApplyWorkspaceEdit(h):Promise.reject(new Error("concurrent_edits"))})}}e.ExtHostDocumentSaveParticipant=P}),define(me[207],ge([0,1,3,16,30,2,17,7]),function(X,e,p,R,C,y,A,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystemEventService=void 0;class E{constructor(I,l,f,c,u){this._onDidCreate=new p.Emitter,this._onDidChange=new p.Emitter,this._onDidDelete=new p.Emitter,this._config=0,f&&(this._config+=1),c&&(this._config+=2),u&&(this._config+=4);const S=C.parse(l),w=I(b=>{if(!f)for(let d of b.created){const h=y.URI.revive(d);S(h.fsPath)&&this._onDidCreate.fire(h)}if(!c)for(let d of b.changed){const h=y.URI.revive(d);S(h.fsPath)&&this._onDidChange.fire(h)}if(!u)for(let d of b.deleted){const h=y.URI.revive(d);S(h.fsPath)&&this._onDidDelete.fire(h)}});this._disposable=P.Disposable.from(this._onDidCreate,this._onDidChange,this._onDidDelete,w)}get ignoreCreateEvents(){return Boolean(this._config&1)}get ignoreChangeEvents(){return Boolean(this._config&2)}get ignoreDeleteEvents(){return Boolean(this._config&4)}dispose(){this._disposable.dispose()}get onDidCreate(){return this._onDidCreate.event}get onDidChange(){return this._onDidChange.event}get onDidDelete(){return this._onDidDelete.event}}class k{constructor(I,l,f){this._logService=l,this._extHostDocumentsAndEditors=f,this._onFileSystemEvent=new p.Emitter,this._onDidRenameFile=new p.Emitter,this._onDidCreateFile=new p.Emitter,this._onDidDeleteFile=new p.Emitter,this._onWillRenameFile=new R.AsyncEmitter,this._onWillCreateFile=new R.AsyncEmitter,this._onWillDeleteFile=new R.AsyncEmitter,this.onDidRenameFile=this._onDidRenameFile.event,this.onDidCreateFile=this._onDidCreateFile.event,this.onDidDeleteFile=this._onDidDeleteFile.event}createFileSystemWatcher(I,l,f,c){return new E(this._onFileSystemEvent.event,I,l,f,c)}$onFileEvent(I){this._onFileSystemEvent.fire(I)}$onDidRunFileOperation(I,l){switch(I){case 2:this._onDidRenameFile.fire(Object.freeze({files:l.map(f=>({oldUri:y.URI.revive(f.source),newUri:y.URI.revive(f.target)}))}));break;case 1:this._onDidDeleteFile.fire(Object.freeze({files:l.map(f=>y.URI.revive(f.target))}));break;case 0:this._onDidCreateFile.fire(Object.freeze({files:l.map(f=>y.URI.revive(f.target))}));break;default:}}getOnWillRenameFileEvent(I){return this._createWillExecuteEvent(I,this._onWillRenameFile)}getOnWillCreateFileEvent(I){return this._createWillExecuteEvent(I,this._onWillCreateFile)}getOnWillDeleteFileEvent(I){return this._createWillExecuteEvent(I,this._onWillDeleteFile)}_createWillExecuteEvent(I,l){return(f,c,u)=>{const S=function(b){f.call(c,b)};return S.extension=I,l.event(S,void 0,u)}}async $onWillRunFileOperation(I,l,f,c){switch(I){case 2:return await this._fireWillEvent(this._onWillRenameFile,{files:l.map(u=>({oldUri:y.URI.revive(u.source),newUri:y.URI.revive(u.target)}))},f,c);case 1:return await this._fireWillEvent(this._onWillDeleteFile,{files:l.map(u=>y.URI.revive(u.target))},f,c);case 0:return await this._fireWillEvent(this._onWillCreateFile,{files:l.map(u=>y.URI.revive(u.target))},f,c)}}async _fireWillEvent(I,l,f,c){const u=new Set,S=[];if(await I.fireAsync(l,c,async(b,d)=>{var h;const g=Date.now(),t=await Promise.resolve(b);t instanceof P.WorkspaceEdit&&(S.push(t),u.add((h=d.extension.displayName)!==null&&h!==void 0?h:d.extension.identifier.value)),Date.now()-g>f&&this._logService.warn("SLOW file-participant",d.extension.identifier)}),c.isCancellationRequested||S.length===0)return;const w={edits:[]};for(let b of S){let{edits:d}=A.WorkspaceEdit.from(b,this._extHostDocumentsAndEditors);w.edits=w.edits.concat(d)}return{edit:w,extensionNames:Array.from(u)}}}e.ExtHostFileSystemEventService=k}),define(me[208],ge([0,1,10,25,2,17,7,84]),function(X,e,p,R,C,y,A,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocument=e.ExtHostCell=void 0;class E{constructor(l,f,c,u){this.start=l,this.deletedCount=f,this.deletedItems=c,this.items=u}static asApiEvents(l){return l.map(f=>({start:f.start,deletedCount:f.deletedCount,deletedItems:f.deletedItems,items:f.items.map(c=>c.apiCell)}))}}class k{constructor(l,f,c){var u,S,w;this.notebook=l,this._extHostDocument=f,this._cellData=c,this.handle=c.handle,this.uri=C.URI.revive(c.uri),this.cellKind=c.cellKind,this._outputs=c.outputs.map(y.NotebookCellOutput.to),this._internalMetadata=(u=c.internalMetadata)!==null&&u!==void 0?u:{},this._metadata=(S=c.metadata)!==null&&S!==void 0?S:{},this._previousResult=y.NotebookCellExecutionSummary.to((w=c.internalMetadata)!==null&&w!==void 0?w:{})}static asModelAddData(l,f){return{EOL:f.eol,lines:f.source,modeId:f.language,uri:f.uri,isDirty:!1,versionId:1,notebook:l}}get internalMetadata(){return this._internalMetadata}get apiCell(){if(!this._apiCell){const l=this,f=this._extHostDocument.getDocument(this.uri);if(!f)throw new Error(`MISSING extHostDocument for notebook cell: ${this.uri}`);this._apiCell=Object.freeze({get index(){return l.notebook.getCellIndex(l)},notebook:l.notebook.apiNotebook,kind:y.NotebookCellKind.to(this._cellData.cellKind),document:f.document,get mime(){return l._mime},set mime(c){l._mime=c},get outputs(){return l._outputs.slice(0)},get metadata(){return l._metadata},get executionSummary(){return l._previousResult}})}return this._apiCell}setOutputs(l){this._outputs=l.map(y.NotebookCellOutput.to)}setOutputItems(l,f,c){const u=c.map(y.NotebookCellOutputItem.to),S=this._outputs.find(w=>w.id===l);S&&(f||(S.items.length=0),S.items.push(...u))}setMetadata(l){this._metadata=l}setInternalMetadata(l){this._internalMetadata=l,this._previousResult=y.NotebookCellExecutionSummary.to(l)}setMime(l){}}e.ExtHostCell=k;class r{constructor(l,f,c,u,S,w){var b;this._proxy=l,this._textDocumentsAndEditors=f,this._textDocuments=c,this._emitter=u,this.uri=S,this.handle=r._handlePool++,this._cells=[],this._versionId=0,this._isDirty=!1,this._disposed=!1,this._notebookType=w.viewType,this._metadata=(b=w.metadata)!==null&&b!==void 0?b:Object.create(null),this._spliceNotebookCells([[0,0,w.cells]],!0),this._versionId=w.versionId}dispose(){this._disposed=!0}get apiNotebook(){if(!this._notebook){const l=this;this._notebook={get uri(){return l.uri},get version(){return l._versionId},get notebookType(){return l._notebookType},get isDirty(){return l._isDirty},get isUntitled(){return l.uri.scheme===p.Schemas.untitled},get isClosed(){return l._disposed},get metadata(){return l._metadata},get cellCount(){return l._cells.length},cellAt(f){return f=l._validateIndex(f),l._cells[f].apiCell},getCells(f){return(f?l._getCells(f):l._cells).map(u=>u.apiCell)},save(){return l._save()}}}return this._notebook}updateBackup(l){var f;(f=this._backup)===null||f===void 0||f.delete(),this._backup=l}disposeBackup(){var l;(l=this._backup)===null||l===void 0||l.delete(),this._backup=void 0}acceptDocumentPropertiesChanged(l){l.metadata&&(this._metadata=Object.assign(Object.assign({},this._metadata),l.metadata))}acceptDirty(l){this._isDirty=l}acceptModelChanged(l,f){this._versionId=l.versionId,this._isDirty=f;for(const c of l.rawEvents)c.kind===P.NotebookCellsChangeType.ModelChange?this._spliceNotebookCells(c.changes,!1):c.kind===P.NotebookCellsChangeType.Move?this._moveCell(c.index,c.newIdx):c.kind===P.NotebookCellsChangeType.Output?this._setCellOutputs(c.index,c.outputs):c.kind===P.NotebookCellsChangeType.OutputItem?this._setCellOutputItems(c.index,c.outputId,c.append,c.outputItems):c.kind===P.NotebookCellsChangeType.ChangeLanguage?this._changeCellLanguage(c.index,c.language):c.kind===P.NotebookCellsChangeType.ChangeCellMime?this._changeCellMime(c.index,c.mime):c.kind===P.NotebookCellsChangeType.ChangeCellMetadata?this._changeCellMetadata(c.index,c.metadata):c.kind===P.NotebookCellsChangeType.ChangeCellInternalMetadata&&this._changeCellInternalMetadata(c.index,c.internalMetadata)}_validateIndex(l){return l=l|0,l<0?0:l>=this._cells.length?this._cells.length-1:l}_validateRange(l){let f=l.start|0,c=l.end|0;return f<0&&(f=0),c>this._cells.length&&(c=this._cells.length),l.with({start:f,end:c})}_getCells(l){l=this._validateRange(l);const f=[];for(let c=l.start;c<l.end;c++)f.push(this._cells[c]);return f}async _save(){return this._disposed?Promise.reject(new Error("Notebook has been closed")):this._proxy.$trySaveNotebook(this.uri)}_spliceNotebookCells(l,f){if(this._disposed)return;const c=[],u=[],S=[];l.reverse().forEach(w=>{const d=w[2].map(t=>{const i=new k(this,this._textDocumentsAndEditors,t);return f||u.push(k.asModelAddData(this.apiNotebook,t)),i}),h=new E(w[0],w[1],[],d),g=this._cells.splice(w[0],w[1],...d);for(const t of g)S.push(t.uri),h.deletedItems.push(t.apiCell);c.push(h)}),this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({addedDocuments:u,removedDocuments:S}),f||this._emitter.emitModelChange(R.deepFreeze({document:this.apiNotebook,changes:E.asApiEvents(c)}))}_moveCell(l,f){const c=this._cells.splice(l,1);this._cells.splice(f,0,...c);const u=[new E(l,1,c.map(S=>S.apiCell),[]),new E(f,0,[],c)];this._emitter.emitModelChange(R.deepFreeze({document:this.apiNotebook,changes:E.asApiEvents(u)}))}_setCellOutputs(l,f){const c=this._cells[l];c.setOutputs(f),this._emitter.emitCellOutputsChange(R.deepFreeze({document:this.apiNotebook,cells:[c.apiCell]}))}_setCellOutputItems(l,f,c,u){const S=this._cells[l];S.setOutputItems(f,c,u),this._emitter.emitCellOutputsChange(R.deepFreeze({document:this.apiNotebook,cells:[S.apiCell]}))}_changeCellLanguage(l,f){const c=this._cells[l];c.apiCell.document.languageId!==f&&this._textDocuments.$acceptModelModeChanged(c.uri,f)}_changeCellMime(l,f){const c=this._cells[l];c.apiCell.mime=f}_changeCellMetadata(l,f){const c=this._cells[l],u=c.apiCell.metadata;c.setMetadata(f);const S=c.apiCell.metadata;R.equals(u,S)||this._emitter.emitCellMetadataChange(R.deepFreeze({document:this.apiNotebook,cell:c.apiCell}))}_changeCellInternalMetadata(l,f){var c;const u=this._cells[l],S=u.internalMetadata;if(u.setInternalMetadata(f),S.runState!==f.runState){const w=(c=f.runState)!==null&&c!==void 0?c:A.NotebookCellExecutionState.Idle;this._emitter.emitCellExecutionStateChange(R.deepFreeze({document:this.apiNotebook,cell:u.apiCell,state:w}))}}getCellFromApiCell(l){return this._cells.find(f=>f.apiCell===l)}getCellFromIndex(l){return this._cells[l]}getCell(l){return this._cells.find(f=>f.handle===l)}getCellIndex(l){return this._cells.indexOf(l)}}e.ExtHostNotebookDocument=r,r._handlePool=0}),define(me[123],ge([0,1,7,17,14]),function(X,e,p,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookEditor=void 0;class y{constructor(E){this._finalized=!1,this._collectedEdits=[],this._documentVersionId=E}finalize(){return this._finalized=!0,{documentVersionId:this._documentVersionId,cellEdits:this._collectedEdits}}_throwIfFinalized(){if(this._finalized)throw new Error("Edit is only valid while callback runs")}replaceMetadata(E){this._throwIfFinalized(),this._collectedEdits.push({editType:5,metadata:E})}replaceCellMetadata(E,k){this._throwIfFinalized(),this._collectedEdits.push({editType:8,index:E,metadata:k})}replaceCells(E,k,r){this._throwIfFinalized(),!(E===k&&r.length===0)&&this._collectedEdits.push({editType:1,index:E,count:k-E,cells:r.map(R.NotebookCellData.from)})}}class A{constructor(E,k,r,I,l,f){this.id=E,this._proxy=k,this.notebookData=r,this._selections=[],this._visibleRanges=[],this._visible=!1,this._hasDecorationsForKey=new Set,this._selections=l,this._visibleRanges=I,this._viewColumn=f}get apiEditor(){if(!this._editor){const E=this;this._editor={get document(){return E.notebookData.apiNotebook},get selections(){return E._selections},set selections(k){if(!Array.isArray(k)||!k.every(p.NotebookRange.isNotebookRange))throw C.illegalArgument("selections");E._selections=k,E._trySetSelections(k)},get visibleRanges(){return E._visibleRanges},revealRange(k,r){E._proxy.$tryRevealRange(E.id,R.NotebookRange.from(k),r??p.NotebookEditorRevealType.Default)},get viewColumn(){return E._viewColumn},edit(k){const r=new y(this.document.version);return k(r),E._applyEdit(r.finalize())},setDecorations(k,r){return E.setDecorations(k,r)}},A.apiEditorsToExtHost.set(this._editor,this)}return this._editor}get visible(){return this._visible}_acceptVisibility(E){this._visible=E}_acceptVisibleRanges(E){this._visibleRanges=E}_acceptSelections(E){this._selections=E}_trySetSelections(E){this._proxy.$trySetSelections(this.id,E.map(R.NotebookRange.from))}_acceptViewColumn(E){this._viewColumn=E}_applyEdit(E){if(E.cellEdits.length===0)return Promise.resolve(!0);const k=[];let r=-1;for(let I=0;I<E.cellEdits.length;I++){if(r<0){k.push(E.cellEdits[I]),r++;continue}const f=k[r],c=E.cellEdits[I];if(f.editType===1&&c.editType===1&&f.index===c.index){f.cells.push(...E.cellEdits[I].cells),f.count+=E.cellEdits[I].count;continue}k.push(E.cellEdits[I]),r++}return this._proxy.$tryApplyEdits(this.id,E.documentVersionId,k)}setDecorations(E,k){if(!(k.isEmpty&&!this._hasDecorationsForKey.has(E.key)))return k.isEmpty?this._hasDecorationsForKey.delete(E.key):this._hasDecorationsForKey.add(E.key),this._proxy.$trySetDecorations(this.id,R.NotebookRange.from(k),E.key)}}e.ExtHostNotebookEditor=A,A.apiEditorsToExtHost=new WeakMap}),define(me[209],ge([0,1,17,114,160,21,51]),function(X,e,p,R,C,y,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostProgress=void 0;class P{constructor(I){this._handles=0,this._mapHandleToCancellationSource=new Map,this._proxy=I}withProgress(I,l,f){const c=this._handles++,{title:u,location:S,cancellable:w}=l,b={label:C.localize(0,null,I.displayName||I.name),id:I.identifier.value};return this._proxy.$startProgress(c,{location:p.ProgressLocation.from(S),title:u,source:b,cancellable:w},I),this._withProgress(c,f,!!w)}_withProgress(I,l,f){let c;f&&(c=new y.CancellationTokenSource,this._mapHandleToCancellationSource.set(I,c));const u=w=>{this._proxy.$progressEnd(w),this._mapHandleToCancellationSource.delete(w),c&&c.dispose()};let S;try{S=l(new k(this._proxy,I),f&&c?c.token:y.CancellationToken.None)}catch(w){throw u(I),w}return S.then(w=>u(I),w=>u(I)),S}$acceptProgressCanceled(I){const l=this._mapHandleToCancellationSource.get(I);l&&(l.cancel(),this._mapHandleToCancellationSource.delete(I))}}e.ExtHostProgress=P;function E(r,I){return r.message=I.message,typeof I.increment=="number"&&(typeof r.increment=="number"?r.increment+=I.increment:r.increment=I.increment),r}class k extends R.Progress{constructor(I,l){super(f=>this.throttledReport(f));this._proxy=I,this._handle=l}throttledReport(I){this._proxy.$progressReport(this._handle,I)}}Ve([A.throttle(100,(r,I)=>E(r,I),()=>Object.create(null))],k.prototype,"throttledReport",null)}),define(me[124],ge([0,1,50,14,70,17,7]),function(X,e,p,R,C,y,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTextEditor=e.ExtHostTextEditorOptions=e.TextEditorEdit=e.TextEditorDecorationType=void 0;class P{constructor(l,f,c){const u=P._Keys.nextId();l.$registerTextEditorDecorationType(f.identifier,u,y.DecorationRenderOptions.from(c)),this.value=Object.freeze({key:u,dispose(){l.$removeTextEditorDecorationType(u)}})}}e.TextEditorDecorationType=P,P._Keys=new C.IdGenerator("TextEditorDecorationType");class E{constructor(l,f){this._collectedEdits=[],this._setEndOfLine=void 0,this._finalized=!1,this._document=l,this._documentVersionId=l.version,this._undoStopBefore=f.undoStopBefore,this._undoStopAfter=f.undoStopAfter}finalize(){return this._finalized=!0,{documentVersionId:this._documentVersionId,edits:this._collectedEdits,setEndOfLine:this._setEndOfLine,undoStopBefore:this._undoStopBefore,undoStopAfter:this._undoStopAfter}}_throwIfFinalized(){if(this._finalized)throw new Error("Edit is only valid while callback runs")}replace(l,f){this._throwIfFinalized();let c=null;if(l instanceof A.Position)c=new A.Range(l,l);else if(l instanceof A.Range)c=l;else throw new Error("Unrecognized location");this._pushEdit(c,f,!1)}insert(l,f){this._throwIfFinalized(),this._pushEdit(new A.Range(l,l),f,!0)}delete(l){this._throwIfFinalized();let f=null;if(l instanceof A.Range)f=l;else throw new Error("Unrecognized location");this._pushEdit(f,null,!0)}_pushEdit(l,f,c){const u=this._document.validateRange(l);this._collectedEdits.push({range:u,text:f,forceMoveMarkers:c})}setEndOfLine(l){if(this._throwIfFinalized(),l!==A.EndOfLine.LF&&l!==A.EndOfLine.CRLF)throw R.illegalArgument("endOfLine");this._setEndOfLine=l}}e.TextEditorEdit=E;class k{constructor(l,f,c,u){this._proxy=l,this._id=f,this._accept(c),this._logService=u;const S=this;this.value={get tabSize(){return S._tabSize},set tabSize(w){S._setTabSize(w)},get insertSpaces(){return S._insertSpaces},set insertSpaces(w){S._setInsertSpaces(w)},get cursorStyle(){return S._cursorStyle},set cursorStyle(w){S._setCursorStyle(w)},get lineNumbers(){return S._lineNumbers},set lineNumbers(w){S._setLineNumbers(w)}}}_accept(l){this._tabSize=l.tabSize,this._insertSpaces=l.insertSpaces,this._cursorStyle=l.cursorStyle,this._lineNumbers=y.TextEditorLineNumbersStyle.to(l.lineNumbers)}_validateTabSize(l){if(l==="auto")return"auto";if(typeof l=="number"){const f=Math.floor(l);return f>0?f:null}if(typeof l=="string"){const f=parseInt(l,10);return isNaN(f)?null:f>0?f:null}return null}_setTabSize(l){const f=this._validateTabSize(l);if(f!==null){if(typeof f=="number"){if(this._tabSize===f)return;this._tabSize=f}this._warnOnError(this._proxy.$trySetOptions(this._id,{tabSize:f}))}}_validateInsertSpaces(l){return l==="auto"?"auto":l==="false"?!1:Boolean(l)}_setInsertSpaces(l){const f=this._validateInsertSpaces(l);if(typeof f=="boolean"){if(this._insertSpaces===f)return;this._insertSpaces=f}this._warnOnError(this._proxy.$trySetOptions(this._id,{insertSpaces:f}))}_setCursorStyle(l){this._cursorStyle!==l&&(this._cursorStyle=l,this._warnOnError(this._proxy.$trySetOptions(this._id,{cursorStyle:l})))}_setLineNumbers(l){this._lineNumbers!==l&&(this._lineNumbers=l,this._warnOnError(this._proxy.$trySetOptions(this._id,{lineNumbers:y.TextEditorLineNumbersStyle.from(l)})))}assign(l){const f={};let c=!1;if(typeof l.tabSize!="undefined"){const u=this._validateTabSize(l.tabSize);u==="auto"?(c=!0,f.tabSize=u):typeof u=="number"&&this._tabSize!==u&&(this._tabSize=u,c=!0,f.tabSize=u)}if(typeof l.insertSpaces!="undefined"){const u=this._validateInsertSpaces(l.insertSpaces);u==="auto"?(c=!0,f.insertSpaces=u):this._insertSpaces!==u&&(this._insertSpaces=u,c=!0,f.insertSpaces=u)}typeof l.cursorStyle!="undefined"&&this._cursorStyle!==l.cursorStyle&&(this._cursorStyle=l.cursorStyle,c=!0,f.cursorStyle=l.cursorStyle),typeof l.lineNumbers!="undefined"&&this._lineNumbers!==l.lineNumbers&&(this._lineNumbers=l.lineNumbers,c=!0,f.lineNumbers=y.TextEditorLineNumbersStyle.from(l.lineNumbers)),c&&this._warnOnError(this._proxy.$trySetOptions(this._id,f))}_warnOnError(l){l.catch(f=>this._logService.warn(f))}}e.ExtHostTextEditorOptions=k;class r{constructor(l,f,c,u,S,w,b,d){this.id=l,this._proxy=f,this._logService=c,this._disposed=!1,this._hasDecorationsForKey=new Set,this._selections=S,this._options=new k(this._proxy,this.id,w,c),this._visibleRanges=b,this._viewColumn=d;const h=this;this.value=Object.freeze({get document(){return u.getValue()},set document(g){throw R.readonly("document")},get selection(){return h._selections&&h._selections[0]},set selection(g){if(!(g instanceof A.Selection))throw R.illegalArgument("selection");h._selections=[g],h._trySetSelection()},get selections(){return h._selections},set selections(g){if(!Array.isArray(g)||g.some(t=>!(t instanceof A.Selection)))throw R.illegalArgument("selections");h._selections=g,h._trySetSelection()},get visibleRanges(){return h._visibleRanges},set visibleRanges(g){throw R.readonly("visibleRanges")},get options(){return h._options.value},set options(g){h._disposed||h._options.assign(g)},get viewColumn(){return h._viewColumn},set viewColumn(g){throw R.readonly("viewColumn")},edit(g,t={undoStopBefore:!0,undoStopAfter:!0}){if(h._disposed)return Promise.reject(new Error("TextEditor#edit not possible on closed editors"));const i=new E(u.getValue(),t);return g(i),h._applyEdit(i)},insertSnippet(g,t,i={undoStopBefore:!0,undoStopAfter:!0}){if(h._disposed)return Promise.reject(new Error("TextEditor#insertSnippet not possible on closed editors"));let s;if(!t||Array.isArray(t)&&t.length===0)s=h._selections.map(n=>y.Range.from(n));else if(t instanceof A.Position){const{lineNumber:n,column:o}=y.Position.from(t);s=[{startLineNumber:n,startColumn:o,endLineNumber:n,endColumn:o}]}else if(t instanceof A.Range)s=[y.Range.from(t)];else{s=[];for(const n of t)if(n instanceof A.Range)s.push(y.Range.from(n));else{const{lineNumber:o,column:v}=y.Position.from(n);s.push({startLineNumber:o,startColumn:v,endLineNumber:o,endColumn:v})}}return f.$tryInsertSnippet(l,g.value,s,i)},setDecorations(g,t){const i=t.length===0;i&&!h._hasDecorationsForKey.has(g.key)||(i?h._hasDecorationsForKey.delete(g.key):h._hasDecorationsForKey.add(g.key),h._runOnProxy(()=>{if(y.isDecorationOptionsArr(t))return f.$trySetDecorations(l,g.key,y.fromRangeOrRangeWithMessage(t));{const s=new Array(4*t.length);for(let n=0,o=t.length;n<o;n++){const v=t[n];s[4*n]=v.start.line+1,s[4*n+1]=v.start.character+1,s[4*n+2]=v.end.line+1,s[4*n+3]=v.end.character+1}return f.$trySetDecorationsFast(l,g.key,s)}}))},revealRange(g,t){h._runOnProxy(()=>f.$tryRevealRange(l,y.Range.from(g),t||A.TextEditorRevealType.Default))},show(g){f.$tryShowEditor(l,y.ViewColumn.from(g))},hide(){f.$tryHideEditor(l)}})}dispose(){p.ok(!this._disposed),this._disposed=!0}_acceptOptions(l){p.ok(!this._disposed),this._options._accept(l)}_acceptVisibleRanges(l){p.ok(!this._disposed),this._visibleRanges=l}_acceptViewColumn(l){p.ok(!this._disposed),this._viewColumn=l}_acceptSelections(l){p.ok(!this._disposed),this._selections=l}async _trySetSelection(){const l=this._selections.map(y.Selection.from);return await this._runOnProxy(()=>this._proxy.$trySetSelections(this.id,l)),this.value}_applyEdit(l){const f=l.finalize();if(f.edits.length===0&&!f.setEndOfLine)return Promise.resolve(!0);const c=f.edits.map(S=>S.range);c.sort((S,w)=>S.end.line===w.end.line?S.end.character===w.end.character?S.start.line===w.start.line?S.start.character-w.start.character:S.start.line-w.start.line:S.end.character-w.end.character:S.end.line-w.end.line);for(let S=0,w=c.length-1;S<w;S++){const b=c[S].end;if(c[S+1].start.isBefore(b))return Promise.reject(new Error("Overlapping ranges are not allowed!"))}const u=f.edits.map(S=>({range:y.Range.from(S.range),text:S.text,forceMoveMarkers:S.forceMoveMarkers}));return this._proxy.$tryApplyEdits(this.id,f.documentVersionId,u,{setEndOfLine:typeof f.setEndOfLine=="number"?y.EndOfLine.from(f.setEndOfLine):void 0,undoStopBefore:f.undoStopBefore,undoStopAfter:f.undoStopAfter})}_runOnProxy(l){return this._disposed?(this._logService.warn("TextEditor is closed/disposed"),Promise.resolve(void 0)):l().then(()=>this,f=>(f instanceof Error&&f.name==="DISPOSED"||this._logService.warn(f),null))}}e.ExtHostTextEditor=r}),define(me[210],ge([0,1,163,24,2,3,6,16,7,15,18,17,21]),function(X,e,p,R,C,y,A,P,E,k,r,I,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTreeViews=void 0;function f(S,w){if(k.isString(S))return{label:S};if(S&&typeof S=="object"&&typeof S.label=="string"){let b;return Array.isArray(S.highlights)&&(b=S.highlights.filter(d=>d.length===2&&typeof d[0]=="number"&&typeof d[1]=="number"),b=b.length?b:void 0),{label:S.label,highlights:b}}}class c{constructor(w,b,d){this._proxy=w,this.commands=b,this.logService=d,this.treeViews=new Map;function h(g){return g&&g.$treeViewId&&g.$treeItemHandle}b.registerArgumentProcessor({processArgument:g=>h(g)?this.convertArgument(g):Array.isArray(g)&&g.length>0?g.map(t=>h(t)?this.convertArgument(t):t):g})}registerTreeDataProvider(w,b,d){const h=this.createTreeView(w,{treeDataProvider:b},d);return{dispose:()=>h.dispose()}}createTreeView(w,b,d){if(!b||!b.treeDataProvider)throw new Error("Options with treeDataProvider is mandatory");const h=b.dragAndDropController!==void 0,g=this._proxy.$registerTreeViewDataProvider(w,{showCollapseAll:!!b.showCollapseAll,canSelectMany:!!b.canSelectMany,canDragAndDrop:h}),t=this.createExtHostTreeView(w,b,d);return{get onDidCollapseElement(){return t.onDidCollapseElement},get onDidExpandElement(){return t.onDidExpandElement},get selection(){return t.selectedElements},get onDidChangeSelection(){return t.onDidChangeSelection},get visible(){return t.visible},get onDidChangeVisibility(){return t.onDidChangeVisibility},get message(){return t.message},set message(i){t.message=i},get title(){return t.title},set title(i){t.title=i},get description(){return t.description},set description(i){t.description=i},reveal:(i,s)=>t.reveal(i,s),dispose:async()=>{await g,this.treeViews.delete(w),t.dispose()}}}$getChildren(w,b){const d=this.treeViews.get(w);return d?d.getChildren(b):Promise.reject(new Error(p.localize(0,null,w)))}$onDrop(w,b,d){const h=this.treeViews.get(w);return h?h.onDrop(b,d):Promise.reject(new Error(p.localize(1,null,w)))}async $hasResolve(w){const b=this.treeViews.get(w);if(!b)throw new Error(p.localize(2,null,w));return b.hasResolve}$resolve(w,b,d){const h=this.treeViews.get(w);if(!h)throw new Error(p.localize(3,null,w));return h.resolveTreeItem(b,d)}$setExpanded(w,b,d){const h=this.treeViews.get(w);if(!h)throw new Error(p.localize(4,null,w));h.setExpanded(b,d)}$setSelection(w,b){const d=this.treeViews.get(w);if(!d)throw new Error(p.localize(5,null,w));d.setSelection(b)}$setVisible(w,b){const d=this.treeViews.get(w);if(!d)throw new Error(p.localize(6,null,w));d.setVisible(b)}createExtHostTreeView(w,b,d){const h=new u(w,b,this._proxy,this.commands.converter,this.logService,d);return this.treeViews.set(w,h),h}convertArgument(w){const b=this.treeViews.get(w.$treeViewId);return b?b.getExtensionElement(w.$treeItemHandle):null}}e.ExtHostTreeViews=c;class u extends A.Disposable{constructor(w,b,d,h,g,t){super();if(this.viewId=w,this.proxy=d,this.commands=h,this.logService=g,this.extension=t,this.roots=null,this.elements=new Map,this.nodes=new Map,this._visible=!1,this._selectedHandles=[],this._onDidExpandElement=this._register(new y.Emitter),this.onDidExpandElement=this._onDidExpandElement.event,this._onDidCollapseElement=this._register(new y.Emitter),this.onDidCollapseElement=this._onDidCollapseElement.event,this._onDidChangeSelection=this._register(new y.Emitter),this.onDidChangeSelection=this._onDidChangeSelection.event,this._onDidChangeVisibility=this._register(new y.Emitter),this.onDidChangeVisibility=this._onDidChangeVisibility.event,this._onDidChangeData=this._register(new y.Emitter),this.refreshPromise=Promise.resolve(),this.refreshQueue=Promise.resolve(),this._message="",this._title="",this._refreshCancellationSource=new l.CancellationTokenSource,t.contributes&&t.contributes.views)for(const n in t.contributes.views)for(const o of t.contributes.views[n])o.id===w&&(this._title=o.name);this.dataProvider=b.treeDataProvider,this.dndController=b.dragAndDropController,this.dataProvider.onDidChangeTreeData2?this._register(this.dataProvider.onDidChangeTreeData2(n=>this._onDidChangeData.fire({message:!1,element:n}))):this.dataProvider.onDidChangeTreeData&&this._register(this.dataProvider.onDidChangeTreeData(n=>this._onDidChangeData.fire({message:!1,element:n})));let i,s;this._register(y.Event.debounce(this._onDidChangeData.event,(n,o)=>(n||(n={message:!1,elements:[]}),o.element!==!1&&(i||(i=new Promise(v=>s=v),this.refreshPromise=this.refreshPromise.then(()=>i)),Array.isArray(o.element)?n.elements.push(...o.element):n.elements.push(o.element)),o.message&&(n.message=!0),n),200,!0)(({message:n,elements:o})=>{o.length&&(this.refreshQueue=this.refreshQueue.then(()=>{const v=s;return i=null,this.refresh(o).then(()=>v())})),n&&this.proxy.$setMessage(this.viewId,this._message)}))}get visible(){return this._visible}get selectedElements(){return this._selectedHandles.map(w=>this.getExtensionElement(w)).filter(w=>!k.isUndefinedOrNull(w))}getChildren(w){const b=w?this.getExtensionElement(w):void 0;if(w&&!b)return this.logService.error(`No tree item with id '${w}' found.`),Promise.resolve([]);const d=this.getChildrenNodes(w);return(d?Promise.resolve(d):this.fetchChildrenNodes(b)).then(h=>h.map(g=>g.item))}getExtensionElement(w){return this.elements.get(w)}reveal(w,b){b=b||{select:!0,focus:!1};const d=k.isUndefinedOrNull(b.select)?!0:b.select,h=k.isUndefinedOrNull(b.focus)?!1:b.focus,g=k.isUndefinedOrNull(b.expand)?!1:b.expand;return typeof this.dataProvider.getParent!="function"?Promise.reject(new Error("Required registered TreeDataProvider to implement 'getParent' method to access 'reveal' method")):w?this.refreshPromise.then(()=>this.resolveUnknownParentChain(w)).then(t=>this.resolveTreeNode(w,t[t.length-1]).then(i=>this.proxy.$reveal(this.viewId,{item:i.item,parentChain:t.map(s=>s.item)},{select:d,focus:h,expand:g})),t=>this.logService.error(t)):this.proxy.$reveal(this.viewId,void 0,{select:d,focus:h,expand:g})}get message(){return this._message}set message(w){this._message=w,this._onDidChangeData.fire({message:!0,element:!1})}get title(){return this._title}set title(w){this._title=w,this.proxy.$setTitle(this.viewId,w,this._description)}get description(){return this._description}set description(w){this._description=w,this.proxy.$setTitle(this.viewId,this._title,w)}setExpanded(w,b){const d=this.getExtensionElement(w);d&&(b?this._onDidExpandElement.fire(Object.freeze({element:d})):this._onDidCollapseElement.fire(Object.freeze({element:d})))}setSelection(w){r.equals(this._selectedHandles,w)||(this._selectedHandles=w,this._onDidChangeSelection.fire(Object.freeze({selection:this.selectedElements})))}setVisible(w){w!==this._visible&&(this._visible=w,this._onDidChangeVisibility.fire(Object.freeze({visible:this._visible})))}onDrop(w,b){const d=w.map(g=>this.getExtensionElement(g)).filter(g=>!k.isUndefinedOrNull(g)),h=this.getExtensionElement(b);return d&&h?P.asPromise(()=>{var g;return(g=this.dndController)===null||g===void 0?void 0:g.onDrop(d,h)}):Promise.resolve(void 0)}get hasResolve(){return!!this.dataProvider.resolveTreeItem}async resolveTreeItem(w,b){var d;if(!this.dataProvider.resolveTreeItem)return;const h=this.elements.get(w);if(h){const g=this.nodes.get(h);if(g){const t=(d=await this.dataProvider.resolveTreeItem(g.extensionItem,h,b))!==null&&d!==void 0?d:g.extensionItem;return g.item.tooltip=this.getTooltip(t.tooltip),g.item.command=this.getCommand(g.disposableStore,t.command),g.item}}}resolveUnknownParentChain(w){return this.resolveParent(w).then(b=>b?this.resolveUnknownParentChain(b).then(d=>this.resolveTreeNode(b,d[d.length-1]).then(h=>(d.push(h),d))):Promise.resolve([]))}resolveParent(w){const b=this.nodes.get(w);return b?Promise.resolve(b.parent?this.elements.get(b.parent.item.handle):void 0):P.asPromise(()=>this.dataProvider.getParent(w))}resolveTreeNode(w,b){const d=this.nodes.get(w);return d?Promise.resolve(d):P.asPromise(()=>this.dataProvider.getTreeItem(w)).then(h=>this.createHandle(w,h,b,!0)).then(h=>this.getChildren(b?b.item.handle:void 0).then(()=>{const g=this.getExtensionElement(h);if(g){const t=this.nodes.get(g);if(t)return Promise.resolve(t)}throw new Error(`Cannot resolve tree item for element ${h}`)}))}getChildrenNodes(w){if(w){let b;if(typeof w=="string"){const d=this.getExtensionElement(w);b=d?this.nodes.get(d):void 0}else b=w;return b&&b.children||null}return this.roots}async fetchChildrenNodes(w){this.clearChildren(w);const b=new l.CancellationTokenSource(this._refreshCancellationSource.token);try{const d=w?this.nodes.get(w):void 0,h=await this.dataProvider.getChildren(w);if(b.token.isCancellationRequested)return[];const g=await Promise.all(r.coalesce(h||[]).map(async t=>{const i=await this.dataProvider.getTreeItem(t);return i&&!b.token.isCancellationRequested?this.createAndRegisterTreeNode(t,i,d):null}));return b.token.isCancellationRequested?[]:r.coalesce(g)}finally{b.dispose()}}refresh(w){if(w.some(d=>!d))return this._refreshCancellationSource.dispose(!0),this._refreshCancellationSource=new l.CancellationTokenSource,this.clearAll(),this.proxy.$refresh(this.viewId);{const d=this.getHandlesToRefresh(w);if(d.length)return this.refreshHandles(d)}return Promise.resolve(void 0)}getHandlesToRefresh(w){const b=new Set,d=w.map(g=>this.nodes.get(g));for(const g of d)if(g&&!b.has(g.item.handle)){let t=g;for(;t&&t.parent&&d.findIndex(i=>t&&t.parent&&i&&i.item.handle===t.parent.item.handle)===-1;){const i=this.elements.get(t.parent.item.handle);t=i?this.nodes.get(i):void 0}t&&!t.parent&&b.add(g.item.handle)}const h=[];return b.forEach(g=>{const t=this.elements.get(g);if(t){const i=this.nodes.get(t);i&&(!i.parent||!b.has(i.parent.item.handle))&&h.push(g)}}),h}refreshHandles(w){const b={};return Promise.all(w.map(d=>this.refreshNode(d).then(h=>{h&&(b[d]=h.item)}))).then(()=>Object.keys(b).length?this.proxy.$refresh(this.viewId,b):void 0)}refreshNode(w){const b=this.getExtensionElement(w);if(b){const d=this.nodes.get(b);if(d)return this.clearChildren(b),P.asPromise(()=>this.dataProvider.getTreeItem(b)).then(h=>{if(h){const g=this.createTreeNode(b,h,d.parent);return this.updateNodeCache(b,g,d,d.parent),d.dispose(),g}return null})}return Promise.resolve(null)}createAndRegisterTreeNode(w,b,d){const h=this.createTreeNode(w,b,d);if(b.id&&this.elements.has(h.item.handle))throw new Error(p.localize(7,null,b.id));return this.addNodeToCache(w,h),this.addNodeToParentCache(h,d),h}getTooltip(w){return E.MarkdownString.isMarkdownString(w)?I.MarkdownString.from(w):w}getCommand(w,b){return b?this.commands.toInternal(b,w):void 0}createTreeNode(w,b,d){const h=new A.DisposableStore,g=this.createHandle(w,b,d),t=this.getLightIconPath(b);return{item:{handle:g,parentHandle:d?d.item.handle:void 0,label:f(b.label,this.extension),description:b.description,resourceUri:b.resourceUri,tooltip:this.getTooltip(b.tooltip),command:this.getCommand(h,b.command),contextValue:b.contextValue,icon:t,iconDark:this.getDarkIconPath(b)||t,themeIcon:this.getThemeIcon(b),collapsibleState:k.isUndefinedOrNull(b.collapsibleState)?E.TreeItemCollapsibleState.None:b.collapsibleState,accessibilityInformation:b.accessibilityInformation},extensionItem:b,parent:d,children:void 0,disposableStore:h,dispose(){h.dispose()}}}getThemeIcon(w){return w.iconPath instanceof E.ThemeIcon?w.iconPath:void 0}createHandle(w,{id:b,label:d,resourceUri:h},g,t){if(b)return`${u.ID_HANDLE_PREFIX}/${b}`;const i=f(d,this.extension),s=g?g.item.handle:u.LABEL_HANDLE_PREFIX;let n=i?i.label:h?R.basename(h):"";n=n.indexOf("/")!==-1?n.replace("/","//"):n;const o=this.nodes.has(w)?this.nodes.get(w).item.handle:void 0,v=this.getChildrenNodes(g)||[];let m,_=0;do{if(m=`${s}/${_}:${n}`,t||!this.elements.has(m)||o===m)break;_++}while(_<=v.length);return m}getLightIconPath(w){if(w.iconPath&&!(w.iconPath instanceof E.ThemeIcon))return typeof w.iconPath=="string"||C.URI.isUri(w.iconPath)?this.getIconPath(w.iconPath):this.getIconPath(w.iconPath.light)}getDarkIconPath(w){if(w.iconPath&&!(w.iconPath instanceof E.ThemeIcon)&&w.iconPath.dark)return this.getIconPath(w.iconPath.dark)}getIconPath(w){return C.URI.isUri(w)?w:C.URI.file(w)}addNodeToCache(w,b){this.elements.set(b.item.handle,w),this.nodes.set(w,b)}updateNodeCache(w,b,d,h){this.elements.delete(b.item.handle),this.nodes.delete(w),b.item.handle!==d.item.handle&&this.elements.delete(d.item.handle),this.addNodeToCache(w,b);const g=this.getChildrenNodes(h)||[],t=g.filter(i=>i.item.handle===d.item.handle)[0];t&&g.splice(g.indexOf(t),1,b)}addNodeToParentCache(w,b){b?(b.children||(b.children=[]),b.children.push(w)):(this.roots||(this.roots=[]),this.roots.push(w))}clearChildren(w){if(w){const b=this.nodes.get(w);if(b){if(b.children)for(const d of b.children){const h=this.elements.get(d.item.handle);h&&this.clear(h)}b.children=void 0}}else this.clearAll()}clear(w){const b=this.nodes.get(w);if(b){if(b.children)for(const d of b.children){const h=this.elements.get(d.item.handle);h&&this.clear(h)}this.nodes.delete(w),this.elements.delete(b.item.handle),b.dispose()}}clearAll(){this.roots=null,this.elements.clear(),this.nodes.forEach(w=>w.dispose()),this.nodes.clear()}dispose(){this._refreshCancellationSource.dispose(),this.clearAll()}}u.LABEL_HANDLE_PREFIX="0",u.ID_HANDLE_PREFIX="1"}),define(me[211],ge([0,1,16,3,52,6,15,118,17,7,122]),function(X,e,p,R,C,y,A,P,E,k,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SingleUseTestCollection=e.TestTree=e.TestPosition=void 0;var I;(function(c){c[c.Disconnected=0]="Disconnected",c[c.IsChild=1]="IsChild",c[c.IsParent=2]="IsParent",c[c.IsSame=3]="IsSame"})(I=e.TestPosition||(e.TestPosition={}));class l{constructor(){this.map=new Map,this._roots=new Set,this.roots=this._roots}get size(){return this.map.size}add(u){if(this.map.has(u.item.extId))throw new Error(`Attempted to insert a duplicate test item ID ${u.item.extId}`);this.map.set(u.item.extId,u),u.parent||this._roots.add(u)}has(u){return this.map.has(u)}delete(u){const S=this.map.get(u);return S?(this.map.delete(u),this._roots.delete(S),!0):!1}get(u){return this.map.get(u)}comparePositions(u,S){const w=typeof u=="string"?this.map.get(u):u,b=typeof S=="string"?this.map.get(S):S;if(!w||!b)return 0;if(w===b)return 3;for(let d=this.map.get(b.parent);d;d=this.map.get(d.parent))if(d===w)return 1;for(let d=this.map.get(w.parent);d;d=this.map.get(d.parent))if(d===b)return 2;return 0}[Symbol.iterator](){return this.map.values()}}e.TestTree=l;class f extends y.Disposable{constructor(u){super();this.controllerId=u,this.testItemToInternal=new Map,this.debounceSendDiff=this._register(new p.RunOnceScheduler(()=>this.flushDiff(),200)),this.diffOpEmitter=this._register(new R.Emitter),this.root=new k.TestItemImpl(`${this.controllerId}Root`,this.controllerId,void 0,void 0,void 0),this.tree=new l,this.diff=[],this.onDidGenerateDiff=this.diffOpEmitter.event,this.addItemInner(this.root,null)}set resolveHandler(u){this._resolveHandler=u;for(const S of this.testItemToInternal.values())this.updateExpandability(S)}get roots(){return C.Iterable.filter(this.testItemToInternal.values(),u=>u.parent===null)}getTestByReference(u){return this.testItemToInternal.get(u)}collectDiff(){const u=this.diff;return this.diff=[],u}pushDiff(u){const S=this.diff[this.diff.length-1];if(S&&u[0]===1){if(S[0]===1&&S[1].extId===u[1].extId){r.applyTestItemUpdate(S[1],u[1]);return}if(S[0]===0&&S[1].item.extId===u[1].extId){r.applyTestItemUpdate(S[1],u[1]);return}}this.diff.push(u),this.debounceSendDiff.isScheduled()||this.debounceSendDiff.schedule()}expand(u,S){var w;const b=this.tree.get(u);if(!!b){if((b.expandLevels===void 0||S>b.expandLevels)&&(b.expandLevels=S),b.expand===1){const d=this.resolveChildren(b);return d.isOpen()?this.expandChildren(b,S-1):d.wait().then(()=>this.expandChildren(b,S-1))}else if(b.expand===3)return((w=b.resolveBarrier)===null||w===void 0?void 0:w.isOpen())===!1?b.resolveBarrier.wait().then(()=>this.expandChildren(b,S-1)):this.expandChildren(b,S-1)}}dispose(){for(const u of this.testItemToInternal.values())P.getPrivateApiFor(u.actual).bus.dispose();this.diff=[],super.dispose()}onTestItemEvent(u,S){const w=u==null?void 0:u.actual.id;switch(S[0]){case 2:this.pushDiff([4,w]);break;case 1:this.removeItem(u);break;case 0:this.addItemInner(S[1],u);break;case 3:const[b,d,h]=S;switch(d){case"canResolveChildren":this.updateExpandability(u);break;case"range":this.pushDiff([1,{extId:w,item:{range:E.Range.from(h)}}]);break;case"error":this.pushDiff([1,{extId:w,item:{error:E.MarkdownString.fromStrict(h)||null}}]);break;default:this.pushDiff([1,{extId:w,item:{[d]:h??null}}]);break}break;default:A.assertNever(S[0])}}addItemInner(u,S){if(!(u instanceof k.TestItemImpl))throw new Error(`TestItems provided to the VS Code API must extend \`vscode.TestItem\`, but ${u.id} did not`);if(this.testItemToInternal.has(u))throw new Error(`Attempted to add a single TestItem ${u.id} multiple times to the tree`);if(this.tree.has(u.id))throw new Error(`Attempted to insert a duplicate test item ID ${u.id}`);const w=S?S.item.extId:null,b=S?S.expandLevels:1,d={actual:u,parent:w,item:E.TestItem.from(u),expandLevels:b?b-1:void 0,expand:0,controllerId:this.controllerId};this.tree.add(d),this.testItemToInternal.set(u,d),this.pushDiff([0,{parent:w,controllerId:this.controllerId,expand:d.expand,item:d.item}]);const h=P.getPrivateApiFor(u);h.bus.event(this.onTestItemEvent.bind(this,d)),this.updateExpandability(d);for(const g of h.children.values())this.testItemToInternal.has(g)||this.addItemInner(g,d)}updateExpandability(u){let S;this._resolveHandler?u.resolveBarrier?S=u.resolveBarrier.isOpen()?3:2:S=u.actual.canResolveChildren?1:0:S=0,S!==u.expand&&(u.expand=S,this.pushDiff([1,{extId:u.actual.id,expand:S}]),S===1&&u.expandLevels!==void 0&&this.resolveChildren(u))}expandChildren(u,S){if(S<0)return;const w=[...u.actual.children.values()].map(b=>this.expand(b.id,S)).filter(p.isThenable);if(w.length)return Promise.all(w).then(()=>{})}resolveChildren(u){if(u.resolveBarrier)return u.resolveBarrier;if(!this._resolveHandler){const b=new p.Barrier;return b.open(),b}u.expand=2,this.pushExpandStateUpdate(u);const S=u.resolveBarrier=new p.Barrier;let w;try{w=this._resolveHandler(u.actual)}catch(b){u.actual.error=b.stack||b.message}return p.isThenable(w)?w.catch(b=>u.actual.error=b.stack||b.message).then(()=>{S.open(),this.updateExpandability(u)}):(S.open(),this.updateExpandability(u)),u.resolveBarrier}pushExpandStateUpdate(u){this.pushDiff([1,{extId:u.actual.id,expand:u.expand}])}removeItem(u){this.pushDiff([2,u.actual.id]);const S=[u];for(;S.length;){const w=S.pop();if(!!w){this.tree.delete(w.item.extId),this.testItemToInternal.delete(w.actual);for(const b of w.actual.children.values())S.push(this.tree.get(b.id))}}}flushDiff(){const u=this.collectDiff();u.length&&this.diffOpEmitter.fire(u)}}e.SingleUseTestCollection=f}),define(me[212],ge([0,1,4,176]),function(X,e,p,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IWorkbenchEnvironmentService=void 0,e.IWorkbenchEnvironmentService=p.refineServiceDecorator(R.IEnvironmentService)}),define(me[213],ge([0,1,26,3,9]),function(X,e,p,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionDescriptionRegistry=e.DeltaExtensionsResult=void 0;class y{constructor(r){this.removedDueToLooping=r}}e.DeltaExtensionsResult=y;class A{constructor(r){this._onDidChange=new R.Emitter,this.onDidChange=this._onDidChange.event,this._extensionDescriptions=r,this._initialize()}_initialize(){this._extensionDescriptions.sort(E),this._extensionsMap=new Map,this._extensionsArr=[],this._activationMap=new Map;for(const r of this._extensionDescriptions){if(this._extensionsMap.has(p.ExtensionIdentifier.toKey(r.identifier))){console.error("Extension `"+r.identifier.value+"` is already registered");continue}if(this._extensionsMap.set(p.ExtensionIdentifier.toKey(r.identifier),r),this._extensionsArr.push(r),Array.isArray(r.activationEvents))for(let I of r.activationEvents)I==="onUri"&&(I=`onUri:${p.ExtensionIdentifier.toKey(r.identifier)}`),this._activationMap.has(I)||this._activationMap.set(I,[]),this._activationMap.get(I).push(r)}}keepOnly(r){const I=new Set;r.forEach(l=>I.add(p.ExtensionIdentifier.toKey(l))),this._extensionDescriptions=this._extensionDescriptions.filter(l=>I.has(p.ExtensionIdentifier.toKey(l.identifier))),this._initialize(),this._onDidChange.fire(void 0)}deltaExtensions(r,I){r.length>0&&(this._extensionDescriptions=this._extensionDescriptions.concat(r));const l=A._findLoopingExtensions(this._extensionDescriptions);if(I=I.concat(l.map(f=>f.identifier)),I.length>0){const f=new Set;I.forEach(c=>f.add(p.ExtensionIdentifier.toKey(c))),this._extensionDescriptions=this._extensionDescriptions.filter(c=>!f.has(p.ExtensionIdentifier.toKey(c.identifier)))}return this._initialize(),this._onDidChange.fire(void 0),new y(l)}static _findLoopingExtensions(r){const I=new class{constructor(){this._arcs=new Map,this._nodesSet=new Set,this._nodesArr=[]}addNode(S){this._nodesSet.has(S)||(this._nodesSet.add(S),this._nodesArr.push(S))}addArc(S,w){this.addNode(S),this.addNode(w),this._arcs.has(S)?this._arcs.get(S).push(w):this._arcs.set(S,[w])}getArcs(S){return this._arcs.has(S)?this._arcs.get(S):[]}hasOnlyGoodArcs(S,w){const b=I.getArcs(S);for(let d=0;d<b.length;d++)if(!w.has(b[d]))return!1;return!0}getNodes(){return this._nodesArr}};let l=new Map;for(let S of r){const w=p.ExtensionIdentifier.toKey(S.identifier);if(l.set(w,S),S.extensionDependencies)for(let b of S.extensionDependencies){const d=p.ExtensionIdentifier.toKey(b);I.addArc(w,d)}}let f=new Set;I.getNodes().filter(S=>I.getArcs(S).length===0).forEach(S=>f.add(S));let c=I.getNodes().filter(S=>!f.has(S)),u;do{u=!1;for(let S=0;S<c.length;S++){const w=c[S];I.hasOnlyGoodArcs(w,f)&&(c.splice(S,1),S--,f.add(w),u=!0)}}while(u);return c.map(S=>l.get(S))}containsActivationEvent(r){return this._activationMap.has(r)}containsExtension(r){return this._extensionsMap.has(p.ExtensionIdentifier.toKey(r))}getExtensionDescriptionsForActivationEvent(r){const I=this._activationMap.get(r);return I?I.slice(0):[]}getAllExtensionDescriptions(){return this._extensionsArr.slice(0)}getExtensionDescription(r){const I=this._extensionsMap.get(p.ExtensionIdentifier.toKey(r));return I||void 0}}e.ExtensionDescriptionRegistry=A;var P;(function(k){k[k.Builtin=0]="Builtin",k[k.User=1]="User",k[k.Dev=2]="Dev"})(P||(P={}));function E(k,r){const I=k.isBuiltin?0:k.isUnderDevelopment?2:1,l=r.isBuiltin?0:r.isUnderDevelopment?2:1;if(I!==l)return I-l;const f=C.posix.basename(k.extensionLocation.path),c=C.posix.basename(r.extensionLocation.path);return f<c?-1:f>c?1:0}}),define(me[214],ge([0,1,22]),function(X,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isMessageOfType=e.createMessageOfType=e.MessageType=e.ExtensionHostExitCode=void 0;var R;(function(P){P[P.VersionMismatch=55]="VersionMismatch",P[P.UnexpectedError=81]="UnexpectedError"})(R=e.ExtensionHostExitCode||(e.ExtensionHostExitCode={}));var C;(function(P){P[P.Initialized=0]="Initialized",P[P.Ready=1]="Ready",P[P.Terminate=2]="Terminate"})(C=e.MessageType||(e.MessageType={}));function y(P){const E=p.VSBuffer.alloc(1);switch(P){case 0:E.writeUInt8(1,0);break;case 1:E.writeUInt8(2,0);break;case 2:E.writeUInt8(3,0);break}return E}e.createMessageOfType=y;function A(P,E){if(P.byteLength!==1)return!1;switch(P.readUInt8(0)){case 1:return E===0;case 2:return E===1;case 3:return E===2;default:return!1}}e.isMessageOfType=A}),define(me[34],ge([0,1,3,2,4,26,178]),function(X,e,p,R,C,y,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullExtensionService=e.toExtensionDescription=e.toExtension=e.throwProposedApiError=e.checkProposedApiEnabled=e.ActivationKind=e.ExtensionHostLogFileName=e.ExtensionPointContribution=e.ActivationTimes=e.ExtensionHostKind=e.MissingExtensionDependency=e.IExtensionService=e.webWorkerExtHostConfig=e.nullExtensionDescription=void 0,e.nullExtensionDescription=Object.freeze({identifier:new y.ExtensionIdentifier("nullExtensionDescription"),name:"Null Extension Description",version:"0.0.0",publisher:"vscode",enableProposedApi:!1,engines:{vscode:""},extensionLocation:R.URI.parse("void:location"),isBuiltin:!1}),e.webWorkerExtHostConfig="extensions.webWorker",e.IExtensionService=C.createDecorator("extensionService");class P{constructor(b){this.dependency=b}}e.MissingExtensionDependency=P;var E;(function(w){w[w.LocalProcess=0]="LocalProcess",w[w.LocalWebWorker=1]="LocalWebWorker",w[w.Remote=2]="Remote"})(E=e.ExtensionHostKind||(e.ExtensionHostKind={}));class k{constructor(b,d,h,g){this.codeLoadingTime=b,this.activateCallTime=d,this.activateResolvedTime=h,this.activationReason=g}}e.ActivationTimes=k;class r{constructor(b,d){this.description=b,this.value=d}}e.ExtensionPointContribution=r,e.ExtensionHostLogFileName="exthost";var I;(function(w){w[w.Normal=0]="Normal",w[w.Immediate=1]="Immediate"})(I=e.ActivationKind||(e.ActivationKind={}));function l(w){w.enableProposedApi||f(w)}e.checkProposedApiEnabled=l;function f(w){throw new Error(`[${w.identifier.value}]: Proposed API is only available when running out of dev or with the following command line switch: --enable-proposed-api ${w.identifier.value}`)}e.throwProposedApiError=f;function c(w){return{type:w.isBuiltin?0:1,isBuiltin:w.isBuiltin||w.isUserBuiltin,identifier:{id:A.getGalleryExtensionId(w.publisher,w.name),uuid:w.uuid},manifest:w,location:w.extensionLocation}}e.toExtension=c;function u(w,b){return Object.assign(Object.assign({identifier:new y.ExtensionIdentifier(w.identifier.id),isBuiltin:w.type===0,isUserBuiltin:w.type===1&&w.isBuiltin,isUnderDevelopment:!!b,extensionLocation:w.location},w.manifest),{uuid:w.identifier.uuid})}e.toExtensionDescription=u;class S{constructor(){this.onDidRegisterExtensions=p.Event.None,this.onDidChangeExtensionsStatus=p.Event.None,this.onDidChangeExtensions=p.Event.None,this.onWillActivateByEvent=p.Event.None,this.onDidChangeResponsiveChange=p.Event.None}activateByEvent(b){return Promise.resolve(void 0)}whenInstalledExtensionsRegistered(){return Promise.resolve(!0)}getExtensions(){return Promise.resolve([])}getExtension(){return Promise.resolve(void 0)}readExtensionPointContributions(b){return Promise.resolve(Object.create(null))}getExtensionsStatus(){return Object.create(null)}getInspectPort(b){return Promise.resolve(0)}stopExtensionHosts(){}async restartExtensionHost(){}async startExtensionHosts(){}async setRemoteEnvironment(b){}canAddExtension(){return!1}canRemoveExtension(){return!1}_activateById(b,d){return Promise.resolve()}_onWillActivateExtension(b){}_onDidActivateExtension(b,d,h,g,t){}_onDidActivateExtensionError(b,d){}_onExtensionRuntimeError(b,d){}_onExtensionHostExit(b){}}e.NullExtensionService=S}),define(me[215],ge([0,1,26,34,12]),function(X,e,p,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsActivator=e.FailedExtension=e.HostExtension=e.EmptyExtension=e.ActivatedExtension=e.ExtensionActivationTimesBuilder=e.ExtensionActivationTimes=void 0;const y=Promise.resolve(void 0);class A{constructor(c,u,S,w){this.startup=c,this.codeLoadingTime=u,this.activateCallTime=S,this.activateResolvedTime=w}}e.ExtensionActivationTimes=A,A.NONE=new A(!1,-1,-1,-1);class P{constructor(c){this._startup=c,this._codeLoadingStart=-1,this._codeLoadingStop=-1,this._activateCallStart=-1,this._activateCallStop=-1,this._activateResolveStart=-1,this._activateResolveStop=-1}_delta(c,u){return c===-1||u===-1?-1:u-c}build(){return new A(this._startup,this._delta(this._codeLoadingStart,this._codeLoadingStop),this._delta(this._activateCallStart,this._activateCallStop),this._delta(this._activateResolveStart,this._activateResolveStop))}codeLoadingStart(){this._codeLoadingStart=Date.now()}codeLoadingStop(){this._codeLoadingStop=Date.now()}activateCallStart(){this._activateCallStart=Date.now()}activateCallStop(){this._activateCallStop=Date.now()}activateResolveStart(){this._activateResolveStart=Date.now()}activateResolveStop(){this._activateResolveStop=Date.now()}}e.ExtensionActivationTimesBuilder=P;class E{constructor(c,u,S,w,b,d){this.activationFailed=c,this.activationFailedError=u,this.activationTimes=S,this.module=w,this.exports=b,this.subscriptions=d}}e.ActivatedExtension=E;class k extends E{constructor(c){super(!1,null,c,{activate:void 0,deactivate:void 0},void 0,[])}}e.EmptyExtension=k;class r extends E{constructor(){super(!1,null,A.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.HostExtension=r;class I extends E{constructor(c){super(!0,c,A.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.FailedExtension=I;let l=class{constructor(c,u,S,w,b){this._logService=b,this._registry=c,this._resolvedExtensionsSet=new Set,u.forEach(d=>this._resolvedExtensionsSet.add(p.ExtensionIdentifier.toKey(d))),this._hostExtensionsMap=new Map,S.forEach(d=>this._hostExtensionsMap.set(p.ExtensionIdentifier.toKey(d),d)),this._host=w,this._activatingExtensions=new Map,this._activatedExtensions=new Map,this._alreadyActivatedEvents=Object.create(null)}isActivated(c){const u=p.ExtensionIdentifier.toKey(c);return this._activatedExtensions.has(u)}getActivatedExtension(c){const u=p.ExtensionIdentifier.toKey(c),S=this._activatedExtensions.get(u);if(!S)throw new Error("Extension `"+c.value+"` is not known or not activated");return S}activateByEvent(c,u){if(this._alreadyActivatedEvents[c])return y;const S=this._registry.getExtensionDescriptionsForActivationEvent(c);return this._activateExtensions(S.map(w=>({id:w.identifier,reason:{startup:u,extensionId:w.identifier,activationEvent:c}}))).then(()=>{this._alreadyActivatedEvents[c]=!0})}activateById(c,u){const S=this._registry.getExtensionDescription(c);if(!S)throw new Error("Extension `"+c+"` is not known");return this._activateExtensions([{id:S.identifier,reason:u}])}_handleActivateRequest(c,u,S){if(this._hostExtensionsMap.has(p.ExtensionIdentifier.toKey(c.id))){u[p.ExtensionIdentifier.toKey(c.id)]=c;return}const w=this._registry.getExtensionDescription(c.id);if(!w){const h=new Error(`Cannot activate unknown extension '${c.id.value}'`);this._host.onExtensionActivationError(c.id,h,new R.MissingExtensionDependency(c.id.value)),this._activatedExtensions.set(p.ExtensionIdentifier.toKey(c.id),new I(h));return}const b=typeof w.extensionDependencies=="undefined"?[]:w.extensionDependencies;let d=!0;for(let h=0,g=b.length;h<g;h++){const t=b[h];if(this._resolvedExtensionsSet.has(p.ExtensionIdentifier.toKey(t)))continue;const i=this._activatedExtensions.get(p.ExtensionIdentifier.toKey(t));if(i&&!i.activationFailed)continue;if(i&&i.activationFailed){const v=w.displayName||w.identifier.value,m=this._registry.getExtensionDescription(t),_=m&&m.displayName||t,D=new Error(`Cannot activate the '${v}' extension because its dependency '${_}' failed to activate`);D.detail=i.activationFailedError,this._host.onExtensionActivationError(w.identifier,D,null),this._activatedExtensions.set(p.ExtensionIdentifier.toKey(w.identifier),new I(D));return}if(this._hostExtensionsMap.has(p.ExtensionIdentifier.toKey(t))){d=!1,u[p.ExtensionIdentifier.toKey(t)]={id:this._hostExtensionsMap.get(p.ExtensionIdentifier.toKey(t)),reason:c.reason};continue}const s=this._registry.getExtensionDescription(t);if(s){d=!1,u[p.ExtensionIdentifier.toKey(t)]={id:s.identifier,reason:c.reason};continue}const n=w.displayName||w.identifier.value,o=new Error(`Cannot activate the '${n}' extension because it depends on unknown extension '${t}'`);this._host.onExtensionActivationError(w.identifier,o,new R.MissingExtensionDependency(t)),this._activatedExtensions.set(p.ExtensionIdentifier.toKey(w.identifier),new I(o));return}d?u[p.ExtensionIdentifier.toKey(w.identifier)]=c:S.push(c)}_activateExtensions(c){if(c.length===0||(c=c.filter(b=>!this._activatedExtensions.has(p.ExtensionIdentifier.toKey(b.id))),c.length===0))return Promise.resolve(void 0);const u=Object.create(null),S=[];for(let b=0,d=c.length;b<d;b++)this._handleActivateRequest(c[b],u,S);for(let b=0,d=S.length;b<d;b++){const h=p.ExtensionIdentifier.toKey(S[b].id);u[h]&&delete u[h]}const w=Object.keys(u).map(b=>u[b]);return S.length===0?Promise.all(w.map(b=>this._activateExtension(b.id,b.reason))).then(b=>{}):this._activateExtensions(w).then(b=>this._activateExtensions(S))}_activateExtension(c,u){const S=p.ExtensionIdentifier.toKey(c);if(this._activatedExtensions.has(S))return Promise.resolve(void 0);const w=this._activatingExtensions.get(S);if(w)return w;const b=this._host.actualActivateExtension(c,u).then(void 0,d=>{const h=new Error;return d&&d.name&&(h.name=d.name),d&&d.message?h.message=`Activating extension '${c.value}' failed: ${d.message}.`:h.message=`Activating extension '${c.value}' failed: ${d}.`,d&&d.stack&&(h.stack=d.stack),this._host.onExtensionActivationError(c,h,null),this._logService.error(`Activating extension ${c.value} failed due to an error:`),this._logService.error(d),new I(d)}).then(d=>{this._activatedExtensions.set(S,d),this._activatingExtensions.delete(S)});return this._activatingExtensions.set(S,b),b}};l=Ve([We(4,C.ILogService)],l),e.ExtensionsActivator=l}),define(me[216],ge([0,1,12,34,27,10,112]),function(X,e,p,R,C,y,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLogService=void 0;let P=class extends p.LogService{constructor(k){if(k.logFile.scheme!==y.Schemas.file)throw new Error("Only file-logging supported");super(new A.SpdLogLogger(R.ExtensionHostLogFileName,k.logFile.fsPath,!0,k.logLevel))}$setLevel(k){this.setLevel(k)}};P=Ve([We(0,C.IExtHostInitDataService)],P),e.ExtHostLogService=P}),define(me[217],ge([0,1,14]),function(X,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LazyPromise=void 0;class R{constructor(){this._actual=null,this._actualOk=null,this._actualErr=null,this._hasValue=!1,this._value=null,this._hasErr=!1,this._err=null}get[Symbol.toStringTag](){return this.toString()}_ensureActual(){return this._actual||(this._actual=new Promise((y,A)=>{this._actualOk=y,this._actualErr=A,this._hasValue&&this._actualOk(this._value),this._hasErr&&this._actualErr(this._err)})),this._actual}resolveOk(y){this._hasValue||this._hasErr||(this._hasValue=!0,this._value=y,this._actual&&this._actualOk(y))}resolveErr(y){this._hasValue||this._hasErr||(this._hasErr=!0,this._err=y,this._actual?this._actualErr(y):p.onUnexpectedError(y))}then(y,A){return this._ensureActual().then(y,A)}catch(y){return this._ensureActual().then(void 0,y)}finally(y){return this._ensureActual().finally(y)}}e.LazyPromise=R}),define(me[125],ge([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getStringIdentifierForProxy=e.createExtHostContextProxyIdentifier=e.createMainContextProxyIdentifier=e.ProxyIdentifier=void 0;class p{constructor(E,k){this.isMain=E,this.sid=k,this.nid=++p.count}}e.ProxyIdentifier=p,p.count=0;const R=[];function C(P){const E=new p(!0,P);return R[E.nid]=E,E}e.createMainContextProxyIdentifier=C;function y(P){const E=new p(!1,P);return R[E.nid]=E,E}e.createExtHostContextProxyIdentifier=y;function A(P){return R[P].sid}e.getStringIdentifierForProxy=A}),define(me[5],ge([0,1,55,2,125]),function(X,e,p,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostContext=e.MainContext=e.ExtHostTestingResource=e.reviveWorkspaceEditDto=e.WorkspaceEditType=e.ISuggestResultDtoField=e.ISuggestDataDtoField=e.IdObject=e.ObjectIdentifier=e.CandidatePortSource=e.NotebookEditorRevealType=e.CellOutputKind=e.WebviewMessageArrayBufferViewType=e.WebviewEditorCapabilities=e.TextEditorRevealType=e.UIKind=void 0;var y;(function(d){d[d.Desktop=1]="Desktop",d[d.Web=2]="Web"})(y=e.UIKind||(e.UIKind={}));var A;(function(d){d[d.Default=0]="Default",d[d.InCenter=1]="InCenter",d[d.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",d[d.AtTop=3]="AtTop"})(A=e.TextEditorRevealType||(e.TextEditorRevealType={}));var P;(function(d){d[d.Editable=0]="Editable",d[d.SupportsHotExit=1]="SupportsHotExit"})(P=e.WebviewEditorCapabilities||(e.WebviewEditorCapabilities={}));var E;(function(d){d[d.Int8Array=1]="Int8Array",d[d.Uint8Array=2]="Uint8Array",d[d.Uint8ClampedArray=3]="Uint8ClampedArray",d[d.Int16Array=4]="Int16Array",d[d.Uint16Array=5]="Uint16Array",d[d.Int32Array=6]="Int32Array",d[d.Uint32Array=7]="Uint32Array",d[d.Float32Array=8]="Float32Array",d[d.Float64Array=9]="Float64Array",d[d.BigInt64Array=10]="BigInt64Array",d[d.BigUint64Array=11]="BigUint64Array"})(E=e.WebviewMessageArrayBufferViewType||(e.WebviewMessageArrayBufferViewType={}));var k;(function(d){d[d.Text=1]="Text",d[d.Error=2]="Error",d[d.Rich=3]="Rich"})(k=e.CellOutputKind||(e.CellOutputKind={}));var r;(function(d){d[d.Default=0]="Default",d[d.InCenter=1]="InCenter",d[d.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",d[d.AtTop=3]="AtTop"})(r=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));var I;(function(d){d[d.None=0]="None",d[d.Process=1]="Process",d[d.Output=2]="Output"})(I=e.CandidatePortSource||(e.CandidatePortSource={}));var l;(function(d){d.name="$ident";function h(t,i){return Object.defineProperty(t,d.name,{value:i,enumerable:!0}),t}d.mixin=h;function g(t){return t[d.name]}d.of=g})(l=e.ObjectIdentifier||(e.ObjectIdentifier={}));class f{static mixin(h){return h._id=f._n++,h}}e.IdObject=f,f._n=0;var c;(function(d){d.label="a",d.kind="b",d.detail="c",d.documentation="d",d.sortText="e",d.filterText="f",d.preselect="g",d.insertText="h",d.insertTextRules="i",d.range="j",d.commitCharacters="k",d.additionalTextEdits="l",d.command="m",d.kindModifier="n"})(c=e.ISuggestDataDtoField||(e.ISuggestDataDtoField={}));var u;(function(d){d.defaultRanges="a",d.completions="b",d.isIncomplete="c",d.duration="d"})(u=e.ISuggestResultDtoField||(e.ISuggestResultDtoField={}));var S;(function(d){d[d.File=1]="File",d[d.Text=2]="Text",d[d.Cell=3]="Cell"})(S=e.WorkspaceEditType||(e.WorkspaceEditType={}));function w(d){if(d&&d.edits)for(const h of d.edits)typeof h.resource=="object"?h.resource=R.URI.revive(h.resource):(h.newUri=R.URI.revive(h.newUri),h.oldUri=R.URI.revive(h.oldUri)),h.metadata&&h.metadata.iconPath&&(h.metadata=p.revive(h.metadata));return d}e.reviveWorkspaceEditDto=w;var b;(function(d){d[d.Workspace=0]="Workspace",d[d.TextDocument=1]="TextDocument"})(b=e.ExtHostTestingResource||(e.ExtHostTestingResource={})),e.MainContext={MainThreadAuthentication:C.createMainContextProxyIdentifier("MainThreadAuthentication"),MainThreadBulkEdits:C.createMainContextProxyIdentifier("MainThreadBulkEdits"),MainThreadClipboard:C.createMainContextProxyIdentifier("MainThreadClipboard"),MainThreadCommands:C.createMainContextProxyIdentifier("MainThreadCommands"),MainThreadComments:C.createMainContextProxyIdentifier("MainThreadComments"),MainThreadConfiguration:C.createMainContextProxyIdentifier("MainThreadConfiguration"),MainThreadConsole:C.createMainContextProxyIdentifier("MainThreadConsole"),MainThreadDebugService:C.createMainContextProxyIdentifier("MainThreadDebugService"),MainThreadDecorations:C.createMainContextProxyIdentifier("MainThreadDecorations"),MainThreadDiagnostics:C.createMainContextProxyIdentifier("MainThreadDiagnostics"),MainThreadDialogs:C.createMainContextProxyIdentifier("MainThreadDiaglogs"),MainThreadDocuments:C.createMainContextProxyIdentifier("MainThreadDocuments"),MainThreadDocumentContentProviders:C.createMainContextProxyIdentifier("MainThreadDocumentContentProviders"),MainThreadTextEditors:C.createMainContextProxyIdentifier("MainThreadTextEditors"),MainThreadEditorInsets:C.createMainContextProxyIdentifier("MainThreadEditorInsets"),MainThreadEditorTabs:C.createMainContextProxyIdentifier("MainThreadEditorTabs"),MainThreadErrors:C.createMainContextProxyIdentifier("MainThreadErrors"),MainThreadTreeViews:C.createMainContextProxyIdentifier("MainThreadTreeViews"),MainThreadDownloadService:C.createMainContextProxyIdentifier("MainThreadDownloadService"),MainThreadKeytar:C.createMainContextProxyIdentifier("MainThreadKeytar"),MainThreadLanguageFeatures:C.createMainContextProxyIdentifier("MainThreadLanguageFeatures"),MainThreadLanguages:C.createMainContextProxyIdentifier("MainThreadLanguages"),MainThreadLog:C.createMainContextProxyIdentifier("MainThread"),MainThreadMessageService:C.createMainContextProxyIdentifier("MainThreadMessageService"),MainThreadOutputService:C.createMainContextProxyIdentifier("MainThreadOutputService"),MainThreadProgress:C.createMainContextProxyIdentifier("MainThreadProgress"),MainThreadQuickOpen:C.createMainContextProxyIdentifier("MainThreadQuickOpen"),MainThreadStatusBar:C.createMainContextProxyIdentifier("MainThreadStatusBar"),MainThreadSecretState:C.createMainContextProxyIdentifier("MainThreadSecretState"),MainThreadStorage:C.createMainContextProxyIdentifier("MainThreadStorage"),MainThreadTelemetry:C.createMainContextProxyIdentifier("MainThreadTelemetry"),MainThreadTerminalService:C.createMainContextProxyIdentifier("MainThreadTerminalService"),MainThreadWebviews:C.createMainContextProxyIdentifier("MainThreadWebviews"),MainThreadWebviewPanels:C.createMainContextProxyIdentifier("MainThreadWebviewPanels"),MainThreadWebviewViews:C.createMainContextProxyIdentifier("MainThreadWebviewViews"),MainThreadCustomEditors:C.createMainContextProxyIdentifier("MainThreadCustomEditors"),MainThreadUrls:C.createMainContextProxyIdentifier("MainThreadUrls"),MainThreadUriOpeners:C.createMainContextProxyIdentifier("MainThreadUriOpeners"),MainThreadWorkspace:C.createMainContextProxyIdentifier("MainThreadWorkspace"),MainThreadFileSystem:C.createMainContextProxyIdentifier("MainThreadFileSystem"),MainThreadExtensionService:C.createMainContextProxyIdentifier("MainThreadExtensionService"),MainThreadSCM:C.createMainContextProxyIdentifier("MainThreadSCM"),MainThreadSearch:C.createMainContextProxyIdentifier("MainThreadSearch"),MainThreadTask:C.createMainContextProxyIdentifier("MainThreadTask"),MainThreadWindow:C.createMainContextProxyIdentifier("MainThreadWindow"),MainThreadLabelService:C.createMainContextProxyIdentifier("MainThreadLabelService"),MainThreadNotebook:C.createMainContextProxyIdentifier("MainThreadNotebook"),MainThreadNotebookDocuments:C.createMainContextProxyIdentifier("MainThreadNotebookDocumentsShape"),MainThreadNotebookEditors:C.createMainContextProxyIdentifier("MainThreadNotebookEditorsShape"),MainThreadNotebookKernels:C.createMainContextProxyIdentifier("MainThreadNotebookKernels"),MainThreadNotebookRenderers:C.createMainContextProxyIdentifier("MainThreadNotebookRenderers"),MainThreadTheming:C.createMainContextProxyIdentifier("MainThreadTheming"),MainThreadTunnelService:C.createMainContextProxyIdentifier("MainThreadTunnelService"),MainThreadTimeline:C.createMainContextProxyIdentifier("MainThreadTimeline"),MainThreadTesting:C.createMainContextProxyIdentifier("MainThreadTesting")},e.ExtHostContext={ExtHostCommands:C.createExtHostContextProxyIdentifier("ExtHostCommands"),ExtHostConfiguration:C.createExtHostContextProxyIdentifier("ExtHostConfiguration"),ExtHostDiagnostics:C.createExtHostContextProxyIdentifier("ExtHostDiagnostics"),ExtHostDebugService:C.createExtHostContextProxyIdentifier("ExtHostDebugService"),ExtHostDecorations:C.createExtHostContextProxyIdentifier("ExtHostDecorations"),ExtHostDocumentsAndEditors:C.createExtHostContextProxyIdentifier("ExtHostDocumentsAndEditors"),ExtHostDocuments:C.createExtHostContextProxyIdentifier("ExtHostDocuments"),ExtHostDocumentContentProviders:C.createExtHostContextProxyIdentifier("ExtHostDocumentContentProviders"),ExtHostDocumentSaveParticipant:C.createExtHostContextProxyIdentifier("ExtHostDocumentSaveParticipant"),ExtHostEditors:C.createExtHostContextProxyIdentifier("ExtHostEditors"),ExtHostTreeViews:C.createExtHostContextProxyIdentifier("ExtHostTreeViews"),ExtHostFileSystem:C.createExtHostContextProxyIdentifier("ExtHostFileSystem"),ExtHostFileSystemInfo:C.createExtHostContextProxyIdentifier("ExtHostFileSystemInfo"),ExtHostFileSystemEventService:C.createExtHostContextProxyIdentifier("ExtHostFileSystemEventService"),ExtHostLanguageFeatures:C.createExtHostContextProxyIdentifier("ExtHostLanguageFeatures"),ExtHostQuickOpen:C.createExtHostContextProxyIdentifier("ExtHostQuickOpen"),ExtHostExtensionService:C.createExtHostContextProxyIdentifier("ExtHostExtensionService"),ExtHostLogService:C.createExtHostContextProxyIdentifier("ExtHostLogService"),ExtHostTerminalService:C.createExtHostContextProxyIdentifier("ExtHostTerminalService"),ExtHostSCM:C.createExtHostContextProxyIdentifier("ExtHostSCM"),ExtHostSearch:C.createExtHostContextProxyIdentifier("ExtHostSearch"),ExtHostTask:C.createExtHostContextProxyIdentifier("ExtHostTask"),ExtHostWorkspace:C.createExtHostContextProxyIdentifier("ExtHostWorkspace"),ExtHostWindow:C.createExtHostContextProxyIdentifier("ExtHostWindow"),ExtHostWebviews:C.createExtHostContextProxyIdentifier("ExtHostWebviews"),ExtHostWebviewPanels:C.createExtHostContextProxyIdentifier("ExtHostWebviewPanels"),ExtHostCustomEditors:C.createExtHostContextProxyIdentifier("ExtHostCustomEditors"),ExtHostWebviewViews:C.createExtHostContextProxyIdentifier("ExtHostWebviewViews"),ExtHostEditorInsets:C.createExtHostContextProxyIdentifier("ExtHostEditorInsets"),ExtHostEditorTabs:C.createExtHostContextProxyIdentifier("ExtHostEditorTabs"),ExtHostProgress:C.createMainContextProxyIdentifier("ExtHostProgress"),ExtHostComments:C.createMainContextProxyIdentifier("ExtHostComments"),ExtHostSecretState:C.createMainContextProxyIdentifier("ExtHostSecretState"),ExtHostStorage:C.createMainContextProxyIdentifier("ExtHostStorage"),ExtHostUrls:C.createExtHostContextProxyIdentifier("ExtHostUrls"),ExtHostUriOpeners:C.createExtHostContextProxyIdentifier("ExtHostUriOpeners"),ExtHostOutputService:C.createMainContextProxyIdentifier("ExtHostOutputService"),ExtHosLabelService:C.createMainContextProxyIdentifier("ExtHostLabelService"),ExtHostNotebook:C.createMainContextProxyIdentifier("ExtHostNotebook"),ExtHostNotebookDocuments:C.createMainContextProxyIdentifier("ExtHostNotebookDocuments"),ExtHostNotebookEditors:C.createMainContextProxyIdentifier("ExtHostNotebookEditors"),ExtHostNotebookKernels:C.createMainContextProxyIdentifier("ExtHostNotebookKernels"),ExtHostNotebookRenderers:C.createMainContextProxyIdentifier("ExtHostNotebookRenderers"),ExtHostTheming:C.createMainContextProxyIdentifier("ExtHostTheming"),ExtHostTunnelService:C.createMainContextProxyIdentifier("ExtHostTunnelService"),ExtHostAuthentication:C.createMainContextProxyIdentifier("ExtHostAuthentication"),ExtHostTimeline:C.createMainContextProxyIdentifier("ExtHostTimeline"),ExtHostTesting:C.createMainContextProxyIdentifier("ExtHostTesting"),ExtHostTelemetry:C.createMainContextProxyIdentifier("ExtHostTelemetry")}}),define(me[85],ge([0,1,5,3,4]),function(X,e,p,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostSecretState=e.ExtHostSecretState=void 0;class y{constructor(P){this._onDidChangePassword=new R.Emitter,this.onDidChangePassword=this._onDidChangePassword.event,this._proxy=P.getProxy(p.MainContext.MainThreadSecretState)}async $onDidChangePassword(P){this._onDidChangePassword.fire(P)}get(P,E){return this._proxy.$getPassword(P,E)}store(P,E,k){return this._proxy.$setPassword(P,E,k)}delete(P,E){return this._proxy.$deletePassword(P,E)}}e.ExtHostSecretState=y,e.IExtHostSecretState=C.createDecorator("IExtHostSecretState")}),define(me[61],ge([0,1,4,12,5,13]),function(X,e,p,R,C,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullApiDeprecationService=e.ExtHostApiDeprecationService=e.IExtHostApiDeprecationService=void 0,e.IExtHostApiDeprecationService=p.createDecorator("IExtHostApiDeprecationService");let A=class{constructor(E,k){this._extHostLogService=k,this._reportedUsages=new Set,this._telemetryShape=E.getProxy(C.MainContext.MainThreadTelemetry)}report(E,k,r){const I=this.getUsageKey(E,k);this._reportedUsages.has(I)||(this._reportedUsages.add(I),k.isUnderDevelopment&&this._extHostLogService.warn(`[Deprecation Warning] '${E}' is deprecated. ${r}`),this._telemetryShape.$publicLog2("extHostDeprecatedApiUsage",{extensionId:k.identifier.value,apiId:E}))}getUsageKey(E,k){return`${E}-${k.identifier.value}`}};A=Ve([We(0,y.IExtHostRpcService),We(1,R.ILogService)],A),e.ExtHostApiDeprecationService=A,e.NullApiDeprecationService=Object.freeze(new class{report(P,E,k){}})}),define(me[218],ge([0,1,3,5,7,26]),function(X,e,p,R,C,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostAuthentication=void 0;class A{constructor(E){this._authenticationProviders=new Map,this._providers=[],this._onDidChangeAuthenticationProviders=new p.Emitter,this.onDidChangeAuthenticationProviders=this._onDidChangeAuthenticationProviders.event,this._onDidChangeSessions=new p.Emitter,this.onDidChangeSessions=this._onDidChangeSessions.event,this._inFlightRequests=new Map,this._proxy=E.getProxy(R.MainContext.MainThreadAuthentication)}$setProviders(E){return this._providers=E,Promise.resolve()}get providers(){return Object.freeze(this._providers.slice())}async getSession(E,k,r,I={}){const l=y.ExtensionIdentifier.toKey(E.identifier),f=this._inFlightRequests.get(l)||[],c=[...r].sort().join(" ");let u=f.find(S=>S.scopes===c);if(u)return u.result;{const S=this._getSession(E,l,k,r,I);u={scopes:c,result:S},f.push(u),this._inFlightRequests.set(l,f);try{await S}finally{const w=f.findIndex(b=>b.scopes===c);w>-1&&(f.splice(w),this._inFlightRequests.set(l,f))}return S}}async _getSession(E,k,r,I,l={}){await this._proxy.$ensureProvider(r);const f=E.displayName||E.name;return this._proxy.$getSession(r,I,k,f,l)}async removeSession(E,k){const r=this._authenticationProviders.get(E);return r?r.provider.removeSession(k):this._proxy.$removeSession(E,k)}registerAuthenticationProvider(E,k,r,I){var l;if(this._authenticationProviders.get(E))throw new Error(`An authentication provider with id '${E}' is already registered.`);this._authenticationProviders.set(E,{label:k,provider:r,options:I??{supportsMultipleAccounts:!1}}),this._providers.find(c=>c.id===E)||this._providers.push({id:E,label:k});const f=r.onDidChangeSessions(c=>{var u,S,w;this._proxy.$sendDidChangeSessions(E,{added:(u=c.added)!==null&&u!==void 0?u:[],changed:(S=c.changed)!==null&&S!==void 0?S:[],removed:(w=c.removed)!==null&&w!==void 0?w:[]})});return this._proxy.$registerAuthenticationProvider(E,k,(l=I==null?void 0:I.supportsMultipleAccounts)!==null&&l!==void 0?l:!1),new C.Disposable(()=>{f.dispose(),this._authenticationProviders.delete(E);const c=this._providers.findIndex(u=>u.id===E);c>-1&&this._providers.splice(c),this._proxy.$unregisterAuthenticationProvider(E)})}$createSession(E,k){const r=this._authenticationProviders.get(E);if(r)return Promise.resolve(r.provider.createSession(k));throw new Error(`Unable to find authentication provider with handle: ${E}`)}$removeSession(E,k){const r=this._authenticationProviders.get(E);if(r)return Promise.resolve(r.provider.removeSession(k));throw new Error(`Unable to find authentication provider with handle: ${E}`)}$getSessions(E,k){const r=this._authenticationProviders.get(E);if(r)return Promise.resolve(r.provider.getSessions(k));throw new Error(`Unable to find authentication provider with handle: ${E}`)}$onDidChangeAuthenticationSessions(E,k){return this._onDidChangeSessions.fire({provider:{id:E,label:k}}),Promise.resolve()}$onDidChangeAuthenticationProviders(E,k){return E.forEach(r=>{this._providers.some(I=>I.id===r.id)||this._providers.push(r)}),k.forEach(r=>{const I=this._providers.findIndex(l=>l.id===r.id);I>-1&&this._providers.splice(I)}),this._onDidChangeAuthenticationProviders.fire({added:E,removed:k}),Promise.resolve()}}e.ExtHostAuthentication=A}),define(me[219],ge([0,1,5,13,17]),function(X,e,p,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostBulkEdits=void 0;let y=class{constructor(P,E){this._extHostDocumentsAndEditors=E,this._proxy=P.getProxy(p.MainContext.MainThreadBulkEdits)}applyWorkspaceEdit(P){const E=C.WorkspaceEdit.from(P,this._extHostDocumentsAndEditors);return this._proxy.$tryApplyWorkspaceEdit(E)}};y=Ve([We(0,R.IExtHostRpcService)],y),e.ExtHostBulkEdits=y}),define(me[220],ge([0,1,5]),function(X,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostClipboard=void 0;class R{constructor(y){const A=y.getProxy(p.MainContext.MainThreadClipboard);this.value=Object.freeze({readText(){return A.$readText()},writeText(P){return A.$writeText(P)}})}}e.ExtHostClipboard=R}),define(me[48],ge([0,1,15,7,17,25,5,18,12,55,40,44,2,6,4,13]),function(X,e,p,R,C,y,A,P,E,k,r,I,l,f,c,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ApiCommand=e.ApiCommandResult=e.ApiCommandArgument=e.CommandsConverter=e.IExtHostCommands=e.ExtHostCommands=void 0;let S=class{constructor(t,i){this._commands=new Map,this._apiCommands=new Map,this._proxy=t.getProxy(A.MainContext.MainThreadCommands),this._logService=i,this.converter=new w(this,s=>{const n=this._apiCommands.get(s);return(n==null?void 0:n.result)===d.Void?n:void 0},i),this._argumentProcessors=[{processArgument(s){return k.revive(s)}},{processArgument(s){return y.cloneAndChange(s,function(n){if(r.Range.isIRange(n))return C.Range.to(n);if(I.Position.isIPosition(n))return C.Position.to(n);if(r.Range.isIRange(n.range)&&l.URI.isUri(n.uri))return C.location.to(n);if(!Array.isArray(n))return n})}}]}registerArgumentProcessor(t){this._argumentProcessors.push(t)}registerApiCommand(t){const i=this.registerCommand(!1,t.id,async(...s)=>{const n=t.args.map((v,m)=>{if(!v.validate(s[m]))throw new Error(`Invalid argument '${v.name}' when running '${t.id}', received: ${s[m]}`);return v.convert(s[m])}),o=await this.executeCommand(t.internalId,...n);return t.result.convert(o,s,this.converter)},void 0,{description:t.description,args:t.args,returns:t.result.description});return this._apiCommands.set(t.id,t),new R.Disposable(()=>{i.dispose(),this._apiCommands.delete(t.id)})}registerCommand(t,i,s,n,o){if(this._logService.trace("ExtHostCommands#registerCommand",i),!i.trim().length)throw new Error("invalid id");if(this._commands.has(i))throw new Error(`command '${i}' already exists`);return this._commands.set(i,{callback:s,thisArg:n,description:o}),t&&this._proxy.$registerCommand(i),new R.Disposable(()=>{this._commands.delete(i)&&t&&this._proxy.$unregisterCommand(i)})}executeCommand(t,...i){return this._logService.trace("ExtHostCommands#executeCommand",t),this._doExecuteCommand(t,i,!0)}async _doExecuteCommand(t,i,s){if(this._commands.has(t))return this._executeContributedCommand(t,i);{const n=y.cloneAndChange(i,function(o){if(o instanceof R.Position)return C.Position.from(o);if(o instanceof R.Range)return C.Range.from(o);if(o instanceof R.Location)return C.location.from(o);if(R.NotebookRange.isNotebookRange(o))return C.NotebookRange.from(o);if(!Array.isArray(o))return o});try{const o=await this._proxy.$executeCommand(t,n,s);return k.revive(o)}catch(o){if(o instanceof Error&&o.message==="$executeCommand:retry")return this._doExecuteCommand(t,i,!1);throw o}}}async _executeContributedCommand(t,i){const s=this._commands.get(t);if(!s)throw new Error("Unknown command");let{callback:n,thisArg:o,description:v}=s;if(v)for(let m=0;m<v.args.length;m++)try{p.validateConstraint(i[m],v.args[m].constraint)}catch(_){throw new Error(`Running the contributed command: '${t}' failed. Illegal argument '${v.args[m].name}' - ${v.args[m].description}`)}try{return await n.apply(o,i)}catch(m){if(t===this.converter.delegatingCommandId){const _=this.converter.getActualCommand(...i);_&&(t=_.command)}throw this._logService.error(m,t),new Error(`Running the contributed command: '${t}' failed.`)}}$executeContributedCommand(t,...i){return this._logService.trace("ExtHostCommands#$executeContributedCommand",t),this._commands.has(t)?(i=i.map(s=>this._argumentProcessors.reduce((n,o)=>o.processArgument(n),s)),this._executeContributedCommand(t,i)):Promise.reject(new Error(`Contributed command '${t}' does not exist.`))}getCommands(t=!1){return this._logService.trace("ExtHostCommands#getCommands",t),this._proxy.$getCommands().then(i=>(t&&(i=i.filter(s=>s[0]!=="_")),i))}$getContributedCommandHandlerDescriptions(){const t=Object.create(null);for(let[i,s]of this._commands){let{description:n}=s;n&&(t[i]=n)}return Promise.resolve(t)}};S=Ve([We(0,u.IExtHostRpcService),We(1,E.ILogService)],S),e.ExtHostCommands=S,e.IExtHostCommands=c.createDecorator("IExtHostCommands");class w{constructor(t,i,s){this._commands=t,this._lookupApiCommand=i,this._logService=s,this.delegatingCommandId=`_vscode_delegate_cmd_${Date.now().toString(36)}`,this._cache=new Map,this._cachIdPool=0,this._commands.registerCommand(!0,this.delegatingCommandId,this._executeConvertedCommand,this)}toInternal(t,i){if(!t)return;const s={$ident:void 0,id:t.command,title:t.title,tooltip:t.tooltip};if(!t.command)return s;const n=this._lookupApiCommand(t.command);if(n)s.id=n.internalId,s.arguments=n.args.map((o,v)=>o.convert(t.arguments&&t.arguments[v]));else if(P.isNonEmptyArray(t.arguments)){const o=++this._cachIdPool;this._cache.set(o,t),i.add(f.toDisposable(()=>{this._cache.delete(o),this._logService.trace("CommandsConverter#DISPOSE",o)})),s.$ident=o,s.id=this.delegatingCommandId,s.arguments=[o],this._logService.trace("CommandsConverter#CREATE",t.command,o)}return s}fromInternal(t){const i=A.ObjectIdentifier.of(t);return typeof i=="number"?this._cache.get(i):{command:t.id,title:t.title,arguments:t.arguments}}getActualCommand(...t){return this._cache.get(t[0])}_executeConvertedCommand(...t){const i=this.getActualCommand(...t);return this._logService.trace("CommandsConverter#EXECUTE",t[0],i?i.command:"MISSING"),i?this._commands.executeCommand(i.command,...i.arguments||[]):Promise.reject("actual command NOT FOUND")}}e.CommandsConverter=w;class b{constructor(t,i,s,n){this.name=t,this.description=i,this.validate=s,this.convert=n}optional(){return new b(this.name,`(optional) ${this.description}`,t=>t==null||this.validate(t),t=>t===void 0?void 0:t===null?null:this.convert(t))}with(t,i){return new b(t??this.name,i??this.description,this.validate,this.convert)}}e.ApiCommandArgument=b,b.Uri=new b("uri","Uri of a text document",g=>l.URI.isUri(g),g=>g),b.Position=new b("position","A position in a text document",g=>R.Position.isPosition(g),C.Position.from),b.Range=new b("range","A range in a text document",g=>R.Range.isRange(g),C.Range.from),b.Selection=new b("selection","A selection in a text document",g=>R.Selection.isSelection(g),C.Selection.from),b.Number=new b("number","",g=>typeof g=="number",g=>g),b.String=new b("string","",g=>typeof g=="string",g=>g),b.CallHierarchyItem=new b("item","A call hierarchy item",g=>g instanceof R.CallHierarchyItem,C.CallHierarchyItem.to);class d{constructor(t,i){this.description=t,this.convert=i}}e.ApiCommandResult=d,d.Void=new d("no result",g=>g);class h{constructor(t,i,s,n,o){this.id=t,this.internalId=i,this.description=s,this.args=n,this.result=o}}e.ApiCommand=h}),define(me[221],ge([0,1,17,7,78,48,18,107]),function(X,e,p,R,C,y,A,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostApiCommands=void 0;const E=[new y.ApiCommand("vscode.executeDocumentHighlights","_executeDocumentHighlights","Execute document highlight provider.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position],new y.ApiCommandResult("A promise that resolves to an array of DocumentHighlight-instances.",r(p.DocumentHighlight.to))),new y.ApiCommand("vscode.executeDocumentSymbolProvider","_executeDocumentSymbolProvider","Execute document symbol provider.",[y.ApiCommandArgument.Uri],new y.ApiCommandResult("A promise that resolves to an array of SymbolInformation and DocumentSymbol instances.",(l,f)=>{if(A.isFalsyOrEmpty(l))return;class c extends R.SymbolInformation{static to(S){const w=new c(S.name,p.SymbolKind.to(S.kind),S.containerName||"",new R.Location(f[0],p.Range.to(S.range)));return w.detail=S.detail,w.range=w.location.range,w.selectionRange=p.Range.to(S.selectionRange),w.children=S.children?S.children.map(c.to):[],w}}return l.map(c.to)})),new y.ApiCommand("vscode.executeFormatDocumentProvider","_executeFormatDocumentProvider","Execute document format provider.",[y.ApiCommandArgument.Uri,new y.ApiCommandArgument("options","Formatting options",l=>!0,l=>l)],new y.ApiCommandResult("A promise that resolves to an array of TextEdits.",r(p.TextEdit.to))),new y.ApiCommand("vscode.executeFormatRangeProvider","_executeFormatRangeProvider","Execute range format provider.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Range,new y.ApiCommandArgument("options","Formatting options",l=>!0,l=>l)],new y.ApiCommandResult("A promise that resolves to an array of TextEdits.",r(p.TextEdit.to))),new y.ApiCommand("vscode.executeFormatOnTypeProvider","_executeFormatOnTypeProvider","Execute format on type provider.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position,new y.ApiCommandArgument("ch","Trigger character",l=>typeof l=="string",l=>l),new y.ApiCommandArgument("options","Formatting options",l=>!0,l=>l)],new y.ApiCommandResult("A promise that resolves to an array of TextEdits.",r(p.TextEdit.to))),new y.ApiCommand("vscode.executeDefinitionProvider","_executeDefinitionProvider","Execute all definition providers.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position],new y.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",I)),new y.ApiCommand("vscode.executeTypeDefinitionProvider","_executeTypeDefinitionProvider","Execute all type definition providers.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position],new y.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",I)),new y.ApiCommand("vscode.executeDeclarationProvider","_executeDeclarationProvider","Execute all declaration providers.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position],new y.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",I)),new y.ApiCommand("vscode.executeImplementationProvider","_executeImplementationProvider","Execute all implementation providers.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position],new y.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",I)),new y.ApiCommand("vscode.executeReferenceProvider","_executeReferenceProvider","Execute all reference providers.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position],new y.ApiCommandResult("A promise that resolves to an array of Location-instances.",r(p.location.to))),new y.ApiCommand("vscode.executeHoverProvider","_executeHoverProvider","Execute all hover providers.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position],new y.ApiCommandResult("A promise that resolves to an array of Hover-instances.",r(p.Hover.to))),new y.ApiCommand("vscode.executeSelectionRangeProvider","_executeSelectionRangeProvider","Execute selection range provider.",[y.ApiCommandArgument.Uri,new y.ApiCommandArgument("position","A position in a text document",l=>Array.isArray(l)&&l.every(f=>R.Position.isPosition(f)),l=>l.map(p.Position.from))],new y.ApiCommandResult("A promise that resolves to an array of ranges.",l=>l.map(f=>{let c;for(const u of f.reverse())c=new R.SelectionRange(p.Range.to(u),c);return c}))),new y.ApiCommand("vscode.executeWorkspaceSymbolProvider","_executeWorkspaceSymbolProvider","Execute all workspace symbol providers.",[y.ApiCommandArgument.String.with("query","Search string")],new y.ApiCommandResult("A promise that resolves to an array of SymbolInformation-instances.",l=>{const f=[];if(Array.isArray(l))for(let c of l)f.push(...c[1].map(p.WorkspaceSymbol.to));return f})),new y.ApiCommand("vscode.prepareCallHierarchy","_executePrepareCallHierarchy","Prepare call hierarchy at a position inside a document",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position],new y.ApiCommandResult("A CallHierarchyItem or undefined",l=>l.map(p.CallHierarchyItem.to))),new y.ApiCommand("vscode.provideIncomingCalls","_executeProvideIncomingCalls","Compute incoming calls for an item",[y.ApiCommandArgument.CallHierarchyItem],new y.ApiCommandResult("A CallHierarchyItem or undefined",l=>l.map(p.CallHierarchyIncomingCall.to))),new y.ApiCommand("vscode.provideOutgoingCalls","_executeProvideOutgoingCalls","Compute outgoing calls for an item",[y.ApiCommandArgument.CallHierarchyItem],new y.ApiCommandResult("A CallHierarchyItem or undefined",l=>l.map(p.CallHierarchyOutgoingCall.to))),new y.ApiCommand("vscode.executeDocumentRenameProvider","_executeDocumentRenameProvider","Execute rename provider.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position,y.ApiCommandArgument.String.with("newName","The new symbol name")],new y.ApiCommandResult("A promise that resolves to a WorkspaceEdit.",l=>{if(!!l){if(l.rejectReason)throw new Error(l.rejectReason);return p.WorkspaceEdit.to(l)}})),new y.ApiCommand("vscode.executeLinkProvider","_executeLinkProvider","Execute document link provider.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Number.with("linkResolveCount","Number of links that should be resolved, only when links are unresolved.").optional()],new y.ApiCommandResult("A promise that resolves to an array of DocumentLink-instances.",l=>l.map(p.DocumentLink.to))),new y.ApiCommand("vscode.provideDocumentSemanticTokensLegend","_provideDocumentSemanticTokensLegend","Provide semantic tokens legend for a document",[y.ApiCommandArgument.Uri],new y.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",l=>{if(!!l)return new R.SemanticTokensLegend(l.tokenTypes,l.tokenModifiers)})),new y.ApiCommand("vscode.provideDocumentSemanticTokens","_provideDocumentSemanticTokens","Provide semantic tokens for a document",[y.ApiCommandArgument.Uri],new y.ApiCommandResult("A promise that resolves to SemanticTokens.",l=>{if(!l)return;const f=P.decodeSemanticTokensDto(l);if(f.type==="full")return new R.SemanticTokens(f.data,void 0)})),new y.ApiCommand("vscode.provideDocumentRangeSemanticTokensLegend","_provideDocumentRangeSemanticTokensLegend","Provide semantic tokens legend for a document range",[y.ApiCommandArgument.Uri],new y.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",l=>{if(!!l)return new R.SemanticTokensLegend(l.tokenTypes,l.tokenModifiers)})),new y.ApiCommand("vscode.provideDocumentRangeSemanticTokens","_provideDocumentRangeSemanticTokens","Provide semantic tokens for a document range",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Range],new y.ApiCommandResult("A promise that resolves to SemanticTokens.",l=>{if(!l)return;const f=P.decodeSemanticTokensDto(l);if(f.type==="full")return new R.SemanticTokens(f.data,void 0)})),new y.ApiCommand("vscode.executeCompletionItemProvider","_executeCompletionItemProvider","Execute completion item provider.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position,y.ApiCommandArgument.String.with("triggerCharacter","Trigger completion when the user types the character, like `,` or `(`").optional(),y.ApiCommandArgument.Number.with("itemResolveCount","Number of completions to resolve (too large numbers slow down completions)").optional()],new y.ApiCommandResult("A promise that resolves to a CompletionList-instance.",(l,f,c)=>{if(!l)return new R.CompletionList([]);const u=l.suggestions.map(S=>p.CompletionItem.to(S,c));return new R.CompletionList(u,l.incomplete)})),new y.ApiCommand("vscode.executeSignatureHelpProvider","_executeSignatureHelpProvider","Execute signature help provider.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position,y.ApiCommandArgument.String.with("triggerCharacter","Trigger signature help when the user types the character, like `,` or `(`").optional()],new y.ApiCommandResult("A promise that resolves to SignatureHelp.",l=>{if(l)return p.SignatureHelp.to(l)})),new y.ApiCommand("vscode.executeCodeLensProvider","_executeCodeLensProvider","Execute code lens provider.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Number.with("itemResolveCount","Number of lenses that should be resolved and returned. Will only return resolved lenses, will impact performance)").optional()],new y.ApiCommandResult("A promise that resolves to an array of CodeLens-instances.",(l,f,c)=>r(u=>new R.CodeLens(p.Range.to(u.range),u.command&&c.fromInternal(u.command)))(l))),new y.ApiCommand("vscode.executeCodeActionProvider","_executeCodeActionProvider","Execute code action provider.",[y.ApiCommandArgument.Uri,new y.ApiCommandArgument("rangeOrSelection","Range in a text document. Some refactoring provider requires Selection object.",l=>R.Range.isRange(l),l=>R.Selection.isSelection(l)?p.Selection.from(l):p.Range.from(l)),y.ApiCommandArgument.String.with("kind","Code action kind to return code actions for").optional(),y.ApiCommandArgument.Number.with("itemResolveCount","Number of code actions to resolve (too large numbers slow down code actions)").optional()],new y.ApiCommandResult("A promise that resolves to an array of Command-instances.",(l,f,c)=>r(u=>{if(u._isSynthetic){if(!u.command)throw new Error("Synthetic code actions must have a command");return c.fromInternal(u.command)}else{const S=new R.CodeAction(u.title,u.kind?new R.CodeActionKind(u.kind):void 0);return u.edit&&(S.edit=p.WorkspaceEdit.to(u.edit)),u.command&&(S.command=c.fromInternal(u.command)),S.isPreferred=u.isPreferred,S}})(l))),new y.ApiCommand("vscode.executeDocumentColorProvider","_executeDocumentColorProvider","Execute document color provider.",[y.ApiCommandArgument.Uri],new y.ApiCommandResult("A promise that resolves to an array of ColorInformation objects.",l=>l?l.map(f=>new R.ColorInformation(p.Range.to(f.range),p.Color.to(f.color))):[])),new y.ApiCommand("vscode.executeColorPresentationProvider","_executeColorPresentationProvider","Execute color presentation provider.",[new y.ApiCommandArgument("color","The color to show and insert",l=>l instanceof R.Color,p.Color.from),new y.ApiCommandArgument("context","Context object with uri and range",l=>!0,l=>({uri:l.uri,range:p.Range.from(l.range)}))],new y.ApiCommandResult("A promise that resolves to an array of ColorPresentation objects.",l=>l?l.map(p.ColorPresentation.to):[])),new y.ApiCommand("vscode.executeInlayHintProvider","_executeInlayHintProvider","Execute inlay hints provider",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Range],new y.ApiCommandResult("A promise that resolves to an array of Inlay objects",l=>l.map(p.InlayHint.to))),new y.ApiCommand("vscode.resolveNotebookContentProviders","_resolveNotebookContentProvider","Resolve Notebook Content Providers",[],new y.ApiCommandResult("A promise that resolves to an array of NotebookContentProvider static info objects.",r(l=>({viewType:l.viewType,displayName:l.displayName,options:{transientOutputs:l.options.transientOutputs,transientCellMetadata:l.options.transientCellMetadata,transientDocumentMetadata:l.options.transientDocumentMetadata},filenamePattern:l.filenamePattern.map(f=>p.NotebookExclusiveDocumentPattern.to(f))})))),new y.ApiCommand("vscode.executeInlineValueProvider","_executeInlineValueProvider","Execute inline value provider",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Range],new y.ApiCommandResult("A promise that resolves to an array of InlineValue objects",l=>l.map(p.InlineValue.to))),new y.ApiCommand("vscode.open","_workbench.open","Opens the provided resource in the editor. Can be a text or binary file, or an http(s) URL. If you need more control over the options for opening a text file, use vscode.window.showTextDocument instead.",[y.ApiCommandArgument.Uri,new y.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",l=>l===void 0||typeof l=="number"||typeof l=="object",l=>l&&(typeof l=="number"?[l,void 0]:[p.ViewColumn.from(l.viewColumn),p.TextEditorOpenOptions.from(l)])).optional(),y.ApiCommandArgument.String.with("label","").optional()],y.ApiCommandResult.Void),new y.ApiCommand("vscode.openWith","_workbench.openWith","Opens the provided resource with a specific editor.",[y.ApiCommandArgument.Uri.with("resource","Resource to open"),y.ApiCommandArgument.String.with("viewId","Custom editor view id or 'default' to use VS Code's default editor"),new y.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",l=>l===void 0||typeof l=="number"||typeof l=="object",l=>l&&(typeof l=="number"?[l,void 0]:[p.ViewColumn.from(l.viewColumn),p.TextEditorOpenOptions.from(l)])).optional()],y.ApiCommandResult.Void),new y.ApiCommand("vscode.diff","_workbench.diff","Opens the provided resources in the diff editor to compare their contents.",[y.ApiCommandArgument.Uri.with("left","Left-hand side resource of the diff editor"),y.ApiCommandArgument.Uri.with("right","Right-hand side resource of the diff editor"),y.ApiCommandArgument.String.with("title","Human readable title for the diff editor").optional(),new y.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",l=>l===void 0||typeof l=="object",l=>l&&[p.ViewColumn.from(l.viewColumn),p.TextEditorOpenOptions.from(l)]).optional()],y.ApiCommandResult.Void)];class k{static register(f){E.forEach(f.registerApiCommand,f)}}e.ExtHostApiCommands=k;function r(l){return f=>{if(Array.isArray(f))return f.map(l)}}function I(l){if(!Array.isArray(l))return;const f=[];for(const c of l)C.isLocationLink(c)?f.push(p.DefinitionLink.to(c)):f.push(p.location.to(c));return f}}),define(me[222],ge([0,1,16,51,3,6,2,78,26,17,7,5]),function(X,e,p,R,C,y,A,P,E,k,r,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostCommentThread=e.ExtHostComments=void 0;class l{constructor(h,g,t){this._documents=t,this._commentControllers=new Map,this._commentControllersByExtension=new Map,this._proxy=h.getProxy(I.MainContext.MainThreadComments),g.registerArgumentProcessor({processArgument:i=>{if(i&&i.$mid===6){const s=this._commentControllers.get(i.handle);return s||i}else if(i&&i.$mid===7){const s=this._commentControllers.get(i.commentControlHandle);if(!s)return i;const n=s.getCommentThread(i.commentThreadHandle);return n||i}else if(i&&i.$mid===8){const s=this._commentControllers.get(i.thread.commentControlHandle);if(!s)return i;const n=s.getCommentThread(i.thread.commentThreadHandle);return n?{thread:n,text:i.text}:i}else if(i&&i.$mid===9){const s=this._commentControllers.get(i.thread.commentControlHandle);if(!s)return i;const n=s.getCommentThread(i.thread.commentThreadHandle);if(!n)return i;let o=i.commentUniqueId,v=n.getCommentByUniqueId(o);return v||i}else if(i&&i.$mid===10){const s=this._commentControllers.get(i.thread.commentControlHandle);if(!s)return i;const n=s.getCommentThread(i.thread.commentThreadHandle);if(!n)return i;let o=i.text,v=i.commentUniqueId,m=n.getCommentByUniqueId(v);return m?(m.body=o,m):i}return i}})}createCommentController(h,g,t){const i=l.handlePool++,s=new c(h,i,this._proxy,g,t);this._commentControllers.set(s.handle,s);const n=this._commentControllersByExtension.get(E.ExtensionIdentifier.toKey(h.identifier))||[];return n.push(s),this._commentControllersByExtension.set(E.ExtensionIdentifier.toKey(h.identifier),n),s}$createCommentThreadTemplate(h,g,t){const i=this._commentControllers.get(h);!i||i.$createCommentThreadTemplate(g,t)}async $updateCommentThreadTemplate(h,g,t){const i=this._commentControllers.get(h);!i||i.$updateCommentThreadTemplate(g,t)}$deleteCommentThread(h,g){const t=this._commentControllers.get(h);t&&t.$deleteCommentThread(g)}$provideCommentingRanges(h,g,t){const i=this._commentControllers.get(h);if(!i||!i.commentingRangeProvider)return Promise.resolve(void 0);const s=this._documents.getDocument(A.URI.revive(g));return p.asPromise(()=>i.commentingRangeProvider.provideCommentingRanges(s,t)).then(n=>n?n.map(o=>k.Range.from(o)):void 0)}$toggleReaction(h,g,t,i,s){const n=this._commentControllers.get(h);return!n||!n.reactionHandler?Promise.resolve(void 0):p.asPromise(()=>{const o=n.getCommentThread(g);if(o){const v=o.getCommentByUniqueId(i.uniqueIdInThread);if(n!==void 0&&v&&n.reactionHandler)return n.reactionHandler(v,w(s))}return Promise.resolve(void 0)})}dispose(){}}e.ExtHostComments=l,l.handlePool=0;class f{constructor(h,g,t,i,s,n,o){this._proxy=h,this._commentController=g,this._id=t,this._uri=i,this._range=s,this._comments=n,this.handle=f._handlePool++,this.commentHandle=0,this.modifications=Object.create(null),this._onDidUpdateCommentThread=new C.Emitter,this.onDidUpdateCommentThread=this._onDidUpdateCommentThread.event,this._canReply=!0,this._commentsMap=new Map,this._acceptInputDisposables=new y.MutableDisposable,this._acceptInputDisposables.value=new y.DisposableStore,this._id===void 0&&(this._id=`${g.id}.${this.handle}`),this._proxy.$createCommentThread(this._commentController.handle,this.handle,this._id,this._uri,k.Range.from(this._range),o),this._localDisposables=[],this._isDiposed=!1,this._localDisposables.push(this.onDidUpdateCommentThread(()=>{this.eventuallyUpdateCommentThread()})),this.comments=n}set threadId(h){this._id=h}get threadId(){return this._id}get id(){return this._id}get resource(){return this._uri}get uri(){return this._uri}set range(h){h.isEqual(this._range)||(this._range=h,this.modifications.range=h,this._onDidUpdateCommentThread.fire())}get range(){return this._range}set canReply(h){this._canReply!==h&&(this._canReply=h,this.modifications.canReply=h,this._onDidUpdateCommentThread.fire())}get canReply(){return this._canReply}get label(){return this._label}set label(h){this._label=h,this.modifications.label=h,this._onDidUpdateCommentThread.fire()}get contextValue(){return this._contextValue}set contextValue(h){this._contextValue=h,this.modifications.contextValue=h,this._onDidUpdateCommentThread.fire()}get comments(){return this._comments}set comments(h){this._comments=h,this.modifications.comments=h,this._onDidUpdateCommentThread.fire()}get collapsibleState(){return this._collapseState}set collapsibleState(h){this._collapseState=h,this.modifications.collapsibleState=h,this._onDidUpdateCommentThread.fire()}get isDisposed(){return this._isDiposed}eventuallyUpdateCommentThread(){if(this._isDiposed)return;this._acceptInputDisposables.value||(this._acceptInputDisposables.value=new y.DisposableStore);const h=t=>Object.prototype.hasOwnProperty.call(this.modifications,t),g={};h("range")&&(g.range=k.Range.from(this._range)),h("label")&&(g.label=this.label),h("contextValue")&&(g.contextValue=this.contextValue),h("comments")&&(g.comments=this._comments.map(t=>u(this,this._commentController,t,this._commentsMap))),h("collapsibleState")&&(g.collapseState=b(this._collapseState)),h("canReply")&&(g.canReply=this.canReply),this.modifications={},this._proxy.$updateCommentThread(this._commentController.handle,this.handle,this._id,this._uri,g)}getCommentByUniqueId(h){for(let g of this._commentsMap){let t=g[0],i=g[1];if(h===i)return t}}dispose(){this._isDiposed=!0,this._acceptInputDisposables.dispose(),this._localDisposables.forEach(h=>h.dispose()),this._proxy.$deleteCommentThread(this._commentController.handle,this.handle)}}f._handlePool=0,Ve([R.debounce(100)],f.prototype,"eventuallyUpdateCommentThread",null),e.ExtHostCommentThread=f;class c{constructor(h,g,t,i,s){this._extension=h,this._handle=g,this._proxy=t,this._id=i,this._label=s,this._threads=new Map,this._proxy.$registerCommentController(this.handle,i,s)}get id(){return this._id}get label(){return this._label}get handle(){return this._handle}get reactionHandler(){return this._reactionHandler}set reactionHandler(h){this._reactionHandler=h,this._proxy.$updateCommentControllerFeatures(this.handle,{reactionHandler:!!h})}get options(){return this._options}set options(h){this._options=h,this._proxy.$updateCommentControllerFeatures(this.handle,{options:this._options})}createCommentThread(h,g,t,i){if(typeof h=="string"){const s=new f(this._proxy,this,h,g,t,i,this._extension.identifier);return this._threads.set(s.handle,s),s}else{const s=new f(this._proxy,this,void 0,h,g,t,this._extension.identifier);return this._threads.set(s.handle,s),s}}$createCommentThreadTemplate(h,g){const t=new f(this._proxy,this,void 0,A.URI.revive(h),k.Range.to(g),[],this._extension.identifier);return t.collapsibleState=P.CommentThreadCollapsibleState.Expanded,this._threads.set(t.handle,t),t}$updateCommentThreadTemplate(h,g){let t=this._threads.get(h);t&&(t.range=k.Range.to(g))}$deleteCommentThread(h){let g=this._threads.get(h);g&&g.dispose(),this._threads.delete(h)}getCommentThread(h){return this._threads.get(h)}dispose(){this._threads.forEach(h=>{h.dispose()}),this._proxy.$unregisterCommentController(this.handle)}}function u(d,h,g,t){let i=t.get(g);i||(i=++d.commentHandle,t.set(g,i));const s=g.author&&g.author.iconPath?g.author.iconPath.toString():void 0;return{mode:g.mode,contextValue:g.contextValue,uniqueIdInThread:i,body:k.MarkdownString.from(g.body),userName:g.author.name,userIconPath:s,label:g.label,commentReactions:g.reactions?g.reactions.map(n=>S(n)):void 0}}function S(d){return{label:d.label,iconPath:d.iconPath?k.pathOrURIToURI(d.iconPath):void 0,count:d.count,hasReacted:d.authorHasReacted}}function w(d){return{label:d.label||"",count:d.count||0,iconPath:d.iconPath?A.URI.revive(d.iconPath):"",authorHasReacted:d.hasReacted||!1}}function b(d){if(d!==void 0)switch(d){case r.CommentThreadCollapsibleState.Expanded:return P.CommentThreadCollapsibleState.Expanded;case r.CommentThreadCollapsibleState.Collapsed:return P.CommentThreadCollapsibleState.Collapsed}return P.CommentThreadCollapsibleState.Collapsed}}),define(me[126],ge([0,1,2,5,7,4,13,12,18,8,9]),function(X,e,p,R,C,y,A,P,E,k,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDecorations=e.ExtHostDecorations=void 0;let I=class bn{constructor(f,c){this._logService=c,this._provider=new Map,this._proxy=f.getProxy(R.MainContext.MainThreadDecorations)}registerFileDecorationProvider(f,c){const u=bn._handlePool++;this._provider.set(u,{provider:f,extensionId:c}),this._proxy.$registerDecorationProvider(u,c.value);const S=f.onDidChangeFileDecorations&&f.onDidChangeFileDecorations(w=>{if(!w){this._proxy.$onDidChange(u,null);return}let b=E.asArray(w);if(b.length<=bn._maxEventSize){this._proxy.$onDidChange(u,b);return}this._logService.warn("[Decorations] CAPPING events from decorations provider",c.value,b.length);const d=b.map(t=>({uri:t,rank:k.count(t.path,"/")})),h=E.groupBy(d,(t,i)=>t.rank-i.rank||k.compare(t.uri.path,i.uri.path));let g=[];e:for(let t of h){let i;for(let s of t){let n=r.dirname(s.uri.path);if(i!==n&&(i=n,g.push(s.uri)>=bn._maxEventSize))break e}}this._proxy.$onDidChange(u,g)});return new C.Disposable(()=>{S==null||S.dispose(),this._proxy.$unregisterDecorationProvider(u),this._provider.delete(u)})}async $provideDecorations(f,c,u){if(!this._provider.has(f))return Object.create(null);const S=Object.create(null),{provider:w,extensionId:b}=this._provider.get(f);return await Promise.all(c.map(async d=>{try{const{uri:h,id:g}=d,t=await Promise.resolve(w.provideFileDecoration(p.URI.revive(h),u));if(!t)return;try{C.FileDecoration.validate(t),S[g]=[t.propagate,t.tooltip,t.badge,t.color]}catch(i){this._logService.warn(`INVALID decoration from extension '${b.value}': ${i}`)}}catch(h){this._logService.error(h)}})),S}};I._handlePool=0,I._maxEventSize=250,I=Ve([We(0,A.IExtHostRpcService),We(1,P.ILogService)],I),e.ExtHostDecorations=I,e.IExtHostDecorations=y.createDecorator("IExtHostDecorations")}),define(me[223],ge([0,1,158,113,2,5,7,17,3,12,23]),function(X,e,p,R,C,y,A,P,E,k,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDiagnostics=e.DiagnosticCollection=void 0;class I{constructor(c,u,S,w,b){this._name=c,this._owner=u,this._maxDiagnosticsPerFile=S,this._proxy=w,this._onDidChangeDiagnostics=b,this._isDisposed=!1,this._data=new r.ResourceMap}dispose(){this._isDisposed||(this._onDidChangeDiagnostics.fire([...this._data.keys()]),this._proxy&&this._proxy.$clear(this._owner),this._data=void 0,this._isDisposed=!0)}get name(){return this._checkDisposed(),this._name}set(c,u){if(!c){this.clear();return}this._checkDisposed();let S=[];if(C.URI.isUri(c)){if(!u){this.delete(c);return}this._data.set(c,u.slice()),S=[c]}else if(Array.isArray(c)){S=[];let b;c=[...c].sort(I._compareIndexedTuplesByUri);for(const d of c){const[h,g]=d;if((!b||h.toString()!==b.toString())&&(b&&this._data.get(b).length===0&&this._data.delete(b),b=h,S.push(h),this._data.set(h,[])),g){const t=this._data.get(h);t&&t.push(...g)}else{const t=this._data.get(h);t&&(t.length=0)}}}if(this._onDidChangeDiagnostics.fire(S),!this._proxy)return;const w=[];for(let b of S){let d=[];const h=this._data.get(b);if(h)if(h.length>this._maxDiagnosticsPerFile){d=[];const g=[A.DiagnosticSeverity.Error,A.DiagnosticSeverity.Warning,A.DiagnosticSeverity.Information,A.DiagnosticSeverity.Hint];e:for(let t=0;t<4;t++)for(let i of h)if(i.severity===g[t]&&d.push(P.Diagnostic.from(i))===this._maxDiagnosticsPerFile)break e;d.push({severity:R.MarkerSeverity.Info,message:p.localize(0,null,h.length-this._maxDiagnosticsPerFile),startLineNumber:d[d.length-1].startLineNumber,startColumn:d[d.length-1].startColumn,endLineNumber:d[d.length-1].endLineNumber,endColumn:d[d.length-1].endColumn})}else d=h.map(g=>P.Diagnostic.from(g));w.push([b,d])}this._proxy.$changeMany(this._owner,w)}delete(c){this._checkDisposed(),this._onDidChangeDiagnostics.fire([c]),this._data.delete(c),this._proxy&&this._proxy.$changeMany(this._owner,[[c,void 0]])}clear(){this._checkDisposed(),this._onDidChangeDiagnostics.fire([...this._data.keys()]),this._data.clear(),this._proxy&&this._proxy.$clear(this._owner)}forEach(c,u){this._checkDisposed();for(let S of this._data.keys())c.apply(u,[S,this.get(S),this])}get(c){this._checkDisposed();const u=this._data.get(c);return Array.isArray(u)?Object.freeze(u.slice(0)):[]}has(c){return this._checkDisposed(),Array.isArray(this._data.get(c))}_checkDisposed(){if(this._isDisposed)throw new Error("illegal state - object is disposed")}static _compareIndexedTuplesByUri(c,u){return c[0].toString()<u[0].toString()?-1:c[0].toString()>u[0].toString()?1:0}}e.DiagnosticCollection=I;let l=class Gt{constructor(c,u){this._logService=u,this._collections=new Map,this._onDidChangeDiagnostics=new E.Emitter,this.onDidChangeDiagnostics=E.Event.map(E.Event.debounce(this._onDidChangeDiagnostics.event,Gt._debouncer,50),Gt._mapper),this._proxy=c.getProxy(y.MainContext.MainThreadDiagnostics)}static _debouncer(c,u){return c?c.concat(u):u}static _mapper(c){const u=new r.ResourceMap;for(const S of c)u.set(S,S);return{uris:Object.freeze(Array.from(u.values()))}}createDiagnosticCollection(c,u){const{_collections:S,_proxy:w,_onDidChangeDiagnostics:b,_logService:d}=this,h=new class{$changeMany(i,s){w.$changeMany(i,s),d.trace("[DiagnosticCollection] change many (extension, owner, uris)",c.value,i,s.length===0?"CLEARING":s)}$clear(i){w.$clear(i),d.trace("[DiagnosticCollection] remove all (extension, owner)",c.value,i)}dispose(){w.dispose()}};let g;if(!u)u="_generated_diagnostic_collection_name_#"+Gt._idPool++,g=u;else if(!S.has(u))g=u;else{this._logService.warn(`DiagnosticCollection with name '${u}' does already exist.`);do g=u+Gt._idPool++;while(S.has(g))}return new class extends I{constructor(){super(u,g,Gt._maxDiagnosticsPerFile,h,b);S.set(g,this)}dispose(){super.dispose(),S.delete(g)}}}getDiagnostics(c){if(c)return this._getDiagnostics(c);{const u=new Map,S=[];for(const w of this._collections.values())w.forEach((b,d)=>{let h=u.get(b.toString());typeof h=="undefined"&&(h=S.length,u.set(b.toString(),h),S.push([b,[]])),S[h][1]=S[h][1].concat(...d)});return S}}_getDiagnostics(c){let u=[];for(let S of this._collections.values())S.has(c)&&(u=u.concat(S.get(c)));return u}$acceptMarkersChange(c){if(!this._mirrorCollection){const u="_generated_mirror",S=new I(u,u,Gt._maxDiagnosticsPerFile,void 0,this._onDidChangeDiagnostics);this._collections.set(u,S),this._mirrorCollection=S}for(const[u,S]of c)this._mirrorCollection.set(C.URI.revive(u),S.map(P.Diagnostic.to))}};l._idPool=0,l._maxDiagnosticsPerFile=1e3,l=Ve([We(1,k.ILogService)],l),e.ExtHostDiagnostics=l}),define(me[224],ge([0,1,2,5]),function(X,e,p,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDialogs=void 0;class C{constructor(A){this._proxy=A.getProxy(R.MainContext.MainThreadDialogs)}showOpenDialog(A){return this._proxy.$showOpenDialog(A).then(P=>P?P.map(E=>p.URI.revive(E)):void 0)}showSaveDialog(A){return this._proxy.$showSaveDialog(A).then(P=>P?p.URI.revive(P):void 0)}}e.ExtHostDialogs=C}),define(me[225],ge([0,1,14,2,7,5,10,21,8]),function(X,e,p,R,C,y,A,P,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentContentProvider=void 0;class k{constructor(I,l,f){this._documentsAndEditors=l,this._logService=f,this._documentContentProviders=new Map,this._proxy=I.getProxy(y.MainContext.MainThreadDocumentContentProviders)}registerTextDocumentContentProvider(I,l){if(Object.keys(A.Schemas).indexOf(I)>=0)throw new Error(`scheme '${I}' already registered`);const f=k._handlePool++;this._documentContentProviders.set(f,l),this._proxy.$registerTextContentProvider(f,I);let c;return typeof l.onDidChange=="function"&&(c=l.onDidChange(u=>{if(u.scheme!==I){this._logService.warn(`Provider for scheme '${I}' is firing event for schema '${u.scheme}' which will be IGNORED`);return}this._documentsAndEditors.getDocument(u)&&this.$provideTextDocumentContent(f,u).then(S=>{if(!S&&typeof S!="string")return;const w=this._documentsAndEditors.getDocument(u);if(!w)return;const b=E.splitLines(S);if(!w.equalLines(b))return this._proxy.$onVirtualDocumentChange(u,S)},p.onUnexpectedError)})),new C.Disposable(()=>{this._documentContentProviders.delete(f)&&this._proxy.$unregisterTextContentProvider(f),c&&(c.dispose(),c=void 0)})}$provideTextDocumentContent(I,l){const f=this._documentContentProviders.get(I);return f?Promise.resolve(f.provideTextDocumentContent(R.URI.revive(l),P.CancellationToken.None)):Promise.reject(new Error(`unsupported uri-scheme: ${l.scheme}`))}}e.ExtHostDocumentContentProvider=k,k._handlePool=0}),define(me[226],ge([0,1,3,6,2,5,119,17,15,25]),function(X,e,p,R,C,y,A,P,E,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocuments=void 0;class r{constructor(l,f){this._onDidAddDocument=new p.Emitter,this._onDidRemoveDocument=new p.Emitter,this._onDidChangeDocument=new p.Emitter,this._onDidSaveDocument=new p.Emitter,this.onDidAddDocument=this._onDidAddDocument.event,this.onDidRemoveDocument=this._onDidRemoveDocument.event,this.onDidChangeDocument=this._onDidChangeDocument.event,this.onDidSaveDocument=this._onDidSaveDocument.event,this._toDispose=new R.DisposableStore,this._documentLoader=new Map,this._proxy=l.getProxy(y.MainContext.MainThreadDocuments),this._documentsAndEditors=f,this._documentsAndEditors.onDidRemoveDocuments(c=>{for(const u of c)this._onDidRemoveDocument.fire(u.document)},void 0,this._toDispose),this._documentsAndEditors.onDidAddDocuments(c=>{for(const u of c)this._onDidAddDocument.fire(u.document)},void 0,this._toDispose)}dispose(){this._toDispose.dispose()}getAllDocumentData(){return[...this._documentsAndEditors.allDocuments()]}getDocumentData(l){if(!l)return;const f=this._documentsAndEditors.getDocument(l);if(f)return f}getDocument(l){const f=this.getDocumentData(l);if(!(f==null?void 0:f.document))throw new Error(`Unable to retrieve document from URI '${l}'`);return f.document}ensureDocumentData(l){const f=this._documentsAndEditors.getDocument(l);if(f)return Promise.resolve(f);let c=this._documentLoader.get(l.toString());return c||(c=this._proxy.$tryOpenDocument(l).then(u=>{this._documentLoader.delete(l.toString());const S=C.URI.revive(u);return E.assertIsDefined(this._documentsAndEditors.getDocument(S))},u=>(this._documentLoader.delete(l.toString()),Promise.reject(u))),this._documentLoader.set(l.toString(),c)),c}createDocumentData(l){return this._proxy.$tryCreateDocument(l).then(f=>C.URI.revive(f))}$acceptModelModeChanged(l,f){const c=C.URI.revive(l),u=this._documentsAndEditors.getDocument(c);if(!u)throw new Error("unknown document");this._onDidRemoveDocument.fire(u.document),u._acceptLanguageId(f),this._onDidAddDocument.fire(u.document)}$acceptModelSaved(l){const f=C.URI.revive(l),c=this._documentsAndEditors.getDocument(f);if(!c)throw new Error("unknown document");this.$acceptDirtyStateChanged(l,!1),this._onDidSaveDocument.fire(c.document)}$acceptDirtyStateChanged(l,f){const c=C.URI.revive(l),u=this._documentsAndEditors.getDocument(c);if(!u)throw new Error("unknown document");u._acceptIsDirty(f),this._onDidChangeDocument.fire({document:u.document,contentChanges:[]})}$acceptModelChanged(l,f,c){const u=C.URI.revive(l),S=this._documentsAndEditors.getDocument(u);if(!S)throw new Error("unknown document");S._acceptIsDirty(c),S.onEvents(f),this._onDidChangeDocument.fire(k.deepFreeze({document:S.document,contentChanges:f.changes.map(w=>({range:P.Range.to(w.range),rangeOffset:w.rangeOffset,rangeLength:w.rangeLength,text:w.text}))}))}setWordDefinitionFor(l,f){A.setWordDefinitionFor(l,f)}}e.ExtHostDocuments=r}),define(me[42],ge([0,1,50,3,6,2,4,5,119,13,124,17,12,23,10,52,134]),function(X,e,p,R,C,y,A,P,E,k,r,I,l,f,c,u,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDocumentsAndEditors=e.ExtHostDocumentsAndEditors=void 0;class w{constructor(h){this.value=h,this._count=0}ref(){this._count++}unref(){return--this._count==0}}let b=class{constructor(h,g){this._extHostRpc=h,this._logService=g,this._activeEditorId=null,this._editors=new Map,this._documents=new f.ResourceMap,this._onDidAddDocuments=new R.Emitter,this._onDidRemoveDocuments=new R.Emitter,this._onDidChangeVisibleTextEditors=new R.Emitter,this._onDidChangeActiveTextEditor=new R.Emitter,this.onDidAddDocuments=this._onDidAddDocuments.event,this.onDidRemoveDocuments=this._onDidRemoveDocuments.event,this.onDidChangeVisibleTextEditors=this._onDidChangeVisibleTextEditors.event,this.onDidChangeActiveTextEditor=this._onDidChangeActiveTextEditor.event}$acceptDocumentsAndEditorsDelta(h){this.acceptDocumentsAndEditorsDelta(h)}acceptDocumentsAndEditorsDelta(h){const g=[],t=[],i=[];if(h.removedDocuments)for(const s of h.removedDocuments){const n=y.URI.revive(s),o=this._documents.get(n);(o==null?void 0:o.unref())&&(this._documents.delete(n),g.push(o.value))}if(h.addedDocuments)for(const s of h.addedDocuments){const n=y.URI.revive(s.uri);let o=this._documents.get(n);if(o&&n.scheme!==c.Schemas.vscodeNotebookCell)throw new Error(`document '${n} already exists!'`);o||(o=new w(new E.ExtHostDocumentData(this._extHostRpc.getProxy(P.MainContext.MainThreadDocuments),n,s.lines,s.EOL,s.versionId,s.modeId,s.isDirty,s.notebook)),this._documents.set(n,o),t.push(o.value)),o.ref()}if(h.removedEditors)for(const s of h.removedEditors){const n=this._editors.get(s);this._editors.delete(s),n&&i.push(n)}if(h.addedEditors)for(const s of h.addedEditors){const n=y.URI.revive(s.documentUri);p.ok(this._documents.has(n),`document '${n}' does not exist`),p.ok(!this._editors.has(s.id),`editor '${s.id}' already exists!`);const o=this._documents.get(n).value,v=new r.ExtHostTextEditor(s.id,this._extHostRpc.getProxy(P.MainContext.MainThreadTextEditors),this._logService,new S.Lazy(()=>o.document),s.selections.map(I.Selection.to),s.options,s.visibleRanges.map(m=>I.Range.to(m)),typeof s.editorPosition=="number"?I.ViewColumn.to(s.editorPosition):void 0);this._editors.set(s.id,v)}h.newActiveEditor!==void 0&&(p.ok(h.newActiveEditor===null||this._editors.has(h.newActiveEditor),`active editor '${h.newActiveEditor}' does not exist`),this._activeEditorId=h.newActiveEditor),C.dispose(g),C.dispose(i),h.removedDocuments&&this._onDidRemoveDocuments.fire(g),h.addedDocuments&&this._onDidAddDocuments.fire(t),(h.removedEditors||h.addedEditors)&&this._onDidChangeVisibleTextEditors.fire(this.allEditors().map(s=>s.value)),h.newActiveEditor!==void 0&&this._onDidChangeActiveTextEditor.fire(this.activeEditor())}getDocument(h){var g;return(g=this._documents.get(h))===null||g===void 0?void 0:g.value}allDocuments(){return u.Iterable.map(this._documents.values(),h=>h.value)}getEditor(h){return this._editors.get(h)}activeEditor(h){if(!this._activeEditorId)return;const g=this._editors.get(this._activeEditorId);return h?g:g==null?void 0:g.value}allEditors(){return[...this._editors.values()]}};b=Ve([We(0,k.IExtHostRpcService),We(1,l.ILogService)],b),e.ExtHostDocumentsAndEditors=b,e.IExtHostDocumentsAndEditors=A.createDecorator("IExtHostDocumentsAndEditors")}),define(me[227],ge([0,1,2,5,6,7,17,142,8,22]),function(X,e,p,R,C,y,A,P,E,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystem=void 0;class r{constructor(){this._schemes=[]}add(f){this._stateMachine=void 0,this._schemes.push(f)}delete(f){const c=this._schemes.indexOf(f);c>=0&&(this._schemes.splice(c,1),this._stateMachine=void 0)}_initStateMachine(){if(!this._stateMachine){const f=this._schemes.sort(),c=[];let u,S,w=14,b=14;for(const d of f){let h=u?E.commonPrefixLength(u,d):0;for(h===0?S=1:S=b;h<d.length;h++)h+1===d.length?(w=b,b=9):b+=1,c.push([S,d.toUpperCase().charCodeAt(h),b]),c.push([S,d.toLowerCase().charCodeAt(h),b]),S=b;u=d,b=w}c.push([9,58,10]),c.push([10,47,12]),this._stateMachine=new P.StateMachine(c)}}provideDocumentLinks(f){this._initStateMachine();const c=[],u=P.LinkComputer.computeLinks({getLineContent(S){return f.lineAt(S-1).text},getLineCount(){return f.lineCount}},this._stateMachine);for(const S of u){const w=A.DocumentLink.to(S);w.target&&c.push(w)}return c}}class I{constructor(f,c){this._extHostLanguageFeatures=c,this._linkProvider=new r,this._fsProvider=new Map,this._registeredSchemes=new Set,this._watches=new Map,this._enableProposedApi=new Map,this._handlePool=0,this._proxy=f.getProxy(R.MainContext.MainThreadFileSystem)}dispose(){var f;(f=this._linkProviderRegistration)===null||f===void 0||f.dispose()}_registerLinkProviderIfNotYetRegistered(){this._linkProviderRegistration||(this._linkProviderRegistration=this._extHostLanguageFeatures.registerDocumentLinkProvider(void 0,"*",this._linkProvider))}registerFileSystemProvider(f,c,u,S={},w){if(this._registeredSchemes.has(c))throw new Error(`a provider for the scheme '${c}' is already registered`);this._registerLinkProviderIfNotYetRegistered();const b=this._handlePool++;this._linkProvider.add(c),this._registeredSchemes.add(c),this._fsProvider.set(b,u),this._enableProposedApi.set(b,w??!1);let d=2;S.isCaseSensitive&&(d+=1024),S.isReadonly&&(d+=2048),typeof u.copy=="function"&&(d+=8),typeof u.open=="function"&&typeof u.close=="function"&&typeof u.read=="function"&&typeof u.write=="function"&&(d+=4),this._proxy.$registerFileSystemProvider(b,c,d).catch(g=>{console.error(`FAILED to register filesystem provider of ${f.value}-extension for the scheme ${c}`),console.error(g)});const h=u.onDidChangeFile(g=>{const t=[];for(const i of g){let{uri:s,type:n}=i;if(s.scheme!==c)continue;let o;switch(n){case y.FileChangeType.Changed:o=0;break;case y.FileChangeType.Created:o=1;break;case y.FileChangeType.Deleted:o=2;break;default:throw new Error("Unknown FileChangeType")}t.push({resource:s,type:o})}this._proxy.$onFileSystemChange(b,t)});return C.toDisposable(()=>{h.dispose(),this._linkProvider.delete(c),this._registeredSchemes.delete(c),this._fsProvider.delete(b),this._enableProposedApi.delete(b),this._proxy.$unregisterProvider(b)})}static _asIStat(f,c){const{type:u,ctime:S,mtime:w,size:b,permissions:d}=f;return c?{type:u,ctime:S,mtime:w,size:b,permissions:d}:{type:u,ctime:S,mtime:w,size:b}}$stat(f,c){return Promise.resolve(this._getFsProvider(f).stat(p.URI.revive(c))).then(u=>{var S;return I._asIStat(u,(S=this._enableProposedApi.get(f))!==null&&S!==void 0?S:!1)})}$readdir(f,c){return Promise.resolve(this._getFsProvider(f).readDirectory(p.URI.revive(c)))}$readFile(f,c){return Promise.resolve(this._getFsProvider(f).readFile(p.URI.revive(c))).then(u=>k.VSBuffer.wrap(u))}$writeFile(f,c,u,S){return Promise.resolve(this._getFsProvider(f).writeFile(p.URI.revive(c),u.buffer,S))}$delete(f,c,u){return Promise.resolve(this._getFsProvider(f).delete(p.URI.revive(c),u))}$rename(f,c,u,S){return Promise.resolve(this._getFsProvider(f).rename(p.URI.revive(c),p.URI.revive(u),S))}$copy(f,c,u,S){const w=this._getFsProvider(f);if(!w.copy)throw new Error('FileSystemProvider does not implement "copy"');return Promise.resolve(w.copy(p.URI.revive(c),p.URI.revive(u),S))}$mkdir(f,c){return Promise.resolve(this._getFsProvider(f).createDirectory(p.URI.revive(c)))}$watch(f,c,u,S){const w=this._getFsProvider(f).watch(p.URI.revive(u),S);this._watches.set(c,w)}$unwatch(f,c){const u=this._watches.get(c);u&&(u.dispose(),this._watches.delete(c))}$open(f,c,u){const S=this._getFsProvider(f);if(!S.open)throw new Error('FileSystemProvider does not implement "open"');return Promise.resolve(S.open(p.URI.revive(c),u))}$close(f,c){const u=this._getFsProvider(f);if(!u.close)throw new Error('FileSystemProvider does not implement "close"');return Promise.resolve(u.close(c))}$read(f,c,u,S){const w=this._getFsProvider(f);if(!w.read)throw new Error('FileSystemProvider does not implement "read"');const b=k.VSBuffer.alloc(S);return Promise.resolve(w.read(c,u,b.buffer,0,S)).then(d=>b.slice(0,d))}$write(f,c,u,S){const w=this._getFsProvider(f);if(!w.write)throw new Error('FileSystemProvider does not implement "write"');return Promise.resolve(w.write(c,u,S.buffer,0,S.byteLength))}_getFsProvider(f){const c=this._fsProvider.get(f);if(!c){const u=new Error;throw u.name="ENOPRO",u.message="no provider",u}return c}}e.ExtHostFileSystem=I}),define(me[86],ge([0,1,5,41,7,22,4,13,59]),function(X,e,p,R,C,y,A,P,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConsumerFileSystem=e.ExtHostConsumerFileSystem=void 0;let k=class xt{constructor(I,l){const f=I.getProxy(p.MainContext.MainThreadFileSystem);this.value=Object.freeze({stat(c){return f.$stat(c).catch(xt._handleError)},readDirectory(c){return f.$readdir(c).catch(xt._handleError)},createDirectory(c){return f.$mkdir(c).catch(xt._handleError)},async readFile(c){return f.$readFile(c).then(u=>u.buffer).catch(xt._handleError)},writeFile(c,u){return f.$writeFile(c,y.VSBuffer.wrap(u)).catch(xt._handleError)},delete(c,u){return f.$delete(c,Object.assign({recursive:!1,useTrash:!1},u)).catch(xt._handleError)},rename(c,u,S){return f.$rename(c,u,Object.assign({overwrite:!1},S)).catch(xt._handleError)},copy(c,u,S){return f.$copy(c,u,Object.assign({overwrite:!1},S)).catch(xt._handleError)},isWritableFileSystem(c){const u=l.getCapabilities(c);if(typeof u=="number")return!(u&2048)}})}static _handleError(I){if(!(I instanceof Error))throw new C.FileSystemError(String(I));if(I.name==="ENOPRO")throw C.FileSystemError.Unavailable(I.message);switch(I.name){case R.FileSystemProviderErrorCode.FileExists:throw C.FileSystemError.FileExists(I.message);case R.FileSystemProviderErrorCode.FileNotFound:throw C.FileSystemError.FileNotFound(I.message);case R.FileSystemProviderErrorCode.FileNotADirectory:throw C.FileSystemError.FileNotADirectory(I.message);case R.FileSystemProviderErrorCode.FileIsADirectory:throw C.FileSystemError.FileIsADirectory(I.message);case R.FileSystemProviderErrorCode.NoPermissions:throw C.FileSystemError.NoPermissions(I.message);case R.FileSystemProviderErrorCode.Unavailable:throw C.FileSystemError.Unavailable(I.message);default:throw new C.FileSystemError(I.message,I.name)}}};k=Ve([We(0,P.IExtHostRpcService),We(1,E.IExtHostFileSystemInfo)],k),e.ExtHostConsumerFileSystem=k,e.IExtHostConsumerFileSystem=A.createDecorator("IExtHostConsumerFileSystem")}),define(me[228],ge([0,1,6,5]),function(X,e,p,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLabelService=void 0;class C{constructor(A){this._handlePool=0,this._proxy=A.getProxy(R.MainContext.MainThreadLabelService)}$registerResourceLabelFormatter(A){const P=this._handlePool++;return this._proxy.$registerResourceLabelFormatter(P,A),p.toDisposable(()=>{this._proxy.$unregisterResourceLabelFormatter(P)})}}e.ExtHostLabelService=C}),define(me[229],ge([0,1,2,25,17,7,16,5,8,40,18,15,139,6,107,70,82,43,14,3]),function(X,e,p,R,C,y,A,P,E,k,r,I,l,f,c,u,S,w,b,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguageFeatures=e.InlineCompletionController=e.DocumentRangeSemanticTokensAdapter=e.DocumentSemanticTokensAdapter=void 0;class h{constructor(V,Z){this._documents=V,this._provider=Z}provideDocumentSymbols(V,Z){const ne=this._documents.getDocument(V);return A.asPromise(()=>this._provider.provideDocumentSymbols(ne,Z)).then(se=>{if(!r.isFalsyOrEmpty(se))return se[0]instanceof y.DocumentSymbol?se.map(C.DocumentSymbol.from):h._asDocumentSymbolTree(se)})}static _asDocumentSymbolTree(V){var Z;V=V.slice(0).sort((J,ae)=>{let he=J.location.range.start.compareTo(ae.location.range.start);return he===0&&(he=ae.location.range.end.compareTo(J.location.range.end)),he});const ne=[],se=[];for(const J of V){const ae={name:J.name||"!!MISSING: name!!",kind:C.SymbolKind.from(J.kind),tags:((Z=J.tags)===null||Z===void 0?void 0:Z.map(C.SymbolTag.from))||[],detail:"",containerName:J.containerName,range:C.Range.from(J.location.range),selectionRange:C.Range.from(J.location.range),children:[]};for(;;){if(se.length===0){se.push(ae),ne.push(ae);break}const he=se[se.length-1];if(k.Range.containsRange(he.range,ae.range)&&!k.Range.equalsRange(he.range,ae.range)){he.children&&he.children.push(ae),se.push(ae);break}se.pop()}}return ne}}class g{constructor(V,Z,ne){this._documents=V,this._commands=Z,this._provider=ne,this._cache=new S.Cache("CodeLens"),this._disposables=new Map}async provideCodeLenses(V,Z){const ne=this._documents.getDocument(V),se=await this._provider.provideCodeLenses(ne,Z);if(!se||Z.isCancellationRequested)return;const J=this._cache.add(se),ae=new f.DisposableStore;this._disposables.set(J,ae);const he={cacheId:J,lenses:[]};for(let Fe=0;Fe<se.length;Fe++)he.lenses.push({cacheId:[J,Fe],range:C.Range.from(se[Fe].range),command:this._commands.toInternal(se[Fe].command,ae)});return he}async resolveCodeLens(V,Z){var ne;const se=V.cacheId&&this._cache.get(...V.cacheId);if(!se)return;let J;if(typeof this._provider.resolveCodeLens!="function"||se.isResolved?J=se:J=await this._provider.resolveCodeLens(se,Z),J||(J=se),Z.isCancellationRequested)return;const ae=V.cacheId&&this._disposables.get(V.cacheId[0]);if(!!ae)return V.command=this._commands.toInternal((ne=J.command)!==null&&ne!==void 0?ne:g._badCmd,ae),V}releaseCodeLenses(V){var Z;(Z=this._disposables.get(V))===null||Z===void 0||Z.dispose(),this._disposables.delete(V),this._cache.delete(V)}}g._badCmd={command:"missing",title:"!!MISSING: command!!"};function t(Ge){return Array.isArray(Ge)?Ge.map(C.DefinitionLink.from):Ge?[C.DefinitionLink.from(Ge)]:[]}class i{constructor(V,Z){this._documents=V,this._provider=Z}provideDefinition(V,Z,ne){const se=this._documents.getDocument(V),J=C.Position.to(Z);return A.asPromise(()=>this._provider.provideDefinition(se,J,ne)).then(t)}}class s{constructor(V,Z){this._documents=V,this._provider=Z}provideDeclaration(V,Z,ne){const se=this._documents.getDocument(V),J=C.Position.to(Z);return A.asPromise(()=>this._provider.provideDeclaration(se,J,ne)).then(t)}}class n{constructor(V,Z){this._documents=V,this._provider=Z}provideImplementation(V,Z,ne){const se=this._documents.getDocument(V),J=C.Position.to(Z);return A.asPromise(()=>this._provider.provideImplementation(se,J,ne)).then(t)}}class o{constructor(V,Z){this._documents=V,this._provider=Z}provideTypeDefinition(V,Z,ne){const se=this._documents.getDocument(V),J=C.Position.to(Z);return A.asPromise(()=>this._provider.provideTypeDefinition(se,J,ne)).then(t)}}class v{constructor(V,Z){this._documents=V,this._provider=Z}provideHover(V,Z,ne){const se=this._documents.getDocument(V),J=C.Position.to(Z);return A.asPromise(()=>this._provider.provideHover(se,J,ne)).then(ae=>{if(!(!ae||r.isFalsyOrEmpty(ae.contents)))return ae.range||(ae.range=se.getWordRangeAtPosition(J)),ae.range||(ae.range=new y.Range(J,J)),C.Hover.from(ae)})}}class m{constructor(V,Z){this._documents=V,this._provider=Z}provideEvaluatableExpression(V,Z,ne){const se=this._documents.getDocument(V),J=C.Position.to(Z);return A.asPromise(()=>this._provider.provideEvaluatableExpression(se,J,ne)).then(ae=>{if(ae)return C.EvaluatableExpression.from(ae)})}}class _{constructor(V,Z){this._documents=V,this._provider=Z}provideInlineValues(V,Z,ne,se){const J=this._documents.getDocument(V);return A.asPromise(()=>this._provider.provideInlineValues(J,C.Range.to(Z),C.InlineValueContext.to(ne),se)).then(ae=>{if(Array.isArray(ae))return ae.map(he=>C.InlineValue.from(he))})}}class D{constructor(V,Z){this._documents=V,this._provider=Z}provideDocumentHighlights(V,Z,ne){const se=this._documents.getDocument(V),J=C.Position.to(Z);return A.asPromise(()=>this._provider.provideDocumentHighlights(se,J,ne)).then(ae=>{if(Array.isArray(ae))return ae.map(C.DocumentHighlight.from)})}}class a{constructor(V,Z){this._documents=V,this._provider=Z}provideLinkedEditingRanges(V,Z,ne){const se=this._documents.getDocument(V),J=C.Position.to(Z);return A.asPromise(()=>this._provider.provideLinkedEditingRanges(se,J,ne)).then(ae=>{if(ae&&Array.isArray(ae.ranges))return{ranges:r.coalesce(ae.ranges.map(C.Range.from)),wordPattern:ae.wordPattern}})}}class T{constructor(V,Z){this._documents=V,this._provider=Z}provideReferences(V,Z,ne,se){const J=this._documents.getDocument(V),ae=C.Position.to(Z);return A.asPromise(()=>this._provider.provideReferences(J,ae,ne,se)).then(he=>{if(Array.isArray(he))return he.map(C.location.from)})}}class L{constructor(V,Z,ne,se,J,ae,he){this._documents=V,this._commands=Z,this._diagnostics=ne,this._provider=se,this._logService=J,this._extension=ae,this._apiDeprecation=he,this._cache=new S.Cache("CodeAction"),this._disposables=new Map}provideCodeActions(V,Z,ne,se){const J=this._documents.getDocument(V),ae=l.Selection.isISelection(Z)?C.Selection.to(Z):C.Range.to(Z),he=[];for(const He of this._diagnostics.getDiagnostics(V))if(ae.intersection(He.range)&&he.push(He)>L._maxCodeActionsPerFile)break;const Fe={diagnostics:he,only:ne.only?new y.CodeActionKind(ne.only):void 0,triggerKind:C.CodeActionTriggerKind.to(ne.trigger)};return A.asPromise(()=>this._provider.provideCodeActions(J,ae,Fe,se)).then(He=>{var _e;if(!r.isNonEmptyArray(He)||se.isCancellationRequested)return;const Ye=this._cache.add(He),K=new f.DisposableStore;this._disposables.set(Ye,K);const ie=[];for(let ve=0;ve<He.length;ve++){const Me=He[ve];!Me||(L._isCommand(Me)?(this._apiDeprecation.report("CodeActionProvider.provideCodeActions - return commands",this._extension,"Return 'CodeAction' instances instead."),ie.push({_isSynthetic:!0,title:Me.title,command:this._commands.toInternal(Me,K)})):(Fe.only&&(Me.kind?Fe.only.contains(Me.kind)||this._logService.warn(`${this._extension.identifier.value} - Code actions of kind '${Fe.only.value} 'requested but returned code action is of kind '${Me.kind.value}'. Code action will be dropped. Please check 'CodeActionContext.only' to only return requested code actions.`):this._logService.warn(`${this._extension.identifier.value} - Code actions of kind '${Fe.only.value} 'requested but returned code action does not have a 'kind'. Code action will be dropped. Please set 'CodeAction.kind'.`)),ie.push({cacheId:[Ye,ve],title:Me.title,command:Me.command&&this._commands.toInternal(Me.command,K),diagnostics:Me.diagnostics&&Me.diagnostics.map(C.Diagnostic.from),edit:Me.edit&&C.WorkspaceEdit.from(Me.edit),kind:Me.kind&&Me.kind.value,isPreferred:Me.isPreferred,disabled:(_e=Me.disabled)===null||_e===void 0?void 0:_e.reason})))}return{cacheId:Ye,actions:ie}})}async resolveCodeAction(V,Z){var ne;const[se,J]=V,ae=this._cache.get(se,J);if(!ae||L._isCommand(ae)||!this._provider.resolveCodeAction)return;const he=(ne=await this._provider.resolveCodeAction(ae,Z))!==null&&ne!==void 0?ne:ae;return(he==null?void 0:he.edit)?C.WorkspaceEdit.from(he.edit):void 0}releaseCodeActions(V){var Z;(Z=this._disposables.get(V))===null||Z===void 0||Z.dispose(),this._disposables.delete(V),this._cache.delete(V)}static _isCommand(V){return typeof V.command=="string"&&typeof V.title=="string"}}L._maxCodeActionsPerFile=1e3;class U{constructor(V,Z){this._documents=V,this._provider=Z}provideDocumentFormattingEdits(V,Z,ne){const se=this._documents.getDocument(V);return A.asPromise(()=>this._provider.provideDocumentFormattingEdits(se,Z,ne)).then(J=>{if(Array.isArray(J))return J.map(C.TextEdit.from)})}}class G{constructor(V,Z){this._documents=V,this._provider=Z}provideDocumentRangeFormattingEdits(V,Z,ne,se){const J=this._documents.getDocument(V),ae=C.Range.to(Z);return A.asPromise(()=>this._provider.provideDocumentRangeFormattingEdits(J,ae,ne,se)).then(he=>{if(Array.isArray(he))return he.map(C.TextEdit.from)})}}class ee{constructor(V,Z){this._documents=V,this._provider=Z,this.autoFormatTriggerCharacters=[]}provideOnTypeFormattingEdits(V,Z,ne,se,J){const ae=this._documents.getDocument(V),he=C.Position.to(Z);return A.asPromise(()=>this._provider.provideOnTypeFormattingEdits(ae,he,ne,se,J)).then(Fe=>{if(Array.isArray(Fe))return Fe.map(C.TextEdit.from)})}}class z{constructor(V,Z){this._provider=V,this._logService=Z,this._symbolCache=new Map,this._resultCache=new Map}provideWorkspaceSymbols(V,Z){const ne=P.IdObject.mixin({symbols:[]});return A.asPromise(()=>this._provider.provideWorkspaceSymbols(V,Z)).then(se=>{if(r.isNonEmptyArray(se))for(const J of se){if(!J)continue;if(!J.name){this._logService.warn("INVALID SymbolInformation, lacks name",J);continue}const ae=P.IdObject.mixin(C.WorkspaceSymbol.from(J));this._symbolCache.set(ae._id,J),ne.symbols.push(ae)}}).then(()=>(ne.symbols.length>0&&this._resultCache.set(ne._id,[ne.symbols[0]._id,ne.symbols[ne.symbols.length-1]._id]),ne))}async resolveWorkspaceSymbol(V,Z){if(typeof this._provider.resolveWorkspaceSymbol!="function")return V;const ne=this._symbolCache.get(V._id);if(ne){const se=await A.asPromise(()=>this._provider.resolveWorkspaceSymbol(ne,Z));return se&&R.mixin(V,C.WorkspaceSymbol.from(se),!0)}}releaseWorkspaceSymbols(V){const Z=this._resultCache.get(V);if(Z){for(let[ne,se]=Z;ne<=se;ne++)this._symbolCache.delete(ne);this._resultCache.delete(V)}}}class N{constructor(V,Z,ne){this._documents=V,this._provider=Z,this._logService=ne}static supportsResolving(V){return typeof V.prepareRename=="function"}provideRenameEdits(V,Z,ne,se){const J=this._documents.getDocument(V),ae=C.Position.to(Z);return A.asPromise(()=>this._provider.provideRenameEdits(J,ae,ne,se)).then(he=>{if(!!he)return C.WorkspaceEdit.from(he)},he=>{const Fe=N._asMessage(he);return Fe?{rejectReason:Fe,edits:void 0}:Promise.reject(he)})}resolveRenameLocation(V,Z,ne){if(typeof this._provider.prepareRename!="function")return Promise.resolve(void 0);const se=this._documents.getDocument(V),J=C.Position.to(Z);return A.asPromise(()=>this._provider.prepareRename(se,J,ne)).then(ae=>{let he,Fe;if(y.Range.isRange(ae)?(he=ae,Fe=se.getText(ae)):I.isObject(ae)&&(he=ae.range,Fe=ae.placeholder),!!he){if(he.start.line>J.line||he.end.line<J.line){this._logService.warn("INVALID rename location: position line must be within range start/end lines");return}return{range:C.Range.from(he),text:Fe}}},ae=>{const he=N._asMessage(ae);return he?{rejectReason:he,range:void 0,text:void 0}:Promise.reject(ae)})}static _asMessage(V){return typeof V=="string"?V:V instanceof Error&&typeof V.message=="string"?V.message:void 0}}class W{constructor(V,Z){this.resultId=V,this.tokens=Z}}class M{constructor(V,Z){this._documents=V,this._provider=Z,this._nextResultId=1,this._previousResults=new Map}provideDocumentSemanticTokens(V,Z,ne){const se=this._documents.getDocument(V),J=Z!==0?this._previousResults.get(Z):null;return A.asPromise(()=>J&&typeof J.resultId=="string"&&typeof this._provider.provideDocumentSemanticTokensEdits=="function"?this._provider.provideDocumentSemanticTokensEdits(se,J.resultId,ne):this._provider.provideDocumentSemanticTokens(se,ne)).then(ae=>(J&&this._previousResults.delete(Z),ae?(ae=M._fixProvidedSemanticTokens(ae),this._send(M._convertToEdits(J,ae),ae)):null))}async releaseDocumentSemanticColoring(V){this._previousResults.delete(V)}static _fixProvidedSemanticTokens(V){return M._isSemanticTokens(V)?M._isCorrectSemanticTokens(V)?V:new y.SemanticTokens(new Uint32Array(V.data),V.resultId):M._isSemanticTokensEdits(V)?M._isCorrectSemanticTokensEdits(V)?V:new y.SemanticTokensEdits(V.edits.map(Z=>new y.SemanticTokensEdit(Z.start,Z.deleteCount,Z.data?new Uint32Array(Z.data):Z.data)),V.resultId):V}static _isSemanticTokens(V){return V&&!!V.data}static _isCorrectSemanticTokens(V){return V.data instanceof Uint32Array}static _isSemanticTokensEdits(V){return V&&Array.isArray(V.edits)}static _isCorrectSemanticTokensEdits(V){for(const Z of V.edits)if(!(Z.data instanceof Uint32Array))return!1;return!0}static _convertToEdits(V,Z){if(!M._isSemanticTokens(Z)||!V||!V.tokens)return Z;const ne=V.tokens,se=ne.length,J=Z.data,ae=J.length;let he=0;const Fe=Math.min(se,ae);for(;he<Fe&&ne[he]===J[he];)he++;if(he===se&&he===ae)return new y.SemanticTokensEdits([],Z.resultId);let He=0;const _e=Fe-he;for(;He<_e&&ne[se-He-1]===J[ae-He-1];)He++;return new y.SemanticTokensEdits([{start:he,deleteCount:se-he-He,data:J.subarray(he,ae-He)}],Z.resultId)}_send(V,Z){if(M._isSemanticTokens(V)){const ne=this._nextResultId++;return this._previousResults.set(ne,new W(V.resultId,V.data)),c.encodeSemanticTokensDto({id:ne,type:"full",data:V.data})}if(M._isSemanticTokensEdits(V)){const ne=this._nextResultId++;return M._isSemanticTokens(Z)?this._previousResults.set(ne,new W(Z.resultId,Z.data)):this._previousResults.set(ne,new W(V.resultId)),c.encodeSemanticTokensDto({id:ne,type:"delta",deltas:(V.edits||[]).map(se=>({start:se.start,deleteCount:se.deleteCount,data:se.data}))})}return null}}e.DocumentSemanticTokensAdapter=M;class j{constructor(V,Z){this._documents=V,this._provider=Z}provideDocumentRangeSemanticTokens(V,Z,ne){const se=this._documents.getDocument(V);return A.asPromise(()=>this._provider.provideDocumentRangeSemanticTokens(se,C.Range.to(Z),ne)).then(J=>J?this._send(J):null)}_send(V){return c.encodeSemanticTokensDto({id:0,type:"full",data:V.data})}}e.DocumentRangeSemanticTokensAdapter=j;class O{constructor(V,Z,ne,se,J){this._documents=V,this._commands=Z,this._provider=ne,this._apiDeprecation=se,this._extension=J,this._cache=new S.Cache("CompletionItem"),this._disposables=new Map}static supportsResolving(V){return typeof V.resolveCompletionItem=="function"}async provideCompletionItems(V,Z,ne,se){const J=this._documents.getDocument(V),ae=C.Position.to(Z),he=J.getWordRangeAtPosition(ae)||new y.Range(ae,ae),Fe=he.with({end:ae}),He=new w.StopWatch(!0),_e=await A.asPromise(()=>this._provider.provideCompletionItems(J,ae,se,C.CompletionContext.to(ne)));if(!_e||se.isCancellationRequested)return;const Ye=Array.isArray(_e)?new y.CompletionList(_e):_e,K=O.supportsResolving(this._provider)?this._cache.add(Ye.items):this._cache.add([]),ie=new f.DisposableStore;this._disposables.set(K,ie);const ve=[],Me={x:K,b:ve,a:{replace:C.Range.from(he),insert:C.Range.from(Fe)},c:Ye.isIncomplete||void 0,d:He.elapsed()};for(let xe=0;xe<Ye.items.length;xe++){const Je=Ye.items[xe],ke=this._convertCompletionItem(Je,[K,xe],Fe,he);ve.push(ke)}return Me}async resolveCompletionItem(V,Z){if(typeof this._provider.resolveCompletionItem!="function")return;const ne=this._cache.get(...V);if(!ne)return;const se=await A.asPromise(()=>this._provider.resolveCompletionItem(ne,Z));if(!!se)return this._convertCompletionItem(se,V)}releaseCompletionItems(V){var Z;(Z=this._disposables.get(V))===null||Z===void 0||Z.dispose(),this._disposables.delete(V),this._cache.delete(V)}_convertCompletionItem(V,Z,ne,se){const J=this._disposables.get(Z[0]);if(!J)throw Error("DisposableStore is missing...");const ae={x:Z,a:V.label,b:V.kind!==void 0?C.CompletionItemKind.from(V.kind):void 0,n:V.tags&&V.tags.map(C.CompletionItemTag.from),c:V.detail,d:typeof V.documentation=="undefined"?void 0:C.MarkdownString.fromStrict(V.documentation),e:V.sortText!==V.label?V.sortText:void 0,f:V.filterText!==V.label?V.filterText:void 0,g:V.preselect||void 0,i:V.keepWhitespace?1:0,k:V.commitCharacters,l:V.additionalTextEdits&&V.additionalTextEdits.map(C.TextEdit.from),m:this._commands.toInternal(V.command,J)};V.textEdit?(this._apiDeprecation.report("CompletionItem.textEdit",this._extension,"Use 'CompletionItem.insertText' and 'CompletionItem.range' instead."),ae.h=V.textEdit.newText):typeof V.insertText=="string"?ae.h=V.insertText:V.insertText instanceof y.SnippetString&&(ae.h=V.insertText.value,ae.i|=4);let he;return V.textEdit?he=V.textEdit.range:V.range&&(he=V.range),y.Range.isRange(he)?ae.j=C.Range.from(he):he&&(!(ne==null?void 0:ne.isEqual(he.inserting))||!(se==null?void 0:se.isEqual(he.replacing)))&&(ae.j={insert:C.Range.from(he.inserting),replace:C.Range.from(he.replacing)}),ae}}class F{constructor(V,Z,ne){this._documents=V,this._provider=Z,this._commands=ne,this._cache=new S.Cache("InlineCompletionItem"),this._disposables=new Map}async provideInlineCompletions(V,Z,ne,se){const J=this._documents.getDocument(V),ae=C.Position.to(Z),he=await A.asPromise(()=>this._provider.provideInlineCompletionItems(J,ae,ne,se));if(!he||se.isCancellationRequested)return;const Fe=I.isArray(he)?{items:he}:he,He=this._cache.add(Fe.items);let _e;return{pid:He,items:Fe.items.map((Ye,K)=>{let ie;return Ye.command&&(_e||(_e=new f.DisposableStore,this._disposables.set(He,_e)),ie=this._commands.toInternal(Ye.command,_e)),{text:Ye.text,range:Ye.range?C.Range.from(Ye.range):void 0,command:ie,idx:K}})}}disposeCompletions(V){this._cache.delete(V);const Z=this._disposables.get(V);Z&&Z.clear(),this._disposables.delete(V)}handleDidShowCompletionItem(V,Z){const ne=this._cache.get(V,Z);ne&&B.get(this._provider).fireOnDidShowCompletionItem({completionItem:ne})}}class B{constructor(){this._onDidShowCompletionItemEmitter=new d.Emitter,this.onDidShowCompletionItem=this._onDidShowCompletionItemEmitter.event}static get(V){let Z=B.map.get(V);return Z||(Z=new B,B.map.set(V,Z)),Z}fireOnDidShowCompletionItem(V){this._onDidShowCompletionItemEmitter.fire(V)}}e.InlineCompletionController=B,B.map=new WeakMap;class ${constructor(V,Z){this._documents=V,this._provider=Z,this._cache=new S.Cache("SignatureHelp")}provideSignatureHelp(V,Z,ne,se){const J=this._documents.getDocument(V),ae=C.Position.to(Z),he=this.reviveContext(ne);return A.asPromise(()=>this._provider.provideSignatureHelp(J,ae,se,he)).then(Fe=>{if(Fe){const He=this._cache.add([Fe]);return Object.assign(Object.assign({},C.SignatureHelp.from(Fe)),{id:He})}})}reviveContext(V){let Z;if(V.activeSignatureHelp){const ne=C.SignatureHelp.to(V.activeSignatureHelp),se=this._cache.get(V.activeSignatureHelp.id,0);se?(Z=se,Z.activeSignature=ne.activeSignature,Z.activeParameter=ne.activeParameter):Z=ne}return Object.assign(Object.assign({},V),{activeSignatureHelp:Z})}releaseSignatureHelp(V){this._cache.delete(V)}}class Y{constructor(V,Z){this._documents=V,this._provider=Z}provideInlayHints(V,Z,ne){const se=this._documents.getDocument(V);return A.asPromise(()=>this._provider.provideInlayHints(se,C.Range.to(Z),ne)).then(J=>J?{hints:J.map(C.InlayHint.from)}:void 0)}}class le{constructor(V,Z){this._documents=V,this._provider=Z,this._cache=new S.Cache("DocumentLink")}async provideLinks(V,Z){const ne=this._documents.getDocument(V),se=await A.asPromise(()=>this._provider.provideDocumentLinks(ne,Z));if(!(!Array.isArray(se)||se.length===0)&&!Z.isCancellationRequested){if(typeof this._provider.resolveDocumentLink!="function")return{links:se.filter(le._validateLink).map(C.DocumentLink.from)};{const J=this._cache.add(se),ae={links:[],id:J};for(let he=0;he<se.length;he++){if(!le._validateLink(se[he]))continue;const Fe=C.DocumentLink.from(se[he]);Fe.cacheId=[J,he],ae.links.push(Fe)}return ae}}}static _validateLink(V){return V.target&&V.target.path.length>5e4?(console.warn("DROPPING link because it is too long"),!1):!0}async resolveLink(V,Z){if(typeof this._provider.resolveDocumentLink!="function")return;const ne=this._cache.get(...V);if(!ne)return;const se=await A.asPromise(()=>this._provider.resolveDocumentLink(ne,Z));if(!(!se||!le._validateLink(se)))return C.DocumentLink.from(se)}releaseLinks(V){this._cache.delete(V)}}class be{constructor(V,Z){this._documents=V,this._provider=Z}provideColors(V,Z){const ne=this._documents.getDocument(V);return A.asPromise(()=>this._provider.provideDocumentColors(ne,Z)).then(se=>Array.isArray(se)?se.map(ae=>({color:C.Color.from(ae.color),range:C.Range.from(ae.range)})):[])}provideColorPresentations(V,Z,ne){const se=this._documents.getDocument(V),J=C.Range.to(Z.range),ae=C.Color.to(Z.color);return A.asPromise(()=>this._provider.provideColorPresentations(ae,{document:se,range:J},ne)).then(he=>{if(!!Array.isArray(he))return he.map(C.ColorPresentation.from)})}}class Le{constructor(V,Z){this._documents=V,this._provider=Z}provideFoldingRanges(V,Z,ne){const se=this._documents.getDocument(V);return A.asPromise(()=>this._provider.provideFoldingRanges(se,Z,ne)).then(J=>{if(!!Array.isArray(J))return J.map(C.FoldingRange.from)})}}class Ie{constructor(V,Z,ne){this._documents=V,this._provider=Z,this._logService=ne}provideSelectionRanges(V,Z,ne){const se=this._documents.getDocument(V),J=Z.map(C.Position.to);return A.asPromise(()=>this._provider.provideSelectionRanges(se,J,ne)).then(ae=>{if(!r.isNonEmptyArray(ae))return[];if(ae.length!==J.length)return this._logService.warn("BAD selection ranges, provider must return ranges for each position"),[];const he=[];for(let Fe=0;Fe<J.length;Fe++){const He=[];he.push(He);let _e=J[Fe],Ye=ae[Fe];for(;;){if(!Ye.range.contains(_e))throw new Error("INVALID selection range, must contain the previous range");if(He.push(C.SelectionRange.from(Ye)),!Ye.parent)break;_e=Ye.range,Ye=Ye.parent}}return he})}}class Ue{constructor(V,Z){this._documents=V,this._provider=Z,this._idPool=new u.IdGenerator(""),this._cache=new Map}async prepareSession(V,Z,ne){const se=this._documents.getDocument(V),J=C.Position.to(Z),ae=await this._provider.prepareCallHierarchy(se,J,ne);if(!ae)return;const he=this._idPool.nextId();return this._cache.set(he,new Map),Array.isArray(ae)?ae.map(Fe=>this._cacheAndConvertItem(he,Fe)):[this._cacheAndConvertItem(he,ae)]}async provideCallsTo(V,Z,ne){const se=this._itemFromCache(V,Z);if(!se)throw new Error("missing call hierarchy item");const J=await this._provider.provideCallHierarchyIncomingCalls(se,ne);if(!!J)return J.map(ae=>({from:this._cacheAndConvertItem(V,ae.from),fromRanges:ae.fromRanges.map(he=>C.Range.from(he))}))}async provideCallsFrom(V,Z,ne){const se=this._itemFromCache(V,Z);if(!se)throw new Error("missing call hierarchy item");const J=await this._provider.provideCallHierarchyOutgoingCalls(se,ne);if(!!J)return J.map(ae=>({to:this._cacheAndConvertItem(V,ae.to),fromRanges:ae.fromRanges.map(he=>C.Range.from(he))}))}releaseSession(V){this._cache.delete(V)}_cacheAndConvertItem(V,Z){var ne;const se=this._cache.get(V),J={_sessionId:V,_itemId:se.size.toString(36),name:Z.name,detail:Z.detail,kind:C.SymbolKind.from(Z.kind),uri:Z.uri,range:C.Range.from(Z.range),selectionRange:C.Range.from(Z.selectionRange),tags:(ne=Z.tags)===null||ne===void 0?void 0:ne.map(C.SymbolTag.from)};return se.set(J._itemId,Z),J}_itemFromCache(V,Z){const ne=this._cache.get(V);return ne==null?void 0:ne.get(Z)}}class Qe{constructor(V,Z){this.adapter=V,this.extension=Z}}class ze{constructor(V,Z,ne,se,J,ae,he){this._adapter=new Map,this._uriTransformer=Z,this._proxy=V.getProxy(P.MainContext.MainThreadLanguageFeatures),this._documents=ne,this._commands=se,this._diagnostics=J,this._logService=ae,this._apiDeprecation=he}_transformDocumentSelector(V){return r.coalesce(r.asArray(V).map(Z=>this._doTransformDocumentSelector(Z)))}_doTransformDocumentSelector(V){if(typeof V=="string")return{$serialized:!0,language:V};if(V)return{$serialized:!0,language:V.language,scheme:this._transformScheme(V.scheme),pattern:typeof V.pattern=="undefined"?void 0:C.GlobPattern.from(V.pattern),exclusive:V.exclusive}}_transformScheme(V){return this._uriTransformer&&typeof V=="string"?this._uriTransformer.transformOutgoingScheme(V):V}_createDisposable(V){return new y.Disposable(()=>{this._adapter.delete(V),this._proxy.$unregister(V)})}_nextHandle(){return ze._handlePool++}_withAdapter(V,Z,ne,se,J=!1){const ae=this._adapter.get(V);if(!ae)return Promise.resolve(se);if(ae.adapter instanceof Z){let he;ae.extension&&(he=Date.now(),this._logService.trace(`[${ae.extension.identifier.value}] INVOKE provider '${Z.name}'`));const Fe=ne(ae.adapter,ae.extension),He=ae.extension;return He&&Promise.resolve(Fe).then(()=>this._logService.trace(`[${He.identifier.value}] provider DONE after ${Date.now()-he}ms`),_e=>{J&&_e instanceof b.CancellationError||(this._logService.error(`[${He.identifier.value}] provider FAILED`),this._logService.error(_e))}),Fe}return Promise.reject(new Error("no adapter found"))}_addNewAdapter(V,Z){const ne=this._nextHandle();return this._adapter.set(ne,new Qe(V,Z)),ne}static _extLabel(V){return V.displayName||V.name}registerDocumentSymbolProvider(V,Z,ne,se){const J=this._addNewAdapter(new h(this._documents,ne),V),ae=se&&se.label||ze._extLabel(V);return this._proxy.$registerDocumentSymbolProvider(J,this._transformDocumentSelector(Z),ae),this._createDisposable(J)}$provideDocumentSymbols(V,Z,ne){return this._withAdapter(V,h,se=>se.provideDocumentSymbols(p.URI.revive(Z),ne),void 0)}registerCodeLensProvider(V,Z,ne){const se=this._nextHandle(),J=typeof ne.onDidChangeCodeLenses=="function"?this._nextHandle():void 0;this._adapter.set(se,new Qe(new g(this._documents,this._commands.converter,ne),V)),this._proxy.$registerCodeLensSupport(se,this._transformDocumentSelector(Z),J);let ae=this._createDisposable(se);if(J!==void 0){const he=ne.onDidChangeCodeLenses(Fe=>this._proxy.$emitCodeLensEvent(J));ae=y.Disposable.from(ae,he)}return ae}$provideCodeLenses(V,Z,ne){return this._withAdapter(V,g,se=>se.provideCodeLenses(p.URI.revive(Z),ne),void 0)}$resolveCodeLens(V,Z,ne){return this._withAdapter(V,g,se=>se.resolveCodeLens(Z,ne),void 0)}$releaseCodeLenses(V,Z){this._withAdapter(V,g,ne=>Promise.resolve(ne.releaseCodeLenses(Z)),void 0)}registerDefinitionProvider(V,Z,ne){const se=this._addNewAdapter(new i(this._documents,ne),V);return this._proxy.$registerDefinitionSupport(se,this._transformDocumentSelector(Z)),this._createDisposable(se)}$provideDefinition(V,Z,ne,se){return this._withAdapter(V,i,J=>J.provideDefinition(p.URI.revive(Z),ne,se),[])}registerDeclarationProvider(V,Z,ne){const se=this._addNewAdapter(new s(this._documents,ne),V);return this._proxy.$registerDeclarationSupport(se,this._transformDocumentSelector(Z)),this._createDisposable(se)}$provideDeclaration(V,Z,ne,se){return this._withAdapter(V,s,J=>J.provideDeclaration(p.URI.revive(Z),ne,se),[])}registerImplementationProvider(V,Z,ne){const se=this._addNewAdapter(new n(this._documents,ne),V);return this._proxy.$registerImplementationSupport(se,this._transformDocumentSelector(Z)),this._createDisposable(se)}$provideImplementation(V,Z,ne,se){return this._withAdapter(V,n,J=>J.provideImplementation(p.URI.revive(Z),ne,se),[])}registerTypeDefinitionProvider(V,Z,ne){const se=this._addNewAdapter(new o(this._documents,ne),V);return this._proxy.$registerTypeDefinitionSupport(se,this._transformDocumentSelector(Z)),this._createDisposable(se)}$provideTypeDefinition(V,Z,ne,se){return this._withAdapter(V,o,J=>J.provideTypeDefinition(p.URI.revive(Z),ne,se),[])}registerHoverProvider(V,Z,ne,se){const J=this._addNewAdapter(new v(this._documents,ne),V);return this._proxy.$registerHoverProvider(J,this._transformDocumentSelector(Z)),this._createDisposable(J)}$provideHover(V,Z,ne,se){return this._withAdapter(V,v,J=>J.provideHover(p.URI.revive(Z),ne,se),void 0)}registerEvaluatableExpressionProvider(V,Z,ne,se){const J=this._addNewAdapter(new m(this._documents,ne),V);return this._proxy.$registerEvaluatableExpressionProvider(J,this._transformDocumentSelector(Z)),this._createDisposable(J)}$provideEvaluatableExpression(V,Z,ne,se){return this._withAdapter(V,m,J=>J.provideEvaluatableExpression(p.URI.revive(Z),ne,se),void 0)}registerInlineValuesProvider(V,Z,ne,se){const J=typeof ne.onDidChangeInlineValues=="function"?this._nextHandle():void 0,ae=this._addNewAdapter(new _(this._documents,ne),V);this._proxy.$registerInlineValuesProvider(ae,this._transformDocumentSelector(Z),J);let he=this._createDisposable(ae);if(J!==void 0){const Fe=ne.onDidChangeInlineValues(He=>this._proxy.$emitInlineValuesEvent(J));he=y.Disposable.from(he,Fe)}return he}$provideInlineValues(V,Z,ne,se,J){return this._withAdapter(V,_,ae=>ae.provideInlineValues(p.URI.revive(Z),ne,se,J),void 0)}registerDocumentHighlightProvider(V,Z,ne){const se=this._addNewAdapter(new D(this._documents,ne),V);return this._proxy.$registerDocumentHighlightProvider(se,this._transformDocumentSelector(Z)),this._createDisposable(se)}$provideDocumentHighlights(V,Z,ne,se){return this._withAdapter(V,D,J=>J.provideDocumentHighlights(p.URI.revive(Z),ne,se),void 0)}registerLinkedEditingRangeProvider(V,Z,ne){const se=this._addNewAdapter(new a(this._documents,ne),V);return this._proxy.$registerLinkedEditingRangeProvider(se,this._transformDocumentSelector(Z)),this._createDisposable(se)}$provideLinkedEditingRanges(V,Z,ne,se){return this._withAdapter(V,a,async J=>{const ae=await J.provideLinkedEditingRanges(p.URI.revive(Z),ne,se);if(ae)return{ranges:ae.ranges,wordPattern:ae.wordPattern?ze._serializeRegExp(ae.wordPattern):void 0}},void 0)}registerReferenceProvider(V,Z,ne){const se=this._addNewAdapter(new T(this._documents,ne),V);return this._proxy.$registerReferenceSupport(se,this._transformDocumentSelector(Z)),this._createDisposable(se)}$provideReferences(V,Z,ne,se,J){return this._withAdapter(V,T,ae=>ae.provideReferences(p.URI.revive(Z),ne,se,J),void 0)}registerCodeActionProvider(V,Z,ne,se){var J,ae;const he=new f.DisposableStore,Fe=this._addNewAdapter(new L(this._documents,this._commands.converter,this._diagnostics,ne,this._logService,V,this._apiDeprecation),V);return this._proxy.$registerQuickFixSupport(Fe,this._transformDocumentSelector(Z),{providedKinds:(J=se==null?void 0:se.providedCodeActionKinds)===null||J===void 0?void 0:J.map(He=>He.value),documentation:(ae=se==null?void 0:se.documentation)===null||ae===void 0?void 0:ae.map(He=>({kind:He.kind.value,command:this._commands.converter.toInternal(He.command,he)}))},ze._extLabel(V),Boolean(ne.resolveCodeAction)),he.add(this._createDisposable(Fe)),he}$provideCodeActions(V,Z,ne,se,J){return this._withAdapter(V,L,ae=>ae.provideCodeActions(p.URI.revive(Z),ne,se,J),void 0)}$resolveCodeAction(V,Z,ne){return this._withAdapter(V,L,se=>se.resolveCodeAction(Z,ne),void 0)}$releaseCodeActions(V,Z){this._withAdapter(V,L,ne=>Promise.resolve(ne.releaseCodeActions(Z)),void 0)}registerDocumentFormattingEditProvider(V,Z,ne){const se=this._addNewAdapter(new U(this._documents,ne),V);return this._proxy.$registerDocumentFormattingSupport(se,this._transformDocumentSelector(Z),V.identifier,V.displayName||V.name),this._createDisposable(se)}$provideDocumentFormattingEdits(V,Z,ne,se){return this._withAdapter(V,U,J=>J.provideDocumentFormattingEdits(p.URI.revive(Z),ne,se),void 0)}registerDocumentRangeFormattingEditProvider(V,Z,ne){const se=this._addNewAdapter(new G(this._documents,ne),V);return this._proxy.$registerRangeFormattingSupport(se,this._transformDocumentSelector(Z),V.identifier,V.displayName||V.name),this._createDisposable(se)}$provideDocumentRangeFormattingEdits(V,Z,ne,se,J){return this._withAdapter(V,G,ae=>ae.provideDocumentRangeFormattingEdits(p.URI.revive(Z),ne,se,J),void 0)}registerOnTypeFormattingEditProvider(V,Z,ne,se){const J=this._addNewAdapter(new ee(this._documents,ne),V);return this._proxy.$registerOnTypeFormattingSupport(J,this._transformDocumentSelector(Z),se,V.identifier),this._createDisposable(J)}$provideOnTypeFormattingEdits(V,Z,ne,se,J,ae){return this._withAdapter(V,ee,he=>he.provideOnTypeFormattingEdits(p.URI.revive(Z),ne,se,J,ae),void 0)}registerWorkspaceSymbolProvider(V,Z){const ne=this._addNewAdapter(new z(Z,this._logService),V);return this._proxy.$registerNavigateTypeSupport(ne),this._createDisposable(ne)}$provideWorkspaceSymbols(V,Z,ne){return this._withAdapter(V,z,se=>se.provideWorkspaceSymbols(Z,ne),{symbols:[]})}$resolveWorkspaceSymbol(V,Z,ne){return this._withAdapter(V,z,se=>se.resolveWorkspaceSymbol(Z,ne),void 0)}$releaseWorkspaceSymbols(V,Z){this._withAdapter(V,z,ne=>ne.releaseWorkspaceSymbols(Z),void 0)}registerRenameProvider(V,Z,ne){const se=this._addNewAdapter(new N(this._documents,ne,this._logService),V);return this._proxy.$registerRenameSupport(se,this._transformDocumentSelector(Z),N.supportsResolving(ne)),this._createDisposable(se)}$provideRenameEdits(V,Z,ne,se,J){return this._withAdapter(V,N,ae=>ae.provideRenameEdits(p.URI.revive(Z),ne,se,J),void 0)}$resolveRenameLocation(V,Z,ne,se){return this._withAdapter(V,N,J=>J.resolveRenameLocation(p.URI.revive(Z),ne,se),void 0)}registerDocumentSemanticTokensProvider(V,Z,ne,se){const J=this._nextHandle(),ae=typeof ne.onDidChangeSemanticTokens=="function"?this._nextHandle():void 0;this._adapter.set(J,new Qe(new M(this._documents,ne),V)),this._proxy.$registerDocumentSemanticTokensProvider(J,this._transformDocumentSelector(Z),se,ae);let he=this._createDisposable(J);if(ae){const Fe=ne.onDidChangeSemanticTokens(He=>this._proxy.$emitDocumentSemanticTokensEvent(ae));he=y.Disposable.from(he,Fe)}return he}$provideDocumentSemanticTokens(V,Z,ne,se){return this._withAdapter(V,M,J=>J.provideDocumentSemanticTokens(p.URI.revive(Z),ne,se),null,!0)}$releaseDocumentSemanticTokens(V,Z){this._withAdapter(V,M,ne=>ne.releaseDocumentSemanticColoring(Z),void 0)}registerDocumentRangeSemanticTokensProvider(V,Z,ne,se){const J=this._addNewAdapter(new j(this._documents,ne),V);return this._proxy.$registerDocumentRangeSemanticTokensProvider(J,this._transformDocumentSelector(Z),se),this._createDisposable(J)}$provideDocumentRangeSemanticTokens(V,Z,ne,se){return this._withAdapter(V,j,J=>J.provideDocumentRangeSemanticTokens(p.URI.revive(Z),ne,se),null,!0)}registerCompletionItemProvider(V,Z,ne,se){const J=this._addNewAdapter(new O(this._documents,this._commands.converter,ne,this._apiDeprecation,V),V);return this._proxy.$registerSuggestSupport(J,this._transformDocumentSelector(Z),se,O.supportsResolving(ne),`${V.identifier.value}(${se.join("")})`),this._createDisposable(J)}$provideCompletionItems(V,Z,ne,se,J){return this._withAdapter(V,O,ae=>ae.provideCompletionItems(p.URI.revive(Z),ne,se,J),void 0)}$resolveCompletionItem(V,Z,ne){return this._withAdapter(V,O,se=>se.resolveCompletionItem(Z,ne),void 0)}$releaseCompletionItems(V,Z){this._withAdapter(V,O,ne=>ne.releaseCompletionItems(Z),void 0)}registerInlineCompletionsProvider(V,Z,ne){const se=this._addNewAdapter(new F(this._documents,ne,this._commands.converter),V);return this._proxy.$registerInlineCompletionsSupport(se,this._transformDocumentSelector(Z)),this._createDisposable(se)}$provideInlineCompletions(V,Z,ne,se,J){return this._withAdapter(V,F,ae=>ae.provideInlineCompletions(p.URI.revive(Z),ne,se,J),void 0)}$handleInlineCompletionDidShow(V,Z,ne){this._withAdapter(V,F,async se=>{se.handleDidShowCompletionItem(Z,ne)},void 0)}$freeInlineCompletionsList(V,Z){this._withAdapter(V,F,async ne=>{ne.disposeCompletions(Z)},void 0)}registerSignatureHelpProvider(V,Z,ne,se){const J=Array.isArray(se)?{triggerCharacters:se,retriggerCharacters:[]}:se,ae=this._addNewAdapter(new $(this._documents,ne),V);return this._proxy.$registerSignatureHelpProvider(ae,this._transformDocumentSelector(Z),J),this._createDisposable(ae)}$provideSignatureHelp(V,Z,ne,se,J){return this._withAdapter(V,$,ae=>ae.provideSignatureHelp(p.URI.revive(Z),ne,se,J),void 0)}$releaseSignatureHelp(V,Z){this._withAdapter(V,$,ne=>ne.releaseSignatureHelp(Z),void 0)}registerInlayHintsProvider(V,Z,ne){const se=typeof ne.onDidChangeInlayHints=="function"?this._nextHandle():void 0,J=this._addNewAdapter(new Y(this._documents,ne),V);this._proxy.$registerInlayHintsProvider(J,this._transformDocumentSelector(Z),se);let ae=this._createDisposable(J);if(se!==void 0){const he=ne.onDidChangeInlayHints(Fe=>this._proxy.$emitInlayHintsEvent(se));ae=y.Disposable.from(ae,he)}return ae}$provideInlayHints(V,Z,ne,se){return this._withAdapter(V,Y,J=>J.provideInlayHints(p.URI.revive(Z),ne,se),void 0)}registerDocumentLinkProvider(V,Z,ne){const se=this._addNewAdapter(new le(this._documents,ne),V);return this._proxy.$registerDocumentLinkProvider(se,this._transformDocumentSelector(Z),typeof ne.resolveDocumentLink=="function"),this._createDisposable(se)}$provideDocumentLinks(V,Z,ne){return this._withAdapter(V,le,se=>se.provideLinks(p.URI.revive(Z),ne),void 0)}$resolveDocumentLink(V,Z,ne){return this._withAdapter(V,le,se=>se.resolveLink(Z,ne),void 0)}$releaseDocumentLinks(V,Z){this._withAdapter(V,le,ne=>ne.releaseLinks(Z),void 0)}registerColorProvider(V,Z,ne){const se=this._addNewAdapter(new be(this._documents,ne),V);return this._proxy.$registerDocumentColorProvider(se,this._transformDocumentSelector(Z)),this._createDisposable(se)}$provideDocumentColors(V,Z,ne){return this._withAdapter(V,be,se=>se.provideColors(p.URI.revive(Z),ne),[])}$provideColorPresentations(V,Z,ne,se){return this._withAdapter(V,be,J=>J.provideColorPresentations(p.URI.revive(Z),ne,se),void 0)}registerFoldingRangeProvider(V,Z,ne){const se=this._nextHandle(),J=typeof ne.onDidChangeFoldingRanges=="function"?this._nextHandle():void 0;this._adapter.set(se,new Qe(new Le(this._documents,ne),V)),this._proxy.$registerFoldingRangeProvider(se,this._transformDocumentSelector(Z),J);let ae=this._createDisposable(se);if(J!==void 0){const he=ne.onDidChangeFoldingRanges(()=>this._proxy.$emitFoldingRangeEvent(J));ae=y.Disposable.from(ae,he)}return ae}$provideFoldingRanges(V,Z,ne,se){return this._withAdapter(V,Le,J=>J.provideFoldingRanges(p.URI.revive(Z),ne,se),void 0)}registerSelectionRangeProvider(V,Z,ne){const se=this._addNewAdapter(new Ie(this._documents,ne,this._logService),V);return this._proxy.$registerSelectionRangeProvider(se,this._transformDocumentSelector(Z)),this._createDisposable(se)}$provideSelectionRanges(V,Z,ne,se){return this._withAdapter(V,Ie,J=>J.provideSelectionRanges(p.URI.revive(Z),ne,se),[])}registerCallHierarchyProvider(V,Z,ne){const se=this._addNewAdapter(new Ue(this._documents,ne),V);return this._proxy.$registerCallHierarchyProvider(se,this._transformDocumentSelector(Z)),this._createDisposable(se)}$prepareCallHierarchy(V,Z,ne,se){return this._withAdapter(V,Ue,J=>Promise.resolve(J.prepareSession(p.URI.revive(Z),ne,se)),void 0)}$provideCallHierarchyIncomingCalls(V,Z,ne,se){return this._withAdapter(V,Ue,J=>J.provideCallsTo(Z,ne,se),void 0)}$provideCallHierarchyOutgoingCalls(V,Z,ne,se){return this._withAdapter(V,Ue,J=>J.provideCallsFrom(Z,ne,se),void 0)}$releaseCallHierarchy(V,Z){this._withAdapter(V,Ue,ne=>Promise.resolve(ne.releaseSession(Z)),void 0)}static _serializeRegExp(V){return{pattern:V.source,flags:E.regExpFlags(V)}}static _serializeIndentationRule(V){return{decreaseIndentPattern:ze._serializeRegExp(V.decreaseIndentPattern),increaseIndentPattern:ze._serializeRegExp(V.increaseIndentPattern),indentNextLinePattern:V.indentNextLinePattern?ze._serializeRegExp(V.indentNextLinePattern):void 0,unIndentedLinePattern:V.unIndentedLinePattern?ze._serializeRegExp(V.unIndentedLinePattern):void 0}}static _serializeOnEnterRule(V){return{beforeText:ze._serializeRegExp(V.beforeText),afterText:V.afterText?ze._serializeRegExp(V.afterText):void 0,previousLineText:V.previousLineText?ze._serializeRegExp(V.previousLineText):void 0,action:V.action}}static _serializeOnEnterRules(V){return V.map(ze._serializeOnEnterRule)}setLanguageConfiguration(V,Z,ne){let{wordPattern:se}=ne;if(se&&E.regExpLeadsToEndlessLoop(se))throw new Error(`Invalid language configuration: wordPattern '${se}' is not allowed to match the empty string.`);se?this._documents.setWordDefinitionFor(Z,se):this._documents.setWordDefinitionFor(Z,void 0),ne.__electricCharacterSupport&&this._apiDeprecation.report("LanguageConfiguration.__electricCharacterSupport",V,"Do not use."),ne.__characterPairSupport&&this._apiDeprecation.report("LanguageConfiguration.__characterPairSupport",V,"Do not use.");const J=this._nextHandle(),ae={comments:ne.comments,brackets:ne.brackets,wordPattern:ne.wordPattern?ze._serializeRegExp(ne.wordPattern):void 0,indentationRules:ne.indentationRules?ze._serializeIndentationRule(ne.indentationRules):void 0,onEnterRules:ne.onEnterRules?ze._serializeOnEnterRules(ne.onEnterRules):void 0,__electricCharacterSupport:ne.__electricCharacterSupport,__characterPairSupport:ne.__characterPairSupport};return this._proxy.$setLanguageConfiguration(J,Z,ae),this._createDisposable(J)}$setWordDefinitions(V){for(const Z of V)this._documents.setWordDefinitionFor(Z.languageId,new RegExp(Z.regexSource,Z.regexFlags))}}e.ExtHostLanguageFeatures=ze,ze._handlePool=0}),define(me[230],ge([0,1,5,17,7]),function(X,e,p,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguages=void 0;class y{constructor(P,E){this._proxy=P.getProxy(p.MainContext.MainThreadLanguages),this._documents=E}getLanguages(){return this._proxy.$getLanguages()}async changeLanguage(P,E){await this._proxy.$changeLanguage(P,E);const k=this._documents.getDocumentData(P);if(!k)throw new Error(`document '${P.toString}' NOT found`);return k.document}async tokenAtPosition(P,E){var k;const r=P.version,I=R.Position.from(E),l=await this._proxy.$tokensAtPosition(P.uri,I),f={type:C.StandardTokenType.Other,range:(k=P.getWordRangeAtPosition(E))!==null&&k!==void 0?k:new C.Range(E.line,E.character,E.line,E.character)};if(!l)return f;const c={range:R.Range.to(l.range),type:R.TokenType.to(l.type)};return!c.range.contains(E)||r!==P.version?f:c}}e.ExtHostLanguages=y}),define(me[231],ge([0,1,5,12,34]),function(X,e,p,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostMessageService=void 0;function y(P){return P&&P.title}let A=class{constructor(E,k){this._logService=k,this._proxy=E.getProxy(p.MainContext.MainThreadMessageService)}showMessage(E,k,r,I,l){const f={extension:E};let c;typeof I=="string"||y(I)?c=[I,...l]:(f.modal=I==null?void 0:I.modal,f.useCustom=I==null?void 0:I.useCustom,f.detail=I==null?void 0:I.detail,c=l),f.useCustom&&C.checkProposedApiEnabled(E);const u=[];for(let S=0;S<c.length;S++){const w=c[S];if(typeof w=="string")u.push({title:w,handle:S,isCloseAffordance:!1});else if(typeof w=="object"){let{title:b,isCloseAffordance:d}=w;u.push({title:b,isCloseAffordance:!!d,handle:S})}else this._logService.warn("Invalid message item:",w)}return this._proxy.$showMessage(k,r,f,u).then(S=>{if(typeof S=="number")return c[S]})}};A=Ve([We(1,R.ILogService)],A),e.ExtHostMessageService=A}),define(me[232],ge([0,1,22,3,73,6,23,8,15,2,82,5,17,7,208,123]),function(X,e,p,R,C,y,A,P,E,k,r,I,l,f,c,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookController=void 0;class S{constructor(b,d,h,g,t){this._textDocumentsAndEditors=h,this._textDocuments=g,this._extensionStoragePaths=t,this._notebookContentProviders=new Map,this._notebookStatusBarItemProviders=new Map,this._documents=new A.ResourceMap,this._editors=new Map,this._onDidChangeNotebookCells=new R.Emitter,this.onDidChangeNotebookCells=this._onDidChangeNotebookCells.event,this._onDidChangeCellOutputs=new R.Emitter,this.onDidChangeCellOutputs=this._onDidChangeCellOutputs.event,this._onDidChangeCellMetadata=new R.Emitter,this.onDidChangeCellMetadata=this._onDidChangeCellMetadata.event,this._onDidChangeActiveNotebookEditor=new R.Emitter,this.onDidChangeActiveNotebookEditor=this._onDidChangeActiveNotebookEditor.event,this._onDidChangeCellExecutionState=new R.Emitter,this.onDidChangeNotebookCellExecutionState=this._onDidChangeCellExecutionState.event,this._visibleNotebookEditors=[],this._onDidOpenNotebookDocument=new R.Emitter,this.onDidOpenNotebookDocument=this._onDidOpenNotebookDocument.event,this._onDidCloseNotebookDocument=new R.Emitter,this.onDidCloseNotebookDocument=this._onDidCloseNotebookDocument.event,this._onDidChangeVisibleNotebookEditors=new R.Emitter,this.onDidChangeVisibleNotebookEditors=this._onDidChangeVisibleNotebookEditors.event,this._statusBarCache=new r.Cache("NotebookCellStatusBarCache"),this._handlePool=0,this._notebookSerializer=new Map,this._backupIdPool=0,this._notebookProxy=b.getProxy(I.MainContext.MainThreadNotebook),this._notebookDocumentsProxy=b.getProxy(I.MainContext.MainThreadNotebookDocuments),this._notebookEditorsProxy=b.getProxy(I.MainContext.MainThreadNotebookEditors),this._commandsConverter=d.converter,d.registerArgumentProcessor({processArgument:i=>{var s;if(i&&i.$mid===12){const n=(s=i.notebookEditor)===null||s===void 0?void 0:s.notebookUri,o=i.cell.handle,v=this._documents.get(n),m=v==null?void 0:v.getCell(o);if(m)return m.apiCell}return i}})}get activeNotebookEditor(){var b;return(b=this._activeNotebookEditor)===null||b===void 0?void 0:b.apiEditor}get visibleNotebookEditors(){return this._visibleNotebookEditors.map(b=>b.apiEditor)}getEditorById(b){const d=this._editors.get(b);if(!d)throw new Error(`unknown text editor: ${b}. known editors: ${[...this._editors.keys()]} `);return d}getIdByEditor(b){for(const[d,h]of this._editors)if(h.apiEditor===b)return d}get notebookDocuments(){return[...this._documents.values()]}getNotebookDocument(b,d){const h=this._documents.get(b);if(!h&&!d)throw new Error(`NO notebook document for '${b}'`);return h}_getProviderData(b){const d=this._notebookContentProviders.get(b);if(!d)throw new Error(`NO provider for '${b}'`);return d}registerNotebookContentProvider(b,d,h,g,t){if(P.isFalsyOrWhitespace(d))throw new Error("viewType cannot be empty or just whitespace");if(this._notebookContentProviders.has(d))throw new Error(`Notebook provider for '${d}' already registered`);this._notebookContentProviders.set(d,{extension:b,provider:h});let i;return h.onDidChangeNotebookContentOptions&&(i=h.onDidChangeNotebookContentOptions(()=>{const s=l.NotebookDocumentContentOptions.from(h.options);this._notebookProxy.$updateNotebookProviderOptions(d,s)})),this._notebookProxy.$registerNotebookProvider({id:b.identifier,location:b.extensionLocation},d,l.NotebookDocumentContentOptions.from(g),S._convertNotebookRegistrationData(b,t)),new f.Disposable(()=>{i==null||i.dispose(),this._notebookContentProviders.delete(d),this._notebookProxy.$unregisterNotebookProvider(d)})}static _convertNotebookRegistrationData(b,d){if(!d)return;const h=d.filenamePattern.map(g=>l.NotebookExclusiveDocumentPattern.from(g)).filter(g=>g!==void 0);if(d.filenamePattern&&!h){console.warn(`Notebook content provider view options file name pattern is invalid ${d.filenamePattern}`);return}return{extension:b.identifier,providerDisplayName:b.displayName||b.name,displayName:d.displayName,filenamePattern:h,exclusive:d.exclusive||!1}}registerNotebookCellStatusBarItemProvider(b,d,h){const g=S._notebookStatusBarItemProviderHandlePool++,t=typeof h.onDidChangeCellStatusBarItems=="function"?S._notebookStatusBarItemProviderHandlePool++:void 0;this._notebookStatusBarItemProviders.set(g,h),this._notebookProxy.$registerNotebookCellStatusBarItemProvider(g,t,d);let i;return t!==void 0&&(i=h.onDidChangeCellStatusBarItems(s=>this._notebookProxy.$emitCellStatusBarEvent(t))),new f.Disposable(()=>{this._notebookStatusBarItemProviders.delete(g),this._notebookProxy.$unregisterNotebookCellStatusBarItemProvider(g,t),i&&i.dispose()})}async createNotebookDocument(b){const d=await this._notebookDocumentsProxy.$tryCreateNotebook({viewType:b.viewType,content:b.content&&l.NotebookData.from(b.content)});return k.URI.revive(d)}async openNotebookDocument(b){const d=this._documents.get(b);if(d)return d.apiNotebook;const h=await this._notebookDocumentsProxy.$tryOpenNotebook(b),g=this._documents.get(k.URI.revive(h));return E.assertIsDefined(g==null?void 0:g.apiNotebook)}async showNotebookDocument(b,d){var h;k.URI.isUri(b)&&(b=await this.openNotebookDocument(b));let g;typeof d=="object"?g={position:l.ViewColumn.from(d.viewColumn),preserveFocus:d.preserveFocus,selections:d.selections&&d.selections.map(l.NotebookRange.from),pinned:typeof d.preview=="boolean"?!d.preview:void 0}:g={preserveFocus:!1};const t=await this._notebookEditorsProxy.$tryShowNotebookDocument(b.uri,b.notebookType,g),i=t&&((h=this._editors.get(t))===null||h===void 0?void 0:h.apiEditor);if(i)return i;throw t?new Error(`Could NOT open editor for "${b.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${b.uri.toString()}".`)}async $provideNotebookCellStatusBarItems(b,d,h,g){const t=this._notebookStatusBarItemProviders.get(b),i=k.URI.revive(d),s=this._documents.get(i);if(!s||!t)return;const n=s.getCellFromIndex(h);if(!n)return;const o=await t.provideCellStatusBarItems(n.apiCell,g);if(!o)return;const v=new y.DisposableStore,m=this._statusBarCache.add([v]),D=(Array.isArray(o)?o:[o]).map(a=>l.NotebookStatusBarItem.from(a,this._commandsConverter,v));return{cacheId:m,items:D}}$releaseNotebookCellStatusBarItems(b){this._statusBarCache.delete(b)}registerNotebookSerializer(b,d,h,g,t){if(P.isFalsyOrWhitespace(d))throw new Error("viewType cannot be empty or just whitespace");const i=this._handlePool++;return this._notebookSerializer.set(i,h),this._notebookProxy.$registerNotebookSerializer(i,{id:b.identifier,location:b.extensionLocation},d,l.NotebookDocumentContentOptions.from(g),S._convertNotebookRegistrationData(b,t)),y.toDisposable(()=>{this._notebookProxy.$unregisterNotebookSerializer(i)})}async $dataToNotebook(b,d,h){const g=this._notebookSerializer.get(b);if(!g)throw new Error("NO serializer found");const t=await g.deserializeNotebook(d.buffer,h);return l.NotebookData.from(t)}async $notebookToData(b,d,h){const g=this._notebookSerializer.get(b);if(!g)throw new Error("NO serializer found");const t=await g.serializeNotebook(l.NotebookData.to(d),h);return p.VSBuffer.wrap(t)}async $openNotebook(b,d,h,g,t){var i;const{provider:s}=this._getProviderData(b),n=await s.openNotebook(k.URI.revive(d),{backupId:h,untitledDocumentData:g==null?void 0:g.buffer},t);return{metadata:(i=n.metadata)!==null&&i!==void 0?i:Object.create(null),cells:n.cells.map(l.NotebookCellData.from)}}async $saveNotebook(b,d,h){const g=this.getNotebookDocument(k.URI.revive(d)),{provider:t}=this._getProviderData(b);return await t.saveNotebook(g.apiNotebook,h),!0}async $saveNotebookAs(b,d,h,g){const t=this.getNotebookDocument(k.URI.revive(d)),{provider:i}=this._getProviderData(b);return await i.saveNotebookAs(k.URI.revive(h),t.apiNotebook,g),!0}async $backupNotebook(b,d,h){var g;const t=this.getNotebookDocument(k.URI.revive(d)),i=this._getProviderData(b),s=(g=this._extensionStoragePaths.workspaceValue(i.extension))!==null&&g!==void 0?g:this._extensionStoragePaths.globalValue(i.extension),n=String(C.hash([t.uri.toString(),this._backupIdPool++])),o=k.URI.joinPath(s,n),v=await i.provider.backupNotebook(t.apiNotebook,{destination:o},h);return t.updateBackup(v),v.id}_createExtHostEditor(b,d,h){if(this._editors.has(d))throw new Error(`editor with id ALREADY EXSIST: ${d}`);const g=new u.ExtHostNotebookEditor(d,this._notebookEditorsProxy,b,h.visibleRanges.map(l.NotebookRange.to),h.selections.map(l.NotebookRange.to),typeof h.viewColumn=="number"?l.ViewColumn.to(h.viewColumn):void 0);this._editors.set(d,g)}$acceptDocumentAndEditorsDelta(b){var d,h,g;if(b.removedDocuments)for(const i of b.removedDocuments){const s=k.URI.revive(i),n=this._documents.get(s);n&&(n.dispose(),this._documents.delete(s),this._textDocumentsAndEditors.$acceptDocumentsAndEditorsDelta({removedDocuments:n.apiNotebook.getCells().map(o=>o.document.uri)}),this._onDidCloseNotebookDocument.fire(n.apiNotebook));for(const o of this._editors.values())o.notebookData.uri.toString()===s.toString()&&this._editors.delete(o.id)}if(b.addedDocuments){const i=[];for(const s of b.addedDocuments){const n=k.URI.revive(s.uri);if(this._documents.has(n))throw new Error(`adding EXISTING notebook ${n} `);const o=this,v=new c.ExtHostNotebookDocument(this._notebookDocumentsProxy,this._textDocumentsAndEditors,this._textDocuments,{emitModelChange(m){o._onDidChangeNotebookCells.fire(m)},emitCellOutputsChange(m){o._onDidChangeCellOutputs.fire(m)},emitCellMetadataChange(m){o._onDidChangeCellMetadata.fire(m)},emitCellExecutionStateChange(m){o._onDidChangeCellExecutionState.fire(m)}},n,s);i.push(...s.cells.map(m=>c.ExtHostCell.asModelAddData(v.apiNotebook,m))),(d=this._documents.get(n))===null||d===void 0||d.dispose(),this._documents.set(n,v),this._textDocumentsAndEditors.$acceptDocumentsAndEditorsDelta({addedDocuments:i}),this._onDidOpenNotebookDocument.fire(v.apiNotebook)}}if(b.addedEditors)for(const i of b.addedEditors){if(this._editors.has(i.id))return;const s=k.URI.revive(i.documentUri),n=this._documents.get(s);n&&this._createExtHostEditor(n,i.id,i)}const t=[];if(b.removedEditors)for(const i of b.removedEditors){const s=this._editors.get(i);s&&(this._editors.delete(i),((h=this._activeNotebookEditor)===null||h===void 0?void 0:h.id)===s.id&&(this._activeNotebookEditor=void 0),t.push(s))}if(b.visibleEditors){this._visibleNotebookEditors=b.visibleEditors.map(s=>this._editors.get(s)).filter(s=>!!s);const i=new Set;this._visibleNotebookEditors.forEach(s=>i.add(s.id));for(const s of this._editors.values()){const n=i.has(s.id);s._acceptVisibility(n)}this._visibleNotebookEditors=[...this._editors.values()].map(s=>s).filter(s=>s.visible),this._onDidChangeVisibleNotebookEditors.fire(this.visibleNotebookEditors)}b.newActiveEditor===null?this._activeNotebookEditor=void 0:b.newActiveEditor&&(this._activeNotebookEditor=this._editors.get(b.newActiveEditor)),b.newActiveEditor!==void 0&&this._onDidChangeActiveNotebookEditor.fire((g=this._activeNotebookEditor)===null||g===void 0?void 0:g.apiEditor)}}e.ExtHostNotebookController=S,S._notebookStatusBarItemProviderHandlePool=0}),define(me[233],ge([0,1,3,70,12,5,13,17]),function(X,e,p,R,C,y,A,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookEditors=void 0;class E{constructor(I,l){const f=E._Keys.nextId();I.$registerNotebookEditorDecorationType(f,P.NotebookDecorationRenderOptions.from(l)),this.value={key:f,dispose(){I.$removeNotebookEditorDecorationType(f)}}}}E._Keys=new R.IdGenerator("NotebookEditorDecorationType");let k=class{constructor(I,l,f){this._logService=I,this._extHostRpc=l,this._notebooksAndEditors=f,this._onDidChangeNotebookEditorSelection=new p.Emitter,this._onDidChangeNotebookEditorVisibleRanges=new p.Emitter,this.onDidChangeNotebookEditorSelection=this._onDidChangeNotebookEditorSelection.event,this.onDidChangeNotebookEditorVisibleRanges=this._onDidChangeNotebookEditorVisibleRanges.event}createNotebookEditorDecorationType(I){return new E(this._extHostRpc.getProxy(y.MainContext.MainThreadNotebookEditors),I).value}$acceptEditorPropertiesChanged(I,l){this._logService.debug("ExtHostNotebook#$acceptEditorPropertiesChanged",I,l);const f=this._notebooksAndEditors.getEditorById(I);l.visibleRanges&&f._acceptVisibleRanges(l.visibleRanges.ranges.map(P.NotebookRange.to)),l.selections&&f._acceptSelections(l.selections.selections.map(P.NotebookRange.to)),l.visibleRanges&&this._onDidChangeNotebookEditorVisibleRanges.fire({notebookEditor:f.apiEditor,visibleRanges:f.apiEditor.visibleRanges}),l.selections&&this._onDidChangeNotebookEditorSelection.fire(Object.freeze({notebookEditor:f.apiEditor,selections:f.apiEditor.selections}))}$acceptEditorViewColumns(I){for(const l in I)this._notebooksAndEditors.getEditorById(l)._acceptViewColumn(P.ViewColumn.to(I[l]))}};k=Ve([We(0,C.ILogService),We(1,A.IExtHostRpcService)],k),e.ExtHostNotebookEditors=k}),define(me[234],ge([0,1,3,6,5,26,2,17,83,23,16,84,21,18,12,7,34]),function(X,e,p,R,C,y,A,P,E,k,r,I,l,f,c,u,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookKernels=void 0;let w=class{constructor(t,i,s,n){this._initData=i,this._extHostNotebook=s,this._logService=n,this._activeExecutions=new k.ResourceMap,this._kernelData=new Map,this._handlePool=0,this._proxy=t.getProxy(C.MainContext.MainThreadNotebookKernels)}createNotebookController(t,i,s,n,o,v){for(let O of this._kernelData.values())if(O.controller.id===i&&y.ExtensionIdentifier.equals(t.identifier,O.extensionId))throw new Error(`notebook controller with id '${i}' ALREADY exist`);const m=this._handlePool++,_=this;this._logService.trace(`NotebookController[${m}], CREATED by ${t.identifier.value}, ${i}`);const D=()=>console.warn(`NO execute handler from notebook controller '${G.id}' of extension: '${t.identifier}'`);let a=!1;const T=new R.DisposableStore,L=new p.Emitter,U=new p.Emitter,G={id:`${t.identifier.value}/${i}`,notebookType:s,extensionId:t.identifier,extensionLocation:t.extensionLocation,label:n||t.identifier.value,preloads:v?v.map(P.NotebookRendererScript.from):[]};let ee=o??D,z;this._proxy.$addKernel(m,G).catch(O=>{console.log(O),a=!0});let N=0;const W=()=>{if(a)return;const O=++N;Promise.resolve().then(()=>{O===N&&this._proxy.$updateKernel(m,G)})},M=new k.ResourceMap,j={get id(){return i},get notebookType(){return G.notebookType},onDidChangeSelectedNotebooks:L.event,get label(){return G.label},set label(O){var F;G.label=(F=O??t.displayName)!==null&&F!==void 0?F:t.name,W()},get detail(){var O;return(O=G.detail)!==null&&O!==void 0?O:""},set detail(O){G.detail=O,W()},get description(){var O;return(O=G.description)!==null&&O!==void 0?O:""},set description(O){G.description=O,W()},get supportedLanguages(){return G.supportedLanguages},set supportedLanguages(O){G.supportedLanguages=O,W()},get supportsExecutionOrder(){var O;return(O=G.supportsExecutionOrder)!==null&&O!==void 0?O:!1},set supportsExecutionOrder(O){G.supportsExecutionOrder=O,W()},get rendererScripts(){return G.preloads?G.preloads.map(P.NotebookRendererScript.to):[]},get executeHandler(){return ee},set executeHandler(O){ee=O??D},get interruptHandler(){return z},set interruptHandler(O){z=O,G.supportsInterrupt=Boolean(O),W()},createNotebookCellExecution(O){if(a)throw new Error("notebook controller is DISPOSED");if(!M.has(O.notebook.uri))throw _._logService.trace(`NotebookController[${m}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(M.keys()).map(F=>F.toString())),new Error(`notebook controller is NOT associated to notebook: ${O.notebook.uri.toString()}`);return _._createNotebookCellExecution(O)},dispose:()=>{a||(this._logService.trace(`NotebookController[${m}], DISPOSED`),a=!0,this._kernelData.delete(m),T.dispose(),L.dispose(),U.dispose(),this._proxy.$removeKernel(m))},updateNotebookAffinity(O,F){_._proxy.$updateNotebookPriority(m,O.uri,F)},onDidReceiveMessage:U.event,postMessage(O,F){return S.checkProposedApiEnabled(t),_._proxy.$postMessage(m,F&&_._extHostNotebook.getIdByEditor(F),O)},asWebviewUri(O){return S.checkProposedApiEnabled(t),E.asWebviewUri(O,_._initData.remote)}};return this._kernelData.set(m,{extensionId:t.identifier,controller:j,onDidReceiveMessage:U,onDidChangeSelection:L,associatedNotebooks:M}),j}$acceptNotebookAssociation(t,i,s){const n=this._kernelData.get(t);if(n){const o=this._extHostNotebook.getNotebookDocument(A.URI.revive(i));s?n.associatedNotebooks.set(o.uri,!0):n.associatedNotebooks.delete(o.uri),this._logService.trace(`NotebookController[${t}] ASSOCIATE notebook`,o.uri.toString(),s),n.onDidChangeSelection.fire({selected:s,notebook:o.apiNotebook})}}async $executeCells(t,i,s){const n=this._kernelData.get(t);if(!n)return;const o=this._extHostNotebook.getNotebookDocument(A.URI.revive(i)),v=[];for(let m of s){const _=o.getCell(m);_&&v.push(_.apiCell)}try{this._logService.trace(`NotebookController[${t}] EXECUTE cells`,o.uri.toString(),v.length),await n.controller.executeHandler.call(n.controller,v,o.apiNotebook,n.controller)}catch(m){this._logService.error(`NotebookController[${t}] execute cells FAILED`,m),console.error(m)}}async $cancelCells(t,i,s){var n;const o=this._kernelData.get(t);if(!o)return;const v=this._extHostNotebook.getNotebookDocument(A.URI.revive(i));if(o.controller.interruptHandler)await o.controller.interruptHandler.call(o.controller,v.apiNotebook);else for(let m of s){const _=v.getCell(m);_&&((n=this._activeExecutions.get(_.uri))===null||n===void 0||n.cancel())}}$acceptKernelMessageFromRenderer(t,i,s){const n=this._kernelData.get(t);if(!n)return;const o=this._extHostNotebook.getEditorById(i);n.onDidReceiveMessage.fire(Object.freeze({editor:o.apiEditor,message:s}))}_createNotebookCellExecution(t){if(t.index<0)throw new Error("CANNOT execute cell that has been REMOVED from notebook");const s=this._extHostNotebook.getNotebookDocument(t.notebook.uri).getCellFromApiCell(t);if(!s)throw new Error("invalid cell");if(this._activeExecutions.has(s.uri))throw new Error(`duplicate execution for ${s.uri}`);const n=new d(s.notebook,s,this._proxy);this._activeExecutions.set(s.uri,n);const o=n.onDidChangeState(()=>{n.state===b.Resolved&&(n.dispose(),o.dispose(),this._activeExecutions.delete(s.uri))});return n.asApiObject()}};w=Ve([We(3,c.ILogService)],w),e.ExtHostNotebookKernels=w;var b;(function(g){g[g.Init=0]="Init",g[g.Started=1]="Started",g[g.Resolved=2]="Resolved"})(b||(b={}));class d extends R.Disposable{constructor(t,i,s){super();this._document=t,this._cell=i,this._proxy=s,this._onDidChangeState=new p.Emitter,this.onDidChangeState=this._onDidChangeState.event,this._state=b.Init,this._tokenSource=this._register(new l.CancellationTokenSource),this._collector=new h(10,n=>this.applyEdits(n)),this._executionOrder=i.internalMetadata.executionOrder,this.mixinMetadata({runState:I.NotebookCellExecutionState.Pending,executionOrder:null})}get state(){return this._state}cancel(){this._tokenSource.cancel()}async applyEditSoon(t){await this._collector.addItem(t)}async applyEdits(t){return this._proxy.$applyExecutionEdits(this._document.uri,t)}verifyStateForOutput(){if(this._state===b.Init)throw new Error("Must call start before modifying cell output");if(this._state===b.Resolved)throw new Error("Cannot modify cell output after calling resolve")}mixinMetadata(t){this.applyEdits([{editType:9,handle:this._cell.handle,internalMetadata:t}])}cellIndexToHandle(t){let i=this._cell;if(t&&(i=this._document.getCellFromApiCell(t)),!i)throw new Error("INVALID cell");return i.handle}validateAndConvertOutputs(t){return t.map(i=>{const s=u.NotebookCellOutput.ensureUniqueMimeTypes(i.items,!0);return s===i.items?P.NotebookCellOutput.from(i):P.NotebookCellOutput.from({items:s,id:i.id,metadata:i.metadata})})}async updateOutputs(t,i,s){const n=this.cellIndexToHandle(i),o=this.validateAndConvertOutputs(f.asArray(t));return this.applyEditSoon({editType:2,handle:n,append:s,outputs:o})}async updateOutputItems(t,i,s){return t=u.NotebookCellOutput.ensureUniqueMimeTypes(f.asArray(t),!0),this.applyEditSoon({editType:7,items:t.map(P.NotebookCellOutputItem.from),outputId:i.id,append:s})}asApiObject(){const t=this;return Object.freeze({get token(){return t._tokenSource.token},get cell(){return t._cell.apiCell},get executionOrder(){return t._executionOrder},set executionOrder(s){t._executionOrder=s,t.mixinMetadata({executionOrder:s})},start(s){if(t._state===b.Resolved||t._state===b.Started)throw new Error("Cannot call start again");t._state=b.Started,t._onDidChangeState.fire(),t.mixinMetadata({runState:I.NotebookCellExecutionState.Executing,runStartTime:s??null})},end(s,n){if(t._state===b.Resolved)throw new Error("Cannot call resolve twice");t._state=b.Resolved,t._onDidChangeState.fire(),t.mixinMetadata({runState:null,lastRunSuccess:s??null,runEndTime:n??null})},clearOutput(s){return t.verifyStateForOutput(),t.updateOutputs([],s,!1)},appendOutput(s,n){return t.verifyStateForOutput(),t.updateOutputs(s,n,!0)},replaceOutput(s,n){return t.verifyStateForOutput(),t.updateOutputs(s,n,!1)},appendOutputItems(s,n){return t.verifyStateForOutput(),t.updateOutputItems(s,n,!0)},replaceOutputItems(s,n){return t.verifyStateForOutput(),t.updateOutputItems(s,n,!1)}})}}class h{constructor(t,i){this.delay=t,this.callback=i,this.batch=[]}addItem(t){return this.batch.push(t),this.waitPromise||(this.waitPromise=r.timeout(this.delay).then(()=>{this.waitPromise=void 0;const i=this.batch;return this.batch=[],this.callback(i)})),this.waitPromise}}}),define(me[235],ge([0,1,3,5,123]),function(X,e,p,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookRenderers=void 0;class y{constructor(P,E){this._extHostNotebook=E,this._rendererMessageEmitters=new Map,this.proxy=P.getProxy(R.MainContext.MainThreadNotebookRenderers)}$postRendererMessage(P,E,k){var r;const I=this._extHostNotebook.getEditorById(P);(r=this._rendererMessageEmitters.get(E))===null||r===void 0||r.fire({editor:I.apiEditor,message:k})}createRendererMessaging(P){return{onDidReceiveMessage:(...k)=>this.getOrCreateEmitterFor(P).event(...k),postMessage:(k,r)=>{const I=C.ExtHostNotebookEditor.apiEditorsToExtHost.get(k);if(!I)throw new Error("The first argument to postMessage() must be a NotebookEditor");this.proxy.$postMessage(I.id,P,r)}}}getOrCreateEmitterFor(P){let E=this._rendererMessageEmitters.get(P);return E||(E=new p.Emitter({onLastListenerRemove:()=>{E==null||E.dispose(),this._rendererMessageEmitters.delete(P)}}),this._rendererMessageEmitters.set(P,E),E)}}e.ExtHostNotebookRenderers=y}),define(me[62],ge([0,1,5,3,6,22,4,13]),function(X,e,p,R,C,y,A,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostOutputService=e.ExtHostOutputService=e.LazyOutputChannel=e.ExtHostPushOutputChannel=e.AbstractExtHostOutputChannel=void 0;class E extends C.Disposable{constructor(c,u,S,w){super();this._onDidAppend=this._register(new R.Emitter),this.onDidAppend=this._onDidAppend.event,this._name=c,this._proxy=w,this._id=w.$register(this.name,u,S),this._disposed=!1,this._offset=0}get name(){return this._name}append(c){this.validate(),this._offset+=c?y.VSBuffer.fromString(c).byteLength:0}update(){this._id.then(c=>this._proxy.$update(c))}appendLine(c){this.validate(),this.append(c+`
`)}clear(){this.validate();const c=this._offset;this._id.then(u=>this._proxy.$clear(u,c))}show(c,u){this.validate(),this._id.then(S=>this._proxy.$reveal(S,!!(typeof c=="boolean"?c:u)))}hide(){this.validate(),this._id.then(c=>this._proxy.$close(c))}validate(){if(this._disposed)throw new Error("Channel has been closed")}dispose(){super.dispose(),this._disposed||this._id.then(c=>this._proxy.$dispose(c)).then(()=>this._disposed=!0)}}e.AbstractExtHostOutputChannel=E;class k extends E{constructor(c,u){super(c,!1,void 0,u)}append(c){super.append(c),this._id.then(u=>this._proxy.$append(u,c)),this._onDidAppend.fire()}}e.ExtHostPushOutputChannel=k;class r extends E{constructor(c,u,S){super(c,!0,u,S)}append(c){throw new Error("Not supported")}}class I{constructor(c,u){this.name=c,this._channel=u}append(c){this._channel.then(u=>u.append(c))}appendLine(c){this._channel.then(u=>u.appendLine(c))}clear(){this._channel.then(c=>c.clear())}show(c,u){this._channel.then(S=>S.show(c,u))}hide(){this._channel.then(c=>c.hide())}dispose(){this._channel.then(c=>c.dispose())}}e.LazyOutputChannel=I;let l=class{constructor(c){this._proxy=c.getProxy(p.MainContext.MainThreadOutputService)}$setVisibleChannel(c){}createOutputChannel(c){if(c=c.trim(),!c)throw new Error("illegal argument `name`. must not be falsy");return new k(c,this._proxy)}createOutputChannelFromLogFile(c,u){if(c=c.trim(),!c)throw new Error("illegal argument `name`. must not be falsy");if(!u)throw new Error("illegal argument `file`. must not be falsy");return new r(c,u,this._proxy)}};l=Ve([We(0,P.IExtHostRpcService)],l),e.ExtHostOutputService=l,e.IExtHostOutputService=A.createDecorator("IExtHostOutputService")}),define(me[236],ge([0,1,16,21,3,6,5,2,7,14,18,54]),function(X,e,p,R,C,y,A,P,E,k,r,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createExtHostQuickOpen=void 0;function l(f,c,u){const S=f.getProxy(A.MainContext.MainThreadQuickOpen);class w{constructor(n,o){this._sessions=new Map,this._instances=0,this._workspace=n,this._commands=o}showQuickPick(n,o,v,m=R.CancellationToken.None){this._onDidSelectItem=void 0;const _=Promise.resolve(n),D=++this._instances,a=S.$show(D,{title:v==null?void 0:v.title,placeHolder:v==null?void 0:v.placeHolder,matchOnDescription:v==null?void 0:v.matchOnDescription,matchOnDetail:v==null?void 0:v.matchOnDetail,ignoreFocusLost:v==null?void 0:v.ignoreFocusOut,canPickMany:v==null?void 0:v.canPickMany},m),T={},L=a.then(()=>T);return Promise.race([L,_]).then(U=>{if(U!==T)return _.then(G=>{const ee=[];for(let z=0;z<G.length;z++){const N=G[z];let W,M,j,O,F;typeof N=="string"?W=N:(W=N.label,M=N.description,j=N.detail,O=N.picked,F=N.alwaysShow),ee.push({label:W,description:M,handle:z,detail:j,picked:O,alwaysShow:F})}return v&&typeof v.onDidSelectItem=="function"&&(this._onDidSelectItem=z=>{v.onDidSelectItem(G[z])}),S.$setItems(D,ee),a.then(z=>{if(typeof z=="number")return G[z];if(Array.isArray(z))return z.map(N=>G[N])})})}).then(void 0,U=>{if(!k.isPromiseCanceledError(U))return S.$setError(D,U),Promise.reject(U)})}$onItemSelected(n){this._onDidSelectItem&&this._onDidSelectItem(n)}showInput(n,o=R.CancellationToken.None){return this._validateInput=n?n.validateInput:void 0,S.$input(n,typeof this._validateInput=="function",o).then(void 0,v=>{if(!k.isPromiseCanceledError(v))return Promise.reject(v)})}$validateInput(n){return this._validateInput?p.asPromise(()=>this._validateInput(n)):Promise.resolve(void 0)}async showWorkspaceFolderPick(n,o=R.CancellationToken.None){const v=await this._commands.executeCommand("_workbench.pickWorkspaceFolder",[n]);if(!v)return;const m=await this._workspace.getWorkspaceFolders2();if(!!m)return m.find(_=>_.uri.toString()===v.uri.toString())}createQuickPick(n,o){const v=new t(n,o,()=>this._sessions.delete(v._id));return this._sessions.set(v._id,v),v}createInputBox(n){const o=new i(n,()=>this._sessions.delete(o._id));return this._sessions.set(o._id,o),o}$onDidChangeValue(n,o){const v=this._sessions.get(n);v&&v._fireDidChangeValue(o)}$onDidAccept(n){const o=this._sessions.get(n);o&&o._fireDidAccept()}$onDidChangeActive(n,o){const v=this._sessions.get(n);v instanceof t&&v._fireDidChangeActive(o)}$onDidChangeSelection(n,o){const v=this._sessions.get(n);v instanceof t&&v._fireDidChangeSelection(o)}$onDidTriggerButton(n,o){const v=this._sessions.get(n);v&&v._fireDidTriggerButton(o)}$onDidHide(n){const o=this._sessions.get(n);o&&o._fireDidHide()}}class b{constructor(n,o){this._extensionId=n,this._onDidDispose=o,this._id=t._nextId++,this._visible=!1,this._expectingHide=!1,this._enabled=!0,this._busy=!1,this._ignoreFocusOut=!0,this._value="",this._buttons=[],this._handlesToButtons=new Map,this._onDidAcceptEmitter=new C.Emitter,this._onDidChangeValueEmitter=new C.Emitter,this._onDidTriggerButtonEmitter=new C.Emitter,this._onDidHideEmitter=new C.Emitter,this._pendingUpdate={id:this._id},this._disposed=!1,this._disposables=[this._onDidTriggerButtonEmitter,this._onDidHideEmitter,this._onDidAcceptEmitter,this._onDidChangeValueEmitter],this.onDidChangeValue=this._onDidChangeValueEmitter.event,this.onDidAccept=this._onDidAcceptEmitter.event,this.onDidTriggerButton=this._onDidTriggerButtonEmitter.event,this.onDidHide=this._onDidHideEmitter.event}get title(){return this._title}set title(n){this._title=n,this.update({title:n})}get step(){return this._steps}set step(n){this._steps=n,this.update({step:n})}get totalSteps(){return this._totalSteps}set totalSteps(n){this._totalSteps=n,this.update({totalSteps:n})}get enabled(){return this._enabled}set enabled(n){this._enabled=n,this.update({enabled:n})}get busy(){return this._busy}set busy(n){this._busy=n,this.update({busy:n})}get ignoreFocusOut(){return this._ignoreFocusOut}set ignoreFocusOut(n){this._ignoreFocusOut=n,this.update({ignoreFocusOut:n})}get value(){return this._value}set value(n){this._value=n,this.update({value:n})}get placeholder(){return this._placeholder}set placeholder(n){this._placeholder=n,this.update({placeholder:n})}get buttons(){return this._buttons}set buttons(n){this._buttons=n.slice(),this._handlesToButtons.clear(),n.forEach((o,v)=>{const m=o===E.QuickInputButtons.Back?-1:v;this._handlesToButtons.set(m,o)}),this.update({buttons:n.map((o,v)=>({iconPath:d(o.iconPath),tooltip:o.tooltip,handle:o===E.QuickInputButtons.Back?-1:v}))})}show(){this._visible=!0,this._expectingHide=!0,this.update({visible:!0})}hide(){this._visible=!1,this.update({visible:!1})}_fireDidAccept(){this._onDidAcceptEmitter.fire()}_fireDidChangeValue(n){this._value=n,this._onDidChangeValueEmitter.fire(n)}_fireDidTriggerButton(n){const o=this._handlesToButtons.get(n);o&&this._onDidTriggerButtonEmitter.fire(o)}_fireDidHide(){this._expectingHide&&(this._expectingHide=!1,this._onDidHideEmitter.fire())}dispose(){this._disposed||(this._disposed=!0,this._fireDidHide(),this._disposables=y.dispose(this._disposables),this._updateTimeout&&(clearTimeout(this._updateTimeout),this._updateTimeout=void 0),this._onDidDispose(),S.$dispose(this._id))}update(n){if(!this._disposed){for(const o of Object.keys(n)){const v=n[o];this._pendingUpdate[o]=v===void 0?null:v}"visible"in this._pendingUpdate?(this._updateTimeout&&(clearTimeout(this._updateTimeout),this._updateTimeout=void 0),this.dispatchUpdate()):this._visible&&!this._updateTimeout&&(this._updateTimeout=setTimeout(()=>{this._updateTimeout=void 0,this.dispatchUpdate()},0))}}dispatchUpdate(){S.$createOrUpdate(this._pendingUpdate),this._pendingUpdate={id:this._id}}}b._nextId=1;function d(s){if(s instanceof E.ThemeIcon)return{id:s.id};const n=g(s),o=h(s);return{dark:typeof n=="string"?P.URI.file(n):n,light:typeof o=="string"?P.URI.file(o):o}}function h(s){return typeof s=="object"&&"light"in s?s.light:s}function g(s){return typeof s=="object"&&"dark"in s?s.dark:s}class t extends b{constructor(n,o,v){super(n,v);this._items=[],this._handlesToItems=new Map,this._itemsToHandles=new Map,this._canSelectMany=!1,this._matchOnDescription=!0,this._matchOnDetail=!0,this._sortByLabel=!0,this._activeItems=[],this._onDidChangeActiveEmitter=new C.Emitter,this._selectedItems=[],this._onDidChangeSelectionEmitter=new C.Emitter,this.onDidChangeActive=this._onDidChangeActiveEmitter.event,this.onDidChangeSelection=this._onDidChangeSelectionEmitter.event,this._disposables.push(this._onDidChangeActiveEmitter,this._onDidChangeSelectionEmitter),this.update({type:"quickPick"})}get items(){return this._items}set items(n){this._items=n.slice(),this._handlesToItems.clear(),this._itemsToHandles.clear(),n.forEach((o,v)=>{this._handlesToItems.set(v,o),this._itemsToHandles.set(o,v)}),this.update({items:n.map((o,v)=>({label:o.label,description:o.description,handle:v,detail:o.detail,picked:o.picked,alwaysShow:o.alwaysShow}))})}get canSelectMany(){return this._canSelectMany}set canSelectMany(n){this._canSelectMany=n,this.update({canSelectMany:n})}get matchOnDescription(){return this._matchOnDescription}set matchOnDescription(n){this._matchOnDescription=n,this.update({matchOnDescription:n})}get matchOnDetail(){return this._matchOnDetail}set matchOnDetail(n){this._matchOnDetail=n,this.update({matchOnDetail:n})}get sortByLabel(){return this._sortByLabel}set sortByLabel(n){this._sortByLabel=n,this.update({sortByLabel:n})}get activeItems(){return this._activeItems}set activeItems(n){this._activeItems=n.filter(o=>this._itemsToHandles.has(o)),this.update({activeItems:this._activeItems.map(o=>this._itemsToHandles.get(o))})}get selectedItems(){return this._selectedItems}set selectedItems(n){this._selectedItems=n.filter(o=>this._itemsToHandles.has(o)),this.update({selectedItems:this._selectedItems.map(o=>this._itemsToHandles.get(o))})}_fireDidChangeActive(n){const o=r.coalesce(n.map(v=>this._handlesToItems.get(v)));this._activeItems=o,this._onDidChangeActiveEmitter.fire(o)}_fireDidChangeSelection(n){const o=r.coalesce(n.map(v=>this._handlesToItems.get(v)));this._selectedItems=o,this._onDidChangeSelectionEmitter.fire(o)}}class i extends b{constructor(n,o){super(n,o);this._password=!1,this.update({type:"inputBox"})}get password(){return this._password}set password(n){this._password=n,this.update({password:n})}get prompt(){return this._prompt}set prompt(n){this._prompt=n,this.update({prompt:n})}get validationMessage(){return this._validationMessage}set validationMessage(n){this._validationMessage=n,this.update({validationMessage:n,severity:n?I.default.Error:I.default.Ignore})}}return new w(c,u)}e.createExtHostQuickOpen=l}),define(me[237],ge([0,1,2,3,51,6,16,5,18,95,12,26,34]),function(X,e,p,R,C,y,A,P,E,k,r,I,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostSCM=e.ExtHostSCMInputBox=void 0;function f(n){if(n)return typeof n.iconPath=="string"?p.URI.file(n.iconPath):n.iconPath}function c(n,o){if(!n.iconPath&&!o.iconPath)return 0;if(n.iconPath){if(!o.iconPath)return 1}else return-1;const v=typeof n.iconPath=="string"?n.iconPath:n.iconPath.fsPath,m=typeof o.iconPath=="string"?o.iconPath:o.iconPath.fsPath;return k.comparePaths(v,m)}function u(n,o){let v=0;if(n.strikeThrough!==o.strikeThrough)return n.strikeThrough?1:-1;if(n.faded!==o.faded)return n.faded?1:-1;if(n.tooltip!==o.tooltip)return(n.tooltip||"").localeCompare(o.tooltip||"");if(v=c(n,o),v!==0)return v;if(n.light&&o.light)v=c(n.light,o.light);else{if(n.light)return 1;if(o.light)return-1}if(v!==0)return v;if(n.dark&&o.dark)v=c(n.dark,o.dark);else{if(n.dark)return 1;if(o.dark)return-1}return v}function S(n,o){if(n.command!==o.command)return n.command<o.command?-1:1;if(n.title!==o.title)return n.title<o.title?-1:1;if(n.tooltip!==o.tooltip){if(n.tooltip!==void 0&&o.tooltip!==void 0)return n.tooltip<o.tooltip?-1:1;if(n.tooltip!==void 0)return 1;if(o.tooltip!==void 0)return-1}if(n.arguments===o.arguments)return 0;if(n.arguments)if(o.arguments){if(n.arguments.length!==o.arguments.length)return n.arguments.length-o.arguments.length}else return 1;else return-1;for(let v=0;v<n.arguments.length;v++){const m=n.arguments[v],_=o.arguments[v];if(m!==_)return m<_?-1:1}return 0}function w(n,o){let v=k.comparePaths(n.resourceUri.fsPath,o.resourceUri.fsPath,!0);if(v!==0)return v;if(n.command&&o.command)v=S(n.command,o.command);else{if(n.command)return 1;if(o.command)return-1}if(v!==0)return v;if(n.decorations&&o.decorations)v=u(n.decorations,o.decorations);else{if(n.decorations)return 1;if(o.decorations)return-1}return v}function b(n,o){for(let v=0;v<n.length;v++)if(n[v]!==o[v])return!1;return!0}function d(n,o){return n.command===o.command&&n.title===o.title&&n.tooltip===o.tooltip&&(n.arguments&&o.arguments?b(n.arguments,o.arguments):n.arguments===o.arguments)}function h(n,o){return E.equals(n,o,d)}class g{constructor(o,v,m){this._extension=o,this._proxy=v,this._sourceControlHandle=m,this._value="",this._onDidChange=new R.Emitter,this._placeholder="",this._visible=!0}get value(){return this._value}set value(o){this._proxy.$setInputBoxValue(this._sourceControlHandle,o),this.updateValue(o)}get onDidChange(){return this._onDidChange.event}get placeholder(){return this._placeholder}set placeholder(o){this._proxy.$setInputBoxPlaceholder(this._sourceControlHandle,o),this._placeholder=o}get validateInput(){return l.checkProposedApiEnabled(this._extension),this._validateInput}set validateInput(o){if(l.checkProposedApiEnabled(this._extension),o&&typeof o!="function")throw new Error(`[${this._extension.identifier.value}]: Invalid SCM input box validation function`);this._validateInput=o,this._proxy.$setValidationProviderIsEnabled(this._sourceControlHandle,!!o)}get visible(){return this._visible}set visible(o){o=!!o,this._visible!==o&&(this._visible=o,this._proxy.$setInputBoxVisibility(this._sourceControlHandle,o))}focus(){l.checkProposedApiEnabled(this._extension),this._visible||(this.visible=!0),this._proxy.$setInputBoxFocus(this._sourceControlHandle)}showValidationMessage(o,v){l.checkProposedApiEnabled(this._extension),this._proxy.$showValidationMessage(this._sourceControlHandle,o,v)}$onInputBoxValueChange(o){this.updateValue(o)}updateValue(o){this._value=o,this._onDidChange.fire(o)}}e.ExtHostSCMInputBox=g;class t{constructor(o,v,m,_,D){this._proxy=o,this._commands=v,this._sourceControlHandle=m,this._id=_,this._label=D,this._resourceHandlePool=0,this._resourceStates=[],this._resourceStatesMap=new Map,this._resourceStatesCommandsMap=new Map,this._resourceStatesDisposablesMap=new Map,this._onDidUpdateResourceStates=new R.Emitter,this.onDidUpdateResourceStates=this._onDidUpdateResourceStates.event,this._disposed=!1,this._onDidDispose=new R.Emitter,this.onDidDispose=this._onDidDispose.event,this._handlesSnapshot=[],this._resourceSnapshot=[],this._hideWhenEmpty=void 0,this.handle=t._handlePool++}get disposed(){return this._disposed}get id(){return this._id}get label(){return this._label}set label(o){this._label=o,this._proxy.$updateGroupLabel(this._sourceControlHandle,this.handle,o)}get hideWhenEmpty(){return this._hideWhenEmpty}set hideWhenEmpty(o){this._hideWhenEmpty=o,this._proxy.$updateGroup(this._sourceControlHandle,this.handle,this.features)}get features(){return{hideWhenEmpty:this.hideWhenEmpty}}get resourceStates(){return[...this._resourceStates]}set resourceStates(o){this._resourceStates=[...o],this._onDidUpdateResourceStates.fire()}getResourceState(o){return this._resourceStatesMap.get(o)}$executeResourceCommand(o,v){const m=this._resourceStatesCommandsMap.get(o);return m?A.asPromise(()=>this._commands.executeCommand(m.command,...m.arguments||[],v)):Promise.resolve(void 0)}_takeResourceStateSnapshot(){var o;const v=[...this._resourceStates].sort(w),_=E.sortedDiff(this._resourceSnapshot,v,w).map(T=>{const L=T.toInsert.map(U=>{const G=this._resourceHandlePool++;this._resourceStatesMap.set(G,U);const ee=U.resourceUri,z=f(U.decorations),N=U.decorations&&f(U.decorations.light)||z,W=U.decorations&&f(U.decorations.dark)||z,M=[];let j;if(U.command)if(U.command.command==="vscode.open"||U.command.command==="vscode.diff"){const le=new y.DisposableStore;j=this._commands.converter.toInternal(U.command,le),this._resourceStatesDisposablesMap.set(G,le)}else this._resourceStatesCommandsMap.set(G,U.command);N&&M.push(N),W&&W.toString()!==(N==null?void 0:N.toString())&&M.push(W);const O=U.decorations&&U.decorations.tooltip||"",F=U.decorations&&!!U.decorations.strikeThrough,B=U.decorations&&!!U.decorations.faded,$=U.contextValue||"";return{rawResource:[G,ee,M,O,F,B,$,j],handle:G}});return{start:T.start,deleteCount:T.deleteCount,toInsert:L}}),D=_.map(({start:T,deleteCount:L,toInsert:U})=>[T,L,U.map(G=>G.rawResource)]),a=_.reverse();for(const{start:T,deleteCount:L,toInsert:U}of a){const G=U.map(z=>z.handle),ee=this._handlesSnapshot.splice(T,L,...G);for(const z of ee)this._resourceStatesMap.delete(z),this._resourceStatesCommandsMap.delete(z),(o=this._resourceStatesDisposablesMap.get(z))===null||o===void 0||o.dispose(),this._resourceStatesDisposablesMap.delete(z)}return this._resourceSnapshot=v,D}dispose(){this._disposed=!0,this._onDidDispose.fire()}}t._handlePool=0;class i{constructor(o,v,m,_,D,a){this._proxy=v,this._commands=m,this._id=_,this._label=D,this._rootUri=a,this._groups=new Map,this._count=void 0,this._quickDiffProvider=void 0,this._commitTemplate=void 0,this._acceptInputDisposables=new y.MutableDisposable,this._acceptInputCommand=void 0,this._statusBarDisposables=new y.MutableDisposable,this._statusBarCommands=void 0,this._selected=!1,this._onDidChangeSelection=new R.Emitter,this.onDidChangeSelection=this._onDidChangeSelection.event,this.handle=i._handlePool++,this.createdResourceGroups=new Map,this.updatedResourceGroups=new Set,this._inputBox=new g(o,this._proxy,this.handle),this._proxy.$registerSourceControl(this.handle,_,D,a)}get id(){return this._id}get label(){return this._label}get rootUri(){return this._rootUri}get inputBox(){return this._inputBox}get count(){return this._count}set count(o){this._count!==o&&(this._count=o,this._proxy.$updateSourceControl(this.handle,{count:o}))}get quickDiffProvider(){return this._quickDiffProvider}set quickDiffProvider(o){this._quickDiffProvider=o,this._proxy.$updateSourceControl(this.handle,{hasQuickDiffProvider:!!o})}get commitTemplate(){return this._commitTemplate}set commitTemplate(o){o!==this._commitTemplate&&(this._commitTemplate=o,this._proxy.$updateSourceControl(this.handle,{commitTemplate:o}))}get acceptInputCommand(){return this._acceptInputCommand}set acceptInputCommand(o){this._acceptInputDisposables.value=new y.DisposableStore,this._acceptInputCommand=o;const v=this._commands.converter.toInternal(o,this._acceptInputDisposables.value);this._proxy.$updateSourceControl(this.handle,{acceptInputCommand:v})}get statusBarCommands(){return this._statusBarCommands}set statusBarCommands(o){if(this._statusBarCommands&&o&&h(this._statusBarCommands,o))return;this._statusBarDisposables.value=new y.DisposableStore,this._statusBarCommands=o;const v=(o||[]).map(m=>this._commands.converter.toInternal(m,this._statusBarDisposables.value));this._proxy.$updateSourceControl(this.handle,{statusBarCommands:v})}get selected(){return this._selected}createResourceGroup(o,v){const m=new t(this._proxy,this._commands,this.handle,o,v),_=R.Event.once(m.onDidDispose)(()=>this.createdResourceGroups.delete(m));return this.createdResourceGroups.set(m,_),this.eventuallyAddResourceGroups(),m}eventuallyAddResourceGroups(){const o=[],v=[];for(const[m,_]of this.createdResourceGroups){_.dispose();const D=m.onDidUpdateResourceStates(()=>{this.updatedResourceGroups.add(m),this.eventuallyUpdateResourceStates()});R.Event.once(m.onDidDispose)(()=>{this.updatedResourceGroups.delete(m),D.dispose(),this._groups.delete(m.handle),this._proxy.$unregisterGroup(this.handle,m.handle)}),o.push([m.handle,m.id,m.label,m.features]);const a=m._takeResourceStateSnapshot();a.length>0&&v.push([m.handle,a]),this._groups.set(m.handle,m)}this._proxy.$registerGroups(this.handle,o,v),this.createdResourceGroups.clear()}eventuallyUpdateResourceStates(){const o=[];this.updatedResourceGroups.forEach(v=>{const m=v._takeResourceStateSnapshot();m.length!==0&&o.push([v.handle,m])}),o.length>0&&this._proxy.$spliceResourceStates(this.handle,o),this.updatedResourceGroups.clear()}getResourceGroup(o){return this._groups.get(o)}setSelectionState(o){this._selected=o,this._onDidChangeSelection.fire(o)}dispose(){this._acceptInputDisposables.dispose(),this._statusBarDisposables.dispose(),this._groups.forEach(o=>o.dispose()),this._proxy.$unregisterSourceControl(this.handle)}}i._handlePool=0,Ve([C.debounce(100)],i.prototype,"eventuallyAddResourceGroups",null),Ve([C.debounce(100)],i.prototype,"eventuallyUpdateResourceStates",null);let s=class Nn{constructor(o,v,m){this._commands=v,this.logService=m,this._sourceControls=new Map,this._sourceControlsByExtension=new Map,this._onDidChangeActiveProvider=new R.Emitter,this._proxy=o.getProxy(P.MainContext.MainThreadSCM),this._telemetry=o.getProxy(P.MainContext.MainThreadTelemetry),v.registerArgumentProcessor({processArgument:_=>{if(_&&_.$mid===3){const D=this._sourceControls.get(_.sourceControlHandle);if(!D)return _;const a=D.getResourceGroup(_.groupHandle);return a?a.getResourceState(_.handle):_}else if(_&&_.$mid===4){const D=this._sourceControls.get(_.sourceControlHandle);return D?D.getResourceGroup(_.groupHandle):_}else if(_&&_.$mid===5){const D=this._sourceControls.get(_.handle);return D||_}return _}})}get onDidChangeActiveProvider(){return this._onDidChangeActiveProvider.event}createSourceControl(o,v,m,_){this.logService.trace("ExtHostSCM#createSourceControl",o.identifier.value,v,m,_),this._telemetry.$publicLog2("api/scm/createSourceControl",{extensionId:o.identifier.value});const D=Nn._handlePool++,a=new i(o,this._proxy,this._commands,v,m,_);this._sourceControls.set(D,a);const T=this._sourceControlsByExtension.get(I.ExtensionIdentifier.toKey(o.identifier))||[];return T.push(a),this._sourceControlsByExtension.set(I.ExtensionIdentifier.toKey(o.identifier),T),a}getLastInputBox(o){this.logService.trace("ExtHostSCM#getLastInputBox",o.identifier.value);const v=this._sourceControlsByExtension.get(I.ExtensionIdentifier.toKey(o.identifier)),m=v&&v[v.length-1];return m&&m.inputBox}$provideOriginalResource(o,v,m){const _=p.URI.revive(v);this.logService.trace("ExtHostSCM#$provideOriginalResource",o,_.toString());const D=this._sourceControls.get(o);return!D||!D.quickDiffProvider||!D.quickDiffProvider.provideOriginalResource?Promise.resolve(null):A.asPromise(()=>D.quickDiffProvider.provideOriginalResource(_,m)).then(a=>a||null)}$onInputBoxValueChange(o,v){this.logService.trace("ExtHostSCM#$onInputBoxValueChange",o);const m=this._sourceControls.get(o);return m&&m.inputBox.$onInputBoxValueChange(v),Promise.resolve(void 0)}$executeResourceCommand(o,v,m,_){this.logService.trace("ExtHostSCM#$executeResourceCommand",o,v,m);const D=this._sourceControls.get(o);if(!D)return Promise.resolve(void 0);const a=D.getResourceGroup(v);return a?a.$executeResourceCommand(m,_):Promise.resolve(void 0)}$validateInput(o,v,m){this.logService.trace("ExtHostSCM#$validateInput",o);const _=this._sourceControls.get(o);return!_||!_.inputBox.validateInput?Promise.resolve(void 0):A.asPromise(()=>_.inputBox.validateInput(v,m)).then(D=>D?Promise.resolve([D.message,D.type]):Promise.resolve(void 0))}$setSelectedSourceControl(o){var v,m;return this.logService.trace("ExtHostSCM#$setSelectedSourceControl",o),o!==void 0&&((v=this._sourceControls.get(o))===null||v===void 0||v.setSelectionState(!0)),this._selectedSourceControlHandle!==void 0&&((m=this._sourceControls.get(this._selectedSourceControlHandle))===null||m===void 0||m.setSelectionState(!1)),this._selectedSourceControlHandle=o,Promise.resolve(void 0)}};s._handlePool=0,s=Ve([We(2,r.ILogService)],s),e.ExtHostSCM=s});var rt=this&&this.__classPrivateFieldSet||function(X,e,p,R,C){if(R==="m")throw new TypeError("Private method is not writable");if(R==="a"&&!C)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?X!==e||!C:!e.has(X))throw new TypeError("Cannot write private member to an object whose class did not declare it");return R==="a"?C.call(X,p):C?C.value=p:e.set(X,p),p},$e=this&&this.__classPrivateFieldGet||function(X,e,p,R){if(p==="a"&&!R)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?X!==e||!R:!e.has(X))throw new TypeError("Cannot read private member from an object whose class did not declare it");return p==="m"?R:p==="a"?R.call(X):R?R.value:e.get(X)};define(me[238],ge([0,1,7,5,161,6,17]),function(X,e,p,R,C,y,A){"use strict";var P,E;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostStatusBar=e.ExtHostStatusBarEntry=void 0;class k{constructor(f,c,u,S,w=p.StatusBarAlignment.Left,b){P.set(this,void 0),E.set(this,void 0),this._disposed=!1,this._visible=!1,this._text="",this._internalCommandRegistration=new y.DisposableStore,rt(this,P,f,"f"),rt(this,E,c,"f"),this._entryId=k.ID_GEN++,this._extension=u,this._id=S,this._alignment=w,this._priority=b}get id(){var f;return(f=this._id)!==null&&f!==void 0?f:this._extension.identifier.value}get alignment(){return this._alignment}get priority(){return this._priority}get text(){return this._text}get name(){return this._name}get tooltip(){return this._tooltip}get tooltip2(){return this._tooltip2}get color(){return this._color}get backgroundColor(){return this._backgroundColor}get command(){var f;return(f=this._command)===null||f===void 0?void 0:f.fromApi}get accessibilityInformation(){return this._accessibilityInformation}set text(f){this._text=f,this.update()}set name(f){this._name=f,this.update()}set tooltip(f){this._tooltip=f,this.update()}set tooltip2(f){this._tooltip2=f,this.update()}set color(f){this._color=f,this.update()}set backgroundColor(f){f&&!k.ALLOWED_BACKGROUND_COLORS.has(f.id)&&(f=void 0),this._backgroundColor=f,this.update()}set command(f){var c;((c=this._command)===null||c===void 0?void 0:c.fromApi)!==f&&(this._internalCommandRegistration.clear(),typeof f=="string"?this._command={fromApi:f,internal:$e(this,E,"f").toInternal({title:"",command:f},this._internalCommandRegistration)}:f?this._command={fromApi:f,internal:$e(this,E,"f").toInternal(f,this._internalCommandRegistration)}:this._command=void 0,this.update())}set accessibilityInformation(f){this._accessibilityInformation=f,this.update()}show(){this._visible=!0,this.update()}hide(){clearTimeout(this._timeoutHandle),this._visible=!1,$e(this,P,"f").$dispose(this._entryId)}update(){this._disposed||!this._visible||(clearTimeout(this._timeoutHandle),this._timeoutHandle=setTimeout(()=>{var f;this._timeoutHandle=void 0;let c;this._extension?this._id?c=`${this._extension.identifier.value}.${this._id}`:c=this._extension.identifier.value:c=this._id;let u;this._name?u=this._name:u=C.localize(0,null,this._extension.displayName||this._extension.name);let S=this._color;this._backgroundColor&&(S=k.ALLOWED_BACKGROUND_COLORS.get(this._backgroundColor.id));const w=this._tooltip2!==void 0?A.MarkdownString.fromStrict(this._tooltip2):this.tooltip;$e(this,P,"f").$setEntry(this._entryId,c,u,this._text,w,(f=this._command)===null||f===void 0?void 0:f.internal,S,this._backgroundColor,this._alignment===p.StatusBarAlignment.Left?0:1,this._priority,this._accessibilityInformation)},0))}dispose(){this.hide(),this._disposed=!0}}e.ExtHostStatusBarEntry=k,P=new WeakMap,E=new WeakMap,k.ID_GEN=0,k.ALLOWED_BACKGROUND_COLORS=new Map([["statusBarItem.errorBackground",new p.ThemeColor("statusBarItem.errorForeground")]]);class r{constructor(f){this._messages=[],this._item=f.createStatusBarEntry(void 0,"status.extensionMessage",p.StatusBarAlignment.Left,Number.MIN_VALUE),this._item.name=C.localize(1,null)}dispose(){this._messages.length=0,this._item.dispose()}setMessage(f){const c={message:f};return this._messages.unshift(c),this._update(),new p.Disposable(()=>{const u=this._messages.indexOf(c);u>=0&&(this._messages.splice(u,1),this._update())})}_update(){this._messages.length>0?(this._item.text=this._messages[0].message,this._item.show()):this._item.hide()}}class I{constructor(f,c){this._proxy=f.getProxy(R.MainContext.MainThreadStatusBar),this._commands=c,this._statusMessage=new r(this)}createStatusBarEntry(f,c,u,S){return new k(this._proxy,this._commands,f,c,u,S)}setStatusBarMessage(f,c){const u=this._statusMessage.setMessage(f);let S;return typeof c=="number"?S=setTimeout(()=>u.dispose(),c):typeof c!="undefined"&&c.then(()=>u.dispose(),()=>u.dispose()),new p.Disposable(()=>{u.dispose(),clearTimeout(S)})}}e.ExtHostStatusBar=I}),define(me[87],ge([0,1,5,3,4]),function(X,e,p,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostStorage=e.ExtHostStorage=void 0;class y{constructor(P){this._onDidChangeStorage=new R.Emitter,this.onDidChangeStorage=this._onDidChangeStorage.event,this._proxy=P.getProxy(p.MainContext.MainThreadStorage)}registerExtensionStorageKeysToSync(P,E){this._proxy.$registerExtensionStorageKeysToSync(P,E)}getValue(P,E,k){return this._proxy.$getValue(P,E).then(r=>r||k)}setValue(P,E,k){return this._proxy.$setValue(P,E,k)}$acceptValue(P,E,k){this._onDidChangeStorage.fire({shared:P,key:E,value:k})}}e.ExtHostStorage=y,e.IExtHostStorage=C.createDecorator("IExtHostStorage")}),define(me[88],ge([0,1,4,27,12,86,2]),function(X,e,p,R,C,y,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionStoragePaths=e.IExtensionStoragePaths=void 0,e.IExtensionStoragePaths=p.createDecorator("IExtensionStoragePaths");let P=class{constructor(k,r,I){var l;this._logService=r,this._extHostFileSystem=I,this._workspace=(l=k.workspace)!==null&&l!==void 0?l:void 0,this._environment=k.environment,this.whenReady=this._getOrCreateWorkspaceStoragePath().then(f=>this._value=f)}async _getOrCreateWorkspaceStoragePath(){var k;if(!this._workspace)return Promise.resolve(void 0);const r=this._workspace.id,I=A.URI.joinPath(this._environment.workspaceStorageHome,r);try{return await this._extHostFileSystem.value.stat(I),this._logService.trace("[ExtHostStorage] storage dir already exists",I),I}catch(l){}try{return this._logService.trace("[ExtHostStorage] creating dir and metadata-file",I),await this._extHostFileSystem.value.createDirectory(I),await this._extHostFileSystem.value.writeFile(A.URI.joinPath(I,"meta.json"),new TextEncoder().encode(JSON.stringify({id:this._workspace.id,configuration:(k=A.URI.revive(this._workspace.configuration))===null||k===void 0?void 0:k.toString(),name:this._workspace.name},void 0,2))),I}catch(l){this._logService.error("[ExtHostStorage]",l);return}}workspaceValue(k){if(this._value)return A.URI.joinPath(this._value,k.identifier.value)}globalValue(k){return A.URI.joinPath(this._environment.globalStorageHome,k.identifier.value.toLowerCase())}};P=Ve([We(0,R.IExtHostInitDataService),We(1,C.ILogService),We(2,y.IExtHostConsumerFileSystem)],P),e.ExtensionStoragePaths=P}),define(me[33],ge([0,1,3,5,4,2,13,6,7,162,14,202,21,32,189,15]),function(X,e,p,R,C,y,A,P,E,k,r,I,l,f,c,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostTerminalService=e.EnvironmentVariableCollection=e.BaseExtHostTerminalService=e.ExtHostPseudoterminal=e.ExtHostTerminal=e.IExtHostTerminalService=void 0,e.IExtHostTerminalService=C.createDecorator("IExtHostTerminalService");class S{constructor(s,n,o,v){this._proxy=s,this._id=n,this._creationOptions=o,this._name=v,this._disposed=!1,this.isOpen=!1,this._creationOptions=Object.freeze(this._creationOptions),this._pidPromise=new Promise(_=>this._pidPromiseComplete=_);const m=this;this.value={get name(){return m._name||""},get processId(){return m._pidPromise},get creationOptions(){return m._creationOptions},get exitStatus(){return m._exitStatus},sendText(_,D=!0){m._checkDisposed(),m._proxy.$sendText(m._id,_,D)},show(_){m._checkDisposed(),m._proxy.$show(m._id,_)},hide(){m._checkDisposed(),m._proxy.$hide(m._id)},dispose(){m._disposed||(m._disposed=!0,m._proxy.$dispose(m._id))},get dimensions(){if(!(m._cols===void 0||m._rows===void 0))return{columns:m._cols,rows:m._rows}}}}async create(s,n){if(typeof this._id!="string")throw new Error("Terminal has already been created");await this._proxy.$createTerminal(this._id,{name:s.name,shellPath:u.withNullAsUndefined(s.shellPath),shellArgs:u.withNullAsUndefined(s.shellArgs),cwd:u.withNullAsUndefined(s.cwd),env:u.withNullAsUndefined(s.env),icon:u.withNullAsUndefined(t(s.iconPath)),initialText:u.withNullAsUndefined(s.message),strictEnv:u.withNullAsUndefined(s.strictEnv),hideFromUser:u.withNullAsUndefined(s.hideFromUser),isFeatureTerminal:u.withNullAsUndefined(n==null?void 0:n.isFeatureTerminal),isExtensionOwnedTerminal:!0,useShellEnvironment:u.withNullAsUndefined(n==null?void 0:n.useShellEnvironment),isSplitTerminal:u.withNullAsUndefined(n==null?void 0:n.isSplitTerminal)})}async createExtensionTerminal(s,n){if(typeof this._id!="string")throw new Error("Terminal has already been created");if(await this._proxy.$createTerminal(this._id,{name:this._name,isExtensionCustomPtyTerminal:!0,icon:n,isSplitTerminal:s}),typeof this._id=="string")throw new Error("Terminal creation failed");return this._id}_checkDisposed(){if(this._disposed)throw new Error("Terminal has already been disposed")}set name(s){this._name=s}setExitCode(s){this._exitStatus=Object.freeze({code:s})}setDimensions(s,n){return s===this._cols&&n===this._rows||s===0||n===0?!1:(this._cols=s,this._rows=n,!0)}_setProcessId(s){this._pidPromiseComplete?(this._pidPromiseComplete(s),this._pidPromiseComplete=void 0):this._pidPromise.then(n=>{n!==s&&(this._pidPromise=Promise.resolve(s))})}}e.ExtHostTerminal=S;class w{constructor(s){this._pty=s,this.id=0,this.shouldPersist=!1,this._onProcessData=new p.Emitter,this.onProcessData=this._onProcessData.event,this._onProcessExit=new p.Emitter,this.onProcessExit=this._onProcessExit.event,this._onProcessReady=new p.Emitter,this._onProcessTitleChanged=new p.Emitter,this.onProcessTitleChanged=this._onProcessTitleChanged.event,this._onProcessOverrideDimensions=new p.Emitter,this._onProcessShellTypeChanged=new p.Emitter,this.onProcessShellTypeChanged=this._onProcessShellTypeChanged.event}get onProcessReady(){return this._onProcessReady.event}get onProcessOverrideDimensions(){return this._onProcessOverrideDimensions.event}async start(){}shutdown(){this._pty.close()}input(s){this._pty.handleInput&&this._pty.handleInput(s)}resize(s,n){this._pty.setDimensions&&this._pty.setDimensions({columns:s,rows:n})}async processBinary(s){}acknowledgeDataEvent(s){}getInitialCwd(){return Promise.resolve("")}getCwd(){return Promise.resolve("")}getLatency(){return Promise.resolve(0)}startSendingEvents(s){this._pty.onDidWrite(n=>this._onProcessData.fire(n)),this._pty.onDidClose&&this._pty.onDidClose((n=void 0)=>{this._onProcessExit.fire(n===void 0?void 0:n)}),this._pty.onDidOverrideDimensions&&this._pty.onDidOverrideDimensions(n=>this._onProcessOverrideDimensions.fire(n&&{cols:n.columns,rows:n.rows})),this._pty.onDidChangeName&&this._pty.onDidChangeName(n=>this._onProcessTitleChanged.fire(n)),this._pty.open(s||void 0),this._pty.setDimensions&&s&&this._pty.setDimensions(s),this._onProcessReady.fire({pid:-1,cwd:""})}}e.ExtHostPseudoterminal=w;let b=1,d=class extends P.Disposable{constructor(s,n){super();this._terminals=[],this._terminalProcesses=new Map,this._terminalProcessDisposables={},this._extensionTerminalAwaitingStart={},this._getTerminalPromises={},this._environmentVariableCollections=new Map,this._linkProviders=new Set,this._profileProviders=new Map,this._terminalLinkCache=new Map,this._terminalLinkCancellationSource=new Map,this._onDidCloseTerminal=new p.Emitter,this._onDidOpenTerminal=new p.Emitter,this._onDidChangeActiveTerminal=new p.Emitter,this._onDidChangeTerminalDimensions=new p.Emitter,this._proxy=n.getProxy(R.MainContext.MainThreadTerminalService),this._bufferer=new c.TerminalDataBufferer(this._proxy.$sendProcessData),this._onDidWriteTerminalData=new p.Emitter({onFirstListenerAdd:()=>this._proxy.$startSendingDataEvents(),onLastListenerRemove:()=>this._proxy.$stopSendingDataEvents()}),this._proxy.$registerProcessSupport(s),this._register({dispose:()=>{for(const[o,v]of this._terminalProcesses)v.shutdown(!0)}})}get activeTerminal(){var s;return(s=this._activeTerminal)===null||s===void 0?void 0:s.value}get terminals(){return this._terminals.map(s=>s.value)}get onDidCloseTerminal(){return this._onDidCloseTerminal&&this._onDidCloseTerminal.event}get onDidOpenTerminal(){return this._onDidOpenTerminal&&this._onDidOpenTerminal.event}get onDidChangeActiveTerminal(){return this._onDidChangeActiveTerminal&&this._onDidChangeActiveTerminal.event}get onDidChangeTerminalDimensions(){return this._onDidChangeTerminalDimensions&&this._onDidChangeTerminalDimensions.event}get onDidWriteTerminalData(){return this._onDidWriteTerminalData&&this._onDidWriteTerminalData.event}getDefaultShell(s){const n=s?this._defaultAutomationProfile:this._defaultProfile;return(n==null?void 0:n.path)||""}getDefaultShellArgs(s){const n=s?this._defaultAutomationProfile:this._defaultProfile;return(n==null?void 0:n.args)||[]}createExtensionTerminal(s,n){const o=new S(this._proxy,f.generateUuid(),s,s.name),v=new w(s.pty);return o.createExtensionTerminal(n==null?void 0:n.isSplitTerminal,t(s.iconPath)).then(m=>{const _=this._setupExtHostProcessListeners(m,v);this._terminalProcessDisposables[m]=_}),this._terminals.push(o),o.value}attachPtyToTerminal(s,n){if(!this._getTerminalById(s))throw new Error(`Cannot resolve terminal with id ${s} for virtual process`);const v=new w(n),m=this._setupExtHostProcessListeners(s,v);this._terminalProcessDisposables[s]=m}async $acceptActiveTerminalChanged(s){const n=this._activeTerminal;if(s===null){this._activeTerminal=void 0,n!==this._activeTerminal&&this._onDidChangeActiveTerminal.fire(this._activeTerminal);return}const o=this._getTerminalById(s);o&&(this._activeTerminal=o,n!==this._activeTerminal&&this._onDidChangeActiveTerminal.fire(this._activeTerminal.value))}async $acceptTerminalProcessData(s,n){const o=this._getTerminalById(s);o&&this._onDidWriteTerminalData.fire({terminal:o.value,data:n})}async $acceptTerminalDimensions(s,n,o){const v=this._getTerminalById(s);v&&v.setDimensions(n,o)&&this._onDidChangeTerminalDimensions.fire({terminal:v.value,dimensions:v.value.dimensions})}async $acceptTerminalMaximumDimensions(s,n,o){var v;(v=this._terminalProcesses.get(s))===null||v===void 0||v.resize(n,o)}async $acceptTerminalTitleChange(s,n){const o=this._getTerminalById(s);o&&(o.name=n)}async $acceptTerminalClosed(s,n){const o=this._getTerminalObjectIndexById(this._terminals,s);if(o!==null){const v=this._terminals.splice(o,1)[0];v.setExitCode(n),this._onDidCloseTerminal.fire(v.value)}}$acceptTerminalOpened(s,n,o,v){if(n){const D=this._getTerminalObjectIndexById(this._terminals,n);if(D!==null){this._terminals[D]._id=s,this._onDidOpenTerminal.fire(this.terminals[D]),this._terminals[D].isOpen=!0;return}}const m={name:v.name,shellPath:v.executable,shellArgs:v.args,cwd:typeof v.cwd=="string"?v.cwd:y.URI.revive(v.cwd),env:v.env,hideFromUser:v.hideFromUser},_=new S(this._proxy,s,m,o);this._terminals.push(_),this._onDidOpenTerminal.fire(_.value),_.isOpen=!0}async $acceptTerminalProcessId(s,n){const o=this._getTerminalById(s);o&&o._setProcessId(n)}async $startExtensionTerminal(s,n){const o=this._getTerminalById(s);if(!o)return{message:k.localize(0,null,s)};o.isOpen||await new Promise(m=>{const _=this.onDidOpenTerminal(async D=>{D===o.value&&(_.dispose(),m())})});const v=this._terminalProcesses.get(s);v?v.startSendingEvents(n):this._extensionTerminalAwaitingStart[s]={initialDimensions:n}}_setupExtHostProcessListeners(s,n){const o=new P.DisposableStore;o.add(n.onProcessReady(m=>this._proxy.$sendProcessReady(s,m.pid,m.cwd))),o.add(n.onProcessTitleChanged(m=>this._proxy.$sendProcessTitle(s,m))),this._bufferer.startBuffering(s,n.onProcessData),o.add(n.onProcessExit(m=>this._onProcessExit(s,m))),n.onProcessOverrideDimensions&&o.add(n.onProcessOverrideDimensions(m=>this._proxy.$sendOverrideDimensions(s,m))),this._terminalProcesses.set(s,n);const v=this._extensionTerminalAwaitingStart[s];return v&&n instanceof w&&(n.startSendingEvents(v.initialDimensions),delete this._extensionTerminalAwaitingStart[s]),o}$acceptProcessAckDataEvent(s,n){var o;(o=this._terminalProcesses.get(s))===null||o===void 0||o.acknowledgeDataEvent(n)}$acceptProcessInput(s,n){var o;(o=this._terminalProcesses.get(s))===null||o===void 0||o.input(n)}$acceptProcessResize(s,n,o){var v;try{(v=this._terminalProcesses.get(s))===null||v===void 0||v.resize(n,o)}catch(m){if(m.code!=="EPIPE"&&m.code!=="ERR_IPC_CHANNEL_CLOSED")throw m}}$acceptProcessShutdown(s,n){var o;(o=this._terminalProcesses.get(s))===null||o===void 0||o.shutdown(n)}$acceptProcessRequestInitialCwd(s){var n;(n=this._terminalProcesses.get(s))===null||n===void 0||n.getInitialCwd().then(o=>this._proxy.$sendProcessInitialCwd(s,o))}$acceptProcessRequestCwd(s){var n;(n=this._terminalProcesses.get(s))===null||n===void 0||n.getCwd().then(o=>this._proxy.$sendProcessCwd(s,o))}$acceptProcessRequestLatency(s){return s}registerLinkProvider(s){return this._linkProviders.add(s),this._linkProviders.size===1&&this._proxy.$startLinkProvider(),new E.Disposable(()=>{this._linkProviders.delete(s),this._linkProviders.size===0&&this._proxy.$stopLinkProvider()})}registerProfileProvider(s,n,o){if(this._profileProviders.has(n))throw new Error(`Terminal profile provider "${n}" already registered`);return this._profileProviders.set(n,o),this._proxy.$registerProfileProvider(n,s.identifier.value),new E.Disposable(()=>{this._profileProviders.delete(n),this._proxy.$unregisterProfileProvider(n)})}async $createContributedProfileTerminal(s,n){var o;const v=new l.CancellationTokenSource().token,m=await((o=this._profileProviders.get(s))===null||o===void 0?void 0:o.provideTerminalProfile(v));if(!v.isCancellationRequested){if(!m||!("options"in m))throw new Error(`No terminal profile options provided for id "${s}"`);if("pty"in m.options){this.createExtensionTerminal(m.options,{isSplitTerminal:n});return}this.createTerminalFromOptions(m.options,{isSplitTerminal:n})}}async $provideLinks(s,n){const o=this._getTerminalById(s);if(!o)return[];this._terminalLinkCache.delete(s);const v=this._terminalLinkCancellationSource.get(s);v&&v.dispose(!0);const m=new l.CancellationTokenSource;this._terminalLinkCancellationSource.set(s,m);const _=[],D={terminal:o.value,line:n},a=[];for(const U of this._linkProviders)a.push(new Promise(async G=>{m.token.onCancellationRequested(()=>G({provider:U,links:[]}));const ee=await U.provideTerminalLinks(D,m.token)||[];m.token.isCancellationRequested||G({provider:U,links:ee})}));const T=await Promise.all(a);if(m.token.isCancellationRequested)return[];const L=new Map;for(const U of T)U&&U.links.length>0&&_.push(...U.links.map(G=>{const ee={id:b++,startIndex:G.startIndex,length:G.length,label:G.tooltip};return L.set(ee.id,{provider:U.provider,link:G}),ee}));return this._terminalLinkCache.set(s,L),_}$activateLink(s,n){var o;const v=(o=this._terminalLinkCache.get(s))===null||o===void 0?void 0:o.get(n);!v||v.provider.handleTerminalLink(v.link)}_onProcessExit(s,n){this._bufferer.stopBuffering(s),this._terminalProcesses.delete(s),delete this._extensionTerminalAwaitingStart[s];const o=this._terminalProcessDisposables[s];o&&(o.dispose(),delete this._terminalProcessDisposables[s]),this._proxy.$sendProcessExit(s,n)}_getTerminalById(s){return this._getTerminalObjectById(this._terminals,s)}_getTerminalObjectById(s,n){const o=this._getTerminalObjectIndexById(s,n);return o!==null?s[o]:null}_getTerminalObjectIndexById(s,n){let o=null;return s.some((v,m)=>v._id===n?(o=m,!0):!1),o}getEnvironmentVariableCollection(s){let n=this._environmentVariableCollections.get(s.identifier.value);return n||(n=new h,this._setEnvironmentVariableCollection(s.identifier.value,n)),n}_syncEnvironmentVariableCollection(s,n){const o=I.serializeEnvironmentVariableCollection(n.map);this._proxy.$setEnvironmentVariableCollection(s,n.persistent,o.length===0?void 0:o)}$initEnvironmentVariableCollections(s){s.forEach(n=>{const o=n[0],v=new h(n[1]);this._setEnvironmentVariableCollection(o,v)})}$acceptDefaultProfile(s,n){this._defaultProfile=s,this._defaultAutomationProfile=n}_setEnvironmentVariableCollection(s,n){this._environmentVariableCollections.set(s,n),n.onDidChangeCollection(()=>{this._syncEnvironmentVariableCollection(s,n)})}};d=Ve([We(1,A.IExtHostRpcService)],d),e.BaseExtHostTerminalService=d;class h{constructor(s){this.map=new Map,this._persistent=!0,this._onDidChangeCollection=new p.Emitter,this.map=new Map(s)}get persistent(){return this._persistent}set persistent(s){this._persistent=s,this._onDidChangeCollection.fire()}get onDidChangeCollection(){return this._onDidChangeCollection&&this._onDidChangeCollection.event}get size(){return this.map.size}replace(s,n){this._setIfDiffers(s,{value:n,type:E.EnvironmentVariableMutatorType.Replace})}append(s,n){this._setIfDiffers(s,{value:n,type:E.EnvironmentVariableMutatorType.Append})}prepend(s,n){this._setIfDiffers(s,{value:n,type:E.EnvironmentVariableMutatorType.Prepend})}_setIfDiffers(s,n){const o=this.map.get(s);(!o||o.value!==n.value||o.type!==n.type)&&(this.map.set(s,n),this._onDidChangeCollection.fire())}get(s){return this.map.get(s)}forEach(s,n){this.map.forEach((o,v)=>s.call(n,v,o,this))}delete(s){this.map.delete(s),this._onDidChangeCollection.fire()}clear(){this.map.clear(),this._onDidChangeCollection.fire()}}e.EnvironmentVariableCollection=h;let g=class extends d{constructor(s){super(!1,s)}createTerminal(s,n,o){throw new r.NotSupportedError}createTerminalFromOptions(s,n){throw new r.NotSupportedError}};g=Ve([We(0,A.IExtHostRpcService)],g),e.WorkerExtHostTerminalService=g;function t(i){if(!!i)return"id"in i?{id:i.id,color:i.color}:i}});var rt=this&&this.__classPrivateFieldSet||function(X,e,p,R,C){if(R==="m")throw new TypeError("Private method is not writable");if(R==="a"&&!C)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?X!==e||!C:!e.has(X))throw new TypeError("Cannot write private member to an object whose class did not declare it");return R==="a"?C.call(X,p):C?C.value=p:e.set(X,p),p},$e=this&&this.__classPrivateFieldGet||function(X,e,p,R){if(p==="a"&&!R)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?X!==e||!R:!e.has(X))throw new TypeError("Cannot read private member from an object whose class did not declare it");return p==="m"?R:p==="a"?R.call(X):R?R.value:e.get(X)};define(me[239],ge([0,1,18,16,22,21,3,69,52,6,25,15,32,5,13,17,7,211,122]),function(X,e,p,R,C,y,A,P,E,k,r,I,l,f,c,u,S,w,b){"use strict";var d,h,g,t,i;Object.defineProperty(e,"__esModule",{value:!0}),e.MirroredTestCollection=e.TestRunDto=e.TestRunCoordinator=e.ExtHostTesting=void 0;let s=class{constructor(L,U){this.resultsChangedEmitter=new A.Emitter,this.controllers=new Map,this.onResultsChanged=this.resultsChangedEmitter.event,this.results=[],this.proxy=L.getProxy(f.MainContext.MainThreadTesting),this.observer=new a(this.proxy),this.runTracker=new o(this.proxy),U.registerArgumentProcessor({processArgument:G=>(G==null?void 0:G.$mid)===13?u.TestItem.toItemFromContext(G):G})}createTestController(L){const U=new k.DisposableStore,G=U.add(new w.SingleUseTestCollection(L)),ee=U.add(new R.RunOnceScheduler(()=>G.expand(G.root.id,0),0)),z={root:G.root,createTestRun:(N,W,M=!0)=>this.runTracker.createTestRun(L,N,W,M),createTestItem(N,W,M,j,O){if(!(M instanceof S.TestItemImpl))throw new Error(`The "parent" passed in for TestItem ${N} is invalid`);return new S.TestItemImpl(N,W,j,O,M)},set resolveChildrenHandler(N){G.resolveHandler=N,N&&ee.schedule()},get resolveChildrenHandler(){return G.resolveHandler},dispose:()=>{U.dispose()}};return this.proxy.$registerTestController(L),U.add(k.toDisposable(()=>this.proxy.$unregisterTestController(L))),this.controllers.set(L,{controller:z,collection:G}),U.add(k.toDisposable(()=>this.controllers.delete(L))),U.add(G.onDidGenerateDiff(N=>this.proxy.$publishDiff(L,N))),z}createTestObserver(){return this.observer.checkout()}async runTests(L,U=y.CancellationToken.None){const G=ee=>ee.map(this.getInternalTestForReference,this).filter(I.isDefined).map(z=>({controllerId:z.controllerId,testId:z.item.extId}));await this.proxy.$runTests({exclude:L.exclude?G(L.exclude).map(ee=>ee.testId):void 0,tests:G(L.tests),debug:L.debug},U)}$publishTestResults(L){this.results=Object.freeze(L.map(U=>r.deepFreeze(u.TestResults.to(U))).concat(this.results).sort((U,G)=>G.completedAt-U.completedAt).slice(0,32)),this.resultsChangedEmitter.fire()}async $expandTest({controllerId:L,testId:U},G){var ee;const z=(ee=this.controllers.get(L))===null||ee===void 0?void 0:ee.collection;z&&(await z.expand(U,G<0?Infinity:G),z.flushDiff())}$acceptDiff(L){this.observer.applyDiff(L)}async $runControllerTests(L,U){var G;const ee=this.controllers.get(L.controllerId);if(!ee)return;const{controller:z,collection:N}=ee,W=L.testIds.map(F=>N.tree.get(F)).filter(I.isDefined),M=L.excludeExtIds.map(F=>ee.collection.tree.get(F)).filter(I.isDefined).filter(F=>W.some(B=>N.tree.comparePositions(B,F)===1));if(!W.length)return;const j={tests:W.map(F=>F.actual),exclude:M.map(F=>F.actual),debug:L.debug},O=this.runTracker.prepareForMainThreadTestRun(j,v.fromInternal(L),U);try{await((G=z.runHandler)===null||G===void 0?void 0:G.call(z,j,U))}finally{O.isRunning&&!U.isCancellationRequested&&await A.Event.toPromise(O.onEnd),this.runTracker.cancelRunById(L.runId)}}$cancelExtensionTestRun(L){L===void 0?this.runTracker.cancelAllRuns():this.runTracker.cancelRunById(L)}getInternalTestForReference(L){var U;return(U=p.mapFind(this.controllers.values(),({collection:G})=>G.getTestByReference(L)))!==null&&U!==void 0?U:this.observer.getMirroredTestDataByReference(L)}};s=Ve([We(0,c.IExtHostRpcService)],s),e.ExtHostTesting=s;class n extends k.Disposable{constructor(L,U,G){super();this.dto=L,this.proxy=U,this.task=new Set,this.sharedTestIds=new Set,this.endEmitter=this._register(new A.Emitter),this.disposed=!1,this.onEnd=this.endEmitter.event,this.cts=this._register(new y.CancellationTokenSource(G)),this._register(this.cts.token.onCancellationRequested(()=>{for(const ee of this.task)ee.end()}))}get isRunning(){return this.task.size>0}get id(){return this.dto.id}createRun(L){const U=new m(L,this.cts.token,this.dto,this.sharedTestIds,this.proxy,()=>{this.task.delete(U),this.isRunning||this.dispose()});return this.task.add(U),U}dispose(){this.disposed||(this.disposed=!0,this.endEmitter.fire(),this.cts.cancel(),super.dispose())}}class o{constructor(L){this.proxy=L,this.tracked=new Map}get trackers(){return this.tracked.values()}prepareForMainThreadTestRun(L,U,G){return this.getTracker(L,U,G)}cancelRunById(L){for(const U of this.tracked.values())if(U.id===L){U.dispose();return}}cancelAllRuns(){for(const L of this.tracked.values())L.dispose()}createTestRun(L,U,G,ee){var z,N;const W=this.tracked.get(U);if(W)return W.createRun(G);const M=v.fromPublic(L,U);this.proxy.$startedExtensionTestRun({debug:U.debug,exclude:(N=(z=U.exclude)===null||z===void 0?void 0:z.map(O=>O.id))!==null&&N!==void 0?N:[],id:M.id,tests:U.tests.map(O=>O.id),persist:ee});const j=this.getTracker(U,M);return j.onEnd(()=>this.proxy.$finishedExtensionTestRun(M.id)),j.createRun(G)}getTracker(L,U,G){const ee=new n(U,this.proxy,G);return this.tracked.set(L,ee),ee.onEnd(()=>this.tracked.delete(L)),ee}}e.TestRunCoordinator=o;class v{constructor(L,U,G,ee){this.controllerId=L,this.id=U,this.include=G,this.exclude=ee}static fromPublic(L,U){var G,ee;return new v(L,l.generateUuid(),new Set(U.tests.map(z=>z.id)),new Set((ee=(G=U.exclude)===null||G===void 0?void 0:G.map(z=>z.id))!==null&&ee!==void 0?ee:E.Iterable.empty()))}static fromInternal(L){return new v(L.controllerId,L.runId,new Set(L.testIds),new Set(L.excludeExtIds))}isIncluded(L){for(let U=L;U;U=U.parent){if(this.include.has(U.id))return!0;if(this.exclude.has(U.id))return!1}return!1}}e.TestRunDto=v;class m{constructor(L,U,G,ee,z,N){this.name=L,this.token=U,d.set(this,void 0),h.set(this,void 0),g.set(this,void 0),t.set(this,void 0),i.set(this,!1),this.taskId=l.generateUuid(),rt(this,t,N,"f"),rt(this,d,z,"f"),rt(this,h,G,"f"),rt(this,g,ee,"f"),z.$startedTestRunTask(G.id,{id:this.taskId,name:L,running:!0})}setState(L,U,G){!$e(this,i,"f")&&$e(this,h,"f").isIncluded(L)&&(this.ensureTestIsKnown(L),$e(this,d,"f").$updateTestStateInRun($e(this,h,"f").id,this.taskId,L.id,U,G))}appendMessage(L,U){!$e(this,i,"f")&&$e(this,h,"f").isIncluded(L)&&(this.ensureTestIsKnown(L),$e(this,d,"f").$appendTestMessageInRun($e(this,h,"f").id,this.taskId,L.id,u.TestMessage.from(U)))}appendOutput(L){$e(this,i,"f")||$e(this,d,"f").$appendOutputToRun($e(this,h,"f").id,this.taskId,C.VSBuffer.fromString(L))}end(){$e(this,i,"f")||(rt(this,i,!0,"f"),$e(this,d,"f").$finishedTestRunTask($e(this,h,"f").id,this.taskId),$e(this,t,"f").call(this))}ensureTestIsKnown(L){const U=$e(this,g,"f");if(U.has(L.id))return;const G=[];for(;G.unshift(u.TestItem.from(L)),!(U.has(L.id)||(U.add(L.id),!L.parent));)L=L.parent;$e(this,d,"f").$addTestsToRun($e(this,h,"f").controllerId,$e(this,h,"f").id,G)}}d=new WeakMap,h=new WeakMap,g=new WeakMap,t=new WeakMap,i=new WeakMap;class _ extends b.IncrementalChangeCollector{constructor(L){super();this.emitter=L,this.added=new Set,this.updated=new Set,this.removed=new Set,this.alreadyRemoved=new Set}get isEmpty(){return this.added.size===0&&this.removed.size===0&&this.updated.size===0}add(L){this.added.add(L)}update(L){Object.assign(L.revived,u.TestItem.toPlain(L.item)),this.added.has(L)||this.updated.add(L)}remove(L){if(this.added.has(L)){this.added.delete(L);return}if(this.updated.delete(L),L.parent&&this.alreadyRemoved.has(L.parent)){this.alreadyRemoved.add(L.item.extId);return}this.removed.add(L)}getChangeEvent(){const{added:L,updated:U,removed:G}=this;return{get added(){return[...L].map(ee=>ee.revived)},get updated(){return[...U].map(ee=>ee.revived)},get removed(){return[...G].map(ee=>ee.revived)}}}complete(){this.isEmpty||this.emitter.fire(this.getChangeEvent())}}class D extends b.AbstractIncrementalTestCollection{constructor(){super(...arguments);this.changeEmitter=new A.Emitter,this.onDidChangeTests=this.changeEmitter.event}get rootTests(){return super.roots}getMirroredTestDataById(L){return this.items.get(L)}getMirroredTestDataByReference(L){return this.items.get(L.id)}createItem(L,U){return Object.assign(Object.assign({},L),{revived:u.TestItem.toPlain(L.item),depth:U?U.depth+1:0,children:new Set})}createChangeCollector(){return new _(this.changeEmitter)}}e.MirroredTestCollection=D;class a{constructor(L){this.proxy=L}checkout(){this.current||(this.current=this.createObserverData());const L=this.current;return L.observers++,{onDidChangeTest:L.tests.onDidChangeTests,get tests(){return[...L.tests.rootTests].map(U=>U.revived)},dispose:P.once(()=>{--L.observers==0&&(this.proxy.$unsubscribeFromDiffs(),this.current=void 0)})}}getMirroredTestDataByReference(L){var U;return(U=this.current)===null||U===void 0?void 0:U.tests.getMirroredTestDataByReference(L)}applyDiff(L){var U;(U=this.current)===null||U===void 0||U.tests.apply(L)}createObserverData(){const L=new D;return this.proxy.$subscribeToDiffs(),{observers:0,tests:L}}}}),define(me[240],ge([0,1,3,18,5,124,17,7]),function(X,e,p,R,C,y,A,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditors=void 0;class E{constructor(r,I){this._extHostDocumentsAndEditors=I,this._onDidChangeTextEditorSelection=new p.Emitter,this._onDidChangeTextEditorOptions=new p.Emitter,this._onDidChangeTextEditorVisibleRanges=new p.Emitter,this._onDidChangeTextEditorViewColumn=new p.Emitter,this._onDidChangeActiveTextEditor=new p.Emitter,this._onDidChangeVisibleTextEditors=new p.Emitter,this.onDidChangeTextEditorSelection=this._onDidChangeTextEditorSelection.event,this.onDidChangeTextEditorOptions=this._onDidChangeTextEditorOptions.event,this.onDidChangeTextEditorVisibleRanges=this._onDidChangeTextEditorVisibleRanges.event,this.onDidChangeTextEditorViewColumn=this._onDidChangeTextEditorViewColumn.event,this.onDidChangeActiveTextEditor=this._onDidChangeActiveTextEditor.event,this.onDidChangeVisibleTextEditors=this._onDidChangeVisibleTextEditors.event,this._proxy=r.getProxy(C.MainContext.MainThreadTextEditors),this._extHostDocumentsAndEditors.onDidChangeVisibleTextEditors(l=>this._onDidChangeVisibleTextEditors.fire(l)),this._extHostDocumentsAndEditors.onDidChangeActiveTextEditor(l=>this._onDidChangeActiveTextEditor.fire(l))}getActiveTextEditor(){return this._extHostDocumentsAndEditors.activeEditor()}getVisibleTextEditors(r){const I=this._extHostDocumentsAndEditors.allEditors();return r?I:I.map(l=>l.value)}async showTextDocument(r,I,l){let f;typeof I=="number"?f={position:A.ViewColumn.from(I),preserveFocus:l}:typeof I=="object"?f={position:A.ViewColumn.from(I.viewColumn),preserveFocus:I.preserveFocus,selection:typeof I.selection=="object"?A.Range.from(I.selection):void 0,pinned:typeof I.preview=="boolean"?!I.preview:void 0}:f={preserveFocus:!1};const c=await this._proxy.$tryShowTextDocument(r.uri,f),u=c&&this._extHostDocumentsAndEditors.getEditor(c);if(u)return u.value;throw c?new Error(`Could NOT open editor for "${r.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${r.uri.toString()}".`)}createTextEditorDecorationType(r,I){return new y.TextEditorDecorationType(this._proxy,r,I).value}$acceptEditorPropertiesChanged(r,I){const l=this._extHostDocumentsAndEditors.getEditor(r);if(!l)throw new Error("unknown text editor");if(I.options&&l._acceptOptions(I.options),I.selections){const f=I.selections.selections.map(A.Selection.to);l._acceptSelections(f)}if(I.visibleRanges){const f=R.coalesce(I.visibleRanges.map(A.Range.to));l._acceptVisibleRanges(f)}if(I.options&&this._onDidChangeTextEditorOptions.fire({textEditor:l.value,options:Object.assign(Object.assign({},I.options),{lineNumbers:A.TextEditorLineNumbersStyle.to(I.options.lineNumbers)})}),I.selections){const f=P.TextEditorSelectionChangeKind.fromValue(I.selections.source),c=I.selections.selections.map(A.Selection.to);this._onDidChangeTextEditorSelection.fire({textEditor:l.value,selections:c,kind:f})}if(I.visibleRanges){const f=R.coalesce(I.visibleRanges.map(A.Range.to));this._onDidChangeTextEditorVisibleRanges.fire({textEditor:l.value,visibleRanges:f})}}$acceptEditorPositionData(r){for(const I in r){const l=this._extHostDocumentsAndEditors.getEditor(I);if(!l)throw new Error("Unknown text editor");const f=A.ViewColumn.to(r[I]);l.value.viewColumn!==f&&(l._acceptViewColumn(f),this._onDidChangeTextEditorViewColumn.fire({textEditor:l.value,viewColumn:f}))}}getDiffInformation(r){return Promise.resolve(this._proxy.$getDiffInformation(r))}}e.ExtHostEditors=E});var $n=this&&this.__rest||function(X,e){var p={};for(var R in X)Object.prototype.hasOwnProperty.call(X,R)&&e.indexOf(R)<0&&(p[R]=X[R]);if(X!=null&&typeof Object.getOwnPropertySymbols=="function")for(var C=0,R=Object.getOwnPropertySymbols(X);C<R.length;C++)e.indexOf(R[C])<0&&Object.prototype.propertyIsEnumerable.call(X,R[C])&&(p[R[C]]=X[R[C]]);return p};define(me[241],ge([0,1,2,4,5,6,7]),function(X,e,p,R,C,y,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTimeline=e.IExtHostTimeline=void 0,e.IExtHostTimeline=R.createDecorator("IExtHostTimeline");class P{constructor(r,I){this._providers=new Map,this._itemsBySourceAndUriMap=new Map,this._proxy=r.getProxy(C.MainContext.MainThreadTimeline),I.registerArgumentProcessor({processArgument:l=>{var f,c;if(l&&l.$mid===11){const u=l.uri===void 0?void 0:p.URI.revive(l.uri);return(c=(f=this._itemsBySourceAndUriMap.get(l.source))===null||f===void 0?void 0:f.get(E(u)))===null||c===void 0?void 0:c.get(l.handle)}return l}})}async $getTimeline(r,I,l,f,c){const u=this._providers.get(r);return u==null?void 0:u.provideTimeline(p.URI.revive(I),l,f,c)}registerTimelineProvider(r,I,l,f){const c=new y.DisposableStore,u=this.convertTimelineItem(I.id,f,c).bind(this);let S;I.onDidChange&&(S=I.onDidChange(b=>this._proxy.$emitTimelineChangeEvent(Object.assign(Object.assign({uri:void 0,reset:!0},b),{id:I.id})),this));const w=this._itemsBySourceAndUriMap;return this.registerTimelineProviderCore(Object.assign(Object.assign({},I),{scheme:r,onDidChange:void 0,async provideTimeline(b,d,h,g){var t;(g==null?void 0:g.resetCache)&&(c.clear(),(t=w.get(I.id))===null||t===void 0||t.clear());const i=await I.provideTimeline(b,d,h);if(i==null)return;const s=u(b,g);return Object.assign(Object.assign({},i),{source:I.id,items:i.items.map(s)})},dispose(){var b;for(const d of w.values())(b=d.get(I.id))===null||b===void 0||b.clear();S==null||S.dispose(),c.dispose()}}))}convertTimelineItem(r,I,l){return(f,c)=>{let u;if(c==null?void 0:c.cacheResults){let S=this._itemsBySourceAndUriMap.get(r);S===void 0&&(S=new Map,this._itemsBySourceAndUriMap.set(r,S));const w=E(f);u=S.get(w),u===void 0&&(u=new Map,S.set(w,u))}return S=>{var w,b;const{iconPath:d}=S,h=$n(S,["iconPath"]),g=`${r}|${(w=S.id)!==null&&w!==void 0?w:S.timestamp}`;u==null||u.set(g,S);let t,i,s;return S.iconPath&&(d instanceof A.ThemeIcon?s={id:d.id}:p.URI.isUri(d)?(t=d,i=d):{light:t,dark:i}=d),Object.assign(Object.assign({},h),{id:(b=h.id)!==null&&b!==void 0?b:void 0,handle:g,source:r,command:S.command?I.toInternal(S.command,l):void 0,icon:t,iconDark:i,themeIcon:s,accessibilityInformation:S.accessibilityInformation})}}}registerTimelineProviderCore(r){if(this._providers.get(r.id))throw new Error(`Timeline Provider ${r.id} already exists.`);return this._proxy.$registerTimelineProvider({id:r.id,label:r.label,scheme:r.scheme}),this._providers.set(r.id,r),y.toDisposable(()=>{var l;for(const f of this._itemsBySourceAndUriMap.values())(l=f.get(r.id))===null||l===void 0||l.clear();this._providers.delete(r.id),this._proxy.$unregisterTimelineProvider(r.id),r.dispose()})}}e.ExtHostTimeline=P;function E(k){return k==null?void 0:k.toString()}}),define(me[242],ge([0,1,6,10,2,5]),function(X,e,p,R,C,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUriOpeners=void 0;class A{constructor(E){this._openers=new Map,this._proxy=E.getProxy(y.MainContext.MainThreadUriOpeners)}registerExternalUriOpener(E,k,r,I){if(this._openers.has(k))throw new Error(`Opener with id '${k}' already registered`);const l=I.schemes.find(f=>!A.supportedSchemes.has(f));if(l)throw new Error(`Scheme '${l}' is not supported. Only http and https are currently supported.`);return this._openers.set(k,r),this._proxy.$registerUriOpener(k,I.schemes,E,I.label),p.toDisposable(()=>{this._openers.delete(k),this._proxy.$unregisterUriOpener(k)})}async $canOpenUri(E,k,r){const I=this._openers.get(E);if(!I)throw new Error(`Unknown opener with id: ${E}`);const l=C.URI.revive(k);return I.canOpenExternalUri(l,r)}async $openUri(E,k,r){const I=this._openers.get(E);if(!I)throw new Error(`Unknown opener id: '${E}'`);return I.openExternalUri(C.URI.revive(k.resolvedUri),{sourceUri:C.URI.revive(k.sourceUri)},r)}}e.ExtHostUriOpeners=A,A.supportedSchemes=new Set([R.Schemas.http,R.Schemas.https])}),define(me[243],ge([0,1,5,2,6,14,26]),function(X,e,p,R,C,y,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUrls=void 0;class P{constructor(k){this.handles=new Set,this.handlers=new Map,this._proxy=k.getProxy(p.MainContext.MainThreadUrls)}registerUriHandler(k,r){if(this.handles.has(A.ExtensionIdentifier.toKey(k)))throw new Error(`Protocol handler already registered for extension ${k}`);const I=P.HandlePool++;return this.handles.add(A.ExtensionIdentifier.toKey(k)),this.handlers.set(I,r),this._proxy.$registerUriHandler(I,k),C.toDisposable(()=>{this.handles.delete(A.ExtensionIdentifier.toKey(k)),this.handlers.delete(I),this._proxy.$unregisterUriHandler(I)})}$handleExternalUri(k,r){const I=this.handlers.get(k);if(!I)return Promise.resolve(void 0);try{I.handleUri(R.URI.revive(r))}catch(l){y.onUnexpectedError(l)}return Promise.resolve(void 0)}async createAppUri(k){return R.URI.revive(await this._proxy.$createAppUri(k))}}e.ExtHostUrls=P,P.HandlePool=0});var rt=this&&this.__classPrivateFieldSet||function(X,e,p,R,C){if(R==="m")throw new TypeError("Private method is not writable");if(R==="a"&&!C)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?X!==e||!C:!e.has(X))throw new TypeError("Cannot write private member to an object whose class did not declare it");return R==="a"?C.call(X,p):C?C.value=p:e.set(X,p),p},$e=this&&this.__classPrivateFieldGet||function(X,e,p,R){if(p==="a"&&!R)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?X!==e||!R:!e.has(X))throw new TypeError("Cannot read private member from an object whose class did not declare it");return p==="m"?R:p==="a"?R.call(X):R?R.value:e.get(X)};define(me[63],ge([0,1,3,2,172,196,83,5]),function(X,e,p,R,C,y,A,P){"use strict";var E,k,r,I,l,f,c,u,S,w,b,d;Object.defineProperty(e,"__esModule",{value:!0}),e.reviveOptions=e.serializeWebviewOptions=e.toExtensionData=e.ExtHostWebviews=e.shouldSerializeBuffersForPostMessage=e.ExtHostWebview=void 0;class h{constructor(m,_,D,a,T,L,U){E.set(this,void 0),k.set(this,void 0),r.set(this,void 0),I.set(this,void 0),l.set(this,void 0),f.set(this,void 0),c.set(this,""),u.set(this,void 0),S.set(this,!1),w.set(this,!1),b.set(this,!1),this._onMessageEmitter=new p.Emitter,this.onDidReceiveMessage=this._onMessageEmitter.event,d.set(this,new p.Emitter),this._onDidDispose=$e(this,d,"f").event,rt(this,E,m,"f"),rt(this,k,_,"f"),rt(this,u,D,"f"),rt(this,I,a,"f"),rt(this,l,T,"f"),rt(this,f,L,"f"),rt(this,b,g(L),"f"),rt(this,r,U,"f")}dispose(){rt(this,S,!0,"f"),$e(this,d,"f").fire(),$e(this,d,"f").dispose(),this._onMessageEmitter.dispose()}asWebviewUri(m){return rt(this,w,!0,"f"),A.asWebviewUri(m,$e(this,I,"f").remote)}get cspSource(){return A.webviewGenericCspSource}get html(){return this.assertNotDisposed(),$e(this,c,"f")}set html(m){this.assertNotDisposed(),$e(this,c,"f")!==m&&(rt(this,c,m,"f"),!$e(this,w,"f")&&/(["'])vscode-resource:([^\s'"]+?)(["'])/i.test(m)&&(rt(this,w,!0,"f"),$e(this,r,"f").report("Webview vscode-resource: uris",$e(this,f,"f"),"Please migrate to use the 'webview.asWebviewUri' api instead: https://aka.ms/vscode-webview-use-aswebviewuri")),$e(this,k,"f").$setHtml($e(this,E,"f"),m))}get options(){return this.assertNotDisposed(),$e(this,u,"f")}set options(m){this.assertNotDisposed(),$e(this,k,"f").$setOptions($e(this,E,"f"),s($e(this,f,"f"),$e(this,l,"f"),m)),rt(this,u,m,"f")}async postMessage(m){if($e(this,S,"f"))return!1;const _=y.serializeWebviewMessage(m,{serializeBuffersForPostMessage:$e(this,b,"f")});return $e(this,k,"f").$postMessage($e(this,E,"f"),_.message,..._.buffers)}assertNotDisposed(){if($e(this,S,"f"))throw new Error("Webview is disposed")}}e.ExtHostWebview=h,E=new WeakMap,k=new WeakMap,r=new WeakMap,I=new WeakMap,l=new WeakMap,f=new WeakMap,c=new WeakMap,u=new WeakMap,S=new WeakMap,w=new WeakMap,b=new WeakMap,d=new WeakMap;function g(v){try{const m=C.normalizeVersion(C.parseVersion(v.engines.vscode));return!!m&&m.majorBase>=1&&m.minorBase>=57}catch(m){return!1}}e.shouldSerializeBuffersForPostMessage=g;class t{constructor(m,_,D,a,T){this.initData=_,this.workspace=D,this._logService=a,this._deprecationService=T,this._webviews=new Map,this._webviewProxy=m.getProxy(P.MainContext.MainThreadWebviews)}$onMessage(m,_,...D){const a=this.getWebview(m);if(a){const{message:T}=y.deserializeWebviewMessage(_,D);a._onMessageEmitter.fire(T)}}$onMissingCsp(m,_){this._logService.warn(`${_} created a webview without a content security policy: https://aka.ms/vscode-webview-missing-csp`)}createNewWebview(m,_,D){const a=new h(m,this._webviewProxy,n(_),this.initData,this.workspace,D,this._deprecationService);return this._webviews.set(m,a),a._onDidDispose(()=>{this._webviews.delete(m)}),a}deleteWebview(m){this._webviews.delete(m)}getWebview(m){return this._webviews.get(m)}}e.ExtHostWebviews=t;function i(v){return{id:v.identifier,location:v.extensionLocation}}e.toExtensionData=i;function s(v,m,_){return{enableCommandUris:_.enableCommandUris,enableScripts:_.enableScripts,portMapping:_.portMapping,localResourceRoots:_.localResourceRoots||o(v,m)}}e.serializeWebviewOptions=s;function n(v){var m;return{enableCommandUris:v.enableCommandUris,enableScripts:v.enableScripts,portMapping:v.portMapping,localResourceRoots:(m=v.localResourceRoots)===null||m===void 0?void 0:m.map(_=>R.URI.from(_))}}e.reviveOptions=n;function o(v,m){return[...((m==null?void 0:m.getWorkspaceFolders())||[]).map(_=>_.uri),v.extensionLocation]}}),define(me[244],ge([0,1,21,73,6,10,24,2,17,63,82,5,7]),function(X,e,p,R,C,y,A,P,E,k,r,I,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostCustomEditors=void 0;class f{constructor(t,i){this.document=t,this._storagePath=i,this._backupCounter=1,this._edits=new r.Cache("custom documents")}addEdit(t){return this._edits.add([t])}async undo(t,i){await this.getEdit(t).undo(),i||this.disposeBackup()}async redo(t,i){await this.getEdit(t).redo(),i||this.disposeBackup()}disposeEdits(t){for(const i of t)this._edits.delete(i)}getNewBackupUri(){if(!this._storagePath)throw new Error("Backup requires a valid storage path");const t=h(this.document.uri)+this._backupCounter++;return A.joinPath(this._storagePath,t)}updateBackup(t){var i;(i=this._backup)===null||i===void 0||i.delete(),this._backup=t}disposeBackup(){var t;(t=this._backup)===null||t===void 0||t.delete(),this._backup=void 0}getEdit(t){const i=this._edits.get(t,0);if(!i)throw new Error("No edit found");return i}}class c{constructor(){this._documents=new Map}get(t,i){return this._documents.get(this.key(t,i))}add(t,i,s){const n=this.key(t,i.uri);if(this._documents.has(n))throw new Error(`Document already exists for viewType:${t} resource:${i.uri}`);const o=new f(i,s);return this._documents.set(n,o),o}delete(t,i){const s=this.key(t,i.uri);this._documents.delete(s)}key(t,i){return`${t}@@@${i}`}}var u;(function(g){g[g.Text=0]="Text",g[g.Custom=1]="Custom"})(u||(u={}));class S{constructor(){this._providers=new Map}addTextProvider(t,i,s){return this.add(0,t,i,s)}addCustomProvider(t,i,s){return this.add(1,t,i,s)}get(t){return this._providers.get(t)}add(t,i,s,n){if(this._providers.has(i))throw new Error(`Provider for viewType:${i} already registered`);return this._providers.set(i,{type:t,extension:s,provider:n}),new l.Disposable(()=>this._providers.delete(i))}}class w{constructor(t,i,s,n,o){this._extHostDocuments=i,this._extensionStoragePaths=s,this._extHostWebview=n,this._extHostWebviewPanels=o,this._editorProviders=new S,this._documents=new c,this._proxy=t.getProxy(I.MainContext.MainThreadCustomEditors)}registerCustomEditorProvider(t,i,s,n){const o=new C.DisposableStore;return b(s)?(o.add(this._editorProviders.addTextProvider(i,t,s)),this._proxy.$registerTextEditorProvider(k.toExtensionData(t),i,n.webviewOptions||{},{supportsMove:!!s.moveCustomTextEditor},k.shouldSerializeBuffersForPostMessage(t))):(o.add(this._editorProviders.addCustomProvider(i,t,s)),this.supportEditing(s)&&o.add(s.onDidChangeCustomDocument(v=>{const m=this.getCustomDocumentEntry(i,v.document.uri);if(d(v)){const _=m.addEdit(v);this._proxy.$onDidEdit(v.document.uri,i,_,v.label)}else this._proxy.$onContentChange(v.document.uri,i)})),this._proxy.$registerCustomEditorProvider(k.toExtensionData(t),i,n.webviewOptions||{},!!n.supportsMultipleEditorsPerDocument,k.shouldSerializeBuffersForPostMessage(t))),l.Disposable.from(o,new l.Disposable(()=>{this._proxy.$unregisterEditorProvider(i)}))}async $createCustomDocument(t,i,s,n,o){var v;const m=this._editorProviders.get(i);if(!m)throw new Error(`No provider found for '${i}'`);if(m.type!==1)throw new Error(`Invalid provide type for '${i}'`);const _=P.URI.revive(t),D=await m.provider.openCustomDocument(_,{backupId:s,untitledDocumentData:n==null?void 0:n.buffer},o);let a;return this.supportEditing(m.provider)&&this._extensionStoragePaths&&(a=(v=this._extensionStoragePaths.workspaceValue(m.extension))!==null&&v!==void 0?v:this._extensionStoragePaths.globalValue(m.extension)),this._documents.add(i,D,a),{editable:this.supportEditing(m.provider)}}async $disposeCustomDocument(t,i){const s=this._editorProviders.get(i);if(!s)throw new Error(`No provider found for '${i}'`);if(s.type!==1)throw new Error(`Invalid provider type for '${i}'`);const n=P.URI.revive(t),{document:o}=this.getCustomDocumentEntry(i,n);this._documents.delete(i,o),o.dispose()}async $resolveWebviewEditor(t,i,s,n,o,v){const m=this._editorProviders.get(s);if(!m)throw new Error(`No provider found for '${s}'`);const _=E.ViewColumn.to(o),D=this._extHostWebview.createNewWebview(i,n.webviewOptions,m.extension),a=this._extHostWebviewPanels.createNewWebviewPanel(i,s,n.title,_,n.panelOptions,D),T=P.URI.revive(t);switch(m.type){case 1:{const{document:L}=this.getCustomDocumentEntry(s,T);return m.provider.resolveCustomEditor(L,a,v)}case 0:{const L=this._extHostDocuments.getDocument(T);return m.provider.resolveCustomTextEditor(L,a,v)}default:throw new Error("Unknown webview provider type")}}$disposeEdits(t,i,s){this.getCustomDocumentEntry(i,t).disposeEdits(s)}async $onMoveCustomEditor(t,i,s){const n=this._editorProviders.get(s);if(!n)throw new Error(`No provider found for '${s}'`);if(!n.provider.moveCustomTextEditor)throw new Error(`Provider does not implement move '${s}'`);const o=this._extHostWebviewPanels.getWebviewPanel(t);if(!o)throw new Error("No webview found");const v=P.URI.revive(i),m=this._extHostDocuments.getDocument(v);await n.provider.moveCustomTextEditor(m,o,p.CancellationToken.None)}async $undo(t,i,s,n){return this.getCustomDocumentEntry(i,t).undo(s,n)}async $redo(t,i,s,n){return this.getCustomDocumentEntry(i,t).redo(s,n)}async $revert(t,i,s){const n=this.getCustomDocumentEntry(i,t);await this.getCustomEditorProvider(i).revertCustomDocument(n.document,s),n.disposeBackup()}async $onSave(t,i,s){const n=this.getCustomDocumentEntry(i,t);await this.getCustomEditorProvider(i).saveCustomDocument(n.document,s),n.disposeBackup()}async $onSaveAs(t,i,s,n){const o=this.getCustomDocumentEntry(i,t);return this.getCustomEditorProvider(i).saveCustomDocumentAs(o.document,P.URI.revive(s),n)}async $backup(t,i,s){const n=this.getCustomDocumentEntry(i,t),v=await this.getCustomEditorProvider(i).backupCustomDocument(n.document,{destination:n.getNewBackupUri()},s);return n.updateBackup(v),v.id}getCustomDocumentEntry(t,i){const s=this._documents.get(t,P.URI.revive(i));if(!s)throw new Error("No custom document found");return s}getCustomEditorProvider(t){const i=this._editorProviders.get(t),s=i==null?void 0:i.provider;if(!s||!this.supportEditing(s))throw new Error("Custom document is not editable");return s}supportEditing(t){return!!t.onDidChangeCustomDocument}}e.ExtHostCustomEditors=w;function b(g){return typeof g.resolveCustomTextEditor=="function"}function d(g){return typeof g.undo=="function"&&typeof g.redo=="function"}function h(g){const t=g.scheme===y.Schemas.file||g.scheme===y.Schemas.untitled?g.fsPath:g.toString();return R.hash(t)+""}});var rt=this&&this.__classPrivateFieldSet||function(X,e,p,R,C){if(R==="m")throw new TypeError("Private method is not writable");if(R==="a"&&!C)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?X!==e||!C:!e.has(X))throw new TypeError("Cannot write private member to an object whose class did not declare it");return R==="a"?C.call(X,p):C?C.value=p:e.set(X,p),p},$e=this&&this.__classPrivateFieldGet||function(X,e,p,R){if(p==="a"&&!R)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?X!==e||!R:!e.has(X))throw new TypeError("Cannot read private member from an object whose class did not declare it");return p==="m"?R:p==="a"?R.call(X):R?R.value:e.get(X)};define(me[245],ge([0,1,3,6,2,32,17,63,5,7]),function(X,e,p,R,C,y,A,P,E,k){"use strict";var r,I,l,f,c,u,S,w,b,d,h,g,t;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewPanels=void 0;class i extends R.Disposable{constructor(v,m,_,D,a,T,L){super();r.set(this,void 0),I.set(this,void 0),l.set(this,void 0),f.set(this,void 0),c.set(this,void 0),u.set(this,void 0),S.set(this,void 0),w.set(this,void 0),b.set(this,!0),d.set(this,!0),h.set(this,!1),g.set(this,this._register(new p.Emitter)),this.onDidDispose=$e(this,g,"f").event,t.set(this,this._register(new p.Emitter)),this.onDidChangeViewState=$e(this,t,"f").event,rt(this,r,v,"f"),rt(this,I,m,"f"),rt(this,l,_,"f"),rt(this,c,T,"f"),rt(this,w,a,"f"),rt(this,u,D,"f"),rt(this,f,L,"f")}dispose(){$e(this,h,"f")||(rt(this,h,!0,"f"),$e(this,g,"f").fire(),$e(this,I,"f").$disposeWebview($e(this,r,"f")),$e(this,f,"f").dispose(),super.dispose())}get webview(){return this.assertNotDisposed(),$e(this,f,"f")}get viewType(){return this.assertNotDisposed(),$e(this,l,"f")}get title(){return this.assertNotDisposed(),$e(this,u,"f")}set title(v){this.assertNotDisposed(),$e(this,u,"f")!==v&&(rt(this,u,v,"f"),$e(this,I,"f").$setTitle($e(this,r,"f"),v))}get iconPath(){return this.assertNotDisposed(),$e(this,S,"f")}set iconPath(v){this.assertNotDisposed(),$e(this,S,"f")!==v&&(rt(this,S,v,"f"),$e(this,I,"f").$setIconPath($e(this,r,"f"),C.URI.isUri(v)?{light:v,dark:v}:v))}get options(){return $e(this,c,"f")}get viewColumn(){if(this.assertNotDisposed(),!(typeof $e(this,w,"f")=="number"&&$e(this,w,"f")<0))return $e(this,w,"f")}get active(){return this.assertNotDisposed(),$e(this,d,"f")}get visible(){return this.assertNotDisposed(),$e(this,b,"f")}_updateViewState(v){$e(this,h,"f")||(this.active!==v.active||this.visible!==v.visible||this.viewColumn!==v.viewColumn)&&(rt(this,d,v.active,"f"),rt(this,b,v.visible,"f"),rt(this,w,v.viewColumn,"f"),$e(this,t,"f").fire({webviewPanel:this}))}reveal(v,m){this.assertNotDisposed(),$e(this,I,"f").$reveal($e(this,r,"f"),{viewColumn:v?A.ViewColumn.from(v):void 0,preserveFocus:!!m})}assertNotDisposed(){if($e(this,h,"f"))throw new Error("Webview is disposed")}}r=new WeakMap,I=new WeakMap,l=new WeakMap,f=new WeakMap,c=new WeakMap,u=new WeakMap,S=new WeakMap,w=new WeakMap,b=new WeakMap,d=new WeakMap,h=new WeakMap,g=new WeakMap,t=new WeakMap;class s{constructor(v,m,_){this.webviews=m,this.workspace=_,this._webviewPanels=new Map,this._serializers=new Map,this._proxy=v.getProxy(E.MainContext.MainThreadWebviewPanels)}static newHandle(){return y.generateUuid()}createWebviewPanel(v,m,_,D,a={}){const T=typeof D=="object"?D.viewColumn:D,L={viewColumn:A.ViewColumn.from(T),preserveFocus:typeof D=="object"&&!!D.preserveFocus},U=P.shouldSerializeBuffersForPostMessage(v),G=s.newHandle();this._proxy.$createWebviewPanel(P.toExtensionData(v),G,m,{title:_,panelOptions:n(a),webviewOptions:P.serializeWebviewOptions(v,this.workspace,a),serializeBuffersForPostMessage:U},L);const ee=this.webviews.createNewWebview(G,a,v);return this.createNewWebviewPanel(G,m,_,T,a,ee)}$onDidChangeWebviewPanelViewStates(v){const m=Object.keys(v);m.sort((_,D)=>{const a=v[_],T=v[D];return a.active?1:T.active?-1:+a.visible-+T.visible});for(const _ of m){const D=this.getWebviewPanel(_);if(!D)continue;const a=v[_];D._updateViewState({active:a.active,visible:a.visible,viewColumn:A.ViewColumn.to(a.position)})}}async $onDidDisposeWebviewPanel(v){const m=this.getWebviewPanel(v);m==null||m.dispose(),this._webviewPanels.delete(v),this.webviews.deleteWebview(v)}registerWebviewPanelSerializer(v,m,_){if(this._serializers.has(m))throw new Error(`Serializer for '${m}' already registered`);return this._serializers.set(m,{serializer:_,extension:v}),this._proxy.$registerSerializer(m,{serializeBuffersForPostMessage:P.shouldSerializeBuffersForPostMessage(v)}),new k.Disposable(()=>{this._serializers.delete(m),this._proxy.$unregisterSerializer(m)})}async $deserializeWebviewPanel(v,m,_,D){const a=this._serializers.get(m);if(!a)throw new Error(`No serializer found for '${m}'`);const{serializer:T,extension:L}=a,U=this.webviews.createNewWebview(v,_.webviewOptions,L),G=this.createNewWebviewPanel(v,m,_.title,D,_.panelOptions,U);await T.deserializeWebviewPanel(G,_.state)}createNewWebviewPanel(v,m,_,D,a,T){const L=new i(v,this._proxy,m,_,D,a,T);return this._webviewPanels.set(v,L),L}getWebviewPanel(v){return this._webviewPanels.get(v)}}e.ExtHostWebviewPanels=s;function n(o){return{enableFindWidget:o.enableFindWidget,retainContextWhenHidden:o.retainContextWhenHidden}}});var rt=this&&this.__classPrivateFieldSet||function(X,e,p,R,C){if(R==="m")throw new TypeError("Private method is not writable");if(R==="a"&&!C)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?X!==e||!C:!e.has(X))throw new TypeError("Cannot write private member to an object whose class did not declare it");return R==="a"?C.call(X,p):C?C.value=p:e.set(X,p),p},$e=this&&this.__classPrivateFieldGet||function(X,e,p,R){if(p==="a"&&!R)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?X!==e||!R:!e.has(X))throw new TypeError("Cannot read private member from an object whose class did not declare it");return p==="m"?R:p==="a"?R.call(X):R?R.value:e.get(X)};define(me[246],ge([0,1,3,6,63,5,7]),function(X,e,p,R,C,y,A){"use strict";var P,E,k,r,I,l,f,c,u,S;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewViews=void 0;class w extends R.Disposable{constructor(h,g,t,i,s,n){super();P.set(this,void 0),E.set(this,void 0),k.set(this,void 0),r.set(this,void 0),I.set(this,!1),l.set(this,void 0),f.set(this,void 0),c.set(this,void 0),u.set(this,this._register(new p.Emitter)),this.onDidChangeVisibility=$e(this,u,"f").event,S.set(this,this._register(new p.Emitter)),this.onDidDispose=$e(this,S,"f").event,rt(this,k,t,"f"),rt(this,f,i,"f"),rt(this,P,h,"f"),rt(this,E,g,"f"),rt(this,r,s,"f"),rt(this,l,n,"f")}dispose(){$e(this,I,"f")||(rt(this,I,!0,"f"),$e(this,S,"f").fire(),$e(this,r,"f").dispose(),super.dispose())}get title(){return this.assertNotDisposed(),$e(this,f,"f")}set title(h){this.assertNotDisposed(),$e(this,f,"f")!==h&&(rt(this,f,h,"f"),$e(this,E,"f").$setWebviewViewTitle($e(this,P,"f"),h))}get description(){return this.assertNotDisposed(),$e(this,c,"f")}set description(h){this.assertNotDisposed(),$e(this,c,"f")!==h&&(rt(this,c,h,"f"),$e(this,E,"f").$setWebviewViewDescription($e(this,P,"f"),h))}get visible(){return $e(this,l,"f")}get webview(){return $e(this,r,"f")}get viewType(){return $e(this,k,"f")}_setVisible(h){h===$e(this,l,"f")||$e(this,I,"f")||(rt(this,l,h,"f"),$e(this,u,"f").fire())}show(h){this.assertNotDisposed(),$e(this,E,"f").$show($e(this,P,"f"),!!h)}assertNotDisposed(){if($e(this,I,"f"))throw new Error("Webview is disposed")}}P=new WeakMap,E=new WeakMap,k=new WeakMap,r=new WeakMap,I=new WeakMap,l=new WeakMap,f=new WeakMap,c=new WeakMap,u=new WeakMap,S=new WeakMap;class b{constructor(h,g){this._extHostWebview=g,this._viewProviders=new Map,this._webviewViews=new Map,this._proxy=h.getProxy(y.MainContext.MainThreadWebviewViews)}registerWebviewViewProvider(h,g,t,i){if(this._viewProviders.has(g))throw new Error(`View provider for '${g}' already registered`);return this._viewProviders.set(g,{provider:t,extension:h}),this._proxy.$registerWebviewViewProvider(C.toExtensionData(h),g,{retainContextWhenHidden:i==null?void 0:i.retainContextWhenHidden,serializeBuffersForPostMessage:!1}),new A.Disposable(()=>{this._viewProviders.delete(g),this._proxy.$unregisterWebviewViewProvider(g)})}async $resolveWebviewView(h,g,t,i,s){const n=this._viewProviders.get(g);if(!n)throw new Error(`No view provider found for '${g}'`);const{provider:o,extension:v}=n,m=this._extHostWebview.createNewWebview(h,{},v),_=new w(h,this._proxy,g,t,m,!0);this._webviewViews.set(h,_),await o.resolveWebviewView(_,{state:i},s)}async $onDidChangeWebviewViewVisibility(h,g){this.getWebviewView(h)._setVisible(g)}async $disposeWebviewView(h){const g=this.getWebviewView(h);this._webviewViews.delete(h),g.dispose(),this._extHostWebview.deleteWebview(h)}getWebviewView(h){const g=this._webviewViews.get(h);if(!g)throw new Error("No webview found");return g}}e.ExtHostWebviewViews=b}),define(me[127],ge([0,1,3,5,2,10,8,4,13]),function(X,e,p,R,C,y,A,P,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWindow=e.ExtHostWindow=void 0;let k=class Un{constructor(I){this._onDidChangeWindowState=new p.Emitter,this.onDidChangeWindowState=this._onDidChangeWindowState.event,this._state=Un.InitialState,this._proxy=I.getProxy(R.MainContext.MainThreadWindow),this._proxy.$getWindowVisibility().then(l=>this.$onDidChangeWindowFocus(l))}get state(){return this._state}$onDidChangeWindowFocus(I){I!==this._state.focused&&(this._state=Object.assign(Object.assign({},this._state),{focused:I}),this._onDidChangeWindowState.fire(this._state))}openUri(I,l){let f;if(typeof I=="string"){f=I;try{I=C.URI.parse(I)}catch(c){return Promise.reject(`Invalid uri - '${I}'`)}}return A.isFalsyOrWhitespace(I.scheme)?Promise.reject("Invalid scheme - cannot be empty"):I.scheme===y.Schemas.command?Promise.reject(`Invalid scheme '${I.scheme}'`):this._proxy.$openUri(I,f,l)}async asExternalUri(I,l){if(A.isFalsyOrWhitespace(I.scheme))return Promise.reject("Invalid scheme - cannot be empty");const f=await this._proxy.$asExternalUri(I,l);return C.URI.from(f)}};k.InitialState={focused:!0},k=Ve([We(0,E.IExtHostRpcService)],k),e.ExtHostWindow=k,e.IExtHostWindow=P.createDecorator("IExtHostWindow")}),define(me[247],ge([0,1,9,100,32,48,6,5,2,13]),function(X,e,p,R,C,y,A,P,E,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDownloadService=void 0;let r=class extends A.Disposable{constructor(l,f){super();const c=l.getProxy(P.MainContext.MainThreadDownloadService);f.registerCommand(!1,"_workbench.downloadResource",async u=>{const S=E.URI.file(p.join(R.tmpdir(),C.generateUuid()));return await c.$download(u,S),S})}};r=Ve([We(0,k.IExtHostRpcService),We(1,y.IExtHostCommands)],r),e.ExtHostDownloadService=r}),define(me[248],ge([0,1,2,9,146,28,62,27,13,6,12,112,41]),function(X,e,p,R,C,y,A,P,E,k,r,I,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostOutputService2=void 0;class f{constructor(w,b,d){this.name=w,this.file=b,this.appender=d}static async create(w,b){const d=await I.createRotatingLogger(w,b,30*l.ByteSize.MB,1);return d.clearFormatters(),new f(w,b,d)}append(w){this.appender.critical(w)}flush(){this.appender.flush()}}class c extends A.AbstractExtHostOutputChannel{constructor(w,b,d){super(w,!1,p.URI.file(b.file),d);this._appender=b}append(w){super.append(w),this._appender.append(w),this._onDidAppend.fire()}update(){this._appender.flush(),super.update()}show(w,b){this._appender.flush(),super.show(w,b)}clear(){this._appender.flush(),super.clear()}}let u=class extends A.ExtHostOutputService{constructor(w,b,d){super(w);this.logService=b,this._namePool=1,this._channels=new Map,this._visibleChannelDisposable=new k.MutableDisposable,this._logsLocation=d.logsLocation}$setVisibleChannel(w){if(w){const b=this._channels.get(w);b&&(this._visibleChannelDisposable.value=b.onDidAppend(()=>b.update()))}}createOutputChannel(w){if(w=w.trim(),!w)throw new Error("illegal argument `name`. must not be falsy");const b=this._doCreateOutChannel(w);return b.then(d=>d._id.then(h=>this._channels.set(h,d))),new A.LazyOutputChannel(w,b)}async _doCreateOutChannel(w){try{const b=R.join(this._logsLocation.fsPath,`output_logging_${C.toLocalISOString(new Date).replace(/-|:|\.\d+Z$/g,"")}`);await y.SymlinkSupport.existsDirectory(b)||await y.Promises.mkdir(b,{recursive:!0});const h=`${this._namePool++}-${w.replace(/[\\/:\*\?"<>\|]/g,"")}`,g=p.URI.file(R.join(b,`${h}.log`)),t=await f.create(h,g.fsPath);return new c(w,t,this._proxy)}catch(b){return this.logService.error(b),new A.ExtHostPushOutputChannel(w,this._proxy)}}};u=Ve([We(0,E.IExtHostRpcService),We(1,r.ILogService),We(2,P.IExtHostInitDataService)],u),e.ExtHostOutputService2=u}),define(me[249],ge([0,1,32,13,33]),function(X,e,p,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTerminalService=void 0;let y=class extends C.BaseExtHostTerminalService{constructor(P){super(!0,P)}createTerminal(P,E,k){return this.createTerminalFromOptions({name:P,shellPath:E,shellArgs:k})}createTerminalFromOptions(P,E){const k=new C.ExtHostTerminal(this._proxy,p.generateUuid(),P,P.name);return this._terminals.push(k),k.create(P,E),k.value}};y=Ve([We(0,R.IExtHostRpcService)],y),e.ExtHostTerminalService=y}),define(me[250],ge([0,1,5,13,6,27,2,38,24,28,7,11,47,3,187,72,12]),function(X,e,p,R,C,y,A,P,E,k,r,I,l,f,c,u,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTunnelService=e.tryFindRootPorts=e.findPorts=e.getRootProcesses=e.loadConnectionTable=e.parseIpAddress=e.loadListeningPorts=e.getSockets=void 0;class w{constructor(m,_,D){this.remoteAddress=m,this.localAddress=_,this._dispose=D,this._onDispose=new f.Emitter,this.onDidDispose=this._onDispose.event}dispose(){return this._onDispose.fire(),this._dispose()}}function b(v){const m=v.trim().split(`
`),_=[];return m.forEach(a=>{const T=/\/proc\/(\d+)\/fd\/\d+ -> socket:\[(\d+)\]/.exec(a);T&&T.length>=3&&_.push({pid:parseInt(T[1],10),socket:parseInt(T[2],10)})}),_.reduce((a,T)=>(a[T.socket]=T,a),{})}e.getSockets=b;function d(...v){const m=[].concat(...v.map(g));return[...new Map(m.filter(_=>_.st==="0A").map(_=>{const D=_.local_address.split(":");return{socket:parseInt(_.inode,10),ip:h(D[0]),port:parseInt(D[1],16)}}).map(_=>[_.ip+":"+_.port,_])).values()]}e.loadListeningPorts=d;function h(v){let m="";if(v.length===8)for(let _=v.length-2;_>=0;_-=2)m+=parseInt(v.substr(_,2),16),_!==0&&(m+=".");else for(let _=v.length-4;_>=0;_-=4)m+=parseInt(v.substr(_,4),16).toString(16),_!==0&&(m+=":");return m}e.parseIpAddress=h;function g(v){const m=v.trim().split(`
`),_=m.shift().trim().split(/\s+/).filter(a=>a!=="rx_queue"&&a!=="tm->when");return m.map(a=>a.trim().split(/\s+/).reduce((T,L,U)=>(T[_[U]||U]=L,T),{}))}e.loadConnectionTable=g;function t(v){return!!v.match(/.*\.vscode-server-[a-zA-Z]+\/bin.*/)||v.indexOf("out/vs/server/main.js")!==-1||v.indexOf("_productName=VSCode")!==-1}function i(v){const m=v.trim().split(`
`),_=[];return m.forEach(D=>{const a=/^\d+\s+\D+\s+root\s+(\d+)\s+(\d+).+\d+\:\d+\:\d+\s+(.+)$/.exec(D);a&&a.length>=4&&_.push({pid:parseInt(a[1],10),ppid:parseInt(a[2]),cmd:a[3]})}),_}e.getRootProcesses=i;async function s(v,m,_){const D=_.reduce((T,L)=>(T[L.pid]=L,T),{}),a=[];return v.forEach(({socket:T,ip:L,port:U})=>{var G;const ee=m[T]?m[T].pid:void 0,z=ee?(G=D[ee])===null||G===void 0?void 0:G.cmd:void 0;ee&&z&&!t(z)&&a.push({host:L,port:U,detail:z,pid:ee})}),a}e.findPorts=s;function n(v,m,_){const D=new Map,a=i(m);for(const T of v){const L=_.get(T.port);if(L){D.set(T.port,L);continue}const U=a.find(G=>G.cmd.includes(`${T.port}`));if(U){let G=U,ee;do ee=a.find(z=>z.ppid===G.pid),ee&&(G=ee);while(ee);D.set(T.port,{host:T.ip,port:T.port,pid:G.pid,detail:G.cmd,ppid:G.ppid})}else D.set(T.port,{host:T.ip,port:T.port,ppid:Number.MAX_VALUE})}return D}e.tryFindRootPorts=n;let o=class extends C.Disposable{constructor(m,_,D){super();this.logService=D,this._showCandidatePort=()=>Promise.resolve(!0),this._extensionTunnels=new Map,this._onDidChangeTunnels=new f.Emitter,this.onDidChangeTunnels=this._onDidChangeTunnels.event,this._candidateFindingEnabled=!1,this._foundRootPorts=new Map,this._providerHandleCounter=0,this._portAttributesProviders=new Map,this._proxy=m.getProxy(p.MainContext.MainThreadTunnelService),I.isLinux&&_.remote.isRemote&&_.remote.authority&&this._proxy.$setRemoteTunnelService(process.pid)}async openTunnel(m,_){this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) ${m.identifier.value} called openTunnel API for ${_.remoteAddress.host}:${_.remoteAddress.port}.`);const D=await this._proxy.$openTunnel(_,m.displayName);if(D){const a=new w(D.remoteAddress,D.localAddress,()=>this._proxy.$closeTunnel(D.remoteAddress));return this._register(a),a}}async getTunnels(){return this._proxy.$getTunnels()}calculateDelay(m){return Math.max(m*20,2e3)}nextPortAttributesProviderHandle(){return this._providerHandleCounter++}registerPortsAttributesProvider(m,_){const D=this.nextPortAttributesProviderHandle();return this._portAttributesProviders.set(D,{selector:m,provider:_}),this._proxy.$registerPortsAttributesProvider(m,D),new r.Disposable(()=>{this._portAttributesProviders.delete(D),this._proxy.$unregisterPortsAttributesProvider(D)})}async $providePortAttributes(m,_,D,a,T){const L=[];for(const G of m){const ee=this._portAttributesProviders.get(G);if(!ee)return[];L.push(...await Promise.all(_.map(async z=>ee.provider.providePortAttributes(z,D,a,T))))}const U=L.filter(G=>!!G);return U.length>0?U.map(G=>({autoForwardAction:G.autoForwardAction,port:G.port})):[]}async $registerCandidateFinder(m){if(m&&this._candidateFindingEnabled)return;this._candidateFindingEnabled=m;let _=new u.MovingAverage,D;for(;this._candidateFindingEnabled;){const a=new Date().getTime(),T=(await this.findCandidatePorts()).filter(U=>c.isLocalhost(U.host)||c.isAllInterfaces(U.host));this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) found candidate ports ${T.map(U=>U.port).join(", ")}`);const L=new Date().getTime()-a;_.update(L),(!D||JSON.stringify(D)!==JSON.stringify(T))&&(D=T,await this._proxy.$onFoundNewCandidates(D)),await new Promise(U=>setTimeout(()=>U(),this.calculateDelay(_.value)))}}async setTunnelExtensionFunctions(m){var _;return m?(m.candidatePortSource!==void 0&&this._proxy.$setCandidatePortSource(m.candidatePortSource),m.showCandidatePort&&(this._showCandidatePort=m.showCandidatePort,this._proxy.$setCandidateFilter()),m.tunnelFactory&&(this._forwardPortProvider=m.tunnelFactory,this._proxy.$setTunnelProvider((_=m.tunnelFeatures)!==null&&_!==void 0?_:{elevation:!1,public:!1}))):this._forwardPortProvider=void 0,C.toDisposable(()=>{this._forwardPortProvider=void 0})}async $closeTunnel(m,_){if(this._extensionTunnels.has(m.host)){const D=this._extensionTunnels.get(m.host);D.has(m.port)&&(_&&D.get(m.port).disposeListener.dispose(),await D.get(m.port).tunnel.dispose(),D.delete(m.port))}}async $onDidTunnelsChange(){this._onDidChangeTunnels.fire()}async $forwardPort(m,_){if(this._forwardPortProvider)try{this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Getting tunnel from provider.");const D=this._forwardPortProvider(m,_);if(this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Got tunnel promise from provider."),D!==void 0){const a=await D;this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Successfully awaited tunnel from provider."),this._extensionTunnels.has(m.remoteAddress.host)||this._extensionTunnels.set(m.remoteAddress.host,new Map);const T=this._register(a.onDidDispose(()=>(this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Extension fired tunnel's onDidDispose."),this._proxy.$closeTunnel(a.remoteAddress))));return this._extensionTunnels.get(m.remoteAddress.host).set(m.remoteAddress.port,{tunnel:a,disposeListener:T}),l.TunnelDto.fromApiTunnel(a)}else this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Tunnel is undefined")}catch(D){this.logService.trace("ForwardedPorts: (ExtHostTunnelService) tunnel provider error")}}async $applyCandidateFilter(m){const _=await Promise.all(m.map(a=>{var T;return this._showCandidatePort(a.host,a.port,(T=a.detail)!==null&&T!==void 0?T:"")})),D=m.filter((a,T)=>_[T]);return this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) filtered from ${m.map(a=>a.port).join(", ")} to ${D.map(a=>a.port).join(", ")}`),D}async findCandidatePorts(){let m="",_="";try{m=await k.Promises.readFile("/proc/net/tcp","utf8"),_=await k.Promises.readFile("/proc/net/tcp6","utf8")}catch(W){}const D=d(m,_),a=await new Promise(W=>{P.exec("ls -l /proc/[0-9]*/fd/[0-9]* | grep socket:",(M,j,O)=>{W(j)})}),T=b(a),L=await k.Promises.readdir("/proc"),U=[];for(let W of L)try{const M=Number(W),j=E.joinPath(A.URI.file("/proc"),W);if((await k.Promises.stat(j.fsPath)).isDirectory()&&!isNaN(M)){const F=await k.Promises.readlink(E.joinPath(j,"cwd").fsPath),B=await k.Promises.readFile(E.joinPath(j,"cmdline").fsPath,"utf8");U.push({pid:M,cwd:F,cmd:B})}}catch(M){}const G=[],ee=D.filter(W=>{const M=T[W.socket];return M||G.push(W),M}),z=s(ee,T,U);let N;if(this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) number of possible root ports ${G.length}`),G.length>0){const W=await new Promise(M=>{P.exec("ps -F -A -l | grep root",(j,O,F)=>{M(O)})});this._foundRootPorts=n(G,W,this._foundRootPorts),N=Array.from(this._foundRootPorts.values()),this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) heuristic ports ${N.join(", ")}`)}return z.then(W=>N?W.concat(N):W)}};o=Ve([We(0,R.IExtHostRpcService),We(1,y.IExtHostInitDataService),We(2,S.ILogService)],o),e.ExtHostTunnelService=o}),define(me[251],ge([0,1,16,21,14,3,6,98,217,125,22]),function(X,e,p,R,C,y,A,P,E,k,r){"use strict";var I;Object.defineProperty(e,"__esModule",{value:!0}),e.RPCProtocol=e.ResponsiveState=e.RequestInitiator=void 0;function l(n,o){try{return JSON.stringify(n,o)}catch(v){return"null"}}function f(n,o){return JSON.stringify(n,o)}function c(n){return n?(o,v)=>v&&v.$mid===1?n.transformOutgoing(v):v:null}var u;(function(n){n[n.LocalSide=0]="LocalSide",n[n.OtherSide=1]="OtherSide"})(u=e.RequestInitiator||(e.RequestInitiator={}));var S;(function(n){n[n.Responsive=0]="Responsive",n[n.Unresponsive=1]="Unresponsive"})(S=e.ResponsiveState||(e.ResponsiveState={}));const w=()=>{},b=Symbol.for("rpcProtocol"),d=Symbol.for("rpcProxy");class h extends A.Disposable{constructor(o,v=null,m=null){super();this[I]=!0,this._onDidChangeResponsiveState=this._register(new y.Emitter),this.onDidChangeResponsiveState=this._onDidChangeResponsiveState.event,this._protocol=o,this._logger=v,this._uriTransformer=m,this._uriReplacer=c(this._uriTransformer),this._isDisposed=!1,this._locals=[],this._proxies=[];for(let _=0,D=k.ProxyIdentifier.count;_<D;_++)this._locals[_]=null,this._proxies[_]=null;this._lastMessageId=0,this._cancelInvokedHandlers=Object.create(null),this._pendingRPCReplies={},this._responsiveState=0,this._unacknowledgedCount=0,this._unresponsiveTime=0,this._asyncCheckUresponsive=this._register(new p.RunOnceScheduler(()=>this._checkUnresponsive(),1e3)),this._protocol.onMessage(_=>this._receiveOneMessage(_))}dispose(){this._isDisposed=!0,Object.keys(this._pendingRPCReplies).forEach(o=>{this._pendingRPCReplies[o].resolveErr(C.canceled())})}drain(){return typeof this._protocol.drain=="function"?this._protocol.drain():Promise.resolve()}_onWillSendRequest(o){this._unacknowledgedCount===0&&(this._unresponsiveTime=Date.now()+h.UNRESPONSIVE_TIME),this._unacknowledgedCount++,this._asyncCheckUresponsive.isScheduled()||this._asyncCheckUresponsive.schedule()}_onDidReceiveAcknowledge(o){this._unresponsiveTime=Date.now()+h.UNRESPONSIVE_TIME,this._unacknowledgedCount--,this._unacknowledgedCount===0&&this._asyncCheckUresponsive.cancel(),this._setResponsiveState(0)}_checkUnresponsive(){this._unacknowledgedCount!==0&&(Date.now()>this._unresponsiveTime?this._setResponsiveState(1):this._asyncCheckUresponsive.schedule())}_setResponsiveState(o){this._responsiveState!==o&&(this._responsiveState=o,this._onDidChangeResponsiveState.fire(this._responsiveState))}get responsiveState(){return this._responsiveState}transformIncomingURIs(o){return this._uriTransformer?P.transformIncomingURIs(o,this._uriTransformer):o}getProxy(o){const{nid:v,sid:m}=o;return this._proxies[v]||(this._proxies[v]=this._createProxy(v,m)),this._proxies[v]}_createProxy(o,v){let m={get:(_,D)=>(typeof D=="string"&&!_[D]&&D.charCodeAt(0)===36&&(_[D]=(...a)=>this._remoteCall(o,D,a)),D===d?v:_[D])};return new Proxy(Object.create(null),m)}set(o,v){return this._locals[o.nid]=v,v}assertRegistered(o){for(let v=0,m=o.length;v<m;v++){const _=o[v];if(!this._locals[_.nid])throw new Error(`Missing actor ${_.sid} (isMain: ${_.isMain})`)}}_receiveOneMessage(o){if(this._isDisposed)return;const v=o.byteLength,m=g.read(o,0),_=m.readUInt8(),D=m.readUInt32();switch(_){case 1:case 2:{let{rpcId:a,method:T,args:L}=t.deserializeRequestJSONArgs(m);this._uriTransformer&&(L=P.transformIncomingURIs(L,this._uriTransformer)),this._receiveRequest(v,D,a,T,L,_===2);break}case 3:case 4:{let{rpcId:a,method:T,args:L}=t.deserializeRequestMixedArgs(m);this._uriTransformer&&(L=P.transformIncomingURIs(L,this._uriTransformer)),this._receiveRequest(v,D,a,T,L,_===4);break}case 5:{this._logger&&this._logger.logIncoming(v,D,0,"ack"),this._onDidReceiveAcknowledge(D);break}case 6:{this._receiveCancel(v,D);break}case 7:{this._receiveReply(v,D,void 0);break}case 9:{let a=t.deserializeReplyOKJSON(m);this._uriTransformer&&(a=P.transformIncomingURIs(a,this._uriTransformer)),this._receiveReply(v,D,a);break}case 8:{let a=t.deserializeReplyOKVSBuffer(m);this._receiveReply(v,D,a);break}case 10:{let a=t.deserializeReplyErrError(m);this._uriTransformer&&(a=P.transformIncomingURIs(a,this._uriTransformer)),this._receiveReplyErr(v,D,a);break}case 11:{this._receiveReplyErr(v,D,void 0);break}default:console.error("received unexpected message"),console.error(o)}}_receiveRequest(o,v,m,_,D,a){this._logger&&this._logger.logIncoming(o,v,1,`receiveRequest ${k.getStringIdentifierForProxy(m)}.${_}(`,D);const T=String(v);let L,U;if(a){const ee=new R.CancellationTokenSource;D.push(ee.token),L=this._invokeHandler(m,_,D),U=()=>ee.cancel()}else L=this._invokeHandler(m,_,D),U=w;this._cancelInvokedHandlers[T]=U;const G=t.serializeAcknowledged(v);this._logger&&this._logger.logOutgoing(G.byteLength,v,1,"ack"),this._protocol.send(G),L.then(ee=>{delete this._cancelInvokedHandlers[T];const z=t.serializeReplyOK(v,ee,this._uriReplacer);this._logger&&this._logger.logOutgoing(z.byteLength,v,1,"reply:",ee),this._protocol.send(z)},ee=>{delete this._cancelInvokedHandlers[T];const z=t.serializeReplyErr(v,ee);this._logger&&this._logger.logOutgoing(z.byteLength,v,1,"replyErr:",ee),this._protocol.send(z)})}_receiveCancel(o,v){this._logger&&this._logger.logIncoming(o,v,1,"receiveCancel");const m=String(v);this._cancelInvokedHandlers[m]&&this._cancelInvokedHandlers[m]()}_receiveReply(o,v,m){this._logger&&this._logger.logIncoming(o,v,0,"receiveReply:",m);const _=String(v);if(!this._pendingRPCReplies.hasOwnProperty(_))return;const D=this._pendingRPCReplies[_];delete this._pendingRPCReplies[_],D.resolveOk(m)}_receiveReplyErr(o,v,m){this._logger&&this._logger.logIncoming(o,v,0,"receiveReplyErr:",m);const _=String(v);if(!this._pendingRPCReplies.hasOwnProperty(_))return;const D=this._pendingRPCReplies[_];delete this._pendingRPCReplies[_];let a;m&&(m.$isError?(a=new Error,a.name=m.name,a.message=m.message,a.stack=m.stack):a=m),D.resolveErr(a)}_invokeHandler(o,v,m){try{return Promise.resolve(this._doInvokeHandler(o,v,m))}catch(_){return Promise.reject(_)}}_doInvokeHandler(o,v,m){const _=this._locals[o];if(!_)throw new Error("Unknown actor "+k.getStringIdentifierForProxy(o));let D=_[v];if(typeof D!="function")throw new Error("Unknown method "+v+" on actor "+k.getStringIdentifierForProxy(o));return D.apply(_,m)}_remoteCall(o,v,m){if(this._isDisposed)return Promise.reject(C.canceled());let _=null;if(m.length>0&&R.CancellationToken.isCancellationToken(m[m.length-1])&&(_=m.pop()),_&&_.isCancellationRequested)return Promise.reject(C.canceled());const D=t.serializeRequestArguments(m,this._uriReplacer),a=++this._lastMessageId,T=String(a),L=new E.LazyPromise;_&&_.onCancellationRequested(()=>{const G=t.serializeCancel(a);this._logger&&this._logger.logOutgoing(G.byteLength,a,0,"cancel"),this._protocol.send(t.serializeCancel(a))}),this._pendingRPCReplies[T]=L,this._onWillSendRequest(a);const U=t.serializeRequest(a,o,v,D,!!_);return this._logger&&this._logger.logOutgoing(U.byteLength,a,0,`request: ${k.getStringIdentifierForProxy(o)}.${v}(`,m),this._protocol.send(U),L}}e.RPCProtocol=h,I=b,h.UNRESPONSIVE_TIME=3*1e3;class g{constructor(o,v){this._buff=o,this._offset=v}static alloc(o,v,m){let _=new g(r.VSBuffer.alloc(m+1+4),0);return _.writeUInt8(o),_.writeUInt32(v),_}static read(o,v){return new g(o,v)}get buffer(){return this._buff}static sizeUInt8(){return 1}writeUInt8(o){this._buff.writeUInt8(o,this._offset),this._offset+=1}readUInt8(){const o=this._buff.readUInt8(this._offset);return this._offset+=1,o}writeUInt32(o){this._buff.writeUInt32BE(o,this._offset),this._offset+=4}readUInt32(){const o=this._buff.readUInt32BE(this._offset);return this._offset+=4,o}static sizeShortString(o){return 1+o.byteLength}writeShortString(o){this._buff.writeUInt8(o.byteLength,this._offset),this._offset+=1,this._buff.set(o,this._offset),this._offset+=o.byteLength}readShortString(){const o=this._buff.readUInt8(this._offset);this._offset+=1;const m=this._buff.slice(this._offset,this._offset+o).toString();return this._offset+=o,m}static sizeLongString(o){return 4+o.byteLength}writeLongString(o){this._buff.writeUInt32BE(o.byteLength,this._offset),this._offset+=4,this._buff.set(o,this._offset),this._offset+=o.byteLength}readLongString(){const o=this._buff.readUInt32BE(this._offset);this._offset+=4;const m=this._buff.slice(this._offset,this._offset+o).toString();return this._offset+=o,m}writeBuffer(o){this._buff.writeUInt32BE(o.byteLength,this._offset),this._offset+=4,this._buff.set(o,this._offset),this._offset+=o.byteLength}static sizeVSBuffer(o){return 4+o.byteLength}writeVSBuffer(o){this._buff.writeUInt32BE(o.byteLength,this._offset),this._offset+=4,this._buff.set(o,this._offset),this._offset+=o.byteLength}readVSBuffer(){const o=this._buff.readUInt32BE(this._offset);this._offset+=4;const v=this._buff.slice(this._offset,this._offset+o);return this._offset+=o,v}static sizeMixedArray(o,v){let m=0;m+=1;for(let _=0,D=o.length;_<D;_++){const a=o[_],T=v[_];switch(m+=1,T){case 1:m+=this.sizeLongString(a);break;case 2:m+=this.sizeVSBuffer(a);break;case 3:break}}return m}writeMixedArray(o,v){this._buff.writeUInt8(o.length,this._offset),this._offset+=1;for(let m=0,_=o.length;m<_;m++){const D=o[m];switch(v[m]){case 1:this.writeUInt8(1),this.writeLongString(D);break;case 2:this.writeUInt8(2),this.writeVSBuffer(D);break;case 3:this.writeUInt8(3);break}}}readMixedArray(){const o=this._buff.readUInt8(this._offset);this._offset+=1;let v=new Array(o);for(let m=0;m<o;m++)switch(this.readUInt8()){case 1:v[m]=this.readLongString();break;case 2:v[m]=this.readVSBuffer();break;case 3:v[m]=void 0;break}return v}}class t{static _arrayContainsBufferOrUndefined(o){for(let v=0,m=o.length;v<m;v++)if(o[v]instanceof r.VSBuffer||typeof o[v]=="undefined")return!0;return!1}static serializeRequestArguments(o,v){if(this._arrayContainsBufferOrUndefined(o)){let m=[],_=[];for(let D=0,a=o.length;D<a;D++){const T=o[D];T instanceof r.VSBuffer?(m[D]=T,_[D]=2):typeof T=="undefined"?(m[D]=r.VSBuffer.alloc(0),_[D]=3):(m[D]=r.VSBuffer.fromString(f(T,v)),_[D]=1)}return{type:"mixed",args:m,argsType:_}}return{type:"simple",args:f(o,v)}}static serializeRequest(o,v,m,_,D){return _.type==="mixed"?this._requestMixedArgs(o,v,m,_.args,_.argsType,D):this._requestJSONArgs(o,v,m,_.args,D)}static _requestJSONArgs(o,v,m,_,D){const a=r.VSBuffer.fromString(m),T=r.VSBuffer.fromString(_);let L=0;L+=g.sizeUInt8(),L+=g.sizeShortString(a),L+=g.sizeLongString(T);let U=g.alloc(D?2:1,o,L);return U.writeUInt8(v),U.writeShortString(a),U.writeLongString(T),U.buffer}static deserializeRequestJSONArgs(o){const v=o.readUInt8(),m=o.readShortString(),_=o.readLongString();return{rpcId:v,method:m,args:JSON.parse(_)}}static _requestMixedArgs(o,v,m,_,D,a){const T=r.VSBuffer.fromString(m);let L=0;L+=g.sizeUInt8(),L+=g.sizeShortString(T),L+=g.sizeMixedArray(_,D);let U=g.alloc(a?4:3,o,L);return U.writeUInt8(v),U.writeShortString(T),U.writeMixedArray(_,D),U.buffer}static deserializeRequestMixedArgs(o){const v=o.readUInt8(),m=o.readShortString(),_=o.readMixedArray(),D=new Array(_.length);for(let a=0,T=_.length;a<T;a++){const L=_[a];typeof L=="string"?D[a]=JSON.parse(L):D[a]=L}return{rpcId:v,method:m,args:D}}static serializeAcknowledged(o){return g.alloc(5,o,0).buffer}static serializeCancel(o){return g.alloc(6,o,0).buffer}static serializeReplyOK(o,v,m){return typeof v=="undefined"?this._serializeReplyOKEmpty(o):v instanceof r.VSBuffer?this._serializeReplyOKVSBuffer(o,v):this._serializeReplyOKJSON(o,l(v,m))}static _serializeReplyOKEmpty(o){return g.alloc(7,o,0).buffer}static _serializeReplyOKVSBuffer(o,v){let m=0;m+=g.sizeVSBuffer(v);let _=g.alloc(8,o,m);return _.writeVSBuffer(v),_.buffer}static deserializeReplyOKVSBuffer(o){return o.readVSBuffer()}static _serializeReplyOKJSON(o,v){const m=r.VSBuffer.fromString(v);let _=0;_+=g.sizeLongString(m);let D=g.alloc(9,o,_);return D.writeLongString(m),D.buffer}static deserializeReplyOKJSON(o){const v=o.readLongString();return JSON.parse(v)}static serializeReplyErr(o,v){return v?this._serializeReplyErrEror(o,v):this._serializeReplyErrEmpty(o)}static _serializeReplyErrEror(o,v){const m=r.VSBuffer.fromString(l(C.transformErrorForSerialization(v),null));let _=0;_+=g.sizeLongString(m);let D=g.alloc(10,o,_);return D.writeLongString(m),D.buffer}static deserializeReplyErrError(o){const v=o.readLongString();return JSON.parse(v)}static _serializeReplyErrEmpty(o){return g.alloc(11,o,0).buffer}}var i;(function(n){n[n.RequestJSONArgs=1]="RequestJSONArgs",n[n.RequestJSONArgsWithCancellation=2]="RequestJSONArgsWithCancellation",n[n.RequestMixedArgs=3]="RequestMixedArgs",n[n.RequestMixedArgsWithCancellation=4]="RequestMixedArgsWithCancellation",n[n.Acknowledged=5]="Acknowledged",n[n.Cancel=6]="Cancel",n[n.ReplyOKEmpty=7]="ReplyOKEmpty",n[n.ReplyOKVSBuffer=8]="ReplyOKVSBuffer",n[n.ReplyOKJSON=9]="ReplyOKJSON",n[n.ReplyErrError=10]="ReplyErrError",n[n.ReplyErrEmpty=11]="ReplyErrEmpty"})(i||(i={}));var s;(function(n){n[n.String=1]="String",n[n.VSBuffer=2]="VSBuffer",n[n.Undefined=3]="Undefined"})(s||(s={}))}),define(me[252],ge([0,1,4]),function(X,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IRemoteAgentService=e.RemoteExtensionLogFileName=void 0,e.RemoteExtensionLogFileName="remoteagent",e.IRemoteAgentService=p.createDecorator("remoteAgentService")}),define(me[253],ge([0,1,10,9,11,2,4,81,45,212,252]),function(X,e,p,R,C,y,A,P,E,k,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractPathService=e.IPathService=void 0,e.IPathService=A.createDecorator("pathService");let I=class xn{constructor(f,c,u,S){this.localUserHome=f,this.remoteAgentService=c,this.environmentService=u,this.contextService=S,this.resolveOS=(async()=>{const w=await this.remoteAgentService.getEnvironment();return(w==null?void 0:w.os)||C.OS})(),this.resolveUserHome=(async()=>{const w=await this.remoteAgentService.getEnvironment();return this.maybeUnresolvedUserHome=(w==null?void 0:w.userHome)||f})()}get defaultUriScheme(){return xn.findDefaultUriScheme(this.environmentService,this.contextService)}static findDefaultUriScheme(f,c){if(f.remoteAuthority)return p.Schemas.vscodeRemote;const u=P.getVirtualWorkspaceScheme(c.getWorkspace());if(u)return u;const S=c.getWorkspace().folders[0];if(S)return S.uri.scheme;const w=c.getWorkspace().configuration;return w?w.scheme:p.Schemas.file}async userHome(f){return(f==null?void 0:f.preferLocal)?this.localUserHome:this.resolveUserHome}get resolvedUserHome(){return this.maybeUnresolvedUserHome}get path(){return this.resolveOS.then(f=>f===1?R.win32:R.posix)}async fileURI(f){let c="";if(await this.resolveOS===1&&(f=f.replace(/\\/g,"/")),f[0]==="/"&&f[1]==="/"){const S=f.indexOf("/",2);S===-1?(c=f.substring(2),f="/"):(c=f.substring(2,S),f=f.substring(S)||"/")}return y.URI.from({scheme:p.Schemas.file,authority:c,path:f,query:"",fragment:""})}};I=Ve([We(1,r.IRemoteAgentService),We(2,k.IWorkbenchEnvironmentService),We(3,E.IWorkspaceContextService)],I),e.AbstractPathService=I}),define(me[64],ge([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchCompleteMessageType=e.Range=e.Position=void 0;class p{constructor(A,P){this.line=A,this.character=P}isBefore(A){return!1}isBeforeOrEqual(A){return!1}isAfter(A){return!1}isAfterOrEqual(A){return!1}isEqual(A){return!1}compareTo(A){return 0}translate(A,P){return new p(0,0)}with(A){return new p(0,0)}}e.Position=p;class R{constructor(A,P,E,k){this.isEmpty=!1,this.isSingleLine=!1,this.start=new p(A,P),this.end=new p(E,k)}contains(A){return!1}isEqual(A){return!1}intersection(A){}union(A){return new R(0,0,0,0)}with(A){return new R(0,0,0,0)}}e.Range=R;var C;(function(y){y[y.Information=1]="Information",y[y.Warning=2]="Warning"})(C=e.TextSearchCompleteMessageType||(e.TextSearchCompleteMessageType={}))}),define(me[31],ge([0,1,18,30,25,29,8,4,9,14,64]),function(X,e,p,R,C,y,A,P,E,k,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.QueryGlobTester=e.resolvePatternsForProvider=e.SerializableFileMatch=e.isFilePatternMatch=e.isSerializedFileMatch=e.isSerializedSearchSuccess=e.isSerializedSearchComplete=e.serializeSearchError=e.deserializeSearchError=e.SearchError=e.SearchErrorCode=e.pathIncludedInQuery=e.getExcludes=e.SearchSortOrder=e.OneLineRange=e.SearchRange=e.TextSearchMatch=e.FileMatch=e.SearchCompletionExitCode=e.isProgressMessage=e.isFileMatch=e.resultIsMatch=e.QueryType=e.SearchProviderType=e.ISearchService=e.SEARCH_EXCLUDE_CONFIG=e.VIEW_ID=e.PANEL_ID=e.VIEWLET_ID=e.TextSearchCompleteMessageType=void 0,Object.defineProperty(e,"TextSearchCompleteMessageType",{enumerable:!0,get:function(){return r.TextSearchCompleteMessageType}}),e.VIEWLET_ID="workbench.view.search",e.PANEL_ID="workbench.panel.search",e.VIEW_ID="workbench.view.search",e.SEARCH_EXCLUDE_CONFIG="search.exclude";const I="\u27EA ",l=" characters skipped \u27EB",f=(I.length+l.length+5)*2;e.ISearchService=P.createDecorator("searchService");var c;(function(M){M[M.file=0]="file",M[M.text=1]="text"})(c=e.SearchProviderType||(e.SearchProviderType={}));var u;(function(M){M[M.File=1]="File",M[M.Text=2]="Text"})(u=e.QueryType||(e.QueryType={}));function S(M){return!!M.preview}e.resultIsMatch=S;function w(M){return!!M.resource}e.isFileMatch=w;function b(M){return!!M.message}e.isProgressMessage=b;var d;(function(M){M[M.Normal=0]="Normal",M[M.NewSearchStarted=1]="NewSearchStarted"})(d=e.SearchCompletionExitCode||(e.SearchCompletionExitCode={}));class h{constructor(j){this.resource=j,this.results=[]}}e.FileMatch=h;class g{constructor(j,O,F){this.ranges=O;const B=Array.isArray(O)?O:[O];if(F&&F.matchLines===1&&t(B)){j=A.getNLines(j,F.matchLines);let $="",Y=0,le=0;const be=Math.floor(F.charsPerLine/5),Le=[];for(const Ie of B){const Ue=Math.max(Ie.startColumn-be,0),Qe=Ie.startColumn+F.charsPerLine;if(Ue>le+be+f){const ze=I+(Ue-le)+l;$+=ze+j.slice(Ue,Qe),Y+=Ue-(le+ze.length)}else $+=j.slice(le,Qe);Le.push(new s(0,Ie.startColumn-Y,Ie.endColumn-Y)),le=Qe}this.preview={text:$,matches:Array.isArray(this.ranges)?Le:Le[0]}}else{const $=Array.isArray(O)?O[0].startLineNumber:O.startLineNumber;this.preview={text:j,matches:p.mapArrayOrNot(O,Y=>new i(Y.startLineNumber-$,Y.startColumn,Y.endLineNumber-$,Y.endColumn))}}}}e.TextSearchMatch=g;function t(M){const j=M[0].startLineNumber;for(const O of M)if(O.startLineNumber!==j||O.endLineNumber!==j)return!1;return!0}class i{constructor(j,O,F,B){this.startLineNumber=j,this.startColumn=O,this.endLineNumber=F,this.endColumn=B}}e.SearchRange=i;class s extends i{constructor(j,O,F){super(j,O,j,F)}}e.OneLineRange=s;var n;(function(M){M.Default="default",M.FileNames="fileNames",M.Type="type",M.Modified="modified",M.CountDescending="countDescending",M.CountAscending="countAscending"})(n=e.SearchSortOrder||(e.SearchSortOrder={}));function o(M,j=!0){const O=M&&M.files&&M.files.exclude,F=j&&M&&M.search&&M.search.exclude;if(!O&&!F)return;if(!O||!F)return O||F;let B=Object.create(null);return B=C.mixin(B,C.deepClone(O)),B=C.mixin(B,C.deepClone(F),!0),B}e.getExcludes=o;function v(M,j){return M.excludePattern&&R.match(M.excludePattern,j)?!1:M.includePattern||M.usingSearchPaths?M.includePattern&&R.match(M.includePattern,j)?!0:M.usingSearchPaths?!!M.folderQueries&&M.folderQueries.some(O=>{const F=O.folder.fsPath;if(y.isEqualOrParent(j,F)){const B=E.relative(F,j);return!O.includePattern||!!R.match(O.includePattern,B)}else return!1}):!1:!0}e.pathIncludedInQuery=v;var m;(function(M){M[M.unknownEncoding=1]="unknownEncoding",M[M.regexParseError=2]="regexParseError",M[M.globParseError=3]="globParseError",M[M.invalidLiteral=4]="invalidLiteral",M[M.rgProcessError=5]="rgProcessError",M[M.other=6]="other",M[M.canceled=7]="canceled"})(m=e.SearchErrorCode||(e.SearchErrorCode={}));class _ extends Error{constructor(j,O){super(j);this.code=O}}e.SearchError=_;function D(M){const j=M.message;if(k.isPromiseCanceledError(M))return new _(j,m.canceled);try{const O=JSON.parse(j);return new _(O.message,O.code)}catch(O){return new _(j,m.other)}}e.deserializeSearchError=D;function a(M){const j={message:M.message,code:M.code};return new Error(JSON.stringify(j))}e.serializeSearchError=a;function T(M){return M.type==="error"?!0:M.type==="success"}e.isSerializedSearchComplete=T;function L(M){return M.type==="success"}e.isSerializedSearchSuccess=L;function U(M){return!!M.path}e.isSerializedFileMatch=U;function G(M,j){const O=M.searchPath?M.searchPath:M.relativePath;return A.fuzzyContains(O,j)}e.isFilePatternMatch=G;class ee{constructor(j){this.path=j,this.results=[]}addMatch(j){this.results.push(j)}serialize(){return{path:this.path,results:this.results,numMatches:this.results.length}}}e.SerializableFileMatch=ee;function z(M,j){const O=Object.assign(Object.assign({},M||{}),j||{});return Object.keys(O).filter(F=>{const B=O[F];return typeof B=="boolean"&&B})}e.resolvePatternsForProvider=z;class N{constructor(j,O){this._parsedIncludeExpression=null,this._excludeExpression=Object.assign(Object.assign({},j.excludePattern||{}),O.excludePattern||{}),this._parsedExcludeExpression=R.parse(this._excludeExpression);let F=j.includePattern;O.includePattern&&(F?F=Object.assign(Object.assign({},F),O.includePattern):F=O.includePattern),F&&(this._parsedIncludeExpression=R.parse(F))}includedInQuerySync(j,O,F){return!(this._parsedExcludeExpression&&this._parsedExcludeExpression(j,O,F)||this._parsedIncludeExpression&&!this._parsedIncludeExpression(j,O,F))}includedInQuery(j,O,F){return Promise.resolve(this._parsedExcludeExpression(j,O,F)).then($=>!!$).then($=>$?!1:this._parsedIncludeExpression?Promise.resolve(this._parsedIncludeExpression(j,O,F)).then(Y=>!!Y):Promise.resolve(!0)).then($=>$)}hasSiblingExcludeClauses(){return W(this._excludeExpression)}}e.QueryGlobTester=N;function W(M){for(const j in M)if(typeof M[j]!="boolean")return!0;return!1}}),define(me[35],ge([0,1,18,16,21,3,23,10,72,24,8,15,2,164,4,12,182,45,59,27,13,7,31,5]),function(X,e,p,R,C,y,A,P,E,k,r,I,l,f,c,u,S,w,b,d,h,g,t,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWorkspace=e.ExtHostWorkspace=void 0;function s(T,L,U){return new k.ExtUri(G=>m(G,U)).isEqual(T,L)}function n(T,L,U){return s(T.uri,L.uri,U)?0:r.compare(T.uri.toString(),L.uri.toString())}function o(T,L,U){return T.index!==L.index?T.index<L.index?-1:1:s(T.uri,L.uri,U)?r.compare(T.name,L.name):r.compare(T.uri.toString(),L.uri.toString())}function v(T,L,U,G){const ee=T.slice(0).sort((N,W)=>U(N,W,G)),z=L.slice(0).sort((N,W)=>U(N,W,G));return p.delta(ee,z,(N,W)=>U(N,W,G))}function m(T,L){const U=L.getCapabilities(T.scheme);return!(U&&U&1024)}class _ extends w.Workspace{constructor(L,U,G,ee,z,N){super(L,G.map(W=>new w.WorkspaceFolder(W)),ee,N);this._name=U,this._isUntitled=z,this._workspaceFolders=[],this._structure=A.TernarySearchTree.forUris(N),G.forEach(W=>{this._workspaceFolders.push(W),this._structure.set(W.uri,W)})}static toExtHostWorkspace(L,U,G,ee){if(!L)return{workspace:null,added:[],removed:[]};const{id:z,name:N,folders:W,configuration:M,isUntitled:j}=L,O=[],F=U;U?W.forEach((le,be)=>{const Le=l.URI.revive(le.uri),Ie=_._findFolder(G||U,Le,ee);Ie?(Ie.name=le.name,Ie.index=le.index,O.push(Ie)):O.push({uri:Le,name:le.name,index:be})}):O.push(...W.map(({uri:le,name:be,index:Le})=>({uri:l.URI.revive(le),name:be,index:Le}))),O.sort((le,be)=>le.index<be.index?-1:1);const B=new _(z,N,O,M?l.URI.revive(M):null,!!j,le=>m(le,ee)),{added:$,removed:Y}=v(F?F.workspaceFolders:[],B.workspaceFolders,n,ee);return{workspace:B,added:$,removed:Y}}static _findFolder(L,U,G){for(let ee=0;ee<L.folders.length;ee++){const z=L.workspaceFolders[ee];if(s(z.uri,U,G))return z}}get name(){return this._name}get isUntitled(){return this._isUntitled}get workspaceFolders(){return this._workspaceFolders.slice(0)}getWorkspaceFolder(L,U){return U&&this._structure.get(L)&&(L=k.dirname(L)),this._structure.findSubstr(L)}resolveWorkspaceFolder(L){return this._structure.get(L)}}let D=class{constructor(L,U,G,ee){this._onDidChangeWorkspace=new y.Emitter,this.onDidChangeWorkspace=this._onDidChangeWorkspace.event,this._onDidGrantWorkspaceTrust=new y.Emitter,this.onDidGrantWorkspaceTrust=this._onDidGrantWorkspaceTrust.event,this._activeSearchCallbacks=[],this._trusted=!1,this._logService=ee,this._extHostFileSystemInfo=G,this._requestIdProvider=new E.Counter,this._barrier=new R.Barrier,this._proxy=L.getProxy(i.MainContext.MainThreadWorkspace),this._messageService=L.getProxy(i.MainContext.MainThreadMessageService);const z=U.workspace;this._confirmedWorkspace=z?new _(z.id,z.name,[],z.configuration?l.URI.revive(z.configuration):null,!!z.isUntitled,N=>m(N,G)):void 0}$initializeWorkspace(L,U){this._trusted=U,this.$acceptWorkspaceData(L),this._barrier.open()}waitForInitializeCall(){return this._barrier.wait()}get workspace(){return this._actualWorkspace}get name(){return this._actualWorkspace?this._actualWorkspace.name:void 0}get workspaceFile(){if(this._actualWorkspace&&this._actualWorkspace.configuration)return this._actualWorkspace.isUntitled?l.URI.from({scheme:P.Schemas.untitled,path:k.basename(k.dirname(this._actualWorkspace.configuration))}):this._actualWorkspace.configuration}get _actualWorkspace(){return this._unconfirmedWorkspace||this._confirmedWorkspace}getWorkspaceFolders(){if(!!this._actualWorkspace)return this._actualWorkspace.workspaceFolders.slice(0)}async getWorkspaceFolders2(){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.workspaceFolders.slice(0)}updateWorkspaceFolders(L,U,G,...ee){const z=[];if(Array.isArray(ee)&&ee.forEach(O=>{l.URI.isUri(O.uri)&&!z.some(F=>s(F.uri,O.uri,this._extHostFileSystemInfo))&&z.push({uri:O.uri,name:O.name||k.basenameOrAuthority(O.uri)})}),this._unconfirmedWorkspace||[U,G].some(O=>typeof O!="number"||O<0)||G===0&&z.length===0)return!1;const N=this._actualWorkspace?this._actualWorkspace.workspaceFolders:[];if(U+G>N.length)return!1;const W=N.slice(0);W.splice(U,G,...z.map(O=>({uri:O.uri,name:O.name||k.basenameOrAuthority(O.uri),index:void 0})));for(let O=0;O<W.length;O++){const F=W[O];if(W.some((B,$)=>$!==O&&s(F.uri,B.uri,this._extHostFileSystemInfo)))return!1}W.forEach((O,F)=>O.index=F);const{added:M,removed:j}=v(N,W,o,this._extHostFileSystemInfo);if(M.length===0&&j.length===0)return!1;if(this._proxy){const O=L.displayName||L.name;this._proxy.$updateWorkspaceFolders(O,U,G,z).then(void 0,F=>{this._unconfirmedWorkspace=void 0,this._messageService.$showMessage(S.Severity.Error,f.localize(0,null,O,F.toString()),{extension:L},[])})}return this.trySetWorkspaceFolders(W),!0}getWorkspaceFolder(L,U){if(!!this._actualWorkspace)return this._actualWorkspace.getWorkspaceFolder(L,U)}async getWorkspaceFolder2(L,U){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.getWorkspaceFolder(L,U)}async resolveWorkspaceFolder(L){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.resolveWorkspaceFolder(L)}getPath(){if(!this._actualWorkspace)return;const{folders:L}=this._actualWorkspace;if(L.length!==0)return L[0].uri.fsPath}getRelativePath(L,U){let G,ee="";if(typeof L=="string"?(G=l.URI.file(L),ee=L):typeof L!="undefined"&&(G=L,ee=L.fsPath),!G)return ee;const z=this.getWorkspaceFolder(G,!0);if(!z)return ee;typeof U=="undefined"&&this._actualWorkspace&&(U=this._actualWorkspace.folders.length>1);let N=k.relativePath(z.uri,G);return U&&z.name&&(N=`${z.name}/${N}`),N}trySetWorkspaceFolders(L){this._actualWorkspace&&(this._unconfirmedWorkspace=_.toExtHostWorkspace({id:this._actualWorkspace.id,name:this._actualWorkspace.name,configuration:this._actualWorkspace.configuration,folders:L,isUntitled:this._actualWorkspace.isUntitled},this._actualWorkspace,void 0,this._extHostFileSystemInfo).workspace||void 0)}$acceptWorkspaceData(L){const{workspace:U,added:G,removed:ee}=_.toExtHostWorkspace(L,this._confirmedWorkspace,this._unconfirmedWorkspace,this._extHostFileSystemInfo);this._confirmedWorkspace=U||void 0,this._unconfirmedWorkspace=void 0,this._onDidChangeWorkspace.fire(Object.freeze({added:G,removed:ee}))}findFiles(L,U,G,ee,z=C.CancellationToken.None){this._logService.trace(`extHostWorkspace#findFiles: fileSearch, extension: ${ee.value}, entryPoint: findFiles`);let N;if(U===null?N=!1:U&&(typeof U=="string"?N=U:N=U.pattern),z&&z.isCancellationRequested)return Promise.resolve([]);const{includePattern:W,folder:M}=a(L);return this._proxy.$startFileSearch(I.withUndefinedAsNull(W),I.withUndefinedAsNull(M),I.withUndefinedAsNull(N),I.withUndefinedAsNull(G),z).then(j=>Array.isArray(j)?j.map(O=>l.URI.revive(O)):[])}async findTextInFiles(L,U,G,ee,z=C.CancellationToken.None){this._logService.trace(`extHostWorkspace#findTextInFiles: textSearch, extension: ${ee.value}, entryPoint: findTextInFiles`);const N=this._requestIdProvider.getNext(),W=typeof U.previewOptions=="undefined"?{matchLines:100,charsPerLine:1e4}:U.previewOptions,{includePattern:M,folder:j}=a(U.include),O=typeof U.exclude=="string"?U.exclude:U.exclude?U.exclude.pattern:void 0,F={ignoreSymlinks:typeof U.followSymlinks=="boolean"?!U.followSymlinks:void 0,disregardIgnoreFiles:typeof U.useIgnoreFiles=="boolean"?!U.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof U.useGlobalIgnoreFiles=="boolean"?!U.useGlobalIgnoreFiles:void 0,disregardExcludeSettings:typeof U.useDefaultExcludes=="boolean"?!U.useDefaultExcludes:!0,fileEncoding:U.encoding,maxResults:U.maxResults,previewOptions:W,afterContext:U.afterContext,beforeContext:U.beforeContext,includePattern:M,excludePattern:O},B=!1;if(this._activeSearchCallbacks[N]=$=>{if(B)return;const Y=l.URI.revive($.resource);$.results.forEach(le=>{t.resultIsMatch(le)?G({uri:Y,preview:{text:le.preview.text,matches:p.mapArrayOrNot(le.preview.matches,be=>new g.Range(be.startLineNumber,be.startColumn,be.endLineNumber,be.endColumn))},ranges:p.mapArrayOrNot(le.ranges,be=>new g.Range(be.startLineNumber,be.startColumn,be.endLineNumber,be.endColumn))}):G({uri:Y,text:le.text,lineNumber:le.lineNumber})})},z.isCancellationRequested)return{};try{const $=await this._proxy.$startTextSearch(L,I.withUndefinedAsNull(j),F,N,z);return delete this._activeSearchCallbacks[N],$||{}}catch($){throw delete this._activeSearchCallbacks[N],$}}$handleTextSearchResult(L,U){this._activeSearchCallbacks[U]&&this._activeSearchCallbacks[U](L)}saveAll(L){return this._proxy.$saveAll(L)}resolveProxy(L){return this._proxy.$resolveProxy(L)}get trusted(){return this._trusted}requestWorkspaceTrust(L){return this._proxy.$requestWorkspaceTrust(L)}$onDidGrantWorkspaceTrust(){this._trusted||(this._trusted=!0,this._onDidGrantWorkspaceTrust.fire())}};D=Ve([We(0,h.IExtHostRpcService),We(1,d.IExtHostInitDataService),We(2,b.IExtHostFileSystemInfo),We(3,u.ILogService)],D),e.ExtHostWorkspace=D,e.IExtHostWorkspace=c.createDecorator("IExtHostWorkspace");function a(T){let L,U;return T&&(typeof T=="string"?L=T:(L=T.pattern,U=T.baseFolder||l.URI.file(T.base))),{includePattern:L,folder:U}}}),define(me[36],ge([0,1,25,3,35,5,7,186,80,15,16,4,13,12,2]),function(X,e,p,R,C,y,A,P,E,k,r,I,l,f,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConfiguration=e.ExtHostConfigProvider=e.ExtHostConfiguration=void 0;function u(i,s){if(s){const n=s.split(".");let o=i;for(let v=0;o&&v<n.length;v++)o=o[n[v]];return o}}function S(i){return i instanceof c.URI}function w(i){return i&&i.uri instanceof c.URI&&i.languageId&&typeof i.languageId=="string"}function b(i){return i&&!i.uri&&i.languageId&&typeof i.languageId=="string"}function d(i){return i&&i.uri instanceof c.URI&&(!i.name||typeof i.name=="string")&&(!i.index||typeof i.index=="number")}function h(i){if(S(i))return{resource:i};if(w(i))return{resource:i.uri,overrideIdentifier:i.languageId};if(b(i))return{overrideIdentifier:i.languageId};if(d(i))return{resource:i.uri};if(i===null)return{resource:null}}let g=class{constructor(s,n,o){this._proxy=s.getProxy(y.MainContext.MainThreadConfiguration),this._extHostWorkspace=n,this._logService=o,this._barrier=new r.Barrier,this._actual=null}getConfigProvider(){return this._barrier.wait().then(s=>this._actual)}$initializeConfiguration(s){this._actual=new t(this._proxy,this._extHostWorkspace,s,this._logService),this._barrier.open()}$acceptConfigurationChanged(s,n){this.getConfigProvider().then(o=>o.$acceptConfigurationChanged(s,n))}};g=Ve([We(0,l.IExtHostRpcService),We(1,C.IExtHostWorkspace),We(2,f.ILogService)],g),e.ExtHostConfiguration=g;class t{constructor(s,n,o,v){this._onDidChangeConfiguration=new R.Emitter,this._proxy=s,this._logService=v,this._extHostWorkspace=n,this._configuration=P.Configuration.parse(o),this._configurationScopes=this._toMap(o.configurationScopes)}get onDidChangeConfiguration(){return this._onDidChangeConfiguration&&this._onDidChangeConfiguration.event}$acceptConfigurationChanged(s,n){const o={data:this._configuration.toData(),workspace:this._extHostWorkspace.workspace};this._configuration=P.Configuration.parse(s),this._configurationScopes=this._toMap(s.configurationScopes),this._onDidChangeConfiguration.fire(this._toConfigurationChangeEvent(n,o))}getConfiguration(s,n,o){const v=h(n)||{},m=this._toReadonlyValue(s?u(this._configuration.getValue(void 0,v,this._extHostWorkspace.workspace),s):this._configuration.getValue(void 0,v,this._extHostWorkspace.workspace));s&&this._validateConfigurationAccess(s,v,o==null?void 0:o.identifier);function _(a){if(a==null)return null;if(typeof a=="boolean")return a?1:4;switch(a){case A.ConfigurationTarget.Global:return 1;case A.ConfigurationTarget.Workspace:return 4;case A.ConfigurationTarget.WorkspaceFolder:return 5}}const D={has(a){return typeof u(m,a)!="undefined"},get:(a,T)=>{this._validateConfigurationAccess(s?`${s}.${a}`:a,v,o==null?void 0:o.identifier);let L=u(m,a);if(typeof L=="undefined")L=T;else{let U;const G=(ee,z)=>{let N;const W=()=>{U=U||p.deepClone(m),N=N||u(U,z)};return k.isObject(ee)?new Proxy(ee,{get:(M,j)=>{if(typeof j=="string"&&j.toLowerCase()==="tojson")return W(),()=>N;if(U)return N=N||u(U,z),N[j];const O=M[j];return typeof j=="string"?G(O,`${z}.${j}`):O},set:(M,j,O)=>(W(),N&&(N[j]=O),!0),deleteProperty:(M,j)=>(W(),N&&delete N[j],!0),defineProperty:(M,j,O)=>(W(),N&&Object.defineProperty(N,j,O),!0)}):ee};L=G(L,a)}return L},update:(a,T,L,U)=>{a=s?`${s}.${a}`:a;const G=_(L);return T!==void 0?this._proxy.$updateConfigurationOption(G,a,T,v,U):this._proxy.$removeConfigurationOption(G,a,v,U)},inspect:a=>{var T,L,U,G,ee,z,N,W;a=s?`${s}.${a}`:a;const M=p.deepClone(this._configuration.inspect(a,v,this._extHostWorkspace.workspace));if(M)return{key:a,defaultValue:(T=M.default)===null||T===void 0?void 0:T.value,globalValue:(L=M.user)===null||L===void 0?void 0:L.value,workspaceValue:(U=M.workspace)===null||U===void 0?void 0:U.value,workspaceFolderValue:(G=M.workspaceFolder)===null||G===void 0?void 0:G.value,defaultLanguageValue:(ee=M.default)===null||ee===void 0?void 0:ee.override,globalLanguageValue:(z=M.user)===null||z===void 0?void 0:z.override,workspaceLanguageValue:(N=M.workspace)===null||N===void 0?void 0:N.override,workspaceFolderLanguageValue:(W=M.workspaceFolder)===null||W===void 0?void 0:W.override,languageIds:M.overrideIdentifiers}}};return typeof m=="object"&&p.mixin(D,m,!1),Object.freeze(D)}_toReadonlyValue(s){const n=o=>k.isObject(o)?new Proxy(o,{get:(v,m)=>n(v[m]),set:(v,m,_)=>{throw new Error(`TypeError: Cannot assign to read only property '${String(m)}' of object`)},deleteProperty:(v,m)=>{throw new Error(`TypeError: Cannot delete read only property '${String(m)}' of object`)},defineProperty:(v,m)=>{throw new Error(`TypeError: Cannot define property '${String(m)}' for a readonly object`)},setPrototypeOf:v=>{throw new Error("TypeError: Cannot set prototype for a readonly object")},isExtensible:()=>!1,preventExtensions:()=>!0}):o;return n(s)}_validateConfigurationAccess(s,n,o){const v=E.OVERRIDE_PROPERTY_PATTERN.test(s)?4:this._configurationScopes.get(s),m=o?`[${o.value}] `:"";if(v===4){typeof(n==null?void 0:n.resource)=="undefined"&&this._logService.warn(`${m}Accessing a resource scoped configuration without providing a resource is not expected. To get the effective value for '${s}', provide the URI of a resource or 'null' for any resource.`);return}if(v===3){(n==null?void 0:n.resource)&&this._logService.warn(`${m}Accessing a window scoped configuration for a resource is not expected. To associate '${s}' to a resource, define its scope to 'resource' in configuration contributions in 'package.json'.`);return}}_toConfigurationChangeEvent(s,n){const o=new P.ConfigurationChangeEvent(s,n,this._configuration,this._extHostWorkspace.workspace);return Object.freeze({affectsConfiguration:(v,m)=>o.affectsConfiguration(v,h(m))})}_toMap(s){return s.reduce((n,o)=>(n.set(o[0],o[1]),n),new Map)}}e.ExtHostConfigProvider=t,e.IExtHostConfiguration=I.createDecorator("IExtHostConfiguration")});var rt=this&&this.__classPrivateFieldSet||function(X,e,p,R,C){if(R==="m")throw new TypeError("Private method is not writable");if(R==="a"&&!C)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?X!==e||!C:!e.has(X))throw new TypeError("Cannot write private member to an object whose class did not declare it");return R==="a"?C.call(X,p):C?C.value=p:e.set(X,p),p},$e=this&&this.__classPrivateFieldGet||function(X,e,p,R){if(p==="a"&&!R)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?X!==e||!R:!e.has(X))throw new TypeError("Cannot read private member from an object whose class did not declare it");return p==="m"?R:p==="a"?R.call(X):R?R.value:e.get(X)};define(me[65],ge([0,1,2,16,3,5,7,35,42,36,21,33,13,27,4,10,11,12,61,201,14]),function(X,e,p,R,C,y,A,P,E,k,r,I,l,f,c,u,S,w,b,d,h){"use strict";var g;Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTask=e.WorkerExtHostTask=e.ExtHostTaskBase=e.TaskExecutionDTO=e.TaskFilterDTO=e.TaskDTO=e.TaskHandleDTO=e.CustomExecutionDTO=e.ShellExecutionDTO=e.ShellExecutionOptionsDTO=e.ProcessExecutionDTO=e.ProcessExecutionOptionsDTO=e.TaskPresentationOptionsDTO=e.TaskDefinitionDTO=void 0;var t;(function(ee){function z(W){if(W!=null)return W}ee.from=z;function N(W){if(W!=null)return W}ee.to=N})(t=e.TaskDefinitionDTO||(e.TaskDefinitionDTO={}));var i;(function(ee){function z(W){if(W!=null)return W}ee.from=z;function N(W){if(W!=null)return W}ee.to=N})(i=e.TaskPresentationOptionsDTO||(e.TaskPresentationOptionsDTO={}));var s;(function(ee){function z(W){if(W!=null)return W}ee.from=z;function N(W){if(W!=null)return W}ee.to=N})(s=e.ProcessExecutionOptionsDTO||(e.ProcessExecutionOptionsDTO={}));var n;(function(ee){function z(M){if(M){const j=M;return j&&!!j.process}else return!1}ee.is=z;function N(M){if(M==null)return;const j={process:M.process,args:M.args};return M.options&&(j.options=s.from(M.options)),j}ee.from=N;function W(M){if(M!=null)return new A.ProcessExecution(M.process,M.args,M.options)}ee.to=W})(n=e.ProcessExecutionDTO||(e.ProcessExecutionDTO={}));var o;(function(ee){function z(W){if(W!=null)return W}ee.from=z;function N(W){if(W!=null)return W}ee.to=N})(o=e.ShellExecutionOptionsDTO||(e.ShellExecutionOptionsDTO={}));var v;(function(ee){function z(M){if(M){const j=M;return j&&(!!j.commandLine||!!j.command)}else return!1}ee.is=z;function N(M){if(M==null)return;const j={};return M.commandLine!==void 0?j.commandLine=M.commandLine:(j.command=M.command,j.args=M.args),M.options&&(j.options=o.from(M.options)),j}ee.from=N;function W(M){if(!(M==null||M.command===void 0&&M.commandLine===void 0))return M.commandLine?new A.ShellExecution(M.commandLine,M.options):new A.ShellExecution(M.command,M.args?M.args:[],M.options)}ee.to=W})(v=e.ShellExecutionDTO||(e.ShellExecutionDTO={}));var m;(function(ee){function z(M){if(M){let j=M;return j&&j.customExecution==="customExecution"}else return!1}ee.is=z;function N(M){return{customExecution:"customExecution"}}ee.from=N;function W(M,j){return j.get(M)}ee.to=W})(m=e.CustomExecutionDTO||(e.CustomExecutionDTO={}));var _;(function(ee){function z(N,W){let M;return N.scope!==void 0&&typeof N.scope!="number"?M=N.scope.uri:N.scope!==void 0&&typeof N.scope=="number"&&(N.scope===A.TaskScope.Workspace&&W&&W.workspaceFile?M=W.workspaceFile:M=d.USER_TASKS_GROUP_KEY),{id:N._id,workspaceFolder:M}}ee.from=z})(_=e.TaskHandleDTO||(e.TaskHandleDTO={}));var D;(function(ee){function z(M,j){if(M==null)return[];const O=[];for(let F of M){const B=N(F,j);B&&O.push(B)}return O}ee.fromMany=z;function N(M,j){if(M==null)return;let O;M.execution instanceof A.ProcessExecution?O=n.from(M.execution):M.execution instanceof A.ShellExecution?O=v.from(M.execution):M.execution&&M.execution instanceof A.CustomExecution&&(O=m.from(M.execution));const F=t.from(M.definition);let B;if(M.scope?typeof M.scope=="number"?B=M.scope:B=M.scope.uri:B=A.TaskScope.Workspace,!F||!B)return;const $=M.group?M.group.id:void 0;return{_id:M._id,definition:F,name:M.name,source:{extensionId:j.identifier.value,label:M.source,scope:B},execution:O,isBackground:M.isBackground,group:$,presentationOptions:i.from(M.presentationOptions),problemMatchers:M.problemMatchers,hasDefinedMatchers:M.hasDefinedMatchers,runOptions:M.runOptions?M.runOptions:{reevaluateOnRerun:!0},detail:M.detail}}ee.from=N;async function W(M,j,O){if(M==null)return;let F;n.is(M.execution)?F=n.to(M.execution):v.is(M.execution)?F=v.to(M.execution):m.is(M.execution)&&(F=m.to(M._id,O));const B=t.to(M.definition);let $;if(M.source&&(M.source.scope!==void 0?typeof M.source.scope=="number"?$=M.source.scope:$=await j.resolveWorkspaceFolder(p.URI.revive(M.source.scope)):$=A.TaskScope.Workspace),!B||!$)return;const Y=new A.Task(B,$,M.name,M.source.label,F,M.problemMatchers);return M.isBackground!==void 0&&(Y.isBackground=M.isBackground),M.group!==void 0&&(Y.group=A.TaskGroup.from(M.group)),M.presentationOptions&&(Y.presentationOptions=i.to(M.presentationOptions)),M._id&&(Y._id=M._id),M.detail&&(Y.detail=M.detail),Y}ee.to=W})(D=e.TaskDTO||(e.TaskDTO={}));var a;(function(ee){function z(W){return W}ee.from=z;function N(W){if(!!W)return Object.assign(Object.create(null),W)}ee.to=N})(a=e.TaskFilterDTO||(e.TaskFilterDTO={}));class T{constructor(z,N,W){this._id=N,this._task=W,g.set(this,void 0),rt(this,g,z,"f")}get task(){return this._task}terminate(){$e(this,g,"f").terminateTask(this)}fireDidStartProcess(z){}fireDidEndProcess(z){}}g=new WeakMap;var L;(function(ee){function z(N){return{id:N._id,task:void 0}}ee.from=z})(L=e.TaskExecutionDTO||(e.TaskExecutionDTO={}));let U=class{constructor(z,N,W,M,j,O,F,B){this._onDidExecuteTask=new C.Emitter,this._onDidTerminateTask=new C.Emitter,this._onDidTaskProcessStarted=new C.Emitter,this._onDidTaskProcessEnded=new C.Emitter,this._proxy=z.getProxy(y.MainContext.MainThreadTask),this._workspaceProvider=W,this._editorService=M,this._configurationService=j,this._terminalService=O,this._handleCounter=0,this._handlers=new Map,this._taskExecutions=new Map,this._taskExecutionPromises=new Map,this._providedCustomExecutions2=new Map,this._notProvidedCustomExecutions=new Set,this._activeCustomExecutions2=new Map,this._logService=F,this._deprecationService=B,this._proxy.$registerSupportedExecutions(!0)}registerTaskProvider(z,N,W){if(!W)return new A.Disposable(()=>{});const M=this.nextHandle();return this._handlers.set(M,{type:N,provider:W,extension:z}),this._proxy.$registerTaskProvider(M,N),new A.Disposable(()=>{this._handlers.delete(M),this._proxy.$unregisterTaskProvider(M)})}registerTaskSystem(z,N){this._proxy.$registerTaskSystem(z,N)}fetchTasks(z){return this._proxy.$fetchTasks(a.from(z)).then(async N=>{const W=[];for(let M of N){const j=await D.to(M,this._workspaceProvider,this._providedCustomExecutions2);j&&W.push(j)}return W})}get taskExecutions(){const z=[];return this._taskExecutions.forEach(N=>z.push(N)),z}terminateTask(z){if(!(z instanceof T))throw new Error("No valid task execution provided");return this._proxy.$terminateTask(z._id)}get onDidStartTask(){return this._onDidExecuteTask.event}async $onDidStartTask(z,N,W){const M=this._providedCustomExecutions2.get(z.id);if(M){if(this._activeCustomExecutions2.get(z.id)!==void 0)throw new Error("We should not be trying to start the same custom task executions twice.");this._activeCustomExecutions2.set(z.id,M),this._terminalService.attachPtyToTerminal(N,await M.callback(W))}this._lastStartedTask=z.id,this._onDidExecuteTask.fire({execution:await this.getTaskExecution(z)})}get onDidEndTask(){return this._onDidTerminateTask.event}async $OnDidEndTask(z){const N=await this.getTaskExecution(z);this._taskExecutionPromises.delete(z.id),this._taskExecutions.delete(z.id),this.customExecutionComplete(z),this._onDidTerminateTask.fire({execution:N})}get onDidStartTaskProcess(){return this._onDidTaskProcessStarted.event}async $onDidStartTaskProcess(z){const N=await this.getTaskExecution(z.id);this._onDidTaskProcessStarted.fire({execution:N,processId:z.processId})}get onDidEndTaskProcess(){return this._onDidTaskProcessEnded.event}async $onDidEndTaskProcess(z){const N=await this.getTaskExecution(z.id);this._onDidTaskProcessEnded.fire({execution:N,exitCode:z.exitCode})}$provideTasks(z,N){const W=this._handlers.get(z);if(!W)return Promise.reject(new Error("no handler found"));const M=[],j=R.asPromise(()=>W.provider.provideTasks(r.CancellationToken.None)).then(O=>this.provideTasksInternal(N,M,W,O));return new Promise(O=>{j.then(F=>{Promise.all(M).then(()=>{O(F)})})})}async $resolveTask(z,N){const W=this._handlers.get(z);if(!W)return Promise.reject(new Error("no handler found"));if(N.definition.type!==W.type)throw new Error(`Unexpected: Task of type [${N.definition.type}] cannot be resolved by provider of type [${W.type}].`);const M=await D.to(N,this._workspaceProvider,this._providedCustomExecutions2);if(!M)throw new Error("Unexpected: Task cannot be resolved.");const j=await W.provider.resolveTask(M,r.CancellationToken.None);if(!j)return;this.checkDeprecation(j,W);const O=D.from(j,W.extension);if(!O)throw new Error("Unexpected: Task cannot be resolved.");if(j.definition!==M.definition)throw new Error("Unexpected: The resolved task definition must be the same object as the original task definition. The task definition cannot be changed.");return m.is(O.execution)&&await this.addCustomExecution(O,j,!0),await this.resolveTaskInternal(O)}nextHandle(){return this._handleCounter++}async addCustomExecution(z,N,W){const M=await this._proxy.$createTaskId(z);!W&&!this._providedCustomExecutions2.has(M)&&this._notProvidedCustomExecutions.add(M),this._providedCustomExecutions2.set(M,N.execution)}async getTaskExecution(z,N){if(typeof z=="string"){const j=this._taskExecutionPromises.get(z);if(!j)throw new Error("Unexpected: The specified task is missing an execution");return j}let W=this._taskExecutionPromises.get(z.id);if(W)return W;const M=new Promise(async(j,O)=>{const F=N||await D.to(z.task,this._workspaceProvider,this._providedCustomExecutions2);F?j(new T(this,z.id,F)):O("Unexpected: Task does not exist.")});return this._taskExecutionPromises.set(z.id,M),M.then(j=>(this._taskExecutions.set(z.id,j),j),j=>Promise.reject(j))}checkDeprecation(z,N){z._deprecated&&this._deprecationService.report("Task.constructor",N.extension,"Use the Task constructor that takes a `scope` instead.")}customExecutionComplete(z){this._activeCustomExecutions2.get(z.id)&&this._activeCustomExecutions2.delete(z.id),this._notProvidedCustomExecutions.has(z.id)&&this._lastStartedTask!==z.id&&(this._providedCustomExecutions2.delete(z.id),this._notProvidedCustomExecutions.delete(z.id));let W=this._notProvidedCustomExecutions.values(),M=W.next();for(;!M.done;)!this._activeCustomExecutions2.has(M.value)&&this._lastStartedTask!==M.value&&(this._providedCustomExecutions2.delete(M.value),this._notProvidedCustomExecutions.delete(M.value)),M=W.next()}};U=Ve([We(0,l.IExtHostRpcService),We(1,f.IExtHostInitDataService),We(2,P.IExtHostWorkspace),We(3,E.IExtHostDocumentsAndEditors),We(4,k.IExtHostConfiguration),We(5,I.IExtHostTerminalService),We(6,w.ILogService),We(7,b.IExtHostApiDeprecationService)],U),e.ExtHostTaskBase=U;let G=class extends U{constructor(z,N,W,M,j,O,F,B){super(z,N,W,M,j,O,F,B);this.registerTaskSystem(u.Schemas.vscodeRemote,{scheme:u.Schemas.vscodeRemote,authority:"",platform:S.PlatformToString(0)})}async executeTask(z,N){if(!N.execution)throw new Error("Tasks to execute must include an execution");const W=D.from(N,z);if(W===void 0)throw new Error("Task is not valid");if(m.is(W.execution))await this.addCustomExecution(W,N,!1);else throw new h.NotSupportedError;const M=await this.getTaskExecution(await this._proxy.$getTaskExecution(W),N);return this._proxy.$executeTask(W).catch(j=>{throw new Error(j)}),M}provideTasksInternal(z,N,W,M){const j=[];if(M)for(let O of M){this.checkDeprecation(O,W),(!O.definition||!z[O.definition.type])&&this._logService.warn(`The task [${O.source}, ${O.name}] uses an undefined task type. The task will be ignored in the future.`);const F=D.from(O,W.extension);F&&m.is(F.execution)?(j.push(F),N.push(this.addCustomExecution(F,O,!0))):this._logService.warn("Only custom execution tasks supported.")}return{tasks:j,extension:W.extension}}async resolveTaskInternal(z){if(m.is(z.execution))return z;this._logService.warn("Only custom execution tasks supported.")}async $resolveVariables(z,N){return{process:void 0,variables:Object.create(null)}}async $jsonTasksSupported(){return!1}async $findExecutable(z,N,W){}};G=Ve([We(0,l.IExtHostRpcService),We(1,f.IExtHostInitDataService),We(2,P.IExtHostWorkspace),We(3,E.IExtHostDocumentsAndEditors),We(4,k.IExtHostConfiguration),We(5,I.IExtHostTerminalService),We(6,w.ILogService),We(7,b.IExtHostApiDeprecationService)],G),e.WorkerExtHostTask=G,e.IExtHostTask=c.createDecorator("IExtHostTask")}),define(me[254],ge([0,1,18,68,30,75,23,10,9,24,8,15,2,140,168,115,45,204,253,31]),function(X,e,p,R,C,y,A,P,E,k,r,I,l,f,c,u,S,w,b,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveResourcesForSearchIncludes=e.QueryBuilder=void 0;let h=class{constructor(_,D,a,T){this.configurationService=_,this.workspaceContextService=D,this.editorGroupsService=a,this.pathService=T}text(_,D,a={}){_=this.getContentPattern(_,a);const T=this.configurationService.getValue(),L=D&&D.some(G=>!this.configurationService.getValue({resource:G}).search.useRipgrep),U=this.commonQuery(D==null?void 0:D.map(S.toWorkspaceFolder),a);return Object.assign(Object.assign({},U),{type:2,contentPattern:_,previewOptions:a.previewOptions,maxFileSize:a.maxFileSize,usePCRE2:T.search.usePCRE2||L||!1,beforeContext:a.beforeContext,afterContext:a.afterContext,userDisabledExcludesAndIgnoreFiles:a.disregardExcludeSettings&&a.disregardIgnoreFiles})}getContentPattern(_,D){const a=this.configurationService.getValue();_.isRegExp&&(_.pattern=_.pattern.replace(/\r?\n/g,"\\n"));const T=Object.assign(Object.assign({},_),{wordSeparators:a.editor.wordSeparators});return this.isCaseSensitive(_,D)&&(T.isCaseSensitive=!0),this.isMultiline(_)&&(T.isMultiline=!0),T}file(_,D={}){const a=this.commonQuery(_,D);return Object.assign(Object.assign({},a),{type:1,filePattern:D.filePattern?D.filePattern.trim():D.filePattern,exists:D.exists,sortByScore:D.sortByScore,cacheKey:D.cacheKey})}handleIncludeExclude(_,D){return _?(_=Array.isArray(_)?_.map(n):n(_),D?this.parseSearchPaths(_):{pattern:t(...Array.isArray(_)?_:[_])}):{}}commonQuery(_=[],D={}){const a=this.handleIncludeExclude(D.includePattern,D.expandPatterns),T=this.handleIncludeExclude(D.excludePattern,D.expandPatterns),L=_.length>1,U=(a.searchPaths&&a.searchPaths.length?a.searchPaths.map(z=>this.getFolderQueryForSearchPath(z,D,T)):_.map(z=>this.getFolderQueryForRoot(z,D,T,L))).filter(z=>!!z),G={_reason:D._reason,folderQueries:U,usingSearchPaths:!!(a.searchPaths&&a.searchPaths.length),extraFileResources:D.extraFileResources,excludePattern:T.pattern,includePattern:a.pattern,onlyOpenEditors:D.onlyOpenEditors,maxResults:D.maxResults};if(D.onlyOpenEditors){const N=p.coalesce(p.flatten(this.editorGroupsService.groups.map(M=>M.editors.map(j=>j.resource)))).filter(M=>d.pathIncludedInQuery(G,M.fsPath)),W=this.commonQueryFromFileList(N);return Object.assign(Object.assign({},G),W)}const ee=D.extraFileResources&&D.extraFileResources.filter(z=>d.pathIncludedInQuery(G,z.fsPath));return G.extraFileResources=ee&&ee.length?ee:void 0,G}commonQueryFromFileList(_){const D=[],a=new A.ResourceMap,T={};let L=!1;return _.forEach(U=>{var G,ee;if(U.scheme===P.Schemas.walkThrough)return;if(k.isAbsolutePath(U)){const N=(ee=(G=this.workspaceContextService.getWorkspaceFolder(U))===null||G===void 0?void 0:G.uri)!==null&&ee!==void 0?ee:U.with({path:E.dirname(U.fsPath)});let W=a.get(N);W||(L=!0,W={folder:N,includePattern:{}},D.push(W),a.set(N,W));const M=E.relative(N.fsPath,U.fsPath);I.assertIsDefined(W.includePattern)[M.replace(/\\/g,"/")]=!0}else U.fsPath&&(L=!0,T[U.fsPath]=!0)}),{folderQueries:D,includePattern:T,usingSearchPaths:!0,excludePattern:L?void 0:{"**/*":!0}}}isCaseSensitive(_,D){if(D.isSmartCase){if(_.isRegExp){if(r.containsUppercaseCharacter(_.pattern,!0))return!0}else if(r.containsUppercaseCharacter(_.pattern))return!0}return!!_.isCaseSensitive}isMultiline(_){return _.isMultiline||_.isRegExp&&f.isMultilineRegexSource(_.pattern)||_.pattern.indexOf(`
`)>=0?!0:!!_.isMultiline}parseSearchPaths(_){const D=W=>E.isAbsolute(W)||/^\.\.?([\/\\]|$)/.test(W),T=(Array.isArray(_)?_:i(_)).map(W=>{const M=this.pathService.resolvedUserHome;return M?y.untildify(W,M.scheme===P.Schemas.file?M.fsPath:M.path):W}),L=R.groupBy(T,W=>D(W)?"searchPaths":"exprSegments"),U=(L.exprSegments||[]).map(W=>r.rtrim(W,"/")).map(W=>r.rtrim(W,"\\")).map(W=>(W[0]==="."&&(W="*"+W),s(W))),G={},ee=this.expandSearchPathPatterns(L.searchPaths||[]);ee&&ee.length&&(G.searchPaths=ee);const z=p.flatten(U),N=t(...z);return N&&(G.pattern=N),G}getExcludesForFolder(_,D){return D.disregardExcludeSettings?void 0:d.getExcludes(_,!D.disregardSearchExcludeSettings)}expandSearchPathPatterns(_){if(!_||!_.length)return[];const D=p.flatten(_.map(T=>{let{pathPortion:L,globPortion:U}=g(T);U&&(U=o(U));const G=this.expandOneSearchPath(L);return p.flatten(G.map(ee=>this.resolveOneSearchPathPattern(ee,U)))})),a=new Map;return D.forEach(T=>{const L=T.searchPath.toString(),U=a.get(L);U?T.pattern&&(U.pattern=U.pattern||{},U.pattern[T.pattern]=!0):a.set(L,{searchPath:T.searchPath,pattern:T.pattern?t(T.pattern):void 0})}),Array.from(a.values())}expandOneSearchPath(_){if(E.isAbsolute(_)){const D=this.workspaceContextService.getWorkspace().folders;return D[0]&&D[0].uri.scheme!==P.Schemas.file?[{searchPath:D[0].uri.with({path:_})}]:[{searchPath:l.URI.file(E.normalize(_))}]}if(this.workspaceContextService.getWorkbenchState()===2){const D=this.workspaceContextService.getWorkspace().folders[0].uri;if(_=n(_),_.startsWith("../")||_===".."){const T=E.posix.resolve(D.path,_);return[{searchPath:D.with({path:T})}]}const a=o(_);return[{searchPath:D,pattern:a}]}else{if(_==="./"||_===".\\")return[];{const D=_.replace(/^\.[\/\\]/,""),T=this.workspaceContextService.getWorkspace().folders.map(L=>{const U=D.match(new RegExp(`^${r.escapeRegExpCharacters(L.name)}(?:/(.*)|$)`));return U?{match:U,folder:L}:null}).filter(I.isDefined);if(T.length)return T.map(L=>{const U=L.match[1];return{searchPath:L.folder.uri,pattern:U&&o(U)}});{const L=_.match(/\.[\/\\](.+)[\/\\]?/),U=L?L[1]:_,G=c.localize(0,null,U);throw new Error(G)}}}}resolveOneSearchPathPattern(_,D){const a=_.pattern&&D?`${_.pattern}/${D}`:_.pattern||D,T=[{searchPath:_.searchPath,pattern:a}];return a&&!a.endsWith("**")&&T.push({searchPath:_.searchPath,pattern:a+"/**"}),T}getFolderQueryForSearchPath(_,D,a){const T=this.getFolderQueryForRoot(S.toWorkspaceFolder(_.searchPath),D,a,!1);return T?Object.assign(Object.assign({},T),{includePattern:_.pattern}):null}getFolderQueryForRoot(_,D,a,T){let L;const U=l.URI.isUri(_)?_:_.uri;if(a.searchPaths){const W=a.searchPaths.filter(M=>k.isEqual(M.searchPath,U))[0];if(W&&!W.pattern)return null;W&&(L=W.pattern)}const G=this.configurationService.getValue({resource:U}),ee=this.getExcludesForFolder(G,D),z=Object.assign(Object.assign({},ee||{}),L||{}),N=l.URI.isUri(_)?k.basename(_):_.name;return{folder:U,folderName:T?N:void 0,excludePattern:Object.keys(z).length>0?z:void 0,fileEncoding:G.files&&G.files.encoding,disregardIgnoreFiles:typeof D.disregardIgnoreFiles=="boolean"?D.disregardIgnoreFiles:!G.search.useIgnoreFiles,disregardGlobalIgnoreFiles:typeof D.disregardGlobalIgnoreFiles=="boolean"?D.disregardGlobalIgnoreFiles:!G.search.useGlobalIgnoreFiles,ignoreSymlinks:typeof D.ignoreSymlinks=="boolean"?D.ignoreSymlinks:!G.search.followSymlinks}}};h=Ve([We(0,u.IConfigurationService),We(1,S.IWorkspaceContextService),We(2,w.IEditorGroupsService),We(3,b.IPathService)],h),e.QueryBuilder=h;function g(m){const _=m.match(/[\*\{\}\(\)\[\]\?]/);if(_){const D=_.index,a=m.substr(0,D).match(/[/|\\][^/\\]*$/);if(a){let T=m.substr(0,a.index);return T.match(/[/\\]/)||(T+="/"),{pathPortion:T,globPortion:m.substr((a.index||0)+1)}}}return{pathPortion:m}}function t(...m){return m.length?m.reduce((_,D)=>(_[D]=!0,_),Object.create(null)):void 0}function i(m){return C.splitGlobAware(m,",").map(_=>_.trim()).filter(_=>!!_.length)}function s(m){return[`**/${m}/**`,`**/${m}`].map(D=>D.replace(/\*\*\/\*\*/g,"**"))}function n(m){return m.replace(/\\/g,"/")}function o(m){return n(m).replace(/^\.\//,"").replace(/\/+$/g,"")}function v(m,_){m=p.distinct(m,T=>T.toString());const D=[],a=_.getWorkspace();return m&&m.forEach(T=>{let L;if(_.getWorkbenchState()===2)L=k.relativePath(a.folders[0].uri,T),L&&L!=="."&&(L="./"+L);else{const U=_.getWorkspaceFolder(T);if(U){const G=U.name;if(a.folders.filter(z=>z.name===G).length===1){const z=k.relativePath(U.uri,T);z===""?L=`./${U.name}`:L=`./${U.name}/${z}`}else L=T.fsPath}}L&&D.push(L)}),D}e.resolveResourcesForSearchIncludes=v}),define(me[255],ge([0,1,24,2,21,14,4,254,31,45]),function(X,e,p,R,C,y,A,P,E,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checkGlobFileExists=e.checkActivateWorkspaceContainsExtension=void 0;const r=7e3;function I(u,S){const w=S.activationEvents;if(!w)return Promise.resolve(void 0);const b=[],d=[];for(const n of w)if(/^workspaceContains:/.test(n)){const o=n.substr("workspaceContains:".length);o.indexOf("*")>=0||o.indexOf("?")>=0||u.forceUsingSearch?d.push(o):b.push(o)}if(b.length===0&&d.length===0)return Promise.resolve(void 0);let h;const g=new Promise((n,o)=>{h=n}),t=n=>h({activationEvent:n}),i=Promise.all(b.map(n=>l(u,n,t))).then(()=>{}),s=f(u,S.identifier,d,t);return Promise.all([i,s]).then(()=>{h(void 0)}),g}e.checkActivateWorkspaceContainsExtension=I;async function l(u,S,w){for(const b of u.folders)if(await u.exists(p.joinPath(R.URI.revive(b),S))){w(`workspaceContains:${S}`);return}}async function f(u,S,w,b){if(w.length===0)return Promise.resolve(void 0);const d=new C.CancellationTokenSource,h=u.checkExists(u.folders,w,d.token),g=setTimeout(async()=>{d.cancel(),b(`workspaceContainsTimeout:${w.join(",")}`)},r);let t=!1;try{t=await h}catch(i){y.isPromiseCanceledError(i)||y.onUnexpectedError(i)}d.dispose(),clearTimeout(g),t&&b(`workspaceContains:${w.join(",")}`)}function c(u,S,w,b){const d=u.get(A.IInstantiationService),h=u.get(E.ISearchService),t=d.createInstance(P.QueryBuilder).file(S.map(i=>k.toWorkspaceFolder(R.URI.revive(i))),{_reason:"checkExists",includePattern:w,exists:!0});return h.fileSearch(t,b).then(i=>!!i.limitHit,i=>y.isPromiseCanceledError(i)?!1:Promise.reject(i))}e.checkGlobFileExists=c});var rt=this&&this.__classPrivateFieldSet||function(X,e,p,R,C){if(R==="m")throw new TypeError("Private method is not writable");if(R==="a"&&!C)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?X!==e||!C:!e.has(X))throw new TypeError("Cannot write private member to an object whose class did not declare it");return R==="a"?C.call(X,p):C?C.value=p:e.set(X,p),p},$e=this&&this.__classPrivateFieldGet||function(X,e,p,R){if(p==="a"&&!R)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?X!==e||!R:!e.has(X))throw new TypeError("Cannot read private member from an object whose class did not declare it");return p==="m"?R:p==="a"?R.call(X):R?R.value:e.get(X)};define(me[39],ge([0,1,159,9,66,24,16,6,23,2,12,5,36,215,87,35,34,213,14,26,22,191,7,116,4,27,88,13,79,47,33,3,255,85,193]),function(X,e,p,R,C,y,A,P,E,k,r,I,l,f,c,u,S,w,b,d,h,g,t,i,s,n,o,v,m,_,D,a,T,L,U){"use strict";var G,ee,z;Object.defineProperty(e,"__esModule",{value:!0}),e.Extension=e.IExtHostExtensionService=e.AbstractExtHostExtensionService=e.IHostUtils=void 0,e.IHostUtils=s.createDecorator("IHostUtils");let N=class Bn extends P.Disposable{constructor(O,F,B,$,Y,le,be,Le,Ie,Ue){super();this._onDidChangeRemoteConnectionData=this._register(new a.Emitter),this.onDidChangeRemoteConnectionData=this._onDidChangeRemoteConnectionData.event,this._hostUtils=F,this._extHostContext=B,this._initData=be,this._extHostWorkspace=$,this._extHostConfiguration=Y,this._logService=le,this._extHostTunnelService=Ie,this._extHostTerminalService=Ue,this._disposables=new P.DisposableStore,this._mainThreadWorkspaceProxy=this._extHostContext.getProxy(I.MainContext.MainThreadWorkspace),this._mainThreadTelemetryProxy=this._extHostContext.getProxy(I.MainContext.MainThreadTelemetry),this._mainThreadExtensionsProxy=this._extHostContext.getProxy(I.MainContext.MainThreadExtensionService),this._almostReadyToRunExtensions=new A.Barrier,this._readyToStartExtensionHost=new A.Barrier,this._readyToRunExtensions=new A.Barrier,this._eagerExtensionsActivated=new A.Barrier,this._registry=new w.ExtensionDescriptionRegistry(this._initData.extensions),this._storage=new c.ExtHostStorage(this._extHostContext),this._secretState=new L.ExtHostSecretState(this._extHostContext),this._storagePath=Le,this._instaService=O.createChild(new m.ServiceCollection([c.IExtHostStorage,this._storage],[L.IExtHostSecretState,this._secretState]));const Qe=new Set;this._initData.hostExtensions.forEach(ze=>Qe.add(d.ExtensionIdentifier.toKey(ze))),this._activator=new f.ExtensionsActivator(this._registry,this._initData.resolvedExtensions,this._initData.hostExtensions,{onExtensionActivationError:(ze,Ge,V)=>{this._mainThreadExtensionsProxy.$onExtensionActivationError(ze,b.transformErrorForSerialization(Ge),V)},actualActivateExtension:async(ze,Ge)=>{if(Qe.has(d.ExtensionIdentifier.toKey(ze)))return await this._mainThreadExtensionsProxy.$activateExtension(ze,Ge),new f.HostExtension;const V=this._registry.getExtensionDescription(ze);return this._activateExtension(V,Ge)}},this._logService),this._extensionPathIndex=null,this._resolvers=Object.create(null),this._started=!1,this._remoteConnectionData=this._initData.remote.connectionData}getRemoteConnectionData(){return this._remoteConnectionData}async initialize(){try{await this._beforeAlmostReadyToRunExtensions(),this._almostReadyToRunExtensions.open(),await this._extHostWorkspace.waitForInitializeCall(),C.mark("code/extHost/ready"),this._readyToStartExtensionHost.open(),this._initData.autoStart&&this._startExtensionHost()}catch(O){b.onUnexpectedError(O)}}async deactivateAll(){let O=[];try{O=this._registry.getAllExtensionDescriptions().map(Y=>Y.identifier).filter(Y=>this.isActivated(Y)).map(Y=>this._deactivate(Y))}catch(F){}await Promise.all(O)}isActivated(O){return this._readyToRunExtensions.isOpen()?this._activator.isActivated(O):!1}_activateByEvent(O,F){return this._activator.activateByEvent(O,F)}_activateById(O,F){return this._activator.activateById(O,F)}activateByIdWithErrors(O,F){return this._activateById(O,F).then(()=>{const B=this._activator.getActivatedExtension(O);if(B.activationFailed)return Promise.reject(B.activationFailedError)})}getExtensionRegistry(){return this._readyToRunExtensions.wait().then(O=>this._registry)}getExtensionExports(O){return this._readyToRunExtensions.isOpen()?this._activator.getActivatedExtension(O).exports:null}getExtensionPathIndex(){if(!this._extensionPathIndex){const O=E.TernarySearchTree.forPaths(),F=this._registry.getAllExtensionDescriptions().map(B=>{if(!!this._getEntryPoint(B))return this._hostUtils.realpath(B.extensionLocation.fsPath).then($=>O.set(k.URI.file($).fsPath,B))});this._extensionPathIndex=Promise.all(F).then(()=>O)}return this._extensionPathIndex}_deactivate(O){let F=Promise.resolve(void 0);if(!this._readyToRunExtensions.isOpen()||!this._activator.isActivated(O))return F;const B=this._activator.getActivatedExtension(O);if(!B)return F;try{typeof B.module.deactivate=="function"&&(F=Promise.resolve(B.module.deactivate()).then(void 0,$=>(this._logService.error($),Promise.resolve(void 0))))}catch($){this._logService.error($)}try{P.dispose(B.subscriptions)}catch($){this._logService.error($)}return F}async _activateExtension(O,F){return this._initData.remote.isRemote?this._mainThreadExtensionsProxy.$onWillActivateExtension(O.identifier):await this._mainThreadExtensionsProxy.$onWillActivateExtension(O.identifier),this._doActivateExtension(O,F).then(B=>{const $=B.activationTimes;return this._mainThreadExtensionsProxy.$onDidActivateExtension(O.identifier,$.codeLoadingTime,$.activateCallTime,$.activateResolvedTime,F),this._logExtensionActivationTimes(O,F,"success",$),B},B=>{throw this._logExtensionActivationTimes(O,F,"failure"),B})}_logExtensionActivationTimes(O,F,B,$){const Y=W(O,F);this._mainThreadTelemetryProxy.$publicLog2("extensionActivationTimes",Object.assign(Object.assign(Object.assign({},Y),$||{}),{outcome:B}))}_doActivateExtension(O,F){const B=W(O,F);this._mainThreadTelemetryProxy.$publicLog2("activatePlugin",B);const $=this._getEntryPoint(O);if(!$)return Promise.resolve(new f.EmptyExtension(f.ExtensionActivationTimes.NONE));this._logService.info(`ExtensionService#_doActivateExtension ${O.identifier.value} ${JSON.stringify(F)}`),this._logService.flush();const Y=new f.ExtensionActivationTimesBuilder(F.startup);return Promise.all([this._loadCommonJSModule(O.identifier,y.joinPath(O.extensionLocation,$),Y),this._loadExtensionContext(O)]).then(le=>(C.mark(`code/extHost/willActivateExtension/${O.identifier.value}`),Bn._callActivate(this._logService,O.identifier,le[0],le[1],Y))).then(le=>(C.mark(`code/extHost/didActivateExtension/${O.identifier.value}`),le))}_loadExtensionContext(O){const F=new g.ExtensionGlobalMemento(O,this._storage),B=new g.ExtensionMemento(O.identifier.value,!1,this._storage),$=new U.ExtensionSecrets(O,this._secretState),Y=O.isUnderDevelopment?this._initData.environment.extensionTestsLocationURI?t.ExtensionMode.Test:t.ExtensionMode.Development:t.ExtensionMode.Production,le=this._initData.remote.isRemote?t.ExtensionKind.Workspace:t.ExtensionKind.UI;return this._logService.trace(`ExtensionService#loadExtensionContext ${O.identifier.value}`),Promise.all([F.whenReady,B.whenReady,this._storagePath.whenReady]).then(()=>{const be=this;let Le;return Object.freeze({globalState:F,workspaceState:B,secrets:$,subscriptions:[],get extensionUri(){return O.extensionLocation},get extensionPath(){return O.extensionLocation.fsPath},asAbsolutePath(Ie){return R.join(O.extensionLocation.fsPath,Ie)},get storagePath(){var Ie;return(Ie=be._storagePath.workspaceValue(O))===null||Ie===void 0?void 0:Ie.fsPath},get globalStoragePath(){return be._storagePath.globalValue(O).fsPath},get logPath(){return R.join(be._initData.logsLocation.fsPath,O.identifier.value)},get logUri(){return k.URI.joinPath(be._initData.logsLocation,O.identifier.value)},get storageUri(){return be._storagePath.workspaceValue(O)},get globalStorageUri(){return be._storagePath.globalValue(O)},get extensionMode(){return Y},get extension(){return Le===void 0&&(Le=new M(be,O.identifier,O,le)),Le},get extensionRuntime(){return S.checkProposedApiEnabled(O),be.extensionRuntime},get environmentVariableCollection(){return be._extHostTerminalService.getEnvironmentVariableCollection(O)}})})}static _callActivate(O,F,B,$,Y){return B=B||{activate:void 0,deactivate:void 0},this._callActivateOptional(O,F,B,$,Y).then(le=>new f.ActivatedExtension(!1,null,Y.build(),B,le,$.subscriptions))}static _callActivateOptional(O,F,B,$,Y){if(typeof B.activate=="function")try{Y.activateCallStart(),O.trace(`ExtensionService#_callActivateOptional ${F.value}`);const le=typeof global=="object"?global:self,be=B.activate.apply(le,[$]);return Y.activateCallStop(),Y.activateResolveStart(),Promise.resolve(be).then(Le=>(Y.activateResolveStop(),Le))}catch(le){return Promise.reject(le)}else return Promise.resolve(B)}_activateOneStartupFinished(O,F){this._activateById(O.identifier,{startup:!1,extensionId:O.identifier,activationEvent:F}).then(void 0,B=>{this._logService.error(B)})}_activateAllStartupFinished(){this._mainThreadExtensionsProxy.$setPerformanceMarks(C.getMarks());for(const O of this._registry.getAllExtensionDescriptions())if(O.activationEvents)for(const F of O.activationEvents)F==="onStartupFinished"&&this._activateOneStartupFinished(O,F)}_handleEagerExtensions(){const O=this._activateByEvent("*",!0).then(void 0,Y=>{this._logService.error(Y)});this._disposables.add(this._extHostWorkspace.onDidChangeWorkspace(Y=>this._handleWorkspaceContainsEagerExtensions(Y.added)));const F=this._extHostWorkspace.workspace?this._extHostWorkspace.workspace.folders:[],B=this._handleWorkspaceContainsEagerExtensions(F),$=Promise.all([O,B]).then(()=>{});return Promise.race([$,A.timeout(1e4)]).then(()=>{this._activateAllStartupFinished()}),$}_handleWorkspaceContainsEagerExtensions(O){return O.length===0?Promise.resolve(void 0):Promise.all(this._registry.getAllExtensionDescriptions().map(F=>this._handleWorkspaceContainsEagerExtension(O,F))).then(()=>{})}async _handleWorkspaceContainsEagerExtension(O,F){if(this.isActivated(F.identifier))return;const B=!this._initData.remote.isRemote&&!!this._initData.remote.authority,$={folders:O.map(le=>le.uri),forceUsingSearch:B,exists:le=>this._hostUtils.exists(le.fsPath),checkExists:(le,be,Le)=>this._mainThreadWorkspaceProxy.$checkExists(le,be,Le)},Y=await T.checkActivateWorkspaceContainsExtension($,F);if(!!Y)return this._activateById(F.identifier,{startup:!0,extensionId:F.identifier,activationEvent:Y.activationEvent}).then(void 0,le=>this._logService.error(le))}async $extensionTestsExecute(){await this._eagerExtensionsActivated.wait();try{return await this._doHandleExtensionTests()}catch(O){throw console.error(O),O}}async _doHandleExtensionTests(){const{extensionDevelopmentLocationURI:O,extensionTestsLocationURI:F}=this._initData.environment;if(!O||!F)throw new Error(p.localize(0,null));const B=await this._loadCommonJSModule(null,F,new f.ExtensionActivationTimesBuilder(!1));if(!B||typeof B.run!="function")throw new Error(p.localize(1,null,F.toString()));return new Promise(($,Y)=>{const le=(Ie,Ue)=>{Ie?Y(Ie):$(typeof Ue=="number"&&Ue>0?1:0)},be=y.originalFSPath(F),Le=B.run(be,le);Le&&Le.then&&Le.then(()=>{$(0)}).catch(Ie=>{Y(Ie.toString())})})}async $extensionTestsExit(O){this._logService.info(`extension host terminating: test runner requested exit with code ${O}`),this._logService.info(`exiting with code ${O}`),this._logService.flush(),this._hostUtils.exit(O)}_startExtensionHost(){if(this._started)throw new Error("Extension host is already started!");return this._started=!0,this._readyToStartExtensionHost.wait().then(()=>this._readyToRunExtensions.open()).then(()=>this._handleEagerExtensions()).then(()=>{this._eagerExtensionsActivated.open(),this._logService.info("eager extensions activated")})}registerRemoteAuthorityResolver(O,F){return this._resolvers[O]=F,P.toDisposable(()=>{delete this._resolvers[O]})}async _activateAndGetResolver(O){const F=O.indexOf("+");if(F===-1)throw new Error("Not an authority that can be resolved!");const B=O.substr(0,F);return await this._almostReadyToRunExtensions.wait(),await this._activateByEvent(`onResolveRemoteAuthority:${B}`,!1),{authorityPrefix:B,resolver:this._resolvers[B]}}async $resolveAuthority(O,F){const{authorityPrefix:B,resolver:$}=await this._activateAndGetResolver(O);if(!$)return{type:"error",error:{code:i.RemoteAuthorityResolverErrorCode.NoResolverFound,message:`No remote extension installed to resolve ${B}.`,detail:void 0}};try{this._disposables.add(await this._extHostTunnelService.setTunnelExtensionFunctions($)),C.mark(`code/extHost/willResolveAuthority/${B}`);const Y=await $.resolve(O,{resolveAttempt:F});C.mark(`code/extHost/didResolveAuthorityOK/${B}`);const le={authority:O,host:Y.host,port:Y.port,connectionToken:Y.connectionToken},be={extensionHostEnv:Y.extensionHostEnv,isTrusted:Y.isTrusted};return{type:"ok",value:{authority:le,options:be,tunnelInformation:{environmentTunnels:Y.environmentTunnels}}}}catch(Y){if(C.mark(`code/extHost/didResolveAuthorityError/${B}`),Y instanceof t.RemoteAuthorityResolverError)return{type:"error",error:{code:Y._code,message:Y._message,detail:Y._detail}};throw Y}}async $getCanonicalURI(O,F){const{authorityPrefix:B,resolver:$}=await this._activateAndGetResolver(O);if(!$)throw new Error(`Cannot get canonical URI because no remote extension is installed to resolve ${B}`);const Y=k.URI.revive(F);if(typeof $.getCanonicalURI=="undefined")return Y;const le=await A.asPromise(()=>$.getCanonicalURI(Y));return le||Y}$startExtensionHost(O){return this._registry.keepOnly(O),this._startExtensionHost()}$activateByEvent(O,F){return F===1?this._activateByEvent(O,!1):this._readyToRunExtensions.wait().then(B=>this._activateByEvent(O,!1))}async $activate(O,F){return await this._readyToRunExtensions.wait(),this._registry.getExtensionDescription(O)?(await this._activateById(O,F),!0):!1}async $deltaExtensions(O,F){O.forEach($=>$.extensionLocation=k.URI.revive($.extensionLocation));const B=await this.getExtensionPathIndex();return await Promise.all(F.map(async $=>{const Y=this._registry.getExtensionDescription($);if(!Y)return;const le=await this._hostUtils.realpath(Y.extensionLocation.fsPath);B.delete(k.URI.file(le).fsPath)})),await Promise.all(O.map(async $=>{const Y=await this._hostUtils.realpath($.extensionLocation.fsPath);B.set(k.URI.file(Y).fsPath,$)})),this._registry.deltaExtensions(O,F),Promise.resolve(void 0)}async $test_latency(O){return O}async $test_up(O){return O.byteLength}async $test_down(O){let F=h.VSBuffer.alloc(O),B=Math.random()%256;for(let $=0;$<O;$++)F.writeUInt8(B,$);return F}async $updateRemoteConnectionData(O){this._remoteConnectionData=O,this._onDidChangeRemoteConnectionData.fire()}};N=Ve([We(0,s.IInstantiationService),We(1,e.IHostUtils),We(2,v.IExtHostRpcService),We(3,u.IExtHostWorkspace),We(4,l.IExtHostConfiguration),We(5,r.ILogService),We(6,n.IExtHostInitDataService),We(7,o.IExtensionStoragePaths),We(8,_.IExtHostTunnelService),We(9,D.IExtHostTerminalService)],N),e.AbstractExtHostExtensionService=N;function W(j,O){return{id:j.identifier.value,name:j.name,extensionVersion:j.version,publisherDisplayName:j.publisher,activationEvents:j.activationEvents?j.activationEvents.join(","):null,isBuiltin:j.isBuiltin,reason:O.activationEvent,reasonId:O.extensionId.value}}e.IExtHostExtensionService=s.createDecorator("IExtHostExtensionService");class M{constructor(O,F,B,$){G.set(this,void 0),ee.set(this,void 0),z.set(this,void 0),rt(this,G,O,"f"),rt(this,ee,F,"f"),rt(this,z,B.identifier,"f"),this.id=B.identifier.value,this.extensionUri=B.extensionLocation,this.extensionPath=R.normalize(y.originalFSPath(B.extensionLocation)),this.packageJSON=B,this.extensionKind=$}get isActive(){return $e(this,G,"f").isActivated($e(this,z,"f"))}get exports(){if(this.packageJSON.api!=="none")return $e(this,G,"f").getExtensionExports($e(this,z,"f"))}activate(){return $e(this,G,"f").activateByIdWithErrors($e(this,z,"f"),{startup:!1,extensionId:$e(this,ee,"f"),activationEvent:"api"}).then(()=>this.exports)}}e.Extension=M,G=new WeakMap,ee=new WeakMap,z=new WeakMap}),define(me[49],ge([0,1,9,2,3,16,5,7,120,35,39,42,203,36,198,13,4,15,37,46]),function(X,e,p,R,C,y,A,P,E,k,r,I,l,f,c,u,S,w,b,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostDebugService=e.ExtHostVariableResolverService=e.ExtHostDebugConsole=e.ExtHostDebugSession=e.ExtHostDebugServiceBase=e.IExtHostDebugService=void 0,e.IExtHostDebugService=S.createDecorator("IExtHostDebugService");let h=class{constructor(m,_,D,a,T,L){this._workspaceService=_,this._extensionService=D,this._editorsService=a,this._configurationService=T,this._editorTabs=L,this._debugSessions=new Map,this._configProviderHandleCounter=0,this._configProviders=[],this._adapterFactoryHandleCounter=0,this._adapterFactories=[],this._trackerFactoryHandleCounter=0,this._trackerFactories=[],this._debugAdapters=new Map,this._debugAdaptersTrackers=new Map,this._onDidStartDebugSession=new C.Emitter,this._onDidTerminateDebugSession=new C.Emitter,this._onDidChangeActiveDebugSession=new C.Emitter,this._onDidReceiveDebugSessionCustomEvent=new C.Emitter,this._debugServiceProxy=m.getProxy(A.MainContext.MainThreadDebugService),this._onDidChangeBreakpoints=new C.Emitter({onFirstListenerAdd:()=>{this.startBreakpoints()}}),this._activeDebugConsole=new t(this._debugServiceProxy),this._breakpoints=new Map,this._breakpointEventsActive=!1,this._extensionService.getExtensionRegistry().then(U=>{U.onDidChange(G=>{this.registerAllDebugTypes(U)}),this.registerAllDebugTypes(U)})}get onDidStartDebugSession(){return this._onDidStartDebugSession.event}get onDidTerminateDebugSession(){return this._onDidTerminateDebugSession.event}get onDidChangeActiveDebugSession(){return this._onDidChangeActiveDebugSession.event}get activeDebugSession(){return this._activeDebugSession}get onDidReceiveDebugSessionCustomEvent(){return this._onDidReceiveDebugSessionCustomEvent.event}get activeDebugConsole(){return this._activeDebugConsole.value}asDebugSourceUri(m,_){const D=m;if(typeof D.sourceReference=="number"&&D.sourceReference>0){let a=`debug:${encodeURIComponent(D.path||"")}`,T="?";return _&&(a+=`${T}session=${encodeURIComponent(_.id)}`,T="&"),a+=`${T}ref=${D.sourceReference}`,R.URI.parse(a)}else{if(D.path)return R.URI.file(D.path);throw new Error("cannot create uri from DAP 'source' object; properties 'path' and 'sourceReference' are both missing.")}}registerAllDebugTypes(m){const _=[];for(const D of m.getAllExtensionDescriptions())if(D.contributes){const a=D.contributes.debuggers;if(a&&a.length>0)for(const T of a)c.isDebuggerMainContribution(T)&&_.push(T.type)}this._debugServiceProxy.$registerDebugTypes(_)}get onDidChangeBreakpoints(){return this._onDidChangeBreakpoints.event}get breakpoints(){this.startBreakpoints();const m=[];return this._breakpoints.forEach(_=>m.push(_)),m}addBreakpoints(m){this.startBreakpoints();const _=m.filter(T=>{const L=T.id;return this._breakpoints.has(L)?!1:(this._breakpoints.set(L,T),!0)});this.fireBreakpointChanges(_,[],[]);const D=[],a=new Map;for(const T of _)if(T instanceof P.SourceBreakpoint){let L=a.get(T.location.uri.toString());L||(L={type:"sourceMulti",uri:T.location.uri,lines:[]},a.set(T.location.uri.toString(),L),D.push(L)),L.lines.push({id:T.id,enabled:T.enabled,condition:T.condition,hitCondition:T.hitCondition,logMessage:T.logMessage,line:T.location.range.start.line,character:T.location.range.start.character})}else T instanceof P.FunctionBreakpoint&&D.push({type:"function",id:T.id,enabled:T.enabled,hitCondition:T.hitCondition,logMessage:T.logMessage,condition:T.condition,functionName:T.functionName});return this._debugServiceProxy.$registerBreakpoints(D)}removeBreakpoints(m){this.startBreakpoints();const _=m.filter(L=>this._breakpoints.delete(L.id));this.fireBreakpointChanges([],_,[]);const D=_.filter(L=>L instanceof P.SourceBreakpoint).map(L=>L.id),a=_.filter(L=>L instanceof P.FunctionBreakpoint).map(L=>L.id),T=_.filter(L=>L instanceof P.DataBreakpoint).map(L=>L.id);return this._debugServiceProxy.$unregisterBreakpoints(D,a,T)}startDebugging(m,_,D){return this._debugServiceProxy.$startDebugging(m?m.uri:void 0,_,{parentSessionID:D.parentSession?D.parentSession.id:void 0,repl:D.consoleMode===P.DebugConsoleMode.MergeWithParent?"mergeWithParent":"separate",noDebug:D.noDebug,compact:D.compact})}stopDebugging(m){return this._debugServiceProxy.$stopDebugging(m?m.id:void 0)}registerDebugConfigurationProvider(m,_,D){if(!_)return new P.Disposable(()=>{});const a=this._configProviderHandleCounter++;return this._configProviders.push({type:m,handle:a,provider:_}),this._debugServiceProxy.$registerDebugConfigurationProvider(m,D,!!_.provideDebugConfigurations,!!_.resolveDebugConfiguration,!!_.resolveDebugConfigurationWithSubstitutedVariables,a),new P.Disposable(()=>{this._configProviders=this._configProviders.filter(T=>T.provider!==_),this._debugServiceProxy.$unregisterDebugConfigurationProvider(a)})}registerDebugAdapterDescriptorFactory(m,_,D){if(!D)return new P.Disposable(()=>{});if(!this.definesDebugType(m,_))throw new Error(`a DebugAdapterDescriptorFactory can only be registered from the extension that defines the '${_}' debugger.`);if(this.getAdapterDescriptorFactoryByType(_))throw new Error("a DebugAdapterDescriptorFactory can only be registered once per a type.");const a=this._adapterFactoryHandleCounter++;return this._adapterFactories.push({type:_,handle:a,factory:D}),this._debugServiceProxy.$registerDebugAdapterDescriptorFactory(_,a),new P.Disposable(()=>{this._adapterFactories=this._adapterFactories.filter(T=>T.factory!==D),this._debugServiceProxy.$unregisterDebugAdapterDescriptorFactory(a)})}registerDebugAdapterTrackerFactory(m,_){if(!_)return new P.Disposable(()=>{});const D=this._trackerFactoryHandleCounter++;return this._trackerFactories.push({type:m,handle:D,factory:_}),new P.Disposable(()=>{this._trackerFactories=this._trackerFactories.filter(a=>a.factory!==_)})}async $runInTerminal(m,_){return Promise.resolve(void 0)}async $substituteVariables(m,_){if(!this._variableResolver){const[T,L]=await Promise.all([this._workspaceService.getWorkspaceFolders2(),this._configurationService.getConfigProvider()]);this._variableResolver=this.createVariableResolver(T||[],this._editorsService,L)}let D;const a=await this.getFolder(m);return a&&(D={uri:a.uri,name:a.name,index:a.index,toResource:()=>{throw new Error("Not implemented")}}),this._variableResolver.resolveAnyAsync(D,_)}createDebugAdapter(m,_){if(m.type==="implementation")return new n(m.implementation)}createSignService(){}async $startDASession(m,_){const D=this,a=await this.getSession(_);return this.getAdapterDescriptor(this.getAdapterDescriptorFactoryByType(a.type),a).then(T=>{if(!T)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${a.type}' (extension might have failed to activate)`);const L=this.convertToDto(T),U=this.createDebugAdapter(L,a);if(!U)throw new Error(`Couldn't create a debug adapter for type '${a.type}'.`);const G=U;return this._debugAdapters.set(m,G),this.getDebugAdapterTrackers(a).then(ee=>(ee&&this._debugAdaptersTrackers.set(m,ee),G.onMessage(async z=>{if(z.type==="request"&&z.command==="handshake"){const N=z,W={type:"response",seq:0,command:N.command,request_seq:N.seq,success:!0};this._signService||(this._signService=this.createSignService());try{if(this._signService){const M=await this._signService.sign(N.arguments.value);W.body={signature:M},G.sendResponse(W)}else throw new Error("no signer")}catch(M){W.success=!1,W.message=M.message,G.sendResponse(W)}}else ee&&ee.onDidSendMessage&&ee.onDidSendMessage(z),z=c.convertToVSCPaths(z,!0),D._debugServiceProxy.$acceptDAMessage(m,z)}),G.onError(z=>{ee&&ee.onError&&ee.onError(z),this._debugServiceProxy.$acceptDAError(m,z.name,z.message,z.stack)}),G.onExit(z=>{ee&&ee.onExit&&ee.onExit(w.withNullAsUndefined(z),void 0),this._debugServiceProxy.$acceptDAExit(m,w.withNullAsUndefined(z),void 0)}),ee&&ee.onWillStartSession&&ee.onWillStartSession(),G.startSession()))})}$sendDAMessage(m,_){_=c.convertToDAPaths(_,!1);const D=this._debugAdaptersTrackers.get(m);D&&D.onWillReceiveMessage&&D.onWillReceiveMessage(_);const a=this._debugAdapters.get(m);a&&a.sendMessage(_)}$stopDASession(m){const _=this._debugAdaptersTrackers.get(m);this._debugAdaptersTrackers.delete(m),_&&_.onWillStopSession&&_.onWillStopSession();const D=this._debugAdapters.get(m);return this._debugAdapters.delete(m),D?D.stopSession():Promise.resolve(void 0)}$acceptBreakpointsDelta(m){const _=[],D=[],a=[];if(m.added)for(const T of m.added){const L=T.id;if(L&&!this._breakpoints.has(L)){let U;if(T.type==="function")U=new P.FunctionBreakpoint(T.functionName,T.enabled,T.condition,T.hitCondition,T.logMessage);else if(T.type==="data")U=new P.DataBreakpoint(T.label,T.dataId,T.canPersist,T.enabled,T.hitCondition,T.condition,T.logMessage);else{const G=R.URI.revive(T.uri);U=new P.SourceBreakpoint(new P.Location(G,new P.Position(T.line,T.character)),T.enabled,T.condition,T.hitCondition,T.logMessage)}U._id=L,this._breakpoints.set(L,U),_.push(U)}}if(m.removed)for(const T of m.removed){const L=this._breakpoints.get(T);L&&(this._breakpoints.delete(T),D.push(L))}if(m.changed){for(const T of m.changed)if(T.id){const L=this._breakpoints.get(T.id);if(L){if(L instanceof P.FunctionBreakpoint&&T.type==="function"){const U=L;U.enabled=T.enabled,U.condition=T.condition,U.hitCondition=T.hitCondition,U.logMessage=T.logMessage,U.functionName=T.functionName}else if(L instanceof P.SourceBreakpoint&&T.type==="source"){const U=L;U.enabled=T.enabled,U.condition=T.condition,U.hitCondition=T.hitCondition,U.logMessage=T.logMessage,U.location=new P.Location(R.URI.revive(T.uri),new P.Position(T.line,T.character))}a.push(L)}}}this.fireBreakpointChanges(_,D,a)}$provideDebugConfigurations(m,_,D){return y.asPromise(async()=>{const a=this.getConfigProviderByHandle(m);if(!a)throw new Error("no DebugConfigurationProvider found");if(!a.provideDebugConfigurations)throw new Error("DebugConfigurationProvider has no method provideDebugConfigurations");const T=await this.getFolder(_);return a.provideDebugConfigurations(T,D)}).then(a=>{if(!a)throw new Error("nothing returned from DebugConfigurationProvider.provideDebugConfigurations");return a})}$resolveDebugConfiguration(m,_,D,a){return y.asPromise(async()=>{const T=this.getConfigProviderByHandle(m);if(!T)throw new Error("no DebugConfigurationProvider found");if(!T.resolveDebugConfiguration)throw new Error("DebugConfigurationProvider has no method resolveDebugConfiguration");const L=await this.getFolder(_);return T.resolveDebugConfiguration(L,D,a)})}$resolveDebugConfigurationWithSubstitutedVariables(m,_,D,a){return y.asPromise(async()=>{const T=this.getConfigProviderByHandle(m);if(!T)throw new Error("no DebugConfigurationProvider found");if(!T.resolveDebugConfigurationWithSubstitutedVariables)throw new Error("DebugConfigurationProvider has no method resolveDebugConfigurationWithSubstitutedVariables");const L=await this.getFolder(_);return T.resolveDebugConfigurationWithSubstitutedVariables(L,D,a)})}async $provideDebugAdapter(m,_){const D=this.getAdapterDescriptorFactoryByHandle(m);if(!D)return Promise.reject(new Error("no adapter descriptor factory found for handle"));const a=await this.getSession(_);return this.getAdapterDescriptor(D,a).then(T=>{if(!T)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${a.type}'`);return this.convertToDto(T)})}async $acceptDebugSessionStarted(m){const _=await this.getSession(m);this._onDidStartDebugSession.fire(_)}async $acceptDebugSessionTerminated(m){const _=await this.getSession(m);_&&(this._onDidTerminateDebugSession.fire(_),this._debugSessions.delete(_.id))}async $acceptDebugSessionActiveChanged(m){this._activeDebugSession=m?await this.getSession(m):void 0,this._onDidChangeActiveDebugSession.fire(this._activeDebugSession)}async $acceptDebugSessionNameChanged(m,_){const D=await this.getSession(m);D&&D._acceptNameChanged(_)}async $acceptDebugSessionCustomEvent(m,_){const a={session:await this.getSession(m),event:_.event,body:_.body};this._onDidReceiveDebugSessionCustomEvent.fire(a)}convertToDto(m){if(m instanceof P.DebugAdapterExecutable)return{type:"executable",command:m.command,args:m.args,options:m.options};if(m instanceof P.DebugAdapterServer)return{type:"server",port:m.port,host:m.host};if(m instanceof P.DebugAdapterNamedPipeServer)return{type:"pipeServer",path:m.path};if(m instanceof P.DebugAdapterInlineImplementation)return{type:"implementation",implementation:m.implementation};throw new Error("convertToDto unexpected type")}getAdapterDescriptorFactoryByType(m){const _=this._adapterFactories.filter(D=>D.type===m);if(_.length>0)return _[0].factory}getAdapterDescriptorFactoryByHandle(m){const _=this._adapterFactories.filter(D=>D.handle===m);if(_.length>0)return _[0].factory}getConfigProviderByHandle(m){const _=this._configProviders.filter(D=>D.handle===m);if(_.length>0)return _[0].provider}definesDebugType(m,_){if(m.contributes){const D=m.contributes.debuggers;if(D&&D.length>0){for(const a of D)if(a.label&&a.type&&a.type===_)return!0}}return!1}getDebugAdapterTrackers(m){const D=m.configuration.type,a=this._trackerFactories.filter(T=>T.type===D||T.type==="*").map(T=>y.asPromise(()=>T.factory.createDebugAdapterTracker(m)).then(L=>L,L=>null));return Promise.race([Promise.all(a).then(T=>{const L=T.filter(U=>!!U);if(L.length>0)return new s(L)}),new Promise((T,L)=>{const U=setTimeout(()=>{clearTimeout(U),L(new Error("timeout"))},1e3)})]).catch(T=>{})}async getAdapterDescriptor(m,_){const D=_.configuration.debugServer;if(typeof D=="number")return Promise.resolve(new P.DebugAdapterServer(D));if(m){const T=await this._extensionService.getExtensionRegistry();return y.asPromise(()=>m.createDebugAdapterDescriptor(_,this.daExecutableFromPackage(_,T))).then(L=>{if(L)return L})}const a=await this._extensionService.getExtensionRegistry();return Promise.resolve(this.daExecutableFromPackage(_,a))}daExecutableFromPackage(m,_){}startBreakpoints(){this._breakpointEventsActive||(this._breakpointEventsActive=!0,this._debugServiceProxy.$startBreakpointEvents())}fireBreakpointChanges(m,_,D){(m.length>0||_.length>0||D.length>0)&&this._onDidChangeBreakpoints.fire(Object.freeze({added:m,removed:_,changed:D}))}async getSession(m){if(m)if(typeof m=="string"){const _=this._debugSessions.get(m);if(_)return _}else{let _=this._debugSessions.get(m.id);if(!_){const D=await this.getFolder(m.folderUri),a=m.parent?this._debugSessions.get(m.parent):void 0;_=new g(this._debugServiceProxy,m.id,m.type,m.name,D,m.configuration,a),this._debugSessions.set(_.id,_),this._debugServiceProxy.$sessionCached(_.id)}return _}throw new Error("cannot find session")}getFolder(m){if(m){const _=R.URI.revive(m);return this._workspaceService.resolveWorkspaceFolder(_)}return Promise.resolve(void 0)}};h=Ve([We(0,u.IExtHostRpcService),We(1,k.IExtHostWorkspace),We(2,r.IExtHostExtensionService),We(3,I.IExtHostDocumentsAndEditors),We(4,f.IExtHostConfiguration),We(5,d.IExtHostEditorTabs)],h),e.ExtHostDebugServiceBase=h;class g{constructor(m,_,D,a,T,L,U){this._debugServiceProxy=m,this._id=_,this._type=D,this._name=a,this._workspaceFolder=T,this._configuration=L,this._parentSession=U}get id(){return this._id}get type(){return this._type}get name(){return this._name}set name(m){this._name=m,this._debugServiceProxy.$setDebugSessionName(this._id,m)}get parentSession(){return this._parentSession}_acceptNameChanged(m){this._name=m}get workspaceFolder(){return this._workspaceFolder}get configuration(){return this._configuration}customRequest(m,_){return this._debugServiceProxy.$customDebugAdapterRequest(this._id,m,_)}getDebugProtocolBreakpoint(m){return this._debugServiceProxy.$getDebugProtocolBreakpoint(this._id,m.id)}}e.ExtHostDebugSession=g;class t{constructor(m){this.value=Object.freeze({append(_){m.$appendDebugConsole(_)},appendLine(_){this.append(_+`
`)}})}}e.ExtHostDebugConsole=t;class i extends l.AbstractVariableResolverService{constructor(m,_,D,a,T){function L(){if(_){const U=_.activeEditor();if(U)return U.document.uri;const G=a.tabs.filter(ee=>ee.isActive);if(G.length>0)return G[0].resource}}super({getFolderUri:U=>{const G=m.filter(ee=>ee.name===U);if(G&&G.length>0)return G[0].uri},getWorkspaceFolderCount:()=>m.length,getConfigurationValue:(U,G)=>D.getConfiguration(void 0,U).get(G),getAppRoot:()=>b.cwd(),getExecPath:()=>b.env.VSCODE_EXEC_PATH,getFilePath:()=>{const U=L();if(U)return p.normalize(U.fsPath)},getWorkspaceFolderPathForFile:()=>{if(T){const U=L();if(U){const G=T.getWorkspaceFolder(U);if(G)return p.normalize(G.uri.fsPath)}}},getSelectedText:()=>{if(_){const U=_.activeEditor();if(U&&!U.selection.isEmpty)return U.document.getText(U.selection)}},getLineNumber:()=>{if(_){const U=_.activeEditor();if(U)return String(U.selection.end.line+1)}}},void 0,Promise.resolve(b.env))}}e.ExtHostVariableResolverService=i;class s{constructor(m){this.trackers=m}onWillStartSession(){this.trackers.forEach(m=>m.onWillStartSession?m.onWillStartSession():void 0)}onWillReceiveMessage(m){this.trackers.forEach(_=>_.onWillReceiveMessage?_.onWillReceiveMessage(m):void 0)}onDidSendMessage(m){this.trackers.forEach(_=>_.onDidSendMessage?_.onDidSendMessage(m):void 0)}onWillStopSession(){this.trackers.forEach(m=>m.onWillStopSession?m.onWillStopSession():void 0)}onError(m){this.trackers.forEach(_=>_.onError?_.onError(m):void 0)}onExit(m,_){this.trackers.forEach(D=>D.onExit?D.onExit(m,_):void 0)}}class n extends E.AbstractDebugAdapter{constructor(m){super();this.implementation=m,m.onDidSendMessage(_=>{this.acceptMessage(_)})}startSession(){return Promise.resolve(void 0)}sendMessage(m){this.implementation.handleMessage(m)}stopSession(){return this.implementation.dispose(),Promise.resolve(void 0)}}let o=class extends h{constructor(m,_,D,a,T,L){super(m,_,D,a,T,L)}createVariableResolver(m,_,D){return new i(m,_,D,this._editorTabs)}};o=Ve([We(0,u.IExtHostRpcService),We(1,k.IExtHostWorkspace),We(2,r.IExtHostExtensionService),We(3,I.IExtHostDocumentsAndEditors),We(4,f.IExtHostConfiguration),We(5,d.IExtHostEditorTabs)],o),e.WorkerExtHostDebugService=o}),define(me[256],ge([0,1,66,2,5,36,34,26,13,27,4,39,37,12]),function(X,e,p,R,C,y,A,P,E,k,r,I,l,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequireInterceptor=void 0;let c=class{constructor(d,h,g,t,i,s,n){this._apiFactory=d,this._extensionRegistry=h,this._instaService=g,this._extHostConfiguration=t,this._extHostExtensionService=i,this._initData=s,this._logService=n,this._factories=new Map,this._alternatives=[]}async install(){this._installInterceptor(),p.mark("code/extHost/willWaitForConfig");const d=await this._extHostConfiguration.getConfigProvider();p.mark("code/extHost/didWaitForConfig");const h=await this._extHostExtensionService.getExtensionPathIndex();this.register(new u(this._apiFactory,h,this._extensionRegistry,d,this._logService)),this.register(this._instaService.createInstance(S)),this._initData.remote.isRemote&&this.register(this._instaService.createInstance(w,h,this._initData.environment.appUriScheme))}register(d){if(Array.isArray(d.nodeModuleName))for(let h of d.nodeModuleName)this._factories.set(h,d);else this._factories.set(d.nodeModuleName,d);typeof d.alternativeModuleName=="function"&&this._alternatives.push(h=>d.alternativeModuleName(h))}};c=Ve([We(2,r.IInstantiationService),We(3,y.IExtHostConfiguration),We(4,I.IExtHostExtensionService),We(5,k.IExtHostInitDataService),We(6,f.ILogService)],c),e.RequireInterceptor=c;class u{constructor(d,h,g,t,i){this._apiFactory=d,this._extensionPaths=h,this._extensionRegistry=g,this._configProvider=t,this._logService=i,this.nodeModuleName="vscode",this._extApiImpl=new Map}load(d,h){const g=this._extensionPaths.findSubstr(h.fsPath);if(g){let t=this._extApiImpl.get(P.ExtensionIdentifier.toKey(g.identifier));return t||(t=this._apiFactory(g,this._extensionRegistry,this._configProvider),this._extApiImpl.set(P.ExtensionIdentifier.toKey(g.identifier),t)),t}if(!this._defaultApiImpl){let t="";this._extensionPaths.forEach((i,s)=>t+=`	${s} -> ${i.identifier.value}
`),this._logService.warn(`Could not identify extension for 'vscode' require call from ${h.fsPath}. These are the extension path mappings: 
${t}`),this._defaultApiImpl=this._apiFactory(A.nullExtensionDescription,this._extensionRegistry,this._configProvider)}return this._defaultApiImpl}}let S=class{constructor(d,h){this.nodeModuleName="keytar";const{environment:g}=h,t=d.getProxy(C.MainContext.MainThreadKeytar);if(g.appRoot){let i=g.appRoot.fsPath;l.platform==="win32"&&(i=i.replace(/\\/g,"/")),i[i.length-1]==="/"&&(i=i.substr(0,i.length-1)),this.alternativeNames=new Set,this.alternativeNames.add(`${i}/node_modules.asar/keytar`),this.alternativeNames.add(`${i}/node_modules/keytar`)}this._impl={getPassword:(i,s)=>t.$getPassword(i,s),setPassword:(i,s,n)=>t.$setPassword(i,s,n),deletePassword:(i,s)=>t.$deletePassword(i,s),findPassword:i=>t.$findPassword(i),findCredentials(i){return t.$findCredentials(i)}}}load(d,h){return this._impl}alternativeModuleName(d){const h=d.length;if(h<=7||!this.alternativeNames)return;const g=h-7;if((d.charAt(g)==="/"||d.charAt(g)==="\\")&&d.endsWith("keytar")&&(d=d.replace(/\\/g,"/"),this.alternativeNames.has(d)))return"keytar"}};S=Ve([We(0,E.IExtHostRpcService),We(1,k.IExtHostInitDataService)],S);let w=class{constructor(d,h,g){this._extensionPaths=d,this._appUriScheme=h,this.nodeModuleName=["open","opn"],this._mainThreadTelemetry=g.getProxy(C.MainContext.MainThreadTelemetry);const t=g.getProxy(C.MainContext.MainThreadWindow);this._impl=(i,s)=>{const n=R.URI.parse(i);return s?this.callOriginal(i,s):n.scheme==="http"||n.scheme==="https"?t.$openUri(n,i,{allowTunneling:!0}):n.scheme==="mailto"||n.scheme===this._appUriScheme?t.$openUri(n,i,{}):this.callOriginal(i,s)}}load(d,h,g){const t=this._extensionPaths.findSubstr(h.fsPath);return t&&(this._extensionId=t.identifier.value,this.sendShimmingTelemetry()),this._original=g(d),this._impl}callOriginal(d,h){return this.sendNoForwardTelemetry(),this._original(d,h)}sendShimmingTelemetry(){!this._extensionId||this._mainThreadTelemetry.$publicLog2("shimming.open",{extension:this._extensionId})}sendNoForwardTelemetry(){!this._extensionId||this._mainThreadTelemetry.$publicLog2("shimming.open.call.noForward",{extension:this._extensionId})}};w=Ve([We(2,E.IExtHostRpcService)],w)}),define(me[257],ge([0,1,165,11,7,199,35,39,42,36,33,13,49,188,16,200,46]),function(X,e,p,R,C,y,A,P,E,k,r,I,l,f,c,u,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDebugService=void 0;let w=class extends l.ExtHostDebugServiceBase{constructor(h,g,t,i,s,n,o){super(h,g,t,i,s,o);this._terminalService=n,this._integratedTerminalInstances=new b}createDebugAdapter(h,g){switch(h.type){case"server":return new y.SocketDebugAdapter(h);case"pipeServer":return new y.NamedPipeDebugAdapter(h);case"executable":return new y.ExecutableDebugAdapter(h,g.type)}return super.createDebugAdapter(h,g)}daExecutableFromPackage(h,g){const t=y.ExecutableDebugAdapter.platformAdapterExecutable(g.getAllExtensionDescriptions(),h.type);if(t)return new C.DebugAdapterExecutable(t.command,t.args,t.options)}createSignService(){return new f.SignService}async $runInTerminal(h,g){if(h.kind==="integrated"){this._terminalDisposedListener||(this._terminalDisposedListener=this._terminalService.onDidCloseTerminal(L=>{this._integratedTerminalInstances.onTerminalClosed(L)}));const t=await this._configurationService.getConfigProvider(),i=this._terminalService.getDefaultShell(!0),s=this._terminalService.getDefaultShellArgs(!0),n=h.title||p.localize(0,null),o=JSON.stringify({shell:i,shellArgs:s});let v=await this._integratedTerminalInstances.checkout(o,n),m,_=!1;if(v)m=h.cwd;else{const L={shellPath:i,shellArgs:s,cwd:h.cwd,name:n};_=!0,v=this._terminalService.createTerminalFromOptions(L,{isFeatureTerminal:!0,useShellEnvironment:!0}),this._integratedTerminalInstances.insert(v,o)}v.show(!0);const D=await v.processId;_?await new Promise(L=>setTimeout(L,1e3)):t.getConfiguration("debug.terminal").get("clearBeforeReusing")&&(i.indexOf("powershell")>=0||i.indexOf("pwsh")>=0||i.indexOf("cmd.exe")>=0?v.sendText("cls"):i.indexOf("bash")>=0?v.sendText("clear"):R.isWindows?v.sendText("cls"):v.sendText("clear"));const a=u.prepareCommand(i,h.args,m,h.env);v.sendText(a);const T=this.onDidTerminateDebugSession(L=>{L.id===g&&(this._integratedTerminalInstances.free(v),T.dispose())});return D}else if(h.kind==="external")return u.runInExternalTerminal(h,await this._configurationService.getConfigProvider());return super.$runInTerminal(h,g)}createVariableResolver(h,g,t){return new l.ExtHostVariableResolverService(h,g,t,this._editorTabs,this._workspaceService)}};w=Ve([We(0,I.IExtHostRpcService),We(1,A.IExtHostWorkspace),We(2,P.IExtHostExtensionService),We(3,E.IExtHostDocumentsAndEditors),We(4,k.IExtHostConfiguration),We(5,r.IExtHostTerminalService),We(6,S.IExtHostEditorTabs)],w),e.ExtHostDebugService=w;class b{constructor(){this._terminalInstances=new Map}async checkout(h,g){const i=[...this._terminalInstances.entries()].map(([s,n])=>c.createCancelablePromise(async o=>{if(s.name!==g||n.lastUsedAt!==-1&&await u.hasChildProcesses(await s.processId))return null;const v=Date.now();return n.lastUsedAt+b.minUseDelay>v||o.isCancellationRequested||n.config!==h?null:(n.lastUsedAt=v,s)}));return await c.firstParallel(i,s=>!!s)}insert(h,g){this._terminalInstances.set(h,{lastUsedAt:Date.now(),config:g})}free(h){const g=this._terminalInstances.get(h);g&&(g.lastUsedAt=-1)}onTerminalClosed(h){this._terminalInstances.delete(h)}}b.minUseDelay=1e3}),define(me[258],ge([0,1,9,2,109,35,49,42,36,33,13,27,65,10,12,61,46]),function(X,e,p,R,C,y,A,P,E,k,r,I,l,f,c,u,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTask=void 0;let w=class extends l.ExtHostTaskBase{constructor(d,h,g,t,i,s,n,o,v){super(d,h,g,t,i,s,n,o);this.workspaceService=g,this.editorTabs=v,h.remote.isRemote&&h.remote.authority?this.registerTaskSystem(f.Schemas.vscodeRemote,{scheme:f.Schemas.vscodeRemote,authority:h.remote.authority,platform:process.platform}):this.registerTaskSystem(f.Schemas.file,{scheme:f.Schemas.file,authority:"",platform:process.platform}),this._proxy.$registerSupportedExecutions(!0,!0,!0)}async executeTask(d,h){const g=h;if(!h.execution&&g._id===void 0)throw new Error("Tasks to execute must include an execution");if(g._id!==void 0){const t=l.TaskHandleDTO.from(g,this.workspaceService),i=await this._proxy.$getTaskExecution(t);if(i.task===void 0)throw new Error("Task from execution DTO is undefined");const s=await this.getTaskExecution(i,h);return this._proxy.$executeTask(t).catch(()=>{}),s}else{const t=l.TaskDTO.from(h,d);if(t===void 0)return Promise.reject(new Error("Task is not valid"));l.CustomExecutionDTO.is(t.execution)&&await this.addCustomExecution(t,h,!1);const i=await this.getTaskExecution(await this._proxy.$getTaskExecution(t),h);return this._proxy.$executeTask(t).catch(()=>{}),i}}provideTasksInternal(d,h,g,t){const i=[];if(t)for(let s of t){this.checkDeprecation(s,g),(!s.definition||!d[s.definition.type])&&this._logService.warn(`The task [${s.source}, ${s.name}] uses an undefined task type. The task will be ignored in the future.`);const n=l.TaskDTO.from(s,g.extension);n&&(i.push(n),l.CustomExecutionDTO.is(n.execution)&&h.push(this.addCustomExecution(n,s,!0)))}return{tasks:i,extension:g.extension}}async resolveTaskInternal(d){return d}async getVariableResolver(d){if(this._variableResolver===void 0){const h=await this._configurationService.getConfigProvider();this._variableResolver=new A.ExtHostVariableResolverService(d,this._editorService,h,this.editorTabs,this.workspaceService)}return this._variableResolver}async $resolveVariables(d,h){const g=R.URI.revive(d),t={process:void 0,variables:Object.create(null)},i=await this._workspaceProvider.resolveWorkspaceFolder(g),s=await this._workspaceProvider.getWorkspaceFolders2();if(!s||!i)throw new Error("Unexpected: Tasks can only be run in a workspace folder");const n=await this.getVariableResolver(s),o={uri:i.uri,name:i.name,index:i.index,toResource:()=>{throw new Error("Not implemented")}};for(let v of h.variables)t.variables[v]=await n.resolveAsync(o,v);if(h.process!==void 0){let v;if(h.process.path!==void 0){v=h.process.path.split(p.delimiter);for(let m=0;m<v.length;m++)v[m]=await n.resolveAsync(o,v[m])}t.process=await C.win32.findExecutable(await n.resolveAsync(o,h.process.name),h.process.cwd!==void 0?await n.resolveAsync(o,h.process.cwd):void 0,v)}return t}async $jsonTasksSupported(){return!0}async $findExecutable(d,h,g){return C.win32.findExecutable(d,h,g)}};w=Ve([We(0,r.IExtHostRpcService),We(1,I.IExtHostInitDataService),We(2,y.IExtHostWorkspace),We(3,P.IExtHostDocumentsAndEditors),We(4,E.IExtHostConfiguration),We(5,k.IExtHostTerminalService),We(6,c.ILogService),We(7,u.IExtHostApiDeprecationService),We(8,S.IExtHostEditorTabs)],w),e.ExtHostTask=w}),define(me[259],ge([0,1,16,14,66,6,2,5,251,12,77,79,27,181,13,60,39,33]),function(X,e,p,R,C,y,A,P,E,k,r,I,l,f,c,u,S,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostMain=void 0;class b{constructor(h,g,t,i){this._disposables=new y.DisposableStore,this._isTerminating=!1,this._hostUtils=t,this._rpcProtocol=new E.RPCProtocol(h,null,i),g=b._transform(g,this._rpcProtocol);const s=new I.ServiceCollection(...r.getSingletonServiceDescriptors());s.set(l.IExtHostInitDataService,Object.assign({_serviceBrand:void 0},g)),s.set(c.IExtHostRpcService,new c.ExtHostRpcService(this._rpcProtocol)),s.set(u.IURITransformerService,new u.URITransformerService(i)),s.set(S.IHostUtils,t);const n=new f.InstantiationService(s,!0),o=n.invokeFunction(D=>D.get(w.IExtHostTerminalService));this._disposables.add(o),this._logService=n.invokeFunction(D=>D.get(k.ILogService)),C.mark("code/extHost/didCreateServices"),this._logService.info("extension host started"),this._logService.trace("initData",g),this._extensionService=n.invokeFunction(D=>D.get(S.IExtHostExtensionService)),this._extensionService.initialize(),Error.stackTraceLimit=100;const v=new WeakMap;this._extensionService.getExtensionPathIndex().then(D=>{Error.prepareStackTrace=(a,T)=>{let L="",U,G;for(const ee of T)L+=`
	at ${ee.toString()}`,G=ee.getFileName(),!U&&G&&(U=D.findSubstr(G));return v.set(a,U),`${a.name||"Error"}: ${a.message||""}${L}`}});const m=this._rpcProtocol.getProxy(P.MainContext.MainThreadExtensionService),_=this._rpcProtocol.getProxy(P.MainContext.MainThreadErrors);R.setUnexpectedErrorHandler(D=>{const a=R.transformErrorForSerialization(D),T=v.get(D);T?m.$onExtensionRuntimeError(T.identifier,a):_.$onUnexpectedError(a)})}terminate(h){if(this._isTerminating)return;this._isTerminating=!0,this._logService.info(`extension host terminating: ${h}`),this._logService.flush(),this._disposables.dispose(),R.setUnexpectedErrorHandler(t=>{this._logService.error(t)}),this._rpcProtocol.dispose();const g=this._extensionService.deactivateAll();setTimeout(()=>{Promise.race([p.timeout(4e3),g]).finally(()=>{this._logService.info("exiting with code 0"),this._logService.flush(),this._logService.dispose(),this._hostUtils.exit(0)})},1e3)}static _transform(h,g){h.extensions.forEach(i=>i.extensionLocation=A.URI.revive(g.transformIncomingURIs(i.extensionLocation))),h.environment.appRoot=A.URI.revive(g.transformIncomingURIs(h.environment.appRoot));const t=h.environment.extensionDevelopmentLocationURI;return t&&(h.environment.extensionDevelopmentLocationURI=t.map(i=>A.URI.revive(g.transformIncomingURIs(i)))),h.environment.extensionTestsLocationURI=A.URI.revive(g.transformIncomingURIs(h.environment.extensionTestsLocationURI)),h.environment.globalStorageHome=A.URI.revive(g.transformIncomingURIs(h.environment.globalStorageHome)),h.environment.workspaceStorageHome=A.URI.revive(g.transformIncomingURIs(h.environment.workspaceStorageHome)),h.logsLocation=A.URI.revive(g.transformIncomingURIs(h.logsLocation)),h.logFile=A.URI.revive(g.transformIncomingURIs(h.logFile)),h.workspace=g.transformIncomingURIs(h.workspace),h}}e.ExtensionHostMain=b}),define(me[260],ge([0,1,9,21,57,30,24,43,31]),function(X,e,p,R,C,y,A,P,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileSearchManager=void 0;class k{constructor(l,f,c){this.config=l,this.provider=f,this.sessionToken=c,this.isLimitHit=!1,this.resultCount=0,this.isCanceled=!1,this.filePattern=l.filePattern,this.includePattern=l.includePattern&&y.parse(l.includePattern),this.maxResults=l.maxResults||void 0,this.exists=l.exists,this.activeCancellationTokens=new Set,this.globalExcludePattern=l.excludePattern&&y.parse(l.excludePattern)}cancel(){this.isCanceled=!0,this.activeCancellationTokens.forEach(l=>l.cancel()),this.activeCancellationTokens=new Set}search(l){const f=this.config.folderQueries||[];return new Promise((c,u)=>{const S=w=>{this.resultCount++,l(w)};if(this.isCanceled)return c({limitHit:this.isLimitHit});this.config.extraFileResources&&this.config.extraFileResources.forEach(w=>{const b=w.toString(),d=p.basename(b);this.globalExcludePattern&&this.globalExcludePattern(b,d)||this.matchFile(S,{base:w,basename:d})}),Promise.all(f.map(w=>this.searchInFolder(w,S))).then(w=>{c({limitHit:this.isLimitHit,stats:w[0]||void 0})},w=>{u(new Error(C.toErrorMessage(w)))})})}async searchInFolder(l,f){const c=new R.CancellationTokenSource,u=this.getSearchOptionsForFolder(l),S=this.initDirectoryTree(),w=new E.QueryGlobTester(this.config,l),b=!w.hasSiblingExcludeClauses();let d;try{this.activeCancellationTokens.add(c),d=P.StopWatch.create();const h=await this.provider.provideFileSearchResults({pattern:this.config.filePattern||""},u,c.token),g=d.elapsed(),t=P.StopWatch.create();return this.isCanceled&&!this.isLimitHit||(h&&h.forEach(i=>{const s=p.posix.relative(l.folder.path,i.path);if(b){const n=p.basename(i.path);this.matchFile(f,{base:l.folder,relativePath:s,basename:n});return}this.addDirectoryEntries(S,l.folder,s,f)}),this.isCanceled&&!this.isLimitHit)?null:(this.matchDirectoryTree(S,w,f),{providerTime:g,postProcessTime:t.elapsed()})}finally{c.dispose(),this.activeCancellationTokens.delete(c)}}getSearchOptionsForFolder(l){const f=E.resolvePatternsForProvider(this.config.includePattern,l.includePattern),c=E.resolvePatternsForProvider(this.config.excludePattern,l.excludePattern);return{folder:l.folder,excludes:c,includes:f,useIgnoreFiles:!l.disregardIgnoreFiles,useGlobalIgnoreFiles:!l.disregardGlobalIgnoreFiles,followSymlinks:!l.ignoreSymlinks,maxResults:this.config.maxResults,session:this.sessionToken}}initDirectoryTree(){const l={rootEntries:[],pathToEntries:Object.create(null)};return l.pathToEntries["."]=l.rootEntries,l}addDirectoryEntries({pathToEntries:l},f,c,u){if(c===this.filePattern){const w=p.basename(this.filePattern);this.matchFile(u,{base:f,relativePath:this.filePattern,basename:w})}function S(w){const b=p.basename(w),d=p.dirname(w);let h=l[d];h||(h=l[d]=[],S(d)),h.push({base:f,relativePath:w,basename:b})}S(c)}matchDirectoryTree({rootEntries:l,pathToEntries:f},c,u){const S=this,w=this.filePattern;function b(d){const h=y.hasSiblingFn(()=>d.map(g=>g.basename));for(let g=0,t=d.length;g<t;g++){const i=d[g],{relativePath:s,basename:n}=i;if(!c.includedInQuerySync(s,n,w!==n?h:void 0))continue;const o=f[s];if(o)b(o);else{if(s===w)continue;S.matchFile(u,i)}if(S.isLimitHit)break}}b(l)}matchFile(l,f){(!this.includePattern||f.relativePath&&this.includePattern(f.relativePath,f.basename))&&((this.exists||this.maxResults&&this.resultCount>=this.maxResults)&&(this.isLimitHit=!0,this.cancel()),this.isLimitHit||l(f))}}class r{constructor(){this.sessions=new Map}fileSearch(l,f,c,u){const S=this.getSessionTokenSource(l.cacheKey),w=new k(l,f,S&&S.token);let b=0;const d=h=>{b+=h.length,c(h.map(g=>this.rawMatchToSearchItem(g)))};return this.doSearch(w,r.BATCH_SIZE,d,u).then(h=>({limitHit:h.limitHit,stats:{fromCache:!1,type:"fileSearchProvider",resultCount:b,detailStats:h.stats}}))}clearCache(l){const f=this.getSessionTokenSource(l);f&&f.cancel()}getSessionTokenSource(l){if(!!l)return this.sessions.has(l)||this.sessions.set(l,new R.CancellationTokenSource),this.sessions.get(l)}rawMatchToSearchItem(l){return l.relativePath?{resource:A.joinPath(l.base,l.relativePath)}:{resource:l.base}}doSearch(l,f,c,u){u.onCancellationRequested(()=>{l.cancel()});const S=b=>{b&&(w.push(b),f>0&&w.length>=f&&(c(w),w=[]))};let w=[];return l.search(S).then(b=>(w.length&&c(w),b),b=>(w.length&&c(w),Promise.reject(b)))}}e.FileSearchManager=r,r.BATCH_SIZE=512}),define(me[128],ge([0,1,9,18,21,57,24,30,2,31,10,15]),function(X,e,p,R,C,y,A,P,E,k,r,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BatchedCollector=e.extensionResultIsMatch=e.TextSearchResultsCollector=e.TextSearchManager=void 0;class l{constructor(d,h,g){this.query=d,this.provider=h,this.fileUtils=g,this.collector=null,this.isLimitHit=!1,this.resultCount=0}search(d,h){const g=this.query.folderQueries||[],t=new C.CancellationTokenSource;return h.onCancellationRequested(()=>t.cancel()),new Promise((i,s)=>{this.collector=new c(d);let n=!1;const o=(v,m)=>{if(!n&&!this.isLimitHit){const _=this.resultSize(v);S(v)&&typeof this.query.maxResults=="number"&&this.resultCount+_>this.query.maxResults&&(this.isLimitHit=!0,n=!0,t.cancel(),v=this.trimResultToSize(v,this.query.maxResults-this.resultCount));const D=this.resultSize(v);this.resultCount+=D,(D>0||!S(v))&&this.collector.add(v,m)}};Promise.all(g.map((v,m)=>this.searchInFolder(v,_=>o(_,m),t.token))).then(v=>{t.dispose(),this.collector.flush();const m=v.some(_=>!!_&&!!_.limitHit);i({limitHit:this.isLimitHit||m,messages:R.flatten(v.map(_=>(_==null?void 0:_.message)?I.isArray(_.message)?_.message:[_.message]:[])),stats:{type:"textSearchProvider"}})},v=>{t.dispose();const m=y.toErrorMessage(v);s(new Error(m))})})}resultSize(d){return S(d)?Array.isArray(d.ranges)?d.ranges.length:1:0}trimResultToSize(d,h){const g=Array.isArray(d.ranges)?d.ranges:[d.ranges],t=Array.isArray(d.preview.matches)?d.preview.matches:[d.preview.matches];return{ranges:g.slice(0,h),preview:{matches:t.slice(0,h),text:d.preview.text},uri:d.uri}}async searchInFolder(d,h,g){const t=new k.QueryGlobTester(this.query,d),i=[],s={report:v=>{if(!this.validateProviderResult(v))return;const m=d.folder.scheme===r.Schemas.file?P.hasSiblingPromiseFn(()=>this.fileUtils.readdir(A.dirname(v.uri))):void 0,_=A.relativePath(d.folder,v.uri);_&&i.push(t.includedInQuery(_,p.basename(_),m).then(D=>{D&&h(v)}))}},n=this.getSearchOptionsForFolder(d),o=await this.provider.provideTextSearchResults(f(this.query.contentPattern),n,s,g);return await Promise.all(i),o}validateProviderResult(d){if(S(d)){if(Array.isArray(d.ranges)){if(!Array.isArray(d.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same type."),!1;if(d.preview.matches.length!==d.ranges.length)return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}else if(Array.isArray(d.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}return!0}getSearchOptionsForFolder(d){const h=k.resolvePatternsForProvider(this.query.includePattern,d.includePattern),g=k.resolvePatternsForProvider(this.query.excludePattern,d.excludePattern),t={folder:E.URI.from(d.folder),excludes:g,includes:h,useIgnoreFiles:!d.disregardIgnoreFiles,useGlobalIgnoreFiles:!d.disregardGlobalIgnoreFiles,followSymlinks:!d.ignoreSymlinks,encoding:d.fileEncoding&&this.fileUtils.toCanonicalName(d.fileEncoding),maxFileSize:this.query.maxFileSize,maxResults:this.query.maxResults,previewOptions:this.query.previewOptions,afterContext:this.query.afterContext,beforeContext:this.query.beforeContext};return t.usePCRE2=this.query.usePCRE2,t}}e.TextSearchManager=l;function f(b){return{isCaseSensitive:b.isCaseSensitive||!1,isRegExp:b.isRegExp||!1,isWordMatch:b.isWordMatch||!1,isMultiline:b.isMultiline||!1,pattern:b.pattern}}class c{constructor(d){this._onResult=d,this._currentFolderIdx=-1,this._currentFileMatch=null,this._batchedCollector=new w(512,h=>this.sendItems(h))}add(d,h){this._currentFileMatch&&(this._currentFolderIdx!==h||!A.isEqual(this._currentUri,d.uri))&&(this.pushToCollector(),this._currentFileMatch=null),this._currentFileMatch||(this._currentFolderIdx=h,this._currentFileMatch={resource:d.uri,results:[]}),this._currentFileMatch.results.push(u(d))}pushToCollector(){const d=this._currentFileMatch&&this._currentFileMatch.results?this._currentFileMatch.results.length:0;this._batchedCollector.addItem(this._currentFileMatch,d)}flush(){this.pushToCollector(),this._batchedCollector.flush()}sendItems(d){this._onResult(d)}}e.TextSearchResultsCollector=c;function u(b){return S(b)?{preview:{matches:R.mapArrayOrNot(b.preview.matches,d=>({startLineNumber:d.start.line,startColumn:d.start.character,endLineNumber:d.end.line,endColumn:d.end.character})),text:b.preview.text},ranges:R.mapArrayOrNot(b.ranges,d=>({startLineNumber:d.start.line,startColumn:d.start.character,endLineNumber:d.end.line,endColumn:d.end.character}))}:{text:b.text,lineNumber:b.lineNumber}}function S(b){return!!b.preview}e.extensionResultIsMatch=S;class w{constructor(d,h){this.maxBatchSize=d,this.cb=h,this.totalNumberCompleted=0,this.batch=[],this.batchSize=0}addItem(d,h){!d||this.addItemToBatch(d,h)}addItems(d,h){!d||this.addItemsToBatch(d,h)}addItemToBatch(d,h){this.batch.push(d),this.batchSize+=h,this.onUpdate()}addItemsToBatch(d,h){this.batch=this.batch.concat(d),this.batchSize+=h,this.onUpdate()}onUpdate(){this.totalNumberCompleted<w.START_BATCH_AFTER_COUNT?this.flush():this.batchSize>=this.maxBatchSize?this.flush():this.timeoutHandle||(this.timeoutHandle=setTimeout(()=>{this.flush()},w.TIMEOUT))}flush(){this.batchSize&&(this.totalNumberCompleted+=this.batchSize,this.cb(this.batch),this.batch=[],this.batchSize=0,this.timeoutHandle&&(clearTimeout(this.timeoutHandle),this.timeoutHandle=0))}}e.BatchedCollector=w,w.TIMEOUT=4e3,w.START_BATCH_AFTER_COUNT=50}),define(me[67],ge([0,1,6,5,4,260,13,60,12,2,128]),function(X,e,p,R,C,y,A,P,E,k,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.reviveQuery=e.ExtHostSearch=e.IExtHostSearch=void 0,e.IExtHostSearch=C.createDecorator("IExtHostSearch");let I=class{constructor(u,S,w){this.extHostRpc=u,this._uriTransformer=S,this._logService=w,this._proxy=this.extHostRpc.getProxy(R.MainContext.MainThreadSearch),this._handlePool=0,this._textSearchProvider=new Map,this._textSearchUsedSchemes=new Set,this._fileSearchProvider=new Map,this._fileSearchUsedSchemes=new Set,this._fileSearchManager=new y.FileSearchManager}_transformScheme(u){return this._uriTransformer.transformOutgoingScheme(u)}registerTextSearchProvider(u,S){if(this._textSearchUsedSchemes.has(u))throw new Error(`a text search provider for the scheme '${u}' is already registered`);this._textSearchUsedSchemes.add(u);const w=this._handlePool++;return this._textSearchProvider.set(w,S),this._proxy.$registerTextSearchProvider(w,this._transformScheme(u)),p.toDisposable(()=>{this._textSearchUsedSchemes.delete(u),this._textSearchProvider.delete(w),this._proxy.$unregisterProvider(w)})}registerFileSearchProvider(u,S){if(this._fileSearchUsedSchemes.has(u))throw new Error(`a file search provider for the scheme '${u}' is already registered`);this._fileSearchUsedSchemes.add(u);const w=this._handlePool++;return this._fileSearchProvider.set(w,S),this._proxy.$registerFileSearchProvider(w,this._transformScheme(u)),p.toDisposable(()=>{this._fileSearchUsedSchemes.delete(u),this._fileSearchProvider.delete(w),this._proxy.$unregisterProvider(w)})}$provideFileSearchResults(u,S,w,b){const d=l(w),h=this._fileSearchProvider.get(u);if(h)return this._fileSearchManager.fileSearch(d,h,g=>{this._proxy.$handleFileMatch(u,S,g.map(t=>t.resource))},b);throw new Error("unknown provider: "+u)}$clearCache(u){return this._fileSearchManager.clearCache(u),Promise.resolve(void 0)}$provideTextSearchResults(u,S,w,b){const d=this._textSearchProvider.get(u);if(!d||!d.provideTextSearchResults)throw new Error(`Unknown provider ${u}`);const h=l(w);return this.createTextSearchManager(h,d).search(t=>this._proxy.$handleTextMatch(u,S,t),b)}createTextSearchManager(u,S){return new r.TextSearchManager(u,S,{readdir:w=>Promise.resolve([]),toCanonicalName:w=>w})}};I=Ve([We(0,A.IExtHostRpcService),We(1,P.IURITransformerService),We(2,E.ILogService)],I),e.ExtHostSearch=I;function l(c){return Object.assign(Object.assign({},c),{folderQueries:c.folderQueries&&c.folderQueries.map(f),extraFileResources:c.extraFileResources&&c.extraFileResources.map(u=>k.URI.revive(u))})}e.reviveQuery=l;function f(c){return Object.assign(Object.assign({},c),{folder:k.URI.revive(c.folder)})}}),define(me[261],ge([0,1,21,14,3,54,2,150,105,141,76,41,5,221,220,48,222,36,223,224,225,206,226,42,39,227,207,229,230,231,62,209,236,237,238,87,33,240,210,17,7,243,63,127,35,34,68,197,228,81,126,65,49,67,12,60,13,27,232,195,47,61,218,241,194,88,86,246,244,245,219,59,239,242,85,46,117,234,64,235,10,183,233,192]),function(X,e,p,R,C,y,A,P,E,k,r,I,l,f,c,u,S,w,b,d,h,g,t,i,s,n,o,v,m,_,D,a,T,L,U,G,ee,z,N,W,M,j,O,F,B,$,Y,le,be,Le,Ie,Ue,Qe,ze,Ge,V,Z,ne,se,J,ae,he,Fe,He,_e,Ye,K,ie,ve,Me,xe,Je,ke,ye,Ae,oe,ue,fe,we,q,pe,Se,Te,Oe){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createApiFactoryAndRegisterActors=void 0;function je(qe){const Ze=qe.get(ne.IExtHostInitDataService),nt=qe.get(Je.IExtHostFileSystemInfo),ct=qe.get(K.IExtHostConsumerFileSystem),Ee=qe.get(s.IExtHostExtensionService),Ce=qe.get(B.IExtHostWorkspace),ce=qe.get(ue.IExtHostTelemetry),Q=qe.get(w.IExtHostConfiguration),Be=qe.get(V.IURITransformerService),De=qe.get(Z.IExtHostRpcService),Ke=qe.get(G.IExtHostStorage),et=qe.get(Ye.IExtensionStoragePaths),tt=qe.get(Ge.ILogService),st=qe.get(ae.IExtHostTunnelService),pt=qe.get(he.IExtHostApiDeprecationService),wt=qe.get(F.IExtHostWindow),Et=qe.get(Ae.IExtHostSecretState),vt=qe.get(oe.IExtHostEditorTabs);De.set(l.ExtHostContext.ExtHostFileSystemInfo,nt),De.set(l.ExtHostContext.ExtHostLogService,tt),De.set(l.ExtHostContext.ExtHostWorkspace,Ce),De.set(l.ExtHostContext.ExtHostConfiguration,Q),De.set(l.ExtHostContext.ExtHostExtensionService,Ee),De.set(l.ExtHostContext.ExtHostStorage,Ke),De.set(l.ExtHostContext.ExtHostTunnelService,st),De.set(l.ExtHostContext.ExtHostWindow,wt),De.set(l.ExtHostContext.ExtHostSecretState,Et),De.set(l.ExtHostContext.ExtHostTelemetry,ce),De.set(l.ExtHostContext.ExtHostEditorTabs,vt);const Bt=De.set(l.ExtHostContext.ExtHostDecorations,qe.get(Ie.IExtHostDecorations)),_t=De.set(l.ExtHostContext.ExtHostDocumentsAndEditors,qe.get(i.IExtHostDocumentsAndEditors)),ht=De.set(l.ExtHostContext.ExtHostCommands,qe.get(u.IExtHostCommands)),ut=De.set(l.ExtHostContext.ExtHostTerminalService,qe.get(ee.IExtHostTerminalService)),ft=De.set(l.ExtHostContext.ExtHostDebugService,qe.get(Qe.IExtHostDebugService)),Ht=De.set(l.ExtHostContext.ExtHostSearch,qe.get(ze.IExtHostSearch)),kt=De.set(l.ExtHostContext.ExtHostTask,qe.get(Ue.IExtHostTask)),At=De.set(l.ExtHostContext.ExtHostOutputService,qe.get(D.IExtHostOutputService)),Kt=De.set(l.ExtHostContext.ExtHostUrls,new j.ExtHostUrls(De)),St=De.set(l.ExtHostContext.ExtHostDocuments,new t.ExtHostDocuments(De,_t)),en=De.set(l.ExtHostContext.ExtHostDocumentContentProviders,new h.ExtHostDocumentContentProvider(De,_t,tt)),tn=De.set(l.ExtHostContext.ExtHostDocumentSaveParticipant,new g.ExtHostDocumentSaveParticipant(tt,St,De.getProxy(l.MainContext.MainThreadBulkEdits))),gt=De.set(l.ExtHostContext.ExtHostNotebook,new se.ExtHostNotebookController(De,ht,_t,St,et)),Qt=De.set(l.ExtHostContext.ExtHostNotebookDocuments,new Oe.ExtHostNotebookDocuments(tt,gt)),zt=De.set(l.ExtHostContext.ExtHostNotebookEditors,new Te.ExtHostNotebookEditors(tt,De,gt)),nn=De.set(l.ExtHostContext.ExtHostNotebookKernels,new fe.ExtHostNotebookKernels(De,Ze,gt,tt)),En=De.set(l.ExtHostContext.ExtHostNotebookRenderers,new q.ExtHostNotebookRenderers(De,gt)),Dt=De.set(l.ExtHostContext.ExtHostEditors,new z.ExtHostEditors(De,_t)),Xt=De.set(l.ExtHostContext.ExtHostTreeViews,new N.ExtHostTreeViews(De.getProxy(l.MainContext.MainThreadTreeViews),ht,tt)),rn=De.set(l.ExtHostContext.ExtHostEditorInsets,new le.ExtHostEditorInsets(De.getProxy(l.MainContext.MainThreadEditorInsets),Dt,Ze)),$t=De.set(l.ExtHostContext.ExtHostDiagnostics,new b.ExtHostDiagnostics(De,tt)),dt=De.set(l.ExtHostContext.ExtHostLanguageFeatures,new v.ExtHostLanguageFeatures(De,Be,St,ht,$t,tt,pt)),sn=De.set(l.ExtHostContext.ExtHostFileSystem,new n.ExtHostFileSystem(De,dt)),Tt=De.set(l.ExtHostContext.ExtHostFileSystemEventService,new o.ExtHostFileSystemEventService(De,tt,_t)),Vt=De.set(l.ExtHostContext.ExtHostQuickOpen,T.createExtHostQuickOpen(De,Ce,ht)),hn=De.set(l.ExtHostContext.ExtHostSCM,new L.ExtHostSCM(De,ht,tt)),_n=De.set(l.ExtHostContext.ExtHostComments,new S.ExtHostComments(De,ht,St)),fn=De.set(l.ExtHostContext.ExtHostProgress,new a.ExtHostProgress(De.getProxy(l.MainContext.MainThreadProgress))),Sn=De.set(l.ExtHostContext.ExtHosLabelService,new be.ExtHostLabelService(De)),Yt=De.set(l.ExtHostContext.ExtHostTheming,new J.ExtHostTheming(De)),Ft=De.set(l.ExtHostContext.ExtHostAuthentication,new Fe.ExtHostAuthentication(De)),yn=De.set(l.ExtHostContext.ExtHostTimeline,new He.ExtHostTimeline(De,ht)),on=De.set(l.ExtHostContext.ExtHostWebviews,new O.ExtHostWebviews(De,{remote:Ze.remote},Ce,tt,pt)),an=De.set(l.ExtHostContext.ExtHostWebviewPanels,new Me.ExtHostWebviewPanels(De,on,Ce)),Dn=De.set(l.ExtHostContext.ExtHostCustomEditors,new ve.ExtHostCustomEditors(De,St,et,on,an)),Jt=De.set(l.ExtHostContext.ExtHostWebviewViews,new ie.ExtHostWebviewViews(De,on)),jt=De.set(l.ExtHostContext.ExtHostTesting,new ke.ExtHostTesting(De,ht)),Cn=De.set(l.ExtHostContext.ExtHostUriOpeners,new ye.ExtHostUriOpeners(De)),ln=Y.values(l.ExtHostContext);De.assertRegistered(ln);const kn=new xe.ExtHostBulkEdits(De,_t),qt=new c.ExtHostClipboard(De),Rt=new _.ExtHostMessageService(De,tt),mn=new d.ExtHostDialogs(De),It=new U.ExtHostStatusBar(De,ht.converter),Wt=new m.ExtHostLanguages(De,St);return f.ExtHostApiCommands.register(ht),function(Ne,cn,gn){const mt=function(){let te=!Ne.isUnderDevelopment;function de(Re){te||(tt.info(`Extension '${Ne.identifier.value}' uses a document selector without scheme. Learn more about this: https://go.microsoft.com/fwlink/?linkid=872305`),te=!0)}return function Re(at){if(Array.isArray(at))at.forEach(Re);else if(typeof at=="string")de(at);else{const bt=at;typeof bt.scheme=="undefined"&&de(at),!Ne.enableProposedApi&&typeof bt.exclusive=="boolean"&&$.throwProposedApiError(Ne)}return at}}(),Pn={getSession(te,de,Re){return Ft.getSession(Ne,te,de,Re)},get onDidChangeSessions(){return Ft.onDidChangeSessions},registerAuthenticationProvider(te,de,Re,at){return Ft.registerAuthenticationProvider(te,de,Re,at)},get onDidChangeAuthenticationProviders(){return $.checkProposedApiEnabled(Ne),Ft.onDidChangeAuthenticationProviders},get providers(){return $.checkProposedApiEnabled(Ne),Ft.providers},logout(te,de){return $.checkProposedApiEnabled(Ne),Ft.removeSession(te,de)}},In={registerCommand(te,de,Re){return ht.registerCommand(!0,te,de,Re)},registerTextEditorCommand(te,de,Re){return ht.registerCommand(!0,te,(...at)=>{const bt=Dt.getActiveTextEditor();if(!bt){tt.warn("Cannot execute "+te+" because there is no active text editor.");return}return bt.edit(Ct=>{de.apply(Re,[bt,Ct,...at])}).then(Ct=>{Ct||tt.warn("Edits from command "+te+" were not applied.")},Ct=>{tt.warn("An error occurred while running command "+te,Ct)})})},registerDiffInformationCommand:(te,de,Re)=>($.checkProposedApiEnabled(Ne),ht.registerCommand(!0,te,async(...at)=>{const bt=_t.activeEditor(!0);if(!bt){tt.warn("Cannot execute "+te+" because there is no active text editor.");return}const Ct=await Dt.getDiffInformation(bt.id);de.apply(Re,[Ct,...at])})),executeCommand(te,...de){return ht.executeCommand(te,...de)},getCommands(te=!1){return ht.getCommands(te)}},pn={get machineId(){return Ze.telemetryInfo.machineId},get sessionId(){return Ze.telemetryInfo.sessionId},get language(){return Ze.environment.appLanguage},get appName(){return Ze.environment.appName},get appRoot(){var te,de;return(de=(te=Ze.environment.appRoot)===null||te===void 0?void 0:te.fsPath)!==null&&de!==void 0?de:""},get uriScheme(){return Ze.environment.appUriScheme},get clipboard(){return qt.value},get shell(){return ut.getDefaultShell(!1)},get isTelemetryEnabled(){return ce.getTelemetryEnabled()},get onDidChangeTelemetryEnabled(){return ce.onDidChangeTelemetryEnabled},get isNewAppInstall(){const te=Date.now()-new Date(Ze.telemetryInfo.firstSessionDate).getTime();return isNaN(te)?!1:te<1e3*60*60*24},openExternal(te,de){return wt.openUri(te,{allowTunneling:!!Ze.remote.authority,allowContributedOpeners:de==null?void 0:de.allowContributedOpeners})},async asExternalUri(te){if(te.scheme===Ze.environment.appUriScheme)return Kt.createAppUri(te);const de=Se.matchesScheme(te,pe.Schemas.http)||Se.matchesScheme(te,pe.Schemas.https);de||$.checkProposedApiEnabled(Ne);try{return await wt.asExternalUri(te,{allowTunneling:!!Ze.remote.authority})}catch(Re){if(de)return te;throw Re}},get remoteName(){return Le.getRemoteName(Ze.remote.authority)},get uiKind(){return Ze.uiKind}};Ze.environment.extensionTestsLocationURI||Object.freeze(pn);const Zt=Ze.remote.isRemote?M.ExtensionKind.Workspace:M.ExtensionKind.UI,An={createTestController(te){return $.checkProposedApiEnabled(Ne),jt.createTestController(te)},createTestObserver(){return $.checkProposedApiEnabled(Ne),jt.createTestObserver()},runTests(te){return $.checkProposedApiEnabled(Ne),jt.runTests(te)},get onDidChangeTestResults(){return $.checkProposedApiEnabled(Ne),jt.onResultsChanged},get testResults(){return $.checkProposedApiEnabled(Ne),jt.results}},Tn={getExtension(te){const de=cn.getExtensionDescription(te);if(de)return new s.Extension(Ee,Ne.identifier,de,Zt)},get all(){return cn.getAllExtensionDescriptions().map(te=>new s.Extension(Ee,Ne.identifier,te,Zt))},get onDidChange(){return cn.onDidChange}},Rn={createDiagnosticCollection(te){return $t.createDiagnosticCollection(Ne.identifier,te)},get onDidChangeDiagnostics(){return $t.onDidChangeDiagnostics},getDiagnostics:te=>$t.getDiagnostics(te),getLanguages(){return Wt.getLanguages()},setTextDocumentLanguage(te,de){return Wt.changeLanguage(te.uri,de)},match(te,de){return r.score(W.LanguageSelector.from(te),de.uri,de.languageId,!0)},registerCodeActionsProvider(te,de,Re){return dt.registerCodeActionProvider(Ne,mt(te),de,Re)},registerCodeLensProvider(te,de){return dt.registerCodeLensProvider(Ne,mt(te),de)},registerDefinitionProvider(te,de){return dt.registerDefinitionProvider(Ne,mt(te),de)},registerDeclarationProvider(te,de){return dt.registerDeclarationProvider(Ne,mt(te),de)},registerImplementationProvider(te,de){return dt.registerImplementationProvider(Ne,mt(te),de)},registerTypeDefinitionProvider(te,de){return dt.registerTypeDefinitionProvider(Ne,mt(te),de)},registerHoverProvider(te,de){return dt.registerHoverProvider(Ne,mt(te),de,Ne.identifier)},registerEvaluatableExpressionProvider(te,de){return dt.registerEvaluatableExpressionProvider(Ne,mt(te),de,Ne.identifier)},registerInlineValuesProvider(te,de){return dt.registerInlineValuesProvider(Ne,mt(te),de,Ne.identifier)},registerDocumentHighlightProvider(te,de){return dt.registerDocumentHighlightProvider(Ne,mt(te),de)},registerLinkedEditingRangeProvider(te,de){return dt.registerLinkedEditingRangeProvider(Ne,mt(te),de)},registerReferenceProvider(te,de){return dt.registerReferenceProvider(Ne,mt(te),de)},registerRenameProvider(te,de){return dt.registerRenameProvider(Ne,mt(te),de)},registerDocumentSymbolProvider(te,de,Re){return dt.registerDocumentSymbolProvider(Ne,mt(te),de,Re)},registerWorkspaceSymbolProvider(te){return dt.registerWorkspaceSymbolProvider(Ne,te)},registerDocumentFormattingEditProvider(te,de){return dt.registerDocumentFormattingEditProvider(Ne,mt(te),de)},registerDocumentRangeFormattingEditProvider(te,de){return dt.registerDocumentRangeFormattingEditProvider(Ne,mt(te),de)},registerOnTypeFormattingEditProvider(te,de,Re,...at){return dt.registerOnTypeFormattingEditProvider(Ne,mt(te),de,[Re].concat(at))},registerDocumentSemanticTokensProvider(te,de,Re){return dt.registerDocumentSemanticTokensProvider(Ne,mt(te),de,Re)},registerDocumentRangeSemanticTokensProvider(te,de,Re){return dt.registerDocumentRangeSemanticTokensProvider(Ne,mt(te),de,Re)},registerSignatureHelpProvider(te,de,Re,...at){return typeof Re=="object"?dt.registerSignatureHelpProvider(Ne,mt(te),de,Re):dt.registerSignatureHelpProvider(Ne,mt(te),de,typeof Re=="undefined"?[]:[Re,...at])},registerCompletionItemProvider(te,de,...Re){return dt.registerCompletionItemProvider(Ne,mt(te),de,Re)},registerInlineCompletionItemProvider(te,de){return $.checkProposedApiEnabled(Ne),dt.registerInlineCompletionsProvider(Ne,mt(te),de)},registerDocumentLinkProvider(te,de){return dt.registerDocumentLinkProvider(Ne,mt(te),de)},registerColorProvider(te,de){return dt.registerColorProvider(Ne,mt(te),de)},registerFoldingRangeProvider(te,de){return dt.registerFoldingRangeProvider(Ne,mt(te),de)},registerSelectionRangeProvider(te,de){return dt.registerSelectionRangeProvider(Ne,te,de)},registerCallHierarchyProvider(te,de){return dt.registerCallHierarchyProvider(Ne,te,de)},setLanguageConfiguration:(te,de)=>dt.setLanguageConfiguration(Ne,te,de),getTokenInformationAtPosition(te,de){return $.checkProposedApiEnabled(Ne),Wt.tokenAtPosition(te,de)},registerInlayHintsProvider(te,de){return $.checkProposedApiEnabled(Ne),dt.registerInlayHintsProvider(Ne,te,de)}},Ln={get activeTextEditor(){return Dt.getActiveTextEditor()},get visibleTextEditors(){return Dt.getVisibleTextEditors()},get activeTerminal(){return ut.activeTerminal},get terminals(){return ut.terminals},async showTextDocument(te,de,Re){const at=await(A.URI.isUri(te)?Promise.resolve(vn.openTextDocument(te)):Promise.resolve(te));return Dt.showTextDocument(at,de,Re)},createTextEditorDecorationType(te){return Dt.createTextEditorDecorationType(Ne,te)},onDidChangeActiveTextEditor(te,de,Re){return Dt.onDidChangeActiveTextEditor(te,de,Re)},onDidChangeVisibleTextEditors(te,de,Re){return Dt.onDidChangeVisibleTextEditors(te,de,Re)},onDidChangeTextEditorSelection(te,de,Re){return Dt.onDidChangeTextEditorSelection(te,de,Re)},onDidChangeTextEditorOptions(te,de,Re){return Dt.onDidChangeTextEditorOptions(te,de,Re)},onDidChangeTextEditorVisibleRanges(te,de,Re){return Dt.onDidChangeTextEditorVisibleRanges(te,de,Re)},onDidChangeTextEditorViewColumn(te,de,Re){return Dt.onDidChangeTextEditorViewColumn(te,de,Re)},onDidCloseTerminal(te,de,Re){return ut.onDidCloseTerminal(te,de,Re)},onDidOpenTerminal(te,de,Re){return ut.onDidOpenTerminal(te,de,Re)},onDidChangeActiveTerminal(te,de,Re){return ut.onDidChangeActiveTerminal(te,de,Re)},onDidChangeTerminalDimensions(te,de,Re){return $.checkProposedApiEnabled(Ne),ut.onDidChangeTerminalDimensions(te,de,Re)},onDidWriteTerminalData(te,de,Re){return $.checkProposedApiEnabled(Ne),ut.onDidWriteTerminalData(te,de,Re)},get state(){return wt.state},onDidChangeWindowState(te,de,Re){return wt.onDidChangeWindowState(te,de,Re)},showInformationMessage(te,...de){return Rt.showMessage(Ne,y.default.Info,te,de[0],de.slice(1))},showWarningMessage(te,...de){return Rt.showMessage(Ne,y.default.Warning,te,de[0],de.slice(1))},showErrorMessage(te,...de){return Rt.showMessage(Ne,y.default.Error,te,de[0],de.slice(1))},showQuickPick(te,de,Re){return Vt.showQuickPick(te,!!Ne.enableProposedApi,de,Re)},showWorkspaceFolderPick(te){return Vt.showWorkspaceFolderPick(te)},showInputBox(te,de){return Vt.showInput(te,de)},showOpenDialog(te){return mn.showOpenDialog(te)},showSaveDialog(te){return mn.showSaveDialog(te)},createStatusBarItem(te,de,Re){let at,bt,Ct;return typeof te=="string"?(at=te,bt=de,Ct=Re):(bt=te,Ct=de),It.createStatusBarEntry(Ne,at,bt,Ct)},setStatusBarMessage(te,de){return It.setStatusBarMessage(te,de)},withScmProgress(te){return pt.report("window.withScmProgress",Ne,"Use 'withProgress' instead."),fn.withProgress(Ne,{location:M.ProgressLocation.SourceControl},(de,Re)=>te({report(at){}}))},withProgress(te,de){return fn.withProgress(Ne,te,de)},createOutputChannel(te){return At.createOutputChannel(te)},createWebviewPanel(te,de,Re,at){return an.createWebviewPanel(Ne,te,de,Re,at)},createWebviewTextEditorInset(te,de,Re,at){return $.checkProposedApiEnabled(Ne),rn.createWebviewEditorInset(te,de,Re,at,Ne)},createTerminal(te,de,Re){return typeof te=="object"?"pty"in te?ut.createExtensionTerminal(te):ut.createTerminalFromOptions(te):ut.createTerminal(te,de,Re)},registerTerminalLinkProvider(te){return ut.registerLinkProvider(te)},registerTerminalProfileProvider(te,de){return ut.registerProfileProvider(Ne,te,de)},registerTreeDataProvider(te,de){return Xt.registerTreeDataProvider(te,de,Ne)},createTreeView(te,de){return Xt.createTreeView(te,de,Ne)},registerWebviewPanelSerializer:(te,de)=>an.registerWebviewPanelSerializer(Ne,te,de),registerCustomEditorProvider:(te,de,Re={})=>Dn.registerCustomEditorProvider(Ne,te,de,Re),registerFileDecorationProvider(te){return Bt.registerFileDecorationProvider(te,Ne.identifier)},registerUriHandler(te){return Kt.registerUriHandler(Ne.identifier,te)},createQuickPick(){return Vt.createQuickPick(Ne.identifier,!!Ne.enableProposedApi)},createInputBox(){return Vt.createInputBox(Ne.identifier)},get activeColorTheme(){return Yt.activeColorTheme},onDidChangeActiveColorTheme(te,de,Re){return Yt.onDidChangeActiveColorTheme(te,de,Re)},registerWebviewViewProvider(te,de,Re){return Jt.registerWebviewViewProvider(Ne,te,de,Re==null?void 0:Re.webviewOptions)},get activeNotebookEditor(){return $.checkProposedApiEnabled(Ne),gt.activeNotebookEditor},onDidChangeActiveNotebookEditor(te,de,Re){return $.checkProposedApiEnabled(Ne),gt.onDidChangeActiveNotebookEditor(te,de,Re)},get visibleNotebookEditors(){return $.checkProposedApiEnabled(Ne),gt.visibleNotebookEditors},get onDidChangeVisibleNotebookEditors(){return $.checkProposedApiEnabled(Ne),gt.onDidChangeVisibleNotebookEditors},onDidChangeNotebookEditorSelection(te,de,Re){return $.checkProposedApiEnabled(Ne),zt.onDidChangeNotebookEditorSelection(te,de,Re)},onDidChangeNotebookEditorVisibleRanges(te,de,Re){return $.checkProposedApiEnabled(Ne),zt.onDidChangeNotebookEditorVisibleRanges(te,de,Re)},showNotebookDocument(te,de){return $.checkProposedApiEnabled(Ne),gt.showNotebookDocument(te,de)},registerExternalUriOpener(te,de,Re){return $.checkProposedApiEnabled(Ne),Cn.registerExternalUriOpener(Ne.identifier,te,de,Re)},get openEditors(){return $.checkProposedApiEnabled(Ne),vt.tabs},get onDidChangeOpenEditors(){return $.checkProposedApiEnabled(Ne),vt.onDidChangeTabs},getInlineCompletionItemController(te){return $.checkProposedApiEnabled(Ne),v.InlineCompletionController.get(te)}},vn={get rootPath(){return pt.report("workspace.rootPath",Ne,"Please use 'workspace.workspaceFolders' instead. More details: https://aka.ms/vscode-eliminating-rootpath"),Ce.getPath()},set rootPath(te){throw R.readonly()},getWorkspaceFolder(te){return Ce.getWorkspaceFolder(te)},get workspaceFolders(){return Ce.getWorkspaceFolders()},get name(){return Ce.name},set name(te){throw R.readonly()},get workspaceFile(){return Ce.workspaceFile},set workspaceFile(te){throw R.readonly()},updateWorkspaceFolders:(te,de,...Re)=>Ce.updateWorkspaceFolders(Ne,te,de||0,...Re),onDidChangeWorkspaceFolders:function(te,de,Re){return Ce.onDidChangeWorkspace(te,de,Re)},asRelativePath:(te,de)=>Ce.getRelativePath(te,de),findFiles:(te,de,Re,at)=>Ce.findFiles(W.GlobPattern.from(te),W.GlobPattern.from(de),Re,Ne.identifier,at),findTextInFiles:(te,de,Re,at)=>{let bt,Ct;return typeof de=="object"?(bt=de,Ct=Re):(bt={},Ct=de,at=Re),Ce.findTextInFiles(te,bt||{},Ct,Ne.identifier,at)},saveAll:te=>Ce.saveAll(te),applyEdit(te){return kn.applyWorkspaceEdit(te)},createFileSystemWatcher:(te,de,Re,at)=>Tt.createFileSystemWatcher(W.GlobPattern.from(te),de,Re,at),get textDocuments(){return St.getAllDocumentData().map(te=>te.document)},set textDocuments(te){throw R.readonly()},openTextDocument(te){let de;const Re=te;if(typeof te=="string")de=Promise.resolve(A.URI.file(te));else if(A.URI.isUri(te))de=Promise.resolve(te);else if(!Re||typeof Re=="object")de=St.createDocumentData(Re);else throw new Error("illegal argument - uriOrFileNameOrOptions");return de.then(at=>St.ensureDocumentData(at).then(bt=>bt.document))},onDidOpenTextDocument:(te,de,Re)=>St.onDidAddDocument(te,de,Re),onDidCloseTextDocument:(te,de,Re)=>St.onDidRemoveDocument(te,de,Re),onDidChangeTextDocument:(te,de,Re)=>St.onDidChangeDocument(te,de,Re),onDidSaveTextDocument:(te,de,Re)=>St.onDidSaveDocument(te,de,Re),onWillSaveTextDocument:(te,de,Re)=>tn.getOnWillSaveTextDocumentEvent(Ne)(te,de,Re),get notebookDocuments(){return gt.notebookDocuments.map(te=>te.apiNotebook)},async openNotebookDocument(te,de){let Re;if(A.URI.isUri(te))Re=te,await gt.openNotebookDocument(te);else if(typeof te=="string")Re=A.URI.revive(await gt.createNotebookDocument({viewType:te,content:de}));else throw new Error("Invalid arguments");return gt.getNotebookDocument(Re).apiNotebook},get onDidOpenNotebookDocument(){return gt.onDidOpenNotebookDocument},get onDidCloseNotebookDocument(){return gt.onDidCloseNotebookDocument},registerNotebookSerializer(te,de,Re,at){return gt.registerNotebookSerializer(Ne,te,de,Re,Ne.enableProposedApi?at:void 0)},registerNotebookContentProvider:(te,de,Re,at)=>($.checkProposedApiEnabled(Ne),gt.registerNotebookContentProvider(Ne,te,de,Re,Ne.enableProposedApi?at:void 0)),onDidChangeConfiguration:(te,de,Re)=>gn.onDidChangeConfiguration(te,de,Re),getConfiguration(te,de){return de=arguments.length===1?void 0:de,gn.getConfiguration(te,de,Ne)},registerTextDocumentContentProvider(te,de){return en.registerTextDocumentContentProvider(te,de)},registerTaskProvider:(te,de)=>(pt.report("window.registerTaskProvider",Ne,"Use the corresponding function on the 'tasks' namespace instead"),kt.registerTaskProvider(Ne,te,de)),registerFileSystemProvider(te,de,Re){return sn.registerFileSystemProvider(Ne.identifier,te,de,Re,Ne.enableProposedApi)},get fs(){return ct.value},registerFileSearchProvider:(te,de)=>($.checkProposedApiEnabled(Ne),Ht.registerFileSearchProvider(te,de)),registerTextSearchProvider:(te,de)=>($.checkProposedApiEnabled(Ne),Ht.registerTextSearchProvider(te,de)),registerRemoteAuthorityResolver:(te,de)=>($.checkProposedApiEnabled(Ne),Ee.registerRemoteAuthorityResolver(te,de)),registerResourceLabelFormatter:te=>($.checkProposedApiEnabled(Ne),Sn.$registerResourceLabelFormatter(te)),onDidCreateFiles:(te,de,Re)=>Tt.onDidCreateFile(te,de,Re),onDidDeleteFiles:(te,de,Re)=>Tt.onDidDeleteFile(te,de,Re),onDidRenameFiles:(te,de,Re)=>Tt.onDidRenameFile(te,de,Re),onWillCreateFiles:(te,de,Re)=>Tt.getOnWillCreateFileEvent(Ne)(te,de,Re),onWillDeleteFiles:(te,de,Re)=>Tt.getOnWillDeleteFileEvent(Ne)(te,de,Re),onWillRenameFiles:(te,de,Re)=>Tt.getOnWillRenameFileEvent(Ne)(te,de,Re),openTunnel:te=>($.checkProposedApiEnabled(Ne),st.openTunnel(Ne,te).then(de=>{if(!de)throw new Error("cannot open tunnel");return de})),get tunnels(){return $.checkProposedApiEnabled(Ne),st.getTunnels()},onDidChangeTunnels:(te,de,Re)=>($.checkProposedApiEnabled(Ne),st.onDidChangeTunnels(te,de,Re)),registerPortAttributesProvider:(te,de)=>($.checkProposedApiEnabled(Ne),st.registerPortsAttributesProvider(te,de)),registerTimelineProvider:(te,de)=>($.checkProposedApiEnabled(Ne),yn.registerTimelineProvider(te,de,Ne.identifier,ht.converter)),get isTrusted(){return Ce.trusted},requestWorkspaceTrust:te=>($.checkProposedApiEnabled(Ne),Ce.requestWorkspaceTrust(te)),onDidGrantWorkspaceTrust:(te,de,Re)=>Ce.onDidGrantWorkspaceTrust(te,de,Re)},Fn={get inputBox(){return pt.report("scm.inputBox",Ne,"Use 'SourceControl.inputBox' instead"),hn.getLastInputBox(Ne)},createSourceControl(te,de,Re){return hn.createSourceControl(Ne,te,de,Re)}},wn={createCommentController(te,de){return _n.createCommentController(Ne,te,de)}},Mt={get activeDebugSession(){return ft.activeDebugSession},get activeDebugConsole(){return ft.activeDebugConsole},get breakpoints(){return ft.breakpoints},onDidStartDebugSession(te,de,Re){return ft.onDidStartDebugSession(te,de,Re)},onDidTerminateDebugSession(te,de,Re){return ft.onDidTerminateDebugSession(te,de,Re)},onDidChangeActiveDebugSession(te,de,Re){return ft.onDidChangeActiveDebugSession(te,de,Re)},onDidReceiveDebugSessionCustomEvent(te,de,Re){return ft.onDidReceiveDebugSessionCustomEvent(te,de,Re)},onDidChangeBreakpoints(te,de,Re){return ft.onDidChangeBreakpoints(te,de,Re)},registerDebugConfigurationProvider(te,de,Re){return ft.registerDebugConfigurationProvider(te,de,Re||M.DebugConfigurationProviderTriggerKind.Initial)},registerDebugAdapterDescriptorFactory(te,de){return ft.registerDebugAdapterDescriptorFactory(Ne,te,de)},registerDebugAdapterTrackerFactory(te,de){return ft.registerDebugAdapterTrackerFactory(te,de)},startDebugging(te,de,Re){return!Re||typeof Re=="object"&&"configuration"in Re?ft.startDebugging(te,de,{parentSession:Re}):ft.startDebugging(te,de,Re||{})},stopDebugging(te){return ft.stopDebugging(te)},addBreakpoints(te){return ft.addBreakpoints(te)},removeBreakpoints(te){return ft.removeBreakpoints(te)},asDebugSourceUri(te,de){return ft.asDebugSourceUri(te,de)}},Nt={registerTaskProvider:(te,de)=>kt.registerTaskProvider(Ne,te,de),fetchTasks:te=>kt.fetchTasks(te),executeTask:te=>kt.executeTask(Ne,te),get taskExecutions(){return kt.taskExecutions},onDidStartTask:(te,de,Re)=>kt.onDidStartTask(te,de,Re),onDidEndTask:(te,de,Re)=>kt.onDidEndTask(te,de,Re),onDidStartTaskProcess:(te,de,Re)=>kt.onDidStartTaskProcess(te,de,Re),onDidEndTaskProcess:(te,de,Re)=>kt.onDidEndTaskProcess(te,de,Re)},Mn={createNotebookController(te,de,Re,at,bt){return nn.createNotebookController(Ne,te,de,Re,at,Ne.enableProposedApi?bt:void 0)},registerNotebookCellStatusBarItemProvider:(te,de)=>gt.registerNotebookCellStatusBarItemProvider(Ne,te,de),get onDidSaveNotebookDocument(){return $.checkProposedApiEnabled(Ne),Qt.onDidSaveNotebookDocument},createNotebookEditorDecorationType(te){return $.checkProposedApiEnabled(Ne),zt.createNotebookEditorDecorationType(te)},createRendererMessaging(te){return $.checkProposedApiEnabled(Ne),En.createRendererMessaging(te)},onDidChangeNotebookDocumentMetadata(te,de,Re){return $.checkProposedApiEnabled(Ne),Qt.onDidChangeNotebookDocumentMetadata(te,de,Re)},onDidChangeNotebookCells(te,de,Re){return $.checkProposedApiEnabled(Ne),gt.onDidChangeNotebookCells(te,de,Re)},onDidChangeNotebookCellExecutionState(te,de,Re){return $.checkProposedApiEnabled(Ne),gt.onDidChangeNotebookCellExecutionState(te,de,Re)},onDidChangeCellOutputs(te,de,Re){return $.checkProposedApiEnabled(Ne),gt.onDidChangeCellOutputs(te,de,Re)},onDidChangeCellMetadata(te,de,Re){return $.checkProposedApiEnabled(Ne),gt.onDidChangeCellMetadata(te,de,Re)},createConcatTextDocument(te,de){return $.checkProposedApiEnabled(Ne),new _e.ExtHostNotebookConcatDocument(gt,St,te,de)}};return{version:Ze.version,authentication:Pn,commands:In,comments:wn,debug:Mt,env:pn,extensions:Tn,languages:Rn,notebooks:Mn,scm:Fn,tasks:Nt,test:An,window:Ln,workspace:vn,Breakpoint:M.Breakpoint,CallHierarchyIncomingCall:M.CallHierarchyIncomingCall,CallHierarchyItem:M.CallHierarchyItem,CallHierarchyOutgoingCall:M.CallHierarchyOutgoingCall,CancellationError:R.CancellationError,CancellationTokenSource:p.CancellationTokenSource,CandidatePortSource:l.CandidatePortSource,CodeAction:M.CodeAction,CodeActionKind:M.CodeActionKind,CodeActionTriggerKind:M.CodeActionTriggerKind,CodeLens:M.CodeLens,Color:M.Color,ColorInformation:M.ColorInformation,ColorPresentation:M.ColorPresentation,ColorThemeKind:M.ColorThemeKind,CommentMode:M.CommentMode,CommentThreadCollapsibleState:M.CommentThreadCollapsibleState,CompletionItem:M.CompletionItem,CompletionItemKind:M.CompletionItemKind,CompletionItemTag:M.CompletionItemTag,CompletionList:M.CompletionList,CompletionTriggerKind:M.CompletionTriggerKind,ConfigurationTarget:M.ConfigurationTarget,CustomExecution:M.CustomExecution,DebugAdapterExecutable:M.DebugAdapterExecutable,DebugAdapterInlineImplementation:M.DebugAdapterInlineImplementation,DebugAdapterNamedPipeServer:M.DebugAdapterNamedPipeServer,DebugAdapterServer:M.DebugAdapterServer,DebugConfigurationProviderTriggerKind:M.DebugConfigurationProviderTriggerKind,DebugConsoleMode:M.DebugConsoleMode,DecorationRangeBehavior:M.DecorationRangeBehavior,Diagnostic:M.Diagnostic,DiagnosticRelatedInformation:M.DiagnosticRelatedInformation,DiagnosticSeverity:M.DiagnosticSeverity,DiagnosticTag:M.DiagnosticTag,Disposable:M.Disposable,DocumentHighlight:M.DocumentHighlight,DocumentHighlightKind:M.DocumentHighlightKind,DocumentLink:M.DocumentLink,DocumentSymbol:M.DocumentSymbol,EndOfLine:M.EndOfLine,EnvironmentVariableMutatorType:M.EnvironmentVariableMutatorType,EvaluatableExpression:M.EvaluatableExpression,InlineValueText:M.InlineValueText,InlineValueVariableLookup:M.InlineValueVariableLookup,InlineValueEvaluatableExpression:M.InlineValueEvaluatableExpression,InlineCompletionTriggerKind:M.InlineCompletionTriggerKind,EventEmitter:C.Emitter,ExtensionKind:M.ExtensionKind,ExtensionMode:M.ExtensionMode,ExternalUriOpenerPriority:M.ExternalUriOpenerPriority,FileChangeType:M.FileChangeType,FileDecoration:M.FileDecoration,FileSystemError:M.FileSystemError,FileType:I.FileType,FilePermission:I.FilePermission,FoldingRange:M.FoldingRange,FoldingRangeKind:M.FoldingRangeKind,FunctionBreakpoint:M.FunctionBreakpoint,InlineCompletionItem:M.InlineSuggestion,InlineCompletionList:M.InlineSuggestions,Hover:M.Hover,IndentAction:k.IndentAction,Location:M.Location,MarkdownString:M.MarkdownString,OverviewRulerLane:E.OverviewRulerLane,ParameterInformation:M.ParameterInformation,PortAutoForwardAction:M.PortAutoForwardAction,Position:M.Position,ProcessExecution:M.ProcessExecution,ProgressLocation:M.ProgressLocation,QuickInputButtons:M.QuickInputButtons,Range:M.Range,RelativePattern:M.RelativePattern,Selection:M.Selection,SelectionRange:M.SelectionRange,SemanticTokens:M.SemanticTokens,SemanticTokensBuilder:M.SemanticTokensBuilder,SemanticTokensEdit:M.SemanticTokensEdit,SemanticTokensEdits:M.SemanticTokensEdits,SemanticTokensLegend:M.SemanticTokensLegend,ShellExecution:M.ShellExecution,ShellQuoting:M.ShellQuoting,SignatureHelp:M.SignatureHelp,SignatureHelpTriggerKind:M.SignatureHelpTriggerKind,SignatureInformation:M.SignatureInformation,SnippetString:M.SnippetString,SourceBreakpoint:M.SourceBreakpoint,StandardTokenType:M.StandardTokenType,StatusBarAlignment:M.StatusBarAlignment,SymbolInformation:M.SymbolInformation,SymbolKind:M.SymbolKind,SymbolTag:M.SymbolTag,Task:M.Task,TaskGroup:M.TaskGroup,TaskPanelKind:M.TaskPanelKind,TaskRevealKind:M.TaskRevealKind,TaskScope:M.TaskScope,TerminalLink:M.TerminalLink,TerminalProfile:M.TerminalProfile,TextDocumentSaveReason:M.TextDocumentSaveReason,TextEdit:M.TextEdit,TextEditorCursorStyle:P.TextEditorCursorStyle,TextEditorLineNumbersStyle:M.TextEditorLineNumbersStyle,TextEditorRevealType:M.TextEditorRevealType,TextEditorSelectionChangeKind:M.TextEditorSelectionChangeKind,ThemeColor:M.ThemeColor,ThemeIcon:M.ThemeIcon,TreeItem:M.TreeItem,TreeItemCollapsibleState:M.TreeItemCollapsibleState,UIKind:l.UIKind,Uri:A.URI,ViewColumn:M.ViewColumn,WorkspaceEdit:M.WorkspaceEdit,InlayHint:M.InlayHint,InlayHintKind:M.InlayHintKind,RemoteAuthorityResolverError:M.RemoteAuthorityResolverError,ResolvedAuthority:M.ResolvedAuthority,SourceControlInputBoxValidationType:M.SourceControlInputBoxValidationType,ExtensionRuntime:M.ExtensionRuntime,TimelineItem:M.TimelineItem,NotebookRange:M.NotebookRange,NotebookCellKind:M.NotebookCellKind,NotebookCellExecutionState:M.NotebookCellExecutionState,NotebookCellData:M.NotebookCellData,NotebookData:M.NotebookData,NotebookRendererScript:M.NotebookRendererScript,NotebookCellStatusBarAlignment:M.NotebookCellStatusBarAlignment,NotebookEditorRevealType:M.NotebookEditorRevealType,NotebookCellOutput:M.NotebookCellOutput,NotebookCellOutputItem:M.NotebookCellOutputItem,NotebookCellStatusBarItem:M.NotebookCellStatusBarItem,NotebookControllerAffinity:M.NotebookControllerAffinity,PortAttributes:M.PortAttributes,LinkedEditingRanges:M.LinkedEditingRanges,TestResultState:M.TestResultState,TestRunRequest:M.TestRunRequest,TestMessage:M.TestMessage,TextSearchCompleteMessageType:we.TextSearchCompleteMessageType,TestMessageSeverity:M.TestMessageSeverity,WorkspaceTrustState:M.WorkspaceTrustState}}}e.createApiFactoryAndRegisterActors=je}),define(me[262],ge([0,1,77,62,35,126,36,48,42,33,65,49,67,88,87,47,61,127,86,59,85,117,46]),function(X,e,p,R,C,y,A,P,E,k,r,I,l,f,c,u,S,w,b,d,h,g,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),p.registerSingleton(f.IExtensionStoragePaths,f.ExtensionStoragePaths),p.registerSingleton(S.IExtHostApiDeprecationService,S.ExtHostApiDeprecationService),p.registerSingleton(P.IExtHostCommands,P.ExtHostCommands),p.registerSingleton(A.IExtHostConfiguration,A.ExtHostConfiguration),p.registerSingleton(b.IExtHostConsumerFileSystem,b.ExtHostConsumerFileSystem),p.registerSingleton(I.IExtHostDebugService,I.WorkerExtHostDebugService),p.registerSingleton(y.IExtHostDecorations,y.ExtHostDecorations),p.registerSingleton(E.IExtHostDocumentsAndEditors,E.ExtHostDocumentsAndEditors),p.registerSingleton(d.IExtHostFileSystemInfo,d.ExtHostFileSystemInfo),p.registerSingleton(R.IExtHostOutputService,R.ExtHostOutputService),p.registerSingleton(l.IExtHostSearch,l.ExtHostSearch),p.registerSingleton(c.IExtHostStorage,c.ExtHostStorage),p.registerSingleton(r.IExtHostTask,r.WorkerExtHostTask),p.registerSingleton(k.IExtHostTerminalService,k.WorkerExtHostTerminalService),p.registerSingleton(u.IExtHostTunnelService,u.ExtHostTunnelService),p.registerSingleton(w.IExtHostWindow,w.ExtHostWindow),p.registerSingleton(C.IExtHostWorkspace,C.ExtHostWorkspace),p.registerSingleton(h.IExtHostSecretState,h.ExtHostSecretState),p.registerSingleton(g.IExtHostTelemetry,g.ExtHostTelemetry),p.registerSingleton(t.IExtHostEditorTabs,t.ExtHostEditorTabs)}),define(me[89],ge([0,1,18,12,31,64]),function(X,e,p,R,C,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OutputChannel=e.createTextSearchResult=e.anchorGlob=void 0;function A(I){return I.startsWith("**")||I.startsWith("/")?I:`/${I}`}e.anchorGlob=A;function P(I,l,f,c){const u=p.mapArrayOrNot(f,E),S=new C.TextSearchMatch(l,u,c),w=S.preview.matches;return{ranges:p.mapArrayOrNot(u,k),uri:I,preview:{text:S.preview.text,matches:p.mapArrayOrNot(w,k)}}}e.createTextSearchResult=P;function E(I){return new C.SearchRange(I.start.line,I.start.character,I.end.line,I.end.character)}function k(I){return new y.Range(I.startLineNumber,I.startColumn,I.endLineNumber,I.endColumn)}let r=class{constructor(l,f){this.prefix=l,this.logService=f}appendLine(l){this.logService.debug(`${this.prefix}#search`,l)}};r=Ve([We(1,R.ILogService)],r),e.OutputChannel=r}),define(me[263],ge([0,1,91,22]),function(X,e,p,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SUPPORTED_ENCODINGS=e.detectEncodingFromBuffer=e.toCanonicalName=e.detectEncodingByBOMFromBuffer=e.toNodeEncoding=e.encodingExists=e.toEncodeReadable=e.toDecodeStream=e.UTF8_BOM=e.UTF16le_BOM=e.UTF16be_BOM=e.isUTFEncoding=e.UTF16le=e.UTF16be=e.UTF8_with_bom=e.UTF8=void 0,e.UTF8="utf8",e.UTF8_with_bom="utf8bom",e.UTF16be="utf16be",e.UTF16le="utf16le";function C(t){return[e.UTF8,e.UTF8_with_bom,e.UTF16be,e.UTF16le].some(i=>i===t)}e.isUTFEncoding=C,e.UTF16be_BOM=[254,255],e.UTF16le_BOM=[255,254],e.UTF8_BOM=[239,187,191];const y=512,A=512,P=512*8,E=512*128;class k{constructor(i){this.iconvLiteDecoder=i}static async create(i){let s;if(i!==e.UTF8)s=(await new Promise((o,v)=>{X(["iconv-lite-umd"],o,v)})).getDecoder(f(i));else{const n=new TextDecoder;s={write(o){return n.decode(o,{stream:!0})},end(){return n.decode()}}}return new k(s)}write(i){return this.iconvLiteDecoder.write(i)}end(){return this.iconvLiteDecoder.end()}}function r(t,i){var s;const n=((s=i.minBytesRequiredForDetection)!==null&&s!==void 0?s:i.guessEncoding)?P:A;return new Promise((o,v)=>{const m=p.newWriteableStream(L=>L.join("")),_=[];let D=0,a;const T=async()=>{try{const L=await g({buffer:R.VSBuffer.concat(_),bytesRead:D},i.guessEncoding);L.encoding=await i.overwriteEncoding(L.encoding),a=await k.create(L.encoding);const U=a.write(R.VSBuffer.concat(_).buffer);m.write(U),_.length=0,D=0,o({stream:m,detected:L})}catch(L){v(L)}};p.listenStream(t,{onData:async L=>{a?m.write(a.write(L.buffer)):(_.push(L),D+=L.byteLength,D>=n&&(t.pause(),await T(),setTimeout(()=>t.resume())))},onError:L=>m.error(L),onEnd:async()=>{a||await T(),m.end(a==null?void 0:a.end())}})})}e.toDecodeStream=r;async function I(t,i,s){const o=(await new Promise((_,D)=>{X(["iconv-lite-umd"],_,D)})).getEncoder(f(i),s);let v=!1,m=!1;return{read(){if(m)return null;const _=t.read();if(typeof _!="string"){if(m=!0,!v&&(s==null?void 0:s.addBOM))switch(i){case e.UTF8:case e.UTF8_with_bom:return R.VSBuffer.wrap(Uint8Array.from(e.UTF8_BOM));case e.UTF16be:return R.VSBuffer.wrap(Uint8Array.from(e.UTF16be_BOM));case e.UTF16le:return R.VSBuffer.wrap(Uint8Array.from(e.UTF16le_BOM))}const D=o.end();return D&&D.length>0?(v=!0,R.VSBuffer.wrap(D)):null}return v=!0,R.VSBuffer.wrap(o.write(_))}}}e.toEncodeReadable=I;async function l(t){return(await new Promise((s,n)=>{X(["iconv-lite-umd"],s,n)})).encodingExists(f(t))}e.encodingExists=l;function f(t){return t===e.UTF8_with_bom||t===null?e.UTF8:t}e.toNodeEncoding=f;function c(t,i){if(!t||i<e.UTF16be_BOM.length)return null;const s=t.readUInt8(0),n=t.readUInt8(1);if(s===e.UTF16be_BOM[0]&&n===e.UTF16be_BOM[1])return e.UTF16be;if(s===e.UTF16le_BOM[0]&&n===e.UTF16le_BOM[1])return e.UTF16le;if(i<e.UTF8_BOM.length)return null;const o=t.readUInt8(2);return s===e.UTF8_BOM[0]&&n===e.UTF8_BOM[1]&&o===e.UTF8_BOM[2]?e.UTF8_with_bom:null}e.detectEncodingByBOMFromBuffer=c;const u=["ascii","utf-16","utf-32"];async function S(t){const i=await new Promise((m,_)=>{X(["jschardet"],m,_)}),s=t.slice(0,E),n=d(s.buffer),o=i.detect(n);if(!o||!o.encoding)return null;const v=o.encoding.toLowerCase();return 0<=u.indexOf(v)?null:b(o.encoding)}const w={ibm866:"cp866",big5:"cp950"};function b(t){const i=t.replace(/[^a-zA-Z0-9]/g,"").toLowerCase();return w[i]||i}function d(t){let i="";for(let s=0;s<t.length;s++)i+=String.fromCharCode(t[s]);return i}function h(t){switch(t){case"shiftjis":return"shift-jis";case"utf16le":return"utf-16le";case"utf16be":return"utf-16be";case"big5hkscs":return"big5-hkscs";case"eucjp":return"euc-jp";case"euckr":return"euc-kr";case"koi8r":return"koi8-r";case"koi8u":return"koi8-u";case"macroman":return"x-mac-roman";case"utf8bom":return"utf8";default:const i=t.match(/windows(\d+)/);return i?"windows-"+i[1]:t}}e.toCanonicalName=h;function g({buffer:t,bytesRead:i},s){let n=c(t,i),o=!1;if(n!==e.UTF16be&&n!==e.UTF16le&&t){let v=!0,m=!0,_=!1;for(let D=0;D<i&&D<y;D++){const a=D%2==1,T=t.readUInt8(D)===0;if(T&&(_=!0),v&&(a&&!T||!a&&T)&&(v=!1),m&&(a&&T||!a&&!T)&&(m=!1),T&&!v&&!m)break}_&&(v?n=e.UTF16le:m?n=e.UTF16be:o=!0)}return s&&!o&&!n&&t?S(t.slice(0,i)).then(v=>({seemsBinary:!1,encoding:v})):{seemsBinary:o,encoding:n}}e.detectEncodingFromBuffer=g,e.SUPPORTED_ENCODINGS={utf8:{labelLong:"UTF-8",labelShort:"UTF-8",order:1,alias:"utf8bom"},utf8bom:{labelLong:"UTF-8 with BOM",labelShort:"UTF-8 with BOM",encodeOnly:!0,order:2,alias:"utf8"},utf16le:{labelLong:"UTF-16 LE",labelShort:"UTF-16 LE",order:3},utf16be:{labelLong:"UTF-16 BE",labelShort:"UTF-16 BE",order:4},windows1252:{labelLong:"Western (Windows 1252)",labelShort:"Windows 1252",order:5},iso88591:{labelLong:"Western (ISO 8859-1)",labelShort:"ISO 8859-1",order:6},iso88593:{labelLong:"Western (ISO 8859-3)",labelShort:"ISO 8859-3",order:7},iso885915:{labelLong:"Western (ISO 8859-15)",labelShort:"ISO 8859-15",order:8},macroman:{labelLong:"Western (Mac Roman)",labelShort:"Mac Roman",order:9},cp437:{labelLong:"DOS (CP 437)",labelShort:"CP437",order:10},windows1256:{labelLong:"Arabic (Windows 1256)",labelShort:"Windows 1256",order:11},iso88596:{labelLong:"Arabic (ISO 8859-6)",labelShort:"ISO 8859-6",order:12},windows1257:{labelLong:"Baltic (Windows 1257)",labelShort:"Windows 1257",order:13},iso88594:{labelLong:"Baltic (ISO 8859-4)",labelShort:"ISO 8859-4",order:14},iso885914:{labelLong:"Celtic (ISO 8859-14)",labelShort:"ISO 8859-14",order:15},windows1250:{labelLong:"Central European (Windows 1250)",labelShort:"Windows 1250",order:16},iso88592:{labelLong:"Central European (ISO 8859-2)",labelShort:"ISO 8859-2",order:17},cp852:{labelLong:"Central European (CP 852)",labelShort:"CP 852",order:18},windows1251:{labelLong:"Cyrillic (Windows 1251)",labelShort:"Windows 1251",order:19},cp866:{labelLong:"Cyrillic (CP 866)",labelShort:"CP 866",order:20},iso88595:{labelLong:"Cyrillic (ISO 8859-5)",labelShort:"ISO 8859-5",order:21},koi8r:{labelLong:"Cyrillic (KOI8-R)",labelShort:"KOI8-R",order:22},koi8u:{labelLong:"Cyrillic (KOI8-U)",labelShort:"KOI8-U",order:23},iso885913:{labelLong:"Estonian (ISO 8859-13)",labelShort:"ISO 8859-13",order:24},windows1253:{labelLong:"Greek (Windows 1253)",labelShort:"Windows 1253",order:25},iso88597:{labelLong:"Greek (ISO 8859-7)",labelShort:"ISO 8859-7",order:26},windows1255:{labelLong:"Hebrew (Windows 1255)",labelShort:"Windows 1255",order:27},iso88598:{labelLong:"Hebrew (ISO 8859-8)",labelShort:"ISO 8859-8",order:28},iso885910:{labelLong:"Nordic (ISO 8859-10)",labelShort:"ISO 8859-10",order:29},iso885916:{labelLong:"Romanian (ISO 8859-16)",labelShort:"ISO 8859-16",order:30},windows1254:{labelLong:"Turkish (Windows 1254)",labelShort:"Windows 1254",order:31},iso88599:{labelLong:"Turkish (ISO 8859-9)",labelShort:"ISO 8859-9",order:32},windows1258:{labelLong:"Vietnamese (Windows 1258)",labelShort:"Windows 1258",order:33},gbk:{labelLong:"Simplified Chinese (GBK)",labelShort:"GBK",order:34},gb18030:{labelLong:"Simplified Chinese (GB18030)",labelShort:"GB18030",order:35},cp950:{labelLong:"Traditional Chinese (Big5)",labelShort:"Big5",order:36},big5hkscs:{labelLong:"Traditional Chinese (Big5-HKSCS)",labelShort:"Big5-HKSCS",order:37},shiftjis:{labelLong:"Japanese (Shift JIS)",labelShort:"Shift JIS",order:38},eucjp:{labelLong:"Japanese (EUC-JP)",labelShort:"EUC-JP",order:39},euckr:{labelLong:"Korean (EUC-KR)",labelShort:"EUC-KR",order:40},windows874:{labelLong:"Thai (Windows 874)",labelShort:"Windows 874",order:41},iso885911:{labelLong:"Latin/Thai (ISO 8859-11)",labelShort:"ISO 8859-11",order:42},koi8ru:{labelLong:"Cyrillic (KOI8-RU)",labelShort:"KOI8-RU",order:43},koi8t:{labelLong:"Tajik (KOI8-T)",labelShort:"KOI8-T",order:44},gb2312:{labelLong:"Simplified Chinese (GB 2312)",labelShort:"GB 2312",order:45},cp865:{labelLong:"Nordic DOS (CP 865)",labelShort:"CP 865",order:46},cp850:{labelLong:"Western European DOS (CP 850)",labelShort:"CP 850",order:47}}}),define(me[129],ge([0,1,263,28,128]),function(X,e,p,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeTextSearchManager=void 0;class y extends C.TextSearchManager{constructor(P,E,k=R){super(P,E,{readdir:r=>k.Promises.readdir(r.fsPath),toCanonicalName:r=>p.toCanonicalName(r)})}}e.NativeTextSearchManager=y}),define(me[264],ge([0,1,265,279,280,2,281]),function(X,e,p,R,C,y,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connectProxyResolver=void 0;function P(I,l,f,c,u,S){const w=S.environment.useHostProxy,b=typeof w=="boolean"?w:!S.remote.isRemote,d=A.createProxyResolver({resolveProxy:g=>I.resolveProxy(g),getHttpProxySetting:()=>l.getConfiguration("http").get("proxy"),log:(g,t,...i)=>{switch(g){case A.LogLevel.Trace:c.trace(t,...i);break;case A.LogLevel.Debug:c.debug(t,...i);break;case A.LogLevel.Info:c.info(t,...i);break;case A.LogLevel.Warning:c.warn(t,...i);break;case A.LogLevel.Error:c.error(t,...i);break;case A.LogLevel.Critical:c.critical(t,...i);break;case A.LogLevel.Off:break;default:s(g,t,i);break}function s(n,o,...v){c.error("Unknown log level",n),c.error(o,...v)}},getLogLevel:()=>c.getLevel(),proxyResolveTelemetry:g=>{u.$publicLog2("resolveProxy",g)},useHostProxy:b,env:process.env}),h=E(l,d);return r(f,h)}e.connectProxyResolver=P;function E(I,l){const f={config:I.getConfiguration("http").get("proxySupport")||"off"};I.onDidChangeConfiguration(u=>{f.config=I.getConfiguration("http").get("proxySupport")||"off"});const c={config:!!I.getConfiguration("http").get("systemCertificates")};return I.onDidChangeConfiguration(u=>{c.config=!!I.getConfiguration("http").get("systemCertificates")}),{http:{off:Object.assign({},p,A.createHttpPatch(p,l,{config:"off"},c,!0)),on:Object.assign({},p,A.createHttpPatch(p,l,{config:"on"},c,!0)),override:Object.assign({},p,A.createHttpPatch(p,l,{config:"override"},c,!0)),onRequest:Object.assign({},p,A.createHttpPatch(p,l,f,c,!0)),default:Object.assign(p,A.createHttpPatch(p,l,f,c,!1))},https:{off:Object.assign({},R,A.createHttpPatch(R,l,{config:"off"},c,!0)),on:Object.assign({},R,A.createHttpPatch(R,l,{config:"on"},c,!0)),override:Object.assign({},R,A.createHttpPatch(R,l,{config:"override"},c,!0)),onRequest:Object.assign({},R,A.createHttpPatch(R,l,f,c,!0)),default:Object.assign(R,A.createHttpPatch(R,l,f,c,!1))},tls:Object.assign(C,A.createTlsPatch(C))}}const k=new Map;function r(I,l){return I.getExtensionPathIndex().then(f=>{const c=X.__$__nodeRequire("module"),u=c._load;c._load=function(w,b,d){if(w==="tls")return l.tls;if(w!=="http"&&w!=="https")return u.apply(this,arguments);const h=l[w],g=f.findSubstr(y.URI.file(b.filename).fsPath);let t=k.get(g);if(t||k.set(g,t={}),!t[w]){let i=h.default;g&&g.enableProposedApi&&(i=h[g.proxySupport]||h.onRequest),t[w]=Object.assign({},i)}return t[w]}})}}),define(me[266],ge([0,1,38,9,74,29,11,8,89,267]),function(X,e,p,R,C,y,A,P,E,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fixDriveC=e.getAbsoluteGlob=e.foldersToIncludeGlobs=e.foldersToRgExcludeGlobs=e.spawnRipgrepCmd=void 0;const r=k.rgPath.replace(/\bnode_modules\.asar\b/,"node_modules.asar.unpacked");function I(d,h,g,t){const i=l(d,h,g,t),s=h.folder.fsPath;return{cmd:p.spawn(r,i.args,{cwd:s}),rgDiskPath:r,siblingClauses:i.siblingClauses,rgArgs:i,cwd:s}}e.spawnRipgrepCmd=I;function l(d,h,g,t){const i=["--files","--hidden","--case-sensitive"];c([h],g,!1).forEach(n=>{const o=E.anchorGlob(n);if(i.push("-g",o),A.isMacintosh){const v=C.normalizeNFD(o);v!==o&&i.push("-g",v)}});const s=f([h],t,void 0,!1);return s.globArgs.forEach(n=>{const o=`!${E.anchorGlob(n)}`;if(i.push("-g",o),A.isMacintosh){const v=C.normalizeNFD(o);v!==o&&i.push("-g",v)}}),h.disregardIgnoreFiles!==!1?i.push("--no-ignore"):i.push("--no-ignore-parent"),h.ignoreSymlinks||i.push("--follow"),d.exists&&i.push("--quiet"),i.push("--no-config"),h.disregardGlobalIgnoreFiles&&i.push("--no-ignore-global"),{args:i,siblingClauses:s.siblingClauses}}function f(d,h,g,t=!0){const i=[];let s={};return d.forEach(n=>{const o=Object.assign({},n.excludePattern||{},h||{}),v=u(o,t?n.folder.fsPath:void 0,g);i.push(...v.globArgs),v.siblingClauses&&(s=Object.assign(s,v.siblingClauses))}),{globArgs:i,siblingClauses:s}}e.foldersToRgExcludeGlobs=f;function c(d,h,g=!0){const t=[];return d.forEach(i=>{const s=Object.assign({},h||{},i.includePattern||{}),n=u(s,g?i.folder.fsPath:void 0);t.push(...n.globArgs)}),t}e.foldersToIncludeGlobs=c;function u(d,h,g){const t=[],i={};return Object.keys(d).forEach(s=>{if(g&&g.has(s)||!s)return;const n=d[s];s=w(h?S(h,s):s),s.startsWith("\\\\")?s="\\\\"+s.substr(2).replace(/\\/g,"/"):s=s.replace(/\\/g,"/"),typeof n=="boolean"&&n?(s.startsWith("\\\\")&&(s+="**"),t.push(b(s))):n&&n.when&&(i[s]=n)}),{globArgs:t,siblingClauses:i}}function S(d,h){return R.isAbsolute(h)?h:R.join(d,h)}e.getAbsoluteGlob=S;function w(d){return d=P.rtrim(d,"\\"),P.rtrim(d,"/")}function b(d){return y.getRoot(d).toLowerCase()==="c:/"?d.replace(/^c:[/\\]/i,"/"):d}e.fixDriveC=b}),define(me[268],ge([0,1,38,56,9,99,18,57,30,74,29,11,43,8,15,28,31,266,96]),function(X,e,p,R,C,y,A,P,E,k,r,I,l,f,c,u,S,w,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.rgErrorMsgForDisplay=e.Engine=e.FileWalker=void 0;const d=new Set;process.on("exit",()=>{d.forEach(s=>s())});class h{constructor(n){this.normalizedFilePatternLowercase=null,this.maxFilesize=null,this.isCanceled=!1,this.fileWalkSW=null,this.cmdSW=null,this.cmdResultCount=0,this.config=n,this.filePattern=n.filePattern||"",this.includePattern=n.includePattern&&E.parse(n.includePattern),this.maxResults=n.maxResults||null,this.exists=!!n.exists,this.walkedPaths=Object.create(null),this.resultCount=0,this.isLimitHit=!1,this.directoriesWalked=0,this.filesWalked=0,this.errors=[],this.filePattern&&(this.normalizedFilePatternLowercase=b.prepareQuery(this.filePattern).normalizedLowercase),this.globalExcludePattern=n.excludePattern&&E.parse(n.excludePattern),this.folderExcludePatterns=new Map,n.folderQueries.forEach(o=>{const v=Object.assign({},o.excludePattern||{},this.config.excludePattern||{}),m=o.folder.fsPath;n.folderQueries.map(_=>_.folder.fsPath).filter(_=>_!==m).forEach(_=>{r.isEqualOrParent(_,m)&&(v[C.relative(m,_)]=!0)}),this.folderExcludePatterns.set(m,new t(v,m))})}cancel(){this.isCanceled=!0}walk(n,o,v,m,_){if(this.fileWalkSW=l.StopWatch.create(!1),this.isCanceled)return _(null,this.isLimitHit);o.forEach(D=>{const a=C.basename(D.fsPath);this.globalExcludePattern&&this.globalExcludePattern(D.fsPath,a)||this.matchFile(v,{relativePath:D.fsPath,searchPath:void 0})}),this.cmdSW=l.StopWatch.create(!1),this.parallel(n,(D,a)=>{this.call(this.cmdTraversal,this,D,v,m,T=>{if(T){const L=P.toErrorMessage(T);console.error(L),this.errors.push(L),a(T,void 0)}else a(null,void 0)})},(D,a)=>{this.fileWalkSW.stop();const T=D?A.coalesce(D)[0]:null;_(T,this.isLimitHit)})}parallel(n,o,v){const m=new Array(n.length),_=new Array(n.length);let D=!1,a=0;if(n.length===0)return v(null,[]);n.forEach((T,L)=>{o(T,(U,G)=>{if(U?(D=!0,m[L]=null,_[L]=U):(m[L]=G,_[L]=null),++a===n.length)return v(D?_:null,m)})})}call(n,o,...v){try{n.apply(o,v)}catch(m){v[v.length-1](m)}}cmdTraversal(n,o,v,m){const _=n.folder.fsPath,D=I.isMacintosh;let a;const T=()=>a&&a.kill();d.add(T);let L=M=>{d.delete(T),L=()=>{},m(M)},U="";const G=this.initDirectoryTree();let ee;const z=w.spawnRipgrepCmd(this.config,n,this.config.includePattern,this.folderExcludePatterns.get(n.folder.fsPath).expression);a=z.cmd,ee=!Object.keys(z.siblingClauses).length;const N=z.rgArgs.args.map(M=>M.match(/^-/)?M:`'${M}'`).join(" ");let W=`${z.rgDiskPath} ${N}
 - cwd: ${z.cwd}`;z.rgArgs.siblingClauses&&(W+=`
 - Sibling clauses: ${JSON.stringify(z.rgArgs.siblingClauses)}`),v({message:W}),this.cmdResultCount=0,this.collectStdout(a,"utf8",v,(M,j,O)=>{if(M){L(M);return}if(this.isLimitHit){L();return}const B=(U+(D?k.normalizeNFC(j||""):j)).split(`
`);if(O){const $=B.length;B[$-1]=B[$-1].trim(),B[$-1]||B.pop()}else U=B.pop()||"";if(B.length&&B[0].indexOf(`
`)!==-1){L(new Error("Splitting up files failed"));return}if(this.cmdResultCount+=B.length,ee){for(const $ of B)if(this.matchFile(o,{base:_,relativePath:$,searchPath:this.getSearchPath(n,$)}),this.isLimitHit){T();break}(O||this.isLimitHit)&&L();return}this.addDirectoryEntries(n,G,_,B,o),O&&(this.matchDirectoryTree(G,_,o),L())})}spawnFindCmd(n){const o=this.folderExcludePatterns.get(n.folder.fsPath),v=o.getBasenameTerms(),m=o.getPathTerms(),_=["-L","."];if(v.length||m.length){_.push("-not","(","(");for(const D of v)_.push("-name",D),_.push("-o");for(const D of m)_.push("-path",D),_.push("-o");_.pop(),_.push(")","-prune",")")}return _.push("-type","f"),p.spawn("find",_,{cwd:n.folder.fsPath})}readStdout(n,o,v){let m="";this.collectStdout(n,o,()=>{},(_,D,a)=>{if(_){v(_);return}m+=D,a&&v(null,m)})}collectStdout(n,o,v,m){let _=(T,L,U)=>{(T||U)&&(_=()=>{},this.cmdSW&&this.cmdSW.stop()),m(T,L,U)},D=!1;n.stdout?(this.forwardData(n.stdout,o,_),n.stdout.once("data",()=>D=!0)):v({message:"stdout is null"});let a;n.stderr?a=this.collectData(n.stderr):v({message:"stderr is null"}),n.on("error",T=>{_(T)}),n.on("close",T=>{let L;!D&&(L=this.decodeData(a,o))&&i(L)?_(new Error(`command failed with error code ${T}: ${this.decodeData(a,o)}`)):(this.exists&&T===0&&(this.isLimitHit=!0),_(null,"",!0))})}forwardData(n,o,v){const m=new y.StringDecoder(o);return n.on("data",_=>{v(null,m.write(_))}),m}collectData(n){const o=[];return n.on("data",v=>{o.push(v)}),o}decodeData(n,o){const v=new y.StringDecoder(o);return n.map(m=>v.write(m)).join("")}initDirectoryTree(){const n={rootEntries:[],pathToEntries:Object.create(null)};return n.pathToEntries["."]=n.rootEntries,n}addDirectoryEntries(n,{pathToEntries:o},v,m,_){m.indexOf(this.filePattern)!==-1&&this.matchFile(_,{base:v,relativePath:this.filePattern,searchPath:this.getSearchPath(n,this.filePattern)});const D=a=>{const T=C.basename(a),L=C.dirname(a);let U=o[L];U||(U=o[L]=[],D(L)),U.push({base:v,relativePath:a,basename:T,searchPath:this.getSearchPath(n,a)})};m.forEach(D)}matchDirectoryTree({rootEntries:n,pathToEntries:o},v,m){const _=this,D=this.folderExcludePatterns.get(v),a=this.filePattern;function T(L){_.directoriesWalked++;const U=E.hasSiblingFn(()=>L.map(G=>G.basename));for(let G=0,ee=L.length;G<ee;G++){const z=L[G],{relativePath:N,basename:W}=z;if(D.test(N,W,a!==W?U:void 0))continue;const M=o[N];if(M)T(M);else{if(_.filesWalked++,N===a)continue;_.matchFile(m,z)}if(_.isLimitHit)break}}T(n)}getStats(){return{cmdTime:this.cmdSW.elapsed(),fileWalkTime:this.fileWalkSW.elapsed(),directoriesWalked:this.directoriesWalked,filesWalked:this.filesWalked,cmdResultCount:this.cmdResultCount}}doWalk(n,o,v,m,_){const D=n.folder,a=E.hasSiblingFn(()=>v);this.parallel(v,(T,L)=>{if(this.isCanceled||this.isLimitHit)return L(null);const U=o?[o,T].join(C.sep):T;if(this.folderExcludePatterns.get(n.folder.fsPath).test(U,T,this.config.filePattern!==T?a:void 0))return L(null);const G=[D.fsPath,U].join(C.sep);R.lstat(G,(ee,z)=>{if(ee||this.isCanceled||this.isLimitHit)return L(null);this.statLinkIfNeeded(G,z,(N,W)=>N||this.isCanceled||this.isLimitHit?L(null):W.isDirectory()?(this.directoriesWalked++,this.realPathIfNeeded(G,z,(M,j)=>M||this.isCanceled||this.isLimitHit||(j=j||"",this.walkedPaths[j])?L(null):(this.walkedPaths[j]=!0,u.Promises.readdir(G).then(O=>{if(this.isCanceled||this.isLimitHit)return L(null);this.doWalk(n,U,O,m,F=>L(F||null))},O=>{L(null)})))):(this.filesWalked++,U===this.filePattern||this.maxFilesize&&c.isNumber(W.size)&&W.size>this.maxFilesize||this.matchFile(m,{base:D.fsPath,relativePath:U,searchPath:this.getSearchPath(n,U)}),L(null,void 0)))})},T=>{const L=T&&A.coalesce(T);return _(L&&L.length>0?L[0]:void 0)})}matchFile(n,o){this.isFileMatch(o)&&(!this.includePattern||this.includePattern(o.relativePath,C.basename(o.relativePath)))&&(this.resultCount++,(this.exists||this.maxResults&&this.resultCount>this.maxResults)&&(this.isLimitHit=!0),this.isLimitHit||n(o))}isFileMatch(n){if(this.filePattern){if(this.filePattern==="*")return!0;if(this.normalizedFilePatternLowercase)return S.isFilePatternMatch(n,this.normalizedFilePatternLowercase)}return!0}statLinkIfNeeded(n,o,v){return o.isSymbolicLink()?R.stat(n,v):v(null,o)}realPathIfNeeded(n,o,v){return o.isSymbolicLink()?R.realpath(n,(m,_)=>m?v(m):v(null,_)):v(null,n)}getSearchPath(n,o){return n.folderName?C.join(n.folderName,o):o}}e.FileWalker=h;class g{constructor(n){this.folderQueries=n.folderQueries,this.extraFiles=n.extraFileResources||[],this.walker=new h(n)}search(n,o,v){this.walker.walk(this.folderQueries,this.extraFiles,n,o,(m,_)=>{v(m,{limitHit:_,stats:this.walker.getStats(),messages:[]})})}cancel(){this.walker.cancel()}}e.Engine=g;class t{constructor(n,o){this.expression=n,this.root=o,this.init(n)}init(n){let o,v;Object.keys(n).filter(m=>n[m]).forEach(m=>{C.isAbsolute(m)?(o=o||E.getEmptyExpression(),o[m]=n[m]):(v=v||E.getEmptyExpression(),v[m]=n[m])}),this.absoluteParsedExpr=o&&E.parse(o,{trimForExclusions:!0}),this.relativeParsedExpr=v&&E.parse(v,{trimForExclusions:!0})}test(n,o,v){return this.relativeParsedExpr&&this.relativeParsedExpr(n,o,v)||this.absoluteParsedExpr&&this.absoluteParsedExpr(C.join(this.root,n),o,v)}getBasenameTerms(){const n=[];return this.absoluteParsedExpr&&n.push(...E.getBasenameTerms(this.absoluteParsedExpr)),this.relativeParsedExpr&&n.push(...E.getBasenameTerms(this.relativeParsedExpr)),n}getPathTerms(){const n=[];return this.absoluteParsedExpr&&n.push(...E.getPathTerms(this.absoluteParsedExpr)),this.relativeParsedExpr&&n.push(...E.getPathTerms(this.relativeParsedExpr)),n}}function i(s){const n=s.trim().split(`
`),o=n[0].trim();if(o.startsWith("Error parsing regex"))return o;if(o.startsWith("regex parse error"))return f.uppercaseFirstLetter(n[n.length-1].trim());if(o.startsWith("error parsing glob")||o.startsWith("unsupported encoding"))return o.charAt(0).toUpperCase()+o.substr(1);if(o==="Literal '\\n' not allowed.")return"Literal '\\n' currently not supported";if(o.startsWith("Literal "))return o}e.rgErrorMsgForDisplay=i}),define(me[130],ge([0,1,38,282,99,18,68,30,9,8,2,31,64,283,267,89]),function(X,e,p,R,C,y,A,P,E,k,r,I,l,f,c,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fixNewline=e.fixRegexNewline=e.unicodeEscapesToPCRE2=e.spreadGlobComponents=e.RipgrepParser=e.buildRegexParseError=e.rgErrorMsgForDisplay=e.RipgrepTextSearchEngine=void 0;const S=c.rgPath.replace(/\bnode_modules\.asar\b/,"node_modules.asar.unpacked");class w{constructor(D){this.outputChannel=D}provideTextSearchResults(D,a,T,L){return this.outputChannel.appendLine(`provideTextSearchResults ${D.pattern}, ${JSON.stringify(Object.assign(Object.assign({},a),{folder:a.folder.toString()}))}`),new Promise((U,G)=>{L.onCancellationRequested(()=>F());const ee=i(D,a),z=a.folder.fsPath,N=ee.map(be=>be.match(/^-/)?be:`'${be}'`).join(" ");this.outputChannel.appendLine(`${S} ${N}
 - cwd: ${z}`);let W=p.spawn(S,ee,{cwd:z});W.on("error",be=>{console.error(be),this.outputChannel.appendLine("Error: "+(be&&be.message)),G(I.serializeSearchError(new I.SearchError(be&&be.message,I.SearchErrorCode.rgProcessError)))});let M=!1;const j=new h(a.maxResults,z,a.previewOptions);j.on("result",be=>{M=!0,$="",T.report(be)});let O=!1;const F=()=>{O=!0,W&&W.kill(),j&&j.cancel()};let B=!1;j.on("hitLimit",()=>{B=!0,F()});let $="";W.stdout.on("data",be=>{j.handleData(be),M||($+=be)});let Y=!1;W.stdout.once("data",()=>Y=!0);let le="";W.stderr.on("data",be=>{const Le=be.toString();this.outputChannel.appendLine(Le),le+=Le}),W.on("close",()=>{if(this.outputChannel.appendLine(Y?"Got data from stdout":"No data from stdout"),this.outputChannel.appendLine(M?"Got result from parser":"No result from parser"),$&&this.outputChannel.appendLine(`Got data without result: ${$}`),this.outputChannel.appendLine(""),O)U({limitHit:B});else{j.flush(),W=null;let be;le&&!Y&&(be=b(le))?G(I.serializeSearchError(new I.SearchError(be.message,be.code))):U({limitHit:B})}})})}}e.RipgrepTextSearchEngine=w;function b(_){const D=_.split(`
`),a=D[0].trim();if(D.some(L=>L.startsWith("regex parse error")))return new I.SearchError(d(D),I.SearchErrorCode.regexParseError);const T=a.match(/grep config error: unknown encoding: (.*)/);if(T)return new I.SearchError(`Unknown encoding: ${T[1]}`,I.SearchErrorCode.unknownEncoding);if(a.startsWith("error parsing glob"))return new I.SearchError(a.charAt(0).toUpperCase()+a.substr(1),I.SearchErrorCode.globParseError);if(a.startsWith("the literal"))return new I.SearchError(a.charAt(0).toUpperCase()+a.substr(1),I.SearchErrorCode.invalidLiteral);if(a.startsWith("PCRE2: error compiling pattern"))return new I.SearchError(a,I.SearchErrorCode.regexParseError)}e.rgErrorMsgForDisplay=b;function d(_){const D=["Regex parse error"],a=_.filter(T=>T.startsWith("PCRE2:"));if(a.length>=1){const T=a[0].replace("PCRE2:","");if(T.indexOf(":")!==-1&&T.split(":").length>=2){const L=T.split(":")[1];D.push(":"+L)}}return D.join("")}e.buildRegexParseError=d;class h extends R.EventEmitter{constructor(D,a,T){super();this.maxResults=D,this.rootFolder=a,this.previewOptions=T,this.remainder="",this.isDone=!1,this.hitLimit=!1,this.numResults=0,this.stringDecoder=new C.StringDecoder}cancel(){this.isDone=!0}flush(){this.handleDecodedData(this.stringDecoder.end())}on(D,a){return super.on(D,a),this}handleData(D){if(this.isDone)return;const a=typeof D=="string"?D:this.stringDecoder.write(D);this.handleDecodedData(a)}handleDecodedData(D){let a=D.indexOf(`
`);const T=this.remainder+D;if(a>=0)a+=this.remainder.length;else{this.remainder=T;return}let L=0;for(;a>=0;)this.handleLine(T.substring(L,a).trim()),L=a+1,a=T.indexOf(`
`,L);this.remainder=T.substring(L)}handleLine(D){if(this.isDone||!D)return;let a;try{a=JSON.parse(D)}catch(T){throw new Error(`malformed line from rg: ${D}`)}if(a.type==="match"){const T=g(a.data.path),L=r.URI.file(E.join(this.rootFolder,T)),U=this.createTextSearchMatch(a.data,L);this.onResult(U),this.hitLimit&&(this.cancel(),this.emit("hitLimit"))}else if(a.type==="context"){const T=g(a.data.path),L=r.URI.file(E.join(this.rootFolder,T));this.createTextSearchContext(a.data,L).forEach(G=>this.onResult(G))}}createTextSearchMatch(D,a){const T=D.line_number-1,L=g(D.lines),U=Buffer.from(L);let G=0,ee=0,z=T;D.submatches.length===0&&D.submatches.push(L.length?{start:0,end:1,match:{text:L[0]}}:{start:0,end:0,match:{text:""}});const N=y.coalesce(D.submatches.map((W,M)=>{if(this.hitLimit)return null;this.numResults++,this.numResults>=this.maxResults&&(this.hitLimit=!0);const j=g(W.match),O=U.slice(G,W.start).toString().length,F=ee+O,B=t(j),$=z,Y=B.numLines+$,le=B.numLines>0?B.lastLineLength:B.lastLineLength+F;return G=W.end,ee=le,z=Y,new l.Range($,F,Y,le)}));return u.createTextSearchResult(a,L,N,this.previewOptions)}createTextSearchContext(D,a){const T=g(D.lines),L=D.line_number;return T.replace(/\r?\n$/,"").split(`
`).map((U,G)=>({text:U,uri:a,lineNumber:L+G}))}onResult(D){this.emit("result",D)}}e.RipgrepParser=h;function g(_){return _.bytes?Buffer.from(_.bytes,"base64").toString():_.text}function t(_){const D=/\n/g;let a=0,T=-1,L;for(;L=D.exec(_);)a++,T=L.index;const U=T>=0?_.length-T-1:_.length;return{numLines:a,lastLineLength:U}}function i(_,D){const a=["--hidden"];a.push(_.isCaseSensitive?"--case-sensitive":"--ignore-case");const{doubleStarIncludes:T,otherIncludes:L}=A.groupBy(D.includes,G=>G.startsWith("**")?"doubleStarIncludes":"otherIncludes");if(L&&L.length){const G=new Set;L.forEach(ee=>{G.add(ee)}),a.push("-g","!*"),G.forEach(ee=>{s(ee).map(u.anchorGlob).forEach(z=>{a.push("-g",z)})})}T&&T.length&&T.forEach(G=>{a.push("-g",G)}),D.excludes.map(u.anchorGlob).forEach(G=>a.push("-g",`!${G}`)),D.maxFileSize&&a.push("--max-filesize",D.maxFileSize+""),D.useIgnoreFiles?a.push("--no-ignore-parent"):a.push("--no-ignore"),D.followSymlinks&&a.push("--follow"),D.encoding&&D.encoding!=="utf8"&&a.push("--encoding",D.encoding),_.pattern==="--"&&(_.isRegExp=!0,_.pattern="\\-\\-"),_.isMultiline&&!_.isRegExp&&(_.pattern=k.escapeRegExpCharacters(_.pattern),_.isRegExp=!0),D.usePCRE2&&a.push("--pcre2"),a.push("--crlf"),_.isRegExp&&(_.pattern=n(_.pattern),a.push("--auto-hybrid-regex"));let U;if(_.isWordMatch){const ee=k.createRegExp(_.pattern,!!_.isRegExp,{wholeWord:_.isWordMatch}).source.replace(/\\\//g,"/");a.push("--regexp",ee)}else if(_.isRegExp){let G=v(_.pattern);G=m(G),a.push("--regexp",G)}else U=_.pattern,a.push("--fixed-strings");return a.push("--no-config"),D.useGlobalIgnoreFiles||a.push("--no-ignore-global"),a.push("--json"),_.isMultiline&&a.push("--multiline"),D.beforeContext&&a.push("--before-context",D.beforeContext+""),D.afterContext&&a.push("--after-context",D.afterContext+""),a.push("--"),U&&a.push(U),a.push("."),a}function s(_){const D=P.splitGlobAware(_,"/");return D.map((a,T)=>D.slice(0,T+1).join("/"))}e.spreadGlobComponents=s;function n(_){const D=/((?:[^\\]|^)(?:\\\\)*)\\u([a-z0-9]{4})/gi;for(;_.match(D);)_=_.replace(D,"$1\\x{$2}");const a=/((?:[^\\]|^)(?:\\\\)*)\\u\{([a-z0-9]{4})\}/gi;for(;_.match(a);)_=_.replace(a,"$1\\x{$2}");return _}e.unicodeEscapesToPCRE2=n;const o=_=>_.type==="Assertion"&&_.kind==="lookbehind";function v(_){let D;try{D=new f.RegExpParser().parsePattern(_)}catch(ee){return _}let a="",T=0;const L=(ee,z,N)=>{a+=_.slice(T,ee)+N,T=z},U=[];return new f.RegExpVisitor({onCharacterEnter(ee){if(ee.raw!=="\\n")return;const z=U[0];if(!z)L(ee.start,ee.end,"\\r?\\n");else if(!U.some(o))if(z.type==="CharacterClass")if(z.negate){const N=_.slice(z.start+2,ee.start)+_.slice(ee.end,z.end-1);L(z.start,z.end,"(?!\\r?\\n"+(N?`|[${N}]`:"")+")")}else{const N=_.slice(z.start+1,ee.start)+_.slice(ee.end,z.end-1);L(z.start,z.end,N===""?"\\r?\\n":`(?:[${N}]|\\r?\\n)`)}else z.type==="Quantifier"&&L(ee.start,ee.end,"(?:\\r?\\n)")},onQuantifierEnter(ee){U.unshift(ee)},onQuantifierLeave(){U.shift()},onCharacterClassRangeEnter(ee){U.unshift(ee)},onCharacterClassRangeLeave(){U.shift()},onCharacterClassEnter(ee){U.unshift(ee)},onCharacterClassLeave(){U.shift()},onAssertionEnter(ee){o(ee)&&U.push(ee)},onAssertionLeave(ee){U[0]===ee&&U.shift()}}).visit(D),a+=_.slice(T),a}e.fixRegexNewline=v;function m(_){return _.replace(/\n/g,"\\r?\\n")}e.fixNewline=m}),define(me[269],ge([0,1,21,130,114,10]),function(X,e,p,R,C,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RipgrepSearchProvider=void 0;class A{constructor(k){this.outputChannel=k,this.inProgress=new Set,process.once("exit",()=>this.dispose())}provideTextSearchResults(k,r,I,l){const f=new R.RipgrepTextSearchEngine(this.outputChannel);if(r.folder.scheme===y.Schemas.userData){const c=Object.assign(Object.assign({},r),{folder:r.folder.with({scheme:y.Schemas.file})}),u=new C.Progress(S=>I.report(Object.assign(Object.assign({},S),{uri:S.uri.with({scheme:r.folder.scheme})})));return this.withToken(l,S=>f.provideTextSearchResults(k,c,u,S))}else return this.withToken(l,c=>f.provideTextSearchResults(k,r,I,c))}async withToken(k,r){const I=P(k);this.inProgress.add(I);const l=await r(I.token);return this.inProgress.delete(I),l}dispose(){this.inProgress.forEach(k=>k.cancel())}}e.RipgrepSearchProvider=A;function P(E){const k=new p.CancellationTokenSource;return E.onCancellationRequested(()=>k.cancel()),k}}),define(me[270],ge([0,1,28,130,129]),function(X,e,p,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchEngineAdapter=void 0;class y{constructor(E){this.query=E}search(E,k,r){if((!this.query.folderQueries||!this.query.folderQueries.length)&&(!this.query.extraFileResources||!this.query.extraFileResources.length))return Promise.resolve({type:"success",limitHit:!1,stats:{type:"searchProcess"}});const I={appendLine(f){r({message:f})}},l=new C.NativeTextSearchManager(this.query,new R.RipgrepTextSearchEngine(I),p);return new Promise((f,c)=>l.search(u=>{k(u.map(A))},E).then(u=>f({limitHit:u.limitHit,type:"success"}),c))}}e.TextSearchEngineAdapter=y;function A(P){return{path:P.resource&&P.resource.fsPath,results:P.results,numMatches:(P.results||[]).reduce((E,k)=>{if(k.ranges){const r=k;return E+(Array.isArray(r.ranges)?r.ranges.length:1)}else return E+1},0)}}}),define(me[271],ge([0,1,56,284,18,16,14,3,96,9,43,2,41,31,268,270]),function(X,e,p,R,C,y,A,P,E,k,r,I,l,f,c,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SearchService=void 0,R.gracefulify(p);class S{constructor(){this.caches=Object.create(null)}fileSearch(t){let i;const s=d(t),n=new P.Emitter({onFirstListenerDidAdd:()=>{i=y.createCancelablePromise(o=>this.doFileSearchWithEngine(c.Engine,s,v=>n.fire(v),o)),i.then(o=>n.fire(o),o=>n.fire({type:"error",error:{message:o.message,stack:o.stack}}))},onLastListenerRemove:()=>{i.cancel()}});return n.event}textSearch(t){let i;const s=d(t),n=new P.Emitter({onFirstListenerDidAdd:()=>{i=y.createCancelablePromise(o=>this.ripgrepTextSearch(s,v=>n.fire(v),o)),i.then(o=>n.fire(o),o=>n.fire({type:"error",error:{message:o.message,stack:o.stack}}))},onLastListenerRemove:()=>{i.cancel()}});return n.event}ripgrepTextSearch(t,i,s){return t.maxFileSize=l.getPlatformLimits(process.arch==="ia32"?0:1).maxFileSize,new u.TextSearchEngineAdapter(t).search(s,i,i)}doFileSearch(t,i,s){return this.doFileSearchWithEngine(c.Engine,t,i,s)}doFileSearchWithEngine(t,i,s,n,o=S.BATCH_SIZE){let v=0;const m=D=>{Array.isArray(D)?(v+=D.length,s(D.map(a=>this.rawMatchToSearchItem(a)))):D.relativePath?(v++,s(this.rawMatchToSearchItem(D))):s(D)};if(i.sortByScore){let D=this.trySortedSearchFromCache(i,m,n);if(!D){const a=i.maxResults?Object.assign({},i,{maxResults:null}):i,T=new t(a);D=this.doSortedSearch(T,i,s,m,n)}return new Promise((a,T)=>{D.then(([L,U])=>{const G=U.map(ee=>this.rawMatchToSearchItem(ee));this.sendProgress(G,s,o),a(L)},T)})}const _=new t(i);return this.doSearch(_,m,o,n).then(D=>({limitHit:D.limitHit,type:"success",stats:{detailStats:D.stats,type:"searchProcess",fromCache:!1,resultCount:v,sortingTime:void 0}}))}rawMatchToSearchItem(t){return{path:t.base?k.join(t.base,t.relativePath):t.relativePath}}doSortedSearch(t,i,s,n,o){const v=new P.Emitter;let m=y.createCancelablePromise(D=>{let a=[];const T=L=>{Array.isArray(L)?a=L:(n(L),v.fire(L))};return this.doSearch(t,T,-1,D).then(L=>[L,a])}),_;if(i.cacheKey){_=this.getOrCreateCache(i.cacheKey);const D={promise:m,event:v.event,resolved:!1};_.resultsToSearchCache[i.filePattern||""]=D,m.then(()=>{D.resolved=!0},a=>{delete _.resultsToSearchCache[i.filePattern||""]}),m=this.preventCancellation(m)}return m.then(([D,a])=>{const T=_?_.scorerCache:Object.create(null),L=(typeof i.maxResults!="number"||i.maxResults>0)&&r.StopWatch.create(!1);return this.sortResults(i,a,T,o).then(U=>{const G=L?L.elapsed():-1;return[{type:"success",stats:{detailStats:D.stats,sortingTime:G,fromCache:!1,type:"searchProcess",workspaceFolderCount:i.folderQueries.length,resultCount:U.length},messages:D.messages,limitHit:D.limitHit||typeof i.maxResults=="number"&&a.length>i.maxResults},U]})})}getOrCreateCache(t){const i=this.caches[t];return i||(this.caches[t]=new w)}trySortedSearchFromCache(t,i,s){const n=t.cacheKey&&this.caches[t.cacheKey];if(!n)return;const o=this.getResultsFromCache(n,t.filePattern||"",i,s);if(o)return o.then(([v,m,_])=>{const D=r.StopWatch.create(!1);return this.sortResults(t,m,n.scorerCache,s).then(a=>{const T=D.elapsed(),L={fromCache:!0,detailStats:_,type:"searchProcess",resultCount:m.length,sortingTime:T};return[{type:"success",limitHit:v.limitHit||typeof t.maxResults=="number"&&m.length>t.maxResults,stats:L},a]})})}sortResults(t,i,s,n){const o=E.prepareQuery(t.filePattern||""),v=(_,D)=>E.compareItemsByFuzzyScore(_,D,o,!0,b,s),m=typeof t.maxResults=="number"?t.maxResults:Number.MAX_VALUE;return C.topAsync(i,v,m,1e4,n)}sendProgress(t,i,s){if(s&&s>0)for(let n=0;n<t.length;n+=s)i(t.slice(n,n+s));else i(t)}getResultsFromCache(t,i,s,n){const o=r.StopWatch.create(!1),v=i.indexOf(k.sep)>=0;let m;for(const T in t.resultsToSearchCache)if(i.startsWith(T)){if(v&&T.indexOf(k.sep)<0&&T!=="")continue;const L=t.resultsToSearchCache[T];m={promise:this.preventCancellation(L.promise),event:L.event,resolved:L.resolved};break}if(!m)return null;const _=o.elapsed(),D=r.StopWatch.create(!1),a=m.event(s);return n&&n.onCancellationRequested(()=>{a.dispose()}),m.promise.then(([T,L])=>{if(n&&n.isCancellationRequested)throw A.canceled();const U=[],G=E.prepareQuery(i).normalizedLowercase;for(const ee of L)!f.isFilePatternMatch(ee,G)||U.push(ee);return[T,U,{cacheWasResolved:m.resolved,cacheLookupTime:_,cacheFilterTime:D.elapsed(),cacheEntryCount:L.length}]})}doSearch(t,i,s,n){return new Promise((o,v)=>{let m=[];n&&n.onCancellationRequested(()=>t.cancel()),t.search(_=>{_&&(s?(m.push(_),s>0&&m.length>=s&&(i(m),m=[])):i(_))},_=>{i(_)},(_,D)=>{m.length&&i(m),_?v(_):o(D)})})}clearCache(t){return delete this.caches[t],Promise.resolve(void 0)}preventCancellation(t){return new class{get[Symbol.toStringTag](){return this.toString()}cancel(){}then(i,s){return t.then(i,s)}catch(i){return this.then(void 0,i)}finally(i){return t.finally(i)}}}}e.SearchService=S,S.BATCH_SIZE=512;class w{constructor(){this.resultsToSearchCache=Object.create(null),this.scorerCache=Object.create(null)}}const b=new class{getItemLabel(g){return k.basename(g.relativePath)}getItemDescription(g){return k.dirname(g.relativePath)}getItemPath(g){return g.relativePath}};function d(g){return Object.assign(Object.assign({},g),{folderQueries:g.folderQueries&&g.folderQueries.map(h),extraFileResources:g.extraFileResources&&g.extraFileResources.map(t=>I.URI.revive(t))})}function h(g){return Object.assign(Object.assign({},g),{folder:I.URI.revive(g.folder)})}}),define(me[272],ge([0,1,6,2,28,12,31,271,269,89,13,60,27,67,10,129]),function(X,e,p,R,C,y,A,P,E,k,r,I,l,f,c,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeExtHostSearch=void 0;let S=class extends f.ExtHostSearch{constructor(b,d,h,g){super(b,h,g);this._pfs=C,this._internalFileSearchHandle=-1,this._internalFileSearchProvider=null;const t=new k.OutputChannel("RipgrepSearchUD",this._logService);this.registerTextSearchProvider(c.Schemas.userData,new E.RipgrepSearchProvider(t)),d.remote.isRemote&&d.remote.authority&&this._registerEHSearchProviders()}_registerEHSearchProviders(){const b=new k.OutputChannel("RipgrepSearchEH",this._logService);this.registerTextSearchProvider(c.Schemas.file,new E.RipgrepSearchProvider(b)),this.registerInternalFileSearchProvider(c.Schemas.file,new P.SearchService)}registerInternalFileSearchProvider(b,d){const h=this._handlePool++;return this._internalFileSearchProvider=d,this._internalFileSearchHandle=h,this._proxy.$registerFileSearchProvider(h,this._transformScheme(b)),p.toDisposable(()=>{this._internalFileSearchProvider=null,this._proxy.$unregisterProvider(h)})}$provideFileSearchResults(b,d,h,g){const t=f.reviveQuery(h);return b===this._internalFileSearchHandle?this.doInternalFileSearch(b,d,t,g):super.$provideFileSearchResults(b,d,h,g)}doInternalFileSearch(b,d,h,g){const t=i=>{if(A.isSerializedFileMatch(i)&&(i=[i]),Array.isArray(i)){this._proxy.$handleFileMatch(b,d,i.map(s=>R.URI.file(s.path)));return}i.message&&this._logService.debug("ExtHostSearch",i.message)};if(!this._internalFileSearchProvider)throw new Error("No internal file search handler");return this._internalFileSearchProvider.doFileSearch(h,t,g)}$clearCache(b){return this._internalFileSearchProvider&&this._internalFileSearchProvider.clearCache(b),super.$clearCache(b)}createTextSearchManager(b,d){return new u.NativeTextSearchManager(b,d)}};S=Ve([We(0,r.IExtHostRpcService),We(1,l.IExtHostInitDataService),We(2,I.IURITransformerService),We(3,y.ILogService)],S),e.NativeExtHostSearch=S}),define(me[131],ge([0,1,285,121,286,3,102,9,100,32,6,22,103,14,11]),function(X,e,p,R,C,y,A,P,E,k,r,I,l,f,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connect=e.serve=e.Server=e.createStaticIPCHandle=e.createRandomIPCHandle=e.XDG_RUNTIME_DIR=e.WebSocketNodeSocket=e.NodeSocket=void 0;class u{constructor(m){this.socket=m,this._errorListener=_=>{if(_){if(_.code==="EPIPE")return;f.onUnexpectedError(_)}},this.socket.on("error",this._errorListener)}dispose(){this.socket.off("error",this._errorListener),this.socket.destroy()}onData(m){const _=D=>m(I.VSBuffer.wrap(D));return this.socket.on("data",_),{dispose:()=>this.socket.off("data",_)}}onClose(m){const _=D=>{m({type:0,hadError:D,error:void 0})};return this.socket.on("close",_),{dispose:()=>this.socket.off("close",_)}}onEnd(m){return this.socket.on("end",m),{dispose:()=>this.socket.off("end",m)}}write(m){if(!this.socket.destroyed)try{this.socket.write(m.buffer,_=>{if(_){if(_.code==="EPIPE")return;f.onUnexpectedError(_)}})}catch(_){if(_.code==="EPIPE")return;f.onUnexpectedError(_)}}end(){this.socket.end()}drain(){return new Promise((m,_)=>{if(this.socket.bufferSize===0){m();return}const D=()=>{this.socket.off("close",D),this.socket.off("end",D),this.socket.off("error",D),this.socket.off("timeout",D),this.socket.off("drain",D),m()};this.socket.on("close",D),this.socket.on("end",D),this.socket.on("error",D),this.socket.on("timeout",D),this.socket.on("drain",D)})}}e.NodeSocket=u;var S;(function(v){v[v.MinHeaderByteSize=2]="MinHeaderByteSize"})(S||(S={}));var w;(function(v){v[v.PeekHeader=1]="PeekHeader",v[v.ReadHeader=2]="ReadHeader",v[v.ReadBody=3]="ReadBody",v[v.Fin=4]="Fin"})(w||(w={}));class b extends r.Disposable{constructor(m,_,D,a){super();this._onDidZlibFlush=this._register(new y.Emitter),this._recordedInflateBytes=[],this._pendingInflateData=[],this._pendingDeflateData=[],this._onData=this._register(new y.Emitter),this._onClose=this._register(new y.Emitter),this._isEnded=!1,this._state={state:1,readLen:2,fin:0,mask:0},this.socket=m,this._totalIncomingWireBytes=0,this._totalIncomingDataBytes=0,this._totalOutgoingWireBytes=0,this._totalOutgoingDataBytes=0,this.permessageDeflate=_,this._recordInflateBytes=a,_?(this._zlibInflate=C.createInflateRaw({windowBits:15}),this._zlibInflate.on("error",T=>{console.error(T),f.onUnexpectedError(T),this._onClose.fire({type:0,hadError:!0,error:T})}),this._zlibInflate.on("data",T=>{this._pendingInflateData.push(T)}),D&&(this._zlibInflate.write(D.buffer),this._zlibInflate.flush(()=>{this._pendingInflateData.length=0})),this._zlibDeflate=C.createDeflateRaw({windowBits:15}),this._zlibDeflate.on("error",T=>{console.error(T),f.onUnexpectedError(T),this._onClose.fire({type:0,hadError:!0,error:T})}),this._zlibDeflate.on("data",T=>{this._pendingDeflateData.push(T)})):(this._zlibInflate=null,this._zlibDeflate=null),this._zlibDeflateFlushWaitingCount=0,this._incomingData=new l.ChunkStream,this._register(this.socket.onData(T=>this._acceptChunk(T))),this._register(this.socket.onClose(T=>this._onClose.fire(T)))}get totalIncomingWireBytes(){return this._totalIncomingWireBytes}get totalIncomingDataBytes(){return this._totalIncomingDataBytes}get totalOutgoingWireBytes(){return this._totalOutgoingWireBytes}get totalOutgoingDataBytes(){return this._totalOutgoingDataBytes}get recordedInflateBytes(){return this._recordInflateBytes?I.VSBuffer.wrap(Buffer.concat(this._recordedInflateBytes)):I.VSBuffer.alloc(0)}dispose(){this._zlibDeflateFlushWaitingCount>0?this._register(this._onDidZlibFlush.event(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(m){return this._onData.event(m)}onClose(m){return this._onClose.event(m)}onEnd(m){return this.socket.onEnd(m)}write(m){this._totalOutgoingDataBytes+=m.byteLength,this._zlibDeflate?(this._zlibDeflate.write(m.buffer),this._zlibDeflateFlushWaitingCount++,this._zlibDeflate.flush(2,()=>{this._zlibDeflateFlushWaitingCount--;let _=Buffer.concat(this._pendingDeflateData);this._pendingDeflateData.length=0,_=_.slice(0,_.length-4),this._isEnded||this._write(I.VSBuffer.wrap(_),!0),this._zlibDeflateFlushWaitingCount===0&&this._onDidZlibFlush.fire()})):this._write(m,!1)}_write(m,_){let D=2;m.byteLength<126?D+=0:m.byteLength<2**16?D+=2:D+=8;const a=I.VSBuffer.alloc(D);if(_?a.writeUInt8(194,0):a.writeUInt8(130,0),m.byteLength<126)a.writeUInt8(m.byteLength,1);else if(m.byteLength<2**16){a.writeUInt8(126,1);let T=1;a.writeUInt8(m.byteLength>>>8&255,++T),a.writeUInt8(m.byteLength>>>0&255,++T)}else{a.writeUInt8(127,1);let T=1;a.writeUInt8(0,++T),a.writeUInt8(0,++T),a.writeUInt8(0,++T),a.writeUInt8(0,++T),a.writeUInt8(m.byteLength>>>24&255,++T),a.writeUInt8(m.byteLength>>>16&255,++T),a.writeUInt8(m.byteLength>>>8&255,++T),a.writeUInt8(m.byteLength>>>0&255,++T)}this._totalOutgoingWireBytes+=a.byteLength+m.byteLength,this.socket.write(I.VSBuffer.concat([a,m]))}end(){this._isEnded=!0,this.socket.end()}_acceptChunk(m){if(m.byteLength!==0){for(this._totalIncomingWireBytes+=m.byteLength,this._incomingData.acceptChunk(m);this._incomingData.byteLength>=this._state.readLen;)if(this._state.state===1){const _=this._incomingData.peek(this._state.readLen),a=(_.readUInt8(0)&128)>>>7,T=_.readUInt8(1),L=(T&128)>>>7,U=T&127;this._state.state=2,this._state.readLen=2+(L?4:0)+(U===126?2:0)+(U===127?8:0),this._state.fin=a,this._state.mask=0}else if(this._state.state===2){const _=this._incomingData.read(this._state.readLen),D=_.readUInt8(1),a=(D&128)>>>7;let T=D&127,L=1;T===126?T=_.readUInt8(++L)*2**8+_.readUInt8(++L):T===127&&(T=_.readUInt8(++L)*0+_.readUInt8(++L)*0+_.readUInt8(++L)*0+_.readUInt8(++L)*0+_.readUInt8(++L)*2**24+_.readUInt8(++L)*2**16+_.readUInt8(++L)*2**8+_.readUInt8(++L));let U=0;a&&(U=_.readUInt8(++L)*2**24+_.readUInt8(++L)*2**16+_.readUInt8(++L)*2**8+_.readUInt8(++L)),this._state.state=3,this._state.readLen=T,this._state.mask=U}else if(this._state.state===3){const _=this._incomingData.read(this._state.readLen);d(_,this._state.mask),this._state.state=1,this._state.readLen=2,this._state.mask=0,this._zlibInflate?(this._recordInflateBytes&&this._recordedInflateBytes.push(Buffer.from(_.buffer)),this._zlibInflate.write(_.buffer),this._state.fin&&(this._recordInflateBytes&&this._recordedInflateBytes.push(Buffer.from([0,0,255,255])),this._zlibInflate.write(Buffer.from([0,0,255,255]))),this._zlibInflate.flush(()=>{const D=Buffer.concat(this._pendingInflateData);this._pendingInflateData.length=0,this._totalIncomingDataBytes+=D.length,this._onData.fire(I.VSBuffer.wrap(D))})):(this._totalIncomingDataBytes+=_.byteLength,this._onData.fire(_))}}}async drain(){this._zlibDeflateFlushWaitingCount>0&&await y.Event.toPromise(this._onDidZlibFlush.event),await this.socket.drain()}}e.WebSocketNodeSocket=b;function d(v,m){if(m===0)return;let _=v.byteLength>>>2;for(let G=0;G<_;G++){const ee=v.readUInt32BE(G*4);v.writeUInt32BE(ee^m,G*4)}let D=_*4,a=v.byteLength-D;const T=m>>>24&255,L=m>>>16&255,U=m>>>8&255;a>=1&&v.writeUInt8(v.readUInt8(D)^T,D),a>=2&&v.writeUInt8(v.readUInt8(D+1)^L,D+1),a>=3&&v.writeUInt8(v.readUInt8(D+2)^U,D+2)}e.XDG_RUNTIME_DIR=process.env.XDG_RUNTIME_DIR;const h={[2]:107,[1]:103};function g(){const v=k.generateUuid();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${v}-sock`;let m;return e.XDG_RUNTIME_DIR?m=P.join(e.XDG_RUNTIME_DIR,`vscode-ipc-${v}.sock`):m=P.join(E.tmpdir(),`vscode-ipc-${v}.sock`),i(m),m}e.createRandomIPCHandle=g;function t(v,m,_){const D=p.createHash("md5").update(v).digest("hex");if(process.platform==="win32")return`\\\\.\\pipe\\${D}-${_}-${m}-sock`;let a;return e.XDG_RUNTIME_DIR&&!process.env.VSCODE_PORTABLE?a=P.join(e.XDG_RUNTIME_DIR,`vscode-${D.substr(0,8)}-${_}-${m}.sock`):a=P.join(v,`${_}-${m}.sock`),i(a),a}e.createStaticIPCHandle=t;function i(v){const m=h[c.platform];typeof m=="number"&&v.length>=m&&console.warn(`WARNING: IPC handle "${v}" is longer than ${m} chars, try a shorter --user-data-dir`)}class s extends A.IPCServer{constructor(m){super(s.toClientConnectionEvent(m));this.server=m}static toClientConnectionEvent(m){const _=y.Event.fromNodeEventEmitter(m,"connection");return y.Event.map(_,D=>({protocol:new l.Protocol(new u(D)),onDidClientDisconnect:y.Event.once(y.Event.fromNodeEventEmitter(D,"close"))}))}dispose(){super.dispose(),this.server&&(this.server.close(),this.server=null)}}e.Server=s;function n(v){return new Promise((m,_)=>{const D=R.createServer();D.on("error",_),D.listen(v,()=>{D.removeListener("error",_),m(new s(D))})})}e.serve=n;function o(v,m){return new Promise((_,D)=>{const a=R.createConnection(v,()=>{a.removeListener("error",D),_(l.Client.fromSocket(new u(a),m))});a.once("error",D)})}e.connect=o}),define(me[273],ge([0,1,131,265,56,48,2,190,12]),function(X,e,p,R,C,y,A,P,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CLIServer=e.CLIServerBase=void 0;class k{constructor(l,f,c){this._commands=l,this.logService=f,this._ipcHandlePath=c,this._server=R.createServer((u,S)=>this.onRequest(u,S)),this.setup().catch(u=>(f.error(u),""))}get ipcHandlePath(){return this._ipcHandlePath}async setup(){try{this._server.listen(this.ipcHandlePath),this._server.on("error",l=>this.logService.error(l))}catch(l){this.logService.error("Could not start open from terminal server.")}return this._ipcHandlePath}onRequest(l,f){const c=[];l.setEncoding("utf8"),l.on("data",u=>c.push(u)),l.on("end",()=>{const u=JSON.parse(c.join(""));switch(u.type){case"open":this.open(u,f);break;case"openExternal":this.openExternal(u,f);break;case"status":this.getStatus(u,f);break;case"extensionManagement":this.manageExtensions(u,f).catch(this.logService.error);break;default:f.writeHead(404),f.write(`Unknown message type: ${u.type}`,S=>{S&&this.logService.error(S)}),f.end();break}})}open(l,f){let{fileURIs:c,folderURIs:u,forceNewWindow:S,diffMode:w,addMode:b,forceReuseWindow:d,gotoLineMode:h,waitMarkerFilePath:g}=l;const t=[];if(Array.isArray(u))for(const i of u)try{t.push({folderUri:A.URI.parse(i)})}catch(s){}if(Array.isArray(c))for(const i of c)try{P.hasWorkspaceFileExtension(i)?t.push({workspaceUri:A.URI.parse(i)}):t.push({fileUri:A.URI.parse(i)})}catch(s){}if(t.length){const i=g?A.URI.file(g):void 0,n={forceNewWindow:S,diffMode:w,addMode:b,gotoLineMode:h,forceReuseWindow:d,preferNewWindow:!d&&!i&&!b,waitMarkerFileURI:i};this._commands.executeCommand("_remoteCLI.windowOpen",t,n)}f.writeHead(200),f.end()}async openExternal(l,f){for(const c of l.uris){const u=A.URI.parse(c),S=u.scheme==="file"?u:c;await this._commands.executeCommand("_remoteCLI.openExternal",S)}f.writeHead(200),f.end()}async manageExtensions(l,f){try{const c=w=>w==null?void 0:w.map(b=>/\.vsix$/i.test(b)?A.URI.parse(b):b),u={list:l.list,install:c(l.install),uninstall:c(l.uninstall),force:l.force},S=await this._commands.executeCommand("_remoteCLI.manageExtensions",u);f.writeHead(200),f.write(S)}catch(c){f.writeHead(500),f.write(String(c),u=>{u&&this.logService.error(u)})}f.end()}async getStatus(l,f){try{const c=await this._commands.executeCommand("_remoteCLI.getSystemStatus");f.writeHead(200),f.write(c),f.end()}catch(c){f.writeHead(500),f.write(String(c),u=>{u&&this.logService.error(u)}),f.end()}}dispose(){this._server.close(),this._ipcHandlePath&&process.platform!=="win32"&&C.existsSync(this._ipcHandlePath)&&C.unlinkSync(this._ipcHandlePath)}}e.CLIServerBase=k;let r=class extends k{constructor(l,f){super(l,f,p.createRandomIPCHandle())}};r=Ve([We(0,y.IExtHostCommands),We(1,E.ILogService)],r),e.CLIServer=r}),define(me[274],ge([0,1,66,261,256,5,264,39,247,2,10,7,273,101]),function(X,e,p,R,C,y,A,P,E,k,r,I,l,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostExtensionService=void 0;class c extends C.RequireInterceptor{_installInterceptor(){const w=this,b=X.__$__nodeRequire("module"),d=b._load;b._load=function(g,t,i){for(let s of w._alternatives){let n=s(g);if(n){g=n;break}}return w._factories.has(g)?w._factories.get(g).load(g,k.URI.file(f.realpathSync(t.filename)),s=>d.apply(this,[s,t,i])):d.apply(this,arguments)}}}class u extends P.AbstractExtHostExtensionService{constructor(){super(...arguments);this.extensionRuntime=I.ExtensionRuntime.Node}async _beforeAlmostReadyToRunExtensions(){const w=this._instaService.invokeFunction(R.createApiFactoryAndRegisterActors);if(this._instaService.createInstance(E.ExtHostDownloadService),this._initData.remote.isRemote&&this._initData.remote.authority){const t=this._instaService.createInstance(l.CLIServer);process.env.VSCODE_IPC_HOOK_CLI=t.ipcHandlePath}await this._instaService.createInstance(c,w,this._registry).install(),p.mark("code/extHost/didInitAPI");const d=await this._extHostConfiguration.getConfigProvider();await A.connectProxyResolver(this._extHostWorkspace,d,this,this._logService,this._mainThreadTelemetryProxy,this._initData),p.mark("code/extHost/didInitProxyResolver");const h=process.send,g=this._extHostContext.getProxy(y.MainContext.MainThreadConsole);process.send=(...t)=>t.length===0||!t[0]||t[0].type!=="__$console"?h.apply(process,t):(g.$logExtensionHostMessage(t[0]),!1)}_getEntryPoint(w){return w.main}_loadCommonJSModule(w,b,d){if(b.scheme!==r.Schemas.file)throw new Error(`Cannot load URI: '${b}', must be of file-scheme`);let h=null;d.codeLoadingStart(),this._logService.info(`ExtensionService#loadCommonJSModule ${b.toString(!0)}`),this._logService.flush();try{w&&p.mark(`code/extHost/willLoadExtensionCode/${w.value}`),h=X.__$__nodeRequire(b.fsPath)}catch(g){return Promise.reject(g)}finally{w&&p.mark(`code/extHost/didLoadExtensionCode/${w.value}`),d.codeLoadingStop()}return Promise.resolve(h)}async $setRemoteEnvironment(w){if(!!this._initData.remote.isRemote)for(const b in w){const d=w[b];d===null?delete process.env[b]:process.env[b]=d}}}e.ExtHostExtensionService=u}),define(me[275],ge([0,1,77,248,249,258,257,272,274,216,250,49,39,62,67,65,33,47,12]),function(X,e,p,R,C,y,A,P,E,k,r,I,l,f,c,u,S,w,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),p.registerSingleton(l.IExtHostExtensionService,E.ExtHostExtensionService),p.registerSingleton(b.ILogService,k.ExtHostLogService),p.registerSingleton(I.IExtHostDebugService,A.ExtHostDebugService),p.registerSingleton(f.IExtHostOutputService,R.ExtHostOutputService2),p.registerSingleton(c.IExtHostSearch,P.NativeExtHostSearch),p.registerSingleton(u.IExtHostTask,y.ExtHostTask),p.registerSingleton(S.IExtHostTerminalService,C.ExtHostTerminalService),p.registerSingleton(w.IExtHostTunnelService,r.ExtHostTunnelService)}),define(me[276],ge([0,1,121,287,66,14,103,131,184,214,259,22,98,28,101,16,262,275]),function(X,e,p,R,C,y,A,P,E,k,r,I,l,f,c,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.startExtensionHostProcess=void 0,function(){for(let n=0;n<process.execArgv.length;n++)process.execArgv[n]==="--inspect-port=0"&&(process.execArgv.splice(n,1),n--)}();const S=R(process.argv.slice(2),{string:["uriTransformerPath","useHostProxy"]});(function(){const s=X.__$__nodeRequire("module"),n=s._load;s._load=function(o){if(o==="natives")throw new Error('Either the extension or a NPM dependency is using the "natives" node module which is unsupported as it can cause a crash of the extension host. Click [here](https://go.microsoft.com/fwlink/?linkid=871887) to find out more');return n.apply(this,arguments)}})();const w=process.exit.bind(process);function b(s){process.exit=function(n){if(s)w(n);else{const o=new Error("An extension called process.exit() and this was prevented.");console.warn(o.stack)}},process.crash=function(){const n=new Error("An extension called process.crash() and this was prevented.");console.warn(n.stack)}}let d=function(s){w()};function h(){if(process.env.VSCODE_EXTHOST_WILL_SEND_SOCKET)return new Promise((s,n)=>{let o=null,v=setTimeout(()=>{d("VSCODE_EXTHOST_IPC_SOCKET timeout")},6e4);const m=108e5,_=3e5,D=new u.RunOnceScheduler(()=>d("renderer disconnected for too long (1)"),m),a=new u.RunOnceScheduler(()=>d("renderer disconnected for too long (2)"),_);process.on("message",(L,U)=>{if(L&&L.type==="VSCODE_EXTHOST_IPC_SOCKET"){const G=I.VSBuffer.wrap(Buffer.from(L.initialDataChunk,"base64"));let ee;if(L.skipWebSocketFrames)ee=new P.NodeSocket(U);else{const z=I.VSBuffer.wrap(Buffer.from(L.inflateBytes,"base64"));ee=new P.WebSocketNodeSocket(new P.NodeSocket(U),L.permessageDeflate,z,!1)}o?(D.cancel(),a.cancel(),o.beginAcceptReconnection(ee,G),o.endAcceptReconnection()):(clearTimeout(v),o=new A.PersistentProtocol(ee,G),o.onDidDispose(()=>d("renderer disconnected")),s(o),o.onSocketClose(()=>{D.schedule()}))}if(L&&L.type==="VSCODE_EXTHOST_IPC_REDUCE_GRACE_TIME"){if(a.isScheduled())return;D.isScheduled()&&a.schedule()}});const T={type:"VSCODE_EXTHOST_IPC_READY"};process.send&&process.send(T)});{const s=process.env.VSCODE_IPC_HOOK_EXTHOST;return new Promise((n,o)=>{const v=p.createConnection(s,()=>{v.removeListener("error",o),n(new A.PersistentProtocol(new P.NodeSocket(v)))});v.once("error",o),v.on("close",()=>{d("renderer closed the socket")})})}}async function g(){const s=await h();return new class{constructor(){this._onMessage=new A.BufferedEmitter,this.onMessage=this._onMessage.event,this._terminating=!1,s.onMessage(n=>{k.isMessageOfType(n,2)?(this._terminating=!0,d("received terminate message from renderer")):this._onMessage.fire(n)})}send(n){this._terminating||s.send(n)}drain(){return s.drain()}}}function t(s){return new Promise(n=>{const o=s.onMessage(v=>{o.dispose();const m=JSON.parse(v.toString()),_=m.commit,D=E.default.commit;_&&D&&_!==D&&w(55);const a=[];process.on("unhandledRejection",(U,G)=>{a.push(G),setTimeout(()=>{const ee=a.indexOf(G);ee>=0&&G.catch(z=>{a.splice(ee,1),y.isPromiseCanceledError(z)||(console.warn(`rejected promise not handled within 1 second: ${z}`),z&&z.stack&&console.warn(`stack trace: ${z.stack}`),y.onUnexpectedError(U))})},1e3)}),process.on("rejectionHandled",U=>{const G=a.indexOf(U);G>=0&&a.splice(G,1)}),process.on("uncaughtException",function(U){y.onUnexpectedError(U)});let T=0;setInterval(function(){try{process.kill(m.parentPid,0),T=0}catch(U){U&&U.code==="EPERM"?(T++,T>=3&&d(`parent process ${m.parentPid} does not exist anymore (3 x EPERM): ${U.message} (code: ${U.code}) (errno: ${U.errno})`)):d(`parent process ${m.parentPid} does not exist anymore: ${U.message} (code: ${U.code}) (errno: ${U.errno})`)}},1e3);let L;try{L=X.__$__nodeRequire("native-watchdog"),L.start(m.parentPid)}catch(U){y.onUnexpectedError(U)}s.send(k.createMessageOfType(0)),n({protocol:s,initData:m})});s.send(k.createMessageOfType(1))})}async function i(){C.mark("code/extHost/willConnectToRenderer");const s=await g();C.mark("code/extHost/didConnectToRenderer");const n=await t(s);C.mark("code/extHost/didWaitForInitData");const{initData:o}=n;b(!!o.environment.extensionTestsLocationURI),o.environment.useHostProxy=S.useHostProxy!==void 0?S.useHostProxy!=="false":void 0;const v=new class{exit(a){w(a)}exists(a){return f.Promises.exists(a)}realpath(a){return c.realpath(a)}};let m=null;if(o.remote.authority&&S.uriTransformerPath)try{const a=X.__$__nodeRequire(S.uriTransformerPath)(o.remote.authority);m=new l.URITransformer(a)}catch(D){console.error(D)}const _=new r.ExtensionHostMain(n.protocol,o,v,m);d=D=>_.terminate(D)}e.startExtensionHostProcess=i}),define(me[288],ge([0,1,276]),function(X,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),p.startExtensionHostProcess().catch(R=>console.log(R))})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/3caebff71e514ece73b125468881d102e767ee4d/core/vs/workbench/services/extensions/node/extensionHostProcess.js.map
